/**************************************************************************************************************************************************************
 *  The Clear BSD License
 *
 *   Copyright (c) – 2016, NetApp, Inc. All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 *
 *   * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *   * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 *
 *   NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *************************************************************************************************************************************************************/


package com.netapp.santricity.models.symbol;

import com.fasterxml.jackson.annotation.JsonValue;
import java.util.Objects;
import com.netapp.santricity.models.v2.*;
import com.netapp.santricity.models.symbol.*;
import com.netapp.santricity.models.utils.*;
import com.netapp.santricity.Pair;
import com.netapp.santricity.StringUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.io.File;
import java.util.Date;
import java.util.Objects;


/**
 * OptionalScheduleCreationDescriptor
 */
@javax.annotation.Generated(value = "class com.ni.aa.client.codegen.lang.JavaNetappClientCodegen", date = "2016-08-12T15:32:46.001-05:00")
public class OptionalScheduleCreationDescriptor   {
  

  /**
   * This enumeration is used to indicate whether a parameter is present or absent.
   */
  public enum OptionEnum {
    absent("absent"),
    present("present"),
    __UNDEFINED("__UNDEFINED");
;
    private String value;

    OptionEnum(String value) {
      this.value = value;
    }

    @Override
    @JsonValue
    public String toString() {
      return String.valueOf(value);
    }
  }

    private OptionEnum option;

    private ScheduleCreationDescriptor descriptor;

  
  /**
   * This enumeration is used to indicate whether a parameter is present or absent.
   **/
  public OptionalScheduleCreationDescriptor option(OptionEnum option) {
    this.option = option;
    return this;
  }
  
  @ApiModelProperty(example = "null", required = true, value = "This enumeration is used to indicate whether a parameter is present or absent.")
  @JsonProperty("option")
  public OptionEnum getOption() {
    return option;
  }
  
  public void setOption(OptionEnum option) {
    this.option = option;
  }

  
  /**
   * This field is only present if the option field is equal to PARAMETER_PRESENT.
   **/
  public OptionalScheduleCreationDescriptor descriptor(ScheduleCreationDescriptor descriptor) {
    this.descriptor = descriptor;
    return this;
  }
  
  @ApiModelProperty(example = "null", value = "This field is only present if the option field is equal to PARAMETER_PRESENT.")
  @JsonProperty("descriptor")
  public ScheduleCreationDescriptor getDescriptor() {
    return descriptor;
  }
  
  public void setDescriptor(ScheduleCreationDescriptor descriptor) {
    this.descriptor = descriptor;
  }

  

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OptionalScheduleCreationDescriptor optionalScheduleCreationDescriptor = (OptionalScheduleCreationDescriptor) o;
    return Objects.equals(this.option, optionalScheduleCreationDescriptor.option) &&
        Objects.equals(this.descriptor, optionalScheduleCreationDescriptor.descriptor);
  }

  @Override
  public int hashCode() {
    return Objects.hash(option, descriptor);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OptionalScheduleCreationDescriptor {\n");
    
    sb.append("    option: ").append(toIndentedString(option)).append("\n");
    sb.append("    descriptor: ").append(toIndentedString(descriptor)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

