package devmgr.api.model;

import devmgr.api.symbol.Drive;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * A hard disk
 */
@XmlRootElement
public class DriveEx extends Drive implements Identifiable {
    public String getId(){
        return getDriveRef();
    }

    @Override
    public boolean equals(Object o) {
        String id = getId();
        if (this == o) return true;
        if (!(o instanceof DriveEx)) return false;

        DriveEx driveEx = (DriveEx) o;

        if (id != null ? !id.equals(driveEx.getId()) : driveEx.getId() != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        String id = getId();
        return id != null ? id.hashCode() : 0;
    }

    /**
     * The Firmware version of the drive with an interposer
     */
    private String firmwareVersion;

    public String getFirmwareVersion()
    {
        return firmwareVersion;
    }

    public void setFirmwareVersion(String versionString)
    {
        this.firmwareVersion = versionString;
    }

    /**
     * Value of the Drive Security lock key identifier
     */
    private String lockKeyIDValue;

    public String getLockKeyIDValue()
    {
        return lockKeyIDValue;
    }

    public void setLockKeyIDValue(String value)
    {
        this.lockKeyIDValue = value;
    }
}
