package devmgr.api.model;

import io.swagger.annotations.ApiModelProperty;

/**
 * Created by lorenp on 2/11/2015.
 */
public enum DriveSpindleSpeed {
    @ApiModelProperty("The spindle speed could not be determined")
    spindleSpeedUnknown(-1),
    @ApiModelProperty("An SSD has no spindle speed")
    spindleSpeedSSD(0),
    @ApiModelProperty("5,400 RPM")
    spindleSpeed5400(5400),
    @ApiModelProperty("7,200 RPM")
    spindleSpeed7200(7200),
    @ApiModelProperty("10,000 RPM")
    spindleSpeed10k(10_000),
    @ApiModelProperty("15,000 RPM")
    spindleSpeed15k(15_000);

    private int value;

    private DriveSpindleSpeed(int value){
        this.value = value;
    }

    public static DriveSpindleSpeed normalize(int value){
        DriveSpindleSpeed ret;
        if(value < 0){
            ret = DriveSpindleSpeed.spindleSpeedUnknown;
        }
        else if(value < 1){
            ret = DriveSpindleSpeed.spindleSpeedSSD;
        }
        else if(value < 6300){
            ret = DriveSpindleSpeed.spindleSpeed5400;
        }
        else if(value < 8600){
            ret = DriveSpindleSpeed.spindleSpeed7200;
        }
        else if(value < 12500){
            ret = DriveSpindleSpeed.spindleSpeed10k;
        }
        else{
            ret = DriveSpindleSpeed.spindleSpeed15k;
        }
        return ret;
    }

}
