package devmgr.api.model;

import devmgr.api.symbol.Host;
import devmgr.api.symbol.HostPort;
import devmgr.api.symbol.Initiator;

import javax.xml.bind.annotation.XmlRootElement;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: masonb
 * Date: 12/11/13
 * Time: 10:46 AM
 * To change this template use File | Settings | File Templates.
 */
@XmlRootElement
public class HostEx extends Host {
    /**
     * Host port for FC, SAS and IB.  iSCSI is different and is represented by Initiator
     */
    private List<HostPort> ports=new ArrayList<>();
    private List<Initiator> initiators = new ArrayList<>();

    /**
     * Higher level collection that is present to make it easier to see the ports.
     * All the needed information is in the ports and initiators collections.  This is just the UI user have an easier access point
     */
    private List<HostSidePort> hostSidePorts=new ArrayList<>();

    /**
     * Id of the host
     */
    public String getId(){
        return getHostRef();
    }

    /**
     * List of HostPorts associated with the host
     */
    public List<HostPort> getPorts() {
        return ports;
    }

    public void setPorts(List<HostPort> ports) {
        this.ports = ports;
    }

    /**
     * List of iSCSI initiators associated with the host
     * @return
     */
    public List<Initiator> getInitiators() {
        return initiators;
    }

    public void setInitiators(List<Initiator> initiators) {
        this.initiators = initiators;
    }

    /**
     * List of ports and initiators associated with the host
     * @return
     */
    public List<HostSidePort> getHostSidePorts() {
        return hostSidePorts;
    }
    /**
     * Higher level collection that is present to make it easier to see the ports.
     * All the needed information is in the ports and initiators collections.  This is just the UI user have an easier access point
     */
    public void setHostSidePorts(List<HostSidePort> hostSidePorts) {
        this.hostSidePorts = hostSidePorts;
    }
}
