/***************************************************************************
 *                                                                         *
 * Copyright 2014 NetApp, Inc. All rights reserved.                        *
 *                                                                         *
 * This file is confidential and a trade secret of NetApp, Inc.            *
 * The receipt of or possession of this file does not convey any rights to *
 * reproduce or disclose its contents or to manufacture, use, or sell      *
 * anything it may describe, in whole, or in part, without the specific    *
 * written consent of NetApp, Inc.                                         *
 *                                                                         *
 ***************************************************************************/

package devmgr.api.model;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class HostTypeValues extends devmgr.api.symbol.HostSpecificValues
{
    private int index;
    private boolean isDefault = false;

    /**
     * Host-type index number stored in the storage system.
     */
    public int getIndex()
    {
        return index;
    }

    /**
     * Set the host-type index number stored in the storage system.
     *
     * @param index Host-type index number
     */
    public void setIndex(int index)
    {
        this.index = index;
    }

    /**
     * Indication if the host port type is the one used by default.
     */
    public boolean isDefault()
    {
        return isDefault;
    }

    /**
     * Set the indication if the host port type is the one used by default.
     *
     * @param isDefault true if the default host port type, false if not
     */
    public void setDefault(boolean isDefault)
    {
        this.isDefault = isDefault;
    }
}
