package devmgr.api.model;

import devmgr.api.symbol.CommandProtocolProperties;
import devmgr.api.symbol.IbInterface;
import io.swagger.annotations.ApiModelProperty;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * Created with IntelliJ IDEA.
 * User: masonb
 * Date: 12/11/13
 * Time: 5:18 PM
 * To change this template use File | Settings | File Templates.
 */

@XmlRootElement
public class IBInterfacePort extends IbInterface implements  HostInterfacePort{
    private String controllerId;

    @ApiModelProperty(value = "List of properties that describe the command protocol.")
    private CommandProtocolProperties[] commandProtocolProperties;

    @Override
    public String getControllerId() {
        return controllerId;
    }

    @Override
    public void setControllerId(String id) {
        this.controllerId=id;
    }

    @Override
    public String getInterfaceId() {
        return getInterfaceRef();
    }

    @Override
    public String getAddressId() {
        return getGlobalIdentifier();
    }

    @Override
    public String getNiceAddressId() {
        return getGlobalIdentifier();
    }


    /**
     * Command protocol properties for a particular interface.
     */
    public CommandProtocolProperties[] getCommandProtocolProperties() {
        return commandProtocolProperties;
    }

    public void setCommandProtocolProperties(CommandProtocolProperties[] commandProtocolProperties) {
        this.commandProtocolProperties = commandProtocolProperties;
    }
}

