/*******************************************************************************
 * Copyright (c) 2016-2017 of NetApp, Inc. All Rights Reserved.                *
 *                                                                             *
 ******************************************************************************/
package devmgr.api.model.ldap;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.xml.bind.annotation.XmlEnumValue;

//TODO: Need to fix issue with Swagger UI displaying enum name instead of the value
@ApiModel
public enum Role {

    @ApiModelProperty(
            allowableValues = GroupMapping.VAL_SECURITYADMIN,
            value = GroupMapping.VAL_SECURITYADMIN,
            example = GroupMapping.VAL_SECURITYADMIN)
    security_admin(GroupMapping.VAL_SECURITYADMIN),

    @ApiModelProperty(
            allowableValues = GroupMapping.VAL_STORAGENONE,
            value = GroupMapping.VAL_STORAGENONE,
            example = GroupMapping.VAL_STORAGENONE)
    storage_none(GroupMapping.VAL_STORAGENONE),

    @ApiModelProperty(
            allowableValues = GroupMapping.VAL_STORAGENONE,
            value = GroupMapping.VAL_STORAGENONE,
            example = GroupMapping.VAL_STORAGENONE)
    support_admin(GroupMapping.VAL_SUPPORTADMIN),

    @ApiModelProperty(
            allowableValues = GroupMapping.VAL_STORAGEMONITOR,
            value = GroupMapping.VAL_STORAGEMONITOR,
            example = GroupMapping.VAL_STORAGEMONITOR)
    storage_monitor(GroupMapping.VAL_STORAGEMONITOR),

    @ApiModelProperty(
            allowableValues = GroupMapping.VAL_STORAGEADMIN,
            value = GroupMapping.VAL_STORAGEADMIN,
            example = GroupMapping.VAL_STORAGEADMIN)
    storage_admin(GroupMapping.VAL_STORAGEADMIN);

    public static Role getEnum(String value) {
        for (Role v : values()) {
            if (v.toString().equalsIgnoreCase(value) || v.name().equalsIgnoreCase(value)) {
                return v;
            }
        }
        throw new IllegalArgumentException("Unable to parse " + value + " as a " + Role.class.getSimpleName());
    }

    private final String name;

    public static String marshal(Role v) {
        return v.toString();
    }

    Role(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
        return name;
    }

}