package devmgr.api.rpc;

@SuppressWarnings("serial")
public class RPCError
extends Exception
{
    public enum ErrorType
    {
        PROTOCOL_ERROR,
        REQUEST_REJECTED,
        BAD_VERIFIER,
        PROG_UNAVAILABLE,
        PROG_MISMATCH,
        ARGS_REJECTED,
        PROC_UNAVAILABLE,
        TIMEOUT,
        CONNECTION_LOST,
        SYSTEM_ERROR, 
        AUTH_ALGORITHM,
        AUTH_REQUIRED,
        INVALID_RBAC_PERMS
    }
    
    private ErrorType m_Type;
    
    public RPCError(ErrorType type)
    {
        m_Type = type;
    }
    
    /**
     * Getter for the error type.
     * @return Error type indicator.
     */
    public ErrorType getType()
    {
        return m_Type;
    }
    
    /**
     * Getter for the message string.
     */
    public String getMessage()
    {
        return m_Type.name();
    }
}
