package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is a variable-length array of AbstractVolRef objects. It is used in situations where a collection of volume objects must be identified for an operation or for conveying configuration information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(682)
public class AbstractVolRefList implements Serializable {
	public AbstractVolRefList() {
	}

	/** The unique identification value of the volume that is accessed via the LUN value associated with this mapping definition. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identification value of the volume that is accessed via the LUN value associated with this mapping definition." , required = true)
	@XmlElement(required = true)
	private String[] abstractVolRef;

	/** @return The unique identification value of the volume that is accessed via the LUN value associated with this mapping definition. */
	public String[] getAbstractVolRef() {
		return this.abstractVolRef;
	}
	/** @param x The unique identification value of the volume that is accessed via the LUN value associated with this mapping definition. */
	public void setAbstractVolRef(String[] x) {
		this.abstractVolRef = x;
	}
}
