package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to return a response from a procedure that acts on an Async Mirror Group. If the return code from the procedure is RETCODE_OK, nothing is returned. If the return code is RETCODE_ARVM_RECOVERY_POINT_DELETION_REQUIRED, the procedure failed and a list of members that triggered the fault is included in the return data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1078)
public class AsyncMirrorGroupActionResult implements Serializable {
	public AsyncMirrorGroupActionResult() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** If the value of returnCode is equal to RETCODE_ARVM_RECOVERY_POINT_DELETION_REQUIRED, a list of members that need to be deleted is returned. */
	@io.swagger.annotations.ApiModelProperty(value ="If the value of returnCode is equal to RETCODE_ARVM_RECOVERY_POINT_DELETION_REQUIRED, a list of members that need to be deleted is returned." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupMemberRefList membersRequiringDeletion;

	/** @return If the value of returnCode is equal to RETCODE_ARVM_RECOVERY_POINT_DELETION_REQUIRED, a list of members that need to be deleted is returned. */
	public AsyncMirrorGroupMemberRefList getMembersRequiringDeletion() {
		return this.membersRequiringDeletion;
	}
	/** @param x If the value of returnCode is equal to RETCODE_ARVM_RECOVERY_POINT_DELETION_REQUIRED, a list of members that need to be deleted is returned. */
	public void setMembersRequiringDeletion(AsyncMirrorGroupMemberRefList x) {
		this.membersRequiringDeletion = x;
	}
}
