package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains test results data from an AMG connectivity test (above and beyond basic return code from the test procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(842)
public class AsyncMirrorGroupConnectivityTestResults implements Serializable {
	public AsyncMirrorGroupConnectivityTestResults() {
	}

	/** Types of AMG connectivity tests. */
	@io.swagger.annotations.ApiModelProperty(value ="Types of AMG connectivity tests." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupConnectivityTestType testType = AsyncMirrorGroupConnectivityTestType.__UNDEFINED;

	/** @return Types of AMG connectivity tests. */
	public AsyncMirrorGroupConnectivityTestType getTestType() {
		return this.testType;
	}
	/** @param x Types of AMG connectivity tests. */
	public void setTestType(AsyncMirrorGroupConnectivityTestType x) {
		this.testType = x;
	}

	/** This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_LATENCY_TEST. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_LATENCY_TEST." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupLinkLatencyTestResults linkTestResults;

	/** @return This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_LATENCY_TEST. */
	public AsyncMirrorGroupLinkLatencyTestResults getLinkTestResults() {
		return this.linkTestResults;
	}
	/** @param x This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_LATENCY_TEST. */
	public void setLinkTestResults(AsyncMirrorGroupLinkLatencyTestResults x) {
		this.linkTestResults = x;
	}

	/** This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_BANDWIDTH_TEST. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_BANDWIDTH_TEST." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupLinkBandwidthTestResults bandwidthTestResults;

	/** @return This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_BANDWIDTH_TEST. */
	public AsyncMirrorGroupLinkBandwidthTestResults getBandwidthTestResults() {
		return this.bandwidthTestResults;
	}
	/** @param x This field is returned if the testType is equal to ASYNC_MIRROR_GROUP_LINK_BANDWIDTH_TEST. */
	public void setBandwidthTestResults(AsyncMirrorGroupLinkBandwidthTestResults x) {
		this.bandwidthTestResults = x;
	}
}
