package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains test results and statistics returned by the testAsyncMirrorGroupConnectivity procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(863)
public class AsyncMirrorGroupConnectivityTestResultsReturned implements Serializable {
	public AsyncMirrorGroupConnectivityTestResultsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** Test results are returned only if the ReturnCode equals RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="Test results are returned only if the ReturnCode equals RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupConnectivityTestResults testResults;

	/** @return Test results are returned only if the ReturnCode equals RETCODE_OK. */
	public AsyncMirrorGroupConnectivityTestResults getTestResults() {
		return this.testResults;
	}
	/** @param x Test results are returned only if the ReturnCode equals RETCODE_OK. */
	public void setTestResults(AsyncMirrorGroupConnectivityTestResults x) {
		this.testResults = x;
	}

	/** A list of mismatched mirror group members is returned only if the ReturnCode equals RETCODE_ARVM_CONNECTIVITY_TEST_AMG_MEMBER_MISMATCH. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of mismatched mirror group members is returned only if the ReturnCode equals RETCODE_ARVM_CONNECTIVITY_TEST_AMG_MEMBER_MISMATCH." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupMemberMismatchList mismatchMembers;

	/** @return A list of mismatched mirror group members is returned only if the ReturnCode equals RETCODE_ARVM_CONNECTIVITY_TEST_AMG_MEMBER_MISMATCH. */
	public AsyncMirrorGroupMemberMismatchList getMismatchMembers() {
		return this.mismatchMembers;
	}
	/** @param x A list of mismatched mirror group members is returned only if the ReturnCode equals RETCODE_ARVM_CONNECTIVITY_TEST_AMG_MEMBER_MISMATCH. */
	public void setMismatchMembers(AsyncMirrorGroupMemberMismatchList x) {
		this.mismatchMembers = x;
	}
}
