package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information about how a new Async Mirror Group is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1200)
public class AsyncMirrorGroupCreationDescriptor implements Serializable {
	public AsyncMirrorGroupCreationDescriptor() {
	}

	/** A reference to an existing Remote Target or candidate information to create a new Remote Target. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to an existing Remote Target or candidate information to create a new Remote Target." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupMirrorConnectionDescriptor connectionDescriptor;

	/** @return A reference to an existing Remote Target or candidate information to create a new Remote Target. */
	public AsyncMirrorGroupMirrorConnectionDescriptor getConnectionDescriptor() {
		return this.connectionDescriptor;
	}
	/** @param x A reference to an existing Remote Target or candidate information to create a new Remote Target. */
	public void setConnectionDescriptor(AsyncMirrorGroupMirrorConnectionDescriptor x) {
		this.connectionDescriptor = x;
	}

	/** A user defined label for the new mirror group. */
	@io.swagger.annotations.ApiModelProperty(value ="A user defined label for the new mirror group." , required = true)
	@XmlElement(required = true)
	private String groupLabel;

	/** @return A user defined label for the new mirror group. */
	public String getGroupLabel() {
		return this.groupLabel;
	}
	/** @param x A user defined label for the new mirror group. */
	public void setGroupLabel(String x) {
		this.groupLabel = x;
	}

	/** The synchronization interval (in minutes). */
	@io.swagger.annotations.ApiModelProperty(value ="The synchronization interval (in minutes)." , required = true)
	@XmlElement(required = true)
	private int syncIntervalMinutes;

	/** @return The synchronization interval (in minutes). */
	public int getSyncIntervalMinutes() {
		return this.syncIntervalMinutes;
	}
	/** @param x The synchronization interval (in minutes). */
	public void setSyncIntervalMinutes(int x) {
		this.syncIntervalMinutes = x;
	}

	/** The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete. */
	@io.swagger.annotations.ApiModelProperty(value ="The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete." , required = true)
	@XmlElement(required = true)
	private int syncCompletionTimeAlertThresholdMinutes;

	/** @return The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete. */
	public int getSyncCompletionTimeAlertThresholdMinutes() {
		return this.syncCompletionTimeAlertThresholdMinutes;
	}
	/** @param x The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete. */
	public void setSyncCompletionTimeAlertThresholdMinutes(int x) {
		this.syncCompletionTimeAlertThresholdMinutes = x;
	}

	/** The recovery point age objective (in minutes). The user is notified via needs-attention when the age of the last good recovery point exceeds this value. */
	@io.swagger.annotations.ApiModelProperty(value ="The recovery point age objective (in minutes). The user is notified via needs-attention when the age of the last good recovery point exceeds this value." , required = true)
	@XmlElement(required = true)
	private int recoveryPointAgeAlertThresholdMinutes;

	/** @return The recovery point age objective (in minutes). The user is notified via needs-attention when the age of the last good recovery point exceeds this value. */
	public int getRecoveryPointAgeAlertThresholdMinutes() {
		return this.recoveryPointAgeAlertThresholdMinutes;
	}
	/** @param x The recovery point age objective (in minutes). The user is notified via needs-attention when the age of the last good recovery point exceeds this value. */
	public void setRecoveryPointAgeAlertThresholdMinutes(int x) {
		this.recoveryPointAgeAlertThresholdMinutes = x;
	}

	/** The repository utilization warning threshold (0-100 percent). A needs attention condition will be generated if the percent of repository capacity currently utilized exceeds this threshold. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold (0-100 percent). A needs attention condition will be generated if the percent of repository capacity currently utilized exceeds this threshold." , required = true)
	@XmlElement(required = true)
	private int repositoryUtilizationWarnThreshold;

	/** @return The repository utilization warning threshold (0-100 percent). A needs attention condition will be generated if the percent of repository capacity currently utilized exceeds this threshold. */
	public int getRepositoryUtilizationWarnThreshold() {
		return this.repositoryUtilizationWarnThreshold;
	}
	/** @param x The repository utilization warning threshold (0-100 percent). A needs attention condition will be generated if the percent of repository capacity currently utilized exceeds this threshold. */
	public void setRepositoryUtilizationWarnThreshold(int x) {
		this.repositoryUtilizationWarnThreshold = x;
	}

	/** The password for remote array. This is required to make sure the SYMbol client has authenticated the users access privileges to both the primary and secondary array. */
	@io.swagger.annotations.ApiModelProperty(value ="The password for remote array. This is required to make sure the SYMbol client has authenticated the users access privileges to both the primary and secondary array." , required = true)
	@XmlElement(required = true)
	private RemoteArrayAuthenticator remotePassword;

	/** @return The password for remote array. This is required to make sure the SYMbol client has authenticated the users access privileges to both the primary and secondary array. */
	public RemoteArrayAuthenticator getRemotePassword() {
		return this.remotePassword;
	}
	/** @param x The password for remote array. This is required to make sure the SYMbol client has authenticated the users access privileges to both the primary and secondary array. */
	public void setRemotePassword(RemoteArrayAuthenticator x) {
		this.remotePassword = x;
	}
}
