package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information about deletion of an Asynchronous Mirror Group (AMG). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(828)
public class AsyncMirrorGroupDeletionDescriptor implements Serializable {
	public AsyncMirrorGroupDeletionDescriptor() {
	}

	/** The AMG to be deleted. */
	@io.swagger.annotations.ApiModelProperty(value ="The AMG to be deleted." , required = true)
	@XmlElement(required = true)
	private String groupRef;

	/** @return The AMG to be deleted. */
	public String getGroupRef() {
		return this.groupRef;
	}
	/** @param x The AMG to be deleted. */
	public void setGroupRef(String x) {
		this.groupRef = x;
	}

	/** If true, indicates that the group deletion should be forced. This is necessary when trying to delete an orphaned AMG or delete an AMG when the remote is unreachable (for example, when the remote array was physically destroyed so the AMG deletion needs to be forced). */
	@io.swagger.annotations.ApiModelProperty(value ="If true, indicates that the group deletion should be forced. This is necessary when trying to delete an orphaned AMG or delete an AMG when the remote is unreachable (for example, when the remote array was physically destroyed so the AMG deletion needs to be forced)." , required = true)
	@XmlElement(required = true)
	private boolean force;

	/** @return If true, indicates that the group deletion should be forced. This is necessary when trying to delete an orphaned AMG or delete an AMG when the remote is unreachable (for example, when the remote array was physically destroyed so the AMG deletion needs to be forced). */
	public boolean isForce() {
		return this.force;
	}
	/** @param x If true, indicates that the group deletion should be forced. This is necessary when trying to delete an orphaned AMG or delete an AMG when the remote is unreachable (for example, when the remote array was physically destroyed so the AMG deletion needs to be forced). */
	public void setForce(boolean x) {
		this.force = x;
	}
}
