package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains test results from an Async Mirror Group bandwidth test. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(620)
public class AsyncMirrorGroupLinkBandwidthTestResults implements Serializable {
	public AsyncMirrorGroupLinkBandwidthTestResults() {
	}

	/** The bandwidth test also returns latency values since latency numbers are measured in order to factor them out of the bandwidth calculations. */
	@io.swagger.annotations.ApiModelProperty(value ="The bandwidth test also returns latency values since latency numbers are measured in order to factor them out of the bandwidth calculations." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupLinkLatencyTestResults latencyMeasures;

	/** @return The bandwidth test also returns latency values since latency numbers are measured in order to factor them out of the bandwidth calculations. */
	public AsyncMirrorGroupLinkLatencyTestResults getLatencyMeasures() {
		return this.latencyMeasures;
	}
	/** @param x The bandwidth test also returns latency values since latency numbers are measured in order to factor them out of the bandwidth calculations. */
	public void setLatencyMeasures(AsyncMirrorGroupLinkLatencyTestResults x) {
		this.latencyMeasures = x;
	}

	/** The minimum bandwidth measured in bits per second. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum bandwidth measured in bits per second." , required = true)
	@XmlElement(required = true)
	private long minBandwidthBitsPerSecond;

	/** @return The minimum bandwidth measured in bits per second. */
	public long getMinBandwidthBitsPerSecond() {
		return this.minBandwidthBitsPerSecond;
	}
	/** @param x The minimum bandwidth measured in bits per second. */
	public void setMinBandwidthBitsPerSecond(long x) {
		this.minBandwidthBitsPerSecond = x;
	}

	/** The maximum bandwidth measured in bits per second. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum bandwidth measured in bits per second." , required = true)
	@XmlElement(required = true)
	private long maxBandwidthBitsPerSecond;

	/** @return The maximum bandwidth measured in bits per second. */
	public long getMaxBandwidthBitsPerSecond() {
		return this.maxBandwidthBitsPerSecond;
	}
	/** @param x The maximum bandwidth measured in bits per second. */
	public void setMaxBandwidthBitsPerSecond(long x) {
		this.maxBandwidthBitsPerSecond = x;
	}

	/** The average bandwidth measured in bits per second. */
	@io.swagger.annotations.ApiModelProperty(value ="The average bandwidth measured in bits per second." , required = true)
	@XmlElement(required = true)
	private long avgBandwidthBitsPerSecond;

	/** @return The average bandwidth measured in bits per second. */
	public long getAvgBandwidthBitsPerSecond() {
		return this.avgBandwidthBitsPerSecond;
	}
	/** @param x The average bandwidth measured in bits per second. */
	public void setAvgBandwidthBitsPerSecond(long x) {
		this.avgBandwidthBitsPerSecond = x;
	}

	/** The negotiated link speed measured in bits per second. */
	@io.swagger.annotations.ApiModelProperty(value ="The negotiated link speed measured in bits per second." , required = true)
	@XmlElement(required = true)
	private long negotiatedLinkSpeedBitsPerSecond;

	/** @return The negotiated link speed measured in bits per second. */
	public long getNegotiatedLinkSpeedBitsPerSecond() {
		return this.negotiatedLinkSpeedBitsPerSecond;
	}
	/** @param x The negotiated link speed measured in bits per second. */
	public void setNegotiatedLinkSpeedBitsPerSecond(long x) {
		this.negotiatedLinkSpeedBitsPerSecond = x;
	}
}
