package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides information about an individual mirror member fault condition. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1091)
public class AsyncMirrorGroupMemberFaultIndication implements Serializable {
	public AsyncMirrorGroupMemberFaultIndication() {
	}

	/** The mirror group member with the fault. */
	@io.swagger.annotations.ApiModelProperty(value ="The mirror group member with the fault." , required = true)
	@XmlElement(required = true)
	private String mirrorMember;

	/** @return The mirror group member with the fault. */
	public String getMirrorMember() {
		return this.mirrorMember;
	}
	/** @param x The mirror group member with the fault. */
	public void setMirrorMember(String x) {
		this.mirrorMember = x;
	}

	/** The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long faultTime;

	/** @return The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970. */
	public long getFaultTime() {
		return this.faultTime;
	}
	/** @param x The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970. */
	public void setFaultTime(long x) {
		this.faultTime = x;
	}

	/** The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}
}
