package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about clearing a"sticky" needs attention condition on an Async Mirror Group member. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1062)
public class AsyncMirrorGroupMemberFaultIndicationClearDescriptor implements Serializable {
	public AsyncMirrorGroupMemberFaultIndicationClearDescriptor() {
	}

	/** The AMG member with condition to be cleared / acknowledged. */
	@io.swagger.annotations.ApiModelProperty(value ="The AMG member with condition to be cleared / acknowledged." , required = true)
	@XmlElement(required = true)
	private String member;

	/** @return The AMG member with condition to be cleared / acknowledged. */
	public String getMember() {
		return this.member;
	}
	/** @param x The AMG member with condition to be cleared / acknowledged. */
	public void setMember(String x) {
		this.member = x;
	}

	/** The type of indication to clear. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of indication to clear." , required = true)
	@XmlElement(required = true)
	private RecoveryFailureType indication = RecoveryFailureType.__UNDEFINED;

	/** @return The type of indication to clear. */
	public RecoveryFailureType getIndication() {
		return this.indication;
	}
	/** @param x The type of indication to clear. */
	public void setIndication(RecoveryFailureType x) {
		this.indication = x;
	}
}
