package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe a mismatch of AsyncMirrorGroupMembers for a given AsyncMirrorGroup. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(769)
public class AsyncMirrorGroupMemberMismatchList implements Serializable {
	public AsyncMirrorGroupMemberMismatchList() {
	}

	/** The Async Mirror Group. */
	@io.swagger.annotations.ApiModelProperty(value ="The Async Mirror Group." , required = true)
	@XmlElement(required = true)
	private String groupRef;

	/** @return The Async Mirror Group. */
	public String getGroupRef() {
		return this.groupRef;
	}
	/** @param x The Async Mirror Group. */
	public void setGroupRef(String x) {
		this.groupRef = x;
	}

	/** A list of base volume labels for members that are present on the local array but not on the remote. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of base volume labels for members that are present on the local array but not on the remote." , required = true)
	@XmlElement(required = true)
	private String[] membersLocalButNotRemote;

	/** @return A list of base volume labels for members that are present on the local array but not on the remote. */
	public String[] getMembersLocalButNotRemote() {
		return this.membersLocalButNotRemote;
	}
	/** @param x A list of base volume labels for members that are present on the local array but not on the remote. */
	public void setMembersLocalButNotRemote(String[] x) {
		this.membersLocalButNotRemote = x;
	}

	/** A list of base volume labels for members that are present on the remote array but not on the local. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of base volume labels for members that are present on the remote array but not on the local." , required = true)
	@XmlElement(required = true)
	private String[] membersRemoteButNotLocal;

	/** @return A list of base volume labels for members that are present on the remote array but not on the local. */
	public String[] getMembersRemoteButNotLocal() {
		return this.membersRemoteButNotLocal;
	}
	/** @param x A list of base volume labels for members that are present on the remote array but not on the local. */
	public void setMembersRemoteButNotLocal(String[] x) {
		this.membersRemoteButNotLocal = x;
	}
}
