package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The Async Mirror Group state. This is primarily intended to reflect the state/presence of a recovery point on the secondary. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(140)
public enum AsyncMirrorGroupState implements Serializable {
		/** Invalid/unknown state. This should never happen. */
		unknown(0),
		/** No complete Recovery Point exists, initial sync in progress. */
		initialSync(1),
		/** Recovery Point exists and age is within time objective. */
		optimal(2),
		/** Recovery Point exists but age is not within time objective. */
		degraded(3),
		/** No Valid Recovery Point (on one or more members) due to failure condition. */
		rpFailed(4),
		__UNDEFINED(464378545);

		public final int value;

		private AsyncMirrorGroupState(int v) {
			this.value = v;
		}
}
