package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report progress of an async mirror synchronization operation for a specific async mirror group. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1070)
public class AsyncMirrorGroupSyncProgress implements Serializable {
	public AsyncMirrorGroupSyncProgress() {
	}

	/** Completion percentage for the operation across the entire group. If synchronization is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	@io.swagger.annotations.ApiModelProperty(value ="Completion percentage for the operation across the entire group. If synchronization is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING." , required = true)
	@XmlElement(required = true)
	private int groupPercentComplete;

	/** @return Completion percentage for the operation across the entire group. If synchronization is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public int getGroupPercentComplete() {
		return this.groupPercentComplete;
	}
	/** @param x Completion percentage for the operation across the entire group. If synchronization is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public void setGroupPercentComplete(int x) {
		this.groupPercentComplete = x;
	}

	/** Estimated time to completion in minutes for all members in the group that are undergoing synchronization. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="Estimated time to completion in minutes for all members in the group that are undergoing synchronization. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN." , required = true)
	@XmlElement(required = true)
	private int groupTimeToCompletion;

	/** @return Estimated time to completion in minutes for all members in the group that are undergoing synchronization. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public int getGroupTimeToCompletion() {
		return this.groupTimeToCompletion;
	}
	/** @param x Estimated time to completion in minutes for all members in the group that are undergoing synchronization. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public void setGroupTimeToCompletion(int x) {
		this.groupTimeToCompletion = x;
	}

	/** Amount of data that needs to be synchronized for the entire group. */
	@io.swagger.annotations.ApiModelProperty(value ="Amount of data that needs to be synchronized for the entire group." , required = true)
	@XmlElement(required = true)
	private long groupSyncBytes;

	/** @return Amount of data that needs to be synchronized for the entire group. */
	public long getGroupSyncBytes() {
		return this.groupSyncBytes;
	}
	/** @param x Amount of data that needs to be synchronized for the entire group. */
	public void setGroupSyncBytes(long x) {
		this.groupSyncBytes = x;
	}

	/** Reference to the async mirror group. */
	@io.swagger.annotations.ApiModelProperty(value ="Reference to the async mirror group." , required = true)
	@XmlElement(required = true)
	private String groupRef;

	/** @return Reference to the async mirror group. */
	public String getGroupRef() {
		return this.groupRef;
	}
	/** @param x Reference to the async mirror group. */
	public void setGroupRef(String x) {
		this.groupRef = x;
	}

	/** List of progress information for each mirror group member. */
	@io.swagger.annotations.ApiModelProperty(value ="List of progress information for each mirror group member." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupMemberSyncProgress[] memberProgress;

	/** @return List of progress information for each mirror group member. */
	public AsyncMirrorGroupMemberSyncProgress[] getMemberProgress() {
		return this.memberProgress;
	}
	/** @param x List of progress information for each mirror group member. */
	public void setMemberProgress(AsyncMirrorGroupMemberSyncProgress[] x) {
		this.memberProgress = x;
	}

	/** The amount of data (in bytes) marked as unsynchronized in the tracking delta logs for the entire group. */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of data (in bytes) marked as unsynchronized in the tracking delta logs for the entire group." , required = true)
	@XmlElement(required = true)
	private long groupTrackingBytes;

	/** @return The amount of data (in bytes) marked as unsynchronized in the tracking delta logs for the entire group. */
	public long getGroupTrackingBytes() {
		return this.groupTrackingBytes;
	}
	/** @param x The amount of data (in bytes) marked as unsynchronized in the tracking delta logs for the entire group. */
	public void setGroupTrackingBytes(long x) {
		this.groupTrackingBytes = x;
	}
}
