package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report on utilization of capacity in async mirror repository. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1080)
public class AsyncMirrorRepositoryUtilization implements Serializable,devmgr.api.model.Identifiable {
	public AsyncMirrorRepositoryUtilization() {
	}

	/** The total number of bytes used in the repository for copy-on-write data and related metadata. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes used in the repository for copy-on-write data and related metadata." , required = true)
	@XmlElement(required = true)
	private long pitDataBytes;

	/** @return The total number of bytes used in the repository for copy-on-write data and related metadata. */
	public long getPitDataBytes() {
		return this.pitDataBytes;
	}
	/** @param x The total number of bytes used in the repository for copy-on-write data and related metadata. */
	public void setPitDataBytes(long x) {
		this.pitDataBytes = x;
	}

	/** The total number of bytes used for the delta logs (bitmaps). */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes used for the delta logs (bitmaps)." , required = true)
	@XmlElement(required = true)
	private long deltaLogBytes;

	/** @return The total number of bytes used for the delta logs (bitmaps). */
	public long getDeltaLogBytes() {
		return this.deltaLogBytes;
	}
	/** @param x The total number of bytes used for the delta logs (bitmaps). */
	public void setDeltaLogBytes(long x) {
		this.deltaLogBytes = x;
	}

	/** The total number of bytes available for ongoing copy-on-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes available for ongoing copy-on-write operations." , required = true)
	@XmlElement(required = true)
	private long bytesAvailable;

	/** @return The total number of bytes available for ongoing copy-on-write operations. */
	public long getBytesAvailable() {
		return this.bytesAvailable;
	}
	/** @param x The total number of bytes available for ongoing copy-on-write operations. */
	public void setBytesAvailable(long x) {
		this.bytesAvailable = x;
	}

	/** The mirror group member for which this utilization information applies. */
	@io.swagger.annotations.ApiModelProperty(value ="The mirror group member for which this utilization information applies." , required = true)
	@XmlElement(required = true)
	private String mirrorRef;

	/** @return The mirror group member for which this utilization information applies. */
	public String getMirrorRef() {
		return this.mirrorRef;
	}
	/** @param x The mirror group member for which this utilization information applies. */
	public void setMirrorRef(String x) {
		this.mirrorRef = x;
	}
	@Override
	public String getId(){
		return mirrorRef;
	}
}
