package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to indicate Async Mirror Sync activity. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(185)
public enum AsyncMirrorSyncActivity implements Serializable {
		/** Invalid/unknown state. This should never happen. */
		unknown(0),
		/** Sync is currently idle. */
		idle(1),
		/** Sync is currently active. */
		active(2),
		/** Sync is currently paused due to link issue (will be idle if user suspended group). */
		paused(3),
		/** Sync has been suspended by a user request. */
		userSuspended(4),
		/** Sync has been suspended by the controller due to an error condition. */
		internallySuspended(5),
		__UNDEFINED(464378545);

		public final int value;

		private AsyncMirrorSyncActivity(int v) {
			this.value = v;
		}
}
