package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type identifies the available iSCSIauthentication methods. The supportedAuthMethods array in the FeatureParams structure will contain values from this enumeration identifying which iSCSI authentication methods are supported on the storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(15)
public enum AuthenticationMethod implements Serializable {
		/** There is no authentication method. */
		none(2),
		/** The authentication method is Challenge Handshake Authentication Protocol (CHAP). */
		chap(4),
		__UNDEFINED(464378545);

		public final int value;

		private AuthenticationMethod(int v) {
			this.value = v;
		}
}
