package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as a template for automatic configuration. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(401)
public class AutoConfigTemplate implements Serializable {
	public AutoConfigTemplate() {
	}

	/** The physical drive type. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical drive type." , required = true)
	@XmlElement(required = true)
	private PhysicalDriveType phyDriveType = PhysicalDriveType.__UNDEFINED;

	/** @return The physical drive type. */
	public PhysicalDriveType getPhyDriveType() {
		return this.phyDriveType;
	}
	/** @param x The physical drive type. */
	public void setPhyDriveType(PhysicalDriveType x) {
		this.phyDriveType = x;
	}

	/** The RAID level of all the potential volumes. */
	@io.swagger.annotations.ApiModelProperty(value ="The RAID level of all the potential volumes." , required = true)
	@XmlElement(required = true)
	private RAIDLevel raidLevel = RAIDLevel.__UNDEFINED;

	/** @return The RAID level of all the potential volumes. */
	public RAIDLevel getRaidLevel() {
		return this.raidLevel;
	}
	/** @param x The RAID level of all the potential volumes. */
	public void setRaidLevel(RAIDLevel x) {
		this.raidLevel = x;
	}

	/** The width of the volume group in drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The width of the volume group in drives." , required = true)
	@XmlElement(required = true)
	private int volumeGroupWidth;

	/** @return The width of the volume group in drives. */
	public int getVolumeGroupWidth() {
		return this.volumeGroupWidth;
	}
	/** @param x The width of the volume group in drives. */
	public void setVolumeGroupWidth(int x) {
		this.volumeGroupWidth = x;
	}

	/** The number of volumes per volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of volumes per volume group." , required = true)
	@XmlElement(required = true)
	private int volumesPerGroup;

	/** @return The number of volumes per volume group. */
	public int getVolumesPerGroup() {
		return this.volumesPerGroup;
	}
	/** @param x The number of volumes per volume group. */
	public void setVolumesPerGroup(int x) {
		this.volumesPerGroup = x;
	}

	/** The number of hot spares to assign. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of hot spares to assign." , required = true)
	@XmlElement(required = true)
	private int numberHotSpares;

	/** @return The number of hot spares to assign. */
	public int getNumberHotSpares() {
		return this.numberHotSpares;
	}
	/** @param x The number of hot spares to assign. */
	public void setNumberHotSpares(int x) {
		this.numberHotSpares = x;
	}

	/** The number of drives to leave unassigned. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of drives to leave unassigned." , required = true)
	@XmlElement(required = true)
	private int numberUnassignedDrives;

	/** @return The number of drives to leave unassigned. */
	public int getNumberUnassignedDrives() {
		return this.numberUnassignedDrives;
	}
	/** @param x The number of drives to leave unassigned. */
	public void setNumberUnassignedDrives(int x) {
		this.numberUnassignedDrives = x;
	}

	/** The segment size for all volumes. */
	@io.swagger.annotations.ApiModelProperty(value ="The segment size for all volumes." , required = true)
	@XmlElement(required = true)
	private int segmentSize;

	/** @return The segment size for all volumes. */
	public int getSegmentSize() {
		return this.segmentSize;
	}
	/** @param x The segment size for all volumes. */
	public void setSegmentSize(int x) {
		this.segmentSize = x;
	}

	/** A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled." , required = true)
	@XmlElement(required = true)
	private int readAhead;

	/** @return A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public int getReadAhead() {
		return this.readAhead;
	}
	/** @param x A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public void setReadAhead(int x) {
		this.readAhead = x;
	}

	/** This field is used to specify the volume group security type. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used to specify the volume group security type." , required = true)
	@XmlElement(required = true)
	private SecurityType volumeGroupSecurityType = SecurityType.__UNDEFINED;

	/** @return This field is used to specify the volume group security type. */
	public SecurityType getVolumeGroupSecurityType() {
		return this.volumeGroupSecurityType;
	}
	/** @param x This field is used to specify the volume group security type. */
	public void setVolumeGroupSecurityType(SecurityType x) {
		this.volumeGroupSecurityType = x;
	}

	/** This field is set to the desired drive media type of the drive. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to the desired drive media type of the drive." , required = true)
	@XmlElement(required = true)
	private DriveMediaType driveMediaType = DriveMediaType.__UNDEFINED;

	/** @return This field is set to the desired drive media type of the drive. */
	public DriveMediaType getDriveMediaType() {
		return this.driveMediaType;
	}
	/** @param x This field is set to the desired drive media type of the drive. */
	public void setDriveMediaType(DriveMediaType x) {
		this.driveMediaType = x;
	}

	/** If this field is set to true, only PI capable drives will be considered for volume candidates, otherwise both PI capable and non-PI capable drives will be considered. */
	@io.swagger.annotations.ApiModelProperty(value ="If this field is set to true, only PI capable drives will be considered for volume candidates, otherwise both PI capable and non-PI capable drives will be considered." , required = true)
	@XmlElement(required = true)
	private boolean onlyProtectionInformationCapable;

	/** @return If this field is set to true, only PI capable drives will be considered for volume candidates, otherwise both PI capable and non-PI capable drives will be considered. */
	public boolean isOnlyProtectionInformationCapable() {
		return this.onlyProtectionInformationCapable;
	}
	/** @param x If this field is set to true, only PI capable drives will be considered for volume candidates, otherwise both PI capable and non-PI capable drives will be considered. */
	public void setOnlyProtectionInformationCapable(boolean x) {
		this.onlyProtectionInformationCapable = x;
	}

	/** Refines the information in the securityType field to describe the set of drives. */
	@io.swagger.annotations.ApiModelProperty(value ="Refines the information in the securityType field to describe the set of drives." , required = true)
	@XmlElement(required = true)
	private SecurityLevel volumeGroupSecurityLevel = SecurityLevel.__UNDEFINED;

	/** @return Refines the information in the securityType field to describe the set of drives. */
	public SecurityLevel getVolumeGroupSecurityLevel() {
		return this.volumeGroupSecurityLevel;
	}
	/** @param x Refines the information in the securityType field to describe the set of drives. */
	public void setVolumeGroupSecurityLevel(SecurityLevel x) {
		this.volumeGroupSecurityLevel = x;
	}
}
