package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to provide all of the component references related to the BBU failure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(784)
public class BatteryPackICCFailure implements Serializable {
	public BatteryPackICCFailure() {
	}

	/** This field is present when the voltage regulator has failed in the battery pack associated with controller A. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present when the voltage regulator has failed in the battery pack associated with controller A." , required = true)
	@XmlElement(required = true)
	private String controllerARef;

	/** @return This field is present when the voltage regulator has failed in the battery pack associated with controller A. */
	public String getControllerARef() {
		return this.controllerARef;
	}
	/** @param x This field is present when the voltage regulator has failed in the battery pack associated with controller A. */
	public void setControllerARef(String x) {
		this.controllerARef = x;
	}

	/** This field is present when the voltage regulator has failed in the battery pack associated with controller B. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present when the voltage regulator has failed in the battery pack associated with controller B." , required = true)
	@XmlElement(required = true)
	private String controllerBRef;

	/** @return This field is present when the voltage regulator has failed in the battery pack associated with controller B. */
	public String getControllerBRef() {
		return this.controllerBRef;
	}
	/** @param x This field is present when the voltage regulator has failed in the battery pack associated with controller B. */
	public void setControllerBRef(String x) {
		this.controllerBRef = x;
	}

	/** This field is present when the charger has failed in the battery pack associated with support CRU A. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present when the charger has failed in the battery pack associated with support CRU A." , required = true)
	@XmlElement(required = true)
	private String supportCRUARef;

	/** @return This field is present when the charger has failed in the battery pack associated with support CRU A. */
	public String getSupportCRUARef() {
		return this.supportCRUARef;
	}
	/** @param x This field is present when the charger has failed in the battery pack associated with support CRU A. */
	public void setSupportCRUARef(String x) {
		this.supportCRUARef = x;
	}

	/** This field is present when the charger has failed in the battery pack associated with support CRU B. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present when the charger has failed in the battery pack associated with support CRU B." , required = true)
	@XmlElement(required = true)
	private String supportCRUBRef;

	/** @return This field is present when the charger has failed in the battery pack associated with support CRU B. */
	public String getSupportCRUBRef() {
		return this.supportCRUBRef;
	}
	/** @param x This field is present when the charger has failed in the battery pack associated with support CRU B. */
	public void setSupportCRUBRef(String x) {
		this.supportCRUBRef = x;
	}

	/** This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed." , required = true)
	@XmlElement(required = true)
	private String batteryPackRef;

	/** @return This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed. */
	public String getBatteryPackRef() {
		return this.batteryPackRef;
	}
	/** @param x This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed. */
	public void setBatteryPackRef(String x) {
		this.batteryPackRef = x;
	}
}
