package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the battery configurations present on a controller. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(97)
public enum BatteryType implements Serializable {
		/** The batteries for the two controllers are packaged in the same customer-replaceable unit. This type is numerically equivalent to BATTERY_TYPE_CONTROLLER_TRAY. */
		singleSharedCru(1),
		/** The batteries for the two controllers are packaged in two individual field-replaceable units. This type is numerically equivalent to BATTERY_TYPE_CONTROLLER. */
		dualIndividualFrus(2),
		/** The batteries for the two controllers are packaged in two shared customer-replaceable units. This type is numerically equivalent to BATTERY_TYPE_PACK_ICC. */
		dualSharedCrus(3),
		/** The batteries for the two controllers are packaged in two individual customer-replaceable units. */
		dualIndividualCrus(4),
		__UNDEFINED(464378545);

		public final int value;

		private BatteryType(int v) {
			this.value = v;
		}
}
