package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about the battery. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(473)
public class BatteryTypeData implements Serializable {
	public BatteryTypeData() {
	}

	/** This enumeration object is used to specify the battery configurations present on a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to specify the battery configurations present on a controller." , required = true)
	@XmlElement(required = true)
	private BatteryType batteryType = BatteryType.__UNDEFINED;

	/** @return This enumeration object is used to specify the battery configurations present on a controller. */
	public BatteryType getBatteryType() {
		return this.batteryType;
	}
	/** @param x This enumeration object is used to specify the battery configurations present on a controller. */
	public void setBatteryType(BatteryType x) {
		this.batteryType = x;
	}

	/** This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with." , required = false)
	@XmlElement(required = false)
	private String cruParentController;

	/** @return This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with. */
	public String getCruParentController() {
		return this.cruParentController;
	}
	/** @param x This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with. */
	public void setCruParentController(String x) {
		this.cruParentController = x;
	}

	/** This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with." , required = false)
	@XmlElement(required = false)
	private String parentController;

	/** @return This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with. */
	public String getParentController() {
		return this.parentController;
	}
	/** @param x This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with. */
	public void setParentController(String x) {
		this.parentController = x;
	}
}
