package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure represents an instance of a cache backup device and identifies various attributes of the device. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(911)
public class CacheBackupDevice implements Serializable,devmgr.api.model.Identifiable {
	public CacheBackupDevice() {
	}

	/** The SYMbol reference that identifies the instance of the device */
	@io.swagger.annotations.ApiModelProperty(value ="The SYMbol reference that identifies the instance of the device" , required = true)
	@XmlElement(required = true)
	private String backupDeviceRef;

	/** @return The SYMbol reference that identifies the instance of the device */
	public String getBackupDeviceRef() {
		return this.backupDeviceRef;
	}
	/** @param x The SYMbol reference that identifies the instance of the device */
	public void setBackupDeviceRef(String x) {
		this.backupDeviceRef = x;
	}

	/** The number of the slot on the controller where the backup device resides. Cache backup device slots are numbered starting at one, independent of other types of slots (e.g., host board slots) on the controller. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the slot on the controller where the backup device resides. Cache backup device slots are numbered starting at one, independent of other types of slots (e.g., host board slots) on the controller. Note that this field is targeted for deletion in SYMbol rev. 85b." , required = true)
	@XmlElement(required = true)
	private int backupDeviceControllerSlot;

	/** @return The number of the slot on the controller where the backup device resides. Cache backup device slots are numbered starting at one, independent of other types of slots (e.g., host board slots) on the controller. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	public int getBackupDeviceControllerSlot() {
		return this.backupDeviceControllerSlot;
	}
	/** @param x The number of the slot on the controller where the backup device resides. Cache backup device slots are numbered starting at one, independent of other types of slots (e.g., host board slots) on the controller. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	public void setBackupDeviceControllerSlot(int x) {
		this.backupDeviceControllerSlot = x;
	}

	/** A reference to the controller where the backup device resides. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller where the backup device resides. Note that this field is targeted for deletion in SYMbol rev. 85b." , required = true)
	@XmlElement(required = true)
	private String parentController;

	/** @return A reference to the controller where the backup device resides. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	public String getParentController() {
		return this.parentController;
	}
	/** @param x A reference to the controller where the backup device resides. Note that this field is targeted for deletion in SYMbol rev. 85b. */
	public void setParentController(String x) {
		this.parentController = x;
	}

	/** The type of the backup device ( e.g., USB flash drive). */
	@io.swagger.annotations.ApiModelProperty(value ="The type of the backup device ( e.g., USB flash drive)." , required = true)
	@XmlElement(required = true)
	private CacheBackupDeviceType backupDeviceType = CacheBackupDeviceType.__UNDEFINED;

	/** @return The type of the backup device ( e.g., USB flash drive). */
	public CacheBackupDeviceType getBackupDeviceType() {
		return this.backupDeviceType;
	}
	/** @param x The type of the backup device ( e.g., USB flash drive). */
	public void setBackupDeviceType(CacheBackupDeviceType x) {
		this.backupDeviceType = x;
	}

	/** The status of the backup device */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the backup device" , required = true)
	@XmlElement(required = true)
	private CacheBackupDeviceStatus backupDeviceStatus = CacheBackupDeviceStatus.__UNDEFINED;

	/** @return The status of the backup device */
	public CacheBackupDeviceStatus getBackupDeviceStatus() {
		return this.backupDeviceStatus;
	}
	/** @param x The status of the backup device */
	public void setBackupDeviceStatus(CacheBackupDeviceStatus x) {
		this.backupDeviceStatus = x;
	}

	/** Vital product data for the backup device. */
	@io.swagger.annotations.ApiModelProperty(value ="Vital product data for the backup device." , required = true)
	@XmlElement(required = true)
	private CacheBackupDeviceVpd backupDeviceVpd;

	/** @return Vital product data for the backup device. */
	public CacheBackupDeviceVpd getBackupDeviceVpd() {
		return this.backupDeviceVpd;
	}
	/** @param x Vital product data for the backup device. */
	public void setBackupDeviceVpd(CacheBackupDeviceVpd x) {
		this.backupDeviceVpd = x;
	}

	/** The capacity of backup device, expressed in megabytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The capacity of backup device, expressed in megabytes." , required = true)
	@XmlElement(required = true)
	private int backupDeviceCapacity;

	/** @return The capacity of backup device, expressed in megabytes. */
	public int getBackupDeviceCapacity() {
		return this.backupDeviceCapacity;
	}
	/** @param x The capacity of backup device, expressed in megabytes. */
	public void setBackupDeviceCapacity(int x) {
		this.backupDeviceCapacity = x;
	}

	/** The repair policy for the cache backup device component. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the cache backup device component." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the cache backup device component. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the cache backup device component. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}

	/** The physical location of the cache backup device. The parent field of Location is set to the controller where the device physically resides, and the position field is the parent-relative/like-component-relative slot number of the device, starting at one. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the cache backup device. The parent field of Location is set to the controller where the device physically resides, and the position field is the parent-relative/like-component-relative slot number of the device, starting at one." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the cache backup device. The parent field of Location is set to the controller where the device physically resides, and the position field is the parent-relative/like-component-relative slot number of the device, starting at one. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the cache backup device. The parent field of Location is set to the controller where the device physically resides, and the position field is the parent-relative/like-component-relative slot number of the device, starting at one. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}
	@Override
	public String getId(){
		return backupDeviceRef;
	}
}
