package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes the location of a cache backup device for reporting cache backup device failures or errors in the major event log. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(322)
public class CacheBackupDeviceLocation implements Serializable {
	public CacheBackupDeviceLocation() {
	}

	/** The tray ID of the controller that houses the cache backup device. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the controller that houses the cache backup device." , required = true)
	@XmlElement(required = true)
	private int controllerTray;

	/** @return The tray ID of the controller that houses the cache backup device. */
	public int getControllerTray() {
		return this.controllerTray;
	}
	/** @param x The tray ID of the controller that houses the cache backup device. */
	public void setControllerTray(int x) {
		this.controllerTray = x;
	}

	/** The slot number of the controller that houses the cache backup device. */
	@io.swagger.annotations.ApiModelProperty(value ="The slot number of the controller that houses the cache backup device." , required = true)
	@XmlElement(required = true)
	private int controllerSlot;

	/** @return The slot number of the controller that houses the cache backup device. */
	public int getControllerSlot() {
		return this.controllerSlot;
	}
	/** @param x The slot number of the controller that houses the cache backup device. */
	public void setControllerSlot(int x) {
		this.controllerSlot = x;
	}

	/** The number of the slot on the controller in which the cache backup device resides. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the slot on the controller in which the cache backup device resides." , required = true)
	@XmlElement(required = true)
	private int cacheBackupDeviceSlot;

	/** @return The number of the slot on the controller in which the cache backup device resides. */
	public int getCacheBackupDeviceSlot() {
		return this.cacheBackupDeviceSlot;
	}
	/** @param x The number of the slot on the controller in which the cache backup device resides. */
	public void setCacheBackupDeviceSlot(int x) {
		this.cacheBackupDeviceSlot = x;
	}
}
