package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the value of the cache flush modifier attribute that is maintained on a per-volume basis. This attribute determines the maximum amount of time that "dirty" (i.e. cached, but not yet written to physical storage) data for the volume can be maintained in cache before being flushed to physical storage. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(188)
public enum CacheFlushModifier implements Serializable {
		/** Cached data will be flushed immediately after it is placed in the cache. */
		flushImmediate(0),
		/** Cached data will be flushed after 250 milliseconds. */
		flush250Msec(1),
		/** Cached data will be flushed after 500 milliseconds. */
		flush500Msec(2),
		/** Cached data will be flushed after 750 milliseconds. */
		flush750Msec(3),
		/** Cached data will be flushed after 1 second. */
		flush1Sec(4),
		/** Cached data will be flushed after 1.5 seconds. */
		flush1500Msec(5),
		/** Cached data will be flushed after 2 seconds. */
		flush2Sec(6),
		/** Cached data will be flushed after 5 seconds. */
		flush5Sec(7),
		/** Cached data will be flushed after 10 seconds. */
		flush10Sec(8),
		/** Cached data will be flushed after 20 seconds. */
		flush20Sec(9),
		/** Cached data will be flushed after 60 seconds. */
		flush60Sec(10),
		/** Cached data will be flushed after 120 seconds. */
		flush120Sec(11),
		/** Cached data will be flushed after 300 seconds. */
		flush300Sec(12),
		/** Cached data will be flushed after 1.2 seconds. */
		flush1200Sec(13),
		/** Cached data will be flushed after 3600 seconds. */
		flush3600Sec(14),
		/** There is no time limit set on dirty cache data. */
		flushInfinite(15),
		__UNDEFINED(464378545);

		public final int value;

		private CacheFlushModifier(int v) {
			this.value = v;
		}
}
