package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes the location of a cache memory DIMM component for purposes of reporting cache-memory-DIMM-related events in the major event log. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(524)
public class CacheMemoryDimmLocation implements Serializable {
	public CacheMemoryDimmLocation() {
	}

	/** The tray ID of the controller where the DIMM is installed. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the controller where the DIMM is installed." , required = true)
	@XmlElement(required = true)
	private int controllerTray;

	/** @return The tray ID of the controller where the DIMM is installed. */
	public int getControllerTray() {
		return this.controllerTray;
	}
	/** @param x The tray ID of the controller where the DIMM is installed. */
	public void setControllerTray(int x) {
		this.controllerTray = x;
	}

	/** The slot number of the controller where the DIMM is installed. */
	@io.swagger.annotations.ApiModelProperty(value ="The slot number of the controller where the DIMM is installed." , required = true)
	@XmlElement(required = true)
	private int controllerSlot;

	/** @return The slot number of the controller where the DIMM is installed. */
	public int getControllerSlot() {
		return this.controllerSlot;
	}
	/** @param x The slot number of the controller where the DIMM is installed. */
	public void setControllerSlot(int x) {
		this.controllerSlot = x;
	}

	/** The number of the slot on the controller where the cache memory DIMM is installed. Cache memory DIMM slots are numbered starting at one, independent of other types of slots (e.g., cache backup device slots) on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the slot on the controller where the cache memory DIMM is installed. Cache memory DIMM slots are numbered starting at one, independent of other types of slots (e.g., cache backup device slots) on the controller." , required = true)
	@XmlElement(required = true)
	private int cacheMemoryDimmControllerSlot;

	/** @return The number of the slot on the controller where the cache memory DIMM is installed. Cache memory DIMM slots are numbered starting at one, independent of other types of slots (e.g., cache backup device slots) on the controller. */
	public int getCacheMemoryDimmControllerSlot() {
		return this.cacheMemoryDimmControllerSlot;
	}
	/** @param x The number of the slot on the controller where the cache memory DIMM is installed. Cache memory DIMM slots are numbered starting at one, independent of other types of slots (e.g., cache backup device slots) on the controller. */
	public void setCacheMemoryDimmControllerSlot(int x) {
		this.cacheMemoryDimmControllerSlot = x;
	}
}
