package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used by the client as the parameter to the getChangeState procedure. It contains information about the most recent configuration state known to the client, and also indicates the maximum hang time for the controller in responding to the request in the absence of a state change. If the controller determines that the client currently has the most up-to-date state information, it will hold onto the request until either a change occurs or the maximum wait time is reached. Otherwise, it will return immediately with information about the new state of the array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(735)
public class ChangeQueryDescriptor implements Serializable {
	public ChangeQueryDescriptor() {
	}

	/** The maximum amount of time (in seconds) the controller can hold the request before responding to the client. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum amount of time (in seconds) the controller can hold the request before responding to the client." , required = true)
	@XmlElement(required = true)
	private int maxWait;

	/** @return The maximum amount of time (in seconds) the controller can hold the request before responding to the client. */
	public int getMaxWait() {
		return this.maxWait;
	}
	/** @param x The maximum amount of time (in seconds) the controller can hold the request before responding to the client. */
	public void setMaxWait(int x) {
		this.maxWait = x;
	}

	/** The ChangeState object represents the client's last known values of the configuration state of the array. The controller uses this information to determine if the client needs to be informed immediately of a change in state. */
	@io.swagger.annotations.ApiModelProperty(value ="The ChangeState object represents the client's last known values of the configuration state of the array. The controller uses this information to determine if the client needs to be informed immediately of a change in state." , required = true)
	@XmlElement(required = true)
	private ChangeState lastKnown;

	/** @return The ChangeState object represents the client's last known values of the configuration state of the array. The controller uses this information to determine if the client needs to be informed immediately of a change in state. */
	public ChangeState getLastKnown() {
		return this.lastKnown;
	}
	/** @param x The ChangeState object represents the client's last known values of the configuration state of the array. The controller uses this information to determine if the client needs to be informed immediately of a change in state. */
	public void setLastKnown(ChangeState x) {
		this.lastKnown = x;
	}
}
