package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(227)
public enum ChannelDiagDataPatternType implements Serializable {
		/** The data pattern is a fixed 32-bit value that is repeated in the data block that is written to the device during the Write phase of the test. */
		fixed(0),
		/** The data pattern is pseudo-random. The value supplied by the client is used as the seed for a pseudo-random sequence that is used to establish the data pattern in the block that is written to the device during the Write phase of the test. */
		random(1),
		__UNDEFINED(464378545);

		public final int value;

		private ChannelDiagDataPatternType(int v) {
			this.value = v;
		}
}
