package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union structure indicates the type of data pattern to use in the channel diagnostic Write-Read-Verify test and provides the associated type-dependent information for the selected pattern type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(385)
public class ChannelDiagDataPatternTypeData implements Serializable {
	public ChannelDiagDataPatternTypeData() {
	}

	/** This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics." , required = true)
	@XmlElement(required = true)
	private ChannelDiagDataPatternType type = ChannelDiagDataPatternType.__UNDEFINED;

	/** @return This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics. */
	public ChannelDiagDataPatternType getType() {
		return this.type;
	}
	/** @param x This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics. */
	public void setType(ChannelDiagDataPatternType x) {
		this.type = x;
	}

	/** A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED. */
	@io.swagger.annotations.ApiModelProperty(value ="A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED." , required = false)
	@XmlElement(required = false)
	private int pattern;

	/** @return A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED. */
	public int getPattern() {
		return this.pattern;
	}
	/** @param x A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED. */
	public void setPattern(int x) {
		this.pattern = x;
	}

	/** A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM. */
	@io.swagger.annotations.ApiModelProperty(value ="A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM." , required = false)
	@XmlElement(required = false)
	private int randomNumberSeed;

	/** @return A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM. */
	public int getRandomNumberSeed() {
		return this.randomNumberSeed;
	}
	/** @param x A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM. */
	public void setRandomNumberSeed(int x) {
		this.randomNumberSeed = x;
	}
}
