package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union type identifies a device for which drive channel fault isolation diagnostics are to be performed. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(765)
public class ChannelDiagDevice implements Serializable {
	public ChannelDiagDevice() {
	}

	/** This enumeration type identifies the types of channel devices on which drive channel fault isolation diagnostics can be run. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration type identifies the types of channel devices on which drive channel fault isolation diagnostics can be run." , required = true)
	@XmlElement(required = true)
	private ChannelDiagDeviceType deviceType = ChannelDiagDeviceType.__UNDEFINED;

	/** @return This enumeration type identifies the types of channel devices on which drive channel fault isolation diagnostics can be run. */
	public ChannelDiagDeviceType getDeviceType() {
		return this.deviceType;
	}
	/** @param x This enumeration type identifies the types of channel devices on which drive channel fault isolation diagnostics can be run. */
	public void setDeviceType(ChannelDiagDeviceType x) {
		this.deviceType = x;
	}

	/** A reference to an instance of a Controller. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to an instance of a Controller. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String controller;

	/** @return A reference to an instance of a Controller. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_CONTROLLER. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference to an instance of a Controller. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_CONTROLLER. */
	public void setController(String x) {
		this.controller = x;
	}

	/** A reference to an instance of a Drive. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_DRIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to an instance of a Drive. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_DRIVE." , required = false)
	@XmlElement(required = false)
	private String drive;

	/** @return A reference to an instance of a Drive. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_DRIVE. */
	public String getDrive() {
		return this.drive;
	}
	/** @param x A reference to an instance of a Drive. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_DRIVE. */
	public void setDrive(String x) {
		this.drive = x;
	}

	/** A reference to an instance of an Esm. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to an instance of an Esm. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_ESM." , required = false)
	@XmlElement(required = false)
	private String esm;

	/** @return A reference to an instance of an Esm. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_ESM. */
	public String getEsm() {
		return this.esm;
	}
	/** @param x A reference to an instance of an Esm. This field is only valid if deviceType is equal to CHANNEL_DIAG_DEVICE_ESM. */
	public void setEsm(String x) {
		this.esm = x;
	}
}
