package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type identifies the types of channel devices on which drive channel fault isolation diagnostics can be run. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(41)
public enum ChannelDiagDeviceType implements Serializable {
		/** An indication that all channel devices are to be included in the test. */
		all(0),
		/** The device to be tested is a controller. */
		controller(1),
		/** The device to be tested is a drive. */
		drive(2),
		/** The device to be tested is an ESM. */
		esm(3),
		__UNDEFINED(464378545);

		public final int value;

		private ChannelDiagDeviceType(int v) {
			this.value = v;
		}
}
