package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union type contains channel diagnostic test results that vary with the particular I/O interface technology of the tested channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1219)
public class ChannelDiagInterfaceDepResults implements Serializable {
	public ChannelDiagInterfaceDepResults() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType interfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getInterfaceType() {
		return this.interfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setInterfaceType(IOInterfaceType x) {
		this.interfaceType = x;
	}

	/** A set of Fibre-Channel-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_FC. */
	@io.swagger.annotations.ApiModelProperty(value ="A set of Fibre-Channel-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_FC." , required = false)
	@XmlElement(required = false)
	private ChannelDiagFcDependentResults fcResults;

	/** @return A set of Fibre-Channel-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_FC. */
	public ChannelDiagFcDependentResults getFcResults() {
		return this.fcResults;
	}
	/** @param x A set of Fibre-Channel-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_FC. */
	public void setFcResults(ChannelDiagFcDependentResults x) {
		this.fcResults = x;
	}

	/** A set of SAS-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_SAS. */
	@io.swagger.annotations.ApiModelProperty(value ="A set of SAS-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_SAS." , required = false)
	@XmlElement(required = false)
	private ChannelDiagSasDependentResults sasResults;

	/** @return A set of SAS-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_SAS. */
	public ChannelDiagSasDependentResults getSasResults() {
		return this.sasResults;
	}
	/** @param x A set of SAS-specific drive channel diagnostic results. This field is present only if interfaceType is set to IO_IF_SAS. */
	public void setSasResults(ChannelDiagSasDependentResults x) {
		this.sasResults = x;
	}
}
