package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type identifies the different status codes that can be reported for a channel diagnostic test. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(167)
public enum ChannelDiagStatus implements Serializable {
		/** The test completed the requested number of iterations. */
		complete(0),
		/** The test did not complete due to unspecified errors. */
		incomplete(1),
		/** The test did not complete due to user cancellation. */
		cancelled(2),
		/** The test did not complete due to expiration of the maximum test time. */
		timeExpired(3),
		/** The test did not start due to errors during test preparation. */
		notStarted(4),
		__UNDEFINED(464378545);

		public final int value;

		private ChannelDiagStatus(int v) {
			this.value = v;
		}
}
