package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union type identifies the parameters for the different types of drive channel fault isolation diagnostic tests. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(420)
public class ChannelDiagTypeParams implements Serializable {
	public ChannelDiagTypeParams() {
	}

	/** This enumeration identifies the different types of drive channel fault isolation diagnostic tests. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration identifies the different types of drive channel fault isolation diagnostic tests." , required = true)
	@XmlElement(required = true)
	private ChannelDiagType type = ChannelDiagType.__UNDEFINED;

	/** @return This enumeration identifies the different types of drive channel fault isolation diagnostic tests. */
	public ChannelDiagType getType() {
		return this.type;
	}
	/** @param x This enumeration identifies the different types of drive channel fault isolation diagnostic tests. */
	public void setType(ChannelDiagType x) {
		this.type = x;
	}

	/** The parameters for the Write-Read-Verify channel diagnostic test. This field is only valid if type is equal to CHANNEL_DIAG_WRITE_READ_VERIFY. */
	@io.swagger.annotations.ApiModelProperty(value ="The parameters for the Write-Read-Verify channel diagnostic test. This field is only valid if type is equal to CHANNEL_DIAG_WRITE_READ_VERIFY." , required = false)
	@XmlElement(required = false)
	private ChannelDiagWrRdVfyParams writeReadVerifyParams;

	/** @return The parameters for the Write-Read-Verify channel diagnostic test. This field is only valid if type is equal to CHANNEL_DIAG_WRITE_READ_VERIFY. */
	public ChannelDiagWrRdVfyParams getWriteReadVerifyParams() {
		return this.writeReadVerifyParams;
	}
	/** @param x The parameters for the Write-Read-Verify channel diagnostic test. This field is only valid if type is equal to CHANNEL_DIAG_WRITE_READ_VERIFY. */
	public void setWriteReadVerifyParams(ChannelDiagWrRdVfyParams x) {
		this.writeReadVerifyParams = x;
	}
}
