package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the results from performing the channel diagnostic Write-Read-Verify test. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1222)
public class ChannelDiagWrRdVfyResults implements Serializable {
	public ChannelDiagWrRdVfyResults() {
	}

	/** The device on which the channel diagnostic test was performed */
	@io.swagger.annotations.ApiModelProperty(value ="The device on which the channel diagnostic test was performed" , required = true)
	@XmlElement(required = true)
	private ChannelDiagDevice device;

	/** @return The device on which the channel diagnostic test was performed */
	public ChannelDiagDevice getDevice() {
		return this.device;
	}
	/** @param x The device on which the channel diagnostic test was performed */
	public void setDevice(ChannelDiagDevice x) {
		this.device = x;
	}

	/** A status code providing general information about the outcome of the diagnostic test. */
	@io.swagger.annotations.ApiModelProperty(value ="A status code providing general information about the outcome of the diagnostic test." , required = true)
	@XmlElement(required = true)
	private ChannelDiagStatus status = ChannelDiagStatus.__UNDEFINED;

	/** @return A status code providing general information about the outcome of the diagnostic test. */
	public ChannelDiagStatus getStatus() {
		return this.status;
	}
	/** @param x A status code providing general information about the outcome of the diagnostic test. */
	public void setStatus(ChannelDiagStatus x) {
		this.status = x;
	}

	/** The number of seconds the diagnostic test actually ran. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of seconds the diagnostic test actually ran." , required = true)
	@XmlElement(required = true)
	private int actualTimeInterval;

	/** @return The number of seconds the diagnostic test actually ran. */
	public int getActualTimeInterval() {
		return this.actualTimeInterval;
	}
	/** @param x The number of seconds the diagnostic test actually ran. */
	public void setActualTimeInterval(int x) {
		this.actualTimeInterval = x;
	}

	/** The total number of iterations attempted */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of iterations attempted" , required = true)
	@XmlElement(required = true)
	private int iterationsAttempted;

	/** @return The total number of iterations attempted */
	public int getIterationsAttempted() {
		return this.iterationsAttempted;
	}
	/** @param x The total number of iterations attempted */
	public void setIterationsAttempted(int x) {
		this.iterationsAttempted = x;
	}

	/** The device on which the tests were performed. */
	@io.swagger.annotations.ApiModelProperty(value ="The device on which the tests were performed." , required = true)
	@XmlElement(required = true)
	private int channelResetsDetected;

	/** @return The device on which the tests were performed. */
	public int getChannelResetsDetected() {
		return this.channelResetsDetected;
	}
	/** @param x The device on which the tests were performed. */
	public void setChannelResetsDetected(int x) {
		this.channelResetsDetected = x;
	}

	/** The number of iterations that completed successfully/ */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that completed successfully/" , required = true)
	@XmlElement(required = true)
	private int iterationsPassed;

	/** @return The number of iterations that completed successfully/ */
	public int getIterationsPassed() {
		return this.iterationsPassed;
	}
	/** @param x The number of iterations that completed successfully/ */
	public void setIterationsPassed(int x) {
		this.iterationsPassed = x;
	}

	/** The number of iterations that failed due to data miscompares. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to data miscompares." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithMiscompares;

	/** @return The number of iterations that failed due to data miscompares. */
	public int getIterationsFailedWithMiscompares() {
		return this.iterationsFailedWithMiscompares;
	}
	/** @param x The number of iterations that failed due to data miscompares. */
	public void setIterationsFailedWithMiscompares(int x) {
		this.iterationsFailedWithMiscompares = x;
	}

	/** The number of iterations that failed due to setup errors prior to starting the iteration. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to setup errors prior to starting the iteration." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithSetupErrors;

	/** @return The number of iterations that failed due to setup errors prior to starting the iteration. */
	public int getIterationsFailedWithSetupErrors() {
		return this.iterationsFailedWithSetupErrors;
	}
	/** @param x The number of iterations that failed due to setup errors prior to starting the iteration. */
	public void setIterationsFailedWithSetupErrors(int x) {
		this.iterationsFailedWithSetupErrors = x;
	}

	/** The number of iterations that failed due I/O timeouts on outbound-data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due I/O timeouts on outbound-data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithOutboundTimeouts;

	/** @return The number of iterations that failed due I/O timeouts on outbound-data commands. */
	public int getIterationsFailedWithOutboundTimeouts() {
		return this.iterationsFailedWithOutboundTimeouts;
	}
	/** @param x The number of iterations that failed due I/O timeouts on outbound-data commands. */
	public void setIterationsFailedWithOutboundTimeouts(int x) {
		this.iterationsFailedWithOutboundTimeouts = x;
	}

	/** The number of iterations that failed due to channel-level resets that occurred during outbound-data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to channel-level resets that occurred during outbound-data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithOutboundResets;

	/** @return The number of iterations that failed due to channel-level resets that occurred during outbound-data commands. */
	public int getIterationsFailedWithOutboundResets() {
		return this.iterationsFailedWithOutboundResets;
	}
	/** @param x The number of iterations that failed due to channel-level resets that occurred during outbound-data commands. */
	public void setIterationsFailedWithOutboundResets(int x) {
		this.iterationsFailedWithOutboundResets = x;
	}

	/** The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on outbound data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on outbound data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithOutboundMiscErrors;

	/** @return The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on outbound data commands. */
	public int getIterationsFailedWithOutboundMiscErrors() {
		return this.iterationsFailedWithOutboundMiscErrors;
	}
	/** @param x The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on outbound data commands. */
	public void setIterationsFailedWithOutboundMiscErrors(int x) {
		this.iterationsFailedWithOutboundMiscErrors = x;
	}

	/** The number of iterations that failed due I/O timeouts on inbound-data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due I/O timeouts on inbound-data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithInboundTimeouts;

	/** @return The number of iterations that failed due I/O timeouts on inbound-data commands. */
	public int getIterationsFailedWithInboundTimeouts() {
		return this.iterationsFailedWithInboundTimeouts;
	}
	/** @param x The number of iterations that failed due I/O timeouts on inbound-data commands. */
	public void setIterationsFailedWithInboundTimeouts(int x) {
		this.iterationsFailedWithInboundTimeouts = x;
	}

	/** The number of iterations that failed due to channel-level resets that occurred during inbound-data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to channel-level resets that occurred during inbound-data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithInboundResets;

	/** @return The number of iterations that failed due to channel-level resets that occurred during inbound-data commands. */
	public int getIterationsFailedWithInboundResets() {
		return this.iterationsFailedWithInboundResets;
	}
	/** @param x The number of iterations that failed due to channel-level resets that occurred during inbound-data commands. */
	public void setIterationsFailedWithInboundResets(int x) {
		this.iterationsFailedWithInboundResets = x;
	}

	/** The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on inbound-data commands. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on inbound-data commands." , required = true)
	@XmlElement(required = true)
	private int iterationsFailedWithInboundMiscErrors;

	/** @return The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on inbound-data commands. */
	public int getIterationsFailedWithInboundMiscErrors() {
		return this.iterationsFailedWithInboundMiscErrors;
	}
	/** @param x The number of iterations that failed due to other command failures (e.g., check conditions, aborted commands, channel-level resets, etc.) on inbound-data commands. */
	public void setIterationsFailedWithInboundMiscErrors(int x) {
		this.iterationsFailedWithInboundMiscErrors = x;
	}

	/** The average elapsed command-processing time, in microseconds) for the outbound-data phases of all successful iterations. */
	@io.swagger.annotations.ApiModelProperty(value ="The average elapsed command-processing time, in microseconds) for the outbound-data phases of all successful iterations." , required = true)
	@XmlElement(required = true)
	private int averageElapsedTimeForOutboundPhases;

	/** @return The average elapsed command-processing time, in microseconds) for the outbound-data phases of all successful iterations. */
	public int getAverageElapsedTimeForOutboundPhases() {
		return this.averageElapsedTimeForOutboundPhases;
	}
	/** @param x The average elapsed command-processing time, in microseconds) for the outbound-data phases of all successful iterations. */
	public void setAverageElapsedTimeForOutboundPhases(int x) {
		this.averageElapsedTimeForOutboundPhases = x;
	}

	/** The statistical variance of the elapsed command-processing time for the outbound-data phases of all successful variations. */
	@io.swagger.annotations.ApiModelProperty(value ="The statistical variance of the elapsed command-processing time for the outbound-data phases of all successful variations." , required = true)
	@XmlElement(required = true)
	private int varianceInElapsedTimeForOutboundPhases;

	/** @return The statistical variance of the elapsed command-processing time for the outbound-data phases of all successful variations. */
	public int getVarianceInElapsedTimeForOutboundPhases() {
		return this.varianceInElapsedTimeForOutboundPhases;
	}
	/** @param x The statistical variance of the elapsed command-processing time for the outbound-data phases of all successful variations. */
	public void setVarianceInElapsedTimeForOutboundPhases(int x) {
		this.varianceInElapsedTimeForOutboundPhases = x;
	}

	/** The average elapsed command-processing time, in microseconds) for the inbound-data phases of all successful iterations. */
	@io.swagger.annotations.ApiModelProperty(value ="The average elapsed command-processing time, in microseconds) for the inbound-data phases of all successful iterations." , required = true)
	@XmlElement(required = true)
	private int averageElapsedTimeForInboundPhases;

	/** @return The average elapsed command-processing time, in microseconds) for the inbound-data phases of all successful iterations. */
	public int getAverageElapsedTimeForInboundPhases() {
		return this.averageElapsedTimeForInboundPhases;
	}
	/** @param x The average elapsed command-processing time, in microseconds) for the inbound-data phases of all successful iterations. */
	public void setAverageElapsedTimeForInboundPhases(int x) {
		this.averageElapsedTimeForInboundPhases = x;
	}

	/** The statistical variance of the elapsed command-processing time for the inbound-data phases of all successful variations. */
	@io.swagger.annotations.ApiModelProperty(value ="The statistical variance of the elapsed command-processing time for the inbound-data phases of all successful variations." , required = true)
	@XmlElement(required = true)
	private int varianceInElapsedTimeForInboundPhases;

	/** @return The statistical variance of the elapsed command-processing time for the inbound-data phases of all successful variations. */
	public int getVarianceInElapsedTimeForInboundPhases() {
		return this.varianceInElapsedTimeForInboundPhases;
	}
	/** @param x The statistical variance of the elapsed command-processing time for the inbound-data phases of all successful variations. */
	public void setVarianceInElapsedTimeForInboundPhases(int x) {
		this.varianceInElapsedTimeForInboundPhases = x;
	}

	/** A set of channel diagnostic test results that depend on the particular I/O interface technology of the tested channel. */
	@io.swagger.annotations.ApiModelProperty(value ="A set of channel diagnostic test results that depend on the particular I/O interface technology of the tested channel." , required = true)
	@XmlElement(required = true)
	private ChannelDiagInterfaceDepResults interfaceDependentResults;

	/** @return A set of channel diagnostic test results that depend on the particular I/O interface technology of the tested channel. */
	public ChannelDiagInterfaceDepResults getInterfaceDependentResults() {
		return this.interfaceDependentResults;
	}
	/** @param x A set of channel diagnostic test results that depend on the particular I/O interface technology of the tested channel. */
	public void setInterfaceDependentResults(ChannelDiagInterfaceDepResults x) {
		this.interfaceDependentResults = x;
	}

	/** The number of the drive channel on which testing was performed. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the drive channel on which testing was performed." , required = true)
	@XmlElement(required = true)
	private int driveChannel;

	/** @return The number of the drive channel on which testing was performed. */
	public int getDriveChannel() {
		return this.driveChannel;
	}
	/** @param x The number of the drive channel on which testing was performed. */
	public void setDriveChannel(int x) {
		this.driveChannel = x;
	}
}
