package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the startChannelDiagnostics procedure. It contains all of the arguments needed to specify a drive channel fault isolation diagnostic test to perform. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(892)
public class ChannelDiagnosticDescriptor implements Serializable {
	public ChannelDiagnosticDescriptor() {
	}

	/** A reference indicating the controller that is to perform the test. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference indicating the controller that is to perform the test." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return A reference indicating the controller that is to perform the test. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference indicating the controller that is to perform the test. */
	public void setController(String x) {
		this.controller = x;
	}

	/** The number of the drive channel to test. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the drive channel to test." , required = true)
	@XmlElement(required = true)
	private int driveChannel;

	/** @return The number of the drive channel to test. */
	public int getDriveChannel() {
		return this.driveChannel;
	}
	/** @param x The number of the drive channel to test. */
	public void setDriveChannel(int x) {
		this.driveChannel = x;
	}

	/** A variable-length array of values, each value indicating a device on the referenced channel to be included in the test. To specify "all devices," all that is needed is a single instance of ChannelDiagDevice with deviceType set to CHANNEL_DEVICE_ALL. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length array of values, each value indicating a device on the referenced channel to be included in the test. To specify \"all devices,\" all that is needed is a single instance of ChannelDiagDevice with deviceType set to CHANNEL_DEVICE_ALL." , required = true)
	@XmlElement(required = true)
	private ChannelDiagDevice[] devices;

	/** @return A variable-length array of values, each value indicating a device on the referenced channel to be included in the test. To specify "all devices," all that is needed is a single instance of ChannelDiagDevice with deviceType set to CHANNEL_DEVICE_ALL. */
	public ChannelDiagDevice[] getDevices() {
		return this.devices;
	}
	/** @param x A variable-length array of values, each value indicating a device on the referenced channel to be included in the test. To specify "all devices," all that is needed is a single instance of ChannelDiagDevice with deviceType set to CHANNEL_DEVICE_ALL. */
	public void setDevices(ChannelDiagDevice[] x) {
		this.devices = x;
	}

	/** The maximum number of seconds the test is allowed to run before it is forcibly terminated. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum number of seconds the test is allowed to run before it is forcibly terminated." , required = true)
	@XmlElement(required = true)
	private int maxTimeInterval;

	/** @return The maximum number of seconds the test is allowed to run before it is forcibly terminated. */
	public int getMaxTimeInterval() {
		return this.maxTimeInterval;
	}
	/** @param x The maximum number of seconds the test is allowed to run before it is forcibly terminated. */
	public void setMaxTimeInterval(int x) {
		this.maxTimeInterval = x;
	}

	/** A sub-structure indicating both the type of diagnostic test to perform and the associated test-type-dependent parameters. */
	@io.swagger.annotations.ApiModelProperty(value ="A sub-structure indicating both the type of diagnostic test to perform and the associated test-type-dependent parameters." , required = true)
	@XmlElement(required = true)
	private ChannelDiagTypeParams diagParams;

	/** @return A sub-structure indicating both the type of diagnostic test to perform and the associated test-type-dependent parameters. */
	public ChannelDiagTypeParams getDiagParams() {
		return this.diagParams;
	}
	/** @param x A sub-structure indicating both the type of diagnostic test to perform and the associated test-type-dependent parameters. */
	public void setDiagParams(ChannelDiagTypeParams x) {
		this.diagParams = x;
	}
}
