package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used for the return value of the getPendingHosts procedure call. It contains a return code and may contain a CheckedPendingHostList. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1220)
public class CheckedPendingHostListReturned implements Serializable {
	public CheckedPendingHostListReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is valid only if the return code is RETCODE_OK. It is a variable-length list of CheckedPendingHost structures. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only if the return code is RETCODE_OK. It is a variable-length list of CheckedPendingHost structures." , required = false)
	@XmlElement(required = false)
	private CheckedPendingHostList checkedPendingHostList;

	/** @return This field is valid only if the return code is RETCODE_OK. It is a variable-length list of CheckedPendingHost structures. */
	public CheckedPendingHostList getCheckedPendingHostList() {
		return this.checkedPendingHostList;
	}
	/** @param x This field is valid only if the return code is RETCODE_OK. It is a variable-length list of CheckedPendingHost structures. */
	public void setCheckedPendingHostList(CheckedPendingHostList x) {
		this.checkedPendingHostList = x;
	}
}
