package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is returned to the getClusterPerformanceParameters command. If the return code is OK, the data structure containing the performance parameters for the cluster is returned. Otherwise, only the return code is returned. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(851)
public class ClusterPerformanceLimitationValuesReturned implements Serializable {
	public ClusterPerformanceLimitationValuesReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** If the return code is RETCODE_OK, the cluster performance limitation values struct is also returned. */
	@io.swagger.annotations.ApiModelProperty(value ="If the return code is RETCODE_OK, the cluster performance limitation values struct is also returned." , required = false)
	@XmlElement(required = false)
	private ClusterPerformanceLimitationValues clusterPerformanceLimitationValues;

	/** @return If the return code is RETCODE_OK, the cluster performance limitation values struct is also returned. */
	public ClusterPerformanceLimitationValues getClusterPerformanceLimitationValues() {
		return this.clusterPerformanceLimitationValues;
	}
	/** @param x If the return code is RETCODE_OK, the cluster performance limitation values struct is also returned. */
	public void setClusterPerformanceLimitationValues(ClusterPerformanceLimitationValues x) {
		this.clusterPerformanceLimitationValues = x;
	}
}
