package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains information required by the analyzeCoWRepository procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(640)
public class CoWRepositoryAnalysisRequest implements Serializable {
	public CoWRepositoryAnalysisRequest() {
	}

	/** This enumeration defines the different action types to be used when requesting a CoW repository analysis. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different action types to be used when requesting a CoW repository analysis." , required = true)
	@XmlElement(required = true)
	private CoWRepositoryAnalysisAction action = CoWRepositoryAnalysisAction.__UNDEFINED;

	/** @return This enumeration defines the different action types to be used when requesting a CoW repository analysis. */
	public CoWRepositoryAnalysisAction getAction() {
		return this.action;
	}
	/** @param x This enumeration defines the different action types to be used when requesting a CoW repository analysis. */
	public void setAction(CoWRepositoryAnalysisAction x) {
		this.action = x;
	}

	/** If the action field equals REPOSITORY_ANALYSIS_TYPE_SPECIFIC_REPOSITORY, then an identifier for the associated volume is returned. */
	@io.swagger.annotations.ApiModelProperty(value ="If the action field equals REPOSITORY_ANALYSIS_TYPE_SPECIFIC_REPOSITORY, then an identifier for the associated volume is returned." , required = false)
	@XmlElement(required = false)
	private String associatedVolume;

	/** @return If the action field equals REPOSITORY_ANALYSIS_TYPE_SPECIFIC_REPOSITORY, then an identifier for the associated volume is returned. */
	public String getAssociatedVolume() {
		return this.associatedVolume;
	}
	/** @param x If the action field equals REPOSITORY_ANALYSIS_TYPE_SPECIFIC_REPOSITORY, then an identifier for the associated volume is returned. */
	public void setAssociatedVolume(String x) {
		this.associatedVolume = x;
	}
}
