package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Identifies a specific code module within the loaded firmware */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(244)
public enum CodeModule implements Serializable {
		/** Invalid or unknown code module */
		unspecified(0),
		/** The RAID controller firmware code module */
		raid(1),
		/** Hypervisor and hypervisor control code module */
		hypervisor(2),
		/** Embedded management code module */
		management(3),
		/** IOM firmware code module */
		iom(4),
		/** Loadable NVSRAM code module */
		nvsram(5),
		/** Downloadable comprehensive bundle of code modules */
		bundle(6),
		/** User-visible display for the comprehensive bundle of code modules */
		bundleDisplay(7),
		__UNDEFINED(464378545);

		public final int value;

		private CodeModule(int v) {
			this.value = v;
		}
}
