package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains the properties associated with a command protocol. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1183)
public class CommandProtocolProperties implements Serializable {
	public CommandProtocolProperties() {
	}

	/** This enumeration describes the command protocol (e.g. SCSI vs. NVMe). */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration describes the command protocol (e.g. SCSI vs. NVMe)." , required = true)
	@XmlElement(required = true)
	private CommandProtocol commandProtocol = CommandProtocol.__UNDEFINED;

	/** @return This enumeration describes the command protocol (e.g. SCSI vs. NVMe). */
	public CommandProtocol getCommandProtocol() {
		return this.commandProtocol;
	}
	/** @param x This enumeration describes the command protocol (e.g. SCSI vs. NVMe). */
	public void setCommandProtocol(CommandProtocol x) {
		this.commandProtocol = x;
	}

	/** This field describes the NVMe command protocol properties. */
	@io.swagger.annotations.ApiModelProperty(value ="This field describes the NVMe command protocol properties." , required = false)
	@XmlElement(required = false)
	private NVMeCommandProtocolProperties nvmeProperties;

	/** @return This field describes the NVMe command protocol properties. */
	public NVMeCommandProtocolProperties getNvmeProperties() {
		return this.nvmeProperties;
	}
	/** @param x This field describes the NVMe command protocol properties. */
	public void setNvmeProperties(NVMeCommandProtocolProperties x) {
		this.nvmeProperties = x;
	}
}
