package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to group all the components. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1187)
public class ComponentBundle implements Serializable {
	public ComponentBundle() {
	}

	/** The fan component. */
	@io.swagger.annotations.ApiModelProperty(value ="The fan component." , required = true)
	@XmlElement(required = true)
	private Fan[] fan;

	/** @return The fan component. */
	public Fan[] getFan() {
		return this.fan;
	}
	/** @param x The fan component. */
	public void setFan(Fan[] x) {
		this.fan = x;
	}

	/** The battery component. */
	@io.swagger.annotations.ApiModelProperty(value ="The battery component." , required = true)
	@XmlElement(required = true)
	private Battery[] battery;

	/** @return The battery component. */
	public Battery[] getBattery() {
		return this.battery;
	}
	/** @param x The battery component. */
	public void setBattery(Battery[] x) {
		this.battery = x;
	}

	/** The power supply component. */
	@io.swagger.annotations.ApiModelProperty(value ="The power supply component." , required = true)
	@XmlElement(required = true)
	private PowerSupply[] powerSupply;

	/** @return The power supply component. */
	public PowerSupply[] getPowerSupply() {
		return this.powerSupply;
	}
	/** @param x The power supply component. */
	public void setPowerSupply(PowerSupply[] x) {
		this.powerSupply = x;
	}

	/** The thermal sensor component. */
	@io.swagger.annotations.ApiModelProperty(value ="The thermal sensor component." , required = true)
	@XmlElement(required = true)
	private ThermalSensor[] thermalSensor;

	/** @return The thermal sensor component. */
	public ThermalSensor[] getThermalSensor() {
		return this.thermalSensor;
	}
	/** @param x The thermal sensor component. */
	public void setThermalSensor(ThermalSensor[] x) {
		this.thermalSensor = x;
	}

	/** The ESM component. */
	@io.swagger.annotations.ApiModelProperty(value ="The ESM component." , required = true)
	@XmlElement(required = true)
	private Esm[] esm;

	/** @return The ESM component. */
	public Esm[] getEsm() {
		return this.esm;
	}
	/** @param x The ESM component. */
	public void setEsm(Esm[] x) {
		this.esm = x;
	}

	/** The UPS component. */
	@io.swagger.annotations.ApiModelProperty(value ="The UPS component." , required = true)
	@XmlElement(required = true)
	private Ups[] ups;

	/** @return The UPS component. */
	public Ups[] getUps() {
		return this.ups;
	}
	/** @param x The UPS component. */
	public void setUps(Ups[] x) {
		this.ups = x;
	}

	/** The minihub component. */
	@io.swagger.annotations.ApiModelProperty(value ="The minihub component." , required = true)
	@XmlElement(required = true)
	private Minihub[] minihub;

	/** @return The minihub component. */
	public Minihub[] getMinihub() {
		return this.minihub;
	}
	/** @param x The minihub component. */
	public void setMinihub(Minihub[] x) {
		this.minihub = x;
	}

	/** The GBIC component. */
	@io.swagger.annotations.ApiModelProperty(value ="The GBIC component." , required = true)
	@XmlElement(required = true)
	private Gbic[] gbic;

	/** @return The GBIC component. */
	public Gbic[] getGbic() {
		return this.gbic;
	}
	/** @param x The GBIC component. */
	public void setGbic(Gbic[] x) {
		this.gbic = x;
	}

	/** The SFP component. */
	@io.swagger.annotations.ApiModelProperty(value ="The SFP component." , required = true)
	@XmlElement(required = true)
	private Sfp[] sfp;

	/** @return The SFP component. */
	public Sfp[] getSfp() {
		return this.sfp;
	}
	/** @param x The SFP component. */
	public void setSfp(Sfp[] x) {
		this.sfp = x;
	}

	/** The interconnect CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="The interconnect CRU." , required = true)
	@XmlElement(required = true)
	private InterconnectCRU[] interconnectCRU;

	/** @return The interconnect CRU. */
	public InterconnectCRU[] getInterconnectCRU() {
		return this.interconnectCRU;
	}
	/** @param x The interconnect CRU. */
	public void setInterconnectCRU(InterconnectCRU[] x) {
		this.interconnectCRU = x;
	}

	/** The Support CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="The Support CRU." , required = true)
	@XmlElement(required = true)
	private SupportCRU[] supportCRU;

	/** @return The Support CRU. */
	public SupportCRU[] getSupportCRU() {
		return this.supportCRU;
	}
	/** @param x The Support CRU. */
	public void setSupportCRU(SupportCRU[] x) {
		this.supportCRU = x;
	}

	/** The alarm. */
	@io.swagger.annotations.ApiModelProperty(value ="The alarm." , required = true)
	@XmlElement(required = true)
	private Alarm[] alarm;

	/** @return The alarm. */
	public Alarm[] getAlarm() {
		return this.alarm;
	}
	/** @param x The alarm. */
	public void setAlarm(Alarm[] x) {
		this.alarm = x;
	}

	/** The host board. */
	@io.swagger.annotations.ApiModelProperty(value ="The host board." , required = true)
	@XmlElement(required = true)
	private HostBoard[] hostBoard;

	/** @return The host board. */
	public HostBoard[] getHostBoard() {
		return this.hostBoard;
	}
	/** @param x The host board. */
	public void setHostBoard(HostBoard[] x) {
		this.hostBoard = x;
	}

	/** The SAS expanders. */
	@io.swagger.annotations.ApiModelProperty(value ="The SAS expanders." , required = true)
	@XmlElement(required = true)
	private SasExpander[] sasExpander;

	/** @return The SAS expanders. */
	public SasExpander[] getSasExpander() {
		return this.sasExpander;
	}
	/** @param x The SAS expanders. */
	public void setSasExpander(SasExpander[] x) {
		this.sasExpander = x;
	}

	/** The cache backup devices. */
	@io.swagger.annotations.ApiModelProperty(value ="The cache backup devices." , required = true)
	@XmlElement(required = true)
	private CacheBackupDevice[] cacheBackupDevice;

	/** @return The cache backup devices. */
	public CacheBackupDevice[] getCacheBackupDevice() {
		return this.cacheBackupDevice;
	}
	/** @param x The cache backup devices. */
	public void setCacheBackupDevice(CacheBackupDevice[] x) {
		this.cacheBackupDevice = x;
	}

	/** List of field replaceable cache memory DIMM modules. */
	@io.swagger.annotations.ApiModelProperty(value ="List of field replaceable cache memory DIMM modules." , required = true)
	@XmlElement(required = true)
	private CacheMemoryDimm[] cacheMemoryDimm;

	/** @return List of field replaceable cache memory DIMM modules. */
	public CacheMemoryDimm[] getCacheMemoryDimm() {
		return this.cacheMemoryDimm;
	}
	/** @param x List of field replaceable cache memory DIMM modules. */
	public void setCacheMemoryDimm(CacheMemoryDimm[] x) {
		this.cacheMemoryDimm = x;
	}

	/** List of field replaceable processor memory DIMMs. */
	@io.swagger.annotations.ApiModelProperty(value ="List of field replaceable processor memory DIMMs." , required = true)
	@XmlElement(required = true)
	private ProcessorMemoryDimm[] processorMemoryDimm;

	/** @return List of field replaceable processor memory DIMMs. */
	public ProcessorMemoryDimm[] getProcessorMemoryDimm() {
		return this.processorMemoryDimm;
	}
	/** @param x List of field replaceable processor memory DIMMs. */
	public void setProcessorMemoryDimm(ProcessorMemoryDimm[] x) {
		this.processorMemoryDimm = x;
	}

	/** List of drawers. */
	@io.swagger.annotations.ApiModelProperty(value ="List of drawers." , required = true)
	@XmlElement(required = true)
	private Drawer[] drawer;

	/** @return List of drawers. */
	public Drawer[] getDrawer() {
		return this.drawer;
	}
	/** @param x List of drawers. */
	public void setDrawer(Drawer[] x) {
		this.drawer = x;
	}
}
