package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type contains information about the location or identification of a component for which a MEL entry was generated. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1001)
public class ComponentLocation implements Serializable {
	public ComponentLocation() {
	}

	/** This enumeration object is used to specify the different component types that can be associated with entries in the Major Event Log. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to specify the different component types that can be associated with entries in the Major Event Log." , required = true)
	@XmlElement(required = true)
	private EventComponentType eventComponentType = EventComponentType.__UNDEFINED;

	/** @return This enumeration object is used to specify the different component types that can be associated with entries in the Major Event Log. */
	public EventComponentType getEventComponentType() {
		return this.eventComponentType;
	}
	/** @param x This enumeration object is used to specify the different component types that can be associated with entries in the Major Event Log. */
	public void setEventComponentType(EventComponentType x) {
		this.eventComponentType = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ALARM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ALARM." , required = false)
	@XmlElement(required = false)
	private TraySlot alarmLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ALARM. */
	public TraySlot getAlarmLocation() {
		return this.alarmLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ALARM. */
	public void setAlarmLocation(TraySlot x) {
		this.alarmLocation = x;
	}

	/** The tray ID of the tray containing the battery for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_BATTERY. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the battery for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_BATTERY." , required = false)
	@XmlElement(required = false)
	private int batteryTray;

	/** @return The tray ID of the tray containing the battery for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_BATTERY. */
	public int getBatteryTray() {
		return this.batteryTray;
	}
	/** @param x The tray ID of the tray containing the battery for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_BATTERY. */
	public void setBatteryTray(int x) {
		this.batteryTray = x;
	}

	/** This field is valid only when the eventComponentType value is equal toEVENT_COMP_TYPE_CACHE_BACKUP_DEVICE. It identifies the location of the cache backup device to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal toEVENT_COMP_TYPE_CACHE_BACKUP_DEVICE. It identifies the location of the cache backup device to which the event applies." , required = false)
	@XmlElement(required = false)
	private CacheBackupDeviceLocation cacheBackupDeviceLocation;

	/** @return This field is valid only when the eventComponentType value is equal toEVENT_COMP_TYPE_CACHE_BACKUP_DEVICE. It identifies the location of the cache backup device to which the event applies. */
	public CacheBackupDeviceLocation getCacheBackupDeviceLocation() {
		return this.cacheBackupDeviceLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal toEVENT_COMP_TYPE_CACHE_BACKUP_DEVICE. It identifies the location of the cache backup device to which the event applies. */
	public void setCacheBackupDeviceLocation(CacheBackupDeviceLocation x) {
		this.cacheBackupDeviceLocation = x;
	}

	/** This field is only valid when the eventComponentType value is equal to EVENT_COMP_TYPE_CACHE_MEM_DIMM. It identifies the location of the cache memory DIMM to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType value is equal to EVENT_COMP_TYPE_CACHE_MEM_DIMM. It identifies the location of the cache memory DIMM to which the event applies." , required = false)
	@XmlElement(required = false)
	private CacheMemoryDimmLocation cacheMemoryDimmLocation;

	/** @return This field is only valid when the eventComponentType value is equal to EVENT_COMP_TYPE_CACHE_MEM_DIMM. It identifies the location of the cache memory DIMM to which the event applies. */
	public CacheMemoryDimmLocation getCacheMemoryDimmLocation() {
		return this.cacheMemoryDimmLocation;
	}
	/** @param x This field is only valid when the eventComponentType value is equal to EVENT_COMP_TYPE_CACHE_MEM_DIMM. It identifies the location of the cache memory DIMM to which the event applies. */
	public void setCacheMemoryDimmLocation(CacheMemoryDimmLocation x) {
		this.cacheMemoryDimmLocation = x;
	}

	/** The location of the channel. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL. */
	@io.swagger.annotations.ApiModelProperty(value ="The location of the channel. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL." , required = false)
	@XmlElement(required = false)
	private ChannelLocation channelLoc;

	/** @return The location of the channel. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL. */
	public ChannelLocation getChannelLoc() {
		return this.channelLoc;
	}
	/** @param x The location of the channel. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL. */
	public void setChannelLoc(ChannelLocation x) {
		this.channelLoc = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL_PORT. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL_PORT." , required = false)
	@XmlElement(required = false)
	private int channelPort;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL_PORT. */
	public int getChannelPort() {
		return this.channelPort;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHANNEL_PORT. */
	public void setChannelPort(int x) {
		this.channelPort = x;
	}

	/** The physical location of the controller that owns the chip for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHIP. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the controller that owns the chip for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHIP." , required = false)
	@XmlElement(required = false)
	private TraySlot chipLoc;

	/** @return The physical location of the controller that owns the chip for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHIP. */
	public TraySlot getChipLoc() {
		return this.chipLoc;
	}
	/** @param x The physical location of the controller that owns the chip for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CHIP. */
	public void setChipLoc(TraySlot x) {
		this.chipLoc = x;
	}

	/** The physical location of the controller for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the controller for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private TraySlot controllerLoc;

	/** @return The physical location of the controller for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CONTROLLER. */
	public TraySlot getControllerLoc() {
		return this.controllerLoc;
	}
	/** @param x The physical location of the controller for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CONTROLLER. */
	public void setControllerLoc(TraySlot x) {
		this.controllerLoc = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SFP." , required = false)
	@XmlElement(required = false)
	private ControllerSfpLocation ctlrSfpLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SFP. */
	public ControllerSfpLocation getCtlrSfpLocation() {
		return this.ctlrSfpLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SFP. */
	public void setCtlrSfpLocation(ControllerSfpLocation x) {
		this.ctlrSfpLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SOC. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SOC." , required = false)
	@XmlElement(required = false)
	private SocLocation socLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SOC. */
	public SocLocation getSocLocation() {
		return this.socLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_CTLR_SOC. */
	public void setSocLocation(SocLocation x) {
		this.socLocation = x;
	}

	/** The physical location of the drive for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_DRIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the drive for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_DRIVE." , required = false)
	@XmlElement(required = false)
	private TraySlot driveLoc;

	/** @return The physical location of the drive for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_DRIVE. */
	public TraySlot getDriveLoc() {
		return this.driveLoc;
	}
	/** @param x The physical location of the drive for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_DRIVE. */
	public void setDriveLoc(TraySlot x) {
		this.driveLoc = x;
	}

	/** The tray ID of the tray for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ENCLOSURE. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ENCLOSURE." , required = false)
	@XmlElement(required = false)
	private int enclosureTray;

	/** @return The tray ID of the tray for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ENCLOSURE. */
	public int getEnclosureTray() {
		return this.enclosureTray;
	}
	/** @param x The tray ID of the tray for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ENCLOSURE. */
	public void setEnclosureTray(int x) {
		this.enclosureTray = x;
	}

	/** The tray ID of the tray containing the ESM card for which the MEL entry was generated. This field is not used and is considered deprecated. Instead the ESM tray/slot location is given by the ExtendedComponentLocation field. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the ESM card for which the MEL entry was generated. This field is not used and is considered deprecated. Instead the ESM tray/slot location is given by the ExtendedComponentLocation field." , required = false)
	@XmlElement(required = false)
	private int esmTray;

	/** @return The tray ID of the tray containing the ESM card for which the MEL entry was generated. This field is not used and is considered deprecated. Instead the ESM tray/slot location is given by the ExtendedComponentLocation field. */
	public int getEsmTray() {
		return this.esmTray;
	}
	/** @param x The tray ID of the tray containing the ESM card for which the MEL entry was generated. This field is not used and is considered deprecated. Instead the ESM tray/slot location is given by the ExtendedComponentLocation field. */
	public void setEsmTray(int x) {
		this.esmTray = x;
	}

	/** The tray ID of the tray containing the fan for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_FAN. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the fan for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_FAN." , required = false)
	@XmlElement(required = false)
	private int fanTray;

	/** @return The tray ID of the tray containing the fan for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_FAN. */
	public int getFanTray() {
		return this.fanTray;
	}
	/** @param x The tray ID of the tray containing the fan for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_FAN. */
	public void setFanTray(int x) {
		this.fanTray = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_HOST_IO_CARD. It identifies the location of the host I/O card to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_HOST_IO_CARD. It identifies the location of the host I/O card to which the event applies." , required = false)
	@XmlElement(required = false)
	private HostIoCardLocation hostIoCardLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_HOST_IO_CARD. It identifies the location of the host I/O card to which the event applies. */
	public HostIoCardLocation getHostIoCardLocation() {
		return this.hostIoCardLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_HOST_IO_CARD. It identifies the location of the host I/O card to which the event applies. */
	public void setHostIoCardLocation(HostIoCardLocation x) {
		this.hostIoCardLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_INITIATOR. It identifies the iSCSI initiator to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_INITIATOR. It identifies the iSCSI initiator to which the event applies." , required = false)
	@XmlElement(required = false)
	private InitiatorLocation initiatorLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_INITIATOR. It identifies the iSCSI initiator to which the event applies. */
	public InitiatorLocation getInitiatorLocation() {
		return this.initiatorLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_INITIATOR. It identifies the iSCSI initiator to which the event applies. */
	public void setInitiatorLocation(InitiatorLocation x) {
		this.initiatorLocation = x;
	}

	/** No information is returned */
	@io.swagger.annotations.ApiModelProperty(value ="No information is returned" , required = false)
	@XmlElement(required = false)
	private TraySlot interconnectCruLocation;

	/** @return No information is returned */
	public TraySlot getInterconnectCruLocation() {
		return this.interconnectCruLocation;
	}
	/** @param x No information is returned */
	public void setInterconnectCruLocation(TraySlot x) {
		this.interconnectCruLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ISNS_SERVER. It identifies the iSNS server to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ISNS_SERVER. It identifies the iSNS server to which the event applies." , required = false)
	@XmlElement(required = false)
	private IsnsServerLocation isnsServerLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ISNS_SERVER. It identifies the iSNS server to which the event applies. */
	public IsnsServerLocation getIsnsServerLocation() {
		return this.isnsServerLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_ISNS_SERVER. It identifies the iSNS server to which the event applies. */
	public void setIsnsServerLocation(IsnsServerLocation x) {
		this.isnsServerLocation = x;
	}

	/** The location of the minihub. This filed is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_MINIHUB. */
	@io.swagger.annotations.ApiModelProperty(value ="The location of the minihub. This filed is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_MINIHUB." , required = false)
	@XmlElement(required = false)
	private MinihubLocation minihubLoc;

	/** @return The location of the minihub. This filed is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_MINIHUB. */
	public MinihubLocation getMinihubLoc() {
		return this.minihubLoc;
	}
	/** @param x The location of the minihub. This filed is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_MINIHUB. */
	public void setMinihubLoc(MinihubLocation x) {
		this.minihubLoc = x;
	}

	/** The tray ID of the tray containing the Fibre Channel port CRU for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_PORT_CRU. This field is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the Fibre Channel port CRU for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_PORT_CRU. This field is deprecated." , required = false)
	@XmlElement(required = false)
	private int portCruTray;

	/** @return The tray ID of the tray containing the Fibre Channel port CRU for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_PORT_CRU. This field is deprecated. */
	public int getPortCruTray() {
		return this.portCruTray;
	}
	/** @param x The tray ID of the tray containing the Fibre Channel port CRU for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_PORT_CRU. This field is deprecated. */
	public void setPortCruTray(int x) {
		this.portCruTray = x;
	}

	/** The tray ID of the tray containing the power supply for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_POWER_SPLY. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the power supply for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_POWER_SPLY." , required = false)
	@XmlElement(required = false)
	private int powerSupplyTray;

	/** @return The tray ID of the tray containing the power supply for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_POWER_SPLY. */
	public int getPowerSupplyTray() {
		return this.powerSupplyTray;
	}
	/** @param x The tray ID of the tray containing the power supply for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_POWER_SPLY. */
	public void setPowerSupplyTray(int x) {
		this.powerSupplyTray = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SFP_PORT. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SFP_PORT." , required = false)
	@XmlElement(required = false)
	private TraySlot sfpLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SFP_PORT. */
	public TraySlot getSfpLocation() {
		return this.sfpLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SFP_PORT. */
	public void setSfpLocation(TraySlot x) {
		this.sfpLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SUPPORT_CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SUPPORT_CRU." , required = false)
	@XmlElement(required = false)
	private TraySlot supportCruLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SUPPORT_CRU. */
	public TraySlot getSupportCruLocation() {
		return this.supportCruLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_SUPPORT_CRU. */
	public void setSupportCruLocation(TraySlot x) {
		this.supportCruLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TARGET. It identifies the iSCSI target to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TARGET. It identifies the iSCSI target to which the event applies." , required = false)
	@XmlElement(required = false)
	private TargetLocation targetLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TARGET. It identifies the iSCSI target to which the event applies. */
	public TargetLocation getTargetLocation() {
		return this.targetLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TARGET. It identifies the iSCSI target to which the event applies. */
	public void setTargetLocation(TargetLocation x) {
		this.targetLocation = x;
	}

	/** The tray ID of the tray containing the temperature sensor for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TEMP_SENSOR. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the temperature sensor for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TEMP_SENSOR." , required = false)
	@XmlElement(required = false)
	private int tempSensorTray;

	/** @return The tray ID of the tray containing the temperature sensor for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TEMP_SENSOR. */
	public int getTempSensorTray() {
		return this.tempSensorTray;
	}
	/** @param x The tray ID of the tray containing the temperature sensor for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_TEMP_SENSOR. */
	public void setTempSensorTray(int x) {
		this.tempSensorTray = x;
	}

	/** The user-assigned label of the volume for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned label of the volume for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME" , required = false)
	@XmlElement(required = false)
	private String label;

	/** @return The user-assigned label of the volume for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME */
	public String getLabel() {
		return this.label;
	}
	/** @param x The user-assigned label of the volume for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The volume group sequence number of the volume group for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME_GRP. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume group sequence number of the volume group for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME_GRP." , required = false)
	@XmlElement(required = false)
	private int groupNumber;

	/** @return The volume group sequence number of the volume group for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME_GRP. */
	public int getGroupNumber() {
		return this.groupNumber;
	}
	/** @param x The volume group sequence number of the volume group for which the MEL entry was generated. This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_VOLUME_GRP. */
	public void setGroupNumber(int x) {
		this.groupNumber = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST. It is the user-assigned label of the host for which the MEL entry is reporting a problem. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST. It is the user-assigned label of the host for which the MEL entry is reporting a problem." , required = false)
	@XmlElement(required = false)
	private String hostLocation;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST. It is the user-assigned label of the host for which the MEL entry is reporting a problem. */
	public String getHostLocation() {
		return this.hostLocation;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST. It is the user-assigned label of the host for which the MEL entry is reporting a problem. */
	public void setHostLocation(String x) {
		this.hostLocation = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST_PORT. It identifies the host port to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST_PORT. It identifies the host port to which the event applies." , required = false)
	@XmlElement(required = false)
	private HostPortLocation hostPortLocation;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST_PORT. It identifies the host port to which the event applies. */
	public HostPortLocation getHostPortLocation() {
		return this.hostPortLocation;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_HOST_PORT. It identifies the host port to which the event applies. */
	public void setHostPortLocation(HostPortLocation x) {
		this.hostPortLocation = x;
	}

	/** The physical location of the drawer for which the MEL event was generated. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DRAWER. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the drawer for which the MEL event was generated. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DRAWER." , required = false)
	@XmlElement(required = false)
	private TraySlot drawerLocation;

	/** @return The physical location of the drawer for which the MEL event was generated. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DRAWER. */
	public TraySlot getDrawerLocation() {
		return this.drawerLocation;
	}
	/** @param x The physical location of the drawer for which the MEL event was generated. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DRAWER. */
	public void setDrawerLocation(TraySlot x) {
		this.drawerLocation = x;
	}

	/** The component type and location are described in this field. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_RELATIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="The component type and location are described in this field. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_RELATIVE." , required = false)
	@XmlElement(required = false)
	private ComponentRelativeLocation componentRelativeLocation;

	/** @return The component type and location are described in this field. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_RELATIVE. */
	public ComponentRelativeLocation getComponentRelativeLocation() {
		return this.componentRelativeLocation;
	}
	/** @param x The component type and location are described in this field. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_RELATIVE. */
	public void setComponentRelativeLocation(ComponentRelativeLocation x) {
		this.componentRelativeLocation = x;
	}

	/** The user-assigned label of the schedule. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SCHEDULE. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned label of the schedule. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SCHEDULE." , required = false)
	@XmlElement(required = false)
	private String schedule;

	/** @return The user-assigned label of the schedule. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SCHEDULE. */
	public String getSchedule() {
		return this.schedule;
	}
	/** @param x The user-assigned label of the schedule. This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SCHEDULE. */
	public void setSchedule(String x) {
		this.schedule = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DISK_POOL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DISK_POOL." , required = false)
	@XmlElement(required = false)
	private int diskPool;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DISK_POOL. */
	public int getDiskPool() {
		return this.diskPool;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_DISK_POOL. */
	public void setDiskPool(int x) {
		this.diskPool = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_ASYNC_MIRROR_GROUP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_ASYNC_MIRROR_GROUP." , required = false)
	@XmlElement(required = false)
	private String asyncMirrorGroup;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_ASYNC_MIRROR_GROUP. */
	public String getAsyncMirrorGroup() {
		return this.asyncMirrorGroup;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_ASYNC_MIRROR_GROUP. */
	public void setAsyncMirrorGroup(String x) {
		this.asyncMirrorGroup = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT. Note that events for PITs also include extended component location information beyond just the associated PiT Group label (PITs themselves are identified by a combination of the label of the associated PiT Group plus a sequence number). */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT. Note that events for PITs also include extended component location information beyond just the associated PiT Group label (PITs themselves are identified by a combination of the label of the associated PiT Group plus a sequence number)." , required = false)
	@XmlElement(required = false)
	private String pitLabel;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT. Note that events for PITs also include extended component location information beyond just the associated PiT Group label (PITs themselves are identified by a combination of the label of the associated PiT Group plus a sequence number). */
	public String getPitLabel() {
		return this.pitLabel;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT. Note that events for PITs also include extended component location information beyond just the associated PiT Group label (PITs themselves are identified by a combination of the label of the associated PiT Group plus a sequence number). */
	public void setPitLabel(String x) {
		this.pitLabel = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT_CONSISTENCY_GROUP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT_CONSISTENCY_GROUP." , required = false)
	@XmlElement(required = false)
	private String cgLabel;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT_CONSISTENCY_GROUP. */
	public String getCgLabel() {
		return this.cgLabel;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_PIT_CONSISTENCY_GROUP. */
	public void setCgLabel(String x) {
		this.cgLabel = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGPIT. Note that events for CGPITs also include extended component location information beyond just the associated CG label (CGPITs themselves are identified by a combination of the label of the associated Consistency Group plus a sequence number). */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGPIT. Note that events for CGPITs also include extended component location information beyond just the associated CG label (CGPITs themselves are identified by a combination of the label of the associated Consistency Group plus a sequence number)." , required = false)
	@XmlElement(required = false)
	private String cgPitLabel;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGPIT. Note that events for CGPITs also include extended component location information beyond just the associated CG label (CGPITs themselves are identified by a combination of the label of the associated Consistency Group plus a sequence number). */
	public String getCgPitLabel() {
		return this.cgPitLabel;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGPIT. Note that events for CGPITs also include extended component location information beyond just the associated CG label (CGPITs themselves are identified by a combination of the label of the associated Consistency Group plus a sequence number). */
	public void setCgPitLabel(String x) {
		this.cgPitLabel = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGVIEW. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGVIEW." , required = false)
	@XmlElement(required = false)
	private String cgViewLabel;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGVIEW. */
	public String getCgViewLabel() {
		return this.cgViewLabel;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_CGVIEW. */
	public void setCgViewLabel(String x) {
		this.cgViewLabel = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FLASH_CACHE. It identifies the flash cache device to which this event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FLASH_CACHE. It identifies the flash cache device to which this event applies." , required = false)
	@XmlElement(required = false)
	private String flashCacheLabel;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FLASH_CACHE. It identifies the flash cache device to which this event applies. */
	public String getFlashCacheLabel() {
		return this.flashCacheLabel;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FLASH_CACHE. It identifies the flash cache device to which this event applies. */
	public void setFlashCacheLabel(String x) {
		this.flashCacheLabel = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_COMMUNITY. The community name string can contain up to 31 characters. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_COMMUNITY. The community name string can contain up to 31 characters." , required = false)
	@XmlElement(required = false)
	private String communityNameString;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_COMMUNITY. The community name string can contain up to 31 characters. */
	public String getCommunityNameString() {
		return this.communityNameString;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_COMMUNITY. The community name string can contain up to 31 characters. */
	public void setCommunityNameString(String x) {
		this.communityNameString = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_TRAP_DESTINATION. It contains an ASCII representation of the destination address (the maximum number of characters is 40 for IPV6, 15 characters for IPV4. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_TRAP_DESTINATION. It contains an ASCII representation of the destination address (the maximum number of characters is 40 for IPV6, 15 characters for IPV4." , required = false)
	@XmlElement(required = false)
	private String destinationIpAddress;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_TRAP_DESTINATION. It contains an ASCII representation of the destination address (the maximum number of characters is 40 for IPV6, 15 characters for IPV4. */
	public String getDestinationIpAddress() {
		return this.destinationIpAddress;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_SNMP_TRAP_DESTINATION. It contains an ASCII representation of the destination address (the maximum number of characters is 40 for IPV6, 15 characters for IPV4. */
	public void setDestinationIpAddress(String x) {
		this.destinationIpAddress = x;
	}

	/** This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FC_TARGET. It contains location data that is an 8-byte binary SCSI name. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FC_TARGET. It contains location data that is an 8-byte binary SCSI name." , required = false)
	@XmlElement(required = false)
	private FibreChannelTargetLocation fcTargetLocation;

	/** @return This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FC_TARGET. It contains location data that is an 8-byte binary SCSI name. */
	public FibreChannelTargetLocation getFcTargetLocation() {
		return this.fcTargetLocation;
	}
	/** @param x This field is only valid when the eventComponentType field is equal to EVENT_COMP_TYPE_FC_TARGET. It contains location data that is an 8-byte binary SCSI name. */
	public void setFcTargetLocation(FibreChannelTargetLocation x) {
		this.fcTargetLocation = x;
	}

	/** Location information for fan CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="Location information for fan CRU." , required = false)
	@XmlElement(required = false)
	private TraySlot fanCruLocation;

	/** @return Location information for fan CRU. */
	public TraySlot getFanCruLocation() {
		return this.fanCruLocation;
	}
	/** @param x Location information for fan CRU. */
	public void setFanCruLocation(TraySlot x) {
		this.fanCruLocation = x;
	}

	/** Power supply CRU location. */
	@io.swagger.annotations.ApiModelProperty(value ="Power supply CRU location." , required = false)
	@XmlElement(required = false)
	private TraySlot powerSupplyCruLocation;

	/** @return Power supply CRU location. */
	public TraySlot getPowerSupplyCruLocation() {
		return this.powerSupplyCruLocation;
	}
	/** @param x Power supply CRU location. */
	public void setPowerSupplyCruLocation(TraySlot x) {
		this.powerSupplyCruLocation = x;
	}

	/** This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_NVME_INITIATOR. It identifies the NVMe initiator to which the event applies. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_NVME_INITIATOR. It identifies the NVMe initiator to which the event applies." , required = false)
	@XmlElement(required = false)
	private InitiatorLocation nvmeInitiatorLocation;

	/** @return This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_NVME_INITIATOR. It identifies the NVMe initiator to which the event applies. */
	public InitiatorLocation getNvmeInitiatorLocation() {
		return this.nvmeInitiatorLocation;
	}
	/** @param x This field is valid only when the eventComponentType value is equal to EVENT_COMP_TYPE_NVME_INITIATOR. It identifies the NVMe initiator to which the event applies. */
	public void setNvmeInitiatorLocation(InitiatorLocation x) {
		this.nvmeInitiatorLocation = x;
	}
}
