package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides support for parent-relative location reporting within MEL events. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(625)
public class ComponentRelativeLocation implements Serializable {
	public ComponentRelativeLocation() {
	}

	/** The type of component. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of component." , required = true)
	@XmlElement(required = true)
	private EventComponentType componentType = EventComponentType.__UNDEFINED;

	/** @return The type of component. */
	public EventComponentType getComponentType() {
		return this.componentType;
	}
	/** @param x The type of component. */
	public void setComponentType(EventComponentType x) {
		this.componentType = x;
	}

	/** The tray ID of the tray containing the component. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray containing the component." , required = true)
	@XmlElement(required = true)
	private int trayId;

	/** @return The tray ID of the tray containing the component. */
	public int getTrayId() {
		return this.trayId;
	}
	/** @param x The tray ID of the tray containing the component. */
	public void setTrayId(int x) {
		this.trayId = x;
	}

	/** The relative position within the component's parent. */
	@io.swagger.annotations.ApiModelProperty(value ="The relative position within the component's parent." , required = true)
	@XmlElement(required = true)
	private int relativePosition;

	/** @return The relative position within the component's parent. */
	public int getRelativePosition() {
		return this.relativePosition;
	}
	/** @param x The relative position within the component's parent. */
	public void setRelativePosition(int x) {
		this.relativePosition = x;
	}

	/** The size of the parent array that follows. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the parent array that follows." , required = true)
	@XmlElement(required = true)
	private int parentSize;

	/** @return The size of the parent array that follows. */
	public int getParentSize() {
		return this.parentSize;
	}
	/** @param x The size of the parent array that follows. */
	public void setParentSize(int x) {
		this.parentSize = x;
	}

	/** This is an array containing additional parent-relative location information. The first element in the array will contain the parent's component type and its relative position within it's parent. */
	@io.swagger.annotations.ApiModelProperty(value ="This is an array containing additional parent-relative location information. The first element in the array will contain the parent's component type and its relative position within it's parent." , required = true)
	@XmlElement(required = true)
	private ParentRelativeLocation[] parent;

	/** @return This is an array containing additional parent-relative location information. The first element in the array will contain the parent's component type and its relative position within it's parent. */
	public ParentRelativeLocation[] getParent() {
		return this.parent;
	}
	/** @param x This is an array containing additional parent-relative location information. The first element in the array will contain the parent's component type and its relative position within it's parent. */
	public void setParent(ParentRelativeLocation[] x) {
		this.parent = x;
	}

	/** Contains the label of the component. */
	@io.swagger.annotations.ApiModelProperty(value ="Contains the label of the component." , required = true)
	@XmlElement(required = true)
	private String componentLabel;

	/** @return Contains the label of the component. */
	public String getComponentLabel() {
		return this.componentLabel;
	}
	/** @param x Contains the label of the component. */
	public void setComponentLabel(String x) {
		this.componentLabel = x;
	}
}
