package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union conveys information about how a new ConcatVolume is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1131)
public class ConcatVolumeCandidate implements Serializable {
	public ConcatVolumeCandidate() {
	}

	/** This enumeration is used to specify the Concatenated Volume candidate type. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to specify the Concatenated Volume candidate type." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeCandidateType candType = ConcatVolumeCandidateType.__UNDEFINED;

	/** @return This enumeration is used to specify the Concatenated Volume candidate type. */
	public ConcatVolumeCandidateType getCandType() {
		return this.candType;
	}
	/** @param x This enumeration is used to specify the Concatenated Volume candidate type. */
	public void setCandType(ConcatVolumeCandidateType x) {
		this.candType = x;
	}

	/** This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_NEW_VOL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_NEW_VOL." , required = false)
	@XmlElement(required = false)
	private ConcatVolumeNewVolumeCandidate newVolCandidate;

	/** @return This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_NEW_VOL. */
	public ConcatVolumeNewVolumeCandidate getNewVolCandidate() {
		return this.newVolCandidate;
	}
	/** @param x This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_NEW_VOL. */
	public void setNewVolCandidate(ConcatVolumeNewVolumeCandidate x) {
		this.newVolCandidate = x;
	}

	/** This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXISTING_VOLS. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXISTING_VOLS." , required = false)
	@XmlElement(required = false)
	private ConcatVolumeExistingVolumeCandidate existVolCandidate;

	/** @return This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXISTING_VOLS. */
	public ConcatVolumeExistingVolumeCandidate getExistVolCandidate() {
		return this.existVolCandidate;
	}
	/** @param x This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXISTING_VOLS. */
	public void setExistVolCandidate(ConcatVolumeExistingVolumeCandidate x) {
		this.existVolCandidate = x;
	}

	/** This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXPANSION. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXPANSION." , required = false)
	@XmlElement(required = false)
	private ConcatVolumeDirectExpansionDescriptor expansionDescriptor;

	/** @return This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXPANSION. */
	public ConcatVolumeDirectExpansionDescriptor getExpansionDescriptor() {
		return this.expansionDescriptor;
	}
	/** @param x This field is present only if the ConcatVolumeCandidateType value is equal to CONCAT_VOL_CANDIDATE_TYPE_EXPANSION. */
	public void setExpansionDescriptor(ConcatVolumeDirectExpansionDescriptor x) {
		this.expansionDescriptor = x;
	}
}
