package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information about how a new ConcatVolume is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1135)
public class ConcatVolumeCreationDescriptor implements Serializable {
	public ConcatVolumeCreationDescriptor() {
	}

	/** Candidate info necessary to create new storage volumes or add existing volumes. */
	@io.swagger.annotations.ApiModelProperty(value ="Candidate info necessary to create new storage volumes or add existing volumes." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeCandidate candidate;

	/** @return Candidate info necessary to create new storage volumes or add existing volumes. */
	public ConcatVolumeCandidate getCandidate() {
		return this.candidate;
	}
	/** @param x Candidate info necessary to create new storage volumes or add existing volumes. */
	public void setCandidate(ConcatVolumeCandidate x) {
		this.candidate = x;
	}

	/** Media Scan parameters. */
	@io.swagger.annotations.ApiModelProperty(value ="Media Scan parameters." , required = true)
	@XmlElement(required = true)
	private VolumeMediaScanParams mediaScanParams;

	/** @return Media Scan parameters. */
	public VolumeMediaScanParams getMediaScanParams() {
		return this.mediaScanParams;
	}
	/** @param x Media Scan parameters. */
	public void setMediaScanParams(VolumeMediaScanParams x) {
		this.mediaScanParams = x;
	}
}
