package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains a list of member volumes to use when creating a concatenated volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(929)
public class ConcatVolumeExistingVolumeCandidate implements Serializable {
	public ConcatVolumeExistingVolumeCandidate() {
	}

	/** This enumeration is used to specify the Concatenated Volume Member reference type. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to specify the Concatenated Volume Member reference type." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeMemberRefType refType = ConcatVolumeMemberRefType.__UNDEFINED;

	/** @return This enumeration is used to specify the Concatenated Volume Member reference type. */
	public ConcatVolumeMemberRefType getRefType() {
		return this.refType;
	}
	/** @param x This enumeration is used to specify the Concatenated Volume Member reference type. */
	public void setRefType(ConcatVolumeMemberRefType x) {
		this.refType = x;
	}

	/** A list of member volumes specified using volume references. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_VOLREF. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of member volumes specified using volume references. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_VOLREF." , required = false)
	@XmlElement(required = false)
	private String[] memberVolumeRef;

	/** @return A list of member volumes specified using volume references. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_VOLREF. */
	public String[] getMemberVolumeRef() {
		return this.memberVolumeRef;
	}
	/** @param x A list of member volumes specified using volume references. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_VOLREF. */
	public void setMemberVolumeRef(String[] x) {
		this.memberVolumeRef = x;
	}

	/** A list of member volumes specified using volume labels. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_LABEL. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of member volumes specified using volume labels. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_LABEL." , required = false)
	@XmlElement(required = false)
	private String[] memberLabel;

	/** @return A list of member volumes specified using volume labels. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_LABEL. */
	public String[] getMemberLabel() {
		return this.memberLabel;
	}
	/** @param x A list of member volumes specified using volume labels. This field is present only if the value of refType is equal to CONCAT_VOL_MEMBER_REF_TYPE_LABEL. */
	public void setMemberLabel(String[] x) {
		this.memberLabel = x;
	}
}
