package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify attributes for "trimming" a ConcatVolume (removing member volumes). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(987)
public class ConcatVolumeTrimDescriptor implements Serializable {
	public ConcatVolumeTrimDescriptor() {
	}

	/** The ConcatVolume to trim. */
	@io.swagger.annotations.ApiModelProperty(value ="The ConcatVolume to trim." , required = true)
	@XmlElement(required = true)
	private String concatVol;

	/** @return The ConcatVolume to trim. */
	public String getConcatVol() {
		return this.concatVol;
	}
	/** @param x The ConcatVolume to trim. */
	public void setConcatVol(String x) {
		this.concatVol = x;
	}

	/** The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1." , required = true)
	@XmlElement(required = true)
	private int trimCount;

	/** @return The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1. */
	public int getTrimCount() {
		return this.trimCount;
	}
	/** @param x The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1. */
	public void setTrimCount(int x) {
		this.trimCount = x;
	}

	/** An indication of whether the member volumes removed should be deleted or retained. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of whether the member volumes removed should be deleted or retained." , required = true)
	@XmlElement(required = true)
	private boolean retainRepositoryMembers;

	/** @return An indication of whether the member volumes removed should be deleted or retained. */
	public boolean isRetainRepositoryMembers() {
		return this.retainRepositoryMembers;
	}
	/** @param x An indication of whether the member volumes removed should be deleted or retained. */
	public void setRetainRepositoryMembers(boolean x) {
		this.retainRepositoryMembers = x;
	}
}
