package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Even though deprecated, the hostBoardID and readyToRemove fields must still be set appropriately. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1216)
public class Controller implements Serializable,devmgr.api.model.Identifiable {
	public Controller() {
	}

	/** True if the controller is in active mode; false otherwise. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the controller is in active mode; false otherwise." , required = true)
	@XmlElement(required = true)
	private boolean active;

	/** @return True if the controller is in active mode; false otherwise. */
	public boolean isActive() {
		return this.active;
	}
	/** @param x True if the controller is in active mode; false otherwise. */
	public void setActive(boolean x) {
		this.active = x;
	}

	/** True if the controller is quiesced. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the controller is quiesced." , required = true)
	@XmlElement(required = true)
	private boolean quiesced;

	/** @return True if the controller is quiesced. */
	public boolean isQuiesced() {
		return this.quiesced;
	}
	/** @param x True if the controller is quiesced. */
	public void setQuiesced(boolean x) {
		this.quiesced = x;
	}

	/** An indication of the current status of the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of the current status of the controller." , required = true)
	@XmlElement(required = true)
	private ControllerStatus status = ControllerStatus.__UNDEFINED;

	/** @return An indication of the current status of the controller. */
	public ControllerStatus getStatus() {
		return this.status;
	}
	/** @param x An indication of the current status of the controller. */
	public void setStatus(ControllerStatus x) {
		this.status = x;
	}

	/** The identifier value for this controller. Other objects may use this reference value to refer to the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The identifier value for this controller. Other objects may use this reference value to refer to the controller." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The identifier value for this controller. Other objects may use this reference value to refer to the controller. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The identifier value for this controller. Other objects may use this reference value to refer to the controller. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The physical location of the controller. The parent reference in Location identifies the tray that physically houses the controller, and the position field is the parent-relative/like-component relative slot number of the controller, starting at one. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the controller. The parent reference in Location identifies the tray that physically houses the controller, and the position field is the parent-relative/like-component relative slot number of the controller, starting at one." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the controller. The parent reference in Location identifies the tray that physically houses the controller, and the position field is the parent-relative/like-component relative slot number of the controller, starting at one. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the controller. The parent reference in Location identifies the tray that physically houses the controller, and the position field is the parent-relative/like-component relative slot number of the controller, starting at one. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** The variable-length ASCII text string that identifies the controller manufacturer. */
	@io.swagger.annotations.ApiModelProperty(value ="The variable-length ASCII text string that identifies the controller manufacturer." , required = true)
	@XmlElement(required = true)
	private String manufacturer;

	/** @return The variable-length ASCII text string that identifies the controller manufacturer. */
	public String getManufacturer() {
		return this.manufacturer;
	}
	/** @param x The variable-length ASCII text string that identifies the controller manufacturer. */
	public void setManufacturer(String x) {
		this.manufacturer = x;
	}

	/** The date of manufacture of the controller, represented in seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The date of manufacture of the controller, represented in seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long manufacturerDate;

	/** @return The date of manufacture of the controller, represented in seconds since midnight GMT on January 1, 1970. */
	public long getManufacturerDate() {
		return this.manufacturerDate;
	}
	/** @param x The date of manufacture of the controller, represented in seconds since midnight GMT on January 1, 1970. */
	public void setManufacturerDate(long x) {
		this.manufacturerDate = x;
	}

	/** The version identification string for the application code that is running on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The version identification string for the application code that is running on the controller." , required = true)
	@XmlElement(required = true)
	private String appVersion;

	/** @return The version identification string for the application code that is running on the controller. */
	public String getAppVersion() {
		return this.appVersion;
	}
	/** @param x The version identification string for the application code that is running on the controller. */
	public void setAppVersion(String x) {
		this.appVersion = x;
	}

	/** The version identification string for the boot code that is running on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The version identification string for the boot code that is running on the controller." , required = true)
	@XmlElement(required = true)
	private String bootVersion;

	/** @return The version identification string for the boot code that is running on the controller. */
	public String getBootVersion() {
		return this.bootVersion;
	}
	/** @param x The version identification string for the boot code that is running on the controller. */
	public void setBootVersion(String x) {
		this.bootVersion = x;
	}

	/** The variable-length ASCII text string that identifies the product by name, as assigned by the manufacturer. */
	@io.swagger.annotations.ApiModelProperty(value ="The variable-length ASCII text string that identifies the product by name, as assigned by the manufacturer." , required = true)
	@XmlElement(required = true)
	private String productID;

	/** @return The variable-length ASCII text string that identifies the product by name, as assigned by the manufacturer. */
	public String getProductID() {
		return this.productID;
	}
	/** @param x The variable-length ASCII text string that identifies the product by name, as assigned by the manufacturer. */
	public void setProductID(String x) {
		this.productID = x;
	}

	/** The product revision level. */
	@io.swagger.annotations.ApiModelProperty(value ="The product revision level." , required = true)
	@XmlElement(required = true)
	private String productRevLevel;

	/** @return The product revision level. */
	public String getProductRevLevel() {
		return this.productRevLevel;
	}
	/** @param x The product revision level. */
	public void setProductRevLevel(String x) {
		this.productRevLevel = x;
	}

	/** The variable-length ASCII text string for the serial number of the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The variable-length ASCII text string for the serial number of the controller." , required = true)
	@XmlElement(required = true)
	private String serialNumber;

	/** @return The variable-length ASCII text string for the serial number of the controller. */
	public String getSerialNumber() {
		return this.serialNumber;
	}
	/** @param x The variable-length ASCII text string for the serial number of the controller. */
	public void setSerialNumber(String x) {
		this.serialNumber = x;
	}

	/** The variable-length ASCII text string that represents the board identifier (i.e. board type) of the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The variable-length ASCII text string that represents the board identifier (i.e. board type) of the controller." , required = true)
	@XmlElement(required = true)
	private String boardID;

	/** @return The variable-length ASCII text string that represents the board identifier (i.e. board type) of the controller. */
	public String getBoardID() {
		return this.boardID;
	}
	/** @param x The variable-length ASCII text string that represents the board identifier (i.e. board type) of the controller. */
	public void setBoardID(String x) {
		this.boardID = x;
	}

	/** The memory size, in MB, that will be used by the controller as cache memory. */
	@io.swagger.annotations.ApiModelProperty(value ="The memory size, in MB, that will be used by the controller as cache memory." , required = true)
	@XmlElement(required = true)
	private int cacheMemorySize;

	/** @return The memory size, in MB, that will be used by the controller as cache memory. */
	public int getCacheMemorySize() {
		return this.cacheMemorySize;
	}
	/** @param x The memory size, in MB, that will be used by the controller as cache memory. */
	public void setCacheMemorySize(int x) {
		this.cacheMemorySize = x;
	}

	/** The size of the controller's CPU memory, in MB. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the controller's CPU memory, in MB." , required = true)
	@XmlElement(required = true)
	private int processorMemorySize;

	/** @return The size of the controller's CPU memory, in MB. */
	public int getProcessorMemorySize() {
		return this.processorMemorySize;
	}
	/** @param x The size of the controller's CPU memory, in MB. */
	public void setProcessorMemorySize(int x) {
		this.processorMemorySize = x;
	}

	/** An array containing one entry for each host-side I/O interface that is present on the controller. A "host interface" is the controller's means of accessing the host I/O channel; each host interface has a one-to-one relationship to a host channel. Although this array is indexed starting at zero, host channels in SYMbol are numbered starting at one. Host channels are numbered one through n per controller, without regard to different channel I/O protocols. Note that an interface may be physically present, but disabled for the particular controller model - in such a case, the corresponding channel is skipped over in the channel numbering. */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing one entry for each host-side I/O interface that is present on the controller. A \"host interface\" is the controller's means of accessing the host I/O channel; each host interface has a one-to-one relationship to a host channel. Although this array is indexed starting at zero, host channels in SYMbol are numbered starting at one. Host channels are numbered one through n per controller, without regard to different channel I/O protocols. Note that an interface may be physically present, but disabled for the particular controller model - in such a case, the corresponding channel is skipped over in the channel numbering." , required = true)
	@XmlElement(required = true)
	private IOInterfaceTypeData[] hostInterfaces;

	/** @return An array containing one entry for each host-side I/O interface that is present on the controller. A "host interface" is the controller's means of accessing the host I/O channel; each host interface has a one-to-one relationship to a host channel. Although this array is indexed starting at zero, host channels in SYMbol are numbered starting at one. Host channels are numbered one through n per controller, without regard to different channel I/O protocols. Note that an interface may be physically present, but disabled for the particular controller model - in such a case, the corresponding channel is skipped over in the channel numbering. */
	public IOInterfaceTypeData[] getHostInterfaces() {
		return this.hostInterfaces;
	}
	/** @param x An array containing one entry for each host-side I/O interface that is present on the controller. A "host interface" is the controller's means of accessing the host I/O channel; each host interface has a one-to-one relationship to a host channel. Although this array is indexed starting at zero, host channels in SYMbol are numbered starting at one. Host channels are numbered one through n per controller, without regard to different channel I/O protocols. Note that an interface may be physically present, but disabled for the particular controller model - in such a case, the corresponding channel is skipped over in the channel numbering. */
	public void setHostInterfaces(IOInterfaceTypeData[] x) {
		this.hostInterfaces = x;
	}

	/** An array containing one entry for each drive-side I/O interface that is present on the controller. A "drive interface" is the controller's means of accessing the drive I/O channel. On the drive side, each channel is associated with two interfaces, one on each controller, giving each controller access to the same set of drive channels. Although this array is indexed starting at zero, drive channels can be numbered one through n, per storage array (not per controller). */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing one entry for each drive-side I/O interface that is present on the controller. A \"drive interface\" is the controller's means of accessing the drive I/O channel. On the drive side, each channel is associated with two interfaces, one on each controller, giving each controller access to the same set of drive channels. Although this array is indexed starting at zero, drive channels can be numbered one through n, per storage array (not per controller)." , required = true)
	@XmlElement(required = true)
	private IOInterfaceTypeData[] driveInterfaces;

	/** @return An array containing one entry for each drive-side I/O interface that is present on the controller. A "drive interface" is the controller's means of accessing the drive I/O channel. On the drive side, each channel is associated with two interfaces, one on each controller, giving each controller access to the same set of drive channels. Although this array is indexed starting at zero, drive channels can be numbered one through n, per storage array (not per controller). */
	public IOInterfaceTypeData[] getDriveInterfaces() {
		return this.driveInterfaces;
	}
	/** @param x An array containing one entry for each drive-side I/O interface that is present on the controller. A "drive interface" is the controller's means of accessing the drive I/O channel. On the drive side, each channel is associated with two interfaces, one on each controller, giving each controller access to the same set of drive channels. Although this array is indexed starting at zero, drive channels can be numbered one through n, per storage array (not per controller). */
	public void setDriveInterfaces(IOInterfaceTypeData[] x) {
		this.driveInterfaces = x;
	}

	/** An array containing one entry for each network interface that is present on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing one entry for each network interface that is present on the controller." , required = true)
	@XmlElement(required = true)
	private NetInterfaceTypeData[] netInterfaces;

	/** @return An array containing one entry for each network interface that is present on the controller. */
	public NetInterfaceTypeData[] getNetInterfaces() {
		return this.netInterfaces;
	}
	/** @param x An array containing one entry for each network interface that is present on the controller. */
	public void setNetInterfaces(NetInterfaceTypeData[] x) {
		this.netInterfaces = x;
	}

	/** This array of structures is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="This array of structures is deprecated." , required = true)
	@XmlElement(required = true)
	private InventoryItem[] inventory;

	/** @return This array of structures is deprecated. */
	public InventoryItem[] getInventory() {
		return this.inventory;
	}
	/** @param x This array of structures is deprecated. */
	public void setInventory(InventoryItem[] x) {
		this.inventory = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved for future use. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved for future use. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** The board ID of the controller's host card. This field is deprecated. The hostBoardId field in the HostBoard structure should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="The board ID of the controller's host card. This field is deprecated. The hostBoardId field in the HostBoard structure should be used instead." , required = true)
	@XmlElement(required = true)
	private String hostBoardID;

	/** @return The board ID of the controller's host card. This field is deprecated. The hostBoardId field in the HostBoard structure should be used instead. */
	public String getHostBoardID() {
		return this.hostBoardID;
	}
	/** @param x The board ID of the controller's host card. This field is deprecated. The hostBoardId field in the HostBoard structure should be used instead. */
	public void setHostBoardID(String x) {
		this.hostBoardID = x;
	}

	/** The physical cache memory size in MB */
	@io.swagger.annotations.ApiModelProperty(value ="The physical cache memory size in MB" , required = true)
	@XmlElement(required = true)
	private int physicalCacheMemorySize;

	/** @return The physical cache memory size in MB */
	public int getPhysicalCacheMemorySize() {
		return this.physicalCacheMemorySize;
	}
	/** @param x The physical cache memory size in MB */
	public void setPhysicalCacheMemorySize(int x) {
		this.physicalCacheMemorySize = x;
	}

	/** This is set to True if the component is ready to remove (and the Ready To Remove LED is on). This field is deprecated. The rtrAttributes field should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="This is set to True if the component is ready to remove (and the Ready To Remove LED is on). This field is deprecated. The rtrAttributes field should be used instead." , required = true)
	@XmlElement(required = true)
	private boolean readyToRemove;

	/** @return This is set to True if the component is ready to remove (and the Ready To Remove LED is on). This field is deprecated. The rtrAttributes field should be used instead. */
	public boolean isReadyToRemove() {
		return this.readyToRemove;
	}
	/** @param x This is set to True if the component is ready to remove (and the Ready To Remove LED is on). This field is deprecated. The rtrAttributes field should be used instead. */
	public void setReadyToRemove(boolean x) {
		this.readyToRemove = x;
	}

	/** The board sub-model ID of the controller card */
	@io.swagger.annotations.ApiModelProperty(value ="The board sub-model ID of the controller card" , required = true)
	@XmlElement(required = true)
	private String boardSubmodelID;

	/** @return The board sub-model ID of the controller card */
	public String getBoardSubmodelID() {
		return this.boardSubmodelID;
	}
	/** @param x The board sub-model ID of the controller card */
	public void setBoardSubmodelID(String x) {
		this.boardSubmodelID = x;
	}

	/** Set to true if the sub-model feature is supported */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the sub-model feature is supported" , required = true)
	@XmlElement(required = true)
	private boolean submodelSupported;

	/** @return Set to true if the sub-model feature is supported */
	public boolean isSubmodelSupported() {
		return this.submodelSupported;
	}
	/** @param x Set to true if the sub-model feature is supported */
	public void setSubmodelSupported(boolean x) {
		this.submodelSupported = x;
	}

	/** The OEM-specified part number of the controller canister */
	@io.swagger.annotations.ApiModelProperty(value ="The OEM-specified part number of the controller canister" , required = true)
	@XmlElement(required = true)
	private String oemPartNumber;

	/** @return The OEM-specified part number of the controller canister */
	public String getOemPartNumber() {
		return this.oemPartNumber;
	}
	/** @param x The OEM-specified part number of the controller canister */
	public void setOemPartNumber(String x) {
		this.oemPartNumber = x;
	}

	/** The part number of the controller board itself. */
	@io.swagger.annotations.ApiModelProperty(value ="The part number of the controller board itself." , required = true)
	@XmlElement(required = true)
	private String partNumber;

	/** @return The part number of the controller board itself. */
	public String getPartNumber() {
		return this.partNumber;
	}
	/** @param x The part number of the controller board itself. */
	public void setPartNumber(String x) {
		this.partNumber = x;
	}

	/** The CRU type of the controller plus its ready-to-remove attributes, which are based on the CRU type. */
	@io.swagger.annotations.ApiModelProperty(value ="The CRU type of the controller plus its ready-to-remove attributes, which are based on the CRU type." , required = true)
	@XmlElement(required = true)
	private RTRAttributes rtrAttributes;

	/** @return The CRU type of the controller plus its ready-to-remove attributes, which are based on the CRU type. */
	public RTRAttributes getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x The CRU type of the controller plus its ready-to-remove attributes, which are based on the CRU type. */
	public void setRtrAttributes(RTRAttributes x) {
		this.rtrAttributes = x;
	}

	/** The timestamp value for the time at which the controller last booted. Note that this value may be different for the other controller in the storage array. This value is defined as the number of seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The timestamp value for the time at which the controller last booted. Note that this value may be different for the other controller in the storage array. This value is defined as the number of seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long bootTime;

	/** @return The timestamp value for the time at which the controller last booted. Note that this value may be different for the other controller in the storage array. This value is defined as the number of seconds since midnight GMT on January 1, 1970. */
	public long getBootTime() {
		return this.bootTime;
	}
	/** @param x The timestamp value for the time at which the controller last booted. Note that this value may be different for the other controller in the storage array. This value is defined as the number of seconds since midnight GMT on January 1, 1970. */
	public void setBootTime(long x) {
		this.bootTime = x;
	}

	/** The model name associated with the controller. A model name is an identifier that is associated with each unique combination of base controller board and host interface card(s). */
	@io.swagger.annotations.ApiModelProperty(value ="The model name associated with the controller. A model name is an identifier that is associated with each unique combination of base controller board and host interface card(s)." , required = true)
	@XmlElement(required = true)
	private String modelName;

	/** @return The model name associated with the controller. A model name is an identifier that is associated with each unique combination of base controller board and host interface card(s). */
	public String getModelName() {
		return this.modelName;
	}
	/** @param x The model name associated with the controller. A model name is an identifier that is associated with each unique combination of base controller board and host interface card(s). */
	public void setModelName(String x) {
		this.modelName = x;
	}

	/** A collection of network-related settings that apply to this controller. */
	@io.swagger.annotations.ApiModelProperty(value ="A collection of network-related settings that apply to this controller." , required = true)
	@XmlElement(required = true)
	private ControllerNetworkSettings networkSettings;

	/** @return A collection of network-related settings that apply to this controller. */
	public ControllerNetworkSettings getNetworkSettings() {
		return this.networkSettings;
	}
	/** @param x A collection of network-related settings that apply to this controller. */
	public void setNetworkSettings(ControllerNetworkSettings x) {
		this.networkSettings = x;
	}

	/** The repair policy for the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the controller." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the controller. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the controller. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}

	/** The total flash cache memory size (in GB) currently in use on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The total flash cache memory size (in GB) currently in use on the controller." , required = true)
	@XmlElement(required = true)
	private int flashCacheMemorySize;

	/** @return The total flash cache memory size (in GB) currently in use on the controller. */
	public int getFlashCacheMemorySize() {
		return this.flashCacheMemorySize;
	}
	/** @param x The total flash cache memory size (in GB) currently in use on the controller. */
	public void setFlashCacheMemorySize(int x) {
		this.flashCacheMemorySize = x;
	}

	/** This structure contains information regarding the state of an IOC data dump -- if it needs to be retrieved, and the tag and timestamp of the dump. */
	@io.swagger.annotations.ApiModelProperty(value ="This structure contains information regarding the state of an IOC data dump -- if it needs to be retrieved, and the tag and timestamp of the dump." , required = true)
	@XmlElement(required = true)
	private CtrlIOCDumpData ctrlIocDumpData;

	/** @return This structure contains information regarding the state of an IOC data dump -- if it needs to be retrieved, and the tag and timestamp of the dump. */
	public CtrlIOCDumpData getCtrlIocDumpData() {
		return this.ctrlIocDumpData;
	}
	/** @param x This structure contains information regarding the state of an IOC data dump -- if it needs to be retrieved, and the tag and timestamp of the dump. */
	public void setCtrlIocDumpData(CtrlIOCDumpData x) {
		this.ctrlIocDumpData = x;
	}

	/** Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray." , required = true)
	@XmlElement(required = true)
	private boolean locateInProgress;

	/** @return Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	public boolean isLocateInProgress() {
		return this.locateInProgress;
	}
	/** @param x Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	public void setLocateInProgress(boolean x) {
		this.locateInProgress = x;
	}

	/** The device contains 7-segment indicators used to display the Tray Identity. */
	@io.swagger.annotations.ApiModelProperty(value ="The device contains 7-segment indicators used to display the Tray Identity." , required = true)
	@XmlElement(required = true)
	private boolean hasTrayIdentityIndicator;

	/** @return The device contains 7-segment indicators used to display the Tray Identity. */
	public boolean isHasTrayIdentityIndicator() {
		return this.hasTrayIdentityIndicator;
	}
	/** @param x The device contains 7-segment indicators used to display the Tray Identity. */
	public void setHasTrayIdentityIndicator(boolean x) {
		this.hasTrayIdentityIndicator = x;
	}

	/** Indicates the error mode in which the controller is operating. A value of 0 indicates the controller is not operating in an error mode. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates the error mode in which the controller is operating. A value of 0 indicates the controller is not operating in an error mode." , required = true)
	@XmlElement(required = true)
	private ControllerErrorModeType controllerErrorMode = ControllerErrorModeType.__UNDEFINED;

	/** @return Indicates the error mode in which the controller is operating. A value of 0 indicates the controller is not operating in an error mode. */
	public ControllerErrorModeType getControllerErrorMode() {
		return this.controllerErrorMode;
	}
	/** @param x Indicates the error mode in which the controller is operating. A value of 0 indicates the controller is not operating in an error mode. */
	public void setControllerErrorMode(ControllerErrorModeType x) {
		this.controllerErrorMode = x;
	}

	/** Version descriptors for loaded code modules */
	@io.swagger.annotations.ApiModelProperty(value ="Version descriptors for loaded code modules" , required = true)
	@XmlElement(required = true)
	private VersionDescriptor[] codeVersions;

	/** @return Version descriptors for loaded code modules */
	public VersionDescriptor[] getCodeVersions() {
		return this.codeVersions;
	}
	/** @param x Version descriptors for loaded code modules */
	public void setCodeVersions(VersionDescriptor[] x) {
		this.codeVersions = x;
	}
	@Override
	public String getId(){
		return controllerRef;
	}
}
