package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is part of the interface to the setControllerProperties procedure. It holds the values of certain controller properties that the caller of the procedure wishes to change. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1028)
public class ControllerChangeableProperties implements Serializable {
	public ControllerChangeableProperties() {
	}

	/** The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 static default router address for the controller (sometimes referred to as the \"gateway address\")." , required = true)
	@XmlElement(required = true)
	private String[] ipv4DefaultRouterAddress;

	/** @return The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	public String[] getIpv4DefaultRouterAddress() {
		return this.ipv4DefaultRouterAddress;
	}
	/** @param x The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	public void setIpv4DefaultRouterAddress(String[] x) {
		this.ipv4DefaultRouterAddress = x;
	}

	/** The IPV6 static default router address and associated data for the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV6 static default router address and associated data for the controller." , required = true)
	@XmlElement(required = true)
	private IpV6AddressData[] ipv6DefaultRouterAddress;

	/** @return The IPV6 static default router address and associated data for the controller. */
	public IpV6AddressData[] getIpv6DefaultRouterAddress() {
		return this.ipv6DefaultRouterAddress;
	}
	/** @param x The IPV6 static default router address and associated data for the controller. */
	public void setIpv6DefaultRouterAddress(IpV6AddressData[] x) {
		this.ipv6DefaultRouterAddress = x;
	}

	/** If set to true, the controller is enabled for establishment of a remote access session. Depending on the controller platform, the method for remote access could be rlogin or telnet */
	@io.swagger.annotations.ApiModelProperty(value ="If set to true, the controller is enabled for establishment of a remote access session. Depending on the controller platform, the method for remote access could be rlogin or telnet" , required = true)
	@XmlElement(required = true)
	private boolean[] remoteAccessEnabled;

	/** @return If set to true, the controller is enabled for establishment of a remote access session. Depending on the controller platform, the method for remote access could be rlogin or telnet */
	public boolean[] getRemoteAccessEnabled() {
		return this.remoteAccessEnabled;
	}
	/** @param x If set to true, the controller is enabled for establishment of a remote access session. Depending on the controller platform, the method for remote access could be rlogin or telnet */
	public void setRemoteAccessEnabled(boolean[] x) {
		this.remoteAccessEnabled = x;
	}

	/** NTP acquisition configuration information. */
	@io.swagger.annotations.ApiModelProperty(value ="NTP acquisition configuration information." , required = true)
	@XmlElement(required = true)
	private NtpAcquisitionDescriptor[] ntpAcquisitionProperties;

	/** @return NTP acquisition configuration information. */
	public NtpAcquisitionDescriptor[] getNtpAcquisitionProperties() {
		return this.ntpAcquisitionProperties;
	}
	/** @param x NTP acquisition configuration information. */
	public void setNtpAcquisitionProperties(NtpAcquisitionDescriptor[] x) {
		this.ntpAcquisitionProperties = x;
	}

	/** DNS acquisition configuration information. */
	@io.swagger.annotations.ApiModelProperty(value ="DNS acquisition configuration information." , required = true)
	@XmlElement(required = true)
	private DnsAcquisitionDescriptor[] dnsAcquisitionProperties;

	/** @return DNS acquisition configuration information. */
	public DnsAcquisitionDescriptor[] getDnsAcquisitionProperties() {
		return this.dnsAcquisitionProperties;
	}
	/** @param x DNS acquisition configuration information. */
	public void setDnsAcquisitionProperties(DnsAcquisitionDescriptor[] x) {
		this.dnsAcquisitionProperties = x;
	}
}
