package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** DNS (Domain Name Service) Parameters */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(823)
public class ControllerDNSProperties implements Serializable {
	public ControllerDNSProperties() {
	}

	/** DNS server acquisition properties */
	@io.swagger.annotations.ApiModelProperty(value ="DNS server acquisition properties" , required = true)
	@XmlElement(required = true)
	private DnsAcquisitionDescriptor acquisitionProperties;

	/** @return DNS server acquisition properties */
	public DnsAcquisitionDescriptor getAcquisitionProperties() {
		return this.acquisitionProperties;
	}
	/** @param x DNS server acquisition properties */
	public void setAcquisitionProperties(DnsAcquisitionDescriptor x) {
		this.acquisitionProperties = x;
	}

	/** DNS servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more DNS servers to use. The presence of these servers does not imply their use. These DNS servers will only be used if the acquisition type is set to DHCP. */
	@io.swagger.annotations.ApiModelProperty(value ="DNS servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more DNS servers to use. The presence of these servers does not imply their use. These DNS servers will only be used if the acquisition type is set to DHCP." , required = true)
	@XmlElement(required = true)
	private IpVxAddress[] dhcpAcquiredDnsServers;

	/** @return DNS servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more DNS servers to use. The presence of these servers does not imply their use. These DNS servers will only be used if the acquisition type is set to DHCP. */
	public IpVxAddress[] getDhcpAcquiredDnsServers() {
		return this.dhcpAcquiredDnsServers;
	}
	/** @param x DNS servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more DNS servers to use. The presence of these servers does not imply their use. These DNS servers will only be used if the acquisition type is set to DHCP. */
	public void setDhcpAcquiredDnsServers(IpVxAddress[] x) {
		this.dhcpAcquiredDnsServers = x;
	}
}
