package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** NTP (Network Time Protocol) Parameters */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1026)
public class ControllerNTPProperties implements Serializable {
	public ControllerNTPProperties() {
	}

	/** NTP server acquisition properties */
	@io.swagger.annotations.ApiModelProperty(value ="NTP server acquisition properties" , required = true)
	@XmlElement(required = true)
	private NtpAcquisitionDescriptor acquisitionProperties;

	/** @return NTP server acquisition properties */
	public NtpAcquisitionDescriptor getAcquisitionProperties() {
		return this.acquisitionProperties;
	}
	/** @param x NTP server acquisition properties */
	public void setAcquisitionProperties(NtpAcquisitionDescriptor x) {
		this.acquisitionProperties = x;
	}

	/** NTP servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more NTP servers. The presence of these servers does not imply their use. These NTP servers will only be used if the NTP acquisition type is set to DHCP. */
	@io.swagger.annotations.ApiModelProperty(value ="NTP servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more NTP servers. The presence of these servers does not imply their use. These NTP servers will only be used if the NTP acquisition type is set to DHCP." , required = true)
	@XmlElement(required = true)
	private IpVxAddress[] dhcpAcquiredNtpServers;

	/** @return NTP servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more NTP servers. The presence of these servers does not imply their use. These NTP servers will only be used if the NTP acquisition type is set to DHCP. */
	public IpVxAddress[] getDhcpAcquiredNtpServers() {
		return this.dhcpAcquiredNtpServers;
	}
	/** @param x NTP servers provided by the DHCP responses. Will be non-empty only if at least one of the Controller's network ports is set to acquire its address via DHCP and the DHCP response included one or more NTP servers. The presence of these servers does not imply their use. These NTP servers will only be used if the NTP acquisition type is set to DHCP. */
	public void setDhcpAcquiredNtpServers(IpVxAddress[] x) {
		this.dhcpAcquiredNtpServers = x;
	}
}
