package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains network settings that have controller-level scope. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1120)
public class ControllerNetworkSettings implements Serializable {
	public ControllerNetworkSettings() {
	}

	/** The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 static default router address for the controller (sometimes referred to as the \"gateway address\")." , required = true)
	@XmlElement(required = true)
	private String ipv4DefaultRouterAddress;

	/** @return The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	public String getIpv4DefaultRouterAddress() {
		return this.ipv4DefaultRouterAddress;
	}
	/** @param x The IPV4 static default router address for the controller (sometimes referred to as the "gateway address"). */
	public void setIpv4DefaultRouterAddress(String x) {
		this.ipv4DefaultRouterAddress = x;
	}

	/** The IPV6 static default router address and associated data for the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV6 static default router address and associated data for the controller." , required = true)
	@XmlElement(required = true)
	private IpV6AddressData ipv6DefaultRouterAddress;

	/** @return The IPV6 static default router address and associated data for the controller. */
	public IpV6AddressData getIpv6DefaultRouterAddress() {
		return this.ipv6DefaultRouterAddress;
	}
	/** @param x The IPV6 static default router address and associated data for the controller. */
	public void setIpv6DefaultRouterAddress(IpV6AddressData x) {
		this.ipv6DefaultRouterAddress = x;
	}

	/** The set of IPV6 candidate default router addresses for the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of IPV6 candidate default router addresses for the controller." , required = true)
	@XmlElement(required = true)
	private IpV6AddressData[] ipv6CandidateDefaultRouterAddresses;

	/** @return The set of IPV6 candidate default router addresses for the controller. */
	public IpV6AddressData[] getIpv6CandidateDefaultRouterAddresses() {
		return this.ipv6CandidateDefaultRouterAddresses;
	}
	/** @param x The set of IPV6 candidate default router addresses for the controller. */
	public void setIpv6CandidateDefaultRouterAddresses(IpV6AddressData[] x) {
		this.ipv6CandidateDefaultRouterAddresses = x;
	}

	/** True if enabled for remote access */
	@io.swagger.annotations.ApiModelProperty(value ="True if enabled for remote access" , required = true)
	@XmlElement(required = true)
	private boolean remoteAccessEnabled;

	/** @return True if enabled for remote access */
	public boolean isRemoteAccessEnabled() {
		return this.remoteAccessEnabled;
	}
	/** @param x True if enabled for remote access */
	public void setRemoteAccessEnabled(boolean x) {
		this.remoteAccessEnabled = x;
	}

	/** DNS configuration information. */
	@io.swagger.annotations.ApiModelProperty(value ="DNS configuration information." , required = true)
	@XmlElement(required = true)
	private ControllerDNSProperties dnsProperties;

	/** @return DNS configuration information. */
	public ControllerDNSProperties getDnsProperties() {
		return this.dnsProperties;
	}
	/** @param x DNS configuration information. */
	public void setDnsProperties(ControllerDNSProperties x) {
		this.dnsProperties = x;
	}

	/** NTP configuration information. */
	@io.swagger.annotations.ApiModelProperty(value ="NTP configuration information." , required = true)
	@XmlElement(required = true)
	private ControllerNTPProperties ntpProperties;

	/** @return NTP configuration information. */
	public ControllerNTPProperties getNtpProperties() {
		return this.ntpProperties;
	}
	/** @param x NTP configuration information. */
	public void setNtpProperties(ControllerNTPProperties x) {
		this.ntpProperties = x;
	}
}
