package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Details for an NTP error. This error is preventing a controller from synchronizing its software clock to a time spec provided by an NTP server. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(516)
public class ControllerNtpErrorDetails implements Serializable {
	public ControllerNtpErrorDetails() {
	}

	/** The controller attempting to obtain an NTP time spec */
	@io.swagger.annotations.ApiModelProperty(value ="The controller attempting to obtain an NTP time spec" , required = true)
	@XmlElement(required = true)
	private String ntpErrorController;

	/** @return The controller attempting to obtain an NTP time spec */
	public String getNtpErrorController() {
		return this.ntpErrorController;
	}
	/** @param x The controller attempting to obtain an NTP time spec */
	public void setNtpErrorController(String x) {
		this.ntpErrorController = x;
	}

	/** The domain name of the NTP server */
	@io.swagger.annotations.ApiModelProperty(value ="The domain name of the NTP server" , required = true)
	@XmlElement(required = true)
	private String domainName;

	/** @return The domain name of the NTP server */
	public String getDomainName() {
		return this.domainName;
	}
	/** @param x The domain name of the NTP server */
	public void setDomainName(String x) {
		this.domainName = x;
	}
}
