package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the argument to the setControllerProperties structure. It indicates which controller the operation applies to and which properties and values are to be set. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1127)
public class ControllerPropertiesUpdateDescriptor implements Serializable {
	public ControllerPropertiesUpdateDescriptor() {
	}

	/** A reference to the controller to update. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller to update." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return A reference to the controller to update. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference to the controller to update. */
	public void setController(String x) {
		this.controller = x;
	}

	/** The new controller property settings. */
	@io.swagger.annotations.ApiModelProperty(value ="The new controller property settings." , required = true)
	@XmlElement(required = true)
	private ControllerChangeableProperties settings;

	/** @return The new controller property settings. */
	public ControllerChangeableProperties getSettings() {
		return this.settings;
	}
	/** @param x The new controller property settings. */
	public void setSettings(ControllerChangeableProperties x) {
		this.settings = x;
	}
}
