package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the possible controller status values that can be returned in a Controller object. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(59)
public enum ControllerStatus implements Serializable {
		/** The controller status is unknown. */
		unknown(0),
		/** The controller status is currently optimal, or fully functional. */
		optimal(1),
		/** The controller is in the failed state. */
		failed(2),
		/** The controller has been removed from the system. */
		removed(3),
		/** The controller detected a RPA memory parity error. */
		rpaParErr(4),
		/** The controller is in service mode. */
		serviceMode(5),
		/** The controller is suspended. */
		suspended(6),
		/** The controller has experienced certain errors or component failures, such that it is still functional, but in need of service or replacement. */
		degraded(7),
		__UNDEFINED(464378545);

		public final int value;

		private ControllerStatus(int v) {
			this.value = v;
		}
}
