package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type identifies the different types of counter group statistics that are provided by the controller firmware. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(238)
public enum CounterGroupType implements Serializable {
		/** This enumeration value is associated with a group of drive-related counters. */
		drive(0),
		/** This enumeration value is associated with a group of RAID-implementation-related counters. */
		implementation(1),
		/** This enumeration value is associated with a group of channel-I/O-related counters. */
		io(2),
		/** This enumeration value is associated with a group of volume-related counters. */
		volume(3),
		/** This enumeration value is associated with a group of controller related counters. */
		controller(4),
		/** This enumeration value is associated with a group of interface related stats counters. */
		iointerface(5),
		__UNDEFINED(464378545);

		public final int value;

		private CounterGroupType(int v) {
			this.value = v;
		}
}
