package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the CPU utilization stats. For multi-core CPU's stats from each core is iterated and reported through variable length array. Uses the parent controller ref in outer structure to identify, which controller these statistics apply. Uses the start and end time stamps in outer structure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(336)
public class CpuUtilizationStats implements Serializable {
	public CpuUtilizationStats() {
	}

	/** Max utilization stats value from CPU. */
	@io.swagger.annotations.ApiModelProperty(value ="Max utilization stats value from CPU." , required = true)
	@XmlElement(required = true)
	private int maxCpuUtilization;

	/** @return Max utilization stats value from CPU. */
	public int getMaxCpuUtilization() {
		return this.maxCpuUtilization;
	}
	/** @param x Max utilization stats value from CPU. */
	public void setMaxCpuUtilization(int x) {
		this.maxCpuUtilization = x;
	}

	/** Sum of utilization stats values from CPU. */
	@io.swagger.annotations.ApiModelProperty(value ="Sum of utilization stats values from CPU." , required = true)
	@XmlElement(required = true)
	private int sumCpuUtilization;

	/** @return Sum of utilization stats values from CPU. */
	public int getSumCpuUtilization() {
		return this.sumCpuUtilization;
	}
	/** @param x Sum of utilization stats values from CPU. */
	public void setSumCpuUtilization(int x) {
		this.sumCpuUtilization = x;
	}

	/** Sum of squares of utilization stats values from CPU. */
	@io.swagger.annotations.ApiModelProperty(value ="Sum of squares of utilization stats values from CPU." , required = true)
	@XmlElement(required = true)
	private int ssqCpuUtilization;

	/** @return Sum of squares of utilization stats values from CPU. */
	public int getSsqCpuUtilization() {
		return this.ssqCpuUtilization;
	}
	/** @param x Sum of squares of utilization stats values from CPU. */
	public void setSsqCpuUtilization(int x) {
		this.ssqCpuUtilization = x;
	}
}
