package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is a set of counter groups collected by the storage array, one group per controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1072)
public class CumulativeStatisticsBundle implements Serializable {
	public CumulativeStatisticsBundle() {
	}

	/** The time that the statistics bundle was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the statistics bundle was retrieved. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long observationTime;

	/** @return The time that the statistics bundle was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	public long getObservationTime() {
		return this.observationTime;
	}
	/** @param x The time that the statistics bundle was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	public void setObservationTime(long x) {
		this.observationTime = x;
	}

	/** A reference to the object to which the statistics bundle applies. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the object to which the statistics bundle applies." , required = true)
	@XmlElement(required = true)
	private ObjectReference objectRef;

	/** @return A reference to the object to which the statistics bundle applies. */
	public ObjectReference getObjectRef() {
		return this.objectRef;
	}
	/** @param x A reference to the object to which the statistics bundle applies. */
	public void setObjectRef(ObjectReference x) {
		this.objectRef = x;
	}

	/** An array of counter groups, one group per controller. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of counter groups, one group per controller." , required = true)
	@XmlElement(required = true)
	private CounterGroup[] counterGroup;

	/** @return An array of counter groups, one group per controller. */
	public CounterGroup[] getCounterGroup() {
		return this.counterGroup;
	}
	/** @param x An array of counter groups, one group per controller. */
	public void setCounterGroup(CounterGroup[] x) {
		this.counterGroup = x;
	}

	/** The end time of the accrued samples within this stats bundle. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The end time of the accrued samples within this stats bundle. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long bundleStartTime;

	/** @return The end time of the accrued samples within this stats bundle. Time is the number of seconds since midnight, January 1, 1970. */
	public long getBundleStartTime() {
		return this.bundleStartTime;
	}
	/** @param x The end time of the accrued samples within this stats bundle. Time is the number of seconds since midnight, January 1, 1970. */
	public void setBundleStartTime(long x) {
		this.bundleStartTime = x;
	}

	/** The end time of the accrued samples within this stats bundle. Time is the number of seconds since bundleStartTime. */
	@io.swagger.annotations.ApiModelProperty(value ="The end time of the accrued samples within this stats bundle. Time is the number of seconds since bundleStartTime." , required = true)
	@XmlElement(required = true)
	private long bundleEndTime;

	/** @return The end time of the accrued samples within this stats bundle. Time is the number of seconds since bundleStartTime. */
	public long getBundleEndTime() {
		return this.bundleEndTime;
	}
	/** @param x The end time of the accrued samples within this stats bundle. Time is the number of seconds since bundleStartTime. */
	public void setBundleEndTime(long x) {
		this.bundleEndTime = x;
	}

	/** When True, indicates more stats data available beyond the specified observation time in controller memory. */
	@io.swagger.annotations.ApiModelProperty(value ="When True, indicates more stats data available beyond the specified observation time in controller memory." , required = true)
	@XmlElement(required = true)
	private boolean areMoreStatsAvailable;

	/** @return When True, indicates more stats data available beyond the specified observation time in controller memory. */
	public boolean isAreMoreStatsAvailable() {
		return this.areMoreStatsAvailable;
	}
	/** @param x When True, indicates more stats data available beyond the specified observation time in controller memory. */
	public void setAreMoreStatsAvailable(boolean x) {
		this.areMoreStatsAvailable = x;
	}
}
