package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains individual arguments that define the attributes for the low and high resolution sampling mode. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(555)
public class CumulativeStatisticsDefaultAttributes implements Serializable {
	public CumulativeStatisticsDefaultAttributes() {
	}

	/** If true, the CFW supports the low and high resolution sampling. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, the CFW supports the low and high resolution sampling." , required = true)
	@XmlElement(required = true)
	private boolean lowHighSamplingSupported;

	/** @return If true, the CFW supports the low and high resolution sampling. */
	public boolean isLowHighSamplingSupported() {
		return this.lowHighSamplingSupported;
	}
	/** @param x If true, the CFW supports the low and high resolution sampling. */
	public void setLowHighSamplingSupported(boolean x) {
		this.lowHighSamplingSupported = x;
	}

	/** Duration, in seconds, for low resolution statistics samples to be saved. */
	@io.swagger.annotations.ApiModelProperty(value ="Duration, in seconds, for low resolution statistics samples to be saved." , required = true)
	@XmlElement(required = true)
	private int lowResolutionPeriod;

	/** @return Duration, in seconds, for low resolution statistics samples to be saved. */
	public int getLowResolutionPeriod() {
		return this.lowResolutionPeriod;
	}
	/** @param x Duration, in seconds, for low resolution statistics samples to be saved. */
	public void setLowResolutionPeriod(int x) {
		this.lowResolutionPeriod = x;
	}

	/** Duration, in seconds, for high resolution statistics samples to be saved. */
	@io.swagger.annotations.ApiModelProperty(value ="Duration, in seconds, for high resolution statistics samples to be saved." , required = true)
	@XmlElement(required = true)
	private int highResolutionPeriod;

	/** @return Duration, in seconds, for high resolution statistics samples to be saved. */
	public int getHighResolutionPeriod() {
		return this.highResolutionPeriod;
	}
	/** @param x Duration, in seconds, for high resolution statistics samples to be saved. */
	public void setHighResolutionPeriod(int x) {
		this.highResolutionPeriod = x;
	}
}
