package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the input to the getCumulativeStatisticsBundles procedure call. It contains the individual arguments that define the list of statistics bundles to return. All bundles must be of the same counter group type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(697)
public class CumulativeStatisticsListDescriptor implements Serializable {
	public CumulativeStatisticsListDescriptor() {
	}

	/** The type of counter group to be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of counter group to be returned." , required = true)
	@XmlElement(required = true)
	private CounterGroupType groupType = CounterGroupType.__UNDEFINED;

	/** @return The type of counter group to be returned. */
	public CounterGroupType getGroupType() {
		return this.groupType;
	}
	/** @param x The type of counter group to be returned. */
	public void setGroupType(CounterGroupType x) {
		this.groupType = x;
	}

	/** A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned." , required = true)
	@XmlElement(required = true)
	private ObjectReference[] objectRef;

	/** @return A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned. */
	public ObjectReference[] getObjectRef() {
		return this.objectRef;
	}
	/** @param x A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned. */
	public void setObjectRef(ObjectReference[] x) {
		this.objectRef = x;
	}

	/** Location of counter group data to be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="Location of counter group data to be returned." , required = true)
	@XmlElement(required = true)
	private CounterGroupDataLocation dataLocation = CounterGroupDataLocation.__UNDEFINED;

	/** @return Location of counter group data to be returned. */
	public CounterGroupDataLocation getDataLocation() {
		return this.dataLocation;
	}
	/** @param x Location of counter group data to be returned. */
	public void setDataLocation(CounterGroupDataLocation x) {
		this.dataLocation = x;
	}

	/** Identifies if low or high resolution. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies if low or high resolution." , required = true)
	@XmlElement(required = true)
	private StatisticsResolutionType statisticsResolution = StatisticsResolutionType.__UNDEFINED;

	/** @return Identifies if low or high resolution. */
	public StatisticsResolutionType getStatisticsResolution() {
		return this.statisticsResolution;
	}
	/** @param x Identifies if low or high resolution. */
	public void setStatisticsResolution(StatisticsResolutionType x) {
		this.statisticsResolution = x;
	}
}
