package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the controller firmware location that resulted in a DPL core dump. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(587)
public class DPLCoreDumpFWLocation implements Serializable {
	public DPLCoreDumpFWLocation() {
	}

	/** The file name within controller firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="The file name within controller firmware." , required = true)
	@XmlElement(required = true)
	private String filename;

	/** @return The file name within controller firmware. */
	public String getFilename() {
		return this.filename;
	}
	/** @param x The file name within controller firmware. */
	public void setFilename(String x) {
		this.filename = x;
	}

	/** The line number within the file. */
	@io.swagger.annotations.ApiModelProperty(value ="The line number within the file." , required = true)
	@XmlElement(required = true)
	private int lineNumber;

	/** @return The line number within the file. */
	public int getLineNumber() {
		return this.lineNumber;
	}
	/** @param x The line number within the file. */
	public void setLineNumber(int x) {
		this.lineNumber = x;
	}
}
