package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a DPL core dump. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(951)
public class DPLCoreDumpInfo implements Serializable {
	public DPLCoreDumpInfo() {
	}

	/** The DPL core dump tag. Each core dump has a unique tag value. */
	@io.swagger.annotations.ApiModelProperty(value ="The DPL core dump tag. Each core dump has a unique tag value." , required = true)
	@XmlElement(required = true)
	private int dplCoreDumpTag;

	/** @return The DPL core dump tag. Each core dump has a unique tag value. */
	public int getDplCoreDumpTag() {
		return this.dplCoreDumpTag;
	}
	/** @param x The DPL core dump tag. Each core dump has a unique tag value. */
	public void setDplCoreDumpTag(int x) {
		this.dplCoreDumpTag = x;
	}

	/** The time that the DPL core dump was captured measured in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the DPL core dump was captured measured in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long captureTime;

	/** @return The time that the DPL core dump was captured measured in seconds since January 1, 1970. */
	public long getCaptureTime() {
		return this.captureTime;
	}
	/** @param x The time that the DPL core dump was captured measured in seconds since January 1, 1970. */
	public void setCaptureTime(long x) {
		this.captureTime = x;
	}

	/** The size of the full core dump, in megabytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the full core dump, in megabytes." , required = true)
	@XmlElement(required = true)
	private int fullCaptureSize;

	/** @return The size of the full core dump, in megabytes. */
	public int getFullCaptureSize() {
		return this.fullCaptureSize;
	}
	/** @param x The size of the full core dump, in megabytes. */
	public void setFullCaptureSize(int x) {
		this.fullCaptureSize = x;
	}

	/** The size of the alternate core dump, in megabytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the alternate core dump, in megabytes." , required = true)
	@XmlElement(required = true)
	private int AltCaptureSize;

	/** @return The size of the alternate core dump, in megabytes. */
	public int getAltCaptureSize() {
		return this.AltCaptureSize;
	}
	/** @param x The size of the alternate core dump, in megabytes. */
	public void setAltCaptureSize(int x) {
		this.AltCaptureSize = x;
	}

	/** The controller firmware version at the time the core dump was captured. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller firmware version at the time the core dump was captured." , required = true)
	@XmlElement(required = true)
	private String fwVersion;

	/** @return The controller firmware version at the time the core dump was captured. */
	public String getFwVersion() {
		return this.fwVersion;
	}
	/** @param x The controller firmware version at the time the core dump was captured. */
	public void setFwVersion(String x) {
		this.fwVersion = x;
	}

	/** The controller platform type. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller platform type." , required = true)
	@XmlElement(required = true)
	private String platformType;

	/** @return The controller platform type. */
	public String getPlatformType() {
		return this.platformType;
	}
	/** @param x The controller platform type. */
	public void setPlatformType(String x) {
		this.platformType = x;
	}

	/** The controller with the full DPL core dump. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller with the full DPL core dump." , required = true)
	@XmlElement(required = true)
	private String fullCtlr;

	/** @return The controller with the full DPL core dump. */
	public String getFullCtlr() {
		return this.fullCtlr;
	}
	/** @param x The controller with the full DPL core dump. */
	public void setFullCtlr(String x) {
		this.fullCtlr = x;
	}

	/** The serial number of the controller with the full DPL core dump. */
	@io.swagger.annotations.ApiModelProperty(value ="The serial number of the controller with the full DPL core dump." , required = true)
	@XmlElement(required = true)
	private String fullCtlrSerialNumber;

	/** @return The serial number of the controller with the full DPL core dump. */
	public String getFullCtlrSerialNumber() {
		return this.fullCtlrSerialNumber;
	}
	/** @param x The serial number of the controller with the full DPL core dump. */
	public void setFullCtlrSerialNumber(String x) {
		this.fullCtlrSerialNumber = x;
	}

	/** The controller with an alternate DPL core dump. May be none. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller with an alternate DPL core dump. May be none." , required = true)
	@XmlElement(required = true)
	private String altCtlr;

	/** @return The controller with an alternate DPL core dump. May be none. */
	public String getAltCtlr() {
		return this.altCtlr;
	}
	/** @param x The controller with an alternate DPL core dump. May be none. */
	public void setAltCtlr(String x) {
		this.altCtlr = x;
	}

	/** The serial number of the controller with an alternate DPL core dump. */
	@io.swagger.annotations.ApiModelProperty(value ="The serial number of the controller with an alternate DPL core dump." , required = true)
	@XmlElement(required = true)
	private String altCtlrSerialNumber;

	/** @return The serial number of the controller with an alternate DPL core dump. */
	public String getAltCtlrSerialNumber() {
		return this.altCtlrSerialNumber;
	}
	/** @param x The serial number of the controller with an alternate DPL core dump. */
	public void setAltCtlrSerialNumber(String x) {
		this.altCtlrSerialNumber = x;
	}

	/** The type of trigger or reboot reason resulting in the DPL core dump. This information is for internal LSI use only. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of trigger or reboot reason resulting in the DPL core dump. This information is for internal LSI use only." , required = true)
	@XmlElement(required = true)
	private int triggerReason;

	/** @return The type of trigger or reboot reason resulting in the DPL core dump. This information is for internal LSI use only. */
	public int getTriggerReason() {
		return this.triggerReason;
	}
	/** @param x The type of trigger or reboot reason resulting in the DPL core dump. This information is for internal LSI use only. */
	public void setTriggerReason(int x) {
		this.triggerReason = x;
	}

	/** Additional detail about the DPL Core Dump. */
	@io.swagger.annotations.ApiModelProperty(value ="Additional detail about the DPL Core Dump." , required = true)
	@XmlElement(required = true)
	private DPLCoreDumpDetail detail;

	/** @return Additional detail about the DPL Core Dump. */
	public DPLCoreDumpDetail getDetail() {
		return this.detail;
	}
	/** @param x Additional detail about the DPL Core Dump. */
	public void setDetail(DPLCoreDumpDetail x) {
		this.detail = x;
	}

	/** This is the total size of the core dump data to be retrieved from this controller, in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the total size of the core dump data to be retrieved from this controller, in bytes." , required = true)
	@XmlElement(required = true)
	private int dom0CaptureSize;

	/** @return This is the total size of the core dump data to be retrieved from this controller, in bytes. */
	public int getDom0CaptureSize() {
		return this.dom0CaptureSize;
	}
	/** @param x This is the total size of the core dump data to be retrieved from this controller, in bytes. */
	public void setDom0CaptureSize(int x) {
		this.dom0CaptureSize = x;
	}

	/** This is the total size of the core dump data to be retrieved from the alternate controller, in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the total size of the core dump data to be retrieved from the alternate controller, in bytes." , required = true)
	@XmlElement(required = true)
	private int dom0AltCaptureSize;

	/** @return This is the total size of the core dump data to be retrieved from the alternate controller, in bytes. */
	public int getDom0AltCaptureSize() {
		return this.dom0AltCaptureSize;
	}
	/** @param x This is the total size of the core dump data to be retrieved from the alternate controller, in bytes. */
	public void setDom0AltCaptureSize(int x) {
		this.dom0AltCaptureSize = x;
	}

	/** This is the time stamp of the latest core dump file on this controller measured in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the time stamp of the latest core dump file on this controller measured in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long dom0CaptureTime;

	/** @return This is the time stamp of the latest core dump file on this controller measured in seconds since January 1, 1970. */
	public long getDom0CaptureTime() {
		return this.dom0CaptureTime;
	}
	/** @param x This is the time stamp of the latest core dump file on this controller measured in seconds since January 1, 1970. */
	public void setDom0CaptureTime(long x) {
		this.dom0CaptureTime = x;
	}

	/** This is the time stamp of the latest core dump file on the alternate controller measured in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the time stamp of the latest core dump file on the alternate controller measured in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long dom0AltCaptureTime;

	/** @return This is the time stamp of the latest core dump file on the alternate controller measured in seconds since January 1, 1970. */
	public long getDom0AltCaptureTime() {
		return this.dom0AltCaptureTime;
	}
	/** @param x This is the time stamp of the latest core dump file on the alternate controller measured in seconds since January 1, 1970. */
	public void setDom0AltCaptureTime(long x) {
		this.dom0AltCaptureTime = x;
	}
}
