package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the reason for a DPL core dump. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(89)
public enum DPLCoreDumpReason implements Serializable {
		/** This should never happen. */
		reasonUnknown(0),
		/** The DPL core dump happened because of an assertion. */
		reasonAssert(1),
		/** The DPL core dump happened because of a panic. */
		reasonPanic(2),
		/** The DPL core dump happened for a reason other than a panic or an assertion. */
		reasonOther(3),
		__UNDEFINED(464378545);

		public final int value;

		private DPLCoreDumpReason(int v) {
			this.value = v;
		}
}
