package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey time information for all schedule methods. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(619)
public class DailySchedule implements Serializable {
	public DailySchedule() {
	}

	/** The number of seconds after midnight local time for the first occurrence during the day. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of seconds after midnight local time for the first occurrence during the day." , required = true)
	@XmlElement(required = true)
	private int timeOfDay;

	/** @return The number of seconds after midnight local time for the first occurrence during the day. */
	public int getTimeOfDay() {
		return this.timeOfDay;
	}
	/** @param x The number of seconds after midnight local time for the first occurrence during the day. */
	public void setTimeOfDay(int x) {
		this.timeOfDay = x;
	}

	/** Interval between schedules if timesPerDay is greater than 1. */
	@io.swagger.annotations.ApiModelProperty(value ="Interval between schedules if timesPerDay is greater than 1." , required = true)
	@XmlElement(required = true)
	private int everyNMinutes;

	/** @return Interval between schedules if timesPerDay is greater than 1. */
	public int getEveryNMinutes() {
		return this.everyNMinutes;
	}
	/** @param x Interval between schedules if timesPerDay is greater than 1. */
	public void setEveryNMinutes(int x) {
		this.everyNMinutes = x;
	}

	/** The number of occurrences during the day based on everyNMinutes, including the first occurrence. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of occurrences during the day based on everyNMinutes, including the first occurrence." , required = true)
	@XmlElement(required = true)
	private int timesPerDay;

	/** @return The number of occurrences during the day based on everyNMinutes, including the first occurrence. */
	public int getTimesPerDay() {
		return this.timesPerDay;
	}
	/** @param x The number of occurrences during the day based on everyNMinutes, including the first occurrence. */
	public void setTimesPerDay(int x) {
		this.timesPerDay = x;
	}
}
