package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains database metadata returned by the getDatabaseMetadata procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(741)
public class DatabaseMetadataReturned implements Serializable {
	public DatabaseMetadataReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** Database metadata is returned only if the ReturnCode equals RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="Database metadata is returned only if the ReturnCode equals RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private DatabaseMetadata databaseData;

	/** @return Database metadata is returned only if the ReturnCode equals RETCODE_OK. */
	public DatabaseMetadata getDatabaseData() {
		return this.databaseData;
	}
	/** @param x Database metadata is returned only if the ReturnCode equals RETCODE_OK. */
	public void setDatabaseData(DatabaseMetadata x) {
		this.databaseData = x;
	}
}
