package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify which day of which month to enable or disable daylight savings time. Several methods are supported: */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(561)
public class DaylightSavingsTime implements Serializable {
	public DaylightSavingsTime() {
	}

	/** Time of day for DST change measured as seconds past midnight. */
	@io.swagger.annotations.ApiModelProperty(value ="Time of day for DST change measured as seconds past midnight." , required = true)
	@XmlElement(required = true)
	private int time;

	/** @return Time of day for DST change measured as seconds past midnight. */
	public int getTime() {
		return this.time;
	}
	/** @param x Time of day for DST change measured as seconds past midnight. */
	public void setTime(int x) {
		this.time = x;
	}

	/** Reference for time. */
	@io.swagger.annotations.ApiModelProperty(value ="Reference for time." , required = true)
	@XmlElement(required = true)
	private ClockMode clockMode = ClockMode.__UNDEFINED;

	/** @return Reference for time. */
	public ClockMode getClockMode() {
		return this.clockMode;
	}
	/** @param x Reference for time. */
	public void setClockMode(ClockMode x) {
		this.clockMode = x;
	}

	/** Month value: 0 to 12 (and negatives). */
	@io.swagger.annotations.ApiModelProperty(value ="Month value: 0 to 12 (and negatives)." , required = true)
	@XmlElement(required = true)
	private int month;

	/** @return Month value: 0 to 12 (and negatives). */
	public int getMonth() {
		return this.month;
	}
	/** @param x Month value: 0 to 12 (and negatives). */
	public void setMonth(int x) {
		this.month = x;
	}

	/** Day of month: 0 to 31 (and negatives). */
	@io.swagger.annotations.ApiModelProperty(value ="Day of month: 0 to 31 (and negatives)." , required = true)
	@XmlElement(required = true)
	private int dayOfMonth;

	/** @return Day of month: 0 to 31 (and negatives). */
	public int getDayOfMonth() {
		return this.dayOfMonth;
	}
	/** @param x Day of month: 0 to 31 (and negatives). */
	public void setDayOfMonth(int x) {
		this.dayOfMonth = x;
	}

	/** Day of week: 0 to 7 (and negatives). */
	@io.swagger.annotations.ApiModelProperty(value ="Day of week: 0 to 7 (and negatives)." , required = true)
	@XmlElement(required = true)
	private int dayOfWeek;

	/** @return Day of week: 0 to 7 (and negatives). */
	public int getDayOfWeek() {
		return this.dayOfWeek;
	}
	/** @param x Day of week: 0 to 7 (and negatives). */
	public void setDayOfWeek(int x) {
		this.dayOfWeek = x;
	}
}
