package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the parameters that are provided by the client when starting a DBM Block retrieval. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(364)
public class DbmBlkRetrieveStartDetails implements Serializable {
	public DbmBlkRetrieveStartDetails() {
	}

	/** When true, unallocated blocks are omitted from the retrieved data. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, unallocated blocks are omitted from the retrieved data." , required = true)
	@XmlElement(required = true)
	private boolean omitUnallocatedBlocks;

	/** @return When true, unallocated blocks are omitted from the retrieved data. */
	public boolean isOmitUnallocatedBlocks() {
		return this.omitUnallocatedBlocks;
	}
	/** @param x When true, unallocated blocks are omitted from the retrieved data. */
	public void setOmitUnallocatedBlocks(boolean x) {
		this.omitUnallocatedBlocks = x;
	}

	/** When true, the block coherency check is not performed during the preparation phase of the data transfer. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, the block coherency check is not performed during the preparation phase of the data transfer." , required = true)
	@XmlElement(required = true)
	private boolean skipBlockCoherencyCheck;

	/** @return When true, the block coherency check is not performed during the preparation phase of the data transfer. */
	public boolean isSkipBlockCoherencyCheck() {
		return this.skipBlockCoherencyCheck;
	}
	/** @param x When true, the block coherency check is not performed during the preparation phase of the data transfer. */
	public void setSkipBlockCoherencyCheck(boolean x) {
		this.skipBlockCoherencyCheck = x;
	}

	/** When true, the structure integrity check is not performed during the preparation phase of the data transfer. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, the structure integrity check is not performed during the preparation phase of the data transfer." , required = true)
	@XmlElement(required = true)
	private boolean skipStructureIntegrityCheck;

	/** @return When true, the structure integrity check is not performed during the preparation phase of the data transfer. */
	public boolean isSkipStructureIntegrityCheck() {
		return this.skipStructureIntegrityCheck;
	}
	/** @param x When true, the structure integrity check is not performed during the preparation phase of the data transfer. */
	public void setSkipStructureIntegrityCheck(boolean x) {
		this.skipStructureIntegrityCheck = x;
	}

	/** Defines which storage device to read the image from. */
	@io.swagger.annotations.ApiModelProperty(value ="Defines which storage device to read the image from." , required = true)
	@XmlElement(required = true)
	private DbmDatabaseLocation sourceLocation = DbmDatabaseLocation.__UNDEFINED;

	/** @return Defines which storage device to read the image from. */
	public DbmDatabaseLocation getSourceLocation() {
		return this.sourceLocation;
	}
	/** @param x Defines which storage device to read the image from. */
	public void setSourceLocation(DbmDatabaseLocation x) {
		this.sourceLocation = x;
	}
}
