package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the parameters that are provided by the client when starting a configuration database validation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(477)
public class DbmCheckRetrieveStartDetails implements Serializable {
	public DbmCheckRetrieveStartDetails() {
	}

	/** When true, a logical consistency check will be performed. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, a logical consistency check will be performed." , required = true)
	@XmlElement(required = true)
	private boolean performLogicalConsistencyCheck;

	/** @return When true, a logical consistency check will be performed. */
	public boolean isPerformLogicalConsistencyCheck() {
		return this.performLogicalConsistencyCheck;
	}
	/** @param x When true, a logical consistency check will be performed. */
	public void setPerformLogicalConsistencyCheck(boolean x) {
		this.performLogicalConsistencyCheck = x;
	}

	/** When true, a block consistency check will be performed. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, a block consistency check will be performed." , required = true)
	@XmlElement(required = true)
	private boolean performBlockConsistencyCheck;

	/** @return When true, a block consistency check will be performed. */
	public boolean isPerformBlockConsistencyCheck() {
		return this.performBlockConsistencyCheck;
	}
	/** @param x When true, a block consistency check will be performed. */
	public void setPerformBlockConsistencyCheck(boolean x) {
		this.performBlockConsistencyCheck = x;
	}

	/** When true, a check of the record contents will be performed by the owner of the record type. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, a check of the record contents will be performed by the owner of the record type." , required = true)
	@XmlElement(required = true)
	private boolean performClientConsistencyCheck;

	/** @return When true, a check of the record contents will be performed by the owner of the record type. */
	public boolean isPerformClientConsistencyCheck() {
		return this.performClientConsistencyCheck;
	}
	/** @param x When true, a check of the record contents will be performed by the owner of the record type. */
	public void setPerformClientConsistencyCheck(boolean x) {
		this.performClientConsistencyCheck = x;
	}

	/** Specifies which storage device contains the image to be checked. */
	@io.swagger.annotations.ApiModelProperty(value ="Specifies which storage device contains the image to be checked." , required = true)
	@XmlElement(required = true)
	private DbmDatabaseLocation sourceLocation = DbmDatabaseLocation.__UNDEFINED;

	/** @return Specifies which storage device contains the image to be checked. */
	public DbmDatabaseLocation getSourceLocation() {
		return this.sourceLocation;
	}
	/** @param x Specifies which storage device contains the image to be checked. */
	public void setSourceLocation(DbmDatabaseLocation x) {
		this.sourceLocation = x;
	}
}
