package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed content of raw data returned by the controller in response to DBM Record retrieval requests. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(550)
public class DbmRecRetrieveChunkDetails implements Serializable {
	public DbmRecRetrieveChunkDetails() {
	}

	/** Indicates whether the overall image has a structural fault or if the integrity wasn't checked prior to retrieval. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates whether the overall image has a structural fault or if the integrity wasn't checked prior to retrieval." , required = true)
	@XmlElement(required = true)
	private DataCheck structureIntegrityCheck = DataCheck.__UNDEFINED;

	/** @return Indicates whether the overall image has a structural fault or if the integrity wasn't checked prior to retrieval. */
	public DataCheck getStructureIntegrityCheck() {
		return this.structureIntegrityCheck;
	}
	/** @param x Indicates whether the overall image has a structural fault or if the integrity wasn't checked prior to retrieval. */
	public void setStructureIntegrityCheck(DataCheck x) {
		this.structureIntegrityCheck = x;
	}

	/** The size of the image that will be retrieved. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the image that will be retrieved." , required = true)
	@XmlElement(required = true)
	private int totalImageSize;

	/** @return The size of the image that will be retrieved. */
	public int getTotalImageSize() {
		return this.totalImageSize;
	}
	/** @param x The size of the image that will be retrieved. */
	public void setTotalImageSize(int x) {
		this.totalImageSize = x;
	}

	/** Indicates when the image was retrieved. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates when the image was retrieved." , required = true)
	@XmlElement(required = true)
	private int timestamp;

	/** @return Indicates when the image was retrieved. */
	public int getTimestamp() {
		return this.timestamp;
	}
	/** @param x Indicates when the image was retrieved. */
	public void setTimestamp(int x) {
		this.timestamp = x;
	}

	/** The value of the configuration gen number when the image was retrieved. */
	@io.swagger.annotations.ApiModelProperty(value ="The value of the configuration gen number when the image was retrieved." , required = true)
	@XmlElement(required = true)
	private long configGen;

	/** @return The value of the configuration gen number when the image was retrieved. */
	public long getConfigGen() {
		return this.configGen;
	}
	/** @param x The value of the configuration gen number when the image was retrieved. */
	public void setConfigGen(long x) {
		this.configGen = x;
	}

	/** The data chunk. */
	@io.swagger.annotations.ApiModelProperty(value ="The data chunk." , required = true)
	@XmlElement(required = true)
	private String chunkData;

	/** @return The data chunk. */
	public String getChunkData() {
		return this.chunkData;
	}
	/** @param x The data chunk. */
	public void setChunkData(String x) {
		this.chunkData = x;
	}

	/** Defines which storage device to read the image from. Repeated here to ensure all chunks were read from the same place. */
	@io.swagger.annotations.ApiModelProperty(value ="Defines which storage device to read the image from. Repeated here to ensure all chunks were read from the same place." , required = true)
	@XmlElement(required = true)
	private DbmDatabaseLocation sourceLocation = DbmDatabaseLocation.__UNDEFINED;

	/** @return Defines which storage device to read the image from. Repeated here to ensure all chunks were read from the same place. */
	public DbmDatabaseLocation getSourceLocation() {
		return this.sourceLocation;
	}
	/** @param x Defines which storage device to read the image from. Repeated here to ensure all chunks were read from the same place. */
	public void setSourceLocation(DbmDatabaseLocation x) {
		this.sourceLocation = x;
	}

	/** Which record types to check. */
	@io.swagger.annotations.ApiModelProperty(value ="Which record types to check." , required = true)
	@XmlElement(required = true)
	private DbmRecConfigType configType = DbmRecConfigType.__UNDEFINED;

	/** @return Which record types to check. */
	public DbmRecConfigType getConfigType() {
		return this.configType;
	}
	/** @param x Which record types to check. */
	public void setConfigType(DbmRecConfigType x) {
		this.configType = x;
	}
}
