package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the parameters that are provided by the client when starting a DBM Record retrieval. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(532)
public class DbmRecRetrieveStartDetails implements Serializable {
	public DbmRecRetrieveStartDetails() {
	}

	/** When true, the structure integrity check is skipped during the preparation phase of the data transfer. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, the structure integrity check is skipped during the preparation phase of the data transfer." , required = true)
	@XmlElement(required = true)
	private boolean skipStructureIntegrityCheck;

	/** @return When true, the structure integrity check is skipped during the preparation phase of the data transfer. */
	public boolean isSkipStructureIntegrityCheck() {
		return this.skipStructureIntegrityCheck;
	}
	/** @param x When true, the structure integrity check is skipped during the preparation phase of the data transfer. */
	public void setSkipStructureIntegrityCheck(boolean x) {
		this.skipStructureIntegrityCheck = x;
	}

	/** Defines which storage device to read the image from. */
	@io.swagger.annotations.ApiModelProperty(value ="Defines which storage device to read the image from." , required = true)
	@XmlElement(required = true)
	private DbmDatabaseLocation sourceLocation = DbmDatabaseLocation.__UNDEFINED;

	/** @return Defines which storage device to read the image from. */
	public DbmDatabaseLocation getSourceLocation() {
		return this.sourceLocation;
	}
	/** @param x Defines which storage device to read the image from. */
	public void setSourceLocation(DbmDatabaseLocation x) {
		this.sourceLocation = x;
	}

	/** Defines which set of record types to read. */
	@io.swagger.annotations.ApiModelProperty(value ="Defines which set of record types to read." , required = true)
	@XmlElement(required = true)
	private DbmRecConfigType configType = DbmRecConfigType.__UNDEFINED;

	/** @return Defines which set of record types to read. */
	public DbmRecConfigType getConfigType() {
		return this.configType;
	}
	/** @param x Defines which set of record types to read. */
	public void setConfigType(DbmRecConfigType x) {
		this.configType = x;
	}
}
