package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around a DdcLogData structure. It is used for returning both a return code and log data on a procedure call. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(650)
public class DdcLogDataReturned implements Serializable {
	public DdcLogDataReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field contains the returned log data. It is present only when the returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the returned log data. It is present only when the returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private DdcLogData ddcLogData;

	/** @return This field contains the returned log data. It is present only when the returnCode is equal to RETCODE_OK. */
	public DdcLogData getDdcLogData() {
		return this.ddcLogData;
	}
	/** @param x This field contains the returned log data. It is present only when the returnCode is equal to RETCODE_OK. */
	public void setDdcLogData(DdcLogData x) {
		this.ddcLogData = x;
	}
}
