package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the input argument to the getControllerDebugInformation procedure. It describes an individual extent of debug information to be returned by the procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(603)
public class DebugInfoExtent implements Serializable {
	public DebugInfoExtent() {
	}

	/** A reference to the controller from which the extent is requested. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller from which the extent is requested." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return A reference to the controller from which the extent is requested. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference to the controller from which the extent is requested. */
	public void setController(String x) {
		this.controller = x;
	}

	/** A controller-assigned identifier of a mutually-consistent collection of debug information extents. On the initial call (chunkNumber = 0), the handle is not significant. */
	@io.swagger.annotations.ApiModelProperty(value ="A controller-assigned identifier of a mutually-consistent collection of debug information extents. On the initial call (chunkNumber = 0), the handle is not significant." , required = true)
	@XmlElement(required = true)
	private String handle;

	/** @return A controller-assigned identifier of a mutually-consistent collection of debug information extents. On the initial call (chunkNumber = 0), the handle is not significant. */
	public String getHandle() {
		return this.handle;
	}
	/** @param x A controller-assigned identifier of a mutually-consistent collection of debug information extents. On the initial call (chunkNumber = 0), the handle is not significant. */
	public void setHandle(String x) {
		this.handle = x;
	}

	/** The number of the "chunk" of debug information to return. Note that chunk number zero has special significance - see structure DebugInfo. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the \"chunk\" of debug information to return. Note that chunk number zero has special significance - see structure DebugInfo." , required = true)
	@XmlElement(required = true)
	private int chunkNumber;

	/** @return The number of the "chunk" of debug information to return. Note that chunk number zero has special significance - see structure DebugInfo. */
	public int getChunkNumber() {
		return this.chunkNumber;
	}
	/** @param x The number of the "chunk" of debug information to return. Note that chunk number zero has special significance - see structure DebugInfo. */
	public void setChunkNumber(int x) {
		this.chunkNumber = x;
	}
}
