package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the different operational states of a DIMM component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(284)
public enum DimmStatus implements Serializable {
		/** The DIMM status is unknown; because of communication problems with the alternate controller. */
		unknown(0),
		/** The DIMM is working properly. */
		optimal(1),
		/** The DIMM slot is intentionally not populated. */
		empty(2),
		/** The DIMM has failed. */
		failed(3),
		__UNDEFINED(464378545);

		public final int value;

		private DimmStatus(int v) {
			this.value = v;
		}
}
