package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Current Status of the given Directory Services Domain */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(274)
public enum DirectoryServicesStatus implements Serializable {
		/** An error with the Directory Service Configuration has been resolved and the service is working normally */
		optimal(0),
		/** The configuration for this domain has been changed */
		configChange(1),
		/** There is a problem communicating with the given domain */
		error(2),
		__UNDEFINED(464378545);

		public final int value;

		private DirectoryServicesStatus(int v) {
			this.value = v;
		}
}
