package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Internal Message Description sent from the WebService Proxy. Indicates a change in the given Directory Service Domain's status */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(705)
public class DirectoryServicesStatusDesc implements Serializable {
	public DirectoryServicesStatusDesc() {
	}

	/** Affected Directory Services Domain */
	@io.swagger.annotations.ApiModelProperty(value ="Affected Directory Services Domain" , required = true)
	@XmlElement(required = true)
	private DirectoryServicesDomain domain;

	/** @return Affected Directory Services Domain */
	public DirectoryServicesDomain getDomain() {
		return this.domain;
	}
	/** @param x Affected Directory Services Domain */
	public void setDomain(DirectoryServicesDomain x) {
		this.domain = x;
	}

	/** The domains new status */
	@io.swagger.annotations.ApiModelProperty(value ="The domains new status" , required = true)
	@XmlElement(required = true)
	private DirectoryServicesStatus status = DirectoryServicesStatus.__UNDEFINED;

	/** @return The domains new status */
	public DirectoryServicesStatus getStatus() {
		return this.status;
	}
	/** @param x The domains new status */
	public void setStatus(DirectoryServicesStatus x) {
		this.status = x;
	}
}
