package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is returned by the controller (or SYMbol/UTM agent) to a client in response to a discoverControllers procedure call. It contains information about all of the controllers (and the storage arrays in which they reside) that are reachable through the SYMbol server that is generating the response. When an actual RAID controller generates the response, the returned object will contain only one AccessibleController element. When an agent generates the response, it will contain an AccessibleController element for every controller that is reachable through the agent's UTM layer. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(781)
public class DiscoveryResponse implements Serializable {
	public DiscoveryResponse() {
	}

	/** A true value in this field indicates that the response was generated by a SYMbol agent; a false value indicates that the response is from a direct network-attached RAID controller. */
	@io.swagger.annotations.ApiModelProperty(value ="A true value in this field indicates that the response was generated by a SYMbol agent; a false value indicates that the response is from a direct network-attached RAID controller." , required = true)
	@XmlElement(required = true)
	private boolean responseFromAgent;

	/** @return A true value in this field indicates that the response was generated by a SYMbol agent; a false value indicates that the response is from a direct network-attached RAID controller. */
	public boolean isResponseFromAgent() {
		return this.responseFromAgent;
	}
	/** @param x A true value in this field indicates that the response was generated by a SYMbol agent; a false value indicates that the response is from a direct network-attached RAID controller. */
	public void setResponseFromAgent(boolean x) {
		this.responseFromAgent = x;
	}

	/** A global identifier of the responding agent. Note that this value will not be set if the response is from a direct network-attached RAID controller instead of an agent. */
	@io.swagger.annotations.ApiModelProperty(value ="A global identifier of the responding agent. Note that this value will not be set if the response is from a direct network-attached RAID controller instead of an agent." , required = true)
	@XmlElement(required = true)
	private String agentId;

	/** @return A global identifier of the responding agent. Note that this value will not be set if the response is from a direct network-attached RAID controller instead of an agent. */
	public String getAgentId() {
		return this.agentId;
	}
	/** @param x A global identifier of the responding agent. Note that this value will not be set if the response is from a direct network-attached RAID controller instead of an agent. */
	public void setAgentId(String x) {
		this.agentId = x;
	}

	/** This field contains a variable-length array of AccessibleController objects. There is one element for each controller that can be reached through the entity that is responding to the request. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a variable-length array of AccessibleController objects. There is one element for each controller that can be reached through the entity that is responding to the request." , required = true)
	@XmlElement(required = true)
	private AccessibleController[] controllers;

	/** @return This field contains a variable-length array of AccessibleController objects. There is one element for each controller that can be reached through the entity that is responding to the request. */
	public AccessibleController[] getControllers() {
		return this.controllers;
	}
	/** @param x This field contains a variable-length array of AccessibleController objects. There is one element for each controller that can be reached through the entity that is responding to the request. */
	public void setControllers(AccessibleController[] x) {
		this.controllers = x;
	}
}
