package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the discrete time series observations collected by an individual controller in the storage array, along with other pertinent data about the statistical stream. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(450)
public class DiscreteTimeSeries implements Serializable {
	public DiscreteTimeSeries() {
	}

	/** A reference to the controller that provided the statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller that provided the statistics." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return A reference to the controller that provided the statistics. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x A reference to the controller that provided the statistics. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The number of times the controller memory buffer for holding the observations has wrapped before being retrieved by the client. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times the controller memory buffer for holding the observations has wrapped before being retrieved by the client." , required = true)
	@XmlElement(required = true)
	private int wrapCount;

	/** @return The number of times the controller memory buffer for holding the observations has wrapped before being retrieved by the client. */
	public int getWrapCount() {
		return this.wrapCount;
	}
	/** @param x The number of times the controller memory buffer for holding the observations has wrapped before being retrieved by the client. */
	public void setWrapCount(int x) {
		this.wrapCount = x;
	}

	/** The array of observations. */
	@io.swagger.annotations.ApiModelProperty(value ="The array of observations." , required = true)
	@XmlElement(required = true)
	private long[] series;

	/** @return The array of observations. */
	public long[] getSeries() {
		return this.series;
	}
	/** @param x The array of observations. */
	public void setSeries(long[] x) {
		this.series = x;
	}
}
