package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union structure is a wrapper for the data returned by the getDiscreteTimeSeriesBundle procedure call */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1007)
public class DiscreteTimeSeriesBundleReturned implements Serializable {
	public DiscreteTimeSeriesBundleReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The data comprising the discrete time series statistical streams. This field is only valid if returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The data comprising the discrete time series statistical streams. This field is only valid if returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private DiscreteTimeSeriesBundle dtsBundle;

	/** @return The data comprising the discrete time series statistical streams. This field is only valid if returnCode is equal to RETCODE_OK. */
	public DiscreteTimeSeriesBundle getDtsBundle() {
		return this.dtsBundle;
	}
	/** @param x The data comprising the discrete time series statistical streams. This field is only valid if returnCode is equal to RETCODE_OK. */
	public void setDtsBundle(DiscreteTimeSeriesBundle x) {
		this.dtsBundle = x;
	}
}
