package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about how a new disk pool is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1153)
public class DiskPoolCreationDescriptor implements Serializable {
	public DiskPoolCreationDescriptor() {
	}

	/** This field must contain a Volume candidate that was returned by getVolumeCandidates. */
	@io.swagger.annotations.ApiModelProperty(value ="This field must contain a Volume candidate that was returned by getVolumeCandidates." , required = true)
	@XmlElement(required = true)
	private VolumeCandidate candidate;

	/** @return This field must contain a Volume candidate that was returned by getVolumeCandidates. */
	public VolumeCandidate getCandidate() {
		return this.candidate;
	}
	/** @param x This field must contain a Volume candidate that was returned by getVolumeCandidates. */
	public void setCandidate(VolumeCandidate x) {
		this.candidate = x;
	}

	/** The label string for the new Volume Group. */
	@io.swagger.annotations.ApiModelProperty(value ="The label string for the new Volume Group." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The label string for the new Volume Group. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The label string for the new Volume Group. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The pool utilization warning capacity as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="The pool utilization warning capacity as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity." , required = true)
	@XmlElement(required = true)
	private int poolUtilizationWarningThreshold;

	/** @return The pool utilization warning capacity as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	public int getPoolUtilizationWarningThreshold() {
		return this.poolUtilizationWarningThreshold;
	}
	/** @param x The pool utilization warning capacity as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	public void setPoolUtilizationWarningThreshold(int x) {
		this.poolUtilizationWarningThreshold = x;
	}

	/** The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity." , required = true)
	@XmlElement(required = true)
	private int poolUtilizationCriticalThreshold;

	/** @return The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	public int getPoolUtilizationCriticalThreshold() {
		return this.poolUtilizationCriticalThreshold;
	}
	/** @param x The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity. */
	public void setPoolUtilizationCriticalThreshold(int x) {
		this.poolUtilizationCriticalThreshold = x;
	}

	/** One failed drive degraded reconstruction priority. */
	@io.swagger.annotations.ApiModelProperty(value ="One failed drive degraded reconstruction priority." , required = true)
	@XmlElement(required = true)
	private DiskPoolOperationPriority degradedReconstructPriority = DiskPoolOperationPriority.__UNDEFINED;

	/** @return One failed drive degraded reconstruction priority. */
	public DiskPoolOperationPriority getDegradedReconstructPriority() {
		return this.degradedReconstructPriority;
	}
	/** @param x One failed drive degraded reconstruction priority. */
	public void setDegradedReconstructPriority(DiskPoolOperationPriority x) {
		this.degradedReconstructPriority = x;
	}

	/** Two failed drive reconstruction critical priority. */
	@io.swagger.annotations.ApiModelProperty(value ="Two failed drive reconstruction critical priority." , required = true)
	@XmlElement(required = true)
	private DiskPoolOperationPriority criticalReconstructPriority = DiskPoolOperationPriority.__UNDEFINED;

	/** @return Two failed drive reconstruction critical priority. */
	public DiskPoolOperationPriority getCriticalReconstructPriority() {
		return this.criticalReconstructPriority;
	}
	/** @param x Two failed drive reconstruction critical priority. */
	public void setCriticalReconstructPriority(DiskPoolOperationPriority x) {
		this.criticalReconstructPriority = x;
	}

	/** Priority of other background operations (DVE,DCE,DCR, and IAF). */
	@io.swagger.annotations.ApiModelProperty(value ="Priority of other background operations (DVE,DCE,DCR, and IAF)." , required = true)
	@XmlElement(required = true)
	private DiskPoolOperationPriority backgroundOperationPriority = DiskPoolOperationPriority.__UNDEFINED;

	/** @return Priority of other background operations (DVE,DCE,DCR, and IAF). */
	public DiskPoolOperationPriority getBackgroundOperationPriority() {
		return this.backgroundOperationPriority;
	}
	/** @param x Priority of other background operations (DVE,DCE,DCR, and IAF). */
	public void setBackgroundOperationPriority(DiskPoolOperationPriority x) {
		this.backgroundOperationPriority = x;
	}
}
