package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used for Disk Pool related priority attributes. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(87)
public enum DiskPoolOperationPriority implements Serializable {
		/** The priority is not valid. */
		invalid(0),
		/** The lowest priority. */
		lowest(1),
		/** Low priority. */
		low(2),
		/** Medium priority. */
		medium(3),
		/** High priority. */
		high(4),
		/** The highest priority. */
		highest(5),
		/** The firmware will use the default priority. */
		useDefault(65535),
		__UNDEFINED(464378545);

		public final int value;

		private DiskPoolOperationPriority(int v) {
			this.value = v;
		}
}
