package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used when calling the setDiskPoolThreshold procedure to set a utilization threshold value for a Disk Pool. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(716)
public class DiskPoolThresholdUpdateDescriptor implements Serializable {
	public DiskPoolThresholdUpdateDescriptor() {
	}

	/** A reference to the Disk Pool. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the Disk Pool." , required = true)
	@XmlElement(required = true)
	private String volumeGroupRef;

	/** @return A reference to the Disk Pool. */
	public String getVolumeGroupRef() {
		return this.volumeGroupRef;
	}
	/** @param x A reference to the Disk Pool. */
	public void setVolumeGroupRef(String x) {
		this.volumeGroupRef = x;
	}

	/** The type of threshold to set. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of threshold to set." , required = true)
	@XmlElement(required = true)
	private DiskPoolThresholdType thresholdType = DiskPoolThresholdType.__UNDEFINED;

	/** @return The type of threshold to set. */
	public DiskPoolThresholdType getThresholdType() {
		return this.thresholdType;
	}
	/** @param x The type of threshold to set. */
	public void setThresholdType(DiskPoolThresholdType x) {
		this.thresholdType = x;
	}

	/** The new threshold value. */
	@io.swagger.annotations.ApiModelProperty(value ="The new threshold value." , required = true)
	@XmlElement(required = true)
	private int newThresholdValue;

	/** @return The new threshold value. */
	public int getNewThresholdValue() {
		return this.newThresholdValue;
	}
	/** @param x The new threshold value. */
	public void setNewThresholdValue(int x) {
		this.newThresholdValue = x;
	}
}
