package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to describe the Disk Pool state. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(250)
public enum DiskPoolUtilizationState implements Serializable {
		/** The Disk Pool's utilization state is not valid. */
		utilizationInvalid(0),
		/** The Disk Pool's consumed capacity is below the value established by either pool utilization threshold. No alert condition exists. */
		utilizationOptimal(1),
		/** The Disk Pool's consumed capacity has reached or exceeded the value established by the Warning threshold, but has not yet reached the value established by the Critical threshold. This state drives a Needs Attention condition for the storage array, unless overridden by OEM customers. The Warning state is superseded by the Critical state threshold. */
		utilizationWarning(2),
		/** The Disk Pool's consumed capacity has reached or exceeded the value established by the Critical threshold. This state drives a Needs Attention condition for the array, unless overridden by OEM customers. */
		utilizationCritical(3),
		/** The Disk Pool's capacity is depleted. */
		capacityDepleted(4),
		__UNDEFINED(464378545);

		public final int value;

		private DiskPoolUtilizationState(int v) {
			this.value = v;
		}
}
