package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** DNS (Domain Name System) acquisition configuration parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(787)
public class DnsAcquisitionDescriptor implements Serializable {
	public DnsAcquisitionDescriptor() {
	}

	/** How the DNS addresses were acquired. */
	@io.swagger.annotations.ApiModelProperty(value ="How the DNS addresses were acquired." , required = true)
	@XmlElement(required = true)
	private DnsAcquisitionMethod dnsAcquisitionType = DnsAcquisitionMethod.__UNDEFINED;

	/** @return How the DNS addresses were acquired. */
	public DnsAcquisitionMethod getDnsAcquisitionType() {
		return this.dnsAcquisitionType;
	}
	/** @param x How the DNS addresses were acquired. */
	public void setDnsAcquisitionType(DnsAcquisitionMethod x) {
		this.dnsAcquisitionType = x;
	}

	/** This field is used if the method is set to DNS_ACQUISITION_METHOD_STATIC. If more than one address is specified, the first (lowest index) item is given highest precedence and the last item (highest index) is given the lowest precedence. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used if the method is set to DNS_ACQUISITION_METHOD_STATIC. If more than one address is specified, the first (lowest index) item is given highest precedence and the last item (highest index) is given the lowest precedence." , required = false)
	@XmlElement(required = false)
	private IpVxAddress[] dnsServers;

	/** @return This field is used if the method is set to DNS_ACQUISITION_METHOD_STATIC. If more than one address is specified, the first (lowest index) item is given highest precedence and the last item (highest index) is given the lowest precedence. */
	public IpVxAddress[] getDnsServers() {
		return this.dnsServers;
	}
	/** @param x This field is used if the method is set to DNS_ACQUISITION_METHOD_STATIC. If more than one address is specified, the first (lowest index) item is given highest precedence and the last item (highest index) is given the lowest precedence. */
	public void setDnsServers(IpVxAddress[] x) {
		this.dnsServers = x;
	}
}
