package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Contains the data required for each type of support data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(419)
public class Dom0SupportDataStartDetails implements Serializable {
	public Dom0SupportDataStartDetails() {
	}

	/** Enumerates the types of support data that can be retrieved from Dom0 */
	@io.swagger.annotations.ApiModelProperty(value ="Enumerates the types of support data that can be retrieved from Dom0" , required = true)
	@XmlElement(required = true)
	private Dom0SupportDataType supportDataType = Dom0SupportDataType.__UNDEFINED;

	/** @return Enumerates the types of support data that can be retrieved from Dom0 */
	public Dom0SupportDataType getSupportDataType() {
		return this.supportDataType;
	}
	/** @param x Enumerates the types of support data that can be retrieved from Dom0 */
	public void setSupportDataType(Dom0SupportDataType x) {
		this.supportDataType = x;
	}

	/** This is only valid when the Dom0 support data type is DOM0_SUPPORT_DATA_JOURNAL_LOGS */
	@io.swagger.annotations.ApiModelProperty(value ="This is only valid when the Dom0 support data type is DOM0_SUPPORT_DATA_JOURNAL_LOGS" , required = false)
	@XmlElement(required = false)
	private Dom0SupportDataJournalStartDetails dom0SupportDataJournalStartDetails;

	/** @return This is only valid when the Dom0 support data type is DOM0_SUPPORT_DATA_JOURNAL_LOGS */
	public Dom0SupportDataJournalStartDetails getDom0SupportDataJournalStartDetails() {
		return this.dom0SupportDataJournalStartDetails;
	}
	/** @param x This is only valid when the Dom0 support data type is DOM0_SUPPORT_DATA_JOURNAL_LOGS */
	public void setDom0SupportDataJournalStartDetails(Dom0SupportDataJournalStartDetails x) {
		this.dom0SupportDataJournalStartDetails = x;
	}
}
