package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed content of raw data returned by the controller in response to DQ retrieval requests. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(348)
public class DqRetrieveChunkDetails implements Serializable {
	public DqRetrieveChunkDetails() {
	}

	/** When true, the data is compressed for the retrieval. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, the data is compressed for the retrieval." , required = true)
	@XmlElement(required = true)
	private boolean compressed;

	/** @return When true, the data is compressed for the retrieval. */
	public boolean isCompressed() {
		return this.compressed;
	}
	/** @param x When true, the data is compressed for the retrieval. */
	public void setCompressed(boolean x) {
		this.compressed = x;
	}

	/** An array of opaque data fields will be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of opaque data fields will be returned." , required = true)
	@XmlElement(required = true)
	private String dqData;

	/** @return An array of opaque data fields will be returned. */
	public String getDqData() {
		return this.dqData;
	}
	/** @param x An array of opaque data fields will be returned. */
	public void setDqData(String x) {
		this.dqData = x;
	}
}
