package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration describes the drive block format for a group of drives. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(72)
public enum DriveBlockFormat implements Serializable {
		/** The drive block format is unknown. */
		unknown(0),
		/** Indicates that all of the drives are native drives; i.e, the logical block size is native and equal to the physical block size. */
		allNative(1),
		/** Indicates that all of the drives are emulation drives; i.e., the logical block size is emulated and different from the physical block size. */
		allEmulated(2),
		/** Indicates that the drives are a mix of emulation and native drives. For emulation drives, the logical block size is emulated and different from the physical block size. For native drives, the logical block size is native and equal to the physical block size. */
		mixed(3),
		__UNDEFINED(464378545);

		public final int value;

		private DriveBlockFormat(int v) {
			this.value = v;
		}
}
