package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about the error counts. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(628)
public class DriveChannelErrorCounts implements Serializable {
	public DriveChannelErrorCounts() {
	}

	/** The number of non channel errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of non channel errors." , required = true)
	@XmlElement(required = true)
	private int nonChannelErrors;

	/** @return The number of non channel errors. */
	public int getNonChannelErrors() {
		return this.nonChannelErrors;
	}
	/** @param x The number of non channel errors. */
	public void setNonChannelErrors(int x) {
		this.nonChannelErrors = x;
	}

	/** The number of timeout errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of timeout errors." , required = true)
	@XmlElement(required = true)
	private int timeoutErrors;

	/** @return The number of timeout errors. */
	public int getTimeoutErrors() {
		return this.timeoutErrors;
	}
	/** @param x The number of timeout errors. */
	public void setTimeoutErrors(int x) {
		this.timeoutErrors = x;
	}

	/** The number of controller detected errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of controller detected errors." , required = true)
	@XmlElement(required = true)
	private int controllerDetectedErrors;

	/** @return The number of controller detected errors. */
	public int getControllerDetectedErrors() {
		return this.controllerDetectedErrors;
	}
	/** @param x The number of controller detected errors. */
	public void setControllerDetectedErrors(int x) {
		this.controllerDetectedErrors = x;
	}

	/** The number of drive detected errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of drive detected errors." , required = true)
	@XmlElement(required = true)
	private int driveDetectedErrors;

	/** @return The number of drive detected errors. */
	public int getDriveDetectedErrors() {
		return this.driveDetectedErrors;
	}
	/** @param x The number of drive detected errors. */
	public void setDriveDetectedErrors(int x) {
		this.driveDetectedErrors = x;
	}

	/** The number of link down errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of link down errors." , required = true)
	@XmlElement(required = true)
	private int linkDownErrors;

	/** @return The number of link down errors. */
	public int getLinkDownErrors() {
		return this.linkDownErrors;
	}
	/** @param x The number of link down errors. */
	public void setLinkDownErrors(int x) {
		this.linkDownErrors = x;
	}
}
