package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information that defines a drive channel port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(925)
public class DriveChannelPort implements Serializable {
	public DriveChannelPort() {
	}

	/** A reference to the drive channel port. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the drive channel port." , required = true)
	@XmlElement(required = true)
	private String portRef;

	/** @return A reference to the drive channel port. */
	public String getPortRef() {
		return this.portRef;
	}
	/** @param x A reference to the drive channel port. */
	public void setPortRef(String x) {
		this.portRef = x;
	}

	/** The Fibre Channel number of the port. */
	@io.swagger.annotations.ApiModelProperty(value ="The Fibre Channel number of the port." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The Fibre Channel number of the port. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The Fibre Channel number of the port. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The type of port (XBB/expansion/internal). */
	@io.swagger.annotations.ApiModelProperty(value ="The type of port (XBB/expansion/internal)." , required = true)
	@XmlElement(required = true)
	private DriveChannelPortType portType = DriveChannelPortType.__UNDEFINED;

	/** @return The type of port (XBB/expansion/internal). */
	public DriveChannelPortType getPortType() {
		return this.portType;
	}
	/** @param x The type of port (XBB/expansion/internal). */
	public void setPortType(DriveChannelPortType x) {
		this.portType = x;
	}

	/** The parent type (minihub/controller). */
	@io.swagger.annotations.ApiModelProperty(value ="The parent type (minihub/controller)." , required = true)
	@XmlElement(required = true)
	private DriveChannelParent parentType;

	/** @return The parent type (minihub/controller). */
	public DriveChannelParent getParentType() {
		return this.parentType;
	}
	/** @param x The parent type (minihub/controller). */
	public void setParentType(DriveChannelParent x) {
		this.parentType = x;
	}
}
