package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the error statistics kept by a controller for a drive channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(675)
public class DriveChannelStatistics implements Serializable {
	public DriveChannelStatistics() {
	}

	/** The time stamp of when the error tracking began. */
	@io.swagger.annotations.ApiModelProperty(value ="The time stamp of when the error tracking began." , required = true)
	@XmlElement(required = true)
	private long startTimeStamp;

	/** @return The time stamp of when the error tracking began. */
	public long getStartTimeStamp() {
		return this.startTimeStamp;
	}
	/** @param x The time stamp of when the error tracking began. */
	public void setStartTimeStamp(long x) {
		this.startTimeStamp = x;
	}

	/** The time stamp of when the error tracking ended. */
	@io.swagger.annotations.ApiModelProperty(value ="The time stamp of when the error tracking ended." , required = true)
	@XmlElement(required = true)
	private long endTimeStamp;

	/** @return The time stamp of when the error tracking ended. */
	public long getEndTimeStamp() {
		return this.endTimeStamp;
	}
	/** @param x The time stamp of when the error tracking ended. */
	public void setEndTimeStamp(long x) {
		this.endTimeStamp = x;
	}

	/** The total number of I/Os. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of I/Os." , required = true)
	@XmlElement(required = true)
	private int totalIoCount;

	/** @return The total number of I/Os. */
	public int getTotalIoCount() {
		return this.totalIoCount;
	}
	/** @param x The total number of I/Os. */
	public void setTotalIoCount(int x) {
		this.totalIoCount = x;
	}

	/** The total number of I/O errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of I/O errors." , required = true)
	@XmlElement(required = true)
	private int totalIoErrorCount;

	/** @return The total number of I/O errors. */
	public int getTotalIoErrorCount() {
		return this.totalIoErrorCount;
	}
	/** @param x The total number of I/O errors. */
	public void setTotalIoErrorCount(int x) {
		this.totalIoErrorCount = x;
	}

	/** The status of the link - up, down, failed */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the link - up, down, failed" , required = true)
	@XmlElement(required = true)
	private LinkStatus linkStatus = LinkStatus.__UNDEFINED;

	/** @return The status of the link - up, down, failed */
	public LinkStatus getLinkStatus() {
		return this.linkStatus;
	}
	/** @param x The status of the link - up, down, failed */
	public void setLinkStatus(LinkStatus x) {
		this.linkStatus = x;
	}

	/** The error category counts. */
	@io.swagger.annotations.ApiModelProperty(value ="The error category counts." , required = true)
	@XmlElement(required = true)
	private DriveChannelErrorCounts errorCounts;

	/** @return The error category counts. */
	public DriveChannelErrorCounts getErrorCounts() {
		return this.errorCounts;
	}
	/** @param x The error category counts. */
	public void setErrorCounts(DriveChannelErrorCounts x) {
		this.errorCounts = x;
	}
}
