package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the firmware download status for one drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(668)
public class DriveDownloadDriveStatus implements Serializable {
	public DriveDownloadDriveStatus() {
	}

	/** The drive reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive reference." , required = true)
	@XmlElement(required = true)
	private String driveRef;

	/** @return The drive reference. */
	public String getDriveRef() {
		return this.driveRef;
	}
	/** @param x The drive reference. */
	public void setDriveRef(String x) {
		this.driveRef = x;
	}

	/** The drive download status. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive download status." , required = true)
	@XmlElement(required = true)
	private DriveDownloadStatus status = DriveDownloadStatus.__UNDEFINED;

	/** @return The drive download status. */
	public DriveDownloadStatus getStatus() {
		return this.status;
	}
	/** @param x The drive download status. */
	public void setStatus(DriveDownloadStatus x) {
		this.status = x;
	}

	/** Will be set to zero unless the DriveDownloadStatus is equal to DRIVE_DL_STAT_IN_PROGRESS_RECON (meaning a reconstruction is in progress). */
	@io.swagger.annotations.ApiModelProperty(value ="Will be set to zero unless the DriveDownloadStatus is equal to DRIVE_DL_STAT_IN_PROGRESS_RECON (meaning a reconstruction is in progress)." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return Will be set to zero unless the DriveDownloadStatus is equal to DRIVE_DL_STAT_IN_PROGRESS_RECON (meaning a reconstruction is in progress). */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x Will be set to zero unless the DriveDownloadStatus is equal to DRIVE_DL_STAT_IN_PROGRESS_RECON (meaning a reconstruction is in progress). */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}
}
