package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object specifies the drive download status. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(285)
public enum DriveDownloadStatus implements Serializable {
		/** The drive download status is ok. */
		okay(1),
		/** Invalid drive reference. */
		invalidDriveref(2),
		/** Duplicate drive. */
		duplicateDrive(3),
		/** The drive download was not attempted. */
		notAttempted(4),
		/** Invalid state. */
		invalidState(5),
		/** The drive download is in progress. */
		inProgress(6),
		/** A partial update was performed. */
		partialUpdate(7),
		/** The drive download failed to update. */
		failedUpdate(8),
		/** The drive has a reconstruction in progress. */
		inProgressRecon(9),
		/** Drive firmware download has been scheduled. */
		pending(10),
		__UNDEFINED(464378545);

		public final int value;

		private DriveDownloadStatus(int v) {
			this.value = v;
		}
}
