package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when downloading a new firmware image to a drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(624)
public class DriveFirmwareUpdateDescriptor implements Serializable {
	public DriveFirmwareUpdateDescriptor() {
	}

	/** This object uniquely identifies the particular drive within the storage array that will receive the new firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the particular drive within the storage array that will receive the new firmware." , required = true)
	@XmlElement(required = true)
	private String driveRef;

	/** @return This object uniquely identifies the particular drive within the storage array that will receive the new firmware. */
	public String getDriveRef() {
		return this.driveRef;
	}
	/** @param x This object uniquely identifies the particular drive within the storage array that will receive the new firmware. */
	public void setDriveRef(String x) {
		this.driveRef = x;
	}

	/** True if the image is a mode select file. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the image is a mode select file." , required = true)
	@XmlElement(required = true)
	private boolean modeSelectFile;

	/** @return True if the image is a mode select file. */
	public boolean isModeSelectFile() {
		return this.modeSelectFile;
	}
	/** @param x True if the image is a mode select file. */
	public void setModeSelectFile(boolean x) {
		this.modeSelectFile = x;
	}

	/** The chunk of firmware to download to the drive. */
	@io.swagger.annotations.ApiModelProperty(value ="The chunk of firmware to download to the drive." , required = true)
	@XmlElement(required = true)
	private FirmwareUpdateDescriptor firmwareUpdateDescriptor;

	/** @return The chunk of firmware to download to the drive. */
	public FirmwareUpdateDescriptor getFirmwareUpdateDescriptor() {
		return this.firmwareUpdateDescriptor;
	}
	/** @param x The chunk of firmware to download to the drive. */
	public void setFirmwareUpdateDescriptor(FirmwareUpdateDescriptor x) {
		this.firmwareUpdateDescriptor = x;
	}
}
