package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides information about drive layout in a drawer (if the tray contains drawers) or in a tray (if the tray does not contain drawers). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(428)
public class DriveLayout implements Serializable {
	public DriveLayout() {
	}

	/** The drive orientation in the drawer or tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive orientation in the drawer or tray." , required = true)
	@XmlElement(required = true)
	private DriveOrientation driveOrientation = DriveOrientation.__UNDEFINED;

	/** @return The drive orientation in the drawer or tray. */
	public DriveOrientation getDriveOrientation() {
		return this.driveOrientation;
	}
	/** @param x The drive orientation in the drawer or tray. */
	public void setDriveOrientation(DriveOrientation x) {
		this.driveOrientation = x;
	}

	/** The number of rows in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of rows in the drive layout. If driveOrientation field is set to \"None\", the value of this field should be zero." , required = true)
	@XmlElement(required = true)
	private int numRows;

	/** @return The number of rows in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	public int getNumRows() {
		return this.numRows;
	}
	/** @param x The number of rows in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	public void setNumRows(int x) {
		this.numRows = x;
	}

	/** The number of columns in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of columns in the drive layout. If driveOrientation field is set to \"None\", the value of this field should be zero." , required = true)
	@XmlElement(required = true)
	private int numColumns;

	/** @return The number of columns in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	public int getNumColumns() {
		return this.numColumns;
	}
	/** @param x The number of columns in the drive layout. If driveOrientation field is set to "None", the value of this field should be zero. */
	public void setNumColumns(int x) {
		this.numColumns = x;
	}

	/** The primary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	@io.swagger.annotations.ApiModelProperty(value ="The primary traversal method for the drawer or tray. If driveOrientation field is set to \"None\", the value of this field should be TRAVERSAL_NONE" , required = true)
	@XmlElement(required = true)
	private Traversal primaryTraversal = Traversal.__UNDEFINED;

	/** @return The primary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	public Traversal getPrimaryTraversal() {
		return this.primaryTraversal;
	}
	/** @param x The primary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	public void setPrimaryTraversal(Traversal x) {
		this.primaryTraversal = x;
	}

	/** The secondary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	@io.swagger.annotations.ApiModelProperty(value ="The secondary traversal method for the drawer or tray. If driveOrientation field is set to \"None\", the value of this field should be TRAVERSAL_NONE" , required = true)
	@XmlElement(required = true)
	private Traversal secondaryTraversal = Traversal.__UNDEFINED;

	/** @return The secondary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	public Traversal getSecondaryTraversal() {
		return this.secondaryTraversal;
	}
	/** @param x The secondary traversal method for the drawer or tray. If driveOrientation field is set to "None", the value of this field should be TRAVERSAL_NONE */
	public void setSecondaryTraversal(Traversal x) {
		this.secondaryTraversal = x;
	}
}
