package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a loss of redundancy to a drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(875)
public class DriveLostRedundancyFailure implements Serializable {
	public DriveLostRedundancyFailure() {
	}

	/** This object uniquely identifies the particular drive within the storage array that has lost redundancy. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the particular drive within the storage array that has lost redundancy." , required = true)
	@XmlElement(required = true)
	private String driveLostRedundancy;

	/** @return This object uniquely identifies the particular drive within the storage array that has lost redundancy. */
	public String getDriveLostRedundancy() {
		return this.driveLostRedundancy;
	}
	/** @param x This object uniquely identifies the particular drive within the storage array that has lost redundancy. */
	public void setDriveLostRedundancy(String x) {
		this.driveLostRedundancy = x;
	}

	/** The channel to the drive that is still operational. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel to the drive that is still operational." , required = true)
	@XmlElement(required = true)
	private int workingChannel;

	/** @return The channel to the drive that is still operational. */
	public int getWorkingChannel() {
		return this.workingChannel;
	}
	/** @param x The channel to the drive that is still operational. */
	public void setWorkingChannel(int x) {
		this.workingChannel = x;
	}

	/** This object uniquely identifies the failed ESM within the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the failed ESM within the storage array." , required = true)
	@XmlElement(required = true)
	private String failedEsm;

	/** @return This object uniquely identifies the failed ESM within the storage array. */
	public String getFailedEsm() {
		return this.failedEsm;
	}
	/** @param x This object uniquely identifies the failed ESM within the storage array. */
	public void setFailedEsm(String x) {
		this.failedEsm = x;
	}
}
