package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object specifies the drive media types that could be present in a storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(67)
public enum DriveMediaType implements Serializable {
		/** There is no preference for a drive media type for volume candidates.. */
		all(0),
		/** The drive media type is unknown. */
		unknown(1),
		/** The drive is a Hard Disk Drive (HDD). */
		hdd(2),
		/** The drive is a Solid State Disk (SSD) drive. */
		ssd(3),
		__UNDEFINED(464378545);

		public final int value;

		private DriveMediaType(int v) {
			this.value = v;
		}
}
