package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This struct contains a drive ref and the corresponding PSID string for that drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(841)
public class DrivePhysicalSecurityId implements Serializable {
	public DrivePhysicalSecurityId() {
	}

	/** The reference to the drive for which the PSID is to be applied. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the drive for which the PSID is to be applied." , required = true)
	@XmlElement(required = true)
	private String driveRef;

	/** @return The reference to the drive for which the PSID is to be applied. */
	public String getDriveRef() {
		return this.driveRef;
	}
	/** @param x The reference to the drive for which the PSID is to be applied. */
	public void setDriveRef(String x) {
		this.driveRef = x;
	}

	/** This string contains the Physical Security ID (PSID) for this drive. The PSID allows the drive to be reset back to factory settings which could happen if the previous lock key was lost. The drive needs to be set back to factory settings in order to be used in the current array. */
	@io.swagger.annotations.ApiModelProperty(value ="This string contains the Physical Security ID (PSID) for this drive. The PSID allows the drive to be reset back to factory settings which could happen if the previous lock key was lost. The drive needs to be set back to factory settings in order to be used in the current array." , required = true)
	@XmlElement(required = true)
	private String physicalSecurityID;

	/** @return This string contains the Physical Security ID (PSID) for this drive. The PSID allows the drive to be reset back to factory settings which could happen if the previous lock key was lost. The drive needs to be set back to factory settings in order to be used in the current array. */
	public String getPhysicalSecurityID() {
		return this.physicalSecurityID;
	}
	/** @param x This string contains the Physical Security ID (PSID) for this drive. The PSID allows the drive to be reset back to factory settings which could happen if the previous lock key was lost. The drive needs to be set back to factory settings in order to be used in the current array. */
	public void setPhysicalSecurityID(String x) {
		this.physicalSecurityID = x;
	}
}
