package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the possible drive status values that can be returned in a Drive object. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(234)
public enum DriveStatus implements Serializable {
		/** The drive status is currently optimal, or fully functional. */
		optimal(1),
		/** The drive is in the failed state. */
		failed(2),
		/** The drive has been newly inserted into the storage array, and is currently being prepared for use. */
		replaced(3),
		/** The drive is being bypassed. */
		bypassed(4),
		/** The drive is present but unresponsive. */
		unresponsive(5),
		/** The drive is physically not present. */
		removed(6),
		/** The drive is considered to be incompatible for various reasons, as defined by DriveStatusCause. */
		incompatible(7),
		/** The drive is undergoing a data relocation operation. */
		dataRelocation(8),
		/** The drive data is being evacuated before drive failure. */
		preFailCopy(9),
		/** This is the state of drive that has been identified to become a source drive in a Copy Then Fail evacuation operation. */
		preFailCopyPending(10),
		__UNDEFINED(464378545);

		public final int value;

		private DriveStatus(int v) {
			this.value = v;
		}
}
