package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains drive temperature data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(623)
public class DriveTemperature implements Serializable {
	public DriveTemperature() {
	}

	/** The current drive temperature (in degrees Celsius). */
	@io.swagger.annotations.ApiModelProperty(value ="The current drive temperature (in degrees Celsius)." , required = true)
	@XmlElement(required = true)
	private int currentTemp;

	/** @return The current drive temperature (in degrees Celsius). */
	public int getCurrentTemp() {
		return this.currentTemp;
	}
	/** @param x The current drive temperature (in degrees Celsius). */
	public void setCurrentTemp(int x) {
		this.currentTemp = x;
	}

	/** Reference temperature (maximum safe operating temperature in degrees Celsius). */
	@io.swagger.annotations.ApiModelProperty(value ="Reference temperature (maximum safe operating temperature in degrees Celsius)." , required = true)
	@XmlElement(required = true)
	private int refTemp;

	/** @return Reference temperature (maximum safe operating temperature in degrees Celsius). */
	public int getRefTemp() {
		return this.refTemp;
	}
	/** @param x Reference temperature (maximum safe operating temperature in degrees Celsius). */
	public void setRefTemp(int x) {
		this.refTemp = x;
	}
}
