package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is returned by the getEnclosureTemperature procedure. It contains the return code for the procedure call and, if the return code is RETCODE_OK, an array of drive temperature data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(957)
public class DriveTemperatureReturned implements Serializable {
	public DriveTemperatureReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** An array of drive temperature data. This field is only valid if returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of drive temperature data. This field is only valid if returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private DriveTemperatureData[] driveTempData;

	/** @return An array of drive temperature data. This field is only valid if returnCode is equal to RETCODE_OK. */
	public DriveTemperatureData[] getDriveTempData() {
		return this.driveTempData;
	}
	/** @param x An array of drive temperature data. This field is only valid if returnCode is equal to RETCODE_OK. */
	public void setDriveTempData(DriveTemperatureData[] x) {
		this.driveTempData = x;
	}
}
