package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about a drive's type-specific data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(916)
public class DriveTypeData implements Serializable {
	public DriveTypeData() {
	}

	/** This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType). */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType)." , required = true)
	@XmlElement(required = true)
	private DriveType driveType = DriveType.__UNDEFINED;

	/** @return This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType). */
	public DriveType getDriveType() {
		return this.driveType;
	}
	/** @param x This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType). */
	public void setDriveType(DriveType x) {
		this.driveType = x;
	}

	/** This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel." , required = false)
	@XmlElement(required = false)
	private FibreDriveAddress[] fibre;

	/** @return This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel. */
	public FibreDriveAddress[] getFibre() {
		return this.fibre;
	}
	/** @param x This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel. */
	public void setFibre(FibreDriveAddress[] x) {
		this.fibre = x;
	}

	/** This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive." , required = false)
	@XmlElement(required = false)
	private SasDriveAddress sas;

	/** @return This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive. */
	public SasDriveAddress getSas() {
		return this.sas;
	}
	/** @param x This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive. */
	public void setSas(SasDriveAddress x) {
		this.sas = x;
	}

	/** This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive." , required = false)
	@XmlElement(required = false)
	private SCSIDriveAddress scsi;

	/** @return This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive. */
	public SCSIDriveAddress getScsi() {
		return this.scsi;
	}
	/** @param x This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive. */
	public void setScsi(SCSIDriveAddress x) {
		this.scsi = x;
	}
}
