package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when downloading a new firmware image to an ESMcard. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(690)
public class ESMFirmwareUpdateDescriptor implements Serializable {
	public ESMFirmwareUpdateDescriptor() {
	}

	/** This object uniquely identifies the particular tray within the storage array that will receive the new firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the particular tray within the storage array that will receive the new firmware." , required = true)
	@XmlElement(required = true)
	private String trayRef;

	/** @return This object uniquely identifies the particular tray within the storage array that will receive the new firmware. */
	public String getTrayRef() {
		return this.trayRef;
	}
	/** @param x This object uniquely identifies the particular tray within the storage array that will receive the new firmware. */
	public void setTrayRef(String x) {
		this.trayRef = x;
	}

	/** The chunk of firmware to download to the ESM card. */
	@io.swagger.annotations.ApiModelProperty(value ="The chunk of firmware to download to the ESM card." , required = true)
	@XmlElement(required = true)
	private FirmwareUpdateDescriptor firmwareUpdateDescriptor;

	/** @return The chunk of firmware to download to the ESM card. */
	public FirmwareUpdateDescriptor getFirmwareUpdateDescriptor() {
		return this.firmwareUpdateDescriptor;
	}
	/** @param x The chunk of firmware to download to the ESM card. */
	public void setFirmwareUpdateDescriptor(FirmwareUpdateDescriptor x) {
		this.firmwareUpdateDescriptor = x;
	}
}
