package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the status of an ESM component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(267)
public enum ESMStatus implements Serializable {
		/** The ESM is working correctly. */
		optimal(1),
		/** The ESM is not working or not present. */
		failed(2),
		/** The ESM has been removed or is missing. */
		removed(3),
		/** The status of the ESM is unknown. */
		unknown(4),
		/** The ESM is not supported. */
		unsupported(5),
		/** The ESM is not certified. */
		uncertified(6),
		__UNDEFINED(464378545);

		public final int value;

		private ESMStatus(int v) {
			this.value = v;
		}
}
