package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** List of the supported ESM and IOM types. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(160)
public enum ESMType implements Serializable {
		/** Unknown or unidentified ESM type. */
		unidentified(0),
		/** Badger ESM used in Camden, Ebbets, and SAS Wembley enclosures. */
		badger(1),
		/** Mercury Devil ESM used in Red Devila nd Blue Devil enclosures. */
		devil(2),
		/** Cyclone ESM used in Trafford enclosure */
		cyclone(3),
		/** Polecat IOM used in Joshua and Alder enclosures (superseded by Otter). Also known as IOM12. */
		polecat(4),
		/** Otter IOM used in Joshua, Alder, and redesigned Trafford enclosures. Also known as IOM12A. */
		otter(5),
		__UNDEFINED(464378545);

		public final int value;

		private ESMType(int v) {
			this.value = v;
		}
}
