package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides information about the embedded external key management client. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(931)
public class EmbeddedExternalKMSInformation implements Serializable {
	public EmbeddedExternalKMSInformation() {
	}

	/** The list of KMS Certificate Files currently installed on the storage array. Only one certificate of each type can ever be installed at a time although not necessarily each possible type will be installed. The specific certificates that need to be installed will depend on the KMIP server, how it is configured, and the CA used to sign certificates. The signed client certificate will always be necessary. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of KMS Certificate Files currently installed on the storage array. Only one certificate of each type can ever be installed at a time although not necessarily each possible type will be installed. The specific certificates that need to be installed will depend on the KMIP server, how it is configured, and the CA used to sign certificates. The signed client certificate will always be necessary." , required = true)
	@XmlElement(required = true)
	private KMSCertificateFileType[] installedKMSCertificateFile;

	/** @return The list of KMS Certificate Files currently installed on the storage array. Only one certificate of each type can ever be installed at a time although not necessarily each possible type will be installed. The specific certificates that need to be installed will depend on the KMIP server, how it is configured, and the CA used to sign certificates. The signed client certificate will always be necessary. */
	public KMSCertificateFileType[] getInstalledKMSCertificateFile() {
		return this.installedKMSCertificateFile;
	}
	/** @param x The list of KMS Certificate Files currently installed on the storage array. Only one certificate of each type can ever be installed at a time although not necessarily each possible type will be installed. The specific certificates that need to be installed will depend on the KMIP server, how it is configured, and the CA used to sign certificates. The signed client certificate will always be necessary. */
	public void setInstalledKMSCertificateFile(KMSCertificateFileType[] x) {
		this.installedKMSCertificateFile = x;
	}

	/** The external key management server endpoint information. */
	@io.swagger.annotations.ApiModelProperty(value ="The external key management server endpoint information." , required = true)
	@XmlElement(required = true)
	private ExternalKMSEndpoint kmsEndpoint;

	/** @return The external key management server endpoint information. */
	public ExternalKMSEndpoint getKmsEndpoint() {
		return this.kmsEndpoint;
	}
	/** @param x The external key management server endpoint information. */
	public void setKmsEndpoint(ExternalKMSEndpoint x) {
		this.kmsEndpoint = x;
	}
}
