package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains default values for the embedded SNMP agent. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(349)
public class EmbeddedSNMPAgentDefaultAttributes implements Serializable {
	public EmbeddedSNMPAgentDefaultAttributes() {
	}

	/** Maximum number of communities that can be added with the addSNMPCommunity procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum number of communities that can be added with the addSNMPCommunity procedure." , required = true)
	@XmlElement(required = true)
	private int maxCommunities;

	/** @return Maximum number of communities that can be added with the addSNMPCommunity procedure. */
	public int getMaxCommunities() {
		return this.maxCommunities;
	}
	/** @param x Maximum number of communities that can be added with the addSNMPCommunity procedure. */
	public void setMaxCommunities(int x) {
		this.maxCommunities = x;
	}

	/** Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure." , required = true)
	@XmlElement(required = true)
	private int maxTrapDestinations;

	/** @return Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure. */
	public int getMaxTrapDestinations() {
		return this.maxTrapDestinations;
	}
	/** @param x Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure. */
	public void setMaxTrapDestinations(int x) {
		this.maxTrapDestinations = x;
	}

	/** Maximum length of a community name. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum length of a community name." , required = true)
	@XmlElement(required = true)
	private int maxCommunityNameStringLength;

	/** @return Maximum length of a community name. */
	public int getMaxCommunityNameStringLength() {
		return this.maxCommunityNameStringLength;
	}
	/** @param x Maximum length of a community name. */
	public void setMaxCommunityNameStringLength(int x) {
		this.maxCommunityNameStringLength = x;
	}

	/** Maximum length of the user-settable system variables. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum length of the user-settable system variables." , required = true)
	@XmlElement(required = true)
	private int maxSystemVariableStringLength;

	/** @return Maximum length of the user-settable system variables. */
	public int getMaxSystemVariableStringLength() {
		return this.maxSystemVariableStringLength;
	}
	/** @param x Maximum length of the user-settable system variables. */
	public void setMaxSystemVariableStringLength(int x) {
		this.maxSystemVariableStringLength = x;
	}

	/** Default value for system variables that are settable via SYMbol. */
	@io.swagger.annotations.ApiModelProperty(value ="Default value for system variables that are settable via SYMbol." , required = true)
	@XmlElement(required = true)
	private String defaultSystemVariableValue;

	/** @return Default value for system variables that are settable via SYMbol. */
	public String getDefaultSystemVariableValue() {
		return this.defaultSystemVariableValue;
	}
	/** @param x Default value for system variables that are settable via SYMbol. */
	public void setDefaultSystemVariableValue(String x) {
		this.defaultSystemVariableValue = x;
	}
}
