package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to convey information for the possible TLV types. Refer to the IEEE Std 802.1AB-2005 */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(667)
public class EnhEthTLV implements Serializable {
	public EnhEthTLV() {
	}

	/** An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005 */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005" , required = true)
	@XmlElement(required = true)
	private EnhEthTLVType enhEthTLVType = EnhEthTLVType.__UNDEFINED;

	/** @return An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005 */
	public EnhEthTLVType getEnhEthTLVType() {
		return this.enhEthTLVType;
	}
	/** @param x An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005 */
	public void setEnhEthTLVType(EnhEthTLVType x) {
		this.enhEthTLVType = x;
	}

	/** This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID." , required = false)
	@XmlElement(required = false)
	private ChassisIDTLV chassisIDTLV;

	/** @return This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID. */
	public ChassisIDTLV getChassisIDTLV() {
		return this.chassisIDTLV;
	}
	/** @param x This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID. */
	public void setChassisIDTLV(ChassisIDTLV x) {
		this.chassisIDTLV = x;
	}

	/** This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID." , required = false)
	@XmlElement(required = false)
	private PortIDTLV portIDTLV;

	/** @return This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID. */
	public PortIDTLV getPortIDTLV() {
		return this.portIDTLV;
	}
	/** @param x This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID. */
	public void setPortIDTLV(PortIDTLV x) {
		this.portIDTLV = x;
	}

	/** This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE." , required = false)
	@XmlElement(required = false)
	private TimeToLiveTLV timeToLiveTLV;

	/** @return This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE. */
	public TimeToLiveTLV getTimeToLiveTLV() {
		return this.timeToLiveTLV;
	}
	/** @param x This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE. */
	public void setTimeToLiveTLV(TimeToLiveTLV x) {
		this.timeToLiveTLV = x;
	}
}
