package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the InfiniBand statistical data reported by the getEnhancedIbStatistics procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(919)
public class EnhancedIbStatisticalData implements Serializable {
	public EnhancedIbStatisticalData() {
	}

	/** This field is a reference to the controller that collected these statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is a reference to the controller that collected these statistics." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return This field is a reference to the controller that collected these statistics. */
	public String getController() {
		return this.controller;
	}
	/** @param x This field is a reference to the controller that collected these statistics. */
	public void setController(String x) {
		this.controller = x;
	}

	/** These are Raw and Relative IB stats. */
	@io.swagger.annotations.ApiModelProperty(value ="These are Raw and Relative IB stats." , required = true)
	@XmlElement(required = true)
	private EnhancedIbBaselinedStatistics baselinedStats;

	/** @return These are Raw and Relative IB stats. */
	public EnhancedIbBaselinedStatistics getBaselinedStats() {
		return this.baselinedStats;
	}
	/** @param x These are Raw and Relative IB stats. */
	public void setBaselinedStats(EnhancedIbBaselinedStatistics x) {
		this.baselinedStats = x;
	}
}
