package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around a structures containing InfiniBand statistical data. It is used by the getEnhancedIbStatistics procedure to return both a return code and the statistical data. Note that getEnhancedIbStatistics replaces the deprecated getIbStatistics(). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1060)
public class EnhancedIbStatisticsReturned implements Serializable {
	public EnhancedIbStatisticsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field contains all IB statistical data for SA. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains all IB statistical data for SA." , required = false)
	@XmlElement(required = false)
	private EnhancedIbStatisticalData[] ibStatistics;

	/** @return This field contains all IB statistical data for SA. */
	public EnhancedIbStatisticalData[] getIbStatistics() {
		return this.ibStatistics;
	}
	/** @param x This field contains all IB statistical data for SA. */
	public void setIbStatistics(EnhancedIbStatisticalData[] x) {
		this.ibStatistics = x;
	}
}
