package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report log data for an environmental card. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1079)
public class EnvCardLogData implements Serializable {
	public EnvCardLogData() {
	}

	/** The serial number of the environmental card */
	@io.swagger.annotations.ApiModelProperty(value ="The serial number of the environmental card" , required = true)
	@XmlElement(required = true)
	private String serialNumber;

	/** @return The serial number of the environmental card */
	public String getSerialNumber() {
		return this.serialNumber;
	}
	/** @param x The serial number of the environmental card */
	public void setSerialNumber(String x) {
		this.serialNumber = x;
	}

	/** The tray and slot number of the environmental card. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray and slot number of the environmental card." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The tray and slot number of the environmental card. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The tray and slot number of the environmental card. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** The event log data for the the environmental card, as an opaque byte array */
	@io.swagger.annotations.ApiModelProperty(value ="The event log data for the the environmental card, as an opaque byte array" , required = true)
	@XmlElement(required = true)
	private String log;

	/** @return The event log data for the the environmental card, as an opaque byte array */
	public String getLog() {
		return this.log;
	}
	/** @param x The event log data for the the environmental card, as an opaque byte array */
	public void setLog(String x) {
		this.log = x;
	}
}
