package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to report result status and log data for the getEnvCardLogData procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1157)
public class EnvCardLogDataReturned implements Serializable {
	public EnvCardLogDataReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The log data for the environmental card. This field is only present if the returnCode is RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The log data for the environmental card. This field is only present if the returnCode is RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private EnvCardLogData envCardLog;

	/** @return The log data for the environmental card. This field is only present if the returnCode is RETCODE_OK. */
	public EnvCardLogData getEnvCardLog() {
		return this.envCardLog;
	}
	/** @param x The log data for the environmental card. This field is only present if the returnCode is RETCODE_OK. */
	public void setEnvCardLog(EnvCardLogData x) {
		this.envCardLog = x;
	}
}
