package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type contains ESM attributes that are specific to the ESM's I/O interface type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1115)
public class EsmInterfaceAttributes implements Serializable {
	public EsmInterfaceAttributes() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType ioInterfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getIoInterfaceType() {
		return this.ioInterfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setIoInterfaceType(IOInterfaceType x) {
		this.ioInterfaceType = x;
	}

	/** This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs." , required = false)
	@XmlElement(required = false)
	private FibreEsmAttributes fibreEsmAttributes;

	/** @return This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs. */
	public FibreEsmAttributes getFibreEsmAttributes() {
		return this.fibreEsmAttributes;
	}
	/** @param x This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs. */
	public void setFibreEsmAttributes(FibreEsmAttributes x) {
		this.fibreEsmAttributes = x;
	}

	/** This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs." , required = false)
	@XmlElement(required = false)
	private SasEsmAttributes sasEsmAttributes;

	/** @return This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs. */
	public SasEsmAttributes getSasEsmAttributes() {
		return this.sasEsmAttributes;
	}
	/** @param x This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs. */
	public void setSasEsmAttributes(SasEsmAttributes x) {
		this.sasEsmAttributes = x;
	}
}
