package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is embedded in an IscsiInterface object and provides information about the physical hardware interface. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(696)
public class EthernetInterfaceData implements Serializable {
	public EthernetInterfaceData() {
	}

	/** Vendor-supplied about the physical part. */
	@io.swagger.annotations.ApiModelProperty(value ="Vendor-supplied about the physical part." , required = true)
	@XmlElement(required = true)
	private VendorPartData partData;

	/** @return Vendor-supplied about the physical part. */
	public VendorPartData getPartData() {
		return this.partData;
	}
	/** @param x Vendor-supplied about the physical part. */
	public void setPartData(VendorPartData x) {
		this.partData = x;
	}

	/** The Ethernet MAC address associated with the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The Ethernet MAC address associated with the interface." , required = true)
	@XmlElement(required = true)
	private String macAddress;

	/** @return The Ethernet MAC address associated with the interface. */
	public String getMacAddress() {
		return this.macAddress;
	}
	/** @param x The Ethernet MAC address associated with the interface. */
	public void setMacAddress(String x) {
		this.macAddress = x;
	}

	/** If set to true, the interface is operating in full duplex mode; otherwise, it is operating in half-duplex mode. */
	@io.swagger.annotations.ApiModelProperty(value ="If set to true, the interface is operating in full duplex mode; otherwise, it is operating in half-duplex mode." , required = true)
	@XmlElement(required = true)
	private boolean fullDuplex;

	/** @return If set to true, the interface is operating in full duplex mode; otherwise, it is operating in half-duplex mode. */
	public boolean isFullDuplex() {
		return this.fullDuplex;
	}
	/** @param x If set to true, the interface is operating in full duplex mode; otherwise, it is operating in half-duplex mode. */
	public void setFullDuplex(boolean x) {
		this.fullDuplex = x;
	}

	/** The maximum size of the payload section in an Ethernet frame. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum size of the payload section in an Ethernet frame." , required = true)
	@XmlElement(required = true)
	private int maximumFramePayloadSize;

	/** @return The maximum size of the payload section in an Ethernet frame. */
	public int getMaximumFramePayloadSize() {
		return this.maximumFramePayloadSize;
	}
	/** @param x The maximum size of the payload section in an Ethernet frame. */
	public void setMaximumFramePayloadSize(int x) {
		this.maximumFramePayloadSize = x;
	}

	/** The speed of the interface, as currently configured. */
	@io.swagger.annotations.ApiModelProperty(value ="The speed of the interface, as currently configured." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed currentInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The speed of the interface, as currently configured. */
	public InterfaceSpeed getCurrentInterfaceSpeed() {
		return this.currentInterfaceSpeed;
	}
	/** @param x The speed of the interface, as currently configured. */
	public void setCurrentInterfaceSpeed(InterfaceSpeed x) {
		this.currentInterfaceSpeed = x;
	}

	/** The maximum speed supported by the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum speed supported by the interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed maximumInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The maximum speed supported by the interface. */
	public InterfaceSpeed getMaximumInterfaceSpeed() {
		return this.maximumInterfaceSpeed;
	}
	/** @param x The maximum speed supported by the interface. */
	public void setMaximumInterfaceSpeed(InterfaceSpeed x) {
		this.maximumInterfaceSpeed = x;
	}

	/** The status of the network link for this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the network link for this interface." , required = true)
	@XmlElement(required = true)
	private LinkStatus linkStatus = LinkStatus.__UNDEFINED;

	/** @return The status of the network link for this interface. */
	public LinkStatus getLinkStatus() {
		return this.linkStatus;
	}
	/** @param x The status of the network link for this interface. */
	public void setLinkStatus(LinkStatus x) {
		this.linkStatus = x;
	}

	/** A list of speeds supported by the Ethernet interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of speeds supported by the Ethernet interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed[] supportedInterfaceSpeeds;

	/** @return A list of speeds supported by the Ethernet interface. */
	public InterfaceSpeed[] getSupportedInterfaceSpeeds() {
		return this.supportedInterfaceSpeeds;
	}
	/** @param x A list of speeds supported by the Ethernet interface. */
	public void setSupportedInterfaceSpeeds(InterfaceSpeed[] x) {
		this.supportedInterfaceSpeeds = x;
	}

	/** If set to true, autoconfiguration is supported. */
	@io.swagger.annotations.ApiModelProperty(value ="If set to true, autoconfiguration is supported." , required = true)
	@XmlElement(required = true)
	private boolean autoconfigSupport;

	/** @return If set to true, autoconfiguration is supported. */
	public boolean isAutoconfigSupport() {
		return this.autoconfigSupport;
	}
	/** @param x If set to true, autoconfiguration is supported. */
	public void setAutoconfigSupport(boolean x) {
		this.autoconfigSupport = x;
	}

	/** If true, support is provided for copper cable diagnostics. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, support is provided for copper cable diagnostics." , required = true)
	@XmlElement(required = true)
	private boolean copperCableDiagnosticsSupport;

	/** @return If true, support is provided for copper cable diagnostics. */
	public boolean isCopperCableDiagnosticsSupport() {
		return this.copperCableDiagnosticsSupport;
	}
	/** @param x If true, support is provided for copper cable diagnostics. */
	public void setCopperCableDiagnosticsSupport(boolean x) {
		this.copperCableDiagnosticsSupport = x;
	}
}
