package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey network configuration parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(506)
public class EthernetParamsUpdateDescriptor implements Serializable {
	public EthernetParamsUpdateDescriptor() {
	}

	/** The intended target of this command. */
	@io.swagger.annotations.ApiModelProperty(value ="The intended target of this command." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The intended target of this command. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The intended target of this command. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** Name of Ethernet port, as reported by bootWare. */
	@io.swagger.annotations.ApiModelProperty(value ="Name of Ethernet port, as reported by bootWare." , required = true)
	@XmlElement(required = true)
	private String interfaceName;

	/** @return Name of Ethernet port, as reported by bootWare. */
	public String getInterfaceName() {
		return this.interfaceName;
	}
	/** @param x Name of Ethernet port, as reported by bootWare. */
	public void setInterfaceName(String x) {
		this.interfaceName = x;
	}

	/** The channel number of this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number of this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number of this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number of this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** IP address of the controller. 0 - use bootp. */
	@io.swagger.annotations.ApiModelProperty(value ="IP address of the controller. 0 - use bootp." , required = true)
	@XmlElement(required = true)
	private int ip;

	/** @return IP address of the controller. 0 - use bootp. */
	public int getIp() {
		return this.ip;
	}
	/** @param x IP address of the controller. 0 - use bootp. */
	public void setIp(int x) {
		this.ip = x;
	}

	/** IP address of the gateway. */
	@io.swagger.annotations.ApiModelProperty(value ="IP address of the gateway." , required = true)
	@XmlElement(required = true)
	private int gatewayIp;

	/** @return IP address of the gateway. */
	public int getGatewayIp() {
		return this.gatewayIp;
	}
	/** @param x IP address of the gateway. */
	public void setGatewayIp(int x) {
		this.gatewayIp = x;
	}

	/** Network subnet mask. */
	@io.swagger.annotations.ApiModelProperty(value ="Network subnet mask." , required = true)
	@XmlElement(required = true)
	private int subnetMask;

	/** @return Network subnet mask. */
	public int getSubnetMask() {
		return this.subnetMask;
	}
	/** @param x Network subnet mask. */
	public void setSubnetMask(int x) {
		this.subnetMask = x;
	}
}
