package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report Ethernet port statistics. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(569)
public class EthernetPortStatistics implements Serializable {
	public EthernetPortStatistics() {
	}

	/** The interface(s) for which the statistics apply. In some cases, the statistics may be aggregated across multiple interfaces. Even though this is shown as an array, it will only be a single instance. */
	@io.swagger.annotations.ApiModelProperty(value ="The interface(s) for which the statistics apply. In some cases, the statistics may be aggregated across multiple interfaces. Even though this is shown as an array, it will only be a single instance." , required = true)
	@XmlElement(required = true)
	private String[] interfaces;

	/** @return The interface(s) for which the statistics apply. In some cases, the statistics may be aggregated across multiple interfaces. Even though this is shown as an array, it will only be a single instance. */
	public String[] getInterfaces() {
		return this.interfaces;
	}
	/** @param x The interface(s) for which the statistics apply. In some cases, the statistics may be aggregated across multiple interfaces. Even though this is shown as an array, it will only be a single instance. */
	public void setInterfaces(String[] x) {
		this.interfaces = x;
	}

	/** The total number of bytes transmitted. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes transmitted." , required = true)
	@XmlElement(required = true)
	private long bytesTransmitted;

	/** @return The total number of bytes transmitted. */
	public long getBytesTransmitted() {
		return this.bytesTransmitted;
	}
	/** @param x The total number of bytes transmitted. */
	public void setBytesTransmitted(long x) {
		this.bytesTransmitted = x;
	}

	/** The total number of bytes received. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes received." , required = true)
	@XmlElement(required = true)
	private long bytesReceived;

	/** @return The total number of bytes received. */
	public long getBytesReceived() {
		return this.bytesReceived;
	}
	/** @param x The total number of bytes received. */
	public void setBytesReceived(long x) {
		this.bytesReceived = x;
	}

	/** Total number of packets transmitted. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of packets transmitted." , required = true)
	@XmlElement(required = true)
	private long packetsTransmitted;

	/** @return Total number of packets transmitted. */
	public long getPacketsTransmitted() {
		return this.packetsTransmitted;
	}
	/** @param x Total number of packets transmitted. */
	public void setPacketsTransmitted(long x) {
		this.packetsTransmitted = x;
	}

	/** Total number of packets received. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of packets received." , required = true)
	@XmlElement(required = true)
	private long packetsReceived;

	/** @return Total number of packets received. */
	public long getPacketsReceived() {
		return this.packetsReceived;
	}
	/** @param x Total number of packets received. */
	public void setPacketsReceived(long x) {
		this.packetsReceived = x;
	}

	/** The number of times the carrier sense condition was lost or never asserted when attempting to transmit a frame. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times the carrier sense condition was lost or never asserted when attempting to transmit a frame." , required = true)
	@XmlElement(required = true)
	private long carrierSenseErrors;

	/** @return The number of times the carrier sense condition was lost or never asserted when attempting to transmit a frame. */
	public long getCarrierSenseErrors() {
		return this.carrierSenseErrors;
	}
	/** @param x The number of times the carrier sense condition was lost or never asserted when attempting to transmit a frame. */
	public void setCarrierSenseErrors(long x) {
		this.carrierSenseErrors = x;
	}

	/** The number of successfully-transmitted frames for which transmission is inhibited by a single collision. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of successfully-transmitted frames for which transmission is inhibited by a single collision." , required = true)
	@XmlElement(required = true)
	private long singleCollisionFrames;

	/** @return The number of successfully-transmitted frames for which transmission is inhibited by a single collision. */
	public long getSingleCollisionFrames() {
		return this.singleCollisionFrames;
	}
	/** @param x The number of successfully-transmitted frames for which transmission is inhibited by a single collision. */
	public void setSingleCollisionFrames(long x) {
		this.singleCollisionFrames = x;
	}

	/** The number of successfully-transmitted frames for which transmission is inhibited by multiple collisions. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of successfully-transmitted frames for which transmission is inhibited by multiple collisions." , required = true)
	@XmlElement(required = true)
	private long multipleCollisionFrames;

	/** @return The number of successfully-transmitted frames for which transmission is inhibited by multiple collisions. */
	public long getMultipleCollisionFrames() {
		return this.multipleCollisionFrames;
	}
	/** @param x The number of successfully-transmitted frames for which transmission is inhibited by multiple collisions. */
	public void setMultipleCollisionFrames(long x) {
		this.multipleCollisionFrames = x;
	}

	/** The number of times a collision is detected later than 512 bit-times into the transmission of a packet. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times a collision is detected later than 512 bit-times into the transmission of a packet." , required = true)
	@XmlElement(required = true)
	private long lateCollisions;

	/** @return The number of times a collision is detected later than 512 bit-times into the transmission of a packet. */
	public long getLateCollisions() {
		return this.lateCollisions;
	}
	/** @param x The number of times a collision is detected later than 512 bit-times into the transmission of a packet. */
	public void setLateCollisions(long x) {
		this.lateCollisions = x;
	}

	/** The number of frames for which the first transmission attempt is delayed because the medium is busy. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames for which the first transmission attempt is delayed because the medium is busy." , required = true)
	@XmlElement(required = true)
	private long deferredTransmissions;

	/** @return The number of frames for which the first transmission attempt is delayed because the medium is busy. */
	public long getDeferredTransmissions() {
		return this.deferredTransmissions;
	}
	/** @param x The number of frames for which the first transmission attempt is delayed because the medium is busy. */
	public void setDeferredTransmissions(long x) {
		this.deferredTransmissions = x;
	}

	/** The number of received frames that exceed the maximum permitted frame size. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of received frames that exceed the maximum permitted frame size." , required = true)
	@XmlElement(required = true)
	private long frameTooLongs;

	/** @return The number of received frames that exceed the maximum permitted frame size. */
	public long getFrameTooLongs() {
		return this.frameTooLongs;
	}
	/** @param x The number of received frames that exceed the maximum permitted frame size. */
	public void setFrameTooLongs(long x) {
		this.frameTooLongs = x;
	}

	/** The number of multicast frames transmitted over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of multicast frames transmitted over the interface." , required = true)
	@XmlElement(required = true)
	private long txMulticastFrameCount;

	/** @return The number of multicast frames transmitted over the interface. */
	public long getTxMulticastFrameCount() {
		return this.txMulticastFrameCount;
	}
	/** @param x The number of multicast frames transmitted over the interface. */
	public void setTxMulticastFrameCount(long x) {
		this.txMulticastFrameCount = x;
	}

	/** The number of broadcast frames transmitted over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of broadcast frames transmitted over the interface." , required = true)
	@XmlElement(required = true)
	private long txBroadcastFrameCount;

	/** @return The number of broadcast frames transmitted over the interface. */
	public long getTxBroadcastFrameCount() {
		return this.txBroadcastFrameCount;
	}
	/** @param x The number of broadcast frames transmitted over the interface. */
	public void setTxBroadcastFrameCount(long x) {
		this.txBroadcastFrameCount = x;
	}

	/** The number of pause frames transmitted over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of pause frames transmitted over the interface." , required = true)
	@XmlElement(required = true)
	private long txPauseFrameCount;

	/** @return The number of pause frames transmitted over the interface. */
	public long getTxPauseFrameCount() {
		return this.txPauseFrameCount;
	}
	/** @param x The number of pause frames transmitted over the interface. */
	public void setTxPauseFrameCount(long x) {
		this.txPauseFrameCount = x;
	}

	/** The number of control frames transmitted over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of control frames transmitted over the interface." , required = true)
	@XmlElement(required = true)
	private long txControlFrameCount;

	/** @return The number of control frames transmitted over the interface. */
	public long getTxControlFrameCount() {
		return this.txControlFrameCount;
	}
	/** @param x The number of control frames transmitted over the interface. */
	public void setTxControlFrameCount(long x) {
		this.txControlFrameCount = x;
	}

	/** The number of frames which experienced deferred transmission for an excessive period of time. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames which experienced deferred transmission for an excessive period of time." , required = true)
	@XmlElement(required = true)
	private long txFrameExcessDeferralCount;

	/** @return The number of frames which experienced deferred transmission for an excessive period of time. */
	public long getTxFrameExcessDeferralCount() {
		return this.txFrameExcessDeferralCount;
	}
	/** @param x The number of frames which experienced deferred transmission for an excessive period of time. */
	public void setTxFrameExcessDeferralCount(long x) {
		this.txFrameExcessDeferralCount = x;
	}

	/** The number of aborts that occurred while transmitting. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of aborts that occurred while transmitting." , required = true)
	@XmlElement(required = true)
	private long txFrameAbortCount;

	/** @return The number of aborts that occurred while transmitting. */
	public long getTxFrameAbortCount() {
		return this.txFrameAbortCount;
	}
	/** @param x The number of aborts that occurred while transmitting. */
	public void setTxFrameAbortCount(long x) {
		this.txFrameAbortCount = x;
	}

	/** The number of frames that could not be sent due to a single or multiple collisions. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames that could not be sent due to a single or multiple collisions." , required = true)
	@XmlElement(required = true)
	private long txFrameCollisionCount;

	/** @return The number of frames that could not be sent due to a single or multiple collisions. */
	public long getTxFrameCollisionCount() {
		return this.txFrameCollisionCount;
	}
	/** @param x The number of frames that could not be sent due to a single or multiple collisions. */
	public void setTxFrameCollisionCount(long x) {
		this.txFrameCollisionCount = x;
	}

	/** The number of frames that were dropped because the transmit FIFO was full. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames that were dropped because the transmit FIFO was full." , required = true)
	@XmlElement(required = true)
	private long txFrameDroppedCount;

	/** @return The number of frames that were dropped because the transmit FIFO was full. */
	public long getTxFrameDroppedCount() {
		return this.txFrameDroppedCount;
	}
	/** @param x The number of frames that were dropped because the transmit FIFO was full. */
	public void setTxFrameDroppedCount(long x) {
		this.txFrameDroppedCount = x;
	}

	/** The number of jumbo frames transmitted over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of jumbo frames transmitted over the interface." , required = true)
	@XmlElement(required = true)
	private long txJumboFrameCount;

	/** @return The number of jumbo frames transmitted over the interface. */
	public long getTxJumboFrameCount() {
		return this.txJumboFrameCount;
	}
	/** @param x The number of jumbo frames transmitted over the interface. */
	public void setTxJumboFrameCount(long x) {
		this.txJumboFrameCount = x;
	}

	/** The number of control frames received with unknown op codes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of control frames received with unknown op codes." , required = true)
	@XmlElement(required = true)
	private long rxUnknownControlFrameCount;

	/** @return The number of control frames received with unknown op codes. */
	public long getRxUnknownControlFrameCount() {
		return this.rxUnknownControlFrameCount;
	}
	/** @param x The number of control frames received with unknown op codes. */
	public void setRxUnknownControlFrameCount(long x) {
		this.rxUnknownControlFrameCount = x;
	}

	/** The number of pause frames received over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of pause frames received over the interface." , required = true)
	@XmlElement(required = true)
	private long rxPauseFrameCount;

	/** @return The number of pause frames received over the interface. */
	public long getRxPauseFrameCount() {
		return this.rxPauseFrameCount;
	}
	/** @param x The number of pause frames received over the interface. */
	public void setRxPauseFrameCount(long x) {
		this.rxPauseFrameCount = x;
	}

	/** The number of control frames received over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of control frames received over the interface." , required = true)
	@XmlElement(required = true)
	private long rxControlFrameCount;

	/** @return The number of control frames received over the interface. */
	public long getRxControlFrameCount() {
		return this.rxControlFrameCount;
	}
	/** @param x The number of control frames received over the interface. */
	public void setRxControlFrameCount(long x) {
		this.rxControlFrameCount = x;
	}

	/** The number of frames received with 802.3 frame length errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames received with 802.3 frame length errors." , required = true)
	@XmlElement(required = true)
	private long rxFrameLengthErrorCount;

	/** @return The number of frames received with 802.3 frame length errors. */
	public long getRxFrameLengthErrorCount() {
		return this.rxFrameLengthErrorCount;
	}
	/** @param x The number of frames received with 802.3 frame length errors. */
	public void setRxFrameLengthErrorCount(long x) {
		this.rxFrameLengthErrorCount = x;
	}

	/** The number of jabber errors detected. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of jabber errors detected." , required = true)
	@XmlElement(required = true)
	private long rxJabberCount;

	/** @return The number of jabber errors detected. */
	public long getRxJabberCount() {
		return this.rxJabberCount;
	}
	/** @param x The number of jabber errors detected. */
	public void setRxJabberCount(long x) {
		this.rxJabberCount = x;
	}

	/** Received frames that were dropped. */
	@io.swagger.annotations.ApiModelProperty(value ="Received frames that were dropped." , required = true)
	@XmlElement(required = true)
	private long rxFrameDropedCount;

	/** @return Received frames that were dropped. */
	public long getRxFrameDropedCount() {
		return this.rxFrameDropedCount;
	}
	/** @param x Received frames that were dropped. */
	public void setRxFrameDropedCount(long x) {
		this.rxFrameDropedCount = x;
	}

	/** The number of frames received and discarded with a CRC error. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames received and discarded with a CRC error." , required = true)
	@XmlElement(required = true)
	private long rxFrameCrcErrorCount;

	/** @return The number of frames received and discarded with a CRC error. */
	public long getRxFrameCrcErrorCount() {
		return this.rxFrameCrcErrorCount;
	}
	/** @param x The number of frames received and discarded with a CRC error. */
	public void setRxFrameCrcErrorCount(long x) {
		this.rxFrameCrcErrorCount = x;
	}

	/** The number of frames received with encoding errors. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames received with encoding errors." , required = true)
	@XmlElement(required = true)
	private long rxFrameEncodingErrorCount;

	/** @return The number of frames received with encoding errors. */
	public long getRxFrameEncodingErrorCount() {
		return this.rxFrameEncodingErrorCount;
	}
	/** @param x The number of frames received with encoding errors. */
	public void setRxFrameEncodingErrorCount(long x) {
		this.rxFrameEncodingErrorCount = x;
	}

	/** The number of frames received that are smaller than the minimum size allowed (64 bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The number of frames received that are smaller than the minimum size allowed (64 bytes)." , required = true)
	@XmlElement(required = true)
	private long rxSmallFrameErrorCount;

	/** @return The number of frames received that are smaller than the minimum size allowed (64 bytes). */
	public long getRxSmallFrameErrorCount() {
		return this.rxSmallFrameErrorCount;
	}
	/** @param x The number of frames received that are smaller than the minimum size allowed (64 bytes). */
	public void setRxSmallFrameErrorCount(long x) {
		this.rxSmallFrameErrorCount = x;
	}

	/** The number of multicast frames received over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of multicast frames received over the interface." , required = true)
	@XmlElement(required = true)
	private long rxMulticastFrameCount;

	/** @return The number of multicast frames received over the interface. */
	public long getRxMulticastFrameCount() {
		return this.rxMulticastFrameCount;
	}
	/** @param x The number of multicast frames received over the interface. */
	public void setRxMulticastFrameCount(long x) {
		this.rxMulticastFrameCount = x;
	}

	/** The number of broadcast frames received over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of broadcast frames received over the interface." , required = true)
	@XmlElement(required = true)
	private long rxBroadcastFrameCount;

	/** @return The number of broadcast frames received over the interface. */
	public long getRxBroadcastFrameCount() {
		return this.rxBroadcastFrameCount;
	}
	/** @param x The number of broadcast frames received over the interface. */
	public void setRxBroadcastFrameCount(long x) {
		this.rxBroadcastFrameCount = x;
	}
}
