package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Identifies the possible speed settings that can be configured for an Ethernet management port. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(100)
public enum EthernetSpeedSetting implements Serializable {
		/** There is no speed setting for the port. */
		speedNone(0),
		/** port should auto-negotiate the speed and duplex mode */
		speedAutoNegotiated(1),
		/** Setting is 10 Mbps, half-duplex. */
		speed10MbitHalfDuplex(2),
		/** Setting is 10 Mbps, full-duplex. */
		speed10MbitFullDuplex(3),
		/** Setting is 100 Mbps, half-duplex. */
		speed100MbitHalfDuplex(4),
		/** Setting is 100 Mbps, full duplex. */
		speed100MbitFullDuplex(5),
		/** Setting is 1000 Mbps half-duplex */
		speed1000MbitHalfDuplex(6),
		/** Setting is 1000 Mbps full duplex */
		speed1000MbitFullDuplex(7),
		__UNDEFINED(464378545);

		public final int value;

		private EthernetSpeedSetting(int v) {
			this.value = v;
		}
}
