package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the different priority values that can be associated with entries in the Major Event Log. In addition, the supportedEventPriorities array in the FeatureParams structure will contain values from this enumeration identifying which MEL event priorities are supported on the storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(55)
public enum EventPriority implements Serializable {
		/** The event priority is default. */
		priorityDefault(-1),
		/** The priority is critical. */
		priorityCritical(0),
		/** The priority is informational. */
		priorityInfo(1),
		/** The event priority is emergency; the array is unusable. This value is unsupported by management software at present, and disallowed by the event data schema. */
		priorityEmergency(2),
		/** The event priority is alert; action must be taken immediately. This value is unsupported by management software at present, and disallowed by the event data schema. */
		priorityAlert(3),
		/** The event priority is error. This value is unsupported by management software at present, and disallowed by the event data schema. */
		priorityError(4),
		/** The event priority is warning. */
		priorityWarning(5),
		/** The event priority is notice; normal but significant. This value is unsupported by management software at present, and disallowed by the event data schema. */
		priorityNotice(6),
		/** The event priority is debug. */
		priorityDebug(7),
		__UNDEFINED(464378545);

		public final int value;

		private EventPriority(int v) {
			this.value = v;
		}
}
