package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used for return data produced by the getExportDependencies procedure. It describes a single volume-level export dependency, which is a relationship between the dependent volume and the array where it currently resides, that may affect the export-ability of the group containing the dependent volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1090)
public class ExportDependency implements Serializable {
	public ExportDependency() {
	}

	/** A reference to a dependent volume associated with the volume group of interest. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to a dependent volume associated with the volume group of interest." , required = true)
	@XmlElement(required = true)
	private String dependentVolume;

	/** @return A reference to a dependent volume associated with the volume group of interest. */
	public String getDependentVolume() {
		return this.dependentVolume;
	}
	/** @param x A reference to a dependent volume associated with the volume group of interest. */
	public void setDependentVolume(String x) {
		this.dependentVolume = x;
	}

	/** Export dependency information for the dependent volume. */
	@io.swagger.annotations.ApiModelProperty(value ="Export dependency information for the dependent volume." , required = true)
	@XmlElement(required = true)
	private ExportDependencyTypeData dependency;

	/** @return Export dependency information for the dependent volume. */
	public ExportDependencyTypeData getDependency() {
		return this.dependency;
	}
	/** @param x Export dependency information for the dependent volume. */
	public void setDependency(ExportDependencyTypeData x) {
		this.dependency = x;
	}

	/** Set to true if the dependency is portable. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the dependency is portable." , required = true)
	@XmlElement(required = true)
	private boolean isPortable;

	/** @return Set to true if the dependency is portable. */
	public boolean isIsPortable() {
		return this.isPortable;
	}
	/** @param x Set to true if the dependency is portable. */
	public void setIsPortable(boolean x) {
		this.isPortable = x;
	}
}
