package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object contains details about the nature of an export dependency. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1036)
public class ExportDependencyTypeData implements Serializable {
	public ExportDependencyTypeData() {
	}

	/** This enumeration specifies the types of dependencies that may be identified for a volume belonging to a group that is a candidate to be exported. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration specifies the types of dependencies that may be identified for a volume belonging to a group that is a candidate to be exported." , required = true)
	@XmlElement(required = true)
	private ExportDependencyType type = ExportDependencyType.__UNDEFINED;

	/** @return This enumeration specifies the types of dependencies that may be identified for a volume belonging to a group that is a candidate to be exported. */
	public ExportDependencyType getType() {
		return this.type;
	}
	/** @param x This enumeration specifies the types of dependencies that may be identified for a volume belonging to a group that is a candidate to be exported. */
	public void setType(ExportDependencyType x) {
		this.type = x;
	}

	/** The identification of a metadata volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_METADATA. */
	@io.swagger.annotations.ApiModelProperty(value ="The identification of a metadata volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_METADATA." , required = false)
	@XmlElement(required = false)
	private String metadataRef;

	/** @return The identification of a metadata volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_METADATA. */
	public String getMetadataRef() {
		return this.metadataRef;
	}
	/** @param x The identification of a metadata volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_METADATA. */
	public void setMetadataRef(String x) {
		this.metadataRef = x;
	}

	/** The identification of the mirror pair that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_MIRROR_PAIR. */
	@io.swagger.annotations.ApiModelProperty(value ="The identification of the mirror pair that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_MIRROR_PAIR." , required = false)
	@XmlElement(required = false)
	private String mirrorRef;

	/** @return The identification of the mirror pair that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_MIRROR_PAIR. */
	public String getMirrorRef() {
		return this.mirrorRef;
	}
	/** @param x The identification of the mirror pair that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_MIRROR_PAIR. */
	public void setMirrorRef(String x) {
		this.mirrorRef = x;
	}

	/** The identification of a snapshot volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_SNAPSHOT. */
	@io.swagger.annotations.ApiModelProperty(value ="The identification of a snapshot volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_SNAPSHOT." , required = false)
	@XmlElement(required = false)
	private String snapshotRef;

	/** @return The identification of a snapshot volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_SNAPSHOT. */
	public String getSnapshotRef() {
		return this.snapshotRef;
	}
	/** @param x The identification of a snapshot volume that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_SNAPSHOT. */
	public void setSnapshotRef(String x) {
		this.snapshotRef = x;
	}

	/** The identification of a volume copy relationship that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_VOLUME_COPY. */
	@io.swagger.annotations.ApiModelProperty(value ="The identification of a volume copy relationship that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_VOLUME_COPY." , required = false)
	@XmlElement(required = false)
	private String volcopyRef;

	/** @return The identification of a volume copy relationship that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_VOLUME_COPY. */
	public String getVolcopyRef() {
		return this.volcopyRef;
	}
	/** @param x The identification of a volume copy relationship that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_VOLUME_COPY. */
	public void setVolcopyRef(String x) {
		this.volcopyRef = x;
	}

	/** The identification of an Async Mirror Group member that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_ASYNC_MIRROR_GROUP_MEMBER. */
	@io.swagger.annotations.ApiModelProperty(value ="The identification of an Async Mirror Group member that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_ASYNC_MIRROR_GROUP_MEMBER." , required = false)
	@XmlElement(required = false)
	private String amgMember;

	/** @return The identification of an Async Mirror Group member that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_ASYNC_MIRROR_GROUP_MEMBER. */
	public String getAmgMember() {
		return this.amgMember;
	}
	/** @param x The identification of an Async Mirror Group member that is associated with the dependent volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_ASYNC_MIRROR_GROUP_MEMBER. */
	public void setAmgMember(String x) {
		this.amgMember = x;
	}

	/** This field contains an identification of the Concat Volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_CONCAT_MEMBER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains an identification of the Concat Volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_CONCAT_MEMBER." , required = false)
	@XmlElement(required = false)
	private String concatVol;

	/** @return This field contains an identification of the Concat Volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_CONCAT_MEMBER. */
	public String getConcatVol() {
		return this.concatVol;
	}
	/** @param x This field contains an identification of the Concat Volume. This field is only present if the type field is set to EXPORT_DEPENDENCY_CONCAT_MEMBER. */
	public void setConcatVol(String x) {
		this.concatVol = x;
	}

	/** This field contains an identification of the PiT Group. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_GROUP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains an identification of the PiT Group. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_GROUP." , required = false)
	@XmlElement(required = false)
	private String pitGroup;

	/** @return This field contains an identification of the PiT Group. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_GROUP. */
	public String getPitGroup() {
		return this.pitGroup;
	}
	/** @param x This field contains an identification of the PiT Group. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_GROUP. */
	public void setPitGroup(String x) {
		this.pitGroup = x;
	}

	/** This field contains an identification of the PiT View. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_VIEW. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains an identification of the PiT View. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_VIEW." , required = false)
	@XmlElement(required = false)
	private String pitView;

	/** @return This field contains an identification of the PiT View. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_VIEW. */
	public String getPitView() {
		return this.pitView;
	}
	/** @param x This field contains an identification of the PiT View. This field is only present if the type field is set to EXPORT_DEPENDENCY_PIT_VIEW. */
	public void setPitView(String x) {
		this.pitView = x;
	}
}
