package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data specifies the location of a component that is referenced within a MEL entry. When the extLocType field in the MEL entry is not equal to EXT_COMP_LOCTYPE_UNKNOWN, it supersedes the standard ComponentLocation field to provide more detail. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(664)
public class ExtendedComponentLocation implements Serializable {
	public ExtendedComponentLocation() {
	}

	/** This enumeration object contains a list of all possible extended component location types that can be returned in a MEL entry. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object contains a list of all possible extended component location types that can be returned in a MEL entry." , required = true)
	@XmlElement(required = true)
	private ExtendedComponentLocationType extLocType = ExtendedComponentLocationType.__UNDEFINED;

	/** @return This enumeration object contains a list of all possible extended component location types that can be returned in a MEL entry. */
	public ExtendedComponentLocationType getExtLocType() {
		return this.extLocType;
	}
	/** @param x This enumeration object contains a list of all possible extended component location types that can be returned in a MEL entry. */
	public void setExtLocType(ExtendedComponentLocationType x) {
		this.extLocType = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_CHANNEL. This field is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_CHANNEL. This field is deprecated." , required = false)
	@XmlElement(required = false)
	private ChannelLocation compChannelLoc;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_CHANNEL. This field is deprecated. */
	public ChannelLocation getCompChannelLoc() {
		return this.compChannelLoc;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_CHANNEL. This field is deprecated. */
	public void setCompChannelLoc(ChannelLocation x) {
		this.compChannelLoc = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_MINIHUB. This field is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_MINIHUB. This field is deprecated." , required = false)
	@XmlElement(required = false)
	private MinihubLocation compMinihubLoc;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_MINIHUB. This field is deprecated. */
	public MinihubLocation getCompMinihubLoc() {
		return this.compMinihubLoc;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_MINIHUB. This field is deprecated. */
	public void setCompMinihubLoc(MinihubLocation x) {
		this.compMinihubLoc = x;
	}

	/** This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAY */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAY" , required = false)
	@XmlElement(required = false)
	private int compTray;

	/** @return This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAY */
	public int getCompTray() {
		return this.compTray;
	}
	/** @param x This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAY */
	public void setCompTray(int x) {
		this.compTray = x;
	}

	/** This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAYSLOT */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAYSLOT" , required = false)
	@XmlElement(required = false)
	private TraySlot compTraySlot;

	/** @return This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAYSLOT */
	public TraySlot getCompTraySlot() {
		return this.compTraySlot;
	}
	/** @param x This field is present only if the extLocType value is EXT_COMP_LOCTYPE_TRAYSLOT */
	public void setCompTraySlot(TraySlot x) {
		this.compTraySlot = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME. This field is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME. This field is deprecated." , required = false)
	@XmlElement(required = false)
	private String compLabel;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME. This field is deprecated. */
	public String getCompLabel() {
		return this.compLabel;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME. This field is deprecated. */
	public void setCompLabel(String x) {
		this.compLabel = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_PIT. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_PIT." , required = false)
	@XmlElement(required = false)
	private long pitSequence;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_PIT. */
	public long getPitSequence() {
		return this.pitSequence;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_PIT. */
	public void setPitSequence(long x) {
		this.pitSequence = x;
	}

	/** SYMbolRef of the component or channelPort */
	@io.swagger.annotations.ApiModelProperty(value ="SYMbolRef of the component or channelPort" , required = false)
	@XmlElement(required = false)
	private String compReference;

	/** @return SYMbolRef of the component or channelPort */
	public String getCompReference() {
		return this.compReference;
	}
	/** @param x SYMbolRef of the component or channelPort */
	public void setCompReference(String x) {
		this.compReference = x;
	}

	/** Controller Reference */
	@io.swagger.annotations.ApiModelProperty(value ="Controller Reference" , required = false)
	@XmlElement(required = false)
	private String controllerReference;

	/** @return Controller Reference */
	public String getControllerReference() {
		return this.controllerReference;
	}
	/** @param x Controller Reference */
	public void setControllerReference(String x) {
		this.controllerReference = x;
	}

	/** Label associated with the physical location of the component or port. */
	@io.swagger.annotations.ApiModelProperty(value ="Label associated with the physical location of the component or port." , required = false)
	@XmlElement(required = false)
	private String locationLabel;

	/** @return Label associated with the physical location of the component or port. */
	public String getLocationLabel() {
		return this.locationLabel;
	}
	/** @param x Label associated with the physical location of the component or port. */
	public void setLocationLabel(String x) {
		this.locationLabel = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME_GRP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME_GRP." , required = false)
	@XmlElement(required = false)
	private String volumeGroupLabel;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME_GRP. */
	public String getVolumeGroupLabel() {
		return this.volumeGroupLabel;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_VOLUME_GRP. */
	public void setVolumeGroupLabel(String x) {
		this.volumeGroupLabel = x;
	}

	/** This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_DISK_POOL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_DISK_POOL." , required = false)
	@XmlElement(required = false)
	private String diskPoolLabel;

	/** @return This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_DISK_POOL. */
	public String getDiskPoolLabel() {
		return this.diskPoolLabel;
	}
	/** @param x This field is present only if the ExtendedComponentLocationType value is EXT_COMP_LOCTYPE_DISK_POOL. */
	public void setDiskPoolLabel(String x) {
		this.diskPoolLabel = x;
	}
}
