package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Specifies the external key management server endpoint information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(861)
public class ExternalKMSEndpoint implements Serializable {
	public ExternalKMSEndpoint() {
	}

	/** The IP or domain address of the key management server */
	@io.swagger.annotations.ApiModelProperty(value ="The IP or domain address of the key management server" , required = true)
	@XmlElement(required = true)
	private NetworkAddress kmsAddress;

	/** @return The IP or domain address of the key management server */
	public NetworkAddress getKmsAddress() {
		return this.kmsAddress;
	}
	/** @param x The IP or domain address of the key management server */
	public void setKmsAddress(NetworkAddress x) {
		this.kmsAddress = x;
	}

	/** The port number to be used for communicating KMIP requests with the key management server. */
	@io.swagger.annotations.ApiModelProperty(value ="The port number to be used for communicating KMIP requests with the key management server." , required = true)
	@XmlElement(required = true)
	private int kmsPort;

	/** @return The port number to be used for communicating KMIP requests with the key management server. */
	public int getKmsPort() {
		return this.kmsPort;
	}
	/** @param x The port number to be used for communicating KMIP requests with the key management server. */
	public void setKmsPort(int x) {
		this.kmsPort = x;
	}
}
