package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains two pieces of information about the version factory default settings: (1) an indication of whether or not factory default version management is supported, and (2) the actual version of the factory default settings */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(462)
public class FactoryDefaultsVersionData implements Serializable {
	public FactoryDefaultsVersionData() {
	}

	/** The factory default version string */
	@io.swagger.annotations.ApiModelProperty(value ="The factory default version string" , required = true)
	@XmlElement(required = true)
	private String factoryDefaultsVersion;

	/** @return The factory default version string */
	public String getFactoryDefaultsVersion() {
		return this.factoryDefaultsVersion;
	}
	/** @param x The factory default version string */
	public void setFactoryDefaultsVersion(String x) {
		this.factoryDefaultsVersion = x;
	}

	/** This field is set to true when version reporting is supported and factory default settings may be downloaded; otherwise it is set to false. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to true when version reporting is supported and factory default settings may be downloaded; otherwise it is set to false." , required = true)
	@XmlElement(required = true)
	private boolean isSupported;

	/** @return This field is set to true when version reporting is supported and factory default settings may be downloaded; otherwise it is set to false. */
	public boolean isIsSupported() {
		return this.isSupported;
	}
	/** @param x This field is set to true when version reporting is supported and factory default settings may be downloaded; otherwise it is set to false. */
	public void setIsSupported(boolean x) {
		this.isSupported = x;
	}
}
