package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the parameters that are provided by the client when starting FDI/DEMS Log retrieval. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(980)
public class FdiDemsLogRetrieveStartDetails implements Serializable {
	public FdiDemsLogRetrieveStartDetails() {
	}

	/** If true, all log entries will be retrieved and the value of oldestEntryTimestamp will be ignored. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, all log entries will be retrieved and the value of oldestEntryTimestamp will be ignored." , required = true)
	@XmlElement(required = true)
	private boolean allLogEntries;

	/** @return If true, all log entries will be retrieved and the value of oldestEntryTimestamp will be ignored. */
	public boolean isAllLogEntries() {
		return this.allLogEntries;
	}
	/** @param x If true, all log entries will be retrieved and the value of oldestEntryTimestamp will be ignored. */
	public void setAllLogEntries(boolean x) {
		this.allLogEntries = x;
	}

	/** If allLogEntries is false, log entries will be retrieved if their timestamp is equal to or more recent than this value (measured in seconds since midnight January 1, 1970). */
	@io.swagger.annotations.ApiModelProperty(value ="If allLogEntries is false, log entries will be retrieved if their timestamp is equal to or more recent than this value (measured in seconds since midnight January 1, 1970)." , required = true)
	@XmlElement(required = true)
	private long oldestEntryTimestamp;

	/** @return If allLogEntries is false, log entries will be retrieved if their timestamp is equal to or more recent than this value (measured in seconds since midnight January 1, 1970). */
	public long getOldestEntryTimestamp() {
		return this.oldestEntryTimestamp;
	}
	/** @param x If allLogEntries is false, log entries will be retrieved if their timestamp is equal to or more recent than this value (measured in seconds since midnight January 1, 1970). */
	public void setOldestEntryTimestamp(long x) {
		this.oldestEntryTimestamp = x;
	}

	/** If true, log entries will be retrieved for all drives and the values in driveRefs will be ignored. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, log entries will be retrieved for all drives and the values in driveRefs will be ignored." , required = true)
	@XmlElement(required = true)
	private boolean allDrives;

	/** @return If true, log entries will be retrieved for all drives and the values in driveRefs will be ignored. */
	public boolean isAllDrives() {
		return this.allDrives;
	}
	/** @param x If true, log entries will be retrieved for all drives and the values in driveRefs will be ignored. */
	public void setAllDrives(boolean x) {
		this.allDrives = x;
	}

	/** If allDrives is false, log entries will be retrieved only for the drives in this list. */
	@io.swagger.annotations.ApiModelProperty(value ="If allDrives is false, log entries will be retrieved only for the drives in this list." , required = true)
	@XmlElement(required = true)
	private DriveRefList driveRefs;

	/** @return If allDrives is false, log entries will be retrieved only for the drives in this list. */
	public DriveRefList getDriveRefs() {
		return this.driveRefs;
	}
	/** @param x If allDrives is false, log entries will be retrieved only for the drives in this list. */
	public void setDriveRefs(DriveRefList x) {
		this.driveRefs = x;
	}
}
