package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the defined feature attributes. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(272)
public enum FeatureAttrId implements Serializable {
		/** The feature attribute is "SHIPPED ENABLED," a boolean value which, when true, means the feature is available at the time the product is shipped. */
		shippedEnabled(1),
		/** The feature attribute is "SHIPPED LIMIT," an integer value which represents a numeric upper bound that is in force at the time the product is shipped. */
		shippedLimit(2),
		/** The feature attribute is "KEY_ENABLED," a boolean value which, when true, means that the feature is capable of being enabled or extended through application of a SAFE (Storage Array Feature Enablement) key. */
		keyEnabled(3),
		/** The feature attribute is "KEY LIMIT," an integer value which represents a numeric upper bound associated with a key-enabled feature. */
		keyLimit(4),
		/** The feature attribute is "SUPPORTED VALUES," a set of strings representing particular capabilities of the feature. */
		supportedValues(5),
		/** The feature attribute is "SUBJECT_TO_GOLD_KEY," a boolean value which, when true, means the "gold key" must be applied before the feature key can be used. */
		subjectToGoldKey(6),
		/** The feature attribute is "EVALUATION DURATION," an unsigned integer representing the evaluation period duration (in days). */
		evalDuration(7),
		__UNDEFINED(464378545);

		public final int value;

		private FeatureAttrId(int v) {
			this.value = v;
		}
}
