package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure represents a "feature bundle." A feature bundle is a collection of features and feature limits that are bound to the product at manufacturing time. A FeatureBundle is not to be confused with the FeatureParams structure. A FeatureBundle describes properties that are known at manufacturing time in terms of limits on current and potential functionality, whereas FeatureParams describes current enabled limits only. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(870)
public class FeatureBundle implements Serializable {
	public FeatureBundle() {
	}

	/** The name of the feature bundle. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the feature bundle." , required = true)
	@XmlElement(required = true)
	private String name;

	/** @return The name of the feature bundle. */
	public String getName() {
		return this.name;
	}
	/** @param x The name of the feature bundle. */
	public void setName(String x) {
		this.name = x;
	}

	/** A variable-length collection of BundledFeature instances, one for every feature comprising the bundle. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length collection of BundledFeature instances, one for every feature comprising the bundle." , required = true)
	@XmlElement(required = true)
	private BundledFeature[] bundledFeatures;

	/** @return A variable-length collection of BundledFeature instances, one for every feature comprising the bundle. */
	public BundledFeature[] getBundledFeatures() {
		return this.bundledFeatures;
	}
	/** @param x A variable-length collection of BundledFeature instances, one for every feature comprising the bundle. */
	public void setBundledFeatures(BundledFeature[] x) {
		this.bundledFeatures = x;
	}

	/** The submodel Identifier associated with the feature bundle. */
	@io.swagger.annotations.ApiModelProperty(value ="The submodel Identifier associated with the feature bundle." , required = true)
	@XmlElement(required = true)
	private String bundleSubmodelId;

	/** @return The submodel Identifier associated with the feature bundle. */
	public String getBundleSubmodelId() {
		return this.bundleSubmodelId;
	}
	/** @param x The submodel Identifier associated with the feature bundle. */
	public void setBundleSubmodelId(String x) {
		this.bundleSubmodelId = x;
	}
}
