package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration describes the various Fibre Channel remote mirror states. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(219)
public enum FibreChannelRemoteMirroringState implements Serializable {
		/** The Fibre Channel mirror state is unknown. */
		unknown(0),
		/** Fibre Channel remote mirroring is not enabled. */
		disabled(1),
		/** Fibre Channel remote mirroring enabled for legacy synchronous or legacy asynchronous RVM. */
		enabledLegacyRvm(2),
		/** Fibre Channel remote mirroring enabled for ARVM. */
		enabledArvm(3),
		/** Fibre Channel remote mirroring enabled for both ARVM and legacy RVM. */
		enabledAll(4),
		__UNDEFINED(464378545);

		public final int value;

		private FibreChannelRemoteMirroringState(int v) {
			this.value = v;
		}
}
