package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a drive's I/O address. It is used for Fibre Channel drive types only. Such drives are typically multi-ported, so there will be one of these address objects for each I/O port on the drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(591)
public class FibreDriveAddress implements Serializable {
	public FibreDriveAddress() {
	}

	/** The controller drive-side channel number used to access the drive via this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller drive-side channel number used to access the drive via this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The controller drive-side channel number used to access the drive via this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The controller drive-side channel number used to access the drive via this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The drive's Fibre Channel loop ID value on the given channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive's Fibre Channel loop ID value on the given channel." , required = true)
	@XmlElement(required = true)
	private int loopID;

	/** @return The drive's Fibre Channel loop ID value on the given channel. */
	public int getLoopID() {
		return this.loopID;
	}
	/** @param x The drive's Fibre Channel loop ID value on the given channel. */
	public void setLoopID(int x) {
		this.loopID = x;
	}
}
