package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure holds information about the ESM channel, channel port and loop ID. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(760)
public class FibreESMAddress implements Serializable {
	public FibreESMAddress() {
	}

	/** The esmPortRef identifies the drive port. */
	@io.swagger.annotations.ApiModelProperty(value ="The esmPortRef identifies the drive port." , required = true)
	@XmlElement(required = true)
	private String esmPortRef;

	/** @return The esmPortRef identifies the drive port. */
	public String getEsmPortRef() {
		return this.esmPortRef;
	}
	/** @param x The esmPortRef identifies the drive port. */
	public void setEsmPortRef(String x) {
		this.esmPortRef = x;
	}

	/** The loop ID of the ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="The loop ID of the ESM." , required = true)
	@XmlElement(required = true)
	private int loopID;

	/** @return The loop ID of the ESM. */
	public int getLoopID() {
		return this.loopID;
	}
	/** @param x The loop ID of the ESM. */
	public void setLoopID(int x) {
		this.loopID = x;
	}

	/** A reference to the controller drive side channel port associated with this ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller drive side channel port associated with this ESM." , required = true)
	@XmlElement(required = true)
	private String portRef;

	/** @return A reference to the controller drive side channel port associated with this ESM. */
	public String getPortRef() {
		return this.portRef;
	}
	/** @param x A reference to the controller drive side channel port associated with this ESM. */
	public void setPortRef(String x) {
		this.portRef = x;
	}
}
