package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about attributes that are specific to fibre channel ESMs */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(963)
public class FibreEsmAttributes implements Serializable {
	public FibreEsmAttributes() {
	}

	/** True if the fibre channel components use switched technology. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the fibre channel components use switched technology." , required = true)
	@XmlElement(required = true)
	private boolean isSwitched;

	/** @return True if the fibre channel components use switched technology. */
	public boolean isIsSwitched() {
		return this.isSwitched;
	}
	/** @param x True if the fibre channel components use switched technology. */
	public void setIsSwitched(boolean x) {
		this.isSwitched = x;
	}

	/** Addressing information for the fibre channel ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="Addressing information for the fibre channel ESM." , required = true)
	@XmlElement(required = true)
	private FibreESMAddress fibreEsmAddress;

	/** @return Addressing information for the fibre channel ESM. */
	public FibreESMAddress getFibreEsmAddress() {
		return this.fibreEsmAddress;
	}
	/** @param x Addressing information for the fibre channel ESM. */
	public void setFibreEsmAddress(FibreESMAddress x) {
		this.fibreEsmAddress = x;
	}
}
