package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a Fibre Channel I/O interface on a controller board. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(914)
public class FibreInterface implements Serializable,devmgr.api.model.Identifiable {
	public FibreInterface() {
	}

	/** The channel number of this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number of this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number of this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number of this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The FC loop ID value used by the controller on this channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The FC loop ID value used by the controller on this channel." , required = true)
	@XmlElement(required = true)
	private int loopID;

	/** @return The FC loop ID value used by the controller on this channel. */
	public int getLoopID() {
		return this.loopID;
	}
	/** @param x The FC loop ID value used by the controller on this channel. */
	public void setLoopID(int x) {
		this.loopID = x;
	}

	/** The speed of the interface in MB/sec. This field is deprecated. The field currentInterfaceSpeed should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="The speed of the interface in MB/sec. This field is deprecated. The field currentInterfaceSpeed should be used instead." , required = true)
	@XmlElement(required = true)
	private int speed;

	/** @return The speed of the interface in MB/sec. This field is deprecated. The field currentInterfaceSpeed should be used instead. */
	public int getSpeed() {
		return this.speed;
	}
	/** @param x The speed of the interface in MB/sec. This field is deprecated. The field currentInterfaceSpeed should be used instead. */
	public void setSpeed(int x) {
		this.speed = x;
	}

	/** The hard (preferred) address of the interface, in loop ID format. */
	@io.swagger.annotations.ApiModelProperty(value ="The hard (preferred) address of the interface, in loop ID format." , required = true)
	@XmlElement(required = true)
	private int hardAddress;

	/** @return The hard (preferred) address of the interface, in loop ID format. */
	public int getHardAddress() {
		return this.hardAddress;
	}
	/** @param x The hard (preferred) address of the interface, in loop ID format. */
	public void setHardAddress(int x) {
		this.hardAddress = x;
	}

	/** The unique identifier of the storage array node associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier of the storage array node associated with this interface." , required = true)
	@XmlElement(required = true)
	private String nodeName;

	/** @return The unique identifier of the storage array node associated with this interface. */
	public String getNodeName() {
		return this.nodeName;
	}
	/** @param x The unique identifier of the storage array node associated with this interface. */
	public void setNodeName(String x) {
		this.nodeName = x;
	}

	/** The unique identifier of the Fibre Channel port associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier of the Fibre Channel port associated with this interface." , required = true)
	@XmlElement(required = true)
	private String portName;

	/** @return The unique identifier of the Fibre Channel port associated with this interface. */
	public String getPortName() {
		return this.portName;
	}
	/** @param x The unique identifier of the Fibre Channel port associated with this interface. */
	public void setPortName(String x) {
		this.portName = x;
	}

	/** The NL_Port identifier assigned to this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The NL_Port identifier assigned to this interface." , required = true)
	@XmlElement(required = true)
	private String portId;

	/** @return The NL_Port identifier assigned to this interface. */
	public String getPortId() {
		return this.portId;
	}
	/** @param x The NL_Port identifier assigned to this interface. */
	public void setPortId(String x) {
		this.portId = x;
	}

	/** The Fibre Channel topology type being used. */
	@io.swagger.annotations.ApiModelProperty(value ="The Fibre Channel topology type being used." , required = true)
	@XmlElement(required = true)
	private FibreTopologyType topology = FibreTopologyType.__UNDEFINED;

	/** @return The Fibre Channel topology type being used. */
	public FibreTopologyType getTopology() {
		return this.topology;
	}
	/** @param x The Fibre Channel topology type being used. */
	public void setTopology(FibreTopologyType x) {
		this.topology = x;
	}

	/** An ASCII text string that describes the Fibre Channel controller chip type. */
	@io.swagger.annotations.ApiModelProperty(value ="An ASCII text string that describes the Fibre Channel controller chip type." , required = true)
	@XmlElement(required = true)
	private String part;

	/** @return An ASCII text string that describes the Fibre Channel controller chip type. */
	public String getPart() {
		return this.part;
	}
	/** @param x An ASCII text string that describes the Fibre Channel controller chip type. */
	public void setPart(String x) {
		this.part = x;
	}

	/** The revision level of the Fibre Channel controller chip. */
	@io.swagger.annotations.ApiModelProperty(value ="The revision level of the Fibre Channel controller chip." , required = true)
	@XmlElement(required = true)
	private int revision;

	/** @return The revision level of the Fibre Channel controller chip. */
	public int getRevision() {
		return this.revision;
	}
	/** @param x The revision level of the Fibre Channel controller chip. */
	public void setRevision(int x) {
		this.revision = x;
	}

	/** True, if this channel is joined with another one. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if this channel is joined with another one." , required = true)
	@XmlElement(required = true)
	private boolean chanMiswire;

	/** @return True, if this channel is joined with another one. */
	public boolean isChanMiswire() {
		return this.chanMiswire;
	}
	/** @param x True, if this channel is joined with another one. */
	public void setChanMiswire(boolean x) {
		this.chanMiswire = x;
	}

	/** True, if an ESM miswire condition exists somewhere on this channel. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if an ESM miswire condition exists somewhere on this channel." , required = true)
	@XmlElement(required = true)
	private boolean esmMiswire;

	/** @return True, if an ESM miswire condition exists somewhere on this channel. */
	public boolean isEsmMiswire() {
		return this.esmMiswire;
	}
	/** @param x True, if an ESM miswire condition exists somewhere on this channel. */
	public void setEsmMiswire(boolean x) {
		this.esmMiswire = x;
	}

	/** The status of the fibre channel link for this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the fibre channel link for this interface." , required = true)
	@XmlElement(required = true)
	private LinkStatus linkStatus = LinkStatus.__UNDEFINED;

	/** @return The status of the fibre channel link for this interface. */
	public LinkStatus getLinkStatus() {
		return this.linkStatus;
	}
	/** @param x The status of the fibre channel link for this interface. */
	public void setLinkStatus(LinkStatus x) {
		this.linkStatus = x;
	}

	/** True if the channel associated with this interface is degraded. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the channel associated with this interface is degraded." , required = true)
	@XmlElement(required = true)
	private boolean isDegraded;

	/** @return True if the channel associated with this interface is degraded. */
	public boolean isIsDegraded() {
		return this.isDegraded;
	}
	/** @param x True if the channel associated with this interface is degraded. */
	public void setIsDegraded(boolean x) {
		this.isDegraded = x;
	}

	/** The speed of the interface in MB per sec. This field is deprecated. The fieldcurrentInterfaceSpeed should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="The speed of the interface in MB per sec. This field is deprecated. The fieldcurrentInterfaceSpeed should be used instead." , required = true)
	@XmlElement(required = true)
	private SpeedControl speedControl = SpeedControl.__UNDEFINED;

	/** @return The speed of the interface in MB per sec. This field is deprecated. The fieldcurrentInterfaceSpeed should be used instead. */
	public SpeedControl getSpeedControl() {
		return this.speedControl;
	}
	/** @param x The speed of the interface in MB per sec. This field is deprecated. The fieldcurrentInterfaceSpeed should be used instead. */
	public void setSpeedControl(SpeedControl x) {
		this.speedControl = x;
	}

	/** The maximum speed in MB/s the interface can run. This field is deprecated. The field maximumInterfaceSpeed should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum speed in MB/s the interface can run. This field is deprecated. The field maximumInterfaceSpeed should be used instead." , required = true)
	@XmlElement(required = true)
	private int maxSpeed;

	/** @return The maximum speed in MB/s the interface can run. This field is deprecated. The field maximumInterfaceSpeed should be used instead. */
	public int getMaxSpeed() {
		return this.maxSpeed;
	}
	/** @param x The maximum speed in MB/s the interface can run. This field is deprecated. The field maximumInterfaceSpeed should be used instead. */
	public void setMaxSpeed(int x) {
		this.maxSpeed = x;
	}

	/** True if speed negotiation could not complete. */
	@io.swagger.annotations.ApiModelProperty(value ="True if speed negotiation could not complete." , required = true)
	@XmlElement(required = true)
	private boolean speedNegError;

	/** @return True if speed negotiation could not complete. */
	public boolean isSpeedNegError() {
		return this.speedNegError;
	}
	/** @param x True if speed negotiation could not complete. */
	public void setSpeedNegError(boolean x) {
		this.speedNegError = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved for future use. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved for future use. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** The DDS state of this drive side channel: optimal, degraded, or failed. */
	@io.swagger.annotations.ApiModelProperty(value ="The DDS state of this drive side channel: optimal, degraded, or failed." , required = true)
	@XmlElement(required = true)
	private int ddsChannelState;

	/** @return The DDS state of this drive side channel: optimal, degraded, or failed. */
	public int getDdsChannelState() {
		return this.ddsChannelState;
	}
	/** @param x The DDS state of this drive side channel: optimal, degraded, or failed. */
	public void setDdsChannelState(int x) {
		this.ddsChannelState = x;
	}

	/** DDS state reason. */
	@io.swagger.annotations.ApiModelProperty(value ="DDS state reason." , required = true)
	@XmlElement(required = true)
	private int ddsStateReason;

	/** @return DDS state reason. */
	public int getDdsStateReason() {
		return this.ddsStateReason;
	}
	/** @param x DDS state reason. */
	public void setDdsStateReason(int x) {
		this.ddsStateReason = x;
	}

	/** Which controller placed the drive side channel in this DDS state. */
	@io.swagger.annotations.ApiModelProperty(value ="Which controller placed the drive side channel in this DDS state." , required = true)
	@XmlElement(required = true)
	private int ddsStateWho;

	/** @return Which controller placed the drive side channel in this DDS state. */
	public int getDdsStateWho() {
		return this.ddsStateWho;
	}
	/** @param x Which controller placed the drive side channel in this DDS state. */
	public void setDdsStateWho(int x) {
		this.ddsStateWho = x;
	}

	/** Set to True if there are channel ports physically attached to this controller. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to True if there are channel ports physically attached to this controller." , required = true)
	@XmlElement(required = true)
	private boolean isLocal;

	/** @return Set to True if there are channel ports physically attached to this controller. */
	public boolean isIsLocal() {
		return this.isLocal;
	}
	/** @param x Set to True if there are channel ports physically attached to this controller. */
	public void setIsLocal(boolean x) {
		this.isLocal = x;
	}

	/** Channel port speed information. This field is deprecated. The same information is available in the LinkSpeedDetectionError structure. */
	@io.swagger.annotations.ApiModelProperty(value ="Channel port speed information. This field is deprecated. The same information is available in the LinkSpeedDetectionError structure." , required = true)
	@XmlElement(required = true)
	private ChannelPorts[] channelPorts;

	/** @return Channel port speed information. This field is deprecated. The same information is available in the LinkSpeedDetectionError structure. */
	public ChannelPorts[] getChannelPorts() {
		return this.channelPorts;
	}
	/** @param x Channel port speed information. This field is deprecated. The same information is available in the LinkSpeedDetectionError structure. */
	public void setChannelPorts(ChannelPorts[] x) {
		this.channelPorts = x;
	}

	/** The current interface speed of the Fibre Channel interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The current interface speed of the Fibre Channel interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed currentInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The current interface speed of the Fibre Channel interface. */
	public InterfaceSpeed getCurrentInterfaceSpeed() {
		return this.currentInterfaceSpeed;
	}
	/** @param x The current interface speed of the Fibre Channel interface. */
	public void setCurrentInterfaceSpeed(InterfaceSpeed x) {
		this.currentInterfaceSpeed = x;
	}

	/** The maximum interface speed of the Fibre Channel interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum interface speed of the Fibre Channel interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed maximumInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The maximum interface speed of the Fibre Channel interface. */
	public InterfaceSpeed getMaximumInterfaceSpeed() {
		return this.maximumInterfaceSpeed;
	}
	/** @param x The maximum interface speed of the Fibre Channel interface. */
	public void setMaximumInterfaceSpeed(InterfaceSpeed x) {
		this.maximumInterfaceSpeed = x;
	}

	/** The unique identifier for a given instance of this structure. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for a given instance of this structure." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The unique identifier for a given instance of this structure. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The unique identifier for a given instance of this structure. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The physical location of the Fibre Channel interface. The parent reference in location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Fibre Channel interface relative to the parent," "2nd Fibre Channel interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the Fibre Channel interface. The parent reference in location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying \"1st Fibre Channel interface relative to the parent,\" \"2nd Fibre Channel interface relative to the parent,\" etc. This \"interface number\" is independent of the interface's channel association." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the Fibre Channel interface. The parent reference in location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Fibre Channel interface relative to the parent," "2nd Fibre Channel interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the Fibre Channel interface. The parent reference in location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Fibre Channel interface relative to the parent," "2nd Fibre Channel interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** This field is true if the Fibre interface on the controller board is trunk capable. This field is always false for host-side interfaces. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is true if the Fibre interface on the controller board is trunk capable. This field is always false for host-side interfaces." , required = true)
	@XmlElement(required = true)
	private boolean isTrunkCapable;

	/** @return This field is true if the Fibre interface on the controller board is trunk capable. This field is always false for host-side interfaces. */
	public boolean isIsTrunkCapable() {
		return this.isTrunkCapable;
	}
	/** @param x This field is true if the Fibre interface on the controller board is trunk capable. This field is always false for host-side interfaces. */
	public void setIsTrunkCapable(boolean x) {
		this.isTrunkCapable = x;
	}

	/** True only when ESM is trunk capable and cabled incorrectly, or not trunk capable but connected in trunk mode. */
	@io.swagger.annotations.ApiModelProperty(value ="True only when ESM is trunk capable and cabled incorrectly, or not trunk capable but connected in trunk mode." , required = true)
	@XmlElement(required = true)
	private boolean trunkMiswire;

	/** @return True only when ESM is trunk capable and cabled incorrectly, or not trunk capable but connected in trunk mode. */
	public boolean isTrunkMiswire() {
		return this.trunkMiswire;
	}
	/** @param x True only when ESM is trunk capable and cabled incorrectly, or not trunk capable but connected in trunk mode. */
	public void setTrunkMiswire(boolean x) {
		this.trunkMiswire = x;
	}

	@io.swagger.annotations.ApiModelProperty(value ="" , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}

	/** Maximum one way data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum one way data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long oneWayMaxRate;

	/** @return Maximum one way data rate in B/s */
	public long getOneWayMaxRate() {
		return this.oneWayMaxRate;
	}
	/** @param x Maximum one way data rate in B/s */
	public void setOneWayMaxRate(long x) {
		this.oneWayMaxRate = x;
	}

	/** Maximum bi-directional data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum bi-directional data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long bidirectionalMaxRate;

	/** @return Maximum bi-directional data rate in B/s */
	public long getBidirectionalMaxRate() {
		return this.bidirectionalMaxRate;
	}
	/** @param x Maximum bi-directional data rate in B/s */
	public void setBidirectionalMaxRate(long x) {
		this.bidirectionalMaxRate = x;
	}
	@Override
	public String getId(){
		return interfaceRef;
	}
}
