package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey details of connections to a fibre channel remote target. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(647)
public class FibreRemoteTargetConnections implements Serializable {
	public FibreRemoteTargetConnections() {
	}

	/** Remote node name. */
	@io.swagger.annotations.ApiModelProperty(value ="Remote node name." , required = true)
	@XmlElement(required = true)
	private String remoteNodeWWN;

	/** @return Remote node name. */
	public String getRemoteNodeWWN() {
		return this.remoteNodeWWN;
	}
	/** @param x Remote node name. */
	public void setRemoteNodeWWN(String x) {
		this.remoteNodeWWN = x;
	}

	/** Associated (visible) switch ports. */
	@io.swagger.annotations.ApiModelProperty(value ="Associated (visible) switch ports." , required = true)
	@XmlElement(required = true)
	private String[] associatedSwitchPorts;

	/** @return Associated (visible) switch ports. */
	public String[] getAssociatedSwitchPorts() {
		return this.associatedSwitchPorts;
	}
	/** @param x Associated (visible) switch ports. */
	public void setAssociatedSwitchPorts(String[] x) {
		this.associatedSwitchPorts = x;
	}

	/** Connected remote target ports. */
	@io.swagger.annotations.ApiModelProperty(value ="Connected remote target ports." , required = true)
	@XmlElement(required = true)
	private FibrePortLogin[] connectedRemoteTargetPorts;

	/** @return Connected remote target ports. */
	public FibrePortLogin[] getConnectedRemoteTargetPorts() {
		return this.connectedRemoteTargetPorts;
	}
	/** @param x Connected remote target ports. */
	public void setConnectedRemoteTargetPorts(FibrePortLogin[] x) {
		this.connectedRemoteTargetPorts = x;
	}
}
