package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure identifies the incorrect and required cabling in order to establish a supported trunk connection between the two devices. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(872)
public class FibreTrunkMiswire implements Serializable {
	public FibreTrunkMiswire() {
	}

	/** Identifies the channel ports currently cabled together that lead to an unsupported trunk connection. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the channel ports currently cabled together that lead to an unsupported trunk connection." , required = true)
	@XmlElement(required = true)
	private ChannelPortPair[] connectedPorts;

	/** @return Identifies the channel ports currently cabled together that lead to an unsupported trunk connection. */
	public ChannelPortPair[] getConnectedPorts() {
		return this.connectedPorts;
	}
	/** @param x Identifies the channel ports currently cabled together that lead to an unsupported trunk connection. */
	public void setConnectedPorts(ChannelPortPair[] x) {
		this.connectedPorts = x;
	}

	/** Identifies the channel ports that should be cabled together in order to establish a supported trunk connection. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the channel ports that should be cabled together in order to establish a supported trunk connection." , required = true)
	@XmlElement(required = true)
	private ChannelPortPair[] requiredPorts;

	/** @return Identifies the channel ports that should be cabled together in order to establish a supported trunk connection. */
	public ChannelPortPair[] getRequiredPorts() {
		return this.requiredPorts;
	}
	/** @param x Identifies the channel ports that should be cabled together in order to establish a supported trunk connection. */
	public void setRequiredPorts(ChannelPortPair[] x) {
		this.requiredPorts = x;
	}
}
