package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a flash cache's attributes and current operational status. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1102)
public class FlashCache implements Serializable,devmgr.api.model.Identifiable {
	public FlashCache() {
	}

	/** The WWN of the high level flash cache volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the high level flash cache volume." , required = true)
	@XmlElement(required = true)
	private String wwn;

	/** @return The WWN of the high level flash cache volume. */
	public String getWwn() {
		return this.wwn;
	}
	/** @param x The WWN of the high level flash cache volume. */
	public void setWwn(String x) {
		this.wwn = x;
	}

	/** A reference to the high level flash cache volume. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the high level flash cache volume." , required = true)
	@XmlElement(required = true)
	private String flashCacheRef;

	/** @return A reference to the high level flash cache volume. */
	public String getFlashCacheRef() {
		return this.flashCacheRef;
	}
	/** @param x A reference to the high level flash cache volume. */
	public void setFlashCacheRef(String x) {
		this.flashCacheRef = x;
	}

	/** Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches. */
	@io.swagger.annotations.ApiModelProperty(value ="Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches." , required = true)
	@XmlElement(required = true)
	private FlashCacheBase flashCacheBase;

	/** @return Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches. */
	public FlashCacheBase getFlashCacheBase() {
		return this.flashCacheBase;
	}
	/** @param x Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches. */
	public void setFlashCacheBase(FlashCacheBase x) {
		this.flashCacheBase = x;
	}

	/** Drive information for the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="Drive information for the flash cache." , required = true)
	@XmlElement(required = true)
	private FlashCacheDriveInfo fcDriveInfo;

	/** @return Drive information for the flash cache. */
	public FlashCacheDriveInfo getFcDriveInfo() {
		return this.fcDriveInfo;
	}
	/** @param x Drive information for the flash cache. */
	public void setFcDriveInfo(FlashCacheDriveInfo x) {
		this.fcDriveInfo = x;
	}
	@Override
	public String getId(){
		return flashCacheRef;
	}
}
