package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used when creating a flash cache for performing analytics. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(490)
public class FlashCacheAnalyticsCreationDescriptor implements Serializable {
	public FlashCacheAnalyticsCreationDescriptor() {
	}

	/** The type of flash cache to create (read only or write cache). */
	@io.swagger.annotations.ApiModelProperty(value ="The type of flash cache to create (read only or write cache)." , required = true)
	@XmlElement(required = true)
	private FlashCacheType flashCacheType = FlashCacheType.__UNDEFINED;

	/** @return The type of flash cache to create (read only or write cache). */
	public FlashCacheType getFlashCacheType() {
		return this.flashCacheType;
	}
	/** @param x The type of flash cache to create (read only or write cache). */
	public void setFlashCacheType(FlashCacheType x) {
		this.flashCacheType = x;
	}

	/** The label to be assigned to the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The label to be assigned to the flash cache." , required = true)
	@XmlElement(required = true)
	private String flashCacheLabel;

	/** @return The label to be assigned to the flash cache. */
	public String getFlashCacheLabel() {
		return this.flashCacheLabel;
	}
	/** @param x The label to be assigned to the flash cache. */
	public void setFlashCacheLabel(String x) {
		this.flashCacheLabel = x;
	}
}
