package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the possible flash cache analytics stop reasons. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(48)
public enum FlashCacheAnalyticsStatusCause implements Serializable {
		/** Flash cache analytics has not stopped so there is no cause. */
		none(0),
		/** Flash cache analytics is stopped since user requested it. */
		userStopped(1),
		/** Flash cache analytics is stopped since user enabled/disabled FC during analytics. */
		userFcChanges(2),
		/** Flash cache analytics is stopped since controller rebooted during analytics. */
		internalCtlrRebooted(3),
		/** Flash cache analytics is stopped due to configuration changes such as creation of certain volume types, ownership transfer, etc. */
		internalCfgChanges(4),
		__UNDEFINED(464378545);

		public final int value;

		private FlashCacheAnalyticsStatusCause(int v) {
			this.value = v;
		}
}
