package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a Flash Cache base object. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(655)
public class FlashCacheBase implements Serializable {
	public FlashCacheBase() {
	}

	/** The user-assigned label of the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned label of the flash cache." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The user-assigned label of the flash cache. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The user-assigned label of the flash cache. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The status of the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the flash cache." , required = true)
	@XmlElement(required = true)
	private FlashCacheStatus status = FlashCacheStatus.__UNDEFINED;

	/** @return The status of the flash cache. */
	public FlashCacheStatus getStatus() {
		return this.status;
	}
	/** @param x The status of the flash cache. */
	public void setStatus(FlashCacheStatus x) {
		this.status = x;
	}

	/** The flash cache configuration type. */
	@io.swagger.annotations.ApiModelProperty(value ="The flash cache configuration type." , required = true)
	@XmlElement(required = true)
	private FlashCacheConfigType configType = FlashCacheConfigType.__UNDEFINED;

	/** @return The flash cache configuration type. */
	public FlashCacheConfigType getConfigType() {
		return this.configType;
	}
	/** @param x The flash cache configuration type. */
	public void setConfigType(FlashCacheConfigType x) {
		this.configType = x;
	}

	/** The flash cache analytics status. */
	@io.swagger.annotations.ApiModelProperty(value ="The flash cache analytics status." , required = true)
	@XmlElement(required = true)
	private FlashCacheAnalyticsStatus analyticsStatus = FlashCacheAnalyticsStatus.__UNDEFINED;

	/** @return The flash cache analytics status. */
	public FlashCacheAnalyticsStatus getAnalyticsStatus() {
		return this.analyticsStatus;
	}
	/** @param x The flash cache analytics status. */
	public void setAnalyticsStatus(FlashCacheAnalyticsStatus x) {
		this.analyticsStatus = x;
	}

	/** The flash cache analytics status cause. */
	@io.swagger.annotations.ApiModelProperty(value ="The flash cache analytics status cause." , required = true)
	@XmlElement(required = true)
	private FlashCacheAnalyticsStatusCause analyticsCause = FlashCacheAnalyticsStatusCause.__UNDEFINED;

	/** @return The flash cache analytics status cause. */
	public FlashCacheAnalyticsStatusCause getAnalyticsCause() {
		return this.analyticsCause;
	}
	/** @param x The flash cache analytics status cause. */
	public void setAnalyticsCause(FlashCacheAnalyticsStatusCause x) {
		this.analyticsCause = x;
	}

	/** The flash cache status cause. */
	@io.swagger.annotations.ApiModelProperty(value ="The flash cache status cause." , required = true)
	@XmlElement(required = true)
	private FlashCacheStatusCause statusCause = FlashCacheStatusCause.__UNDEFINED;

	/** @return The flash cache status cause. */
	public FlashCacheStatusCause getStatusCause() {
		return this.statusCause;
	}
	/** @param x The flash cache status cause. */
	public void setStatusCause(FlashCacheStatusCause x) {
		this.statusCause = x;
	}
}
