package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to identify how the flash cache is used. Supported configuration types will be reported using a FeatureParamsModificationEvent with an event attribute called SUPPORTEDFLASHCACHECONFIGS. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(161)
public enum FlashCacheConfigType implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** The flash cache is configured as a file system. */
		filesystem(1),
		/** The flash cache is configured as a database. */
		database(2),
		/** This enumeration value actually refers to a WEBSERVER configuration type instead of a MULTIMEDIA configuration type. */
		multimedia(3),
		__UNDEFINED(464378545);

		public final int value;

		private FlashCacheConfigType(int v) {
			this.value = v;
		}
}
