package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as the argument to the createFlashCache procedure. It identifies the attributes for creation of a flash cache. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1066)
public class FlashCacheCreationDescriptor implements Serializable {
	public FlashCacheCreationDescriptor() {
	}

	/** This field identifies the flash cache as either a read only or write cache. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the flash cache as either a read only or write cache." , required = true)
	@XmlElement(required = true)
	private FlashCacheType flashCacheType = FlashCacheType.__UNDEFINED;

	/** @return This field identifies the flash cache as either a read only or write cache. */
	public FlashCacheType getFlashCacheType() {
		return this.flashCacheType;
	}
	/** @param x This field identifies the flash cache as either a read only or write cache. */
	public void setFlashCacheType(FlashCacheType x) {
		this.flashCacheType = x;
	}

	/** The volume candidate object to be used for creation of the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume candidate object to be used for creation of the flash cache." , required = true)
	@XmlElement(required = true)
	private VolumeCandidate candidate;

	/** @return The volume candidate object to be used for creation of the flash cache. */
	public VolumeCandidate getCandidate() {
		return this.candidate;
	}
	/** @param x The volume candidate object to be used for creation of the flash cache. */
	public void setCandidate(VolumeCandidate x) {
		this.candidate = x;
	}

	/** The label to be assigned to the flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The label to be assigned to the flash cache." , required = true)
	@XmlElement(required = true)
	private String flashCacheLabel;

	/** @return The label to be assigned to the flash cache. */
	public String getFlashCacheLabel() {
		return this.flashCacheLabel;
	}
	/** @param x The label to be assigned to the flash cache. */
	public void setFlashCacheLabel(String x) {
		this.flashCacheLabel = x;
	}

	/** If true, all user mapped volumes will have flash cache enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, all user mapped volumes will have flash cache enabled." , required = true)
	@XmlElement(required = true)
	private boolean enableExisting;

	/** @return If true, all user mapped volumes will have flash cache enabled. */
	public boolean isEnableExisting() {
		return this.enableExisting;
	}
	/** @param x If true, all user mapped volumes will have flash cache enabled. */
	public void setEnableExisting(boolean x) {
		this.enableExisting = x;
	}
}
