package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to map a cached volume to the associated flash cache. An array of these structures is provided in the ObjectBundle. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1074)
public class FlashCacheMap implements Serializable,devmgr.api.model.Identifiable {
	public FlashCacheMap() {
	}

	/** A reference to the associated flash cache. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the associated flash cache." , required = true)
	@XmlElement(required = true)
	private String flashCache;

	/** @return A reference to the associated flash cache. */
	public String getFlashCache() {
		return this.flashCache;
	}
	/** @param x A reference to the associated flash cache. */
	public void setFlashCache(String x) {
		this.flashCache = x;
	}

	/** A reference to the cached volume. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the cached volume." , required = true)
	@XmlElement(required = true)
	private String cachedVolume;

	/** @return A reference to the cached volume. */
	public String getCachedVolume() {
		return this.cachedVolume;
	}
	/** @param x A reference to the cached volume. */
	public void setCachedVolume(String x) {
		this.cachedVolume = x;
	}

	/** A unique identifier for the map entry. */
	@io.swagger.annotations.ApiModelProperty(value ="A unique identifier for the map entry." , required = true)
	@XmlElement(required = true)
	private String flashCacheMapRef;

	/** @return A unique identifier for the map entry. */
	public String getFlashCacheMapRef() {
		return this.flashCacheMapRef;
	}
	/** @param x A unique identifier for the map entry. */
	public void setFlashCacheMapRef(String x) {
		this.flashCacheMapRef = x;
	}
	@Override
	public String getId(){
		return flashCacheMapRef;
	}
}
