package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains statistics for a given flash cache. It is returned by the getFlashCacheStatistics procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(448)
public class FlashCacheStatisticsReturned implements Serializable {
	public FlashCacheStatisticsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The flash cache statistics are returned if the returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The flash cache statistics are returned if the returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private FlashCacheStatistics flashCacheStatistics;

	/** @return The flash cache statistics are returned if the returnCode is equal to RETCODE_OK. */
	public FlashCacheStatistics getFlashCacheStatistics() {
		return this.flashCacheStatistics;
	}
	/** @param x The flash cache statistics are returned if the returnCode is equal to RETCODE_OK. */
	public void setFlashCacheStatistics(FlashCacheStatistics x) {
		this.flashCacheStatistics = x;
	}
}
