package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to identify the current status of the flash cache. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(281)
public enum FlashCacheStatusCause implements Serializable {
		/** The flash cache status is not set. */
		none(0),
		/** The flash cache is in an optimal state with a hot spare in use. */
		hotspareInuse(1),
		/** The flash cache state is due to inaccessible drives. This is possible when the flash cache is in a degraded or failed state. */
		drivesInaccessible(2),
		/** The flash cache state is due to a cache size mismatch. This is possible when the flash cache is in a failed state. */
		cacheSizeMismatch(3),
		/** The flash cache is due to missing drives. This is possible when the flash cache is in a degraded state. */
		missingDrives(4),
		__UNDEFINED(464378545);

		public final int value;

		private FlashCacheStatusCause(int v) {
			this.value = v;
		}
}
