package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains data associated with a FRU diagnostic test. It is used to request a test of a specific type be performed on a device in a specific slot number. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(580)
public class FruDiagDescriptor implements Serializable {
	public FruDiagDescriptor() {
	}

	/** The diagnostic test type. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test type." , required = true)
	@XmlElement(required = true)
	private FruDiagTestType fruDiagTestType = FruDiagTestType.__UNDEFINED;

	/** @return The diagnostic test type. */
	public FruDiagTestType getFruDiagTestType() {
		return this.fruDiagTestType;
	}
	/** @param x The diagnostic test type. */
	public void setFruDiagTestType(FruDiagTestType x) {
		this.fruDiagTestType = x;
	}

	/** The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored. */
	@io.swagger.annotations.ApiModelProperty(value ="The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored." , required = true)
	@XmlElement(required = true)
	private int slot;

	/** @return The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored. */
	public int getSlot() {
		return this.slot;
	}
	/** @param x The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored. */
	public void setSlot(int x) {
		this.slot = x;
	}

	/** The diagnostic test to be performed. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test to be performed." , required = true)
	@XmlElement(required = true)
	private FruDiagTestIdentifier fruDiagTestIdentifier = FruDiagTestIdentifier.__UNDEFINED;

	/** @return The diagnostic test to be performed. */
	public FruDiagTestIdentifier getFruDiagTestIdentifier() {
		return this.fruDiagTestIdentifier;
	}
	/** @param x The diagnostic test to be performed. */
	public void setFruDiagTestIdentifier(FruDiagTestIdentifier x) {
		this.fruDiagTestIdentifier = x;
	}
}
