package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains data associated with a FRU diagnostic test. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(347)
public class FruDiagReturnData implements Serializable {
	public FruDiagReturnData() {
	}

	/** Variable-length ASCII text string that identifies the device serial number. */
	@io.swagger.annotations.ApiModelProperty(value ="Variable-length ASCII text string that identifies the device serial number." , required = true)
	@XmlElement(required = true)
	private String serialNumber;

	/** @return Variable-length ASCII text string that identifies the device serial number. */
	public String getSerialNumber() {
		return this.serialNumber;
	}
	/** @param x Variable-length ASCII text string that identifies the device serial number. */
	public void setSerialNumber(String x) {
		this.serialNumber = x;
	}

	/** Device slot number (1-based). */
	@io.swagger.annotations.ApiModelProperty(value ="Device slot number (1-based)." , required = true)
	@XmlElement(required = true)
	private int slot;

	/** @return Device slot number (1-based). */
	public int getSlot() {
		return this.slot;
	}
	/** @param x Device slot number (1-based). */
	public void setSlot(int x) {
		this.slot = x;
	}

	/** The time the diagnostic was started, represented in seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time the diagnostic was started, represented in seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long startTime;

	/** @return The time the diagnostic was started, represented in seconds since midnight GMT on January 1, 1970. */
	public long getStartTime() {
		return this.startTime;
	}
	/** @param x The time the diagnostic was started, represented in seconds since midnight GMT on January 1, 1970. */
	public void setStartTime(long x) {
		this.startTime = x;
	}

	/** If the diagnostic is not running this is the time the diagnostic was completed or interrupted. If the diagnostic is running this is the time the status was requested. The time is represented in seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="If the diagnostic is not running this is the time the diagnostic was completed or interrupted. If the diagnostic is running this is the time the status was requested. The time is represented in seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long endTime;

	/** @return If the diagnostic is not running this is the time the diagnostic was completed or interrupted. If the diagnostic is running this is the time the status was requested. The time is represented in seconds since midnight GMT on January 1, 1970. */
	public long getEndTime() {
		return this.endTime;
	}
	/** @param x If the diagnostic is not running this is the time the diagnostic was completed or interrupted. If the diagnostic is running this is the time the status was requested. The time is represented in seconds since midnight GMT on January 1, 1970. */
	public void setEndTime(long x) {
		this.endTime = x;
	}

	/** The diagnostic test type. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test type." , required = true)
	@XmlElement(required = true)
	private FruDiagTestType testType = FruDiagTestType.__UNDEFINED;

	/** @return The diagnostic test type. */
	public FruDiagTestType getTestType() {
		return this.testType;
	}
	/** @param x The diagnostic test type. */
	public void setTestType(FruDiagTestType x) {
		this.testType = x;
	}

	/** The diagnostic test identifier. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test identifier." , required = true)
	@XmlElement(required = true)
	private FruDiagTestIdentifier testIdentifier = FruDiagTestIdentifier.__UNDEFINED;

	/** @return The diagnostic test identifier. */
	public FruDiagTestIdentifier getTestIdentifier() {
		return this.testIdentifier;
	}
	/** @param x The diagnostic test identifier. */
	public void setTestIdentifier(FruDiagTestIdentifier x) {
		this.testIdentifier = x;
	}

	/** The diagnostic test status. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test status." , required = true)
	@XmlElement(required = true)
	private FruDiagStatus status = FruDiagStatus.__UNDEFINED;

	/** @return The diagnostic test status. */
	public FruDiagStatus getStatus() {
		return this.status;
	}
	/** @param x The diagnostic test status. */
	public void setStatus(FruDiagStatus x) {
		this.status = x;
	}

	/** The diagnostic test error code. */
	@io.swagger.annotations.ApiModelProperty(value ="The diagnostic test error code." , required = true)
	@XmlElement(required = true)
	private int errorCode;

	/** @return The diagnostic test error code. */
	public int getErrorCode() {
		return this.errorCode;
	}
	/** @param x The diagnostic test error code. */
	public void setErrorCode(int x) {
		this.errorCode = x;
	}

	/** This value is a number in the range 0 to 100 indicating the percent complete. */
	@io.swagger.annotations.ApiModelProperty(value ="This value is a number in the range 0 to 100 indicating the percent complete." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return This value is a number in the range 0 to 100 indicating the percent complete. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x This value is a number in the range 0 to 100 indicating the percent complete. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}
}
