package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the various actions that can be performed using the setFunctionState procedure. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(73)
public enum FunctionAction implements Serializable {
		/** No action specified. */
		unknown(0),
		/** Return the value, don't make any changes to the state of the function. */
		getValue(1),
		/** Enable the specified function. */
		enableFunction(2),
		/** Disable the specified function. */
		disableFunction(3),
		/** Revert back to the default value. */
		setDefault(4),
		__UNDEFINED(464378545);

		public final int value;

		private FunctionAction(int v) {
			this.value = v;
		}
}
