package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the state of a specified function. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(27)
public enum FunctionState implements Serializable {
		/** The function state is unknown. */
		unknown(0),
		/** The function state is inconsistent between the two controllers. */
		inconsistent(1),
		/** The function is enabled. */
		enabled(2),
		/** The function is disabled. */
		disabled(3),
		/** The function state could not be determined. */
		unavailable(4),
		__UNDEFINED(464378545);

		public final int value;

		private FunctionState(int v) {
			this.value = v;
		}
}
