package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to return data collected by the setFunctionState() procedure. If the ReturnCode is not equal to RETCODE_OK, no data is returned. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(481)
public class FunctionStateReturned implements Serializable {
	public FunctionStateReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is present only if the value of returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private FunctionState functionState = FunctionState.__UNDEFINED;

	/** @return This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public FunctionState getFunctionState() {
		return this.functionState;
	}
	/** @param x This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public void setFunctionState(FunctionState x) {
		this.functionState = x;
	}
}
