package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about a GBIC's type-specific data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(737)
public class GBICParentTypeData implements Serializable {
	public GBICParentTypeData() {
	}

	/** This enumeration is used to identify the parent type of a GBIC component. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to identify the parent type of a GBIC component." , required = true)
	@XmlElement(required = true)
	private GBICParentType gbicParentType = GBICParentType.__UNDEFINED;

	/** @return This enumeration is used to identify the parent type of a GBIC component. */
	public GBICParentType getGbicParentType() {
		return this.gbicParentType;
	}
	/** @param x This enumeration is used to identify the parent type of a GBIC component. */
	public void setGbicParentType(GBICParentType x) {
		this.gbicParentType = x;
	}

	/** This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_CONTROLLER. It contains the detailed information about the controller channel. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_CONTROLLER. It contains the detailed information about the controller channel." , required = false)
	@XmlElement(required = false)
	private ControllerGBIC controllerGBIC;

	/** @return This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_CONTROLLER. It contains the detailed information about the controller channel. */
	public ControllerGBIC getControllerGBIC() {
		return this.controllerGBIC;
	}
	/** @param x This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_CONTROLLER. It contains the detailed information about the controller channel. */
	public void setControllerGBIC(ControllerGBIC x) {
		this.controllerGBIC = x;
	}

	/** No information is returned */
	@io.swagger.annotations.ApiModelProperty(value ="No information is returned" , required = false)
	@XmlElement(required = false)
	private String parentEsm;

	/** @return No information is returned */
	public String getParentEsm() {
		return this.parentEsm;
	}
	/** @param x No information is returned */
	public void setParentEsm(String x) {
		this.parentEsm = x;
	}

	/** This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_MINIHUB. It contains the detailed information about the minihub the GBIC belongs to. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_MINIHUB. It contains the detailed information about the minihub the GBIC belongs to." , required = false)
	@XmlElement(required = false)
	private String parentMinihub;

	/** @return This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_MINIHUB. It contains the detailed information about the minihub the GBIC belongs to. */
	public String getParentMinihub() {
		return this.parentMinihub;
	}
	/** @param x This field is present only if the gbicParentType value is GBIC_PARENT_TYPE_MINIHUB. It contains the detailed information about the minihub the GBIC belongs to. */
	public void setParentMinihub(String x) {
		this.parentMinihub = x;
	}
}
