package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is designed to model the critical aspects of a volume that has been removed from a storage array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(928)
public class GhostVolume implements Serializable {
	public GhostVolume() {
	}

	/** The World Wide Name of the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The World Wide Name of the volume." , required = true)
	@XmlElement(required = true)
	private String worldWideName;

	/** @return The World Wide Name of the volume. */
	public String getWorldWideName() {
		return this.worldWideName;
	}
	/** @param x The World Wide Name of the volume. */
	public void setWorldWideName(String x) {
		this.worldWideName = x;
	}

	/** The reference for this volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this volume." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference for this volume. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference for this volume. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved1;

	/** @return Reserved */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved2;

	/** @return Reserved */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}
}
