package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the protocol selection used by a host interface card with a selectable protocol type. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(268)
public enum HICProtocolType implements Serializable {
		/** A firmware-configurable host interface card is not on this controller. */
		none(0),
		/** The HIC to to be configured for Ethernet protocol. */
		ethernet(1),
		/** The HIC to to be configured for Fibre Channel protocol. */
		fc(2),
		/** The HIC is to be configured for Ethernet protocol on ports 1 and 2 and for Fibre Channel on ports 3 and 4 (if ports 3 and 4 are present). */
		ethernetAndFcSplit(3),
		__UNDEFINED(464378545);

		public final int value;

		private HICProtocolType(int v) {
			this.value = v;
		}
}
