package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about the higher-level volumes. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1133)
public class HLVolumeBundle implements Serializable {
	public HLVolumeBundle() {
	}

	/** An array of SnapshotVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of SnapshotVolume objects." , required = true)
	@XmlElement(required = true)
	private SnapshotVolume[] snapshotVol;

	/** @return An array of SnapshotVolume objects. */
	public SnapshotVolume[] getSnapshotVol() {
		return this.snapshotVol;
	}
	/** @param x An array of SnapshotVolume objects. */
	public void setSnapshotVol(SnapshotVolume[] x) {
		this.snapshotVol = x;
	}

	/** An array of MirrorProxyVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of MirrorProxyVolume objects." , required = true)
	@XmlElement(required = true)
	private MirrorProxyVolume[] mirrorVol;

	/** @return An array of MirrorProxyVolume objects. */
	public MirrorProxyVolume[] getMirrorVol() {
		return this.mirrorVol;
	}
	/** @param x An array of MirrorProxyVolume objects. */
	public void setMirrorVol(MirrorProxyVolume[] x) {
		this.mirrorVol = x;
	}

	/** An array of MetadataVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of MetadataVolume objects." , required = true)
	@XmlElement(required = true)
	private MetadataVolume[] metadataVol;

	/** @return An array of MetadataVolume objects. */
	public MetadataVolume[] getMetadataVol() {
		return this.metadataVol;
	}
	/** @param x An array of MetadataVolume objects. */
	public void setMetadataVol(MetadataVolume[] x) {
		this.metadataVol = x;
	}

	/** An array of RemoteVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of RemoteVolume objects." , required = true)
	@XmlElement(required = true)
	private RemoteVolume[] remoteVol;

	/** @return An array of RemoteVolume objects. */
	public RemoteVolume[] getRemoteVol() {
		return this.remoteVol;
	}
	/** @param x An array of RemoteVolume objects. */
	public void setRemoteVol(RemoteVolume[] x) {
		this.remoteVol = x;
	}

	/** An array of VolumeCopy objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of VolumeCopy objects." , required = true)
	@XmlElement(required = true)
	private VolumeCopy[] volumeCopy;

	/** @return An array of VolumeCopy objects. */
	public VolumeCopy[] getVolumeCopy() {
		return this.volumeCopy;
	}
	/** @param x An array of VolumeCopy objects. */
	public void setVolumeCopy(VolumeCopy[] x) {
		this.volumeCopy = x;
	}

	/** An array of PITGroup objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of PITGroup objects." , required = true)
	@XmlElement(required = true)
	private PITGroup[] pitGroup;

	/** @return An array of PITGroup objects. */
	public PITGroup[] getPitGroup() {
		return this.pitGroup;
	}
	/** @param x An array of PITGroup objects. */
	public void setPitGroup(PITGroup[] x) {
		this.pitGroup = x;
	}

	/** An array of PiT objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of PiT objects." , required = true)
	@XmlElement(required = true)
	private PIT[] pit;

	/** @return An array of PiT objects. */
	public PIT[] getPit() {
		return this.pit;
	}
	/** @param x An array of PiT objects. */
	public void setPit(PIT[] x) {
		this.pit = x;
	}

	/** An array of PITView objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of PITView objects." , required = true)
	@XmlElement(required = true)
	private PITView[] pitView;

	/** @return An array of PITView objects. */
	public PITView[] getPitView() {
		return this.pitView;
	}
	/** @param x An array of PITView objects. */
	public void setPitView(PITView[] x) {
		this.pitView = x;
	}

	/** An array of PITConsistencyGroup objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of PITConsistencyGroup objects." , required = true)
	@XmlElement(required = true)
	private PITConsistencyGroup[] pitConsistencyGroup;

	/** @return An array of PITConsistencyGroup objects. */
	public PITConsistencyGroup[] getPitConsistencyGroup() {
		return this.pitConsistencyGroup;
	}
	/** @param x An array of PITConsistencyGroup objects. */
	public void setPitConsistencyGroup(PITConsistencyGroup[] x) {
		this.pitConsistencyGroup = x;
	}

	/** An array of ConcatVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of ConcatVolume objects." , required = true)
	@XmlElement(required = true)
	private ConcatVolume[] concatVolume;

	/** @return An array of ConcatVolume objects. */
	public ConcatVolume[] getConcatVolume() {
		return this.concatVolume;
	}
	/** @param x An array of ConcatVolume objects. */
	public void setConcatVolume(ConcatVolume[] x) {
		this.concatVolume = x;
	}

	/** An array of ConcatVolumeMember objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of ConcatVolumeMember objects." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeMember[] concatVolMember;

	/** @return An array of ConcatVolumeMember objects. */
	public ConcatVolumeMember[] getConcatVolMember() {
		return this.concatVolMember;
	}
	/** @param x An array of ConcatVolumeMember objects. */
	public void setConcatVolMember(ConcatVolumeMember[] x) {
		this.concatVolMember = x;
	}

	/** An array of PITConsistencyGroupView objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of PITConsistencyGroupView objects." , required = true)
	@XmlElement(required = true)
	private PITConsistencyGroupView[] pitConsistencyGroupView;

	/** @return An array of PITConsistencyGroupView objects. */
	public PITConsistencyGroupView[] getPitConsistencyGroupView() {
		return this.pitConsistencyGroupView;
	}
	/** @param x An array of PITConsistencyGroupView objects. */
	public void setPitConsistencyGroupView(PITConsistencyGroupView[] x) {
		this.pitConsistencyGroupView = x;
	}

	/** An array of ThinVolume objects. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of ThinVolume objects." , required = true)
	@XmlElement(required = true)
	private ThinVolume[] thinVolume;

	/** @return An array of ThinVolume objects. */
	public ThinVolume[] getThinVolume() {
		return this.thinVolume;
	}
	/** @param x An array of ThinVolume objects. */
	public void setThinVolume(ThinVolume[] x) {
		this.thinVolume = x;
	}

	/** Async Mirror Groups. */
	@io.swagger.annotations.ApiModelProperty(value ="Async Mirror Groups." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroup[] asyncMirrorGroup;

	/** @return Async Mirror Groups. */
	public AsyncMirrorGroup[] getAsyncMirrorGroup() {
		return this.asyncMirrorGroup;
	}
	/** @param x Async Mirror Groups. */
	public void setAsyncMirrorGroup(AsyncMirrorGroup[] x) {
		this.asyncMirrorGroup = x;
	}

	/** Async Mirror Group Members. */
	@io.swagger.annotations.ApiModelProperty(value ="Async Mirror Group Members." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupMember[] asyncMirrorGroupMember;

	/** @return Async Mirror Group Members. */
	public AsyncMirrorGroupMember[] getAsyncMirrorGroupMember() {
		return this.asyncMirrorGroupMember;
	}
	/** @param x Async Mirror Group Members. */
	public void setAsyncMirrorGroupMember(AsyncMirrorGroupMember[] x) {
		this.asyncMirrorGroupMember = x;
	}

	/** "Incomplete" Async Mirror Group Members. */
	@io.swagger.annotations.ApiModelProperty(value ="\"Incomplete\" Async Mirror Group Members." , required = true)
	@XmlElement(required = true)
	private AsyncMirrorGroupIncompleteMember[] asyncMirrorGroupIncompleteMember;

	/** @return "Incomplete" Async Mirror Group Members. */
	public AsyncMirrorGroupIncompleteMember[] getAsyncMirrorGroupIncompleteMember() {
		return this.asyncMirrorGroupIncompleteMember;
	}
	/** @param x "Incomplete" Async Mirror Group Members. */
	public void setAsyncMirrorGroupIncompleteMember(AsyncMirrorGroupIncompleteMember[] x) {
		this.asyncMirrorGroupIncompleteMember = x;
	}
}
