package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure, used when enabling or disabling high resolution statistics gathering, reports the enable and disable state. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(586)
public class HighResolutionReturned implements Serializable {
	public HighResolutionReturned() {
	}

	/** The return code from the procedure to enable or disable high resolution statistical sampling. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from the procedure to enable or disable high resolution statistical sampling." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code from the procedure to enable or disable high resolution statistical sampling. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code from the procedure to enable or disable high resolution statistical sampling. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** True if high resolution is enabled and false if disabled. */
	@io.swagger.annotations.ApiModelProperty(value ="True if high resolution is enabled and false if disabled." , required = true)
	@XmlElement(required = true)
	private boolean isEnabled;

	/** @return True if high resolution is enabled and false if disabled. */
	public boolean isIsEnabled() {
		return this.isEnabled;
	}
	/** @param x True if high resolution is enabled and false if disabled. */
	public void setIsEnabled(boolean x) {
		this.isEnabled = x;
	}
}
