package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the input to the activateHistogram procedure call. It contains the individual arguments that define the histogram set to create and activate. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(745)
public class HistogramDescriptor implements Serializable {
	public HistogramDescriptor() {
	}

	/** A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the storage array object (e.g., volume, drive, ets.) to observe." , required = true)
	@XmlElement(required = true)
	private ObjectReference objectRef;

	/** @return A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	public ObjectReference getObjectRef() {
		return this.objectRef;
	}
	/** @param x A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	public void setObjectRef(ObjectReference x) {
		this.objectRef = x;
	}

	/** The type of statistic to observe in the activated streams. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of statistic to observe in the activated streams." , required = true)
	@XmlElement(required = true)
	private StatStreamType streamType = StatStreamType.__UNDEFINED;

	/** @return The type of statistic to observe in the activated streams. */
	public StatStreamType getStreamType() {
		return this.streamType;
	}
	/** @param x The type of statistic to observe in the activated streams. */
	public void setStreamType(StatStreamType x) {
		this.streamType = x;
	}

	/** The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten" , required = true)
	@XmlElement(required = true)
	private int duration;

	/** @return The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten */
	public int getDuration() {
		return this.duration;
	}
	/** @param x The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten */
	public void setDuration(int x) {
		this.duration = x;
	}

	/** The lowest value of interest for the stream. */
	@io.swagger.annotations.ApiModelProperty(value ="The lowest value of interest for the stream." , required = true)
	@XmlElement(required = true)
	private long lowestValue;

	/** @return The lowest value of interest for the stream. */
	public long getLowestValue() {
		return this.lowestValue;
	}
	/** @param x The lowest value of interest for the stream. */
	public void setLowestValue(long x) {
		this.lowestValue = x;
	}

	/** The number of values in the first category. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of values in the first category." , required = true)
	@XmlElement(required = true)
	private long lowestRange;

	/** @return The number of values in the first category. */
	public long getLowestRange() {
		return this.lowestRange;
	}
	/** @param x The number of values in the first category. */
	public void setLowestRange(long x) {
		this.lowestRange = x;
	}

	/** The type of scale to use for the histogram. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of scale to use for the histogram." , required = true)
	@XmlElement(required = true)
	private HistogramScaleType scaleType = HistogramScaleType.__UNDEFINED;

	/** @return The type of scale to use for the histogram. */
	public HistogramScaleType getScaleType() {
		return this.scaleType;
	}
	/** @param x The type of scale to use for the histogram. */
	public void setScaleType(HistogramScaleType x) {
		this.scaleType = x;
	}

	/** The number of categories in the histogram. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of categories in the histogram." , required = true)
	@XmlElement(required = true)
	private int numCategories;

	/** @return The number of categories in the histogram. */
	public int getNumCategories() {
		return this.numCategories;
	}
	/** @param x The number of categories in the histogram. */
	public void setNumCategories(int x) {
		this.numCategories = x;
	}
}
