package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the different scale types that can be applied to a histogram. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(262)
public enum HistogramScaleType implements Serializable {
		/** Indicates linear scaling of the histogram. */
		linear(0),
		/** Indicates base 2 logarithmic scaling of the histogram. */
		logBase2(1),
		/** Indicates base 10 logarithmic scaling of the histogram. */
		logBase10(2),
		__UNDEFINED(464378545);

		public final int value;

		private HistogramScaleType(int v) {
			this.value = v;
		}
}
