package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains summary information about a histogram. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(411)
public class HistogramSummary implements Serializable {
	public HistogramSummary() {
	}

	/** The total number of samples. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of samples." , required = true)
	@XmlElement(required = true)
	private long totalSamples;

	/** @return The total number of samples. */
	public long getTotalSamples() {
		return this.totalSamples;
	}
	/** @param x The total number of samples. */
	public void setTotalSamples(long x) {
		this.totalSamples = x;
	}

	/** The sum of all samples. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of all samples." , required = true)
	@XmlElement(required = true)
	private long sumSamples;

	/** @return The sum of all samples. */
	public long getSumSamples() {
		return this.sumSamples;
	}
	/** @param x The sum of all samples. */
	public void setSumSamples(long x) {
		this.sumSamples = x;
	}

	/** The minimum sampled value. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum sampled value." , required = true)
	@XmlElement(required = true)
	private long minSample;

	/** @return The minimum sampled value. */
	public long getMinSample() {
		return this.minSample;
	}
	/** @param x The minimum sampled value. */
	public void setMinSample(long x) {
		this.minSample = x;
	}

	/** The maximum sampled value. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum sampled value." , required = true)
	@XmlElement(required = true)
	private long maxSample;

	/** @return The maximum sampled value. */
	public long getMaxSample() {
		return this.maxSample;
	}
	/** @param x The maximum sampled value. */
	public void setMaxSample(long x) {
		this.maxSample = x;
	}
}
