package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the status of a controller's host board. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(109)
public enum HostBoardStatus implements Serializable {
		/** The status of the host board is unknown (generally due to conditions within the array that cause normal communication pathways to be unavailable). */
		unknown(0),
		/** The host board is working correctly. */
		optimal(1),
		/** The host board needs attention. */
		needsAttention(2),
		/** The host board is not present. This status is used to represent an empty host card slot, i.e., the controller model is defined such that it may receive a host card field upgrade, but currently has an unpopulated host card slot. */
		notPresent(3),
		/** The host board is in a degraded condition. This means that some, but not all, ports of the host board are unable to transport I/O. */
		degraded(4),
		/** The host board has failed and is unable to transport I/O. */
		failed(5),
		/** A diagnostic operation is currently running on the host board. */
		diagInProgress(6),
		__UNDEFINED(464378545);

		public final int value;

		private HostBoardStatus(int v) {
			this.value = v;
		}
}
