package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to indicate the type of a controller's host board. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(95)
public enum HostBoardType implements Serializable {
		/** The host board type is unknown. */
		typeUnknown(1),
		/** The host board is a standard XBB 4-port, 4GB Fibre Channel host board. */
		type4portFc(2),
		/** The host board is a Qlogic 4GB Fibre Channel switch having 20 ports, 16 of which are available externally. */
		type20portSwitchedFc(3),
		/** The host board is a single-port, serial-attached SCSI host board. */
		type1portSas(4),
		/** The host board is a 2-port, 4GB Fibre Channel host board. */
		type2portFc(5),
		/** The host board is a 2-port iSCSI host board. */
		type2portIscsi(6),
		/** The host board is a dual-port, serial-attached SCSI host board. */
		type2portSas(7),
		/** The host board is a 2-port InfiniBand host board. */
		type2portIb(8),
		/** The host board is a standard XBB 8-port, 4GB Fibre Channel host board. */
		type8portFc(9),
		/** The host board is a 4-port iSCSI host board. */
		type4portIscsi(10),
		/** The host board is a 4-port SAS host board. */
		type4portSas(11),
		/** The host board is a quad-port serial-attached SCSI Glacier host board. */
		type4portSasGlacier(12),
		/** The host board is a two-port FC-ISCSI Samoa board. */
		type2portFcIscsiSamoa(13),
		/** The host board is a quad-port Samoa board with two ports operating in iSCSI mode and two ports operating in FC mode. */
		type4portFcIscsiSamoa(14),
		/** The host board is a two-port iSCSI Zion host board. */
		type2portIscsiZion(15),
		/** The host board is a dual-port, serial-attached SCSI host board. */
		type2portSasAcadia(16),
		/** The host board is a 4-port, serial-attached SCSI host board. */
		type4portSasAcadia(17),
		/** The host board is a 2-port InfiniBand Denali host board. */
		type2portIbDenali(18),
		/** The host board is a 2-port FC Samoa board. */
		type2portFcSamoa(19),
		/** The host board is a 4-port FC Samoa board. */
		type4portFcSamoa(20),
		/** The host board is a 2-port iSCSI Samoa board. */
		type2portIscsiSamoa(21),
		/** The host board is a 4-port iSCSI Samoa board. */
		type4portIscsiSamoa(22),
		/** The host board is a 4-port 12Gb SAS (SAS3) board. */
		type4portSas3(23),
		/** The host board is a 2-port 100Gb Infiniband board. */
		type2portIb100gb(24),
		/** The host board is a 4-port 25Gb Ethernet board. */
		type4portEthernet25gb(25),
		/** The host board is a 4-port 32Gb Fibre Channel board. */
		type4portFc32gb(26),
		__UNDEFINED(464378545);

		public final int value;

		private HostBoardType(int v) {
			this.value = v;
		}
}
