package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type contains type-specific data for a particular host board type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(588)
public class HostBoardTypeData implements Serializable {
	public HostBoardTypeData() {
	}

	/** This enumeration object is used to indicate the type of a controller's host board. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to indicate the type of a controller's host board." , required = true)
	@XmlElement(required = true)
	private HostBoardType type = HostBoardType.__UNDEFINED;

	/** @return This enumeration object is used to indicate the type of a controller's host board. */
	public HostBoardType getType() {
		return this.type;
	}
	/** @param x This enumeration object is used to indicate the type of a controller's host board. */
	public void setType(HostBoardType x) {
		this.type = x;
	}

	/** Host board data for two-port InfiniBand host board. This field is only present if type is equal to HB_TYPE_2PORT_IB. */
	@io.swagger.annotations.ApiModelProperty(value ="Host board data for two-port InfiniBand host board. This field is only present if type is equal to HB_TYPE_2PORT_IB." , required = false)
	@XmlElement(required = false)
	private HostBoard2PortIbTypeData dualPortIbTypeData;

	/** @return Host board data for two-port InfiniBand host board. This field is only present if type is equal to HB_TYPE_2PORT_IB. */
	public HostBoard2PortIbTypeData getDualPortIbTypeData() {
		return this.dualPortIbTypeData;
	}
	/** @param x Host board data for two-port InfiniBand host board. This field is only present if type is equal to HB_TYPE_2PORT_IB. */
	public void setDualPortIbTypeData(HostBoard2PortIbTypeData x) {
		this.dualPortIbTypeData = x;
	}

	/** If the host board type is denali with two port infiniband, return the two port ib type data struct. */
	@io.swagger.annotations.ApiModelProperty(value ="If the host board type is denali with two port infiniband, return the two port ib type data struct." , required = false)
	@XmlElement(required = false)
	private HostBoard2PortIbTypeData dualPortDenaliIbTypeData;

	/** @return If the host board type is denali with two port infiniband, return the two port ib type data struct. */
	public HostBoard2PortIbTypeData getDualPortDenaliIbTypeData() {
		return this.dualPortDenaliIbTypeData;
	}
	/** @param x If the host board type is denali with two port infiniband, return the two port ib type data struct. */
	public void setDualPortDenaliIbTypeData(HostBoard2PortIbTypeData x) {
		this.dualPortDenaliIbTypeData = x;
	}
}
