package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the setHostProperties procedure. It indicates what properties the caller wants to change and the new values for those properties. To support changing a subset of these properties, all of the fields are variable-length arrays of maximum size one; If the caller does not want to change a property, the corresponding length indicator should be zero; otherwise the length indicator is one, and the single element is the new value of the property. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(734)
public class HostChangeableProperties implements Serializable {
	public HostChangeableProperties() {
	}

	/** The index value indicating the type of host. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object. */
	@io.swagger.annotations.ApiModelProperty(value ="The index value indicating the type of host. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object." , required = true)
	@XmlElement(required = true)
	private int[] hostTypeIndex;

	/** @return The index value indicating the type of host. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object. */
	public int[] getHostTypeIndex() {
		return this.hostTypeIndex;
	}
	/** @param x The index value indicating the type of host. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object. */
	public void setHostTypeIndex(int[] x) {
		this.hostTypeIndex = x;
	}

	/** The user-assigned, descriptive label string for the host. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned, descriptive label string for the host." , required = true)
	@XmlElement(required = true)
	private String[] label;

	/** @return The user-assigned, descriptive label string for the host. */
	public String[] getLabel() {
		return this.label;
	}
	/** @param x The user-assigned, descriptive label string for the host. */
	public void setLabel(String[] x) {
		this.label = x;
	}

	/** The cluster reference value of the cluster in which this host resides. A null reference (binary zeros) means that the host should not be attached to any cluster. */
	@io.swagger.annotations.ApiModelProperty(value ="The cluster reference value of the cluster in which this host resides. A null reference (binary zeros) means that the host should not be attached to any cluster." , required = true)
	@XmlElement(required = true)
	private String[] clusterRef;

	/** @return The cluster reference value of the cluster in which this host resides. A null reference (binary zeros) means that the host should not be attached to any cluster. */
	public String[] getClusterRef() {
		return this.clusterRef;
	}
	/** @param x The cluster reference value of the cluster in which this host resides. A null reference (binary zeros) means that the host should not be attached to any cluster. */
	public void setClusterRef(String[] x) {
		this.clusterRef = x;
	}
}
