package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as the argument when invoking the createHost procedure. It provides all of the user-specified information necessary to create a new Host object. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(825)
public class HostCreationDescriptor implements Serializable {
	public HostCreationDescriptor() {
	}

	/** The user-assigned, descriptive label string for the host. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned, descriptive label string for the host." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The user-assigned, descriptive label string for the host. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The user-assigned, descriptive label string for the host. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The cluster reference value of the cluster in which this host resides, or a null reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The cluster reference value of the cluster in which this host resides, or a null reference." , required = true)
	@XmlElement(required = true)
	private String clusterRef;

	/** @return The cluster reference value of the cluster in which this host resides, or a null reference. */
	public String getClusterRef() {
		return this.clusterRef;
	}
	/** @param x The cluster reference value of the cluster in which this host resides, or a null reference. */
	public void setClusterRef(String x) {
		this.clusterRef = x;
	}

	/** The initial settings for the new host. */
	@io.swagger.annotations.ApiModelProperty(value ="The initial settings for the new host." , required = true)
	@XmlElement(required = true)
	private HostChangeableProperties settings;

	/** @return The initial settings for the new host. */
	public HostChangeableProperties getSettings() {
		return this.settings;
	}
	/** @param x The initial settings for the new host. */
	public void setSettings(HostChangeableProperties x) {
		this.settings = x;
	}
}
