package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as part of the input argument for the setHostPortProperties procedure. It contains settings for various host port changeable properties. This structure is a replacement for the deprecated HostPortChangeableProperties. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1128)
public class HostPortMutableProperties implements Serializable {
	public HostPortMutableProperties() {
	}

	/** Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r */
	@io.swagger.annotations.ApiModelProperty(value ="Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r" , required = true)
	@XmlElement(required = true)
	private String[] label;

	/** @return Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r */
	public String[] getLabel() {
		return this.label;
	}
	/** @param x Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r */
	public void setLabel(String[] x) {
		this.label = x;
	}

	/** Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host. */
	@io.swagger.annotations.ApiModelProperty(value ="Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host." , required = true)
	@XmlElement(required = true)
	private String[] hostRef;

	/** @return Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host. */
	public String[] getHostRef() {
		return this.hostRef;
	}
	/** @param x Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host. */
	public void setHostRef(String[] x) {
		this.hostRef = x;
	}

	/** Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier */
	@io.swagger.annotations.ApiModelProperty(value ="Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier" , required = true)
	@XmlElement(required = true)
	private SCSIInitiatorPortId[] portId;

	/** @return Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier */
	public SCSIInitiatorPortId[] getPortId() {
		return this.portId;
	}
	/** @param x Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier */
	public void setPortId(SCSIInitiatorPortId[] x) {
		this.portId = x;
	}
}
