package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as the argument to the setHostPortType procedure; it provides all information needed to modify the type attribute of a HostPort object. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(504)
public class HostPortTypeUpdateDescriptor implements Serializable {
	public HostPortTypeUpdateDescriptor() {
	}

	/** The unique identification value that identifies the HostPort to be modified. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identification value that identifies the HostPort to be modified." , required = true)
	@XmlElement(required = true)
	private String hostPortRef;

	/** @return The unique identification value that identifies the HostPort to be modified. */
	public String getHostPortRef() {
		return this.hostPortRef;
	}
	/** @param x The unique identification value that identifies the HostPort to be modified. */
	public void setHostPortRef(String x) {
		this.hostPortRef = x;
	}

	/** The new index value that is to be used to identify the type of the HostPort object. */
	@io.swagger.annotations.ApiModelProperty(value ="The new index value that is to be used to identify the type of the HostPort object." , required = true)
	@XmlElement(required = true)
	private int hostPortTypeIndex;

	/** @return The new index value that is to be used to identify the type of the HostPort object. */
	public int getHostPortTypeIndex() {
		return this.hostPortTypeIndex;
	}
	/** @param x The new index value that is to be used to identify the type of the HostPort object. */
	public void setHostPortTypeIndex(int x) {
		this.hostPortTypeIndex = x;
	}
}
