package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the setHostPortsAttributes procedure and defines the set of changeable attributes for a HostPorts object. Each field has a length indicator that can be zero or one. A length indicator of zero means the value is not specified. With this design we can easily add additional attributes if need be in the future. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(622)
public class HostPortsChangeableAttributes implements Serializable {
	public HostPortsChangeableAttributes() {
	}

	/** This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. All interfaces/ports on this HostBoard will be set to the same speed */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. All interfaces/ports on this HostBoard will be set to the same speed" , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed[] maximumInterfaceSpeed;

	/** @return This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. All interfaces/ports on this HostBoard will be set to the same speed */
	public InterfaceSpeed[] getMaximumInterfaceSpeed() {
		return this.maximumInterfaceSpeed;
	}
	/** @param x This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. All interfaces/ports on this HostBoard will be set to the same speed */
	public void setMaximumInterfaceSpeed(InterfaceSpeed[] x) {
		this.maximumInterfaceSpeed = x;
	}
}
