package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** A HostSAConnection object describes a "connection" between a specific host-resident I/O port and specific controller-resident I/O port. Use of this object is not supported in the current version of the storage array firmware or SYMbol interface. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(926)
public class HostSAConnection implements Serializable {
	public HostSAConnection() {
	}

	/** The reference to the host-storage array connection. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the host-storage array connection." , required = true)
	@XmlElement(required = true)
	private String hostSAConnectionRef;

	/** @return The reference to the host-storage array connection. */
	public String getHostSAConnectionRef() {
		return this.hostSAConnectionRef;
	}
	/** @param x The reference to the host-storage array connection. */
	public void setHostSAConnectionRef(String x) {
		this.hostSAConnectionRef = x;
	}

	/** The host id. */
	@io.swagger.annotations.ApiModelProperty(value ="The host id." , required = true)
	@XmlElement(required = true)
	private int srcHostId;

	/** @return The host id. */
	public int getSrcHostId() {
		return this.srcHostId;
	}
	/** @param x The host id. */
	public void setSrcHostId(int x) {
		this.srcHostId = x;
	}

	/** The host port. */
	@io.swagger.annotations.ApiModelProperty(value ="The host port." , required = true)
	@XmlElement(required = true)
	private String hostPortRef;

	/** @return The host port. */
	public String getHostPortRef() {
		return this.hostPortRef;
	}
	/** @param x The host port. */
	public void setHostPortRef(String x) {
		this.hostPortRef = x;
	}

	/** The storage array port reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The storage array port reference." , required = true)
	@XmlElement(required = true)
	private String saPortRef;

	/** @return The storage array port reference. */
	public String getSaPortRef() {
		return this.saPortRef;
	}
	/** @param x The storage array port reference. */
	public void setSaPortRef(String x) {
		this.saPortRef = x;
	}

	/** set to true if the host is online. */
	@io.swagger.annotations.ApiModelProperty(value ="set to true if the host is online." , required = true)
	@XmlElement(required = true)
	private boolean online;

	/** @return set to true if the host is online. */
	public boolean isOnline() {
		return this.online;
	}
	/** @param x set to true if the host is online. */
	public void setOnline(boolean x) {
		this.online = x;
	}
}
