package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about an IOC Dump. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(303)
public class IOCDumpInfo implements Serializable {
	public IOCDumpInfo() {
	}

	/** The IOC Dump Tag. Each IOC Dump has a unique tag value. */
	@io.swagger.annotations.ApiModelProperty(value ="The IOC Dump Tag. Each IOC Dump has a unique tag value." , required = true)
	@XmlElement(required = true)
	private int iocDumpTag;

	/** @return The IOC Dump Tag. Each IOC Dump has a unique tag value. */
	public int getIocDumpTag() {
		return this.iocDumpTag;
	}
	/** @param x The IOC Dump Tag. Each IOC Dump has a unique tag value. */
	public void setIocDumpTag(int x) {
		this.iocDumpTag = x;
	}

	/** The time that the IOC Dump was captured measured in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the IOC Dump was captured measured in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long captureTime;

	/** @return The time that the IOC Dump was captured measured in seconds since January 1, 1970. */
	public long getCaptureTime() {
		return this.captureTime;
	}
	/** @param x The time that the IOC Dump was captured measured in seconds since January 1, 1970. */
	public void setCaptureTime(long x) {
		this.captureTime = x;
	}

	/** The channel number. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The size of the IOC Dump in megabytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the IOC Dump in megabytes." , required = true)
	@XmlElement(required = true)
	private int captureSize;

	/** @return The size of the IOC Dump in megabytes. */
	public int getCaptureSize() {
		return this.captureSize;
	}
	/** @param x The size of the IOC Dump in megabytes. */
	public void setCaptureSize(int x) {
		this.captureSize = x;
	}

	/** The controller firmware version at the time the IOC Dump was captured. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller firmware version at the time the IOC Dump was captured." , required = true)
	@XmlElement(required = true)
	private String fwVersion;

	/** @return The controller firmware version at the time the IOC Dump was captured. */
	public String getFwVersion() {
		return this.fwVersion;
	}
	/** @param x The controller firmware version at the time the IOC Dump was captured. */
	public void setFwVersion(String x) {
		this.fwVersion = x;
	}

	/** The reason for the IOC Dump. */
	@io.swagger.annotations.ApiModelProperty(value ="The reason for the IOC Dump." , required = true)
	@XmlElement(required = true)
	private IOCDumpReason iocDumpReason = IOCDumpReason.__UNDEFINED;

	/** @return The reason for the IOC Dump. */
	public IOCDumpReason getIocDumpReason() {
		return this.iocDumpReason;
	}
	/** @param x The reason for the IOC Dump. */
	public void setIocDumpReason(IOCDumpReason x) {
		this.iocDumpReason = x;
	}
}
