package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains information returned by the triggerIOCDumpOnDemand procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(549)
public class IOCDumpOnDemandReturn implements Serializable {
	public IOCDumpOnDemandReturn() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is present only if the value of returnCode is equal to RETCODE_OK. The value of the tag is unique for each IOC dump. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of returnCode is equal to RETCODE_OK. The value of the tag is unique for each IOC dump." , required = false)
	@XmlElement(required = false)
	private int iocDumpTag;

	/** @return This field is present only if the value of returnCode is equal to RETCODE_OK. The value of the tag is unique for each IOC dump. */
	public int getIocDumpTag() {
		return this.iocDumpTag;
	}
	/** @param x This field is present only if the value of returnCode is equal to RETCODE_OK. The value of the tag is unique for each IOC dump. */
	public void setIocDumpTag(int x) {
		this.iocDumpTag = x;
	}
}
