package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(276)
public enum IOInterfaceType implements Serializable {
		/** No interface type has been implemented. */
		notImplemented(0),
		/** The interface type is SCSI. This field is obsolete. */
		scsi(1),
		/** The interface type is Fibre Channel (FC). */
		fc(2),
		/** The interface type is serial ATA. */
		sata(3),
		/** Serial-Attached SCSI */
		sas(4),
		/** Internet SCSI */
		iscsi(5),
		/** Infiniband */
		ib(6),
		/** The interface type is FCOE. */
		fcoe(7),
		/** The interface type is NVMe over Fabrics. */
		nvmeof(8),
		__UNDEFINED(464378545);

		public final int value;

		private IOInterfaceType(int v) {
			this.value = v;
		}
}
