package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about an I/O interface's type-specific data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1214)
public class IOInterfaceTypeData implements Serializable {
	public IOInterfaceTypeData() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType interfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getInterfaceType() {
		return this.interfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setInterfaceType(IOInterfaceType x) {
		this.interfaceType = x;
	}

	/** This field is present only if the interfaceType value is equal to IO_IF_FC. It contains the detailed interface information for a Fibre Channel I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to IO_IF_FC. It contains the detailed interface information for a Fibre Channel I/O interface." , required = false)
	@XmlElement(required = false)
	private FibreInterface fibre;

	/** @return This field is present only if the interfaceType value is equal to IO_IF_FC. It contains the detailed interface information for a Fibre Channel I/O interface. */
	public FibreInterface getFibre() {
		return this.fibre;
	}
	/** @param x This field is present only if the interfaceType value is equal to IO_IF_FC. It contains the detailed interface information for a Fibre Channel I/O interface. */
	public void setFibre(FibreInterface x) {
		this.fibre = x;
	}

	/** This field is present only if the interfaceType value is equal to IO_IF_IB. It contains the detailed interface information for an Infiniband interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to IO_IF_IB. It contains the detailed interface information for an Infiniband interface." , required = false)
	@XmlElement(required = false)
	private IbInterface ib;

	/** @return This field is present only if the interfaceType value is equal to IO_IF_IB. It contains the detailed interface information for an Infiniband interface. */
	public IbInterface getIb() {
		return this.ib;
	}
	/** @param x This field is present only if the interfaceType value is equal to IO_IF_IB. It contains the detailed interface information for an Infiniband interface. */
	public void setIb(IbInterface x) {
		this.ib = x;
	}

	/** This field is present only if the interface type value is equal to IO_IF_ISCSI. It contains the detailed interface information for an iSCSI I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interface type value is equal to IO_IF_ISCSI. It contains the detailed interface information for an iSCSI I/O interface." , required = false)
	@XmlElement(required = false)
	private IscsiInterface iscsi;

	/** @return This field is present only if the interface type value is equal to IO_IF_ISCSI. It contains the detailed interface information for an iSCSI I/O interface. */
	public IscsiInterface getIscsi() {
		return this.iscsi;
	}
	/** @param x This field is present only if the interface type value is equal to IO_IF_ISCSI. It contains the detailed interface information for an iSCSI I/O interface. */
	public void setIscsi(IscsiInterface x) {
		this.iscsi = x;
	}

	/** This field is present only if the interfaceType value is equal to IO_IF_SAS. It contains the detailed interface information for a serial-attached SCSI I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to IO_IF_SAS. It contains the detailed interface information for a serial-attached SCSI I/O interface." , required = false)
	@XmlElement(required = false)
	private SasInterface sas;

	/** @return This field is present only if the interfaceType value is equal to IO_IF_SAS. It contains the detailed interface information for a serial-attached SCSI I/O interface. */
	public SasInterface getSas() {
		return this.sas;
	}
	/** @param x This field is present only if the interfaceType value is equal to IO_IF_SAS. It contains the detailed interface information for a serial-attached SCSI I/O interface. */
	public void setSas(SasInterface x) {
		this.sas = x;
	}

	/** This field is present only if the interfaceType value is equal to IO_IF_SATA. It contains the detailed interface information for a SATA I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to IO_IF_SATA. It contains the detailed interface information for a SATA I/O interface." , required = false)
	@XmlElement(required = false)
	private SATAInterface sata;

	/** @return This field is present only if the interfaceType value is equal to IO_IF_SATA. It contains the detailed interface information for a SATA I/O interface. */
	public SATAInterface getSata() {
		return this.sata;
	}
	/** @param x This field is present only if the interfaceType value is equal to IO_IF_SATA. It contains the detailed interface information for a SATA I/O interface. */
	public void setSata(SATAInterface x) {
		this.sata = x;
	}

	/** This field is present only if the interfaceType value is equal to IO_IF_SCSI. It contains the detailed interface information for a SCSI I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to IO_IF_SCSI. It contains the detailed interface information for a SCSI I/O interface." , required = false)
	@XmlElement(required = false)
	private SCSIInterface scsi;

	/** @return This field is present only if the interfaceType value is equal to IO_IF_SCSI. It contains the detailed interface information for a SCSI I/O interface. */
	public SCSIInterface getScsi() {
		return this.scsi;
	}
	/** @param x This field is present only if the interfaceType value is equal to IO_IF_SCSI. It contains the detailed interface information for a SCSI I/O interface. */
	public void setScsi(SCSIInterface x) {
		this.scsi = x;
	}
}
