package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure stores information about a group of iSCSI initiators (hosts) and targets (storage arrays) in an iSCSI environment. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1048)
public class ITNexus implements Serializable {
	public ITNexus() {
	}

	/** The TCP port of an iSCSI initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="The TCP port of an iSCSI initiator." , required = true)
	@XmlElement(required = true)
	private SCSIInitiatorPortId initiatorPortId;

	/** @return The TCP port of an iSCSI initiator. */
	public SCSIInitiatorPortId getInitiatorPortId() {
		return this.initiatorPortId;
	}
	/** @param x The TCP port of an iSCSI initiator. */
	public void setInitiatorPortId(SCSIInitiatorPortId x) {
		this.initiatorPortId = x;
	}

	/** The TCP port of an iSCSI target. */
	@io.swagger.annotations.ApiModelProperty(value ="The TCP port of an iSCSI target." , required = true)
	@XmlElement(required = true)
	private SCSITargetPortId targetPortId;

	/** @return The TCP port of an iSCSI target. */
	public SCSITargetPortId getTargetPortId() {
		return this.targetPortId;
	}
	/** @param x The TCP port of an iSCSI target. */
	public void setTargetPortId(SCSITargetPortId x) {
		this.targetPortId = x;
	}

	/** The user label for a host port (iSCSI host initiator). */
	@io.swagger.annotations.ApiModelProperty(value ="The user label for a host port (iSCSI host initiator)." , required = true)
	@XmlElement(required = true)
	private String hostLabel;

	/** @return The user label for a host port (iSCSI host initiator). */
	public String getHostLabel() {
		return this.hostLabel;
	}
	/** @param x The user label for a host port (iSCSI host initiator). */
	public void setHostLabel(String x) {
		this.hostLabel = x;
	}
}
