package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure shows the InfiniBand statistical data that is relative to a pre-set baseline. These statistics consist of start-of-day-relative counters, and user-baseline-relative counters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(754)
public class IbBaselinedStatistics implements Serializable {
	public IbBaselinedStatistics() {
	}

	/** The time data associated with this set of statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="The time data associated with this set of statistics." , required = true)
	@XmlElement(required = true)
	private StatisticalTimeData timeData;

	/** @return The time data associated with this set of statistics. */
	public StatisticalTimeData getTimeData() {
		return this.timeData;
	}
	/** @param x The time data associated with this set of statistics. */
	public void setTimeData(StatisticalTimeData x) {
		this.timeData = x;
	}

	/** An array of structures containing "raw" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing \"raw\" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface." , required = true)
	@XmlElement(required = true)
	private IbInterfaceStatistics[] ibInterfaceStatisticsRaw;

	/** @return An array of structures containing "raw" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	public IbInterfaceStatistics[] getIbInterfaceStatisticsRaw() {
		return this.ibInterfaceStatisticsRaw;
	}
	/** @param x An array of structures containing "raw" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	public void setIbInterfaceStatisticsRaw(IbInterfaceStatistics[] x) {
		this.ibInterfaceStatisticsRaw = x;
	}

	/** An array of structures containing "relative" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing \"relative\" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface." , required = true)
	@XmlElement(required = true)
	private IbInterfaceStatistics[] ibInterfaceStatisticsRel;

	/** @return An array of structures containing "relative" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	public IbInterfaceStatistics[] getIbInterfaceStatisticsRel() {
		return this.ibInterfaceStatisticsRel;
	}
	/** @param x An array of structures containing "relative" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface. */
	public void setIbInterfaceStatisticsRel(IbInterfaceStatistics[] x) {
		this.ibInterfaceStatisticsRel = x;
	}
}
