package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes an InfiniBand host-side interface on the storage array controller. There is an instance of this structure for every physical interface. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(994)
public class IbInterface implements Serializable,devmgr.api.model.Identifiable {
	public IbInterface() {
	}

	/** The opaque data by which an instance of IbInterface is uniquely identified. */
	@io.swagger.annotations.ApiModelProperty(value ="The opaque data by which an instance of IbInterface is uniquely identified." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The opaque data by which an instance of IbInterface is uniquely identified. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The opaque data by which an instance of IbInterface is uniquely identified. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The number of the host channel associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the host channel associated with this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The number of the host channel associated with this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The number of the host channel associated with this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** A reference to the channel port for the channel associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the channel port for the channel associated with this interface." , required = true)
	@XmlElement(required = true)
	private String channelPortRef;

	/** @return A reference to the channel port for the channel associated with this interface. */
	public String getChannelPortRef() {
		return this.channelPortRef;
	}
	/** @param x A reference to the channel port for the channel associated with this interface. */
	public void setChannelPortRef(String x) {
		this.channelPortRef = x;
	}

	/** The InfiniBand local identifier associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The InfiniBand local identifier associated with this interface." , required = true)
	@XmlElement(required = true)
	private int localIdentifier;

	/** @return The InfiniBand local identifier associated with this interface. */
	public int getLocalIdentifier() {
		return this.localIdentifier;
	}
	/** @param x The InfiniBand local identifier associated with this interface. */
	public void setLocalIdentifier(int x) {
		this.localIdentifier = x;
	}

	/** The InfiniBand global identifier associated with this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The InfiniBand global identifier associated with this interface." , required = true)
	@XmlElement(required = true)
	private String globalIdentifier;

	/** @return The InfiniBand global identifier associated with this interface. */
	public String getGlobalIdentifier() {
		return this.globalIdentifier;
	}
	/** @param x The InfiniBand global identifier associated with this interface. */
	public void setGlobalIdentifier(String x) {
		this.globalIdentifier = x;
	}

	/** The state of the InfiniBand link. */
	@io.swagger.annotations.ApiModelProperty(value ="The state of the InfiniBand link." , required = true)
	@XmlElement(required = true)
	private IbLinkState linkState = IbLinkState.__UNDEFINED;

	/** @return The state of the InfiniBand link. */
	public IbLinkState getLinkState() {
		return this.linkState;
	}
	/** @param x The state of the InfiniBand link. */
	public void setLinkState(IbLinkState x) {
		this.linkState = x;
	}

	/** The state of the InfiniBand port. */
	@io.swagger.annotations.ApiModelProperty(value ="The state of the InfiniBand port." , required = true)
	@XmlElement(required = true)
	private IbPortState portState = IbPortState.__UNDEFINED;

	/** @return The state of the InfiniBand port. */
	public IbPortState getPortState() {
		return this.portState;
	}
	/** @param x The state of the InfiniBand port. */
	public void setPortState(IbPortState x) {
		this.portState = x;
	}

	/** The size in bytes of the largest packet that the interface can transmit. */
	@io.swagger.annotations.ApiModelProperty(value ="The size in bytes of the largest packet that the interface can transmit." , required = true)
	@XmlElement(required = true)
	private int maximumTransmissionUnit;

	/** @return The size in bytes of the largest packet that the interface can transmit. */
	public int getMaximumTransmissionUnit() {
		return this.maximumTransmissionUnit;
	}
	/** @param x The size in bytes of the largest packet that the interface can transmit. */
	public void setMaximumTransmissionUnit(int x) {
		this.maximumTransmissionUnit = x;
	}

	/** The speed at which the interface is currently operating. */
	@io.swagger.annotations.ApiModelProperty(value ="The speed at which the interface is currently operating." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed currentSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The speed at which the interface is currently operating. */
	public InterfaceSpeed getCurrentSpeed() {
		return this.currentSpeed;
	}
	/** @param x The speed at which the interface is currently operating. */
	public void setCurrentSpeed(InterfaceSpeed x) {
		this.currentSpeed = x;
	}

	/** An array containing the different speeds at which the interface is capable of operating. */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing the different speeds at which the interface is capable of operating." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed[] supportedSpeed;

	/** @return An array containing the different speeds at which the interface is capable of operating. */
	public InterfaceSpeed[] getSupportedSpeed() {
		return this.supportedSpeed;
	}
	/** @param x An array containing the different speeds at which the interface is capable of operating. */
	public void setSupportedSpeed(InterfaceSpeed[] x) {
		this.supportedSpeed = x;
	}

	/** The width at which the link is currently operating, e.g., 1 means "1X," 4 means "4X,".etc. */
	@io.swagger.annotations.ApiModelProperty(value ="The width at which the link is currently operating, e.g., 1 means \"1X,\" 4 means \"4X,\".etc." , required = true)
	@XmlElement(required = true)
	private IbLinkWidth currentLinkWidth = IbLinkWidth.__UNDEFINED;

	/** @return The width at which the link is currently operating, e.g., 1 means "1X," 4 means "4X,".etc. */
	public IbLinkWidth getCurrentLinkWidth() {
		return this.currentLinkWidth;
	}
	/** @param x The width at which the link is currently operating, e.g., 1 means "1X," 4 means "4X,".etc. */
	public void setCurrentLinkWidth(IbLinkWidth x) {
		this.currentLinkWidth = x;
	}

	/** An array containing the different link widths at which the link is capable of operating. */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing the different link widths at which the link is capable of operating." , required = true)
	@XmlElement(required = true)
	private IbLinkWidth[] supportedLinkWidth;

	/** @return An array containing the different link widths at which the link is capable of operating. */
	public IbLinkWidth[] getSupportedLinkWidth() {
		return this.supportedLinkWidth;
	}
	/** @param x An array containing the different link widths at which the link is capable of operating. */
	public void setSupportedLinkWidth(IbLinkWidth[] x) {
		this.supportedLinkWidth = x;
	}

	/** The number of data virtual lanes that are currently active for this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of data virtual lanes that are currently active for this interface." , required = true)
	@XmlElement(required = true)
	private int currentDataVirtualLanes;

	/** @return The number of data virtual lanes that are currently active for this interface. */
	public int getCurrentDataVirtualLanes() {
		return this.currentDataVirtualLanes;
	}
	/** @param x The number of data virtual lanes that are currently active for this interface. */
	public void setCurrentDataVirtualLanes(int x) {
		this.currentDataVirtualLanes = x;
	}

	/** The maximum number of data virtual lanes supported by the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum number of data virtual lanes supported by the interface." , required = true)
	@XmlElement(required = true)
	private int maximumDataVirtualLanes;

	/** @return The maximum number of data virtual lanes supported by the interface. */
	public int getMaximumDataVirtualLanes() {
		return this.maximumDataVirtualLanes;
	}
	/** @param x The maximum number of data virtual lanes supported by the interface. */
	public void setMaximumDataVirtualLanes(int x) {
		this.maximumDataVirtualLanes = x;
	}

	/** The physical location of the Infiniband interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Infiniband interface relative to the parent," "2nd Infiniband interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the Infiniband interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying \"1st Infiniband interface relative to the parent,\" \"2nd Infiniband interface relative to the parent,\" etc. This \"interface number\" is independent of the interface's channel association." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the Infiniband interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Infiniband interface relative to the parent," "2nd Infiniband interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the Infiniband interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st Infiniband interface relative to the parent," "2nd Infiniband interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** This field indicates whether or not the I/O interface is PI capable. */
	@io.swagger.annotations.ApiModelProperty(value ="This field indicates whether or not the I/O interface is PI capable." , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	/** @return This field indicates whether or not the I/O interface is PI capable. */
	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	/** @param x This field indicates whether or not the I/O interface is PI capable. */
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}

	/** This flag is true if SRP (SCSI RDMA Protocol) is currently supported. */
	@io.swagger.annotations.ApiModelProperty(value ="This flag is true if SRP (SCSI RDMA Protocol) is currently supported." , required = true)
	@XmlElement(required = true)
	private boolean isSRPSupported;

	/** @return This flag is true if SRP (SCSI RDMA Protocol) is currently supported. */
	public boolean isIsSRPSupported() {
		return this.isSRPSupported;
	}
	/** @param x This flag is true if SRP (SCSI RDMA Protocol) is currently supported. */
	public void setIsSRPSupported(boolean x) {
		this.isSRPSupported = x;
	}

	/** This flag is true if iSER (iSCSI Extensions for RDMA) is currently supported. */
	@io.swagger.annotations.ApiModelProperty(value ="This flag is true if iSER (iSCSI Extensions for RDMA) is currently supported." , required = true)
	@XmlElement(required = true)
	private boolean isISERSupported;

	/** @return This flag is true if iSER (iSCSI Extensions for RDMA) is currently supported. */
	public boolean isIsISERSupported() {
		return this.isISERSupported;
	}
	/** @param x This flag is true if iSER (iSCSI Extensions for RDMA) is currently supported. */
	public void setIsISERSupported(boolean x) {
		this.isISERSupported = x;
	}

	/** This element contains the current state of the physical Infiniband port. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the current state of the physical Infiniband port." , required = true)
	@XmlElement(required = true)
	private IbPhysPortState physPortState = IbPhysPortState.__UNDEFINED;

	/** @return This element contains the current state of the physical Infiniband port. */
	public IbPhysPortState getPhysPortState() {
		return this.physPortState;
	}
	/** @param x This element contains the current state of the physical Infiniband port. */
	public void setPhysPortState(IbPhysPortState x) {
		this.physPortState = x;
	}

	/** Maximum one way data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum one way data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long oneWayMaxRate;

	/** @return Maximum one way data rate in B/s */
	public long getOneWayMaxRate() {
		return this.oneWayMaxRate;
	}
	/** @param x Maximum one way data rate in B/s */
	public void setOneWayMaxRate(long x) {
		this.oneWayMaxRate = x;
	}

	/** Maximum bi-directional data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum bi-directional data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long bidirectionalMaxRate;

	/** @return Maximum bi-directional data rate in B/s */
	public long getBidirectionalMaxRate() {
		return this.bidirectionalMaxRate;
	}
	/** @param x Maximum bi-directional data rate in B/s */
	public void setBidirectionalMaxRate(long x) {
		this.bidirectionalMaxRate = x;
	}

	/** Indicates if the interface is configured to support NVMe over Fabrics protocol */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates if the interface is configured to support NVMe over Fabrics protocol" , required = true)
	@XmlElement(required = true)
	private boolean isNVMeSupported;

	/** @return Indicates if the interface is configured to support NVMe over Fabrics protocol */
	public boolean isIsNVMeSupported() {
		return this.isNVMeSupported;
	}
	/** @param x Indicates if the interface is configured to support NVMe over Fabrics protocol */
	public void setIsNVMeSupported(boolean x) {
		this.isNVMeSupported = x;
	}
	@Override
	public String getId(){
		return interfaceRef;
	}
}
