package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains returned data for the getIbIocAttributes procedure. It consists of attributes for one InfiniBand I/O controller in the InfiniBand I/O Unit. An InfiniBand I/O Controller is a logical entity defined in the InfiniBand Architecture. It does not correlate one-to-one with a storage array controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(748)
public class IbIocAttributes implements Serializable {
	public IbIocAttributes() {
	}

	/** A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated." , required = true)
	@XmlElement(required = true)
	private String hostBoardRef;

	/** @return A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated. */
	public String getHostBoardRef() {
		return this.hostBoardRef;
	}
	/** @param x A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated. */
	public void setHostBoardRef(String x) {
		this.hostBoardRef = x;
	}

	/** The I/O controller profile for the storage array controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The I/O controller profile for the storage array controller." , required = true)
	@XmlElement(required = true)
	private IbIocProfile iocProfile;

	/** @return The I/O controller profile for the storage array controller. */
	public IbIocProfile getIocProfile() {
		return this.iocProfile;
	}
	/** @param x The I/O controller profile for the storage array controller. */
	public void setIocProfile(IbIocProfile x) {
		this.iocProfile = x;
	}

	/** An array of structures indicating the services that are provided by the InfiniBand I/O controller. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures indicating the services that are provided by the InfiniBand I/O controller." , required = true)
	@XmlElement(required = true)
	private IbServiceEntry[] serviceEntries;

	/** @return An array of structures indicating the services that are provided by the InfiniBand I/O controller. */
	public IbServiceEntry[] getServiceEntries() {
		return this.serviceEntries;
	}
	/** @param x An array of structures indicating the services that are provided by the InfiniBand I/O controller. */
	public void setServiceEntries(IbServiceEntry[] x) {
		this.serviceEntries = x;
	}
}
