package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the InfiniBand "point in time" statistics, i.e., those statistics that are simply readings of certain values at the point in time of the getIbStatistics request. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1021)
public class IbPointInTimeStatistics implements Serializable {
	public IbPointInTimeStatistics() {
	}

	/** A timestamp, expressed as number of seconds since midnight GMT on January 1, 1970, which is the time at which the statistics were read by the controller firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="A timestamp, expressed as number of seconds since midnight GMT on January 1, 1970, which is the time at which the statistics were read by the controller firmware." , required = true)
	@XmlElement(required = true)
	private long timeOfReading;

	/** @return A timestamp, expressed as number of seconds since midnight GMT on January 1, 1970, which is the time at which the statistics were read by the controller firmware. */
	public long getTimeOfReading() {
		return this.timeOfReading;
	}
	/** @param x A timestamp, expressed as number of seconds since midnight GMT on January 1, 1970, which is the time at which the statistics were read by the controller firmware. */
	public void setTimeOfReading(long x) {
		this.timeOfReading = x;
	}

	/** An array of structures containing the IB TCA statistics, one structure per TCA (i.e., InfiniBand host board). */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing the IB TCA statistics, one structure per TCA (i.e., InfiniBand host board)." , required = true)
	@XmlElement(required = true)
	private IbTcaStatistics[] ibTcaStatistics;

	/** @return An array of structures containing the IB TCA statistics, one structure per TCA (i.e., InfiniBand host board). */
	public IbTcaStatistics[] getIbTcaStatistics() {
		return this.ibTcaStatistics;
	}
	/** @param x An array of structures containing the IB TCA statistics, one structure per TCA (i.e., InfiniBand host board). */
	public void setIbTcaStatistics(IbTcaStatistics[] x) {
		this.ibTcaStatistics = x;
	}

	/** An array of structures containing the IB RDMA channel statistics, one structure per RDMA channel. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing the IB RDMA channel statistics, one structure per RDMA channel." , required = true)
	@XmlElement(required = true)
	private IbRdmaChannelStatistics[] ibRdmaChannelStatistics;

	/** @return An array of structures containing the IB RDMA channel statistics, one structure per RDMA channel. */
	public IbRdmaChannelStatistics[] getIbRdmaChannelStatistics() {
		return this.ibRdmaChannelStatistics;
	}
	/** @param x An array of structures containing the IB RDMA channel statistics, one structure per RDMA channel. */
	public void setIbRdmaChannelStatistics(IbRdmaChannelStatistics[] x) {
		this.ibRdmaChannelStatistics = x;
	}
}
