package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information describing an individual RDMA channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(775)
public class IbRdmaChannel implements Serializable {
	public IbRdmaChannel() {
	}

	/** This field identifies the RDMA channel by identifying its initiator and target endpoints. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the RDMA channel by identifying its initiator and target endpoints." , required = true)
	@XmlElement(required = true)
	private IbRdmaChannelEndpoints endpoints;

	/** @return This field identifies the RDMA channel by identifying its initiator and target endpoints. */
	public IbRdmaChannelEndpoints getEndpoints() {
		return this.endpoints;
	}
	/** @param x This field identifies the RDMA channel by identifying its initiator and target endpoints. */
	public void setEndpoints(IbRdmaChannelEndpoints x) {
		this.endpoints = x;
	}

	/** The maximum supported RDMA message size or this RDMA channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum supported RDMA message size or this RDMA channel." , required = true)
	@XmlElement(required = true)
	private int maximumRdmaMessageSize;

	/** @return The maximum supported RDMA message size or this RDMA channel. */
	public int getMaximumRdmaMessageSize() {
		return this.maximumRdmaMessageSize;
	}
	/** @param x The maximum supported RDMA message size or this RDMA channel. */
	public void setMaximumRdmaMessageSize(int x) {
		this.maximumRdmaMessageSize = x;
	}

	/** The maximum supported transmission unit for the path associated with the RDMA channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum supported transmission unit for the path associated with the RDMA channel." , required = true)
	@XmlElement(required = true)
	private int pathMaximumTransmissionUnit;

	/** @return The maximum supported transmission unit for the path associated with the RDMA channel. */
	public int getPathMaximumTransmissionUnit() {
		return this.pathMaximumTransmissionUnit;
	}
	/** @param x The maximum supported transmission unit for the path associated with the RDMA channel. */
	public void setPathMaximumTransmissionUnit(int x) {
		this.pathMaximumTransmissionUnit = x;
	}

	/** The maximum supported queue depth for this RDMA channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum supported queue depth for this RDMA channel." , required = true)
	@XmlElement(required = true)
	private int maximumQueueDepth;

	/** @return The maximum supported queue depth for this RDMA channel. */
	public int getMaximumQueueDepth() {
		return this.maximumQueueDepth;
	}
	/** @param x The maximum supported queue depth for this RDMA channel. */
	public void setMaximumQueueDepth(int x) {
		this.maximumQueueDepth = x;
	}

	/** The current state of this RDMA channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The current state of this RDMA channel." , required = true)
	@XmlElement(required = true)
	private IbRdmaChannelState channelState = IbRdmaChannelState.__UNDEFINED;

	/** @return The current state of this RDMA channel. */
	public IbRdmaChannelState getChannelState() {
		return this.channelState;
	}
	/** @param x The current state of this RDMA channel. */
	public void setChannelState(IbRdmaChannelState x) {
		this.channelState = x;
	}
}
