package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure uniquely identifies an InfiniBand RDMA channel by defining its endpoints. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(653)
public class IbRdmaChannelEndpoints implements Serializable {
	public IbRdmaChannelEndpoints() {
	}

	/** The InfiniBand global identifier of the initiator port. */
	@io.swagger.annotations.ApiModelProperty(value ="The InfiniBand global identifier of the initiator port." , required = true)
	@XmlElement(required = true)
	private String initiatorPortId;

	/** @return The InfiniBand global identifier of the initiator port. */
	public String getInitiatorPortId() {
		return this.initiatorPortId;
	}
	/** @param x The InfiniBand global identifier of the initiator port. */
	public void setInitiatorPortId(String x) {
		this.initiatorPortId = x;
	}

	/** The InfiniBand global identifier of the target port. */
	@io.swagger.annotations.ApiModelProperty(value ="The InfiniBand global identifier of the target port." , required = true)
	@XmlElement(required = true)
	private String targetPortId;

	/** @return The InfiniBand global identifier of the target port. */
	public String getTargetPortId() {
		return this.targetPortId;
	}
	/** @param x The InfiniBand global identifier of the target port. */
	public void setTargetPortId(String x) {
		this.targetPortId = x;
	}

	/** A reference to the target channel port. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the target channel port." , required = true)
	@XmlElement(required = true)
	private String targetChannelPort;

	/** @return A reference to the target channel port. */
	public String getTargetChannelPort() {
		return this.targetChannelPort;
	}
	/** @param x A reference to the target channel port. */
	public void setTargetChannelPort(String x) {
		this.targetChannelPort = x;
	}
}
