package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration data type identifies the possible states of an InfiniBand RDMA channel. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(189)
public enum IbRdmaChannelState implements Serializable {
		/** The RDMA channel is not initialized. */
		uninitialized(1),
		/** The RDMA channel is in the process of establishing the connection. */
		connecting(2),
		/** The RDMA channel has an active connection. */
		connected(3),
		/** The RDMA channel is in the process of disconnecting. */
		disconnecting(4),
		/** The connection on the RDMA channel has been terminated. */
		disconnected(5),
		__UNDEFINED(464378545);

		public final int value;

		private IbRdmaChannelState(int v) {
			this.value = v;
		}
}
