package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is returned by the getIbRdmaChannels procedure. It contains the procedure return code, and, if the procedure call was successful, the RDMA channel information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(886)
public class IbRdmaChannelsReturned implements Serializable {
	public IbRdmaChannelsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** An array of structures containing information about an RDMA channel, one structure per currently-active channel. This field is only present when returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing information about an RDMA channel, one structure per currently-active channel. This field is only present when returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private IbRdmaChannel[] rdmaChannels;

	/** @return An array of structures containing information about an RDMA channel, one structure per currently-active channel. This field is only present when returnCode is equal to RETCODE_OK. */
	public IbRdmaChannel[] getRdmaChannels() {
		return this.rdmaChannels;
	}
	/** @param x An array of structures containing information about an RDMA channel, one structure per currently-active channel. This field is only present when returnCode is equal to RETCODE_OK. */
	public void setRdmaChannels(IbRdmaChannel[] x) {
		this.rdmaChannels = x;
	}
}
