package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is a counter group containing RAID-implementation-related statistical counters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(484)
public class ImplementationCounterGroup implements Serializable {
	public ImplementationCounterGroup() {
	}

	/** A reference to the controller that accumulated the counters for this group. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller that accumulated the counters for this group." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return A reference to the controller that accumulated the counters for this group. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x A reference to the controller that accumulated the counters for this group. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long baseTime;

	/** @return The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public long getBaseTime() {
		return this.baseTime;
	}
	/** @param x The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public void setBaseTime(long x) {
		this.baseTime = x;
	}

	/** The number of read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitOps;

	/** @return The number of read operations that hit cache. */
	public long getReadHitOps() {
		return this.readHitOps;
	}
	/** @param x The number of read operations that hit cache. */
	public void setReadHitOps(long x) {
		this.readHitOps = x;
	}

	/** The number of bytes read that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes read that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitBytes;

	/** @return The number of bytes read that hit cache. */
	public long getReadHitBytes() {
		return this.readHitBytes;
	}
	/** @param x The number of bytes read that hit cache. */
	public void setReadHitBytes(long x) {
		this.readHitBytes = x;
	}

	/** The total time in microseconds spent in read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeTotal;

	/** @return The total time in microseconds spent in read operations that hit cache. */
	public long getReadHitTimeTotal() {
		return this.readHitTimeTotal;
	}
	/** @param x The total time in microseconds spent in read operations that hit cache. */
	public void setReadHitTimeTotal(long x) {
		this.readHitTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one read operation that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one read operation that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeMax;

	/** @return The maximum time in microseconds spent in any one read operation that hit cache. */
	public long getReadHitTimeMax() {
		return this.readHitTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one read operation that hit cache. */
	public void setReadHitTimeMax(long x) {
		this.readHitTimeMax = x;
	}

	/** The number of stripe reads that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of stripe reads that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitStripes;

	/** @return The number of stripe reads that hit cache. */
	public long getReadHitStripes() {
		return this.readHitStripes;
	}
	/** @param x The number of stripe reads that hit cache. */
	public void setReadHitStripes(long x) {
		this.readHitStripes = x;
	}

	/** The number of segment reads that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of segment reads that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitSegments;

	/** @return The number of segment reads that hit cache. */
	public long getReadHitSegments() {
		return this.readHitSegments;
	}
	/** @param x The number of segment reads that hit cache. */
	public void setReadHitSegments(long x) {
		this.readHitSegments = x;
	}

	/** The number of read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read operations." , required = true)
	@XmlElement(required = true)
	private long readOps;

	/** @return The number of read operations. */
	public long getReadOps() {
		return this.readOps;
	}
	/** @param x The number of read operations. */
	public void setReadOps(long x) {
		this.readOps = x;
	}

	/** The number of bytes read. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes read." , required = true)
	@XmlElement(required = true)
	private long readBytes;

	/** @return The number of bytes read. */
	public long getReadBytes() {
		return this.readBytes;
	}
	/** @param x The number of bytes read. */
	public void setReadBytes(long x) {
		this.readBytes = x;
	}

	/** The total time in microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotal;

	/** @return The total time in microseconds spent in read operations. */
	public long getReadTimeTotal() {
		return this.readTimeTotal;
	}
	/** @param x The total time in microseconds spent in read operations. */
	public void setReadTimeTotal(long x) {
		this.readTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one read operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one read operation." , required = true)
	@XmlElement(required = true)
	private long readTimeMax;

	/** @return The maximum time in microseconds spent in any one read operation. */
	public long getReadTimeMax() {
		return this.readTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one read operation. */
	public void setReadTimeMax(long x) {
		this.readTimeMax = x;
	}

	/** The number of stripe reads. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of stripe reads." , required = true)
	@XmlElement(required = true)
	private long readStripes;

	/** @return The number of stripe reads. */
	public long getReadStripes() {
		return this.readStripes;
	}
	/** @param x The number of stripe reads. */
	public void setReadStripes(long x) {
		this.readStripes = x;
	}

	/** The number of segment reads. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of segment reads." , required = true)
	@XmlElement(required = true)
	private long readSegments;

	/** @return The number of segment reads. */
	public long getReadSegments() {
		return this.readSegments;
	}
	/** @param x The number of segment reads. */
	public void setReadSegments(long x) {
		this.readSegments = x;
	}

	/** The number of write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitOps;

	/** @return The number of write operations that hit cache. */
	public long getWriteHitOps() {
		return this.writeHitOps;
	}
	/** @param x The number of write operations that hit cache. */
	public void setWriteHitOps(long x) {
		this.writeHitOps = x;
	}

	/** The number of bytes written that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes written that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitBytes;

	/** @return The number of bytes written that hit cache. */
	public long getWriteHitBytes() {
		return this.writeHitBytes;
	}
	/** @param x The number of bytes written that hit cache. */
	public void setWriteHitBytes(long x) {
		this.writeHitBytes = x;
	}

	/** The total time in microseconds spent in write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeTotal;

	/** @return The total time in microseconds spent in write operations that hit cache. */
	public long getWriteHitTimeTotal() {
		return this.writeHitTimeTotal;
	}
	/** @param x The total time in microseconds spent in write operations that hit cache. */
	public void setWriteHitTimeTotal(long x) {
		this.writeHitTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one write operation that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one write operation that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeMax;

	/** @return The maximum time in microseconds spent in any one write operation that hit cache. */
	public long getWriteHitTimeMax() {
		return this.writeHitTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one write operation that hit cache. */
	public void setWriteHitTimeMax(long x) {
		this.writeHitTimeMax = x;
	}

	/** The number of stripe writes that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of stripe writes that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitStripes;

	/** @return The number of stripe writes that hit cache. */
	public long getWriteHitStripes() {
		return this.writeHitStripes;
	}
	/** @param x The number of stripe writes that hit cache. */
	public void setWriteHitStripes(long x) {
		this.writeHitStripes = x;
	}

	/** The number of segment writes that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of segment writes that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitSegments;

	/** @return The number of segment writes that hit cache. */
	public long getWriteHitSegments() {
		return this.writeHitSegments;
	}
	/** @param x The number of segment writes that hit cache. */
	public void setWriteHitSegments(long x) {
		this.writeHitSegments = x;
	}

	/** The number of write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of write operations." , required = true)
	@XmlElement(required = true)
	private long writeOps;

	/** @return The number of write operations. */
	public long getWriteOps() {
		return this.writeOps;
	}
	/** @param x The number of write operations. */
	public void setWriteOps(long x) {
		this.writeOps = x;
	}

	/** The number of bytes written. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes written." , required = true)
	@XmlElement(required = true)
	private long writeBytes;

	/** @return The number of bytes written. */
	public long getWriteBytes() {
		return this.writeBytes;
	}
	/** @param x The number of bytes written. */
	public void setWriteBytes(long x) {
		this.writeBytes = x;
	}

	/** The total time in microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotal;

	/** @return The total time in microseconds spent in write operations. */
	public long getWriteTimeTotal() {
		return this.writeTimeTotal;
	}
	/** @param x The total time in microseconds spent in write operations. */
	public void setWriteTimeTotal(long x) {
		this.writeTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one write operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one write operation." , required = true)
	@XmlElement(required = true)
	private long writeTimeMax;

	/** @return The maximum time in microseconds spent in any one write operation. */
	public long getWriteTimeMax() {
		return this.writeTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one write operation. */
	public void setWriteTimeMax(long x) {
		this.writeTimeMax = x;
	}

	/** The number of stripe writes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of stripe writes." , required = true)
	@XmlElement(required = true)
	private long writeStripes;

	/** @return The number of stripe writes. */
	public long getWriteStripes() {
		return this.writeStripes;
	}
	/** @param x The number of stripe writes. */
	public void setWriteStripes(long x) {
		this.writeStripes = x;
	}

	/** The number of segment writes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of segment writes." , required = true)
	@XmlElement(required = true)
	private long writeSegments;

	/** @return The number of segment writes. */
	public long getWriteSegments() {
		return this.writeSegments;
	}
	/** @param x The number of segment writes. */
	public void setWriteSegments(long x) {
		this.writeSegments = x;
	}

	/** The number of non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherOps;

	/** @return The number of non-read-write operations. */
	public long getOtherOps() {
		return this.otherOps;
	}
	/** @param x The number of non-read-write operations. */
	public void setOtherOps(long x) {
		this.otherOps = x;
	}

	/** The total time in microseconds spent in non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotal;

	/** @return The total time in microseconds spent in non-read-write operations. */
	public long getOtherTimeTotal() {
		return this.otherTimeTotal;
	}
	/** @param x The total time in microseconds spent in non-read-write operations. */
	public void setOtherTimeTotal(long x) {
		this.otherTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one non-read-write operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one non-read-write operation." , required = true)
	@XmlElement(required = true)
	private long otherTimeMax;

	/** @return The maximum time in microseconds spent in any one non-read-write operation. */
	public long getOtherTimeMax() {
		return this.otherTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one non-read-write operation. */
	public void setOtherTimeMax(long x) {
		this.otherTimeMax = x;
	}

	/** The total time in microseconds spent idle since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent idle since baseTime." , required = true)
	@XmlElement(required = true)
	private long idleTime;

	/** @return The total time in microseconds spent idle since baseTime. */
	public long getIdleTime() {
		return this.idleTime;
	}
	/** @param x The total time in microseconds spent idle since baseTime. */
	public void setIdleTime(long x) {
		this.idleTime = x;
	}

	/** This field is used to record the number of write operations for a given RAID implementation algorithm. The algorithms are numbered 0..(NUMBER_OF_ALGORITHMS - 1). The actual algorithm represented by a given algorithm number depends on the RAID level of the object of interest. For RAID 0 objects, algorithm 0 is Single, Algorithm 2 is Complex, and Algorithm 3 is Fast. For RAID 3/5, Algorithm 0 is Full, Algorithm 1 is Partial, Algorithm 2 is RMW, Algorithm 3 is No Parity, and Algorithm 4 is Fast. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used to record the number of write operations for a given RAID implementation algorithm. The algorithms are numbered 0..(NUMBER_OF_ALGORITHMS - 1). The actual algorithm represented by a given algorithm number depends on the RAID level of the object of interest. For RAID 0 objects, algorithm 0 is Single, Algorithm 2 is Complex, and Algorithm 3 is Fast. For RAID 3/5, Algorithm 0 is Full, Algorithm 1 is Partial, Algorithm 2 is RMW, Algorithm 3 is No Parity, and Algorithm 4 is Fast." , required = true)
	@XmlElement(required = true)
	private long[] writeOpsByAlgorithm;

	/** @return This field is used to record the number of write operations for a given RAID implementation algorithm. The algorithms are numbered 0..(NUMBER_OF_ALGORITHMS - 1). The actual algorithm represented by a given algorithm number depends on the RAID level of the object of interest. For RAID 0 objects, algorithm 0 is Single, Algorithm 2 is Complex, and Algorithm 3 is Fast. For RAID 3/5, Algorithm 0 is Full, Algorithm 1 is Partial, Algorithm 2 is RMW, Algorithm 3 is No Parity, and Algorithm 4 is Fast. */
	public long[] getWriteOpsByAlgorithm() {
		return this.writeOpsByAlgorithm;
	}
	/** @param x This field is used to record the number of write operations for a given RAID implementation algorithm. The algorithms are numbered 0..(NUMBER_OF_ALGORITHMS - 1). The actual algorithm represented by a given algorithm number depends on the RAID level of the object of interest. For RAID 0 objects, algorithm 0 is Single, Algorithm 2 is Complex, and Algorithm 3 is Fast. For RAID 3/5, Algorithm 0 is Full, Algorithm 1 is Partial, Algorithm 2 is RMW, Algorithm 3 is No Parity, and Algorithm 4 is Fast. */
	public void setWriteOpsByAlgorithm(long[] x) {
		this.writeOpsByAlgorithm = x;
	}

	/** The sum of the squares of microseconds spent in read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in read operations that hit cache. */
	public long getReadHitTimeTotalSq() {
		return this.readHitTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in read operations that hit cache. */
	public void setReadHitTimeTotalSq(long x) {
		this.readHitTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in read operations. */
	public long getReadTimeTotalSq() {
		return this.readTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in read operations. */
	public void setReadTimeTotalSq(long x) {
		this.readTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in write operations that hit cache. */
	public long getWriteHitTimeTotalSq() {
		return this.writeHitTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in write operations that hit cache. */
	public void setWriteHitTimeTotalSq(long x) {
		this.writeHitTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in write operations. */
	public long getWriteTimeTotalSq() {
		return this.writeTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in write operations. */
	public void setWriteTimeTotalSq(long x) {
		this.writeTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in non read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in non read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in non read-write operations. */
	public long getOtherTimeTotalSq() {
		return this.otherTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in non read-write operations. */
	public void setOtherTimeTotalSq(long x) {
		this.otherTimeTotalSq = x;
	}

	/** The number of read requests that have failed due to redundancy group inconsistencies. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests that have failed due to redundancy group inconsistencies." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkUnrecoveredReads;

	/** @return The number of read requests that have failed due to redundancy group inconsistencies. */
	public long getErrRedundancyChkUnrecoveredReads() {
		return this.errRedundancyChkUnrecoveredReads;
	}
	/** @param x The number of read requests that have failed due to redundancy group inconsistencies. */
	public void setErrRedundancyChkUnrecoveredReads(long x) {
		this.errRedundancyChkUnrecoveredReads = x;
	}

	/** The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkRecoveredReads;

	/** @return The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	public long getErrRedundancyChkRecoveredReads() {
		return this.errRedundancyChkRecoveredReads;
	}
	/** @param x The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	public void setErrRedundancyChkRecoveredReads(long x) {
		this.errRedundancyChkRecoveredReads = x;
	}

	/** The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkIndeterminateReads;

	/** @return The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	public long getErrRedundancyChkIndeterminateReads() {
		return this.errRedundancyChkIndeterminateReads;
	}
	/** @param x The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	public void setErrRedundancyChkIndeterminateReads(long x) {
		this.errRedundancyChkIndeterminateReads = x;
	}

	/** The number of flash cache read hit operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of flash cache read hit operations." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitOps;

	/** @return The number of flash cache read hit operations. */
	public long getFlashCacheReadHitOps() {
		return this.flashCacheReadHitOps;
	}
	/** @param x The number of flash cache read hit operations. */
	public void setFlashCacheReadHitOps(long x) {
		this.flashCacheReadHitOps = x;
	}

	/** The number of flash cache read hit bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of flash cache read hit bytes." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitBytes;

	/** @return The number of flash cache read hit bytes. */
	public long getFlashCacheReadHitBytes() {
		return this.flashCacheReadHitBytes;
	}
	/** @param x The number of flash cache read hit bytes. */
	public void setFlashCacheReadHitBytes(long x) {
		this.flashCacheReadHitBytes = x;
	}

	/** The sum of all response times for all reads that have cache hits, in microseconds. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of all response times for all reads that have cache hits, in microseconds." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeTotal;

	/** @return The sum of all response times for all reads that have cache hits, in microseconds. */
	public long getFlashCacheReadHitTimeTotal() {
		return this.flashCacheReadHitTimeTotal;
	}
	/** @param x The sum of all response times for all reads that have cache hits, in microseconds. */
	public void setFlashCacheReadHitTimeTotal(long x) {
		this.flashCacheReadHitTimeTotal = x;
	}

	/** Maximum I/O time in microseconds for any one read I/O that has a cache hit. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum I/O time in microseconds for any one read I/O that has a cache hit." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeMax;

	/** @return Maximum I/O time in microseconds for any one read I/O that has a cache hit. */
	public long getFlashCacheReadHitTimeMax() {
		return this.flashCacheReadHitTimeMax;
	}
	/** @param x Maximum I/O time in microseconds for any one read I/O that has a cache hit. */
	public void setFlashCacheReadHitTimeMax(long x) {
		this.flashCacheReadHitTimeMax = x;
	}

	/** The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation)." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeTotalSq;

	/** @return The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	public long getFlashCacheReadHitTimeTotalSq() {
		return this.flashCacheReadHitTimeTotalSq;
	}
	/** @param x The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	public void setFlashCacheReadHitTimeTotalSq(long x) {
		this.flashCacheReadHitTimeTotalSq = x;
	}
}
