package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The structure is designed to model the critical aspects of an InterconnectCRU component. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1089)
public class InterconnectCRU implements Serializable {
	public InterconnectCRU() {
	}

	/** The reference for this physical interconnect CRU */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this physical interconnect CRU" , required = true)
	@XmlElement(required = true)
	private String interconnectCRURef;

	/** @return The reference for this physical interconnect CRU */
	public String getInterconnectCRURef() {
		return this.interconnectCRURef;
	}
	/** @param x The reference for this physical interconnect CRU */
	public void setInterconnectCRURef(String x) {
		this.interconnectCRURef = x;
	}

	/** The operational status of the interconnect CRU */
	@io.swagger.annotations.ApiModelProperty(value ="The operational status of the interconnect CRU" , required = true)
	@XmlElement(required = true)
	private InterconnectCRUStatus status = InterconnectCRUStatus.__UNDEFINED;

	/** @return The operational status of the interconnect CRU */
	public InterconnectCRUStatus getStatus() {
		return this.status;
	}
	/** @param x The operational status of the interconnect CRU */
	public void setStatus(InterconnectCRUStatus x) {
		this.status = x;
	}

	/** The physical location of the interconnect CRU. The parent reference in Location identifies the tray containing the CRU, and the position field is always one. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the interconnect CRU. The parent reference in Location identifies the tray containing the CRU, and the position field is always one." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the interconnect CRU. The parent reference in Location identifies the tray containing the CRU, and the position field is always one. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the interconnect CRU. The parent reference in Location identifies the tray containing the CRU, and the position field is always one. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** VPD Manufacture Date */
	@io.swagger.annotations.ApiModelProperty(value ="VPD Manufacture Date" , required = true)
	@XmlElement(required = true)
	private long manufacturerDate;

	/** @return VPD Manufacture Date */
	public long getManufacturerDate() {
		return this.manufacturerDate;
	}
	/** @param x VPD Manufacture Date */
	public void setManufacturerDate(long x) {
		this.manufacturerDate = x;
	}

	/** The VPD vendor name */
	@io.swagger.annotations.ApiModelProperty(value ="The VPD vendor name" , required = true)
	@XmlElement(required = true)
	private String vendorName;

	/** @return The VPD vendor name */
	public String getVendorName() {
		return this.vendorName;
	}
	/** @param x The VPD vendor name */
	public void setVendorName(String x) {
		this.vendorName = x;
	}

	/** The VPD part number */
	@io.swagger.annotations.ApiModelProperty(value ="The VPD part number" , required = true)
	@XmlElement(required = true)
	private String vendorPN;

	/** @return The VPD part number */
	public String getVendorPN() {
		return this.vendorPN;
	}
	/** @param x The VPD part number */
	public void setVendorPN(String x) {
		this.vendorPN = x;
	}

	/** The VPD serial number */
	@io.swagger.annotations.ApiModelProperty(value ="The VPD serial number" , required = true)
	@XmlElement(required = true)
	private String vendorSN;

	/** @return The VPD serial number */
	public String getVendorSN() {
		return this.vendorSN;
	}
	/** @param x The VPD serial number */
	public void setVendorSN(String x) {
		this.vendorSN = x;
	}

	/** The VPD field replaceable unit type */
	@io.swagger.annotations.ApiModelProperty(value ="The VPD field replaceable unit type" , required = true)
	@XmlElement(required = true)
	private String fruType;

	/** @return The VPD field replaceable unit type */
	public String getFruType() {
		return this.fruType;
	}
	/** @param x The VPD field replaceable unit type */
	public void setFruType(String x) {
		this.fruType = x;
	}

	/** When set to True, it means that the component is ready to remove (and the Ready to Remove indicator will be turned on). This field is deprecated. The rtrAttributes field should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="When set to True, it means that the component is ready to remove (and the Ready to Remove indicator will be turned on). This field is deprecated. The rtrAttributes field should be used instead." , required = true)
	@XmlElement(required = true)
	private boolean readyToRemove;

	/** @return When set to True, it means that the component is ready to remove (and the Ready to Remove indicator will be turned on). This field is deprecated. The rtrAttributes field should be used instead. */
	public boolean isReadyToRemove() {
		return this.readyToRemove;
	}
	/** @param x When set to True, it means that the component is ready to remove (and the Ready to Remove indicator will be turned on). This field is deprecated. The rtrAttributes field should be used instead. */
	public void setReadyToRemove(boolean x) {
		this.readyToRemove = x;
	}

	/** The CRU type of the interconnect CRU plus its ready-to-remove attributes, which are based on the CRU type. */
	@io.swagger.annotations.ApiModelProperty(value ="The CRU type of the interconnect CRU plus its ready-to-remove attributes, which are based on the CRU type." , required = true)
	@XmlElement(required = true)
	private RTRAttributes rtrAttributes;

	/** @return The CRU type of the interconnect CRU plus its ready-to-remove attributes, which are based on the CRU type. */
	public RTRAttributes getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x The CRU type of the interconnect CRU plus its ready-to-remove attributes, which are based on the CRU type. */
	public void setRtrAttributes(RTRAttributes x) {
		this.rtrAttributes = x;
	}

	/** The repair policy for the interconnect CRU component. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the interconnect CRU component." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the interconnect CRU component. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the interconnect CRU component. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}
}
