package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the statistical information on a per channel basis. These statistics include the channel type, number and the read and write details. The ObjectReference for this counter group must be an InterfaceRef. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(455)
public class InterfaceCounterGroup implements Serializable {
	public InterfaceCounterGroup() {
	}

	/** The controller that generated this group. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller that generated this group." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The controller that generated this group. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The controller that generated this group. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** Time the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="Time the counters were last reset. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long baseTime;

	/** @return Time the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public long getBaseTime() {
		return this.baseTime;
	}
	/** @param x Time the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public void setBaseTime(long x) {
		this.baseTime = x;
	}

	/** Start time for this collection as measured by the number of seconds since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="Start time for this collection as measured by the number of seconds since baseTime." , required = true)
	@XmlElement(required = true)
	private long startTime;

	/** @return Start time for this collection as measured by the number of seconds since baseTime. */
	public long getStartTime() {
		return this.startTime;
	}
	/** @param x Start time for this collection as measured by the number of seconds since baseTime. */
	public void setStartTime(long x) {
		this.startTime = x;
	}

	/** End time for this collection as measured by the number of seconds since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="End time for this collection as measured by the number of seconds since baseTime." , required = true)
	@XmlElement(required = true)
	private long observedTime;

	/** @return End time for this collection as measured by the number of seconds since baseTime. */
	public long getObservedTime() {
		return this.observedTime;
	}
	/** @param x End time for this collection as measured by the number of seconds since baseTime. */
	public void setObservedTime(long x) {
		this.observedTime = x;
	}

	/** Channel Type enumeration Drive side, host side, or management. */
	@io.swagger.annotations.ApiModelProperty(value ="Channel Type enumeration Drive side, host side, or management." , required = true)
	@XmlElement(required = true)
	private ChannelType channelType = ChannelType.__UNDEFINED;

	/** @return Channel Type enumeration Drive side, host side, or management. */
	public ChannelType getChannelType() {
		return this.channelType;
	}
	/** @param x Channel Type enumeration Drive side, host side, or management. */
	public void setChannelType(ChannelType x) {
		this.channelType = x;
	}

	/** Channel numerical ID. */
	@io.swagger.annotations.ApiModelProperty(value ="Channel numerical ID." , required = true)
	@XmlElement(required = true)
	private int channelNumber;

	/** @return Channel numerical ID. */
	public int getChannelNumber() {
		return this.channelNumber;
	}
	/** @param x Channel numerical ID. */
	public void setChannelNumber(int x) {
		this.channelNumber = x;
	}

	/** Number of read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of read operations." , required = true)
	@XmlElement(required = true)
	private long readOps;

	/** @return Number of read operations. */
	public long getReadOps() {
		return this.readOps;
	}
	/** @param x Number of read operations. */
	public void setReadOps(long x) {
		this.readOps = x;
	}

	/** Number of bytes read. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of bytes read." , required = true)
	@XmlElement(required = true)
	private long readBytes;

	/** @return Number of bytes read. */
	public long getReadBytes() {
		return this.readBytes;
	}
	/** @param x Number of bytes read. */
	public void setReadBytes(long x) {
		this.readBytes = x;
	}

	/** Total time in microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Total time in microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotal;

	/** @return Total time in microseconds spent in read operations. */
	public long getReadTimeTotal() {
		return this.readTimeTotal;
	}
	/** @param x Total time in microseconds spent in read operations. */
	public void setReadTimeTotal(long x) {
		this.readTimeTotal = x;
	}

	/** Max time in microseconds spent processing one read operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Max time in microseconds spent processing one read operation." , required = true)
	@XmlElement(required = true)
	private long readTimeMax;

	/** @return Max time in microseconds spent processing one read operation. */
	public long getReadTimeMax() {
		return this.readTimeMax;
	}
	/** @param x Max time in microseconds spent processing one read operation. */
	public void setReadTimeMax(long x) {
		this.readTimeMax = x;
	}

	/** Number of write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of write operations." , required = true)
	@XmlElement(required = true)
	private long writeOps;

	/** @return Number of write operations. */
	public long getWriteOps() {
		return this.writeOps;
	}
	/** @param x Number of write operations. */
	public void setWriteOps(long x) {
		this.writeOps = x;
	}

	/** Number of bytes write. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of bytes write." , required = true)
	@XmlElement(required = true)
	private long writeBytes;

	/** @return Number of bytes write. */
	public long getWriteBytes() {
		return this.writeBytes;
	}
	/** @param x Number of bytes write. */
	public void setWriteBytes(long x) {
		this.writeBytes = x;
	}

	/** Total time in microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Total time in microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotal;

	/** @return Total time in microseconds spent in write operations. */
	public long getWriteTimeTotal() {
		return this.writeTimeTotal;
	}
	/** @param x Total time in microseconds spent in write operations. */
	public void setWriteTimeTotal(long x) {
		this.writeTimeTotal = x;
	}

	/** Max time in microseconds spent processing one write operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Max time in microseconds spent processing one write operation." , required = true)
	@XmlElement(required = true)
	private long writeTimeMax;

	/** @return Max time in microseconds spent processing one write operation. */
	public long getWriteTimeMax() {
		return this.writeTimeMax;
	}
	/** @param x Max time in microseconds spent processing one write operation. */
	public void setWriteTimeMax(long x) {
		this.writeTimeMax = x;
	}

	/** Number of non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherOps;

	/** @return Number of non-read-write operations. */
	public long getOtherOps() {
		return this.otherOps;
	}
	/** @param x Number of non-read-write operations. */
	public void setOtherOps(long x) {
		this.otherOps = x;
	}

	/** Total time in microseconds spent in non-read-write ops. */
	@io.swagger.annotations.ApiModelProperty(value ="Total time in microseconds spent in non-read-write ops." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotal;

	/** @return Total time in microseconds spent in non-read-write ops. */
	public long getOtherTimeTotal() {
		return this.otherTimeTotal;
	}
	/** @param x Total time in microseconds spent in non-read-write ops. */
	public void setOtherTimeTotal(long x) {
		this.otherTimeTotal = x;
	}

	/** Max time in microseconds spent processing one non-read-write op. */
	@io.swagger.annotations.ApiModelProperty(value ="Max time in microseconds spent processing one non-read-write op." , required = true)
	@XmlElement(required = true)
	private long otherTimeMax;

	/** @return Max time in microseconds spent processing one non-read-write op. */
	public long getOtherTimeMax() {
		return this.otherTimeMax;
	}
	/** @param x Max time in microseconds spent processing one non-read-write op. */
	public void setOtherTimeMax(long x) {
		this.otherTimeMax = x;
	}

	/** Sum of the squares of microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Sum of the squares of microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotalSq;

	/** @return Sum of the squares of microseconds spent in read operations. */
	public long getReadTimeTotalSq() {
		return this.readTimeTotalSq;
	}
	/** @param x Sum of the squares of microseconds spent in read operations. */
	public void setReadTimeTotalSq(long x) {
		this.readTimeTotalSq = x;
	}

	/** Sum of the squares of microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Sum of the squares of microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotalSq;

	/** @return Sum of the squares of microseconds spent in write operations. */
	public long getWriteTimeTotalSq() {
		return this.writeTimeTotalSq;
	}
	/** @param x Sum of the squares of microseconds spent in write operations. */
	public void setWriteTimeTotalSq(long x) {
		this.writeTimeTotalSq = x;
	}

	/** Sum of the squares of microseconds spent in non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="Sum of the squares of microseconds spent in non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotalSq;

	/** @return Sum of the squares of microseconds spent in non-read-write operations. */
	public long getOtherTimeTotalSq() {
		return this.otherTimeTotalSq;
	}
	/** @param x Sum of the squares of microseconds spent in non-read-write operations. */
	public void setOtherTimeTotalSq(long x) {
		this.otherTimeTotalSq = x;
	}

	/** Total channel queue depth. */
	@io.swagger.annotations.ApiModelProperty(value ="Total channel queue depth." , required = true)
	@XmlElement(required = true)
	private long queueDepthTotal;

	/** @return Total channel queue depth. */
	public long getQueueDepthTotal() {
		return this.queueDepthTotal;
	}
	/** @param x Total channel queue depth. */
	public void setQueueDepthTotal(long x) {
		this.queueDepthTotal = x;
	}

	/** Maximum channel queue depth. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum channel queue depth." , required = true)
	@XmlElement(required = true)
	private long queueDepthMax;

	/** @return Maximum channel queue depth. */
	public long getQueueDepthMax() {
		return this.queueDepthMax;
	}
	/** @param x Maximum channel queue depth. */
	public void setQueueDepthMax(long x) {
		this.queueDepthMax = x;
	}

	/** The total number of errors detected on this channel. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of errors detected on this channel." , required = true)
	@XmlElement(required = true)
	private long channelErrorCounts;

	/** @return The total number of errors detected on this channel. */
	public long getChannelErrorCounts() {
		return this.channelErrorCounts;
	}
	/** @param x The total number of errors detected on this channel. */
	public void setChannelErrorCounts(long x) {
		this.channelErrorCounts = x;
	}
}
