package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Describes the Internal Message to be processed by EOS */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(976)
public class InternalMessage implements Serializable {
	public InternalMessage() {
	}

	/** Discriminator for the InternalMessage union. Describes what type of message is being sent */
	@io.swagger.annotations.ApiModelProperty(value ="Discriminator for the InternalMessage union. Describes what type of message is being sent" , required = true)
	@XmlElement(required = true)
	private InternalMessageType messageType = InternalMessageType.__UNDEFINED;

	/** @return Discriminator for the InternalMessage union. Describes what type of message is being sent */
	public InternalMessageType getMessageType() {
		return this.messageType;
	}
	/** @param x Discriminator for the InternalMessage union. Describes what type of message is being sent */
	public void setMessageType(InternalMessageType x) {
		this.messageType = x;
	}

	/** A message about the Security Audit Log */
	@io.swagger.annotations.ApiModelProperty(value ="A message about the Security Audit Log" , required = false)
	@XmlElement(required = false)
	private SecurityAuditLogEventDesc auditLogEvent;

	/** @return A message about the Security Audit Log */
	public SecurityAuditLogEventDesc getAuditLogEvent() {
		return this.auditLogEvent;
	}
	/** @param x A message about the Security Audit Log */
	public void setAuditLogEvent(SecurityAuditLogEventDesc x) {
		this.auditLogEvent = x;
	}

	/** A message about a SYMbol access change */
	@io.swagger.annotations.ApiModelProperty(value ="A message about a SYMbol access change" , required = false)
	@XmlElement(required = false)
	private SYMbolAccessChangeDesc symbolAccessChangeEvent;

	/** @return A message about a SYMbol access change */
	public SYMbolAccessChangeDesc getSymbolAccessChangeEvent() {
		return this.symbolAccessChangeEvent;
	}
	/** @param x A message about a SYMbol access change */
	public void setSymbolAccessChangeEvent(SYMbolAccessChangeDesc x) {
		this.symbolAccessChangeEvent = x;
	}

	/** A message about the Directory Server status */
	@io.swagger.annotations.ApiModelProperty(value ="A message about the Directory Server status" , required = false)
	@XmlElement(required = false)
	private DirectoryServicesStatusDesc dirServerStatus;

	/** @return A message about the Directory Server status */
	public DirectoryServicesStatusDesc getDirServerStatus() {
		return this.dirServerStatus;
	}
	/** @param x A message about the Directory Server status */
	public void setDirServerStatus(DirectoryServicesStatusDesc x) {
		this.dirServerStatus = x;
	}

	/** A message about an authorization failure lockout of a local user */
	@io.swagger.annotations.ApiModelProperty(value ="A message about an authorization failure lockout of a local user" , required = false)
	@XmlElement(required = false)
	private LocalUserAuthFailLockoutDesc authFailLockoutEvent;

	/** @return A message about an authorization failure lockout of a local user */
	public LocalUserAuthFailLockoutDesc getAuthFailLockoutEvent() {
		return this.authFailLockoutEvent;
	}
	/** @param x A message about an authorization failure lockout of a local user */
	public void setAuthFailLockoutEvent(LocalUserAuthFailLockoutDesc x) {
		this.authFailLockoutEvent = x;
	}
}
