package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Discriminator for the InternalMessage union. Describes what type of message is being sent */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(12)
public enum InternalMessageType implements Serializable {
		/** Invalid message */
		unknown(0),
		/** An event related to the Security Audit Log */
		auditLog(1),
		/** An internal message related to the SYMbol server access */
		symAccess(2),
		/** An internal message related to the Directory Service Server */
		dirServer(3),
		/** An internal message related to the local user authentication lockout */
		localAuthLockout(4),
		__UNDEFINED(464378545);

		public final int value;

		private InternalMessageType(int v) {
			this.value = v;
		}
}
