package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Represents a controller or host card IO interface. Contains generic info that applies for all IO interfaces and IO-protocol-specific info. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1221)
public class IoInterface implements Serializable {
	public IoInterface() {
	}

	/** The SYMbol array-wide unique name for the interface object. */
	@io.swagger.annotations.ApiModelProperty(value ="The SYMbol array-wide unique name for the interface object." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The SYMbol array-wide unique name for the interface object. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The SYMbol array-wide unique name for the interface object. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The type of channel (e.g., host-side, drive-side) that the interface is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of channel (e.g., host-side, drive-side) that the interface is associated with." , required = true)
	@XmlElement(required = true)
	private ChannelType channelType = ChannelType.__UNDEFINED;

	/** @return The type of channel (e.g., host-side, drive-side) that the interface is associated with. */
	public ChannelType getChannelType() {
		return this.channelType;
	}
	/** @param x The type of channel (e.g., host-side, drive-side) that the interface is associated with. */
	public void setChannelType(ChannelType x) {
		this.channelType = x;
	}

	/** A field whose contents vary depending on the I/O protocol type of the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A field whose contents vary depending on the I/O protocol type of the interface." , required = true)
	@XmlElement(required = true)
	private IOInterfaceTypeData ioInterfaceTypeData;

	/** @return A field whose contents vary depending on the I/O protocol type of the interface. */
	public IOInterfaceTypeData getIoInterfaceTypeData() {
		return this.ioInterfaceTypeData;
	}
	/** @param x A field whose contents vary depending on the I/O protocol type of the interface. */
	public void setIoInterfaceTypeData(IOInterfaceTypeData x) {
		this.ioInterfaceTypeData = x;
	}

	/** Uniquely identifies a particular physical RAID controller within the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="Uniquely identifies a particular physical RAID controller within the storage array." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return Uniquely identifies a particular physical RAID controller within the storage array. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x Uniquely identifies a particular physical RAID controller within the storage array. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The list of properties that describe the command protocol. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of properties that describe the command protocol." , required = true)
	@XmlElement(required = true)
	private CommandProtocolPropertiesList commandProtocolPropertiesList;

	/** @return The list of properties that describe the command protocol. */
	public CommandProtocolPropertiesList getCommandProtocolPropertiesList() {
		return this.commandProtocolPropertiesList;
	}
	/** @param x The list of properties that describe the command protocol. */
	public void setCommandProtocolPropertiesList(CommandProtocolPropertiesList x) {
		this.commandProtocolPropertiesList = x;
	}
}
