package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to map an I/O interface to the associated HIC. An array of these structures is provided in the ObjectBundle. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(707)
public class IoInterfaceHicMap implements Serializable {
	public IoInterfaceHicMap() {
	}

	/** A reference to the I/O interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the I/O interface." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return A reference to the I/O interface. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x A reference to the I/O interface. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The reference to the associated HIC. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the associated HIC." , required = true)
	@XmlElement(required = true)
	private String hostBoardRef;

	/** @return The reference to the associated HIC. */
	public String getHostBoardRef() {
		return this.hostBoardRef;
	}
	/** @param x The reference to the associated HIC. */
	public void setHostBoardRef(String x) {
		this.hostBoardRef = x;
	}
}
