package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(273)
public enum IpAddressType implements Serializable {
		/** The IP address format defined in version 4 of the Internet protocol. */
		ipv4(0),
		/** The IP address format defined in version 6 of the Internet protocol. */
		ipv6(1),
		__UNDEFINED(464378545);

		public final int value;

		private IpAddressType(int v) {
			this.value = v;
		}
}
