package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the various IPV4 address elements that are subject to either manual or automatic (i.e., DHCP) configuration, along with a state variable indicating the state of configuration for these elements. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(610)
public class IpV4AddressData implements Serializable {
	public IpV4AddressData() {
	}

	/** Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces. */
	@io.swagger.annotations.ApiModelProperty(value ="Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces." , required = true)
	@XmlElement(required = true)
	private IpConfigState configState = IpConfigState.__UNDEFINED;

	/** @return Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces. */
	public IpConfigState getConfigState() {
		return this.configState;
	}
	/** @param x Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces. */
	public void setConfigState(IpConfigState x) {
		this.configState = x;
	}

	/** The IPV4 address associated with the endpoint. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 address associated with the endpoint." , required = true)
	@XmlElement(required = true)
	private String ipv4Address;

	/** @return The IPV4 address associated with the endpoint. */
	public String getIpv4Address() {
		return this.ipv4Address;
	}
	/** @param x The IPV4 address associated with the endpoint. */
	public void setIpv4Address(String x) {
		this.ipv4Address = x;
	}

	/** IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces. */
	@io.swagger.annotations.ApiModelProperty(value ="IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces." , required = true)
	@XmlElement(required = true)
	private String ipv4SubnetMask;

	/** @return IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces. */
	public String getIpv4SubnetMask() {
		return this.ipv4SubnetMask;
	}
	/** @param x IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces. */
	public void setIpv4SubnetMask(String x) {
		this.ipv4SubnetMask = x;
	}

	/** IPV4 gateway address associated w/ the endpoint; used for iSER interfaces. */
	@io.swagger.annotations.ApiModelProperty(value ="IPV4 gateway address associated w/ the endpoint; used for iSER interfaces." , required = true)
	@XmlElement(required = true)
	private String ipv4GatewayAddress;

	/** @return IPV4 gateway address associated w/ the endpoint; used for iSER interfaces. */
	public String getIpv4GatewayAddress() {
		return this.ipv4GatewayAddress;
	}
	/** @param x IPV4 gateway address associated w/ the endpoint; used for iSER interfaces. */
	public void setIpv4GatewayAddress(String x) {
		this.ipv4GatewayAddress = x;
	}
}
