package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the different methods available for assigning an IPV4 address to a network interface. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(259)
public enum IpV4ConfigMethod implements Serializable {
		/** The IPV4 configuration method using Dynamic Host Configuration Protocol (DHCP) version 4. */
		configDhcp(0),
		/** The IPV4 configuration method of explicit, static IP address assignment. */
		configStatic(1),
		__UNDEFINED(464378545);

		public final int value;

		private IpV4ConfigMethod(int v) {
			this.value = v;
		}
}
