package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the different methods available for assigning an IV6P address to a network interface. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(263)
public enum IpV6ConfigMethod implements Serializable {
		/** The IPV6 configuration method of explicit, static IP address assignment. */
		configStatic(0),
		/** The IPV6 configuration method of stateless autoconfiguration. */
		configStateless(1),
		__UNDEFINED(464378545);

		public final int value;

		private IpV6ConfigMethod(int v) {
			this.value = v;
		}
}
