package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type defines values for indicating the state of an IPV6 router address. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(286)
public enum IpV6RouterAddressState implements Serializable {
		/** There is no known default router. */
		unknown(0),
		/** The default router has been configured. */
		configured(1),
		/** The default router was discovered from a router advertisement. */
		advertised(2),
		/** The default router is no longer valid. */
		stale(3),
		__UNDEFINED(464378545);

		public final int value;

		private IpV6RouterAddressState(int v) {
			this.value = v;
		}
}
