package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type represents an IP address that can be formatted either according to version 4 or version 6 of the Internet protocol. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(700)
public class IpVxAddress implements Serializable {
	public IpVxAddress() {
	}

	/** This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol." , required = true)
	@XmlElement(required = true)
	private IpAddressType addressType = IpAddressType.__UNDEFINED;

	/** @return This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	public IpAddressType getAddressType() {
		return this.addressType;
	}
	/** @param x This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	public void setAddressType(IpAddressType x) {
		this.addressType = x;
	}

	/** An IP address formatted according to version 4 of the Internet protocol. This field is only present if addressType is equal to IPV4. */
	@io.swagger.annotations.ApiModelProperty(value ="An IP address formatted according to version 4 of the Internet protocol. This field is only present if addressType is equal to IPV4." , required = false)
	@XmlElement(required = false)
	private String ipv4Address;

	/** @return An IP address formatted according to version 4 of the Internet protocol. This field is only present if addressType is equal to IPV4. */
	public String getIpv4Address() {
		return this.ipv4Address;
	}
	/** @param x An IP address formatted according to version 4 of the Internet protocol. This field is only present if addressType is equal to IPV4. */
	public void setIpv4Address(String x) {
		this.ipv4Address = x;
	}

	/** An IP address formatted according to version 6 of the Internet protocol. This field is only present if addressType is equal to IPV6. */
	@io.swagger.annotations.ApiModelProperty(value ="An IP address formatted according to version 6 of the Internet protocol. This field is only present if addressType is equal to IPV6." , required = false)
	@XmlElement(required = false)
	private String ipv6Address;

	/** @return An IP address formatted according to version 6 of the Internet protocol. This field is only present if addressType is equal to IPV6. */
	public String getIpv6Address() {
		return this.ipv6Address;
	}
	/** @param x An IP address formatted according to version 6 of the Internet protocol. This field is only present if addressType is equal to IPV6. */
	public void setIpv6Address(String x) {
		this.ipv6Address = x;
	}
}
