package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type represents an IP address data element associated with an IP address formatted either according to version 4 or version 6 of the Internet protocol. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(881)
public class IpVxAddressData implements Serializable {
	public IpVxAddressData() {
	}

	/** This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol." , required = true)
	@XmlElement(required = true)
	private IpAddressType addressType = IpAddressType.__UNDEFINED;

	/** @return This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	public IpAddressType getAddressType() {
		return this.addressType;
	}
	/** @param x This enumeration defines the different types of IP addresses, corresponding to different versions of the Internet protocol. */
	public void setAddressType(IpAddressType x) {
		this.addressType = x;
	}

	/** Contains the various IPV4 address elements. */
	@io.swagger.annotations.ApiModelProperty(value ="Contains the various IPV4 address elements." , required = false)
	@XmlElement(required = false)
	private IpV4AddressData ipv4Data;

	/** @return Contains the various IPV4 address elements. */
	public IpV4AddressData getIpv4Data() {
		return this.ipv4Data;
	}
	/** @param x Contains the various IPV4 address elements. */
	public void setIpv4Data(IpV4AddressData x) {
		this.ipv4Data = x;
	}

	/** contains the various IPV6 address elements. */
	@io.swagger.annotations.ApiModelProperty(value ="contains the various IPV6 address elements." , required = false)
	@XmlElement(required = false)
	private IpV6AddressData ipv6Data;

	/** @return contains the various IPV6 address elements. */
	public IpV6AddressData getIpv6Data() {
		return this.ipv6Data;
	}
	/** @param x contains the various IPV6 address elements. */
	public void setIpv6Data(IpV6AddressData x) {
		this.ipv6Data = x;
	}
}
