package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the possible values for iSCSI Copper Cable Diagnostics Completion Status. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(277)
public enum IscsiCableDiagCompletionStatus implements Serializable {
		/** Diagnostics status unknown. */
		unknown(0),
		/** Diagnostics completed. */
		complete(1),
		/** Could not start diagnostics because another operation is already in progress on the port. */
		startFailed(2),
		/** Copper cable diagnostics are not supported on this HIC. */
		unsupported(3),
		/** The diagnostic operations timed out. */
		timeout(4),
		__UNDEFINED(464378545);

		public final int value;

		private IscsiCableDiagCompletionStatus(int v) {
			this.value = v;
		}
}
