package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information describing an iSCSI connection. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1042)
public class IscsiConnectionEndpoints implements Serializable {
	public IscsiConnectionEndpoints() {
	}

	/** The TCP/IP protocol endpoint that is local to the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="The TCP/IP protocol endpoint that is local to the storage array." , required = true)
	@XmlElement(required = true)
	private TcpProtocolEndpoint localEndpoint;

	/** @return The TCP/IP protocol endpoint that is local to the storage array. */
	public TcpProtocolEndpoint getLocalEndpoint() {
		return this.localEndpoint;
	}
	/** @param x The TCP/IP protocol endpoint that is local to the storage array. */
	public void setLocalEndpoint(TcpProtocolEndpoint x) {
		this.localEndpoint = x;
	}

	/** The TCP/IP protocol endpoint that is remote from the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="The TCP/IP protocol endpoint that is remote from the storage array." , required = true)
	@XmlElement(required = true)
	private TcpProtocolEndpoint remoteEndpoint;

	/** @return The TCP/IP protocol endpoint that is remote from the storage array. */
	public TcpProtocolEndpoint getRemoteEndpoint() {
		return this.remoteEndpoint;
	}
	/** @param x The TCP/IP protocol endpoint that is remote from the storage array. */
	public void setRemoteEndpoint(TcpProtocolEndpoint x) {
		this.remoteEndpoint = x;
	}
}
