package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the identification information associated with an iSCSI initiator port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(629)
public class IscsiInitiatorPortId implements Serializable {
	public IscsiInitiatorPortId() {
	}

	/** The iSCSI node name of the initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="The iSCSI node name of the initiator." , required = true)
	@XmlElement(required = true)
	private String initiatorNodeName;

	/** @return The iSCSI node name of the initiator. */
	public String getInitiatorNodeName() {
		return this.initiatorNodeName;
	}
	/** @param x The iSCSI node name of the initiator. */
	public void setInitiatorNodeName(String x) {
		this.initiatorNodeName = x;
	}

	/** The initiator session ID associated with the initiator port. */
	@io.swagger.annotations.ApiModelProperty(value ="The initiator session ID associated with the initiator port." , required = true)
	@XmlElement(required = true)
	private String initiatorSessionId;

	/** @return The initiator session ID associated with the initiator port. */
	public String getInitiatorSessionId() {
		return this.initiatorSessionId;
	}
	/** @param x The initiator session ID associated with the initiator port. */
	public void setInitiatorSessionId(String x) {
		this.initiatorSessionId = x;
	}
}
