package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides iSCSI protocol statistical data in the context of an iSCSI initiator. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(547)
public class IscsiInitiatorStatistics implements Serializable {
	public IscsiInitiatorStatistics() {
	}

	/** This element contains the count of successful iSCSI logins to the target. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the count of successful iSCSI logins to the target." , required = true)
	@XmlElement(required = true)
	private long successfulLogins;

	/** @return This element contains the count of successful iSCSI logins to the target. */
	public long getSuccessfulLogins() {
		return this.successfulLogins;
	}
	/** @param x This element contains the count of successful iSCSI logins to the target. */
	public void setSuccessfulLogins(long x) {
		this.successfulLogins = x;
	}

	/** This element contains the number of times an iSCSI login attempt to or from the target failed. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of times an iSCSI login attempt to or from the target failed." , required = true)
	@XmlElement(required = true)
	private long loginFailures;

	/** @return This element contains the number of times an iSCSI login attempt to or from the target failed. */
	public long getLoginFailures() {
		return this.loginFailures;
	}
	/** @param x This element contains the number of times an iSCSI login attempt to or from the target failed. */
	public void setLoginFailures(long x) {
		this.loginFailures = x;
	}

	/** This element contains the number of times an initiator login authentication attempt was accepted by the target. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of times an initiator login authentication attempt was accepted by the target." , required = true)
	@XmlElement(required = true)
	private long successfulLoginAuthentications;

	/** @return This element contains the number of times an initiator login authentication attempt was accepted by the target. */
	public long getSuccessfulLoginAuthentications() {
		return this.successfulLoginAuthentications;
	}
	/** @param x This element contains the number of times an initiator login authentication attempt was accepted by the target. */
	public void setSuccessfulLoginAuthentications(long x) {
		this.successfulLoginAuthentications = x;
	}

	/** This element contains the number of times an initiator login authentication attempt was rejected by the target. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of times an initiator login authentication attempt was rejected by the target." , required = true)
	@XmlElement(required = true)
	private long authenticationLoginFailures;

	/** @return This element contains the number of times an initiator login authentication attempt was rejected by the target. */
	public long getAuthenticationLoginFailures() {
		return this.authenticationLoginFailures;
	}
	/** @param x This element contains the number of times an initiator login authentication attempt was rejected by the target. */
	public void setAuthenticationLoginFailures(long x) {
		this.authenticationLoginFailures = x;
	}

	/** This element contains the number of iSCSI PDUs processed by the initiator that experienced no errors of any sort. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI PDUs processed by the initiator that experienced no errors of any sort." , required = true)
	@XmlElement(required = true)
	private long errorFreePdus;

	/** @return This element contains the number of iSCSI PDUs processed by the initiator that experienced no errors of any sort. */
	public long getErrorFreePdus() {
		return this.errorFreePdus;
	}
	/** @param x This element contains the number of iSCSI PDUs processed by the initiator that experienced no errors of any sort. */
	public void setErrorFreePdus(long x) {
		this.errorFreePdus = x;
	}

	/** This element contains the number of iSCSI PDUs processed by the initiator that experienced protocol errors. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI PDUs processed by the initiator that experienced protocol errors." , required = true)
	@XmlElement(required = true)
	private long protocolErrorPdus;

	/** @return This element contains the number of iSCSI PDUs processed by the initiator that experienced protocol errors. */
	public long getProtocolErrorPdus() {
		return this.protocolErrorPdus;
	}
	/** @param x This element contains the number of iSCSI PDUs processed by the initiator that experienced protocol errors. */
	public void setProtocolErrorPdus(long x) {
		this.protocolErrorPdus = x;
	}

	/** This element contains the number of iSCSI PDUs received by the initiator having header digest errors. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI PDUs received by the initiator having header digest errors." , required = true)
	@XmlElement(required = true)
	private long headerDigestErrors;

	/** @return This element contains the number of iSCSI PDUs received by the initiator having header digest errors. */
	public long getHeaderDigestErrors() {
		return this.headerDigestErrors;
	}
	/** @param x This element contains the number of iSCSI PDUs received by the initiator having header digest errors. */
	public void setHeaderDigestErrors(long x) {
		this.headerDigestErrors = x;
	}

	/** This element contains the number of iSCSI PDUs received by the initiator having data digest errors. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI PDUs received by the initiator having data digest errors." , required = true)
	@XmlElement(required = true)
	private long dataDigestErrors;

	/** @return This element contains the number of iSCSI PDUs received by the initiator having data digest errors. */
	public long getDataDigestErrors() {
		return this.dataDigestErrors;
	}
	/** @param x This element contains the number of iSCSI PDUs received by the initiator having data digest errors. */
	public void setDataDigestErrors(long x) {
		this.dataDigestErrors = x;
	}

	/** This element contains the number of iSCSI sessions for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI sessions for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error." , required = true)
	@XmlElement(required = true)
	private long sessionFailures;

	/** @return This element contains the number of iSCSI sessions for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	public long getSessionFailures() {
		return this.sessionFailures;
	}
	/** @param x This element contains the number of iSCSI sessions for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	public void setSessionFailures(long x) {
		this.sessionFailures = x;
	}

	/** This element contains the number of iSCSI connections for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	@io.swagger.annotations.ApiModelProperty(value ="This element contains the number of iSCSI connections for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error." , required = true)
	@XmlElement(required = true)
	private long connectionFailures;

	/** @return This element contains the number of iSCSI connections for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	public long getConnectionFailures() {
		return this.connectionFailures;
	}
	/** @param x This element contains the number of iSCSI connections for the initiator that terminated abnormally, either by administrative action or due to firmware-detected error. */
	public void setConnectionFailures(long x) {
		this.connectionFailures = x;
	}
}
