package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains elements that are commonly used in iSCSI target and initiator structures and unions. These elements are valid for iSCSI only. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(819)
public class IscsiInitiatorTargetBaseParameters implements Serializable {
	public IscsiInitiatorTargetBaseParameters() {
	}

	/** The IP addresses, portal group numbers, and port number for the initiator or target. */
	@io.swagger.annotations.ApiModelProperty(value ="The IP addresses, portal group numbers, and port number for the initiator or target." , required = true)
	@XmlElement(required = true)
	private TargetPortal[] portals;

	/** @return The IP addresses, portal group numbers, and port number for the initiator or target. */
	public TargetPortal[] getPortals() {
		return this.portals;
	}
	/** @param x The IP addresses, portal group numbers, and port number for the initiator or target. */
	public void setPortals(TargetPortal[] x) {
		this.portals = x;
	}
}
