package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about an iSCSI interface on a storage array controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1039)
public class IscsiInterface implements Serializable,devmgr.api.model.Identifiable {
	public IscsiInterface() {
	}

	/** The number of the channel controlled by this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the channel controlled by this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The number of the channel controlled by this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The number of the channel controlled by this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** A reference to the channel port object associated with the channel controlled by this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the channel port object associated with the channel controlled by this interface." , required = true)
	@XmlElement(required = true)
	private String channelPortRef;

	/** @return A reference to the channel port object associated with the channel controlled by this interface. */
	public String getChannelPortRef() {
		return this.channelPortRef;
	}
	/** @param x A reference to the channel port object associated with the channel controlled by this interface. */
	public void setChannelPortRef(String x) {
		this.channelPortRef = x;
	}

	/** The number of the TCP port on which the target listens for incoming connections. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the TCP port on which the target listens for incoming connections." , required = true)
	@XmlElement(required = true)
	private int tcpListenPort;

	/** @return The number of the TCP port on which the target listens for incoming connections. */
	public int getTcpListenPort() {
		return this.tcpListenPort;
	}
	/** @param x The number of the TCP port on which the target listens for incoming connections. */
	public void setTcpListenPort(int x) {
		this.tcpListenPort = x;
	}

	/** True if IPV4 is enabled for this interface; always true for iSER interface. */
	@io.swagger.annotations.ApiModelProperty(value ="True if IPV4 is enabled for this interface; always true for iSER interface." , required = true)
	@XmlElement(required = true)
	private boolean ipv4Enabled;

	/** @return True if IPV4 is enabled for this interface; always true for iSER interface. */
	public boolean isIpv4Enabled() {
		return this.ipv4Enabled;
	}
	/** @param x True if IPV4 is enabled for this interface; always true for iSER interface. */
	public void setIpv4Enabled(boolean x) {
		this.ipv4Enabled = x;
	}

	/** IPV4-related information for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="IPV4-related information for the interface." , required = true)
	@XmlElement(required = true)
	private InternetProtocolV4Data ipv4Data;

	/** @return IPV4-related information for the interface. */
	public InternetProtocolV4Data getIpv4Data() {
		return this.ipv4Data;
	}
	/** @param x IPV4-related information for the interface. */
	public void setIpv4Data(InternetProtocolV4Data x) {
		this.ipv4Data = x;
	}

	/** Information about the physical interface (e.g., Ethernet). */
	@io.swagger.annotations.ApiModelProperty(value ="Information about the physical interface (e.g., Ethernet)." , required = true)
	@XmlElement(required = true)
	private PhysicalInterfaceTypeData interfaceData;

	/** @return Information about the physical interface (e.g., Ethernet). */
	public PhysicalInterfaceTypeData getInterfaceData() {
		return this.interfaceData;
	}
	/** @param x Information about the physical interface (e.g., Ethernet). */
	public void setInterfaceData(PhysicalInterfaceTypeData x) {
		this.interfaceData = x;
	}

	/** The unique identifier for a given instance of this structure. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for a given instance of this structure." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The unique identifier for a given instance of this structure. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The unique identifier for a given instance of this structure. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** True if IPV6 is enabled for this interface; otherwise false. */
	@io.swagger.annotations.ApiModelProperty(value ="True if IPV6 is enabled for this interface; otherwise false." , required = true)
	@XmlElement(required = true)
	private boolean ipv6Enabled;

	/** @return True if IPV6 is enabled for this interface; otherwise false. */
	public boolean isIpv6Enabled() {
		return this.ipv6Enabled;
	}
	/** @param x True if IPV6 is enabled for this interface; otherwise false. */
	public void setIpv6Enabled(boolean x) {
		this.ipv6Enabled = x;
	}

	/** IPV6-related information for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="IPV6-related information for the interface." , required = true)
	@XmlElement(required = true)
	private InternetProtocolV6Data ipv6Data;

	/** @return IPV6-related information for the interface. */
	public InternetProtocolV6Data getIpv6Data() {
		return this.ipv6Data;
	}
	/** @param x IPV6-related information for the interface. */
	public void setIpv6Data(InternetProtocolV6Data x) {
		this.ipv6Data = x;
	}

	/** The physical location of the iSCSI interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st iSCSI interface relative to the parent," "2nd iSCSI interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the iSCSI interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying \"1st iSCSI interface relative to the parent,\" \"2nd iSCSI interface relative to the parent,\" etc. This \"interface number\" is independent of the interface's channel association." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the iSCSI interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st iSCSI interface relative to the parent," "2nd iSCSI interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the iSCSI interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st iSCSI interface relative to the parent," "2nd iSCSI interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** This field indicates whether or not the I/O interface is PI capable. */
	@io.swagger.annotations.ApiModelProperty(value ="This field indicates whether or not the I/O interface is PI capable." , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	/** @return This field indicates whether or not the I/O interface is PI capable. */
	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	/** @param x This field indicates whether or not the I/O interface is PI capable. */
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}

	/** This flag is true if the interface is capable of IPv6 functionality. */
	@io.swagger.annotations.ApiModelProperty(value ="This flag is true if the interface is capable of IPv6 functionality." , required = true)
	@XmlElement(required = true)
	private boolean isIPv6Capable;

	/** @return This flag is true if the interface is capable of IPv6 functionality. */
	public boolean isIsIPv6Capable() {
		return this.isIPv6Capable;
	}
	/** @param x This flag is true if the interface is capable of IPv6 functionality. */
	public void setIsIPv6Capable(boolean x) {
		this.isIPv6Capable = x;
	}

	/** Maximum one way data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum one way data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long oneWayMaxRate;

	/** @return Maximum one way data rate in B/s */
	public long getOneWayMaxRate() {
		return this.oneWayMaxRate;
	}
	/** @param x Maximum one way data rate in B/s */
	public void setOneWayMaxRate(long x) {
		this.oneWayMaxRate = x;
	}

	/** Maximum bi-directional data rate in B/s */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum bi-directional data rate in B/s" , required = true)
	@XmlElement(required = true)
	private long bidirectionalMaxRate;

	/** @return Maximum bi-directional data rate in B/s */
	public long getBidirectionalMaxRate() {
		return this.bidirectionalMaxRate;
	}
	/** @param x Maximum bi-directional data rate in B/s */
	public void setBidirectionalMaxRate(long x) {
		this.bidirectionalMaxRate = x;
	}
	@Override
	public String getId(){
		return interfaceRef;
	}
}
