package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around an IscsiNegotiationDefaults structure. It is used by the getIscsiNegotiationDefaults procedures to return both a return code and a the default settings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1061)
public class IscsiNegotiationDefaultsReturned implements Serializable {
	public IscsiNegotiationDefaultsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The default settings for iSCSI negotiation. */
	@io.swagger.annotations.ApiModelProperty(value ="The default settings for iSCSI negotiation." , required = false)
	@XmlElement(required = false)
	private IscsiNegotiationDefaults defaults;

	/** @return The default settings for iSCSI negotiation. */
	public IscsiNegotiationDefaults getDefaults() {
		return this.defaults;
	}
	/** @param x The default settings for iSCSI negotiation. */
	public void setDefaults(IscsiNegotiationDefaults x) {
		this.defaults = x;
	}
}
