package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about an iSCSI session. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1180)
public class IscsiSession implements Serializable {
	public IscsiSession() {
	}

	/** The type of session, discovery or normal. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of session, discovery or normal." , required = true)
	@XmlElement(required = true)
	private IscsiSessionType type = IscsiSessionType.__UNDEFINED;

	/** @return The type of session, discovery or normal. */
	public IscsiSessionType getType() {
		return this.type;
	}
	/** @param x The type of session, discovery or normal. */
	public void setType(IscsiSessionType x) {
		this.type = x;
	}

	/** A target-assigned handle of unspecified format that uniquely identifies the session. */
	@io.swagger.annotations.ApiModelProperty(value ="A target-assigned handle of unspecified format that uniquely identifies the session." , required = true)
	@XmlElement(required = true)
	private int tsih;

	/** @return A target-assigned handle of unspecified format that uniquely identifies the session. */
	public int getTsih() {
		return this.tsih;
	}
	/** @param x A target-assigned handle of unspecified format that uniquely identifies the session. */
	public void setTsih(int x) {
		this.tsih = x;
	}

	/** The SCSI protocol endpoints of the session. */
	@io.swagger.annotations.ApiModelProperty(value ="The SCSI protocol endpoints of the session." , required = true)
	@XmlElement(required = true)
	private IscsiSessionEndpoints endpoints;

	/** @return The SCSI protocol endpoints of the session. */
	public IscsiSessionEndpoints getEndpoints() {
		return this.endpoints;
	}
	/** @param x The SCSI protocol endpoints of the session. */
	public void setEndpoints(IscsiSessionEndpoints x) {
		this.endpoints = x;
	}

	/** A collection of session-level settings that are subject to initiator-target negotiation. */
	@io.swagger.annotations.ApiModelProperty(value ="A collection of session-level settings that are subject to initiator-target negotiation." , required = true)
	@XmlElement(required = true)
	private IscsiNegotiableSessionSettings negotiatedSettings;

	/** @return A collection of session-level settings that are subject to initiator-target negotiation. */
	public IscsiNegotiableSessionSettings getNegotiatedSettings() {
		return this.negotiatedSettings;
	}
	/** @param x A collection of session-level settings that are subject to initiator-target negotiation. */
	public void setNegotiatedSettings(IscsiNegotiableSessionSettings x) {
		this.negotiatedSettings = x;
	}

	/** The set of connections that are associated with this session. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of connections that are associated with this session." , required = true)
	@XmlElement(required = true)
	private IscsiConnection[] connections;

	/** @return The set of connections that are associated with this session. */
	public IscsiConnection[] getConnections() {
		return this.connections;
	}
	/** @param x The set of connections that are associated with this session. */
	public void setConnections(IscsiConnection[] x) {
		this.connections = x;
	}
}
