package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around an array of IscsiSession structures. It is used by the getIscsiSessions procedure to return both a return code and the session settings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1206)
public class IscsiSessionsReturned implements Serializable {
	public IscsiSessionsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The settings that are in effect for the sessions identified in the getIscsiSessions procedure call. */
	@io.swagger.annotations.ApiModelProperty(value ="The settings that are in effect for the sessions identified in the getIscsiSessions procedure call." , required = false)
	@XmlElement(required = false)
	private IscsiSession[] sessions;

	/** @return The settings that are in effect for the sessions identified in the getIscsiSessions procedure call. */
	public IscsiSession[] getSessions() {
		return this.sessions;
	}
	/** @param x The settings that are in effect for the sessions identified in the getIscsiSessions procedure call. */
	public void setSessions(IscsiSession[] x) {
		this.sessions = x;
	}
}
