package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration data type identifies the various states of the array (i.e., the iSCSI entity) with respect to iSNS registration activity. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(196)
public enum IsnsRegistrationState implements Serializable {
		/** No target is enabled for iSNS registration. */
		disabled(1),
		/** The array is in the process of discovering the IP address of the iSNS server, via DHCP. */
		locatingServer(2),
		/** The array has the IP address of the iSNS server and is in the process of connecting to it. */
		connectingToServer(3),
		/** The array has completed the registration of the targets enabled for iSNS discovery. */
		completed(4),
		__UNDEFINED(464378545);

		public final int value;

		private IsnsRegistrationState(int v) {
			this.value = v;
		}
}
