package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify the location of an iSNS server in a Major Event Log entry. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(970)
public class IsnsServerLocation implements Serializable {
	public IsnsServerLocation() {
	}

	/** The IP address of the iSNS server. */
	@io.swagger.annotations.ApiModelProperty(value ="The IP address of the iSNS server." , required = true)
	@XmlElement(required = true)
	private IpVxAddress ipAddress;

	/** @return The IP address of the iSNS server. */
	public IpVxAddress getIpAddress() {
		return this.ipAddress;
	}
	/** @param x The IP address of the iSNS server. */
	public void setIpAddress(IpVxAddress x) {
		this.ipAddress = x;
	}

	/** The number of the TCP port on which the iSNS server listens for incoming connections. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the TCP port on which the iSNS server listens for incoming connections." , required = true)
	@XmlElement(required = true)
	private int tcpListenPort;

	/** @return The number of the TCP port on which the iSNS server listens for incoming connections. */
	public int getTcpListenPort() {
		return this.tcpListenPort;
	}
	/** @param x The number of the TCP port on which the iSNS server listens for incoming connections. */
	public void setTcpListenPort(int x) {
		this.tcpListenPort = x;
	}
}
