package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Identifies a certificate used for KMIP server authentication and its time of expiration. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(359)
public class KMSCertificateExpirationDetails implements Serializable {
	public KMSCertificateExpirationDetails() {
	}

	/** Type of KMS certificate for which expiration is being reported. */
	@io.swagger.annotations.ApiModelProperty(value ="Type of KMS certificate for which expiration is being reported." , required = true)
	@XmlElement(required = true)
	private KMSCertificateFileType certificateFileType = KMSCertificateFileType.__UNDEFINED;

	/** @return Type of KMS certificate for which expiration is being reported. */
	public KMSCertificateFileType getCertificateFileType() {
		return this.certificateFileType;
	}
	/** @param x Type of KMS certificate for which expiration is being reported. */
	public void setCertificateFileType(KMSCertificateFileType x) {
		this.certificateFileType = x;
	}

	/** Expiration time of day (as a string) for a KMS certificate */
	@io.swagger.annotations.ApiModelProperty(value ="Expiration time of day (as a string) for a KMS certificate" , required = true)
	@XmlElement(required = true)
	private String expirationTimeOfDay;

	/** @return Expiration time of day (as a string) for a KMS certificate */
	public String getExpirationTimeOfDay() {
		return this.expirationTimeOfDay;
	}
	/** @param x Expiration time of day (as a string) for a KMS certificate */
	public void setExpirationTimeOfDay(String x) {
		this.expirationTimeOfDay = x;
	}

	/** Expiration time of a KMS certificate in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="Expiration time of a KMS certificate in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long expirationTime;

	/** @return Expiration time of a KMS certificate in seconds since January 1, 1970. */
	public long getExpirationTime() {
		return this.expirationTime;
	}
	/** @param x Expiration time of a KMS certificate in seconds since January 1, 1970. */
	public void setExpirationTime(long x) {
		this.expirationTime = x;
	}
}
