package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed parameters that are supplied to the controller when installing a KMS certificate file. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(316)
public class KMSCertificateFileInstallDescriptor implements Serializable {
	public KMSCertificateFileInstallDescriptor() {
	}

	/** The certificate file type. */
	@io.swagger.annotations.ApiModelProperty(value ="The certificate file type." , required = true)
	@XmlElement(required = true)
	private KMSCertificateFileType kmsCertificateFileType = KMSCertificateFileType.__UNDEFINED;

	/** @return The certificate file type. */
	public KMSCertificateFileType getKmsCertificateFileType() {
		return this.kmsCertificateFileType;
	}
	/** @param x The certificate file type. */
	public void setKmsCertificateFileType(KMSCertificateFileType x) {
		this.kmsCertificateFileType = x;
	}

	/** The certificate file provided as a stream of data. */
	@io.swagger.annotations.ApiModelProperty(value ="The certificate file provided as a stream of data." , required = true)
	@XmlElement(required = true)
	private String kmsCertificateFile;

	/** @return The certificate file provided as a stream of data. */
	public String getKmsCertificateFile() {
		return this.kmsCertificateFile;
	}
	/** @param x The certificate file provided as a stream of data. */
	public void setKmsCertificateFile(String x) {
		this.kmsCertificateFile = x;
	}
}
