package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed parameters that are supplied to the controller when retrieving a KMS certificate file. This would typically be used by a management client to provide information about an installed certificate to an administrator. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(564)
public class KMSCertificateFileRetrieveDescriptor implements Serializable {
	public KMSCertificateFileRetrieveDescriptor() {
	}

	/** The certificate file type. */
	@io.swagger.annotations.ApiModelProperty(value ="The certificate file type." , required = true)
	@XmlElement(required = true)
	private KMSCertificateFileType kmsCertificateFileType = KMSCertificateFileType.__UNDEFINED;

	/** @return The certificate file type. */
	public KMSCertificateFileType getKmsCertificateFileType() {
		return this.kmsCertificateFileType;
	}
	/** @param x The certificate file type. */
	public void setKmsCertificateFileType(KMSCertificateFileType x) {
		this.kmsCertificateFileType = x;
	}
}
