package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union conveys information about a KMS certificate file being retrieved from the storage array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(317)
public class KMSCertificateFileReturn implements Serializable {
	public KMSCertificateFileReturn() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The requested certificate file being returned as a stream of data. */
	@io.swagger.annotations.ApiModelProperty(value ="The requested certificate file being returned as a stream of data." , required = false)
	@XmlElement(required = false)
	private String certificateFile;

	/** @return The requested certificate file being returned as a stream of data. */
	public String getCertificateFile() {
		return this.certificateFile;
	}
	/** @param x The requested certificate file being returned as a stream of data. */
	public void setCertificateFile(String x) {
		this.certificateFile = x;
	}
}
