package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Identifies the type of Key Management Server (KMS) certificate file to be retrieved from or installed on the storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(265)
public enum KMSCertificateFileType implements Serializable {
		/** Should not happen. */
		certificateFileTypeUnknown(0),
		/** Indicates a signed client certificate. A CSR is signed by a CA to create the signed certificate. */
		clientCertificate(1),
		/** Indicates a signed server certificate from the KMIP server. */
		serverCertificate(3),
		__UNDEFINED(464378545);

		public final int value;

		private KMSCertificateFileType(int v) {
			this.value = v;
		}
}
