package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed parameters that are supplied to the controller to generate a Certificate Signing Request (CSR). The contents of this structure make up what is called a Distinguished Name or DN. This supports the UTF-8 character set. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(386)
public class KMSClientCSRDescriptor implements Serializable {
	public KMSClientCSRDescriptor() {
	}

	/** Common Name (eg, your name or your server's host name) */
	@io.swagger.annotations.ApiModelProperty(value ="Common Name (eg, your name or your server's host name)" , required = true)
	@XmlElement(required = true)
	private String commonName;

	/** @return Common Name (eg, your name or your server's host name) */
	public String getCommonName() {
		return this.commonName;
	}
	/** @param x Common Name (eg, your name or your server's host name) */
	public void setCommonName(String x) {
		this.commonName = x;
	}

	/** Organization Name (eg, company) */
	@io.swagger.annotations.ApiModelProperty(value ="Organization Name (eg, company)" , required = true)
	@XmlElement(required = true)
	private String organizationName;

	/** @return Organization Name (eg, company) */
	public String getOrganizationName() {
		return this.organizationName;
	}
	/** @param x Organization Name (eg, company) */
	public void setOrganizationName(String x) {
		this.organizationName = x;
	}

	/** Organizational Unit Name (eg, section) */
	@io.swagger.annotations.ApiModelProperty(value ="Organizational Unit Name (eg, section)" , required = true)
	@XmlElement(required = true)
	private String organizationalUnitName;

	/** @return Organizational Unit Name (eg, section) */
	public String getOrganizationalUnitName() {
		return this.organizationalUnitName;
	}
	/** @param x Organizational Unit Name (eg, section) */
	public void setOrganizationalUnitName(String x) {
		this.organizationalUnitName = x;
	}

	/** Locality Name (eg, city) */
	@io.swagger.annotations.ApiModelProperty(value ="Locality Name (eg, city)" , required = true)
	@XmlElement(required = true)
	private String localityName;

	/** @return Locality Name (eg, city) */
	public String getLocalityName() {
		return this.localityName;
	}
	/** @param x Locality Name (eg, city) */
	public void setLocalityName(String x) {
		this.localityName = x;
	}

	/** State or Province Name (full name) */
	@io.swagger.annotations.ApiModelProperty(value ="State or Province Name (full name)" , required = true)
	@XmlElement(required = true)
	private String stateProvinceName;

	/** @return State or Province Name (full name) */
	public String getStateProvinceName() {
		return this.stateProvinceName;
	}
	/** @param x State or Province Name (full name) */
	public void setStateProvinceName(String x) {
		this.stateProvinceName = x;
	}

	/** Country Name (2 letter code) */
	@io.swagger.annotations.ApiModelProperty(value ="Country Name (2 letter code)" , required = true)
	@XmlElement(required = true)
	private String countryName;

	/** @return Country Name (2 letter code) */
	public String getCountryName() {
		return this.countryName;
	}
	/** @param x Country Name (2 letter code) */
	public void setCountryName(String x) {
		this.countryName = x;
	}
}
