package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the createLockKey procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(352)
public class KeyIDInfo implements Serializable {
	public KeyIDInfo() {
	}

	/** This is the lock Key ID. Whenever a lock key is initialized or changed, a new lock key ID is generated. The lock key ID can be set to a value set by the user, or the controller can generate a lock key. The lock key ID is written to all security-enabled drives that use the referenced lock key. Note that the lock key ID can be read at any time from the disk drive, even if the drive is locked. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the lock Key ID. Whenever a lock key is initialized or changed, a new lock key ID is generated. The lock key ID can be set to a value set by the user, or the controller can generate a lock key. The lock key ID is written to all security-enabled drives that use the referenced lock key. Note that the lock key ID can be read at any time from the disk drive, even if the drive is locked." , required = true)
	@XmlElement(required = true)
	private String lockKeyID;

	/** @return This is the lock Key ID. Whenever a lock key is initialized or changed, a new lock key ID is generated. The lock key ID can be set to a value set by the user, or the controller can generate a lock key. The lock key ID is written to all security-enabled drives that use the referenced lock key. Note that the lock key ID can be read at any time from the disk drive, even if the drive is locked. */
	public String getLockKeyID() {
		return this.lockKeyID;
	}
	/** @param x This is the lock Key ID. Whenever a lock key is initialized or changed, a new lock key ID is generated. The lock key ID can be set to a value set by the user, or the controller can generate a lock key. The lock key ID is written to all security-enabled drives that use the referenced lock key. Note that the lock key ID can be read at any time from the disk drive, even if the drive is locked. */
	public void setLockKeyID(String x) {
		this.lockKeyID = x;
	}

	/** The Pass Phrase is an alphanumeric string that is used to provide a human-compatible method of generating a lock key (for MegaRAID controllers) or for securely wrapping the lock key (external controllers). The controller firmware places no restrictions on the Pass Phrase, but for improved security, the management application will place the following requirements on a Pass Phrase used for any purpose: */
	@io.swagger.annotations.ApiModelProperty(value ="The Pass Phrase is an alphanumeric string that is used to provide a human-compatible method of generating a lock key (for MegaRAID controllers) or for securely wrapping the lock key (external controllers). The controller firmware places no restrictions on the Pass Phrase, but for improved security, the management application will place the following requirements on a Pass Phrase used for any purpose:" , required = true)
	@XmlElement(required = true)
	private String passPhrase;

	/** @return The Pass Phrase is an alphanumeric string that is used to provide a human-compatible method of generating a lock key (for MegaRAID controllers) or for securely wrapping the lock key (external controllers). The controller firmware places no restrictions on the Pass Phrase, but for improved security, the management application will place the following requirements on a Pass Phrase used for any purpose: */
	public String getPassPhrase() {
		return this.passPhrase;
	}
	/** @param x The Pass Phrase is an alphanumeric string that is used to provide a human-compatible method of generating a lock key (for MegaRAID controllers) or for securely wrapping the lock key (external controllers). The controller firmware places no restrictions on the Pass Phrase, but for improved security, the management application will place the following requirements on a Pass Phrase used for any purpose: */
	public void setPassPhrase(String x) {
		this.passPhrase = x;
	}
}
