package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure defines the key value tag which is metadata utilized in application awareness. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(771)
public class KeyValueTag implements Serializable {
	public KeyValueTag() {
	}

	/** The unique handle for a key-value object contained within this structure. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique handle for a key-value object contained within this structure." , required = true)
	@XmlElement(required = true)
	private String keyValueTagRef;

	/** @return The unique handle for a key-value object contained within this structure. */
	public String getKeyValueTagRef() {
		return this.keyValueTagRef;
	}
	/** @param x The unique handle for a key-value object contained within this structure. */
	public void setKeyValueTagRef(String x) {
		this.keyValueTagRef = x;
	}

	/** The key is a fixed length, opaque byte sequence that stores user-defined data. */
	@io.swagger.annotations.ApiModelProperty(value ="The key is a fixed length, opaque byte sequence that stores user-defined data." , required = true)
	@XmlElement(required = true)
	private String key;

	/** @return The key is a fixed length, opaque byte sequence that stores user-defined data. */
	public String getKey() {
		return this.key;
	}
	/** @param x The key is a fixed length, opaque byte sequence that stores user-defined data. */
	public void setKey(String x) {
		this.key = x;
	}

	/** The value is a fixed length opaque byte sequence that stores user-defined data. */
	@io.swagger.annotations.ApiModelProperty(value ="The value is a fixed length opaque byte sequence that stores user-defined data." , required = true)
	@XmlElement(required = true)
	private String value;

	/** @return The value is a fixed length opaque byte sequence that stores user-defined data. */
	public String getValue() {
		return this.value;
	}
	/** @param x The value is a fixed length opaque byte sequence that stores user-defined data. */
	public void setValue(String x) {
		this.value = x;
	}
}
