package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This descriptor defines for the specified volume, the key-value tags that should be associated. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(964)
public class KeyValueTagMappingSetDescriptor implements Serializable {
	public KeyValueTagMappingSetDescriptor() {
	}

	/** This union identifies the type of object and its reference which is to be associated with the key values contained in the list. */
	@io.swagger.annotations.ApiModelProperty(value ="This union identifies the type of object and its reference which is to be associated with the key values contained in the list." , required = true)
	@XmlElement(required = true)
	private KeyValueTagObjectReference object;

	/** @return This union identifies the type of object and its reference which is to be associated with the key values contained in the list. */
	public KeyValueTagObjectReference getObject() {
		return this.object;
	}
	/** @param x This union identifies the type of object and its reference which is to be associated with the key values contained in the list. */
	public void setObject(KeyValueTagObjectReference x) {
		this.object = x;
	}

	/** This defines the list of key value tags that are associated with the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="This defines the list of key value tags that are associated with the volume." , required = true)
	@XmlElement(required = true)
	private KeyValueTagRefList keyValueTagRefList;

	/** @return This defines the list of key value tags that are associated with the volume. */
	public KeyValueTagRefList getKeyValueTagRefList() {
		return this.keyValueTagRefList;
	}
	/** @param x This defines the list of key value tags that are associated with the volume. */
	public void setKeyValueTagRefList(KeyValueTagRefList x) {
		this.keyValueTagRefList = x;
	}
}
