package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union defines the relationship between the KeyValueTagObjectReferenceType and the structure of the reference. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(756)
public class KeyValueTagObjectReference implements Serializable {
	public KeyValueTagObjectReference() {
	}

	/** Enumeration used to define the different type of object that can be associated with a key value tag. */
	@io.swagger.annotations.ApiModelProperty(value ="Enumeration used to define the different type of object that can be associated with a key value tag." , required = true)
	@XmlElement(required = true)
	private KeyValueTagObjectReferenceType objectType = KeyValueTagObjectReferenceType.__UNDEFINED;

	/** @return Enumeration used to define the different type of object that can be associated with a key value tag. */
	public KeyValueTagObjectReferenceType getObjectType() {
		return this.objectType;
	}
	/** @param x Enumeration used to define the different type of object that can be associated with a key value tag. */
	public void setObjectType(KeyValueTagObjectReferenceType x) {
		this.objectType = x;
	}

	/** This field is returned for an object of type Volume. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned for an object of type Volume." , required = false)
	@XmlElement(required = false)
	private String volume;

	/** @return This field is returned for an object of type Volume. */
	public String getVolume() {
		return this.volume;
	}
	/** @param x This field is returned for an object of type Volume. */
	public void setVolume(String x) {
		this.volume = x;
	}

	/** This field is returned for an object of type Workload. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned for an object of type Workload." , required = false)
	@XmlElement(required = false)
	private String workload;

	/** @return This field is returned for an object of type Workload. */
	public String getWorkload() {
		return this.workload;
	}
	/** @param x This field is returned for an object of type Workload. */
	public void setWorkload(String x) {
		this.workload = x;
	}
}
