package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys all required parameter data needed to create a new LUN mapping via the createLUNMapping procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(709)
public class LUNMappingCreationDescriptor implements Serializable {
	public LUNMappingCreationDescriptor() {
	}

	/** The logical unit number used to access the volume via the new mapping definition. */
	@io.swagger.annotations.ApiModelProperty(value ="The logical unit number used to access the volume via the new mapping definition." , required = true)
	@XmlElement(required = true)
	private int lun;

	/** @return The logical unit number used to access the volume via the new mapping definition. */
	public int getLun() {
		return this.lun;
	}
	/** @param x The logical unit number used to access the volume via the new mapping definition. */
	public void setLun(int x) {
		this.lun = x;
	}

	/** The permission values associated with the new mapping definition. This field is not currently used, but is provided for future extensions. */
	@io.swagger.annotations.ApiModelProperty(value ="The permission values associated with the new mapping definition. This field is not currently used, but is provided for future extensions." , required = true)
	@XmlElement(required = true)
	private int perms;

	/** @return The permission values associated with the new mapping definition. This field is not currently used, but is provided for future extensions. */
	public int getPerms() {
		return this.perms;
	}
	/** @param x The permission values associated with the new mapping definition. This field is not currently used, but is provided for future extensions. */
	public void setPerms(int x) {
		this.perms = x;
	}

	/** The unique identification value of the volume that is accessed via the LUN value associated with the new mapping definition. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identification value of the volume that is accessed via the LUN value associated with the new mapping definition." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The unique identification value of the volume that is accessed via the LUN value associated with the new mapping definition. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The unique identification value of the volume that is accessed via the LUN value associated with the new mapping definition. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The unique identifier of the entity for which the mapping applies. The type of the entity, and thus of the SYMbol reference, depends on the mapping type. For example, if the LUNMapping object represents a cluster-wide mapping, this field will contain the ClusterRef of the cluster for which the mapping applies. Similarly, if the object represents a host-specific mapping, this field will contain the HostRef of the host for which the mapping applies. Note that if the object represents a default mapping, this field must contain a NULL SYMbolRef. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier of the entity for which the mapping applies. The type of the entity, and thus of the SYMbol reference, depends on the mapping type. For example, if the LUNMapping object represents a cluster-wide mapping, this field will contain the ClusterRef of the cluster for which the mapping applies. Similarly, if the object represents a host-specific mapping, this field will contain the HostRef of the host for which the mapping applies. Note that if the object represents a default mapping, this field must contain a NULL SYMbolRef." , required = true)
	@XmlElement(required = true)
	private String mapRef;

	/** @return The unique identifier of the entity for which the mapping applies. The type of the entity, and thus of the SYMbol reference, depends on the mapping type. For example, if the LUNMapping object represents a cluster-wide mapping, this field will contain the ClusterRef of the cluster for which the mapping applies. Similarly, if the object represents a host-specific mapping, this field will contain the HostRef of the host for which the mapping applies. Note that if the object represents a default mapping, this field must contain a NULL SYMbolRef. */
	public String getMapRef() {
		return this.mapRef;
	}
	/** @param x The unique identifier of the entity for which the mapping applies. The type of the entity, and thus of the SYMbol reference, depends on the mapping type. For example, if the LUNMapping object represents a cluster-wide mapping, this field will contain the ClusterRef of the cluster for which the mapping applies. Similarly, if the object represents a host-specific mapping, this field will contain the HostRef of the host for which the mapping applies. Note that if the object represents a default mapping, this field must contain a NULL SYMbolRef. */
	public void setMapRef(String x) {
		this.mapRef = x;
	}
}
