package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to return the result of a getLUNMappings procedure call. Note that this information is also present in the standard ObjectBundle that is returned by the getObjectGraph procedure, which is the preferred mechanism for obtaining such state information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(804)
public class LUNMappings implements Serializable {
	public LUNMappings() {
	}

	/** An indication of the outcome of the request. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of the outcome of the request." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An indication of the outcome of the request. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An indication of the outcome of the request. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** An array containing all currently-defined LUN mappings. The unique identification value for this object. Other objects may use this reference value to refer to the mapping definition. */
	@io.swagger.annotations.ApiModelProperty(value ="An array containing all currently-defined LUN mappings. The unique identification value for this object. Other objects may use this reference value to refer to the mapping definition." , required = true)
	@XmlElement(required = true)
	private LUNMapping[] lunMapping;

	/** @return An array containing all currently-defined LUN mappings. The unique identification value for this object. Other objects may use this reference value to refer to the mapping definition. */
	public LUNMapping[] getLunMapping() {
		return this.lunMapping;
	}
	/** @param x An array containing all currently-defined LUN mappings. The unique identification value for this object. Other objects may use this reference value to refer to the mapping definition. */
	public void setLunMapping(LUNMapping[] x) {
		this.lunMapping = x;
	}
}
