package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to identify the status of a network link. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(230)
public enum LinkStatus implements Serializable {
		/** Link status status does not apply for a certain I/O interface technology (e.g., Serial-Attached SCSI). */
		none(0),
		/** The link is operational. */
		up(1),
		/** The link is not operational. */
		down(2),
		/** The link is failed. */
		failed(3),
		__UNDEFINED(464378545);

		public final int value;

		private LinkStatus(int v) {
			this.value = v;
		}
}
