package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Internal Message Description sent from the WebService Proxy. Indicates a local user account has become locked out or unlocked due to authentication failures. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(935)
public class LocalUserAuthFailLockoutDesc implements Serializable {
	public LocalUserAuthFailLockoutDesc() {
	}

	/** IP Address affected by the lockout */
	@io.swagger.annotations.ApiModelProperty(value ="IP Address affected by the lockout" , required = true)
	@XmlElement(required = true)
	private IpVxAddress ipAddress;

	/** @return IP Address affected by the lockout */
	public IpVxAddress getIpAddress() {
		return this.ipAddress;
	}
	/** @param x IP Address affected by the lockout */
	public void setIpAddress(IpVxAddress x) {
		this.ipAddress = x;
	}

	/** True if the IP Address is now locked out, and false if it has been re-enabled */
	@io.swagger.annotations.ApiModelProperty(value ="True if the IP Address is now locked out, and false if it has been re-enabled" , required = true)
	@XmlElement(required = true)
	private boolean isLockedOut;

	/** @return True if the IP Address is now locked out, and false if it has been re-enabled */
	public boolean isIsLockedOut() {
		return this.isLockedOut;
	}
	/** @param x True if the IP Address is now locked out, and false if it has been re-enabled */
	public void setIsLockedOut(boolean x) {
		this.isLockedOut = x;
	}
}
