package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is returned by getCtlLockDownInfo() when a controller is locked down. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(691)
public class LockDownInfoReturned implements Serializable {
	public LockDownInfoReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field contains information about a locked down controller and is only valid if returnCode is RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains information about a locked down controller and is only valid if returnCode is RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private LockDownInfo lockDownInfo;

	/** @return This field contains information about a locked down controller and is only valid if returnCode is RETCODE_OK. */
	public LockDownInfo getLockDownInfo() {
		return this.lockDownInfo;
	}
	/** @param x This field contains information about a locked down controller and is only valid if returnCode is RETCODE_OK. */
	public void setLockDownInfo(LockDownInfo x) {
		this.lockDownInfo = x;
	}
}
