package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This object provides the native controller firmware version for the array. This information is returned when a simplex controller lockdown occurs because of a firmware mismatch between the newly inserted controller and the version of firmware stored in the configuration database on the drives in the array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(369)
public class LockdownCtrlFwVersion implements Serializable {
	public LockdownCtrlFwVersion() {
	}

	/** The firmware version of the native controller, as read from the configuration database on the array drives. Note that this will be dot delimited; i.e. nn.nn.nn.nn. */
	@io.swagger.annotations.ApiModelProperty(value ="The firmware version of the native controller, as read from the configuration database on the array drives. Note that this will be dot delimited; i.e. nn.nn.nn.nn." , required = true)
	@XmlElement(required = true)
	private String fwVersion;

	/** @return The firmware version of the native controller, as read from the configuration database on the array drives. Note that this will be dot delimited; i.e. nn.nn.nn.nn. */
	public String getFwVersion() {
		return this.fwVersion;
	}
	/** @param x The firmware version of the native controller, as read from the configuration database on the array drives. Note that this will be dot delimited; i.e. nn.nn.nn.nn. */
	public void setFwVersion(String x) {
		this.fwVersion = x;
	}
}
