package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to report progress of a particular long-lived operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1178)
public class LongLivedOperation implements Serializable {
	public LongLivedOperation() {
	}

	/** This enumeration object is used to specify one of a set of volume actions that may be active for a volume. These volume actions represent "long-running" operations on a volume. Any time such an operation is active, the current progress can be determined using the getVolumeActionProgress procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to specify one of a set of volume actions that may be active for a volume. These volume actions represent \"long-running\" operations on a volume. Any time such an operation is active, the current progress can be determined using the getVolumeActionProgress procedure." , required = true)
	@XmlElement(required = true)
	private VolumeAction volAction = VolumeAction.__UNDEFINED;

	/** @return This enumeration object is used to specify one of a set of volume actions that may be active for a volume. These volume actions represent "long-running" operations on a volume. Any time such an operation is active, the current progress can be determined using the getVolumeActionProgress procedure. */
	public VolumeAction getVolAction() {
		return this.volAction;
	}
	/** @param x This enumeration object is used to specify one of a set of volume actions that may be active for a volume. These volume actions represent "long-running" operations on a volume. Any time such an operation is active, the current progress can be determined using the getVolumeActionProgress procedure. */
	public void setVolAction(VolumeAction x) {
		this.volAction = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_COPYBACK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_COPYBACK." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation copyback;

	/** @return This field is present only if volAction is equal to VOL_ACTION_COPYBACK. */
	public VolumeGroupOperation getCopyback() {
		return this.copyback;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_COPYBACK. */
	public void setCopyback(VolumeGroupOperation x) {
		this.copyback = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_RECONSTRUCTING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_RECONSTRUCTING." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation reconstruct;

	/** @return This field is present only if volAction is equal to VOL_ACTION_RECONSTRUCTING. */
	public VolumeGroupOperation getReconstruct() {
		return this.reconstruct;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_RECONSTRUCTING. */
	public void setReconstruct(VolumeGroupOperation x) {
		this.reconstruct = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCE." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation capacityExpansion;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCE. */
	public VolumeGroupOperation getCapacityExpansion() {
		return this.capacityExpansion;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCE. */
	public void setCapacityExpansion(VolumeGroupOperation x) {
		this.capacityExpansion = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DRM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DRM." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation raidMigration;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DRM. */
	public VolumeGroupOperation getRaidMigration() {
		return this.raidMigration;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DRM. */
	public void setRaidMigration(VolumeGroupOperation x) {
		this.raidMigration = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDRM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDRM." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation raidMigrationandExpansion;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDRM. */
	public VolumeGroupOperation getRaidMigrationandExpansion() {
		return this.raidMigrationandExpansion;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDRM. */
	public void setRaidMigrationandExpansion(VolumeGroupOperation x) {
		this.raidMigrationandExpansion = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DSEG. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DSEG." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation segSize;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DSEG. */
	public VolumeGroupOperation getSegSize() {
		return this.segSize;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DSEG. */
	public void setSegSize(VolumeGroupOperation x) {
		this.segSize = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DVE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DVE." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation volExpansion;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DVE. */
	public VolumeGroupOperation getVolExpansion() {
		return this.volExpansion;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DVE. */
	public void setVolExpansion(VolumeGroupOperation x) {
		this.volExpansion = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDVE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDVE." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation volAndCapExpansion;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDVE. */
	public VolumeGroupOperation getVolAndCapExpansion() {
		return this.volAndCapExpansion;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DCEDVE. */
	public void setVolAndCapExpansion(VolumeGroupOperation x) {
		this.volAndCapExpansion = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DEFRAG. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DEFRAG." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation defrag;

	/** @return This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DEFRAG. */
	public VolumeGroupOperation getDefrag() {
		return this.defrag;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_REMAPPING_DEFRAG. */
	public void setDefrag(VolumeGroupOperation x) {
		this.defrag = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_INITIALIZING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_INITIALIZING." , required = false)
	@XmlElement(required = false)
	private InitializationOperation init;

	/** @return This field is present only if volAction is equal to VOL_ACTION_INITIALIZING. */
	public InitializationOperation getInit() {
		return this.init;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_INITIALIZING. */
	public void setInit(InitializationOperation x) {
		this.init = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_FORMATTING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_FORMATTING." , required = false)
	@XmlElement(required = false)
	private InitializationOperation format;

	/** @return This field is present only if volAction is equal to VOL_ACTION_FORMATTING. */
	public InitializationOperation getFormat() {
		return this.format;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_FORMATTING. */
	public void setFormat(InitializationOperation x) {
		this.format = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_SYNCHRONIZING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_SYNCHRONIZING." , required = false)
	@XmlElement(required = false)
	private MirrorSyncOperation sync;

	/** @return This field is present only if volAction is equal to VOL_ACTION_SYNCHRONIZING. */
	public MirrorSyncOperation getSync() {
		return this.sync;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_SYNCHRONIZING. */
	public void setSync(MirrorSyncOperation x) {
		this.sync = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_VOLUME_COPY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_VOLUME_COPY." , required = false)
	@XmlElement(required = false)
	private VolumeCopyOperation copy;

	/** @return This field is present only if volAction is equal to VOL_ACTION_VOLUME_COPY. */
	public VolumeCopyOperation getCopy() {
		return this.copy;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_VOLUME_COPY. */
	public void setCopy(VolumeCopyOperation x) {
		this.copy = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_PARITY_SCAN. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_PARITY_SCAN." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation parityScan;

	/** @return This field is present only if volAction is equal to VOL_ACTION_PARITY_SCAN. */
	public VolumeGroupOperation getParityScan() {
		return this.parityScan;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_PARITY_SCAN. */
	public void setParityScan(VolumeGroupOperation x) {
		this.parityScan = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_SNAPSHOT_ROLLBACK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_SNAPSHOT_ROLLBACK." , required = false)
	@XmlElement(required = false)
	private SnapshotRollbackOperation rollback;

	/** @return This field is present only if volAction is equal to VOL_ACTION_SNAPSHOT_ROLLBACK. */
	public SnapshotRollbackOperation getRollback() {
		return this.rollback;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_SNAPSHOT_ROLLBACK. */
	public void setRollback(SnapshotRollbackOperation x) {
		this.rollback = x;
	}

	/** This field is present only if volAction is equal to VOL_ACTION_PIT_ROLLBACK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if volAction is equal to VOL_ACTION_PIT_ROLLBACK." , required = false)
	@XmlElement(required = false)
	private PITRollbackOperation pitRollback;

	/** @return This field is present only if volAction is equal to VOL_ACTION_PIT_ROLLBACK. */
	public PITRollbackOperation getPitRollback() {
		return this.pitRollback;
	}
	/** @param x This field is present only if volAction is equal to VOL_ACTION_PIT_ROLLBACK. */
	public void setPitRollback(PITRollbackOperation x) {
		this.pitRollback = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_ASYNC_MIRROR_GROUP_INITIAL_SYNC. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_ASYNC_MIRROR_GROUP_INITIAL_SYNC." , required = false)
	@XmlElement(required = false)
	private AsyncMirrorGroupInitialSyncOperation initialSync;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_ASYNC_MIRROR_GROUP_INITIAL_SYNC. */
	public AsyncMirrorGroupInitialSyncOperation getInitialSync() {
		return this.initialSync;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_ASYNC_MIRROR_GROUP_INITIAL_SYNC. */
	public void setInitialSync(AsyncMirrorGroupInitialSyncOperation x) {
		this.initialSync = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_REBALANCING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_REBALANCING." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation rebalancing;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_REBALANCING. */
	public VolumeGroupOperation getRebalancing() {
		return this.rebalancing;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_REBALANCING. */
	public void setRebalancing(VolumeGroupOperation x) {
		this.rebalancing = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation copyThenFail;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL. */
	public VolumeGroupOperation getCopyThenFail() {
		return this.copyThenFail;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL. */
	public void setCopyThenFail(VolumeGroupOperation x) {
		this.copyThenFail = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL_PENDING. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL_PENDING." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation copyThenFailPending;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL_PENDING. */
	public VolumeGroupOperation getCopyThenFailPending() {
		return this.copyThenFailPending;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_FAIL_PENDING. */
	public void setCopyThenFailPending(VolumeGroupOperation x) {
		this.copyThenFailPending = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation copyThenReplace;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE. */
	public VolumeGroupOperation getCopyThenReplace() {
		return this.copyThenReplace;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE. */
	public void setCopyThenReplace(VolumeGroupOperation x) {
		this.copyThenReplace = x;
	}

	/** This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE_AND_FAIL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE_AND_FAIL." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation copyThenReplaceAndFail;

	/** @return This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE_AND_FAIL. */
	public VolumeGroupOperation getCopyThenReplaceAndFail() {
		return this.copyThenReplaceAndFail;
	}
	/** @param x This field is present only if the value of volAction is equal to VOL_ACTION_COPY_THEN_REPLACE_AND_FAIL. */
	public void setCopyThenReplaceAndFail(VolumeGroupOperation x) {
		this.copyThenReplaceAndFail = x;
	}

	/** This field is present only if the DDP pool is critical due to two drive failures. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the DDP pool is critical due to two drive failures." , required = false)
	@XmlElement(required = false)
	private VolumeGroupOperation reconstructCritical;

	/** @return This field is present only if the DDP pool is critical due to two drive failures. */
	public VolumeGroupOperation getReconstructCritical() {
		return this.reconstructCritical;
	}
	/** @param x This field is present only if the DDP pool is critical due to two drive failures. */
	public void setReconstructCritical(VolumeGroupOperation x) {
		this.reconstructCritical = x;
	}

	/** Thin volume defrag operation */
	@io.swagger.annotations.ApiModelProperty(value ="Thin volume defrag operation" , required = false)
	@XmlElement(required = false)
	private VolumeOperation thinDefrag;

	/** @return Thin volume defrag operation */
	public VolumeOperation getThinDefrag() {
		return this.thinDefrag;
	}
	/** @param x Thin volume defrag operation */
	public void setThinDefrag(VolumeOperation x) {
		this.thinDefrag = x;
	}

	/** A DDP Volume is in the creating state. */
	@io.swagger.annotations.ApiModelProperty(value ="A DDP Volume is in the creating state." , required = false)
	@XmlElement(required = false)
	private VolumeOperation volCreation;

	/** @return A DDP Volume is in the creating state. */
	public VolumeOperation getVolCreation() {
		return this.volCreation;
	}
	/** @param x A DDP Volume is in the creating state. */
	public void setVolCreation(VolumeOperation x) {
		this.volCreation = x;
	}

	/** A DDP Volume is in the deleting state. */
	@io.swagger.annotations.ApiModelProperty(value ="A DDP Volume is in the deleting state." , required = false)
	@XmlElement(required = false)
	private VolumeOperation volDeletion;

	/** @return A DDP Volume is in the deleting state. */
	public VolumeOperation getVolDeletion() {
		return this.volDeletion;
	}
	/** @param x A DDP Volume is in the deleting state. */
	public void setVolDeletion(VolumeOperation x) {
		this.volDeletion = x;
	}
}
