package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes an extent, or range, of MEL entries. This structure is used as an output of the SYMbol procedure getMelExtents and an input to the SYMbol procedure getMelEntries. When the structure is returned by getMelExtents, the starting sequence number and the ending sequence number are equal if the MEL log is empty. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(413)
public class MelExtent implements Serializable {
	public MelExtent() {
	}

	/** This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned." , required = true)
	@XmlElement(required = true)
	private long startingSeqNum;

	/** @return This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned. */
	public long getStartingSeqNum() {
		return this.startingSeqNum;
	}
	/** @param x This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned. */
	public void setStartingSeqNum(long x) {
		this.startingSeqNum = x;
	}

	/** When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned. */
	@io.swagger.annotations.ApiModelProperty(value ="When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned." , required = true)
	@XmlElement(required = true)
	private long endingSeqNum;

	/** @return When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned. */
	public long getEndingSeqNum() {
		return this.endingSeqNum;
	}
	/** @param x When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned. */
	public void setEndingSeqNum(long x) {
		this.endingSeqNum = x;
	}
}
