package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the range of management client records to read in a given operation */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(494)
public class MgmtClientRecordReadDescriptor implements Serializable {
	public MgmtClientRecordReadDescriptor() {
	}

	/** This field contains the database ID of the first record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the database ID of the first record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record." , required = true)
	@XmlElement(required = true)
	private MgmtClientRecordId rangeBegin;

	/** @return This field contains the database ID of the first record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	public MgmtClientRecordId getRangeBegin() {
		return this.rangeBegin;
	}
	/** @param x This field contains the database ID of the first record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	public void setRangeBegin(MgmtClientRecordId x) {
		this.rangeBegin = x;
	}

	/** This field contains the database ID of the last record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the database ID of the last record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record." , required = true)
	@XmlElement(required = true)
	private MgmtClientRecordId rangeEnd;

	/** @return This field contains the database ID of the last record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	public MgmtClientRecordId getRangeEnd() {
		return this.rangeEnd;
	}
	/** @param x This field contains the database ID of the last record of a range of records to read. Note that the read operation reads all records in the range, inclusive of this record. */
	public void setRangeEnd(MgmtClientRecordId x) {
		this.rangeEnd = x;
	}
}
