package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain the list of valid volumes for mirroring on the remote array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(563)
public class MirrorVolumeCandidateList implements Serializable {
	public MirrorVolumeCandidateList() {
	}

	/** The list of valid volumes for mirroring. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of valid volumes for mirroring." , required = true)
	@XmlElement(required = true)
	private MirrorVolumeCandidate[] mirrorVolumeCandidate;

	/** @return The list of valid volumes for mirroring. */
	public MirrorVolumeCandidate[] getMirrorVolumeCandidate() {
		return this.mirrorVolumeCandidate;
	}
	/** @param x The list of valid volumes for mirroring. */
	public void setMirrorVolumeCandidate(MirrorVolumeCandidate[] x) {
		this.mirrorVolumeCandidate = x;
	}

	/** The return code from getVolumeListForMirroring. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from getVolumeListForMirroring." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code from getVolumeListForMirroring. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code from getVolumeListForMirroring. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The current configuration generation number of the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The current configuration generation number of the remote array." , required = true)
	@XmlElement(required = true)
	private long remoteCfgGeneration;

	/** @return The current configuration generation number of the remote array. */
	public long getRemoteCfgGeneration() {
		return this.remoteCfgGeneration;
	}
	/** @param x The current configuration generation number of the remote array. */
	public void setRemoteCfgGeneration(long x) {
		this.remoteCfgGeneration = x;
	}
}
