package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union describes the protocol properties associated with a command set type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1132)
public class NVMeCommandProtocolProperties implements Serializable {
	public NVMeCommandProtocolProperties() {
	}

	/** This enumeration describes the command set type (e.g. to descriminate between the NVMe and NVMe over Fabrics command sets). */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration describes the command set type (e.g. to descriminate between the NVMe and NVMe over Fabrics command sets)." , required = true)
	@XmlElement(required = true)
	private CommandSetType commandSet = CommandSetType.__UNDEFINED;

	/** @return This enumeration describes the command set type (e.g. to descriminate between the NVMe and NVMe over Fabrics command sets). */
	public CommandSetType getCommandSet() {
		return this.commandSet;
	}
	/** @param x This enumeration describes the command set type (e.g. to descriminate between the NVMe and NVMe over Fabrics command sets). */
	public void setCommandSet(CommandSetType x) {
		this.commandSet = x;
	}

	/** This describes the NVMe over Fabrics protocol properties. */
	@io.swagger.annotations.ApiModelProperty(value ="This describes the NVMe over Fabrics protocol properties." , required = false)
	@XmlElement(required = false)
	private NVMeoFProtocolProperties nvmeofProperties;

	/** @return This describes the NVMe over Fabrics protocol properties. */
	public NVMeoFProtocolProperties getNvmeofProperties() {
		return this.nvmeofProperties;
	}
	/** @param x This describes the NVMe over Fabrics protocol properties. */
	public void setNvmeofProperties(NVMeoFProtocolProperties x) {
		this.nvmeofProperties = x;
	}
}
