package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Defines an NVMe over Fabrics Initiator Port, both the NQN and the 128-bit Host Identifier */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(948)
public class NVMeInitiatorPortId implements Serializable {
	public NVMeInitiatorPortId() {
	}

	/** NVMe Qualified Name (NQN) of the host */
	@io.swagger.annotations.ApiModelProperty(value ="NVMe Qualified Name (NQN) of the host" , required = true)
	@XmlElement(required = true)
	private String name;

	/** @return NVMe Qualified Name (NQN) of the host */
	public String getName() {
		return this.name;
	}
	/** @param x NVMe Qualified Name (NQN) of the host */
	public void setName(String x) {
		this.name = x;
	}

	/** 128-bit Host Identifier value */
	@io.swagger.annotations.ApiModelProperty(value ="128-bit Host Identifier value" , required = true)
	@XmlElement(required = true)
	private String hostIdentifier;

	/** @return 128-bit Host Identifier value */
	public String getHostIdentifier() {
		return this.hostIdentifier;
	}
	/** @param x 128-bit Host Identifier value */
	public void setHostIdentifier(String x) {
		this.hostIdentifier = x;
	}

	/** The unique identifier for the host port. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for the host port." , required = true)
	@XmlElement(required = true)
	private HostPortLocation portIdentifier;

	/** @return The unique identifier for the host port. */
	public HostPortLocation getPortIdentifier() {
		return this.portIdentifier;
	}
	/** @param x The unique identifier for the host port. */
	public void setPortIdentifier(HostPortLocation x) {
		this.portIdentifier = x;
	}
}
