package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure shows the NVMe over Fabrics statistical data that is relative to a pre-set baseline. These statistics consist of start-of-day-relative counters, and user-baseline-relative counters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1010)
public class NVMeoFBaselinedStatistics implements Serializable {
	public NVMeoFBaselinedStatistics() {
	}

	/** The time data associated with this set of statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="The time data associated with this set of statistics." , required = true)
	@XmlElement(required = true)
	private StatisticalTimeData timeData;

	/** @return The time data associated with this set of statistics. */
	public StatisticalTimeData getTimeData() {
		return this.timeData;
	}
	/** @param x The time data associated with this set of statistics. */
	public void setTimeData(StatisticalTimeData x) {
		this.timeData = x;
	}

	/** An array of structures containing "raw" (i.e., baseline = controller start-of-day) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing \"raw\" (i.e., baseline = controller start-of-day) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private NVMeoFInterfaceStatistics[] nvmeofInterfaceStatisticsRaw;

	/** @return An array of structures containing "raw" (i.e., baseline = controller start-of-day) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	public NVMeoFInterfaceStatistics[] getNvmeofInterfaceStatisticsRaw() {
		return this.nvmeofInterfaceStatisticsRaw;
	}
	/** @param x An array of structures containing "raw" (i.e., baseline = controller start-of-day) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	public void setNvmeofInterfaceStatisticsRaw(NVMeoFInterfaceStatistics[] x) {
		this.nvmeofInterfaceStatisticsRaw = x;
	}

	/** An array of structures containing "relative" (i.e., baseline = user pre-set baseline) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of structures containing \"relative\" (i.e., baseline = user pre-set baseline) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private NVMeoFInterfaceStatistics[] nvmeofInterfaceStatisticsRel;

	/** @return An array of structures containing "relative" (i.e., baseline = user pre-set baseline) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	public NVMeoFInterfaceStatistics[] getNvmeofInterfaceStatisticsRel() {
		return this.nvmeofInterfaceStatisticsRel;
	}
	/** @param x An array of structures containing "relative" (i.e., baseline = user pre-set baseline) NVMe over Fabrics interface statistics, one structure per NVMe over Fabrics interface. */
	public void setNvmeofInterfaceStatisticsRel(NVMeoFInterfaceStatistics[] x) {
		this.nvmeofInterfaceStatisticsRel = x;
	}
}
