package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes the statistics for an NVMe over Fabrics interface. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(794)
public class NVMeoFInterfaceStatistics implements Serializable {
	public NVMeoFInterfaceStatistics() {
	}

	/** The reference to the interface object. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the interface object." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The reference to the interface object. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The reference to the interface object. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The number of NVMe controllers (i.e., I_T_Nexuses in SCSI terminology) over this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVMe controllers (i.e., I_T_Nexuses in SCSI terminology) over this interface." , required = true)
	@XmlElement(required = true)
	private int totalControllerCount;

	/** @return The number of NVMe controllers (i.e., I_T_Nexuses in SCSI terminology) over this interface. */
	public int getTotalControllerCount() {
		return this.totalControllerCount;
	}
	/** @param x The number of NVMe controllers (i.e., I_T_Nexuses in SCSI terminology) over this interface. */
	public void setTotalControllerCount(int x) {
		this.totalControllerCount = x;
	}

	/** The number of Keep Alive Timeouts that have occurred on this NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of Keep Alive Timeouts that have occurred on this NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private long keepAliveTimeouts;

	/** @return The number of Keep Alive Timeouts that have occurred on this NVMe over Fabrics interface. */
	public long getKeepAliveTimeouts() {
		return this.keepAliveTimeouts;
	}
	/** @param x The number of Keep Alive Timeouts that have occurred on this NVMe over Fabrics interface. */
	public void setKeepAliveTimeouts(long x) {
		this.keepAliveTimeouts = x;
	}

	/** The maximum number of I/O Queue Connect Failures that have occurred on this NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum number of I/O Queue Connect Failures that have occurred on this NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private long maxIoQueuesConnectFailures;

	/** @return The maximum number of I/O Queue Connect Failures that have occurred on this NVMe over Fabrics interface. */
	public long getMaxIoQueuesConnectFailures() {
		return this.maxIoQueuesConnectFailures;
	}
	/** @param x The maximum number of I/O Queue Connect Failures that have occurred on this NVMe over Fabrics interface. */
	public void setMaxIoQueuesConnectFailures(long x) {
		this.maxIoQueuesConnectFailures = x;
	}

	/** The maximum number of NVMe Controller Connect Failures that have occurred on this NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum number of NVMe Controller Connect Failures that have occurred on this NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private long maxControllerConnectFailures;

	/** @return The maximum number of NVMe Controller Connect Failures that have occurred on this NVMe over Fabrics interface. */
	public long getMaxControllerConnectFailures() {
		return this.maxControllerConnectFailures;
	}
	/** @param x The maximum number of NVMe Controller Connect Failures that have occurred on this NVMe over Fabrics interface. */
	public void setMaxControllerConnectFailures(long x) {
		this.maxControllerConnectFailures = x;
	}

	/** The number of NVM Controller Resets that have occurred on this NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVM Controller Resets that have occurred on this NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private long nvmeControllerResets;

	/** @return The number of NVM Controller Resets that have occurred on this NVMe over Fabrics interface. */
	public long getNvmeControllerResets() {
		return this.nvmeControllerResets;
	}
	/** @param x The number of NVM Controller Resets that have occurred on this NVMe over Fabrics interface. */
	public void setNvmeControllerResets(long x) {
		this.nvmeControllerResets = x;
	}

	/** The number of NVM Controller Shutdowns that have occurred on this NVMe over Fabrics interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVM Controller Shutdowns that have occurred on this NVMe over Fabrics interface." , required = true)
	@XmlElement(required = true)
	private long nvmeControllerShutdowns;

	/** @return The number of NVM Controller Shutdowns that have occurred on this NVMe over Fabrics interface. */
	public long getNvmeControllerShutdowns() {
		return this.nvmeControllerShutdowns;
	}
	/** @param x The number of NVM Controller Shutdowns that have occurred on this NVMe over Fabrics interface. */
	public void setNvmeControllerShutdowns(long x) {
		this.nvmeControllerShutdowns = x;
	}

	/** This structure describes the NVMe over Fabrics queue statistics for the Admin Queue. */
	@io.swagger.annotations.ApiModelProperty(value ="This structure describes the NVMe over Fabrics queue statistics for the Admin Queue." , required = true)
	@XmlElement(required = true)
	private NVMeoFQueueStatistics adminQueueStatistics;

	/** @return This structure describes the NVMe over Fabrics queue statistics for the Admin Queue. */
	public NVMeoFQueueStatistics getAdminQueueStatistics() {
		return this.adminQueueStatistics;
	}
	/** @param x This structure describes the NVMe over Fabrics queue statistics for the Admin Queue. */
	public void setAdminQueueStatistics(NVMeoFQueueStatistics x) {
		this.adminQueueStatistics = x;
	}

	/** This structure describes the NVMe over Fabrics queue statistics for the I/O Queues. */
	@io.swagger.annotations.ApiModelProperty(value ="This structure describes the NVMe over Fabrics queue statistics for the I/O Queues." , required = true)
	@XmlElement(required = true)
	private NVMeoFQueueStatistics ioQueueStatistics;

	/** @return This structure describes the NVMe over Fabrics queue statistics for the I/O Queues. */
	public NVMeoFQueueStatistics getIoQueueStatistics() {
		return this.ioQueueStatistics;
	}
	/** @param x This structure describes the NVMe over Fabrics queue statistics for the I/O Queues. */
	public void setIoQueueStatistics(NVMeoFQueueStatistics x) {
		this.ioQueueStatistics = x;
	}
}
