package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union defines the properties of the NVMe over Fabrics protocol for the given provider. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1063)
public class NVMeoFProtocolProperties implements Serializable {
	public NVMeoFProtocolProperties() {
	}

	/** This enumeration is used to identify the provider (i.e. intermediate transport protocol) of the RDMA transport. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to identify the provider (i.e. intermediate transport protocol) of the RDMA transport." , required = true)
	@XmlElement(required = true)
	private NVMeoFRDMAProvider provider = NVMeoFRDMAProvider.__UNDEFINED;

	/** @return This enumeration is used to identify the provider (i.e. intermediate transport protocol) of the RDMA transport. */
	public NVMeoFRDMAProvider getProvider() {
		return this.provider;
	}
	/** @param x This enumeration is used to identify the provider (i.e. intermediate transport protocol) of the RDMA transport. */
	public void setProvider(NVMeoFRDMAProvider x) {
		this.provider = x;
	}

	/** This defines the Infiniband properties for NVMe over Fabrics. */
	@io.swagger.annotations.ApiModelProperty(value ="This defines the Infiniband properties for NVMe over Fabrics." , required = false)
	@XmlElement(required = false)
	private NVMeoFInfinibandProperties ibProperties;

	/** @return This defines the Infiniband properties for NVMe over Fabrics. */
	public NVMeoFInfinibandProperties getIbProperties() {
		return this.ibProperties;
	}
	/** @param x This defines the Infiniband properties for NVMe over Fabrics. */
	public void setIbProperties(NVMeoFInfinibandProperties x) {
		this.ibProperties = x;
	}
}
