package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the NVMe over Fabrics queue statistics related to connects, disconnects, command counts by status, etc. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(544)
public class NVMeoFQueueStatistics implements Serializable {
	public NVMeoFQueueStatistics() {
	}

	/** The number of successful NVMeof Connect requests. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of successful NVMeof Connect requests." , required = true)
	@XmlElement(required = true)
	private long successfulConnectRequests;

	/** @return The number of successful NVMeof Connect requests. */
	public long getSuccessfulConnectRequests() {
		return this.successfulConnectRequests;
	}
	/** @param x The number of successful NVMeof Connect requests. */
	public void setSuccessfulConnectRequests(long x) {
		this.successfulConnectRequests = x;
	}

	/** The number of NVMeof connection failures. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVMeof connection failures." , required = true)
	@XmlElement(required = true)
	private long connectionFailures;

	/** @return The number of NVMeof connection failures. */
	public long getConnectionFailures() {
		return this.connectionFailures;
	}
	/** @param x The number of NVMeof connection failures. */
	public void setConnectionFailures(long x) {
		this.connectionFailures = x;
	}

	/** The number of NVMeof disconnects. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVMeof disconnects." , required = true)
	@XmlElement(required = true)
	private long disconnects;

	/** @return The number of NVMeof disconnects. */
	public long getDisconnects() {
		return this.disconnects;
	}
	/** @param x The number of NVMeof disconnects. */
	public void setDisconnects(long x) {
		this.disconnects = x;
	}

	/** The number of NVMeof commands that returned good status. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVMeof commands that returned good status." , required = true)
	@XmlElement(required = true)
	private long commandsGoodStatus;

	/** @return The number of NVMeof commands that returned good status. */
	public long getCommandsGoodStatus() {
		return this.commandsGoodStatus;
	}
	/** @param x The number of NVMeof commands that returned good status. */
	public void setCommandsGoodStatus(long x) {
		this.commandsGoodStatus = x;
	}

	/** The number of NVMeof commands that returned error status. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of NVMeof commands that returned error status." , required = true)
	@XmlElement(required = true)
	private long commandsErrorStatus;

	/** @return The number of NVMeof commands that returned error status. */
	public long getCommandsErrorStatus() {
		return this.commandsErrorStatus;
	}
	/** @param x The number of NVMeof commands that returned error status. */
	public void setCommandsErrorStatus(long x) {
		this.commandsErrorStatus = x;
	}
}
