package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to identify the provider (i.e. intermediate transport protocol) of the RDMA transport. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(132)
public enum NVMeoFRDMAProvider implements Serializable {
		/** The RDMA provider is unknown. */
		providerUnknown(0),
		/** The RDMA provider is unspecified. */
		providerUnspecified(1),
		/** The RDMA provider is Infiniband. */
		providerInfiniband(2),
		/** The RDMA provider is ROCE (RDMA over Converged Ethernet) v1. */
		providerRoce(3),
		/** The RDMA provider is ROCE (RDMA over Converged Ethernet) v2. */
		providerRocev2(4),
		/** The RDMA provider is iWARP. */
		providerIwarp(5),
		/** There is no RDMA provider as Fibre Channel is the transport. */
		noneFc(6),
		__UNDEFINED(464378545);

		public final int value;

		private NVMeoFRDMAProvider(int v) {
			this.value = v;
		}
}
