package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the NVMe over Fabrics statistical data reported by the getNVMeoFStatistics procedure. There are two sub-groups of statistics in this structure: statistical counters that are relative to a baseline and point-in-time readings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1143)
public class NVMeoFStatisticalData implements Serializable {
	public NVMeoFStatisticalData() {
	}

	/** A reference to the controller that collected these statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller that collected these statistics." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return A reference to the controller that collected these statistics. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference to the controller that collected these statistics. */
	public void setController(String x) {
		this.controller = x;
	}

	/** NVMe over Fabrics counter-oriented statistics that are relative to a pre-set baseline. */
	@io.swagger.annotations.ApiModelProperty(value ="NVMe over Fabrics counter-oriented statistics that are relative to a pre-set baseline." , required = true)
	@XmlElement(required = true)
	private NVMeoFBaselinedStatistics baselinedStats;

	/** @return NVMe over Fabrics counter-oriented statistics that are relative to a pre-set baseline. */
	public NVMeoFBaselinedStatistics getBaselinedStats() {
		return this.baselinedStats;
	}
	/** @param x NVMe over Fabrics counter-oriented statistics that are relative to a pre-set baseline. */
	public void setBaselinedStats(NVMeoFBaselinedStatistics x) {
		this.baselinedStats = x;
	}
}
