package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe the contents of a particular region of controller NVSRAM. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(442)
public class NVSRAMRegion implements Serializable {
	public NVSRAMRegion() {
	}

	/** The identifier of the region whose data is contained in this object. */
	@io.swagger.annotations.ApiModelProperty(value ="The identifier of the region whose data is contained in this object." , required = true)
	@XmlElement(required = true)
	private NVSRAMRegionId regionId = NVSRAMRegionId.__UNDEFINED;

	/** @return The identifier of the region whose data is contained in this object. */
	public NVSRAMRegionId getRegionId() {
		return this.regionId;
	}
	/** @param x The identifier of the region whose data is contained in this object. */
	public void setRegionId(NVSRAMRegionId x) {
		this.regionId = x;
	}

	/** A variable-length byte array that contains the complete content of the region. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length byte array that contains the complete content of the region." , required = true)
	@XmlElement(required = true)
	private String regionData;

	/** @return A variable-length byte array that contains the complete content of the region. */
	public String getRegionData() {
		return this.regionData;
	}
	/** @param x A variable-length byte array that contains the complete content of the region. */
	public void setRegionData(String x) {
		this.regionData = x;
	}
}
