package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to differentiate between various defined regions of a controller's NVSRAM. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(210)
public enum NVSRAMRegionId implements Serializable {
		/** Indicates that all regions are to be selected. This value is only used as part of a request to read NVSRAM via the getControllerNVSRAM procedure. */
		allRegions(-1),
		/** This value is used to specify the region of controller NVSRAM that is not user-configurable. */
		nonUserConfigData(226),
		/** This value is used to specify the region of controller NVSRAM that holds subsystem identification information. */
		subsystemId(232),
		/** This value is used to specify the region of controller NVSRAM that holds subsystem fault information. */
		subsystemFaultData(233),
		/** This value is used to specify the region of controller NVSRAM that holds drive fault information. */
		driveFaultData(234),
		/** This value is used to specify the region of controller NVSRAM that holds host-managed information. */
		hostManagedData(236),
		/** This value is used to specify the region of controller NVSRAM that holds host I/O interface information. */
		hostInterfaceData(237),
		/** This value is used to specify the region of controller NVSRAM that holds user-configurable information. */
		userConfigData(238),
		/** This value is used to specify the region of controller NVSRAM that holds BOOTP information. */
		bootpData(240),
		/** This value is used to specify the region of controller NVSRAM that holds the extended user-configurable information. */
		extUserConfigData(241),
		/** This value is used to specify the region of controller NVSRAM that holds the host type dependent region. */
		hostTypeDependentData(242),
		/** This value is used to specify the second region of controller NVSRAM that holds user-configurable data. */
		userConfig2Data(244),
		__UNDEFINED(464378545);

		public final int value;

		private NVSRAMRegionId(int v) {
			this.value = v;
		}
}
