package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when modifying a controller's NVSRAM at the individual byte or byte-range level. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(320)
public class NVSRAMUpdateDescriptor implements Serializable {
	public NVSRAMUpdateDescriptor() {
	}

	/** The region identifier for the NVSRAM region to be modified. */
	@io.swagger.annotations.ApiModelProperty(value ="The region identifier for the NVSRAM region to be modified." , required = true)
	@XmlElement(required = true)
	private NVSRAMRegionId regionId = NVSRAMRegionId.__UNDEFINED;

	/** @return The region identifier for the NVSRAM region to be modified. */
	public NVSRAMRegionId getRegionId() {
		return this.regionId;
	}
	/** @param x The region identifier for the NVSRAM region to be modified. */
	public void setRegionId(NVSRAMRegionId x) {
		this.regionId = x;
	}

	/** The offset from the beginning of the region where the update is to begin. */
	@io.swagger.annotations.ApiModelProperty(value ="The offset from the beginning of the region where the update is to begin." , required = true)
	@XmlElement(required = true)
	private int offset;

	/** @return The offset from the beginning of the region where the update is to begin. */
	public int getOffset() {
		return this.offset;
	}
	/** @param x The offset from the beginning of the region where the update is to begin. */
	public void setOffset(int x) {
		this.offset = x;
	}

	/** A variable-length array of bytes that provides the new data to be written to the controller's NVSRAM starting at the location specified by the offset field. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length array of bytes that provides the new data to be written to the controller's NVSRAM starting at the location specified by the offset field." , required = true)
	@XmlElement(required = true)
	private String regionData;

	/** @return A variable-length array of bytes that provides the new data to be written to the controller's NVSRAM starting at the location specified by the offset field. */
	public String getRegionData() {
		return this.regionData;
	}
	/** @param x A variable-length array of bytes that provides the new data to be written to the controller's NVSRAM starting at the location specified by the offset field. */
	public void setRegionData(String x) {
		this.regionData = x;
	}
}
