package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about a network interface's type-specific data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1122)
public class NetInterfaceTypeData implements Serializable {
	public NetInterfaceTypeData() {
	}

	/** This enumeration defines the different network interface types that may be reported as part of the interface information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different network interface types that may be reported as part of the interface information associated with a controller." , required = true)
	@XmlElement(required = true)
	private NetInterfaceType interfaceType = NetInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different network interface types that may be reported as part of the interface information associated with a controller. */
	public NetInterfaceType getInterfaceType() {
		return this.interfaceType;
	}
	/** @param x This enumeration defines the different network interface types that may be reported as part of the interface information associated with a controller. */
	public void setInterfaceType(NetInterfaceType x) {
		this.interfaceType = x;
	}

	/** This field is present only if the interfaceType value is equal to NET_IF_ETHERNET. It contains the detailed interface information for an Ethernet network interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the interfaceType value is equal to NET_IF_ETHERNET. It contains the detailed interface information for an Ethernet network interface." , required = false)
	@XmlElement(required = false)
	private EthernetInterface ethernet;

	/** @return This field is present only if the interfaceType value is equal to NET_IF_ETHERNET. It contains the detailed interface information for an Ethernet network interface. */
	public EthernetInterface getEthernet() {
		return this.ethernet;
	}
	/** @param x This field is present only if the interfaceType value is equal to NET_IF_ETHERNET. It contains the detailed interface information for an Ethernet network interface. */
	public void setEthernet(EthernetInterface x) {
		this.ethernet = x;
	}
}
