package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Contains either a domain name, IPv4, or IPv6 address. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(786)
public class NetworkAddress implements Serializable {
	public NetworkAddress() {
	}

	/** This enum defines the possible network address types. */
	@io.swagger.annotations.ApiModelProperty(value ="This enum defines the possible network address types." , required = true)
	@XmlElement(required = true)
	private NetworkAddressType addrType = NetworkAddressType.__UNDEFINED;

	/** @return This enum defines the possible network address types. */
	public NetworkAddressType getAddrType() {
		return this.addrType;
	}
	/** @param x This enum defines the possible network address types. */
	public void setAddrType(NetworkAddressType x) {
		this.addrType = x;
	}

	/** Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490. */
	@io.swagger.annotations.ApiModelProperty(value ="Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490." , required = false)
	@XmlElement(required = false)
	private String domainName;

	/** @return Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490. */
	public String getDomainName() {
		return this.domainName;
	}
	/** @param x Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490. */
	public void setDomainName(String x) {
		this.domainName = x;
	}

	/** IPv4 or IPv6 address */
	@io.swagger.annotations.ApiModelProperty(value ="IPv4 or IPv6 address" , required = false)
	@XmlElement(required = false)
	private IpVxAddress ipvxAddress;

	/** @return IPv4 or IPv6 address */
	public IpVxAddress getIpvxAddress() {
		return this.ipvxAddress;
	}
	/** @param x IPv4 or IPv6 address */
	public void setIpvxAddress(IpVxAddress x) {
		this.ipvxAddress = x;
	}
}
