package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the lock key ID, the wrapped lock key, and the sequence number. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(492)
public class NewLockKey implements Serializable {
	public NewLockKey() {
	}

	/** The lock key ID to set for this lock key. */
	@io.swagger.annotations.ApiModelProperty(value ="The lock key ID to set for this lock key." , required = true)
	@XmlElement(required = true)
	private String lockKeyID;

	/** @return The lock key ID to set for this lock key. */
	public String getLockKeyID() {
		return this.lockKeyID;
	}
	/** @param x The lock key ID to set for this lock key. */
	public void setLockKeyID(String x) {
		this.lockKeyID = x;
	}

	/** The wrapped lock key. */
	@io.swagger.annotations.ApiModelProperty(value ="The wrapped lock key." , required = true)
	@XmlElement(required = true)
	private String wrappedLockKey;

	/** @return The wrapped lock key. */
	public String getWrappedLockKey() {
		return this.wrappedLockKey;
	}
	/** @param x The wrapped lock key. */
	public void setWrappedLockKey(String x) {
		this.wrappedLockKey = x;
	}

	/** The sequence number for this key. */
	@io.swagger.annotations.ApiModelProperty(value ="The sequence number for this key." , required = true)
	@XmlElement(required = true)
	private int newKeySequence;

	/** @return The sequence number for this key. */
	public int getNewKeySequence() {
		return this.newKeySequence;
	}
	/** @param x The sequence number for this key. */
	public void setNewKeySequence(int x) {
		this.newKeySequence = x;
	}
}
