package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe volumes not-on-preferred-path conditions. This reflects all volumes whose preferred manager is the given controller but the current manager is not. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(562)
public class NotOnPreferredPath implements Serializable {
	public NotOnPreferredPath() {
	}

	/** The preferred owner. */
	@io.swagger.annotations.ApiModelProperty(value ="The preferred owner." , required = true)
	@XmlElement(required = true)
	private String preferredOwner;

	/** @return The preferred owner. */
	public String getPreferredOwner() {
		return this.preferredOwner;
	}
	/** @param x The preferred owner. */
	public void setPreferredOwner(String x) {
		this.preferredOwner = x;
	}

	/** A list of volumes not on the preferred path. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of volumes not on the preferred path." , required = true)
	@XmlElement(required = true)
	private String[] volumes;

	/** @return A list of volumes not on the preferred path. */
	public String[] getVolumes() {
		return this.volumes;
	}
	/** @param x A list of volumes not on the preferred path. */
	public void setVolumes(String[] x) {
		this.volumes = x;
	}
}
