package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains a SCSI opcode value and an associated count of the number of times the opcode has been observed. It is used in reporting opcode counts as part of an IoCounterGroup. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(498)
public class OpcodeCounter implements Serializable {
	public OpcodeCounter() {
	}

	/** A SCSI opcode value. */
	@io.swagger.annotations.ApiModelProperty(value ="A SCSI opcode value." , required = true)
	@XmlElement(required = true)
	private int opcode;

	/** @return A SCSI opcode value. */
	public int getOpcode() {
		return this.opcode;
	}
	/** @param x A SCSI opcode value. */
	public void setOpcode(int x) {
		this.opcode = x;
	}

	/** The number of times the opcode has been observed. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times the opcode has been observed." , required = true)
	@XmlElement(required = true)
	private long count;

	/** @return The number of times the opcode has been observed. */
	public long getCount() {
		return this.count;
	}
	/** @param x The number of times the opcode has been observed. */
	public void setCount(long x) {
		this.count = x;
	}
}
