package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a PiT Consistency Group. NOTE: A PITConsistencyGroup may have a schedule associated with it. In that case, the targetObject field in the ScheduleInstance object will contain the PITConsistencyGroupRef. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(764)
public class PITConsistencyGroup implements Serializable,devmgr.api.model.Identifiable,devmgr.api.model.Named {
	public PITConsistencyGroup() {
	}

	/** The reference (key) for this PITConsistencyGroup. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference (key) for this PITConsistencyGroup." , required = true)
	@XmlElement(required = true)
	private String cgRef;

	/** @return The reference (key) for this PITConsistencyGroup. */
	public String getCgRef() {
		return this.cgRef;
	}
	/** @param x The reference (key) for this PITConsistencyGroup. */
	public void setCgRef(String x) {
		this.cgRef = x;
	}

	/** The name of the Consistency Group. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the Consistency Group." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The name of the Consistency Group. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The name of the Consistency Group. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The behavior on repository full condition. */
	@io.swagger.annotations.ApiModelProperty(value ="The behavior on repository full condition." , required = true)
	@XmlElement(required = true)
	private PITRepositoryFullPolicy repFullPolicy = PITRepositoryFullPolicy.__UNDEFINED;

	/** @return The behavior on repository full condition. */
	public PITRepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x The behavior on repository full condition. */
	public void setRepFullPolicy(PITRepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}

	/** The auto-delete indicator. If non-zero, the oldest PiT will be automatically deleted when creating a new one to keep the total number of PiTs limited to the number specified. */
	@io.swagger.annotations.ApiModelProperty(value ="The auto-delete indicator. If non-zero, the oldest PiT will be automatically deleted when creating a new one to keep the total number of PiTs limited to the number specified." , required = true)
	@XmlElement(required = true)
	private int autoDeleteLimit;

	/** @return The auto-delete indicator. If non-zero, the oldest PiT will be automatically deleted when creating a new one to keep the total number of PiTs limited to the number specified. */
	public int getAutoDeleteLimit() {
		return this.autoDeleteLimit;
	}
	/** @param x The auto-delete indicator. If non-zero, the oldest PiT will be automatically deleted when creating a new one to keep the total number of PiTs limited to the number specified. */
	public void setAutoDeleteLimit(int x) {
		this.autoDeleteLimit = x;
	}

	/** The importance of the rollback operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The importance of the rollback operation." , required = true)
	@XmlElement(required = true)
	private RollbackPriority rollbackPriority = RollbackPriority.__UNDEFINED;

	/** @return The importance of the rollback operation. */
	public RollbackPriority getRollbackPriority() {
		return this.rollbackPriority;
	}
	/** @param x The importance of the rollback operation. */
	public void setRollbackPriority(RollbackPriority x) {
		this.rollbackPriority = x;
	}

	/** A list of all unique sequence numbers for all existing PiTs of members in this consistency group. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of all unique sequence numbers for all existing PiTs of members in this consistency group." , required = true)
	@XmlElement(required = true)
	private long[] uniqueSequenceNumber;

	/** @return A list of all unique sequence numbers for all existing PiTs of members in this consistency group. */
	public long[] getUniqueSequenceNumber() {
		return this.uniqueSequenceNumber;
	}
	/** @param x A list of all unique sequence numbers for all existing PiTs of members in this consistency group. */
	public void setUniqueSequenceNumber(long[] x) {
		this.uniqueSequenceNumber = x;
	}

	/** The status of Pending PiT Creation. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of Pending PiT Creation." , required = true)
	@XmlElement(required = true)
	private PITCreationPendingStatus creationPendingStatus = PITCreationPendingStatus.__UNDEFINED;

	/** @return The status of Pending PiT Creation. */
	public PITCreationPendingStatus getCreationPendingStatus() {
		return this.creationPendingStatus;
	}
	/** @param x The status of Pending PiT Creation. */
	public void setCreationPendingStatus(PITCreationPendingStatus x) {
		this.creationPendingStatus = x;
	}
	@Override
	public String getId(){
		return cgRef;
	}
	@Override
	public String getName(){
		return label;
	}
}
