package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure used to specify attributes for creation of a PITConsistencyGroup. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1167)
public class PITConsistencyGroupCreationDescriptor implements Serializable {
	public PITConsistencyGroupCreationDescriptor() {
	}

	/** The name of the Consistency Group. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the Consistency Group." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The name of the Consistency Group. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The name of the Consistency Group. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** Behavior on repository full condition. */
	@io.swagger.annotations.ApiModelProperty(value ="Behavior on repository full condition." , required = true)
	@XmlElement(required = true)
	private PITRepositoryFullPolicy repFullPolicy = PITRepositoryFullPolicy.__UNDEFINED;

	/** @return Behavior on repository full condition. */
	public PITRepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x Behavior on repository full condition. */
	public void setRepFullPolicy(PITRepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}

	/** The auto-delete setting for Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	@io.swagger.annotations.ApiModelProperty(value ="The auto-delete setting for Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified." , required = true)
	@XmlElement(required = true)
	private int autoDeleteLimit;

	/** @return The auto-delete setting for Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	public int getAutoDeleteLimit() {
		return this.autoDeleteLimit;
	}
	/** @param x The auto-delete setting for Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	public void setAutoDeleteLimit(int x) {
		this.autoDeleteLimit = x;
	}

	/** Importance of rollback operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Importance of rollback operation." , required = true)
	@XmlElement(required = true)
	private RollbackPriority rollbackPriority = RollbackPriority.__UNDEFINED;

	/** @return Importance of rollback operation. */
	public RollbackPriority getRollbackPriority() {
		return this.rollbackPriority;
	}
	/** @param x Importance of rollback operation. */
	public void setRollbackPriority(RollbackPriority x) {
		this.rollbackPriority = x;
	}

	/** An optional schedule to be created with the new consistency group. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	@io.swagger.annotations.ApiModelProperty(value ="An optional schedule to be created with the new consistency group. The target object is empty in this structure (unknown because not yet created, assigned by this creation method)." , required = true)
	@XmlElement(required = true)
	private OptionalScheduleCreationDescriptor cgSchedule;

	/** @return An optional schedule to be created with the new consistency group. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	public OptionalScheduleCreationDescriptor getCgSchedule() {
		return this.cgSchedule;
	}
	/** @param x An optional schedule to be created with the new consistency group. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	public void setCgSchedule(OptionalScheduleCreationDescriptor x) {
		this.cgSchedule = x;
	}
}
