package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to delete a PiT consistency group. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(493)
public class PITConsistencyGroupDeletionDescriptor implements Serializable {
	public PITConsistencyGroupDeletionDescriptor() {
	}

	/** The consistency group to delete. */
	@io.swagger.annotations.ApiModelProperty(value ="The consistency group to delete." , required = true)
	@XmlElement(required = true)
	private String cgRef;

	/** @return The consistency group to delete. */
	public String getCgRef() {
		return this.cgRef;
	}
	/** @param x The consistency group to delete. */
	public void setCgRef(String x) {
		this.cgRef = x;
	}

	/** A flag used to indicate whether the member volumes of the associated repository should be retained or deleted (provided the PiT Groups are being deleted). */
	@io.swagger.annotations.ApiModelProperty(value ="A flag used to indicate whether the member volumes of the associated repository should be retained or deleted (provided the PiT Groups are being deleted)." , required = true)
	@XmlElement(required = true)
	private boolean retainRepositoryMembers;

	/** @return A flag used to indicate whether the member volumes of the associated repository should be retained or deleted (provided the PiT Groups are being deleted). */
	public boolean isRetainRepositoryMembers() {
		return this.retainRepositoryMembers;
	}
	/** @param x A flag used to indicate whether the member volumes of the associated repository should be retained or deleted (provided the PiT Groups are being deleted). */
	public void setRetainRepositoryMembers(boolean x) {
		this.retainRepositoryMembers = x;
	}
}
