package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure used to update various consistency group parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(577)
public class PITConsistencyGroupParamsUpdateDescriptor implements Serializable {
	public PITConsistencyGroupParamsUpdateDescriptor() {
	}

	/** The consistency group to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The consistency group to be updated." , required = true)
	@XmlElement(required = true)
	private String cgRef;

	/** @return The consistency group to be updated. */
	public String getCgRef() {
		return this.cgRef;
	}
	/** @param x The consistency group to be updated. */
	public void setCgRef(String x) {
		this.cgRef = x;
	}

	/** The name of the consistency group. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the consistency group." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The name of the consistency group. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The name of the consistency group. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** Behavior on repository full condition. */
	@io.swagger.annotations.ApiModelProperty(value ="Behavior on repository full condition." , required = true)
	@XmlElement(required = true)
	private PITRepositoryFullPolicy repFullPolicy = PITRepositoryFullPolicy.__UNDEFINED;

	/** @return Behavior on repository full condition. */
	public PITRepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x Behavior on repository full condition. */
	public void setRepFullPolicy(PITRepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}

	/** The auto-delete setting for the Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	@io.swagger.annotations.ApiModelProperty(value ="The auto-delete setting for the Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified." , required = true)
	@XmlElement(required = true)
	private int autoDeleteLimit;

	/** @return The auto-delete setting for the Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	public int getAutoDeleteLimit() {
		return this.autoDeleteLimit;
	}
	/** @param x The auto-delete setting for the Consistency Group. A non-zero value indicates auto delete is enabled and limit should be set to value specified. */
	public void setAutoDeleteLimit(int x) {
		this.autoDeleteLimit = x;
	}

	/** Importance of rollback operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Importance of rollback operation." , required = true)
	@XmlElement(required = true)
	private RollbackPriority rollbackPriority = RollbackPriority.__UNDEFINED;

	/** @return Importance of rollback operation. */
	public RollbackPriority getRollbackPriority() {
		return this.rollbackPriority;
	}
	/** @param x Importance of rollback operation. */
	public void setRollbackPriority(RollbackPriority x) {
		this.rollbackPriority = x;
	}
}
