package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to remove a member from an existing PiT consistency group. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(979)
public class PITConsistencyGroupRemoveMemberDescriptor implements Serializable {
	public PITConsistencyGroupRemoveMemberDescriptor() {
	}

	/** The consistency group from which the member is to be removed. */
	@io.swagger.annotations.ApiModelProperty(value ="The consistency group from which the member is to be removed." , required = true)
	@XmlElement(required = true)
	private String cgRef;

	/** @return The consistency group from which the member is to be removed. */
	public String getCgRef() {
		return this.cgRef;
	}
	/** @param x The consistency group from which the member is to be removed. */
	public void setCgRef(String x) {
		this.cgRef = x;
	}

	/** The member to remove (must be a member of the consistency group specified above). */
	@io.swagger.annotations.ApiModelProperty(value ="The member to remove (must be a member of the consistency group specified above)." , required = true)
	@XmlElement(required = true)
	private String memberRef;

	/** @return The member to remove (must be a member of the consistency group specified above). */
	public String getMemberRef() {
		return this.memberRef;
	}
	/** @param x The member to remove (must be a member of the consistency group specified above). */
	public void setMemberRef(String x) {
		this.memberRef = x;
	}

	/** An indication of whether the repository member volumes should be deleted or retained if the PiT Group is being deleted. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of whether the repository member volumes should be deleted or retained if the PiT Group is being deleted." , required = true)
	@XmlElement(required = true)
	private boolean retainRepositoryMembers;

	/** @return An indication of whether the repository member volumes should be deleted or retained if the PiT Group is being deleted. */
	public boolean isRetainRepositoryMembers() {
		return this.retainRepositoryMembers;
	}
	/** @param x An indication of whether the repository member volumes should be deleted or retained if the PiT Group is being deleted. */
	public void setRetainRepositoryMembers(boolean x) {
		this.retainRepositoryMembers = x;
	}
}
