package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a PiT Consistency Group View. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(730)
public class PITConsistencyGroupView implements Serializable,devmgr.api.model.Identifiable,devmgr.api.model.Named {
	public PITConsistencyGroupView() {
	}

	/** The reference (key) for this PITConsistencyGroupView. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference (key) for this PITConsistencyGroupView." , required = true)
	@XmlElement(required = true)
	private String cgViewRef;

	/** @return The reference (key) for this PITConsistencyGroupView. */
	public String getCgViewRef() {
		return this.cgViewRef;
	}
	/** @param x The reference (key) for this PITConsistencyGroupView. */
	public void setCgViewRef(String x) {
		this.cgViewRef = x;
	}

	/** The PiT Consistency Group to which the Consistency Group View belongs. */
	@io.swagger.annotations.ApiModelProperty(value ="The PiT Consistency Group to which the Consistency Group View belongs." , required = true)
	@XmlElement(required = true)
	private String groupRef;

	/** @return The PiT Consistency Group to which the Consistency Group View belongs. */
	public String getGroupRef() {
		return this.groupRef;
	}
	/** @param x The PiT Consistency Group to which the Consistency Group View belongs. */
	public void setGroupRef(String x) {
		this.groupRef = x;
	}

	/** The name of the Consistency Group View. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the Consistency Group View." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The name of the Consistency Group View. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The name of the Consistency Group View. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The controller-time (measured in seconds since January 1, 1970) when the Consistency Group View was created or re-attached to another PiT. All member Views that are part of this Consistency Group View have this value in their corresponding fields. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller-time (measured in seconds since January 1, 1970) when the Consistency Group View was created or re-attached to another PiT. All member Views that are part of this Consistency Group View have this value in their corresponding fields." , required = true)
	@XmlElement(required = true)
	private long viewTime;

	/** @return The controller-time (measured in seconds since January 1, 1970) when the Consistency Group View was created or re-attached to another PiT. All member Views that are part of this Consistency Group View have this value in their corresponding fields. */
	public long getViewTime() {
		return this.viewTime;
	}
	/** @param x The controller-time (measured in seconds since January 1, 1970) when the Consistency Group View was created or re-attached to another PiT. All member Views that are part of this Consistency Group View have this value in their corresponding fields. */
	public void setViewTime(long x) {
		this.viewTime = x;
	}

	/** The view sequence number. This is a monotonically increasing sequence value that is common across all member Views that are part of this Consistency Group View. */
	@io.swagger.annotations.ApiModelProperty(value ="The view sequence number. This is a monotonically increasing sequence value that is common across all member Views that are part of this Consistency Group View." , required = true)
	@XmlElement(required = true)
	private long viewSequenceNumber;

	/** @return The view sequence number. This is a monotonically increasing sequence value that is common across all member Views that are part of this Consistency Group View. */
	public long getViewSequenceNumber() {
		return this.viewSequenceNumber;
	}
	/** @param x The view sequence number. This is a monotonically increasing sequence value that is common across all member Views that are part of this Consistency Group View. */
	public void setViewSequenceNumber(long x) {
		this.viewSequenceNumber = x;
	}
	@Override
	public String getId(){
		return cgViewRef;
	}
	@Override
	public String getName(){
		return label;
	}
}
