package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to specify the method by which the PiT was created. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(20)
public enum PITCreationMethod implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** The PiT was created by user action. */
		user(1),
		/** The PiT was created by scheduled PiT creation, either on an individual PiT group or on a PITConsistencyGroup. */
		schedule(2),
		__UNDEFINED(464378545);

		public final int value;

		private PITCreationMethod(int v) {
			this.value = v;
		}
}
