package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information about how a new PiT Group is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1195)
public class PITGroupCreationDescriptor implements Serializable {
	public PITGroupCreationDescriptor() {
	}

	/** The base volume for this PiT Group. */
	@io.swagger.annotations.ApiModelProperty(value ="The base volume for this PiT Group." , required = true)
	@XmlElement(required = true)
	private String baseVolume;

	/** @return The base volume for this PiT Group. */
	public String getBaseVolume() {
		return this.baseVolume;
	}
	/** @param x The base volume for this PiT Group. */
	public void setBaseVolume(String x) {
		this.baseVolume = x;
	}

	/** The user-assigned PiT Group label. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned PiT Group label." , required = true)
	@XmlElement(required = true)
	private String pitGroupLabel;

	/** @return The user-assigned PiT Group label. */
	public String getPitGroupLabel() {
		return this.pitGroupLabel;
	}
	/** @param x The user-assigned PiT Group label. */
	public void setPitGroupLabel(String x) {
		this.pitGroupLabel = x;
	}

	/** The volume candidate for the repository. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume candidate for the repository." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeCreationDescriptor repositoryCandidate;

	/** @return The volume candidate for the repository. */
	public ConcatVolumeCreationDescriptor getRepositoryCandidate() {
		return this.repositoryCandidate;
	}
	/** @param x The volume candidate for the repository. */
	public void setRepositoryCandidate(ConcatVolumeCreationDescriptor x) {
		this.repositoryCandidate = x;
	}

	/** Behavior on repository full condition. */
	@io.swagger.annotations.ApiModelProperty(value ="Behavior on repository full condition." , required = true)
	@XmlElement(required = true)
	private PITRepositoryFullPolicy repFullPolicy = PITRepositoryFullPolicy.__UNDEFINED;

	/** @return Behavior on repository full condition. */
	public PITRepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x Behavior on repository full condition. */
	public void setRepFullPolicy(PITRepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}

	/** The auto-delete setting for PiT Group. A non-zero value indicates auto delete is enabled and the limit should be set to the value specified. */
	@io.swagger.annotations.ApiModelProperty(value ="The auto-delete setting for PiT Group. A non-zero value indicates auto delete is enabled and the limit should be set to the value specified." , required = true)
	@XmlElement(required = true)
	private int autoDeleteLimit;

	/** @return The auto-delete setting for PiT Group. A non-zero value indicates auto delete is enabled and the limit should be set to the value specified. */
	public int getAutoDeleteLimit() {
		return this.autoDeleteLimit;
	}
	/** @param x The auto-delete setting for PiT Group. A non-zero value indicates auto delete is enabled and the limit should be set to the value specified. */
	public void setAutoDeleteLimit(int x) {
		this.autoDeleteLimit = x;
	}

	/** Importance of rollback operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Importance of rollback operation." , required = true)
	@XmlElement(required = true)
	private RollbackPriority rollbackPriority = RollbackPriority.__UNDEFINED;

	/** @return Importance of rollback operation. */
	public RollbackPriority getRollbackPriority() {
		return this.rollbackPriority;
	}
	/** @param x Importance of rollback operation. */
	public void setRollbackPriority(RollbackPriority x) {
		this.rollbackPriority = x;
	}

	/** An optional PiT schedule to be created with the new PITGroup. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	@io.swagger.annotations.ApiModelProperty(value ="An optional PiT schedule to be created with the new PITGroup. The target object is empty in this structure (unknown because not yet created, assigned by this creation method)." , required = true)
	@XmlElement(required = true)
	private OptionalScheduleCreationDescriptor pitSchedule;

	/** @return An optional PiT schedule to be created with the new PITGroup. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	public OptionalScheduleCreationDescriptor getPitSchedule() {
		return this.pitSchedule;
	}
	/** @param x An optional PiT schedule to be created with the new PITGroup. The target object is empty in this structure (unknown because not yet created, assigned by this creation method). */
	public void setPitSchedule(OptionalScheduleCreationDescriptor x) {
		this.pitSchedule = x;
	}
}
