package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report on utilization of capacity in a PiT group repository. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(924)
public class PITGroupRepositoryUtilization implements Serializable {
	public PITGroupRepositoryUtilization() {
	}

	/** The total number of bytes used in the repository for all PiTs in the group. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes used in the repository for all PiTs in the group." , required = true)
	@XmlElement(required = true)
	private long pitGroupBytesUsed;

	/** @return The total number of bytes used in the repository for all PiTs in the group. */
	public long getPitGroupBytesUsed() {
		return this.pitGroupBytesUsed;
	}
	/** @param x The total number of bytes used in the repository for all PiTs in the group. */
	public void setPitGroupBytesUsed(long x) {
		this.pitGroupBytesUsed = x;
	}

	/** The total number of bytes available for ongoing copy-on-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes available for ongoing copy-on-write operations." , required = true)
	@XmlElement(required = true)
	private long pitGroupBytesAvailable;

	/** @return The total number of bytes available for ongoing copy-on-write operations. */
	public long getPitGroupBytesAvailable() {
		return this.pitGroupBytesAvailable;
	}
	/** @param x The total number of bytes available for ongoing copy-on-write operations. */
	public void setPitGroupBytesAvailable(long x) {
		this.pitGroupBytesAvailable = x;
	}

	/** The PiT Group for which this utilization information applies. */
	@io.swagger.annotations.ApiModelProperty(value ="The PiT Group for which this utilization information applies." , required = true)
	@XmlElement(required = true)
	private String groupRef;

	/** @return The PiT Group for which this utilization information applies. */
	public String getGroupRef() {
		return this.groupRef;
	}
	/** @param x The PiT Group for which this utilization information applies. */
	public void setGroupRef(String x) {
		this.groupRef = x;
	}

	/** The repository utilization of each specific PiT in the PiT group. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization of each specific PiT in the PiT group." , required = true)
	@XmlElement(required = true)
	private PITRepositoryUtilization[] pitUtilization;

	/** @return The repository utilization of each specific PiT in the PiT group. */
	public PITRepositoryUtilization[] getPitUtilization() {
		return this.pitUtilization;
	}
	/** @param x The repository utilization of each specific PiT in the PiT group. */
	public void setPitUtilization(PITRepositoryUtilization[] x) {
		this.pitUtilization = x;
	}
}
