package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains information about a PiT Group's repository utilization. It is returned by the getPITGroupRepositoryUtilization procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1174)
public class PITGroupRepositoryUtilizationListReturned implements Serializable {
	public PITGroupRepositoryUtilizationListReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** A list of PITGroupRepositoryUtilization structures. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of PITGroupRepositoryUtilization structures. This field is present only if the value of returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private PITGroupRepositoryUtilizationList utilization;

	/** @return A list of PITGroupRepositoryUtilization structures. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public PITGroupRepositoryUtilizationList getUtilization() {
		return this.utilization;
	}
	/** @param x A list of PITGroupRepositoryUtilization structures. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public void setUtilization(PITGroupRepositoryUtilizationList x) {
		this.utilization = x;
	}
}
