package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to determine the status of a PiT Group. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(181)
public enum PITGroupStatus implements Serializable {
		/** The PiT Group status is unknown. This should never happen. */
		unknown(0),
		/** The PiT Group is working correctly. */
		optimal(1),
		/** The PiT Group repository is full and the "fail base writes policy" is set */
		full(2),
		/** The PiT Group has failed. */
		failed(3),
		/** The repository is over the warning threshold. */
		overThreshold(4),
		__UNDEFINED(464378545);

		public final int value;

		private PITGroupStatus(int v) {
			this.value = v;
		}
}
