package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains static default values for PiT Groups. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(482)
public class PITGroupsDefaultAttributes implements Serializable {
	public PITGroupsDefaultAttributes() {
	}

	/** The maximum number of views per PiT. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum number of views per PiT." , required = true)
	@XmlElement(required = true)
	private int maxViewsPerPIT;

	/** @return The maximum number of views per PiT. */
	public int getMaxViewsPerPIT() {
		return this.maxViewsPerPIT;
	}
	/** @param x The maximum number of views per PiT. */
	public void setMaxViewsPerPIT(int x) {
		this.maxViewsPerPIT = x;
	}

	/** The minimum repository size (in bytes) for PiT Group or PiT View repository. Note that this is the absolute floor on the repository capacity, but a slightly higher minimum may be imposed based on the capacity of the base volume. This is necessary to ensure rollback operations have sufficient repository capacity for metadata. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum repository size (in bytes) for PiT Group or PiT View repository. Note that this is the absolute floor on the repository capacity, but a slightly higher minimum may be imposed based on the capacity of the base volume. This is necessary to ensure rollback operations have sufficient repository capacity for metadata." , required = true)
	@XmlElement(required = true)
	private long minimumRepositoryCapacityInBytes;

	/** @return The minimum repository size (in bytes) for PiT Group or PiT View repository. Note that this is the absolute floor on the repository capacity, but a slightly higher minimum may be imposed based on the capacity of the base volume. This is necessary to ensure rollback operations have sufficient repository capacity for metadata. */
	public long getMinimumRepositoryCapacityInBytes() {
		return this.minimumRepositoryCapacityInBytes;
	}
	/** @param x The minimum repository size (in bytes) for PiT Group or PiT View repository. Note that this is the absolute floor on the repository capacity, but a slightly higher minimum may be imposed based on the capacity of the base volume. This is necessary to ensure rollback operations have sufficient repository capacity for metadata. */
	public void setMinimumRepositoryCapacityInBytes(long x) {
		this.minimumRepositoryCapacityInBytes = x;
	}

	/** Maximum repository size for a PiT group as a percentage of the base volume capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum repository size for a PiT group as a percentage of the base volume capacity." , required = true)
	@XmlElement(required = true)
	private int maxPITGroupRepositoryCapacityAsPercentOfBaseCapacity;

	/** @return Maximum repository size for a PiT group as a percentage of the base volume capacity. */
	public int getMaxPITGroupRepositoryCapacityAsPercentOfBaseCapacity() {
		return this.maxPITGroupRepositoryCapacityAsPercentOfBaseCapacity;
	}
	/** @param x Maximum repository size for a PiT group as a percentage of the base volume capacity. */
	public void setMaxPITGroupRepositoryCapacityAsPercentOfBaseCapacity(int x) {
		this.maxPITGroupRepositoryCapacityAsPercentOfBaseCapacity = x;
	}

	/** Maximum repository size for a PiT View as a percentage of the base volume capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum repository size for a PiT View as a percentage of the base volume capacity." , required = true)
	@XmlElement(required = true)
	private int maxPITViewRepositoryCapacityAsPercentOfBaseCapacity;

	/** @return Maximum repository size for a PiT View as a percentage of the base volume capacity. */
	public int getMaxPITViewRepositoryCapacityAsPercentOfBaseCapacity() {
		return this.maxPITViewRepositoryCapacityAsPercentOfBaseCapacity;
	}
	/** @param x Maximum repository size for a PiT View as a percentage of the base volume capacity. */
	public void setMaxPITViewRepositoryCapacityAsPercentOfBaseCapacity(int x) {
		this.maxPITViewRepositoryCapacityAsPercentOfBaseCapacity = x;
	}

	/** Default repository capacity for PiT View or PiT Group as a percentage of the base volume capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="Default repository capacity for PiT View or PiT Group as a percentage of the base volume capacity." , required = true)
	@XmlElement(required = true)
	private int defaultRepositoryCapacityAsPercentOfBaseCapacity;

	/** @return Default repository capacity for PiT View or PiT Group as a percentage of the base volume capacity. */
	public int getDefaultRepositoryCapacityAsPercentOfBaseCapacity() {
		return this.defaultRepositoryCapacityAsPercentOfBaseCapacity;
	}
	/** @param x Default repository capacity for PiT View or PiT Group as a percentage of the base volume capacity. */
	public void setDefaultRepositoryCapacityAsPercentOfBaseCapacity(int x) {
		this.defaultRepositoryCapacityAsPercentOfBaseCapacity = x;
	}

	/** Default repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="Default repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int defaultRepositoryUtilizationWarningThreshold;

	/** @return Default repository utilization warning threshold percentage. */
	public int getDefaultRepositoryUtilizationWarningThreshold() {
		return this.defaultRepositoryUtilizationWarningThreshold;
	}
	/** @param x Default repository utilization warning threshold percentage. */
	public void setDefaultRepositoryUtilizationWarningThreshold(int x) {
		this.defaultRepositoryUtilizationWarningThreshold = x;
	}

	/** Minimum capacity (in bytes) of a volume to be added to a ConcatVolume for expansion. */
	@io.swagger.annotations.ApiModelProperty(value ="Minimum capacity (in bytes) of a volume to be added to a ConcatVolume for expansion." , required = true)
	@XmlElement(required = true)
	private long minimumConcatVolumeCapacityExpansion;

	/** @return Minimum capacity (in bytes) of a volume to be added to a ConcatVolume for expansion. */
	public long getMinimumConcatVolumeCapacityExpansion() {
		return this.minimumConcatVolumeCapacityExpansion;
	}
	/** @param x Minimum capacity (in bytes) of a volume to be added to a ConcatVolume for expansion. */
	public void setMinimumConcatVolumeCapacityExpansion(long x) {
		this.minimumConcatVolumeCapacityExpansion = x;
	}
}
