package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to specify the policy to apply when a PiT repository is full and cluster allocation fails. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(19)
public enum PITRepositoryFullPolicy implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** Fail writes to the base on cluster allocation fail. */
		failbasewrites(1),
		/** Purge PiT(s) to free space. */
		purgepit(2),
		__UNDEFINED(464378545);

		public final int value;

		private PITRepositoryFullPolicy(int v) {
			this.value = v;
		}
}
