package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report on a specific PiTs utilization of capacity in the PiT group repository. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(855)
public class PITRepositoryUtilization implements Serializable {
	public PITRepositoryUtilization() {
	}

	/** A reference to the specific PiT for which utilization is being reported. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the specific PiT for which utilization is being reported." , required = true)
	@XmlElement(required = true)
	private String pitRef;

	/** @return A reference to the specific PiT for which utilization is being reported. */
	public String getPitRef() {
		return this.pitRef;
	}
	/** @param x A reference to the specific PiT for which utilization is being reported. */
	public void setPitRef(String x) {
		this.pitRef = x;
	}

	/** The total number of bytes in use in the repository for this specific PiTs metadata, copy-on-write indexes, and copy-on-write data. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of bytes in use in the repository for this specific PiTs metadata, copy-on-write indexes, and copy-on-write data." , required = true)
	@XmlElement(required = true)
	private long bytesUsed;

	/** @return The total number of bytes in use in the repository for this specific PiTs metadata, copy-on-write indexes, and copy-on-write data. */
	public long getBytesUsed() {
		return this.bytesUsed;
	}
	/** @param x The total number of bytes in use in the repository for this specific PiTs metadata, copy-on-write indexes, and copy-on-write data. */
	public void setBytesUsed(long x) {
		this.bytesUsed = x;
	}
}
