package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report progress of a PiT rollback operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(864)
public class PITRollbackOperation implements Serializable {
	public PITRollbackOperation() {
	}

	/** A reference to the PiT Group. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the PiT Group." , required = true)
	@XmlElement(required = true)
	private String pitGroupRef;

	/** @return A reference to the PiT Group. */
	public String getPitGroupRef() {
		return this.pitGroupRef;
	}
	/** @param x A reference to the PiT Group. */
	public void setPitGroupRef(String x) {
		this.pitGroupRef = x;
	}

	/** A reference to the specific PiT being rolled back. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the specific PiT being rolled back." , required = true)
	@XmlElement(required = true)
	private String pitRef;

	/** @return A reference to the specific PiT being rolled back. */
	public String getPitRef() {
		return this.pitRef;
	}
	/** @param x A reference to the specific PiT being rolled back. */
	public void setPitRef(String x) {
		this.pitRef = x;
	}

	/** If true, the operation has not started. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, the operation has not started." , required = true)
	@XmlElement(required = true)
	private boolean pending;

	/** @return If true, the operation has not started. */
	public boolean isPending() {
		return this.pending;
	}
	/** @param x If true, the operation has not started. */
	public void setPending(boolean x) {
		this.pending = x;
	}

	/** The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	@io.swagger.annotations.ApiModelProperty(value ="The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}

	/** The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN." , required = true)
	@XmlElement(required = true)
	private int timeToCompletion;

	/** @return The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public int getTimeToCompletion() {
		return this.timeToCompletion;
	}
	/** @param x The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public void setTimeToCompletion(int x) {
		this.timeToCompletion = x;
	}
}
