package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to specify the status of a PiT. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(150)
public enum PITStatus implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** The PiT state is valid/active. */
		optimal(1),
		/** The PiT has failed (repository failed). */
		failed(2),
		/** The PiT has been purged by PITRepositoryFullPolicy to free space. */
		purged(3),
		__UNDEFINED(464378545);

		public final int value;

		private PITStatus(int v) {
			this.value = v;
		}
}
