package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union describes a PITView's association (if any) to a Consistency Group View. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(457)
public class PITViewMembership implements Serializable {
	public PITViewMembership() {
	}

	/** This enumeration identifies the possible types for a PITView. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration identifies the possible types for a PITView." , required = true)
	@XmlElement(required = true)
	private PITViewType viewType = PITViewType.__UNDEFINED;

	/** @return This enumeration identifies the possible types for a PITView. */
	public PITViewType getViewType() {
		return this.viewType;
	}
	/** @param x This enumeration identifies the possible types for a PITView. */
	public void setViewType(PITViewType x) {
		this.viewType = x;
	}

	/** A reference to the PITConsistencyGroupView is returned if the value of viewType is equal to PIT_VIEW_TYPE_MEMBER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the PITConsistencyGroupView is returned if the value of viewType is equal to PIT_VIEW_TYPE_MEMBER." , required = false)
	@XmlElement(required = false)
	private String cgViewRef;

	/** @return A reference to the PITConsistencyGroupView is returned if the value of viewType is equal to PIT_VIEW_TYPE_MEMBER. */
	public String getCgViewRef() {
		return this.cgViewRef;
	}
	/** @param x A reference to the PITConsistencyGroupView is returned if the value of viewType is equal to PIT_VIEW_TYPE_MEMBER. */
	public void setCgViewRef(String x) {
		this.cgViewRef = x;
	}
}
