package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure used to update various PITView parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1099)
public class PITViewParamsUpdateDescriptor implements Serializable {
	public PITViewParamsUpdateDescriptor() {
	}

	/** The view on which parameters are to be set. */
	@io.swagger.annotations.ApiModelProperty(value ="The view on which parameters are to be set." , required = true)
	@XmlElement(required = true)
	private String viewRef;

	/** @return The view on which parameters are to be set. */
	public String getViewRef() {
		return this.viewRef;
	}
	/** @param x The view on which parameters are to be set. */
	public void setViewRef(String x) {
		this.viewRef = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}

	/** The name of the view. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the view." , required = true)
	@XmlElement(required = true)
	private String viewLabel;

	/** @return The name of the view. */
	public String getViewLabel() {
		return this.viewLabel;
	}
	/** @param x The name of the view. */
	public void setViewLabel(String x) {
		this.viewLabel = x;
	}
}
