package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information required to update the firmware on one or more power supplies. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(676)
public class PSUFirmwareUpdateDescriptor implements Serializable {
	public PSUFirmwareUpdateDescriptor() {
	}

	/** Force an update of power supplies with the same FW revision as the updated FW or non-optimal power supplies. */
	@io.swagger.annotations.ApiModelProperty(value ="Force an update of power supplies with the same FW revision as the updated FW or non-optimal power supplies." , required = true)
	@XmlElement(required = true)
	private boolean forceUpdate;

	/** @return Force an update of power supplies with the same FW revision as the updated FW or non-optimal power supplies. */
	public boolean isForceUpdate() {
		return this.forceUpdate;
	}
	/** @param x Force an update of power supplies with the same FW revision as the updated FW or non-optimal power supplies. */
	public void setForceUpdate(boolean x) {
		this.forceUpdate = x;
	}

	/** A list of references to power supply objects. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of references to power supply objects." , required = true)
	@XmlElement(required = true)
	private String[] powerSupplyRef;

	/** @return A list of references to power supply objects. */
	public String[] getPowerSupplyRef() {
		return this.powerSupplyRef;
	}
	/** @param x A list of references to power supply objects. */
	public void setPowerSupplyRef(String[] x) {
		this.powerSupplyRef = x;
	}

	/** The firmware update descriptor containing the firmware image and related information. */
	@io.swagger.annotations.ApiModelProperty(value ="The firmware update descriptor containing the firmware image and related information." , required = true)
	@XmlElement(required = true)
	private FirmwareUpdateDescriptor firmwareUpdateDescriptor;

	/** @return The firmware update descriptor containing the firmware image and related information. */
	public FirmwareUpdateDescriptor getFirmwareUpdateDescriptor() {
		return this.firmwareUpdateDescriptor;
	}
	/** @param x The firmware update descriptor containing the firmware image and related information. */
	public void setFirmwareUpdateDescriptor(FirmwareUpdateDescriptor x) {
		this.firmwareUpdateDescriptor = x;
	}
}
