package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used to return status information during a power supply firmware update. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(942)
public class PSUFirmwareUpdateStatus implements Serializable {
	public PSUFirmwareUpdateStatus() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of statuses. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of statuses." , required = false)
	@XmlElement(required = false)
	private PSUUpdateStatus[] psuUpdateStatus;

	/** @return This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of statuses. */
	public PSUUpdateStatus[] getPsuUpdateStatus() {
		return this.psuUpdateStatus;
	}
	/** @param x This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of statuses. */
	public void setPsuUpdateStatus(PSUUpdateStatus[] x) {
		this.psuUpdateStatus = x;
	}
}
