package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains status information related to updating the firmware on an individual power supply. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(755)
public class PSUUpdateStatus implements Serializable {
	public PSUUpdateStatus() {
	}

	/** A reference to the power supply object. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the power supply object." , required = true)
	@XmlElement(required = true)
	private String powerSupplyRef;

	/** @return A reference to the power supply object. */
	public String getPowerSupplyRef() {
		return this.powerSupplyRef;
	}
	/** @param x A reference to the power supply object. */
	public void setPowerSupplyRef(String x) {
		this.powerSupplyRef = x;
	}

	/** The firmware update status. */
	@io.swagger.annotations.ApiModelProperty(value ="The firmware update status." , required = true)
	@XmlElement(required = true)
	private PowerSupplyUpdateStatus powerSupplyUpdateStatus = PowerSupplyUpdateStatus.__UNDEFINED;

	/** @return The firmware update status. */
	public PowerSupplyUpdateStatus getPowerSupplyUpdateStatus() {
		return this.powerSupplyUpdateStatus;
	}
	/** @param x The firmware update status. */
	public void setPowerSupplyUpdateStatus(PowerSupplyUpdateStatus x) {
		this.powerSupplyUpdateStatus = x;
	}
}
