package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is used to identify the parent CRU of a component that is sharing a CRU with other components. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(721)
public class ParentCru implements Serializable {
	public ParentCru() {
	}

	/** This enumeration object is used to specify the type of reference that is contained in a ParentCru union. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to specify the type of reference that is contained in a ParentCru union." , required = true)
	@XmlElement(required = true)
	private ParentCruType type = ParentCruType.__UNDEFINED;

	/** @return This enumeration object is used to specify the type of reference that is contained in a ParentCru union. */
	public ParentCruType getType() {
		return this.type;
	}
	/** @param x This enumeration object is used to specify the type of reference that is contained in a ParentCru union. */
	public void setType(ParentCruType x) {
		this.type = x;
	}

	/** This field contains a reference to the parent controller. It is only valid if the type field is equal to PARENT_CRU_TYPE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent controller. It is only valid if the type field is equal to PARENT_CRU_TYPE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String parentController;

	/** @return This field contains a reference to the parent controller. It is only valid if the type field is equal to PARENT_CRU_TYPE_CONTROLLER. */
	public String getParentController() {
		return this.parentController;
	}
	/** @param x This field contains a reference to the parent controller. It is only valid if the type field is equal to PARENT_CRU_TYPE_CONTROLLER. */
	public void setParentController(String x) {
		this.parentController = x;
	}

	/** This field contains a reference to the parent ESM. It is only valid if the type field is equal to PARENT_CRU_TYPE_ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent ESM. It is only valid if the type field is equal to PARENT_CRU_TYPE_ESM." , required = false)
	@XmlElement(required = false)
	private String parentEsm;

	/** @return This field contains a reference to the parent ESM. It is only valid if the type field is equal to PARENT_CRU_TYPE_ESM. */
	public String getParentEsm() {
		return this.parentEsm;
	}
	/** @param x This field contains a reference to the parent ESM. It is only valid if the type field is equal to PARENT_CRU_TYPE_ESM. */
	public void setParentEsm(String x) {
		this.parentEsm = x;
	}

	/** This field contains a reference to the parent Fan. It is only valid if the type field is equal to PARENT_CRU_TYPE_FAN. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent Fan. It is only valid if the type field is equal to PARENT_CRU_TYPE_FAN." , required = false)
	@XmlElement(required = false)
	private String parentFan;

	/** @return This field contains a reference to the parent Fan. It is only valid if the type field is equal to PARENT_CRU_TYPE_FAN. */
	public String getParentFan() {
		return this.parentFan;
	}
	/** @param x This field contains a reference to the parent Fan. It is only valid if the type field is equal to PARENT_CRU_TYPE_FAN. */
	public void setParentFan(String x) {
		this.parentFan = x;
	}

	/** This field contains a reference to the parent interconnect CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_ICC_CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent interconnect CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_ICC_CRU." , required = false)
	@XmlElement(required = false)
	private String parentInterconnectCru;

	/** @return This field contains a reference to the parent interconnect CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_ICC_CRU. */
	public String getParentInterconnectCru() {
		return this.parentInterconnectCru;
	}
	/** @param x This field contains a reference to the parent interconnect CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_ICC_CRU. */
	public void setParentInterconnectCru(String x) {
		this.parentInterconnectCru = x;
	}

	/** This field contains a reference to the parent support CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_SUPPORT_CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent support CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_SUPPORT_CRU." , required = false)
	@XmlElement(required = false)
	private String parentSupportCru;

	/** @return This field contains a reference to the parent support CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_SUPPORT_CRU. */
	public String getParentSupportCru() {
		return this.parentSupportCru;
	}
	/** @param x This field contains a reference to the parent support CRU. It is only valid if the type field is equal to PARENT_CRU_TYPE_SUPPORT_CRU. */
	public void setParentSupportCru(String x) {
		this.parentSupportCru = x;
	}

	/** This field contains a reference to the parent drawer. It is only valid if the type field is equal to PARENT_CRU_TYPE_DRAWER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains a reference to the parent drawer. It is only valid if the type field is equal to PARENT_CRU_TYPE_DRAWER." , required = false)
	@XmlElement(required = false)
	private String parentDrawer;

	/** @return This field contains a reference to the parent drawer. It is only valid if the type field is equal to PARENT_CRU_TYPE_DRAWER. */
	public String getParentDrawer() {
		return this.parentDrawer;
	}
	/** @param x This field contains a reference to the parent drawer. It is only valid if the type field is equal to PARENT_CRU_TYPE_DRAWER. */
	public void setParentDrawer(String x) {
		this.parentDrawer = x;
	}
}
