package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report the results of the scanVolume procedure. It contains return code and parity status codes, which specify the result of the scan/repair action. It also contains the ending LBAs which identify the location of the last LBA scanned successfully or the LBA of any media or parity error found during the scan. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(574)
public class ParityScanResponse implements Serializable {
	public ParityScanResponse() {
	}

	/** The return code from the scanVolume procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from the scanVolume procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code from the scanVolume procedure. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code from the scanVolume procedure. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The status of the scanVolume procedure specifying the scan result when returnCode is RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the scanVolume procedure specifying the scan result when returnCode is RETCODE_OK." , required = true)
	@XmlElement(required = true)
	private ParityStatus parityStatus = ParityStatus.__UNDEFINED;

	/** @return The status of the scanVolume procedure specifying the scan result when returnCode is RETCODE_OK. */
	public ParityStatus getParityStatus() {
		return this.parityStatus;
	}
	/** @param x The status of the scanVolume procedure specifying the scan result when returnCode is RETCODE_OK. */
	public void setParityStatus(ParityStatus x) {
		this.parityStatus = x;
	}

	/** The last LBA scanned. This identifies the failing LBA when a parity or media error is detected. It identifies the last good LBA when the scan is successful or a timeout occurs. */
	@io.swagger.annotations.ApiModelProperty(value ="The last LBA scanned. This identifies the failing LBA when a parity or media error is detected. It identifies the last good LBA when the scan is successful or a timeout occurs." , required = true)
	@XmlElement(required = true)
	private long endingLBA;

	/** @return The last LBA scanned. This identifies the failing LBA when a parity or media error is detected. It identifies the last good LBA when the scan is successful or a timeout occurs. */
	public long getEndingLBA() {
		return this.endingLBA;
	}
	/** @param x The last LBA scanned. This identifies the failing LBA when a parity or media error is detected. It identifies the last good LBA when the scan is successful or a timeout occurs. */
	public void setEndingLBA(long x) {
		this.endingLBA = x;
	}
}
