package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is a member of the ParityScanResponse object. It is used to communicate the results of a volume scan. This value is only significant when the returnCode is set to RETCODE_OK. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(151)
public enum ParityStatus implements Serializable {
		/** Scan completed successfully */
		ok(0),
		/** Scan timeout occurred */
		timeout(1),
		/** The volume scan detected a parity mismatch at the LBA identified in the endingLBA object. */
		parityError(2),
		/** Media Error Detected */
		mediaError(3),
		/** EDC Error Detected */
		edcError(4),
		/** A single parity mismatch has been detected at LBA {0} */
		raid6QError(5),
		/** A dual parity error has been detected at LBA {0} */
		raid6PqError(6),
		/** Parity status is ok following retry */
		okFollowingRetry(7),
		/** This error is returned when there is a successful isolation and correction of a parity mismatch. */
		okFollowingRaid6Correction(8),
		/** This error is returned when there is an unsuccessful isolation of a parity mismatch. */
		raid6DataError(9),
		__UNDEFINED(464378545);

		public final int value;

		private ParityStatus(int v) {
			this.value = v;
		}
}
