package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe a host that has identified itself to the array, but which has not been added to the configured topology. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1130)
public class PendingHost implements Serializable {
	public PendingHost() {
	}

	/** The official node name of the host to which the pending topology host port belongs. */
	@io.swagger.annotations.ApiModelProperty(value ="The official node name of the host to which the pending topology host port belongs." , required = true)
	@XmlElement(required = true)
	private String hostLabel;

	/** @return The official node name of the host to which the pending topology host port belongs. */
	public String getHostLabel() {
		return this.hostLabel;
	}
	/** @param x The official node name of the host to which the pending topology host port belongs. */
	public void setHostLabel(String x) {
		this.hostLabel = x;
	}

	/** A string representing the host type of the pending topology host port. The contents of this field is the "short form" of the host type label used in the controller firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="A string representing the host type of the pending topology host port. The contents of this field is the \"short form\" of the host type label used in the controller firmware." , required = true)
	@XmlElement(required = true)
	private String hostType;

	/** @return A string representing the host type of the pending topology host port. The contents of this field is the "short form" of the host type label used in the controller firmware. */
	public String getHostType() {
		return this.hostType;
	}
	/** @param x A string representing the host type of the pending topology host port. The contents of this field is the "short form" of the host type label used in the controller firmware. */
	public void setHostType(String x) {
		this.hostType = x;
	}

	/** This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host." , required = true)
	@XmlElement(required = true)
	private SCSIInitiatorPortId[] hostPortId;

	/** @return This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host. */
	public SCSIInitiatorPortId[] getHostPortId() {
		return this.hostPortId;
	}
	/** @param x This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host. */
	public void setHostPortId(SCSIInitiatorPortId[] x) {
		this.hostPortId = x;
	}
}
