package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration indicates what the match is based on for a pending host that matches a configured host. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(246)
public enum PendingHostMatchType implements Serializable {
		/** The match is based on matching names only. This matching criteria is applied after the ports match criteria. */
		nameOnly(1),
		/** The match is based on matching ports only. A match on ports happens when all of the configured ports for a pending host are found under exactly one configured host. Any unconfigured ports for a pending host are not considered in the test for a match. This matching criteria takes precedence over the PENDING_HOST_MATCH_NAME_ONLY criteria. */
		portsOnly(2),
		/** The match is based on both matching names and matching ports. */
		nameAndPorts(3),
		__UNDEFINED(464378545);

		public final int value;

		private PendingHostMatchType(int v) {
			this.value = v;
		}
}
