package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure defines the output format and amount of data for retrieveRingBuffer. There are 2 concurrent ringBuffers in the array controller. The seconds ring and the minutes ring. There are up to 2048 buffers for both the seconds and minutes ring buffers. Providing roughly 30 minutes of second data and 30 hours of minute data. For ASUP collection the call is expected to take the following format to retrieve data on a one minute interval for the max time captured. perfRingType is 5, numberOfSeconds is -1, numberofMinutes is 0, numberOfSecondsBack is 0, and numberofMinutesBack is 0. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(487)
public class PerformanceRingStartDetails implements Serializable {
	public PerformanceRingStartDetails() {
	}

	/** This field is the output format for the ring buffer data retrieval. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is the output format for the ring buffer data retrieval." , required = true)
	@XmlElement(required = true)
	private PerformanceRingType perfRingType = PerformanceRingType.__UNDEFINED;

	/** @return This field is the output format for the ring buffer data retrieval. */
	public PerformanceRingType getPerfRingType() {
		return this.perfRingType;
	}
	/** @param x This field is the output format for the ring buffer data retrieval. */
	public void setPerfRingType(PerformanceRingType x) {
		this.perfRingType = x;
	}

	/** The total number of seconds to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of seconds to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data." , required = true)
	@XmlElement(required = true)
	private int numberOfSeconds;

	/** @return The total number of seconds to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	public int getNumberOfSeconds() {
		return this.numberOfSeconds;
	}
	/** @param x The total number of seconds to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	public void setNumberOfSeconds(int x) {
		this.numberOfSeconds = x;
	}

	/** The total number of minutes to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of minutes to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data." , required = true)
	@XmlElement(required = true)
	private int numberOfMinutes;

	/** @return The total number of minutes to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	public int getNumberOfMinutes() {
		return this.numberOfMinutes;
	}
	/** @param x The total number of minutes to retrieve, up to 2048, 0 indicates all available, -1 indicates to skip any returning data. */
	public void setNumberOfMinutes(int x) {
		this.numberOfMinutes = x;
	}

	/** This field is used with a value of all available, once the data is read a flag is set in the ringBuffer structure to indicate that the data has been read via SYMbol. When combined with a numberOfSeconds or numberOfMinutes is 0 it returns only data previously not sent via SYMbol. When numberOfSeconds or numberOfMinutes are anything other than -1 or 0 the field is ignored. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used with a value of all available, once the data is read a flag is set in the ringBuffer structure to indicate that the data has been read via SYMbol. When combined with a numberOfSeconds or numberOfMinutes is 0 it returns only data previously not sent via SYMbol. When numberOfSeconds or numberOfMinutes are anything other than -1 or 0 the field is ignored." , required = true)
	@XmlElement(required = true)
	private boolean onlyUnreadData;

	/** @return This field is used with a value of all available, once the data is read a flag is set in the ringBuffer structure to indicate that the data has been read via SYMbol. When combined with a numberOfSeconds or numberOfMinutes is 0 it returns only data previously not sent via SYMbol. When numberOfSeconds or numberOfMinutes are anything other than -1 or 0 the field is ignored. */
	public boolean isOnlyUnreadData() {
		return this.onlyUnreadData;
	}
	/** @param x This field is used with a value of all available, once the data is read a flag is set in the ringBuffer structure to indicate that the data has been read via SYMbol. When combined with a numberOfSeconds or numberOfMinutes is 0 it returns only data previously not sent via SYMbol. When numberOfSeconds or numberOfMinutes are anything other than -1 or 0 the field is ignored. */
	public void setOnlyUnreadData(boolean x) {
		this.onlyUnreadData = x;
	}
}
