package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the Performance Ring Buffer Types. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(121)
public enum PerformanceRingType implements Serializable {
		/** The performance ring type is a controller level summary. */
		summary(1),
		/** The performance ring type is a channel related performance. */
		channel(2),
		/** The performance ring type is controller latency on a per channel basis. */
		latency(3),
		/** The performance ring type is currently not supported. */
		drive(4),
		/** The performance ring type is controller all, which returns all of the gathered information. */
		all(5),
		__UNDEFINED(464378545);

		public final int value;

		private PerformanceRingType(int v) {
			this.value = v;
		}
}
