package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain information about the persistent registrations associated with a volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(874)
public class PersistentRegistration implements Serializable {
	public PersistentRegistration() {
	}

	/** The volume identifier. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume identifier." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The volume identifier. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The volume identifier. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** LUN (mapped). */
	@io.swagger.annotations.ApiModelProperty(value ="LUN (mapped)." , required = true)
	@XmlElement(required = true)
	private int lun;

	/** @return LUN (mapped). */
	public int getLun() {
		return this.lun;
	}
	/** @param x LUN (mapped). */
	public void setLun(int x) {
		this.lun = x;
	}

	/** Group that volume is accessible by. */
	@io.swagger.annotations.ApiModelProperty(value ="Group that volume is accessible by." , required = true)
	@XmlElement(required = true)
	private String clusterRef;

	/** @return Group that volume is accessible by. */
	public String getClusterRef() {
		return this.clusterRef;
	}
	/** @param x Group that volume is accessible by. */
	public void setClusterRef(String x) {
		this.clusterRef = x;
	}

	/** Host that volume is accessible by. */
	@io.swagger.annotations.ApiModelProperty(value ="Host that volume is accessible by." , required = true)
	@XmlElement(required = true)
	private String hostRef;

	/** @return Host that volume is accessible by. */
	public String getHostRef() {
		return this.hostRef;
	}
	/** @param x Host that volume is accessible by. */
	public void setHostRef(String x) {
		this.hostRef = x;
	}

	/** Reservation type. */
	@io.swagger.annotations.ApiModelProperty(value ="Reservation type." , required = true)
	@XmlElement(required = true)
	private ReservationTypeID reservationTypeID = ReservationTypeID.__UNDEFINED;

	/** @return Reservation type. */
	public ReservationTypeID getReservationTypeID() {
		return this.reservationTypeID;
	}
	/** @param x Reservation type. */
	public void setReservationTypeID(ReservationTypeID x) {
		this.reservationTypeID = x;
	}

	/** List of registrants. */
	@io.swagger.annotations.ApiModelProperty(value ="List of registrants." , required = true)
	@XmlElement(required = true)
	private RegistrantList registrantList;

	/** @return List of registrants. */
	public RegistrantList getRegistrantList() {
		return this.registrantList;
	}
	/** @param x List of registrants. */
	public void setRegistrantList(RegistrantList x) {
		this.registrantList = x;
	}

	/** Persist through power loss active. */
	@io.swagger.annotations.ApiModelProperty(value ="Persist through power loss active." , required = true)
	@XmlElement(required = true)
	private boolean ptpl_A;

	/** @return Persist through power loss active. */
	public boolean isPtpl_A() {
		return this.ptpl_A;
	}
	/** @param x Persist through power loss active. */
	public void setPtpl_A(boolean x) {
		this.ptpl_A = x;
	}
}
