package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object describes drive properties that are unique to a particular physical drive type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(792)
public class PhysicalDriveTypeData implements Serializable {
	public PhysicalDriveTypeData() {
	}

	/** This enumeration object is used to describe the physical interface of the drive. This is not necessarily the same as the I/O protocol interface used by the controller to communicate with the drive (DriveType). In addition, the supportedDriveTypes array in the FeatureParams structure will contain values from this enumeration identifying which drive types are supported on the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to describe the physical interface of the drive. This is not necessarily the same as the I/O protocol interface used by the controller to communicate with the drive (DriveType). In addition, the supportedDriveTypes array in the FeatureParams structure will contain values from this enumeration identifying which drive types are supported on the storage array." , required = true)
	@XmlElement(required = true)
	private PhysicalDriveType phyDriveType = PhysicalDriveType.__UNDEFINED;

	/** @return This enumeration object is used to describe the physical interface of the drive. This is not necessarily the same as the I/O protocol interface used by the controller to communicate with the drive (DriveType). In addition, the supportedDriveTypes array in the FeatureParams structure will contain values from this enumeration identifying which drive types are supported on the storage array. */
	public PhysicalDriveType getPhyDriveType() {
		return this.phyDriveType;
	}
	/** @param x This enumeration object is used to describe the physical interface of the drive. This is not necessarily the same as the I/O protocol interface used by the controller to communicate with the drive (DriveType). In addition, the supportedDriveTypes array in the FeatureParams structure will contain values from this enumeration identifying which drive types are supported on the storage array. */
	public void setPhyDriveType(PhysicalDriveType x) {
		this.phyDriveType = x;
	}

	/** This field identifies the attributes of SATA drives It is only present if the phyDriveType field is equal to PHY_DRIVE_TYPE_SATA. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the attributes of SATA drives It is only present if the phyDriveType field is equal to PHY_DRIVE_TYPE_SATA." , required = false)
	@XmlElement(required = false)
	private SataDriveAttributes sataDriveAttributes;

	/** @return This field identifies the attributes of SATA drives It is only present if the phyDriveType field is equal to PHY_DRIVE_TYPE_SATA. */
	public SataDriveAttributes getSataDriveAttributes() {
		return this.sataDriveAttributes;
	}
	/** @param x This field identifies the attributes of SATA drives It is only present if the phyDriveType field is equal to PHY_DRIVE_TYPE_SATA. */
	public void setSataDriveAttributes(SataDriveAttributes x) {
		this.sataDriveAttributes = x;
	}
}
