package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object describes properties that are unique to a particular controller physical interface type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(934)
public class PhysicalInterfaceTypeData implements Serializable {
	public PhysicalInterfaceTypeData() {
	}

	/** This enumeration object is used to indicate the physical type of an I/O interface, in contrast to the logical protocol used by the interface (iSCSI is a logical protocol; Ethernet is a physical interface). */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to indicate the physical type of an I/O interface, in contrast to the logical protocol used by the interface (iSCSI is a logical protocol; Ethernet is a physical interface)." , required = true)
	@XmlElement(required = true)
	private PhysicalInterfaceType type = PhysicalInterfaceType.__UNDEFINED;

	/** @return This enumeration object is used to indicate the physical type of an I/O interface, in contrast to the logical protocol used by the interface (iSCSI is a logical protocol; Ethernet is a physical interface). */
	public PhysicalInterfaceType getType() {
		return this.type;
	}
	/** @param x This enumeration object is used to indicate the physical type of an I/O interface, in contrast to the logical protocol used by the interface (iSCSI is a logical protocol; Ethernet is a physical interface). */
	public void setType(PhysicalInterfaceType x) {
		this.type = x;
	}

	/** This field contains information about an Ethernet physical interface It is only present if the type field is equal to PHYSICAL_INTERFACE_ETHERNET. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains information about an Ethernet physical interface It is only present if the type field is equal to PHYSICAL_INTERFACE_ETHERNET." , required = false)
	@XmlElement(required = false)
	private EthernetInterfaceData ethernetData;

	/** @return This field contains information about an Ethernet physical interface It is only present if the type field is equal to PHYSICAL_INTERFACE_ETHERNET. */
	public EthernetInterfaceData getEthernetData() {
		return this.ethernetData;
	}
	/** @param x This field contains information about an Ethernet physical interface It is only present if the type field is equal to PHYSICAL_INTERFACE_ETHERNET. */
	public void setEthernetData(EthernetInterfaceData x) {
		this.ethernetData = x;
	}

	/** This field indicates iSCSI/iSER interface. */
	@io.swagger.annotations.ApiModelProperty(value ="This field indicates iSCSI/iSER interface." , required = false)
	@XmlElement(required = false)
	private InfinibandInterfaceData infinibandData;

	/** @return This field indicates iSCSI/iSER interface. */
	public InfinibandInterfaceData getInfinibandData() {
		return this.infinibandData;
	}
	/** @param x This field indicates iSCSI/iSER interface. */
	public void setInfinibandData(InfinibandInterfaceData x) {
		this.infinibandData = x;
	}
}
