package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Conveys information about a host ports location, host interface card or base board */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(843)
public class PortsRefTypeData implements Serializable {
	public PortsRefTypeData() {
	}

	/** This enumeration is used to specify whether the actions will be taken on ports residing on a host interface card or a base board. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to specify whether the actions will be taken on ports residing on a host interface card or a base board." , required = true)
	@XmlElement(required = true)
	private PortsRefType portRefType = PortsRefType.__UNDEFINED;

	/** @return This enumeration is used to specify whether the actions will be taken on ports residing on a host interface card or a base board. */
	public PortsRefType getPortRefType() {
		return this.portRefType;
	}
	/** @param x This enumeration is used to specify whether the actions will be taken on ports residing on a host interface card or a base board. */
	public void setPortRefType(PortsRefType x) {
		this.portRefType = x;
	}

	/** Host Interface Card */
	@io.swagger.annotations.ApiModelProperty(value ="Host Interface Card" , required = false)
	@XmlElement(required = false)
	private String hicRef;

	/** @return Host Interface Card */
	public String getHicRef() {
		return this.hicRef;
	}
	/** @param x Host Interface Card */
	public void setHicRef(String x) {
		this.hicRef = x;
	}

	/** Base Board Reference */
	@io.swagger.annotations.ApiModelProperty(value ="Base Board Reference" , required = false)
	@XmlElement(required = false)
	private String baseBoardRef;

	/** @return Base Board Reference */
	public String getBaseBoardRef() {
		return this.baseBoardRef;
	}
	/** @param x Base Board Reference */
	public void setBaseBoardRef(String x) {
		this.baseBoardRef = x;
	}
}
