package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure returned from the powerCyclePhysicalDrive procedure. All data is populated, regardless of the return code. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(710)
public class PowerCyclePhysicalDriveDataReturn implements Serializable {
	public PowerCyclePhysicalDriveDataReturn() {
	}

	/** The return code from the powerCyclePhysicalDrive procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from the powerCyclePhysicalDrive procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode retCode = ReturnCode.__UNDEFINED;

	/** @return The return code from the powerCyclePhysicalDrive procedure. */
	public ReturnCode getRetCode() {
		return this.retCode;
	}
	/** @param x The return code from the powerCyclePhysicalDrive procedure. */
	public void setRetCode(ReturnCode x) {
		this.retCode = x;
	}

	/** The drive for which the powerCyclePhysicalDrive procedure was sent. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive for which the powerCyclePhysicalDrive procedure was sent." , required = true)
	@XmlElement(required = true)
	private String driveRef;

	/** @return The drive for which the powerCyclePhysicalDrive procedure was sent. */
	public String getDriveRef() {
		return this.driveRef;
	}
	/** @param x The drive for which the powerCyclePhysicalDrive procedure was sent. */
	public void setDriveRef(String x) {
		this.driveRef = x;
	}
}
