package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to determine the status of a power supply component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(155)
public enum PowerSupplyStatus implements Serializable {
		/** The power supply is working correctly. */
		optimal(1),
		/** The power supply is not working or not present. */
		failed(2),
		/** The power supply has been removed or is missing. */
		removed(3),
		/** The status of the power supply is unknown. */
		unknown(4),
		/** The power supply has no input voltage. */
		noinput(5),
		__UNDEFINED(464378545);

		public final int value;

		private PowerSupplyStatus(int v) {
			this.value = v;
		}
}
