package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the possible status values for a power supply firmware update. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(158)
public enum PowerSupplyUpdateStatus implements Serializable {
		/** The power supply update completed successfully. */
		complete(0),
		/** The power supply update was bypassed because it's FW revision was the same as the updated FW. */
		byPassed(1),
		/** The power supply update is pending. */
		pending(2),
		/** The power supply update is in progress. */
		inProgress(3),
		/** The power supply update failed. */
		failed(4),
		/** The firmware update for this power supply has been aborted because the firmware update for another power supply failed. */
		aborted(5),
		__UNDEFINED(464378545);

		public final int value;

		private PowerSupplyUpdateStatus(int v) {
			this.value = v;
		}
}
