package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about the protection type and protection capabilities of drive(s). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(519)
public class ProtectionInformationCapabilities implements Serializable {
	public ProtectionInformationCapabilities() {
	}

	/** True when all drive(s) are PI capable. */
	@io.swagger.annotations.ApiModelProperty(value ="True when all drive(s) are PI capable." , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	/** @return True when all drive(s) are PI capable. */
	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	/** @param x True when all drive(s) are PI capable. */
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}

	/** This field is set to the protection type provided for the drive(s). */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to the protection type provided for the drive(s)." , required = true)
	@XmlElement(required = true)
	private ProtectionType protectionType = ProtectionType.__UNDEFINED;

	/** @return This field is set to the protection type provided for the drive(s). */
	public ProtectionType getProtectionType() {
		return this.protectionType;
	}
	/** @param x This field is set to the protection type provided for the drive(s). */
	public void setProtectionType(ProtectionType x) {
		this.protectionType = x;
	}
}
