package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used when identifying a Protection Information type. In addition, the supportedProtectionTypes array in the FeatureParams structure will contain values from this enumeration identifying which Protection Types are supported on the storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(136)
public enum ProtectionType implements Serializable {
		/** The volume does not support protection information (the PROTECT bit is set to zero in the standard INQUIRY data) or the volume has been formatted with protection information disabled. */
		type0Protection(0),
		/** The LOGICAL BLOCK GUARD contains a valid CRC. The LOGICAL BLOCK APPLICATION TAG is defined by the owner of the tag as determined by the ATO bit in the Control Mode page. The LOGICAL BLOCK REFERENCE TAG contains the least significant four bytes of the associated LOGICAL BLOCK ADDRESS (LBA). */
		type1Protection(1),
		/** The LOGICAL BLOCK GUARD contains a valid CRC. The LOGICAL BLOCK APPLICATION TAG is defined by the owner of the tag as determined by the ATO bit in the Control Mode page. If the Application Tag is owned by the application client, the expected value may be specified in the Command Description Block (CDB). The LOGICAL BLOCK REFERENCE TAG in the first block of the I/O operation contains a value specified in the CDB. For each subsequent block, the Reference Tag for each block within the I/O operation is equal to the Reference Tag of the previous block plus one. */
		type2Protection(2),
		/** The LOGICAL BLOCK GUARD contains a valid CRC. The LOGICAL BLOCK APPLICATION TAG is defined by the owner of the tag as determined by the ATO bit in the Control Mode page. The LOGICAL BLOCK REFERENCE TAG is present but not defined. */
		type3Protection(3),
		__UNDEFINED(464378545);

		public final int value;

		private ProtectionType(int v) {
			this.value = v;
		}
}
