package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used in the FailureTypeList returned by the getRecoveryFailureList procedure. It contains data needed for recovery of certain Portable Volume Group fault scenarios that are too complicated to be described by just a single SYMbol reference. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(857)
public class PvgRecoveryData implements Serializable {
	public PvgRecoveryData() {
	}

	/** This field is a SYMbol reference indicating the "drive of interest" for the associated recovery failure type. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is a SYMbol reference indicating the \"drive of interest\" for the associated recovery failure type." , required = true)
	@XmlElement(required = true)
	private String drive;

	/** @return This field is a SYMbol reference indicating the "drive of interest" for the associated recovery failure type. */
	public String getDrive() {
		return this.drive;
	}
	/** @param x This field is a SYMbol reference indicating the "drive of interest" for the associated recovery failure type. */
	public void setDrive(String x) {
		this.drive = x;
	}

	/** This field is a SYMbol reference indicating the "volume group of interest" for the associated recovery failure type. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is a SYMbol reference indicating the \"volume group of interest\" for the associated recovery failure type." , required = true)
	@XmlElement(required = true)
	private String volumeGroup;

	/** @return This field is a SYMbol reference indicating the "volume group of interest" for the associated recovery failure type. */
	public String getVolumeGroup() {
		return this.volumeGroup;
	}
	/** @param x This field is a SYMbol reference indicating the "volume group of interest" for the associated recovery failure type. */
	public void setVolumeGroup(String x) {
		this.volumeGroup = x;
	}
}
