package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the data to be returned from a Read Link Status command. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(856)
public class RLSResults implements Serializable {
	public RLSResults() {
	}

	/** The return code from the getReadLinkStatus procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from the getReadLinkStatus procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code from the getReadLinkStatus procedure. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code from the getReadLinkStatus procedure. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The time relative to the controllers that the getReadLinkStatus command was issued. */
	@io.swagger.annotations.ApiModelProperty(value ="The time relative to the controllers that the getReadLinkStatus command was issued." , required = true)
	@XmlElement(required = true)
	private long overallRLSTime;

	/** @return The time relative to the controllers that the getReadLinkStatus command was issued. */
	public long getOverallRLSTime() {
		return this.overallRLSTime;
	}
	/** @param x The time relative to the controllers that the getReadLinkStatus command was issued. */
	public void setOverallRLSTime(long x) {
		this.overallRLSTime = x;
	}

	/** The RLS results for the controllers. */
	@io.swagger.annotations.ApiModelProperty(value ="The RLS results for the controllers." , required = true)
	@XmlElement(required = true)
	private RLSData[] controllers;

	/** @return The RLS results for the controllers. */
	public RLSData[] getControllers() {
		return this.controllers;
	}
	/** @param x The RLS results for the controllers. */
	public void setControllers(RLSData[] x) {
		this.controllers = x;
	}

	/** The RLS results for the drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The RLS results for the drives." , required = true)
	@XmlElement(required = true)
	private RLSData[] drives;

	/** @return The RLS results for the drives. */
	public RLSData[] getDrives() {
		return this.drives;
	}
	/** @param x The RLS results for the drives. */
	public void setDrives(RLSData[] x) {
		this.drives = x;
	}

	/** The RLS results for the ESMs. */
	@io.swagger.annotations.ApiModelProperty(value ="The RLS results for the ESMs." , required = true)
	@XmlElement(required = true)
	private RLSData[] esms;

	/** @return The RLS results for the ESMs. */
	public RLSData[] getEsms() {
		return this.esms;
	}
	/** @param x The RLS results for the ESMs. */
	public void setEsms(RLSData[] x) {
		this.esms = x;
	}
}
