package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is used to identify the ready-to-remove attributes of a component based on CRU type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(750)
public class RTRAttributes implements Serializable {
	public RTRAttributes() {
	}

	/** This enumeration identifies the type of CRU a component has. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration identifies the type of CRU a component has." , required = true)
	@XmlElement(required = true)
	private CruType cruType = CruType.__UNDEFINED;

	/** @return This enumeration identifies the type of CRU a component has. */
	public CruType getCruType() {
		return this.cruType;
	}
	/** @param x This enumeration identifies the type of CRU a component has. */
	public void setCruType(CruType x) {
		this.cruType = x;
	}

	/** This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE." , required = false)
	@XmlElement(required = false)
	private ParentCru parentCru;

	/** @return This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE. */
	public ParentCru getParentCru() {
		return this.parentCru;
	}
	/** @param x This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE. */
	public void setParentCru(ParentCru x) {
		this.parentCru = x;
	}

	/** This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED." , required = false)
	@XmlElement(required = false)
	private RTRAttributeData rtrAttributeData;

	/** @return This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED. */
	public RTRAttributeData getRtrAttributeData() {
		return this.rtrAttributeData;
	}
	/** @param x This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED. */
	public void setRtrAttributeData(RTRAttributeData x) {
		this.rtrAttributeData = x;
	}
}
