package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to describe indicate the operand for the requestRemoval procedure. It replaces the deprecated RTRTypeRef union. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(643)
public class RTRObject implements Serializable {
	public RTRObject() {
	}

	/** This enumeration is used to determine the type of a given component. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to determine the type of a given component." , required = true)
	@XmlElement(required = true)
	private RTRType rtrType = RTRType.__UNDEFINED;

	/** @return This enumeration is used to determine the type of a given component. */
	public RTRType getRtrType() {
		return this.rtrType;
	}
	/** @param x This enumeration is used to determine the type of a given component. */
	public void setRtrType(RTRType x) {
		this.rtrType = x;
	}

	/** This field is present only if the RTRType is RTR_TYPE_ALARM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the RTRType is RTR_TYPE_ALARM." , required = false)
	@XmlElement(required = false)
	private String alarmRef;

	/** @return This field is present only if the RTRType is RTR_TYPE_ALARM. */
	public String getAlarmRef() {
		return this.alarmRef;
	}
	/** @param x This field is present only if the RTRType is RTR_TYPE_ALARM. */
	public void setAlarmRef(String x) {
		this.alarmRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_BATTERY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_BATTERY." , required = false)
	@XmlElement(required = false)
	private String batteryRef;

	/** @return This field is present only if rtrType is RTR_TYPE_BATTERY. */
	public String getBatteryRef() {
		return this.batteryRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_BATTERY. */
	public void setBatteryRef(String x) {
		this.batteryRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String controllerRef;

	/** @return This field is present only if rtrType is RTR_TYPE_CONTROLLER. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_CONTROLLER. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_DRIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_DRIVE." , required = false)
	@XmlElement(required = false)
	private String driveRef;

	/** @return This field is present only if rtrType is RTR_TYPE_DRIVE. */
	public String getDriveRef() {
		return this.driveRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_DRIVE. */
	public void setDriveRef(String x) {
		this.driveRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_ESM." , required = false)
	@XmlElement(required = false)
	private String esmRef;

	/** @return This field is present only if rtrType is RTR_TYPE_ESM. */
	public String getEsmRef() {
		return this.esmRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_ESM. */
	public void setEsmRef(String x) {
		this.esmRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_FAN. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_FAN." , required = false)
	@XmlElement(required = false)
	private String fanRef;

	/** @return This field is present only if rtrType is RTR_TYPE_FAN. */
	public String getFanRef() {
		return this.fanRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_FAN. */
	public void setFanRef(String x) {
		this.fanRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_INTERCONNECT. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_INTERCONNECT." , required = false)
	@XmlElement(required = false)
	private String interconnectRef;

	/** @return This field is present only if rtrType is RTR_TYPE_INTERCONNECT. */
	public String getInterconnectRef() {
		return this.interconnectRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_INTERCONNECT. */
	public void setInterconnectRef(String x) {
		this.interconnectRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_MINIHUB. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_MINIHUB." , required = false)
	@XmlElement(required = false)
	private String minihubRef;

	/** @return This field is present only if rtrType is RTR_TYPE_MINIHUB. */
	public String getMinihubRef() {
		return this.minihubRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_MINIHUB. */
	public void setMinihubRef(String x) {
		this.minihubRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_POWER_SUPPLY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_POWER_SUPPLY." , required = false)
	@XmlElement(required = false)
	private String powerSupplyRef;

	/** @return This field is present only if rtrType is RTR_TYPE_POWER_SUPPLY. */
	public String getPowerSupplyRef() {
		return this.powerSupplyRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_POWER_SUPPLY. */
	public void setPowerSupplyRef(String x) {
		this.powerSupplyRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_SUPPORT_CRU. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_SUPPORT_CRU." , required = false)
	@XmlElement(required = false)
	private String supportCruRef;

	/** @return This field is present only if rtrType is RTR_TYPE_SUPPORT_CRU. */
	public String getSupportCruRef() {
		return this.supportCruRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_SUPPORT_CRU. */
	public void setSupportCruRef(String x) {
		this.supportCruRef = x;
	}

	/** This field is present only if the RTRType is RTR_TYPE_THERMAL_SENSOR. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the RTRType is RTR_TYPE_THERMAL_SENSOR." , required = false)
	@XmlElement(required = false)
	private String thermalSensorRef;

	/** @return This field is present only if the RTRType is RTR_TYPE_THERMAL_SENSOR. */
	public String getThermalSensorRef() {
		return this.thermalSensorRef;
	}
	/** @param x This field is present only if the RTRType is RTR_TYPE_THERMAL_SENSOR. */
	public void setThermalSensorRef(String x) {
		this.thermalSensorRef = x;
	}

	/** This field is present only if rtrType is RTR_TYPE_DRAWER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if rtrType is RTR_TYPE_DRAWER." , required = false)
	@XmlElement(required = false)
	private String drawerRef;

	/** @return This field is present only if rtrType is RTR_TYPE_DRAWER. */
	public String getDrawerRef() {
		return this.drawerRef;
	}
	/** @param x This field is present only if rtrType is RTR_TYPE_DRAWER. */
	public void setDrawerRef(String x) {
		this.drawerRef = x;
	}
}
