package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to determine the type of a given component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(61)
public enum RTRType implements Serializable {
		/** This component is an invalid candidate type for removal. */
		unknown(0),
		/** This component is an Interconnect CRU. */
		interconnect(1),
		/** This component is Support CRU A or B. */
		supportCru(2),
		/** This component is Controller A or B. */
		controller(3),
		/** This component is a battery. */
		battery(4),
		/** This component is a drive. */
		drive(5),
		/** This component is an ESM. */
		esm(6),
		/** This component is a fan. */
		fan(7),
		/** This component is a power supply. */
		powerSupply(8),
		/** This component is a minihub. */
		minihub(9),
		/** This component is an alarm. */
		alarm(10),
		/** This component is a thermal sensor. */
		thermalSensor(11),
		/** This component is a drawer. */
		drawer(12),
		__UNDEFINED(464378545);

		public final int value;

		private RTRType(int v) {
			this.value = v;
		}
}
