package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as the argument to the requestToRemove procedure; it provides all information needed to enable or disable a Ready to Remove indicator or to put the Ready to Remove indicator in automatic mode. The requestToRemove procedure where this structure is used has been deprecated and therefore this structure is also deprecated. See the requestRemoval procedure for a description of the replacement procedure and associated structures. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(927)
public class RTRUpdateDescriptor implements Serializable {
	public RTRUpdateDescriptor() {
	}

	/** The reference that indicates the object to modify. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference that indicates the object to modify." , required = true)
	@XmlElement(required = true)
	private RTRTypeRef rtrRef;

	/** @return The reference that indicates the object to modify. */
	public RTRTypeRef getRtrRef() {
		return this.rtrRef;
	}
	/** @param x The reference that indicates the object to modify. */
	public void setRtrRef(RTRTypeRef x) {
		this.rtrRef = x;
	}

	/** Indicates the ready-to-remove control to activate on the specified component (enable, disable, or put the indicator in automatic mode). */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates the ready-to-remove control to activate on the specified component (enable, disable, or put the indicator in automatic mode)." , required = true)
	@XmlElement(required = true)
	private RTRControl rtrControl = RTRControl.__UNDEFINED;

	/** @return Indicates the ready-to-remove control to activate on the specified component (enable, disable, or put the indicator in automatic mode). */
	public RTRControl getRtrControl() {
		return this.rtrControl;
	}
	/** @param x Indicates the ready-to-remove control to activate on the specified component (enable, disable, or put the indicator in automatic mode). */
	public void setRtrControl(RTRControl x) {
		this.rtrControl = x;
	}
}
