package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Used to differentiate between the detailed information formats that are passed to the controller in raw data restore operations, based on the type of transfer being performed. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(719)
public class RawDataRestoreChunkDetails implements Serializable {
	public RawDataRestoreChunkDetails() {
	}

	/** This enumeration lists the raw data transfer types. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration lists the raw data transfer types." , required = true)
	@XmlElement(required = true)
	private RawDataTransferType rawDataTransferType = RawDataTransferType.__UNDEFINED;

	/** @return This enumeration lists the raw data transfer types. */
	public RawDataTransferType getRawDataTransferType() {
		return this.rawDataTransferType;
	}
	/** @param x This enumeration lists the raw data transfer types. */
	public void setRawDataTransferType(RawDataTransferType x) {
		this.rawDataTransferType = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DBMBLK." , required = false)
	@XmlElement(required = false)
	private DbmBlkRestoreChunkDetails dbmBlk;

	/** @return This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	public DbmBlkRestoreChunkDetails getDbmBlk() {
		return this.dbmBlk;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	public void setDbmBlk(DbmBlkRestoreChunkDetails x) {
		this.dbmBlk = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DBMREC. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DBMREC." , required = false)
	@XmlElement(required = false)
	private DbmRecRestoreChunkDetails dbmRec;

	/** @return This field is present only if the type value is equal to RAWDATA_DBMREC. */
	public DbmRecRestoreChunkDetails getDbmRec() {
		return this.dbmRec;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DBMREC. */
	public void setDbmRec(DbmRecRestoreChunkDetails x) {
		this.dbmRec = x;
	}
}
