package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** used to differentiate between the transfer-type-specific details that can be requested when starting a raw data retrieval. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(865)
public class RawDataRetrieveChunkDetails implements Serializable {
	public RawDataRetrieveChunkDetails() {
	}

	/** This enumeration lists the raw data transfer types. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration lists the raw data transfer types." , required = true)
	@XmlElement(required = true)
	private RawDataTransferType rawDataTransferType = RawDataTransferType.__UNDEFINED;

	/** @return This enumeration lists the raw data transfer types. */
	public RawDataTransferType getRawDataTransferType() {
		return this.rawDataTransferType;
	}
	/** @param x This enumeration lists the raw data transfer types. */
	public void setRawDataTransferType(RawDataTransferType x) {
		this.rawDataTransferType = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DQ. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DQ." , required = false)
	@XmlElement(required = false)
	private DqRetrieveChunkDetails dq;

	/** @return This field is present only if the type value is equal to RAWDATA_DQ. */
	public DqRetrieveChunkDetails getDq() {
		return this.dq;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DQ. */
	public void setDq(DqRetrieveChunkDetails x) {
		this.dq = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DBMREC. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DBMREC." , required = false)
	@XmlElement(required = false)
	private DbmRecRetrieveChunkDetails dbmRec;

	/** @return This field is present only if the type value is equal to RAWDATA_DBMREC. */
	public DbmRecRetrieveChunkDetails getDbmRec() {
		return this.dbmRec;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DBMREC. */
	public void setDbmRec(DbmRecRetrieveChunkDetails x) {
		this.dbmRec = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DBMBLK." , required = false)
	@XmlElement(required = false)
	private DbmBlkRetrieveChunkDetails dbmBlk;

	/** @return This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	public DbmBlkRetrieveChunkDetails getDbmBlk() {
		return this.dbmBlk;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DBMBLK. */
	public void setDbmBlk(DbmBlkRetrieveChunkDetails x) {
		this.dbmBlk = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DBM_CHECK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DBM_CHECK." , required = false)
	@XmlElement(required = false)
	private DbmCheckRetrieveChunkDetails dbmCheck;

	/** @return This field is present only if the type value is equal to RAWDATA_DBM_CHECK. */
	public DbmCheckRetrieveChunkDetails getDbmCheck() {
		return this.dbmCheck;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DBM_CHECK. */
	public void setDbmCheck(DbmCheckRetrieveChunkDetails x) {
		this.dbmCheck = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_ENCLOSURE_STATE_CAPTURE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_ENCLOSURE_STATE_CAPTURE." , required = false)
	@XmlElement(required = false)
	private EnclosureStateCaptureRetrieveChunkDetails enclosureStateCapture;

	/** @return This field is present only if the type value is equal to RAWDATA_ENCLOSURE_STATE_CAPTURE. */
	public EnclosureStateCaptureRetrieveChunkDetails getEnclosureStateCapture() {
		return this.enclosureStateCapture;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_ENCLOSURE_STATE_CAPTURE. */
	public void setEnclosureStateCapture(EnclosureStateCaptureRetrieveChunkDetails x) {
		this.enclosureStateCapture = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DPL_CORE_DUMP_BUNDLE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DPL_CORE_DUMP_BUNDLE." , required = false)
	@XmlElement(required = false)
	private DPLCoreDumpRetrieveChunkDetails dplCoreDump;

	/** @return This field is present only if the type value is equal to RAWDATA_DPL_CORE_DUMP_BUNDLE. */
	public DPLCoreDumpRetrieveChunkDetails getDplCoreDump() {
		return this.dplCoreDump;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DPL_CORE_DUMP_BUNDLE. */
	public void setDplCoreDump(DPLCoreDumpRetrieveChunkDetails x) {
		this.dplCoreDump = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_IO_STATISTICS. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_IO_STATISTICS." , required = false)
	@XmlElement(required = false)
	private IoStatisticsRetrieveChunkDetails ioStatistics;

	/** @return This field is present only if the type value is equal to RAWDATA_IO_STATISTICS. */
	public IoStatisticsRetrieveChunkDetails getIoStatistics() {
		return this.ioStatistics;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_IO_STATISTICS. */
	public void setIoStatistics(IoStatisticsRetrieveChunkDetails x) {
		this.ioStatistics = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_FDI_DEMS_LOGS. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_FDI_DEMS_LOGS." , required = false)
	@XmlElement(required = false)
	private FdiDemsLogRetrieveChunkDetails fdiDemsLog;

	/** @return This field is present only if the type value is equal to RAWDATA_FDI_DEMS_LOGS. */
	public FdiDemsLogRetrieveChunkDetails getFdiDemsLog() {
		return this.fdiDemsLog;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_FDI_DEMS_LOGS. */
	public void setFdiDemsLog(FdiDemsLogRetrieveChunkDetails x) {
		this.fdiDemsLog = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DRIVE_PERFORMANCE_HISTORY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DRIVE_PERFORMANCE_HISTORY." , required = false)
	@XmlElement(required = false)
	private DrivePerformanceHistoryRetrieveChunkDetails drivePerformanceHistory;

	/** @return This field is present only if the type value is equal to RAWDATA_DRIVE_PERFORMANCE_HISTORY. */
	public DrivePerformanceHistoryRetrieveChunkDetails getDrivePerformanceHistory() {
		return this.drivePerformanceHistory;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DRIVE_PERFORMANCE_HISTORY. */
	public void setDrivePerformanceHistory(DrivePerformanceHistoryRetrieveChunkDetails x) {
		this.drivePerformanceHistory = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_IOC_DUMP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_IOC_DUMP." , required = false)
	@XmlElement(required = false)
	private IOCDumpRetrieveChunkDetails iocDump;

	/** @return This field is present only if the type value is equal to RAWDATA_IOC_DUMP. */
	public IOCDumpRetrieveChunkDetails getIocDump() {
		return this.iocDump;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_IOC_DUMP. */
	public void setIocDump(IOCDumpRetrieveChunkDetails x) {
		this.iocDump = x;
	}

	/** This is the case for when drive health logs are being returned in the raw data retrieve operation. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the case for when drive health logs are being returned in the raw data retrieve operation." , required = false)
	@XmlElement(required = false)
	private DriveHealthLogsChunkDetails driveHealthLogs;

	/** @return This is the case for when drive health logs are being returned in the raw data retrieve operation. */
	public DriveHealthLogsChunkDetails getDriveHealthLogs() {
		return this.driveHealthLogs;
	}
	/** @param x This is the case for when drive health logs are being returned in the raw data retrieve operation. */
	public void setDriveHealthLogs(DriveHealthLogsChunkDetails x) {
		this.driveHealthLogs = x;
	}

	@io.swagger.annotations.ApiModelProperty(value ="" , required = false)
	@XmlElement(required = false)
	private PerformanceRingChunkDetails ctrlPerfStats;

	public PerformanceRingChunkDetails getCtrlPerfStats() {
		return this.ctrlPerfStats;
	}
	public void setCtrlPerfStats(PerformanceRingChunkDetails x) {
		this.ctrlPerfStats = x;
	}

	/** This field is present only if the type value is equal to RAWDATA_DOM0_SUPPORT_DATA. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the type value is equal to RAWDATA_DOM0_SUPPORT_DATA." , required = false)
	@XmlElement(required = false)
	private Dom0SupportDataChunkDetails dom0DataChunkDetails;

	/** @return This field is present only if the type value is equal to RAWDATA_DOM0_SUPPORT_DATA. */
	public Dom0SupportDataChunkDetails getDom0DataChunkDetails() {
		return this.dom0DataChunkDetails;
	}
	/** @param x This field is present only if the type value is equal to RAWDATA_DOM0_SUPPORT_DATA. */
	public void setDom0DataChunkDetails(Dom0SupportDataChunkDetails x) {
		this.dom0DataChunkDetails = x;
	}

	/** Data passed back to host application when workload capture data is retrieved. */
	@io.swagger.annotations.ApiModelProperty(value ="Data passed back to host application when workload capture data is retrieved." , required = false)
	@XmlElement(required = false)
	private WlcAnalyticsChunkDetails wlcAnalyticsChunkDetails;

	/** @return Data passed back to host application when workload capture data is retrieved. */
	public WlcAnalyticsChunkDetails getWlcAnalyticsChunkDetails() {
		return this.wlcAnalyticsChunkDetails;
	}
	/** @param x Data passed back to host application when workload capture data is retrieved. */
	public void setWlcAnalyticsChunkDetails(WlcAnalyticsChunkDetails x) {
		this.wlcAnalyticsChunkDetails = x;
	}

	/** Auto Load Balance statistics log data returned to the reqeustor. */
	@io.swagger.annotations.ApiModelProperty(value ="Auto Load Balance statistics log data returned to the reqeustor." , required = false)
	@XmlElement(required = false)
	private AutoLoadBalanceStatsLogRetrieveChunkDetails autoLoadBalanceStatistics;

	/** @return Auto Load Balance statistics log data returned to the reqeustor. */
	public AutoLoadBalanceStatsLogRetrieveChunkDetails getAutoLoadBalanceStatistics() {
		return this.autoLoadBalanceStatistics;
	}
	/** @param x Auto Load Balance statistics log data returned to the reqeustor. */
	public void setAutoLoadBalanceStatistics(AutoLoadBalanceStatsLogRetrieveChunkDetails x) {
		this.autoLoadBalanceStatistics = x;
	}
}
