package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure defines the response that is provided by the controller to a continueRawDataRetrieve( ) request. The client is responsible for specifying incremented thisSequenceNumber values, starting with 0, for each successive chunk of data. After the client has successfully retrieved the chunk whose thisSequenceNumber value matches finalSequenceNumber, the transfer is considered complete, and the controller deletes all internal indications that the retrieval is in progress. At this point, another retrieval of the given type can be started. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1022)
public class RawDataRetrieveInfo implements Serializable {
	public RawDataRetrieveInfo() {
	}

	/** The data transfer type. */
	@io.swagger.annotations.ApiModelProperty(value ="The data transfer type." , required = true)
	@XmlElement(required = true)
	private RawDataTransferType type = RawDataTransferType.__UNDEFINED;

	/** @return The data transfer type. */
	public RawDataTransferType getType() {
		return this.type;
	}
	/** @param x The data transfer type. */
	public void setType(RawDataTransferType x) {
		this.type = x;
	}

	/** True for the last chunk of data; otherwise false. */
	@io.swagger.annotations.ApiModelProperty(value ="True for the last chunk of data; otherwise false." , required = true)
	@XmlElement(required = true)
	private boolean lastChunk;

	/** @return True for the last chunk of data; otherwise false. */
	public boolean isLastChunk() {
		return this.lastChunk;
	}
	/** @param x True for the last chunk of data; otherwise false. */
	public void setLastChunk(boolean x) {
		this.lastChunk = x;
	}

	/** The sequence number of the current chunk of data being delivered to the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The sequence number of the current chunk of data being delivered to the controller." , required = true)
	@XmlElement(required = true)
	private int thisSequenceNumber;

	/** @return The sequence number of the current chunk of data being delivered to the controller. */
	public int getThisSequenceNumber() {
		return this.thisSequenceNumber;
	}
	/** @param x The sequence number of the current chunk of data being delivered to the controller. */
	public void setThisSequenceNumber(int x) {
		this.thisSequenceNumber = x;
	}

	/** The transfer type-specific details. */
	@io.swagger.annotations.ApiModelProperty(value ="The transfer type-specific details." , required = true)
	@XmlElement(required = true)
	private RawDataRetrieveChunkDetails details;

	/** @return The transfer type-specific details. */
	public RawDataRetrieveChunkDetails getDetails() {
		return this.details;
	}
	/** @param x The transfer type-specific details. */
	public void setDetails(RawDataRetrieveChunkDetails x) {
		this.details = x;
	}

	/** This value is a number in the range of 0 to 100 indicating the percent complete. */
	@io.swagger.annotations.ApiModelProperty(value ="This value is a number in the range of 0 to 100 indicating the percent complete." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return This value is a number in the range of 0 to 100 indicating the percent complete. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x This value is a number in the range of 0 to 100 indicating the percent complete. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}
}
