package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** contains the return data for the startRawDataRetrieve procedure - a return code, and, provided that the code is RETCODE_OK, transfer type info */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(553)
public class RawDataRetrieveStartResult implements Serializable {
	public RawDataRetrieveStartResult() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The raw data transfer type. */
	@io.swagger.annotations.ApiModelProperty(value ="The raw data transfer type." , required = false)
	@XmlElement(required = false)
	private RawDataTransferType type = RawDataTransferType.__UNDEFINED;

	/** @return The raw data transfer type. */
	public RawDataTransferType getType() {
		return this.type;
	}
	/** @param x The raw data transfer type. */
	public void setType(RawDataTransferType x) {
		this.type = x;
	}
}
