package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration lists the raw data transfer types. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(194)
public enum RawDataTransferType implements Serializable {
		/** The raw data transfer type is unknown. */
		unknown(0),
		/** The raw data transfer type is Debug Queue Trace Retrieval. */
		dq(1),
		/** The raw data transfer type is DbmBlk. Whole physical blocks of data are transferred. In addition to transferring valid used data, unrelated data and/or data that has been initialized but is not yet used will also be transferred. */
		dbmblk(2),
		/** The raw data transfer type is DbmRec. Logical records are transferred rather than whole data blocks. */
		dbmrec(3),
		/** The raw data transfer type is Configure Database Validation. */
		dbmCheck(4),
		/** The raw data transfer type is for state capture from ESMs or DCMs. */
		enclosureStateCapture(5),
		/** The raw data transfer type is for a complete DPL Core Dump bundle.. This is used to request that both the full or alternate DPL core dump and DQ trace buffer should be retrieved. */
		dplCoreDumpBundle(6),
		/** The raw data transfer type is for I/O Statistics Retrieval. */
		ioStatistics(7),
		/** The raw data transfer type is FDI/DEMS. */
		fdiDemsLogs(8),
		/** The raw data transfer type is drive performance history retrieval. */
		drivePerformanceHistory(9),
		/** The raw data transfer type is for an IOC Dump. */
		iocDump(10),
		/** The raw data operation is for drive health logs. */
		driveHealthLogs(11),
		/** The raw data operation is to retrieve the controller performance logs. */
		ctrlPerfLogs(12),
		/** Used to retrieve Dom0 support data. */
		dom0SupportData(16),
		/** Enum value for workload capture as a raw data retrieve client. */
		retrieveWlcAnalytics(17),
		/** Request for AutoLoadBalancing statistics log data. */
		autoLoadBalanceStatisticsLog(18),
		__UNDEFINED(464378545);

		public final int value;

		private RawDataTransferType(int v) {
			this.value = v;
		}
}
