package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about how a recovered volume is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(844)
public class RecoverVolumeDescriptor implements Serializable {
	public RecoverVolumeDescriptor() {
	}

	/** The user assigned volume name. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned volume name." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The user assigned volume name. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The user assigned volume name. */
	public void setLabel(String x) {
		this.label = x;
	}

	/** The controller that will manage the volume. This is ignored if shared volume support is active. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller that will manage the volume. This is ignored if shared volume support is active." , required = true)
	@XmlElement(required = true)
	private String manager;

	/** @return The controller that will manage the volume. This is ignored if shared volume support is active. */
	public String getManager() {
		return this.manager;
	}
	/** @param x The controller that will manage the volume. This is ignored if shared volume support is active. */
	public void setManager(String x) {
		this.manager = x;
	}

	/** The volume capacity in megabytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume capacity in megabytes." , required = true)
	@XmlElement(required = true)
	private long capacity;

	/** @return The volume capacity in megabytes. */
	public long getCapacity() {
		return this.capacity;
	}
	/** @param x The volume capacity in megabytes. */
	public void setCapacity(long x) {
		this.capacity = x;
	}

	/** The RAID level of the potential volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The RAID level of the potential volume." , required = true)
	@XmlElement(required = true)
	private RAIDLevel raidLevel = RAIDLevel.__UNDEFINED;

	/** @return The RAID level of the potential volume. */
	public RAIDLevel getRaidLevel() {
		return this.raidLevel;
	}
	/** @param x The RAID level of the potential volume. */
	public void setRaidLevel(RAIDLevel x) {
		this.raidLevel = x;
	}

	/** The volume segment size (bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The volume segment size (bytes)." , required = true)
	@XmlElement(required = true)
	private int segmentSize;

	/** @return The volume segment size (bytes). */
	public int getSegmentSize() {
		return this.segmentSize;
	}
	/** @param x The volume segment size (bytes). */
	public void setSegmentSize(int x) {
		this.segmentSize = x;
	}

	/** A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled." , required = true)
	@XmlElement(required = true)
	private int readAhead;

	/** @return A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public int getReadAhead() {
		return this.readAhead;
	}
	/** @param x A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public void setReadAhead(int x) {
		this.readAhead = x;
	}

	/** Volume begins at this drive offset (bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="Volume begins at this drive offset (bytes)." , required = true)
	@XmlElement(required = true)
	private long offset;

	/** @return Volume begins at this drive offset (bytes). */
	public long getOffset() {
		return this.offset;
	}
	/** @param x Volume begins at this drive offset (bytes). */
	public void setOffset(long x) {
		this.offset = x;
	}

	/** The volume group number. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume group number." , required = true)
	@XmlElement(required = true)
	private int volumeGroupNumber;

	/** @return The volume group number. */
	public int getVolumeGroupNumber() {
		return this.volumeGroupNumber;
	}
	/** @param x The volume group number. */
	public void setVolumeGroupNumber(int x) {
		this.volumeGroupNumber = x;
	}

	/** The number of drives in the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of drives in the volume group." , required = true)
	@XmlElement(required = true)
	private int driveCount;

	/** @return The number of drives in the volume group. */
	public int getDriveCount() {
		return this.driveCount;
	}
	/** @param x The number of drives in the volume group. */
	public void setDriveCount(int x) {
		this.driveCount = x;
	}

	/** The list of drives to be used. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of drives to be used." , required = true)
	@XmlElement(required = true)
	private DriveRefList driveRefList;

	/** @return The list of drives to be used. */
	public DriveRefList getDriveRefList() {
		return this.driveRefList;
	}
	/** @param x The list of drives to be used. */
	public void setDriveRefList(DriveRefList x) {
		this.driveRefList = x;
	}

	/** The label to assign to the new volume group when unassigned drives are used for recovery. */
	@io.swagger.annotations.ApiModelProperty(value ="The label to assign to the new volume group when unassigned drives are used for recovery." , required = true)
	@XmlElement(required = true)
	private String volumeGroupLabel;

	/** @return The label to assign to the new volume group when unassigned drives are used for recovery. */
	public String getVolumeGroupLabel() {
		return this.volumeGroupLabel;
	}
	/** @param x The label to assign to the new volume group when unassigned drives are used for recovery. */
	public void setVolumeGroupLabel(String x) {
		this.volumeGroupLabel = x;
	}

	/** The WWN of the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the volume." , required = true)
	@XmlElement(required = true)
	private String volumeWWN;

	/** @return The WWN of the volume. */
	public String getVolumeWWN() {
		return this.volumeWWN;
	}
	/** @param x The WWN of the volume. */
	public void setVolumeWWN(String x) {
		this.volumeWWN = x;
	}

	/** The SSID of the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The SSID of the volume." , required = true)
	@XmlElement(required = true)
	private int volumeSSID;

	/** @return The SSID of the volume. */
	public int getVolumeSSID() {
		return this.volumeSSID;
	}
	/** @param x The SSID of the volume. */
	public void setVolumeSSID(int x) {
		this.volumeSSID = x;
	}

	/** True if dynamic segment sizing pre-allocation is enabled for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="True if dynamic segment sizing pre-allocation is enabled for the volume." , required = true)
	@XmlElement(required = true)
	private boolean dssPreallocEnabled;

	/** @return True if dynamic segment sizing pre-allocation is enabled for the volume. */
	public boolean isDssPreallocEnabled() {
		return this.dssPreallocEnabled;
	}
	/** @param x True if dynamic segment sizing pre-allocation is enabled for the volume. */
	public void setDssPreallocEnabled(boolean x) {
		this.dssPreallocEnabled = x;
	}

	/** The protection type of the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The protection type of the volume." , required = true)
	@XmlElement(required = true)
	private ProtectionType protectionType = ProtectionType.__UNDEFINED;

	/** @return The protection type of the volume. */
	public ProtectionType getProtectionType() {
		return this.protectionType;
	}
	/** @param x The protection type of the volume. */
	public void setProtectionType(ProtectionType x) {
		this.protectionType = x;
	}

	/** Determines whether or not reserved space is allocated on the drives in the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="Determines whether or not reserved space is allocated on the drives in the volume group." , required = true)
	@XmlElement(required = true)
	private boolean allocateReservedSpace;

	/** @return Determines whether or not reserved space is allocated on the drives in the volume group. */
	public boolean isAllocateReservedSpace() {
		return this.allocateReservedSpace;
	}
	/** @param x Determines whether or not reserved space is allocated on the drives in the volume group. */
	public void setAllocateReservedSpace(boolean x) {
		this.allocateReservedSpace = x;
	}
}
