package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a persistent registrant. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(761)
public class Registrant implements Serializable {
	public Registrant() {
	}

	/** The associated host port if mapped. */
	@io.swagger.annotations.ApiModelProperty(value ="The associated host port if mapped." , required = true)
	@XmlElement(required = true)
	private String hostPortRef;

	/** @return The associated host port if mapped. */
	public String getHostPortRef() {
		return this.hostPortRef;
	}
	/** @param x The associated host port if mapped. */
	public void setHostPortRef(String x) {
		this.hostPortRef = x;
	}

	/** The host port name if not mapped. */
	@io.swagger.annotations.ApiModelProperty(value ="The host port name if not mapped." , required = true)
	@XmlElement(required = true)
	private String hostPortName;

	/** @return The host port name if not mapped. */
	public String getHostPortName() {
		return this.hostPortName;
	}
	/** @param x The host port name if not mapped. */
	public void setHostPortName(String x) {
		this.hostPortName = x;
	}

	/** Host port reserved for this target. */
	@io.swagger.annotations.ApiModelProperty(value ="Host port reserved for this target." , required = true)
	@XmlElement(required = true)
	private ReservedPortID reservedPort = ReservedPortID.__UNDEFINED;

	/** @return Host port reserved for this target. */
	public ReservedPortID getReservedPort() {
		return this.reservedPort;
	}
	/** @param x Host port reserved for this target. */
	public void setReservedPort(ReservedPortID x) {
		this.reservedPort = x;
	}

	/** Host port registered with these targets. */
	@io.swagger.annotations.ApiModelProperty(value ="Host port registered with these targets." , required = true)
	@XmlElement(required = true)
	private RegisteredPorts registeredPorts;

	/** @return Host port registered with these targets. */
	public RegisteredPorts getRegisteredPorts() {
		return this.registeredPorts;
	}
	/** @param x Host port registered with these targets. */
	public void setRegisteredPorts(RegisteredPorts x) {
		this.registeredPorts = x;
	}
}
