package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to represent a set of connections to a remote array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(774)
public class RemoteArray implements Serializable {
	public RemoteArray() {
	}

	/** A unique identifier for this RemoteArray object. */
	@io.swagger.annotations.ApiModelProperty(value ="A unique identifier for this RemoteArray object." , required = true)
	@XmlElement(required = true)
	private String remoteArrayRef;

	/** @return A unique identifier for this RemoteArray object. */
	public String getRemoteArrayRef() {
		return this.remoteArrayRef;
	}
	/** @param x A unique identifier for this RemoteArray object. */
	public void setRemoteArrayRef(String x) {
		this.remoteArrayRef = x;
	}

	/** The storage array ID of the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The storage array ID of the remote array." , required = true)
	@XmlElement(required = true)
	private SAIdentifier saId;

	/** @return The storage array ID of the remote array. */
	public SAIdentifier getSaId() {
		return this.saId;
	}
	/** @param x The storage array ID of the remote array. */
	public void setSaId(SAIdentifier x) {
		this.saId = x;
	}

	/** One or more paths to the remote array. Note these could be differing protocols. */
	@io.swagger.annotations.ApiModelProperty(value ="One or more paths to the remote array. Note these could be differing protocols." , required = true)
	@XmlElement(required = true)
	private String[] remoteTargets;

	/** @return One or more paths to the remote array. Note these could be differing protocols. */
	public String[] getRemoteTargets() {
		return this.remoteTargets;
	}
	/** @param x One or more paths to the remote array. Note these could be differing protocols. */
	public void setRemoteTargets(String[] x) {
		this.remoteTargets = x;
	}
}
