package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the remote mirror authentication. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(466)
public class RemoteMirrorAuthenticator implements Serializable {
	public RemoteMirrorAuthenticator() {
	}

	/** The current configuration generation number of the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The current configuration generation number of the remote array." , required = true)
	@XmlElement(required = true)
	private long cfgGen;

	/** @return The current configuration generation number of the remote array. */
	public long getCfgGen() {
		return this.cfgGen;
	}
	/** @param x The current configuration generation number of the remote array. */
	public void setCfgGen(long x) {
		this.cfgGen = x;
	}

	/** SHA-1 message digest value. */
	@io.swagger.annotations.ApiModelProperty(value ="SHA-1 message digest value." , required = true)
	@XmlElement(required = true)
	private String digest;

	/** @return SHA-1 message digest value. */
	public String getDigest() {
		return this.digest;
	}
	/** @param x SHA-1 message digest value. */
	public void setDigest(String x) {
		this.digest = x;
	}
}
