package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure defines the initiator/target on the remote array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1134)
public class RemoteTarget implements Serializable {
	public RemoteTarget() {
	}

	/** Unique identifier for this initiator/target object. */
	@io.swagger.annotations.ApiModelProperty(value ="Unique identifier for this initiator/target object." , required = true)
	@XmlElement(required = true)
	private String remoteRef;

	/** @return Unique identifier for this initiator/target object. */
	public String getRemoteRef() {
		return this.remoteRef;
	}
	/** @param x Unique identifier for this initiator/target object. */
	public void setRemoteRef(String x) {
		this.remoteRef = x;
	}

	/** Node name associated with the local initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="Node name associated with the local initiator." , required = true)
	@XmlElement(required = true)
	private ScsiNodeName nodeName;

	/** @return Node name associated with the local initiator. */
	public ScsiNodeName getNodeName() {
		return this.nodeName;
	}
	/** @param x Node name associated with the local initiator. */
	public void setNodeName(ScsiNodeName x) {
		this.nodeName = x;
	}

	/** Name that can be assigned to a local initiator. Not used for FC initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="Name that can be assigned to a local initiator. Not used for FC initiator." , required = true)
	@XmlElement(required = true)
	private ScsiInitiatorTargetBaseProperties SCSIInitiatorTargetBaseProperties;

	/** @return Name that can be assigned to a local initiator. Not used for FC initiator. */
	public ScsiInitiatorTargetBaseProperties getSCSIInitiatorTargetBaseProperties() {
		return this.SCSIInitiatorTargetBaseProperties;
	}
	/** @param x Name that can be assigned to a local initiator. Not used for FC initiator. */
	public void setSCSIInitiatorTargetBaseProperties(ScsiInitiatorTargetBaseProperties x) {
		this.SCSIInitiatorTargetBaseProperties = x;
	}
}
