package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain information about a remote volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(893)
public class RemoteVolume implements Serializable {
	public RemoteVolume() {
	}

	/** The WWN of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the remote volume." , required = true)
	@XmlElement(required = true)
	private String worldWideName;

	/** @return The WWN of the remote volume. */
	public String getWorldWideName() {
		return this.worldWideName;
	}
	/** @param x The WWN of the remote volume. */
	public void setWorldWideName(String x) {
		this.worldWideName = x;
	}

	/** The identifier of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The identifier of the remote volume." , required = true)
	@XmlElement(required = true)
	private String remoteVolRef;

	/** @return The identifier of the remote volume. */
	public String getRemoteVolRef() {
		return this.remoteVolRef;
	}
	/** @param x The identifier of the remote volume. */
	public void setRemoteVolRef(String x) {
		this.remoteVolRef = x;
	}

	/** The controller that owns the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller that owns the remote volume." , required = true)
	@XmlElement(required = true)
	private String manager;

	/** @return The controller that owns the remote volume. */
	public String getManager() {
		return this.manager;
	}
	/** @param x The controller that owns the remote volume. */
	public void setManager(String x) {
		this.manager = x;
	}

	/** The identifier of the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The identifier of the remote array." , required = true)
	@XmlElement(required = true)
	private SAIdentifier remoteArrayId;

	/** @return The identifier of the remote array. */
	public SAIdentifier getRemoteArrayId() {
		return this.remoteArrayId;
	}
	/** @param x The identifier of the remote array. */
	public void setRemoteArrayId(SAIdentifier x) {
		this.remoteArrayId = x;
	}

	/** This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field." , required = true)
	@XmlElement(required = true)
	private String remoteNodeWWN;

	/** @return This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	public String getRemoteNodeWWN() {
		return this.remoteNodeWWN;
	}
	/** @param x This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	public void setRemoteNodeWWN(String x) {
		this.remoteNodeWWN = x;
	}

	/** The WWN of the volume on the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the volume on the remote array." , required = true)
	@XmlElement(required = true)
	private String remoteVolWWN;

	/** @return The WWN of the volume on the remote array. */
	public String getRemoteVolWWN() {
		return this.remoteVolWWN;
	}
	/** @param x The WWN of the volume on the remote array. */
	public void setRemoteVolWWN(String x) {
		this.remoteVolWWN = x;
	}

	/** The user assigned label of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned label of the remote volume." , required = true)
	@XmlElement(required = true)
	private String remoteVolUserLabel;

	/** @return The user assigned label of the remote volume. */
	public String getRemoteVolUserLabel() {
		return this.remoteVolUserLabel;
	}
	/** @param x The user assigned label of the remote volume. */
	public void setRemoteVolUserLabel(String x) {
		this.remoteVolUserLabel = x;
	}

	/** The state of the current remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The state of the current remote volume." , required = true)
	@XmlElement(required = true)
	private RemoteVolumeState remoteVolState = RemoteVolumeState.__UNDEFINED;

	/** @return The state of the current remote volume. */
	public RemoteVolumeState getRemoteVolState() {
		return this.remoteVolState;
	}
	/** @param x The state of the current remote volume. */
	public void setRemoteVolState(RemoteVolumeState x) {
		this.remoteVolState = x;
	}

	/** The actual capacity of the volume on the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The actual capacity of the volume on the remote array." , required = true)
	@XmlElement(required = true)
	private long remoteVolCapacity;

	/** @return The actual capacity of the volume on the remote array. */
	public long getRemoteVolCapacity() {
		return this.remoteVolCapacity;
	}
	/** @param x The actual capacity of the volume on the remote array. */
	public void setRemoteVolCapacity(long x) {
		this.remoteVolCapacity = x;
	}

	/** The SSID of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The SSID of the remote volume." , required = true)
	@XmlElement(required = true)
	private int volumeHandle;

	/** @return The SSID of the remote volume. */
	public int getVolumeHandle() {
		return this.volumeHandle;
	}
	/** @param x The SSID of the remote volume. */
	public void setVolumeHandle(int x) {
		this.volumeHandle = x;
	}

	/** The permissions of the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The permissions of the volume." , required = true)
	@XmlElement(required = true)
	private VolumePerms perms;

	/** @return The permissions of the volume. */
	public VolumePerms getPerms() {
		return this.perms;
	}
	/** @param x The permissions of the volume. */
	public void setPerms(VolumePerms x) {
		this.perms = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved1;

	/** @return Reserved */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved2;

	/** @return Reserved */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** The name of the RemoteVolume. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the RemoteVolume." , required = true)
	@XmlElement(required = true)
	private ScsiNodeName remoteNodeName;

	/** @return The name of the RemoteVolume. */
	public ScsiNodeName getRemoteNodeName() {
		return this.remoteNodeName;
	}
	/** @param x The name of the RemoteVolume. */
	public void setRemoteNodeName(ScsiNodeName x) {
		this.remoteNodeName = x;
	}

	/** The security type of the volume on the remote array. Note this may be SECURITY_TYPE_UNKNOWN if connection to remote array is down. */
	@io.swagger.annotations.ApiModelProperty(value ="The security type of the volume on the remote array. Note this may be SECURITY_TYPE_UNKNOWN if connection to remote array is down." , required = true)
	@XmlElement(required = true)
	private SecurityType remoteVolSecurityType = SecurityType.__UNDEFINED;

	/** @return The security type of the volume on the remote array. Note this may be SECURITY_TYPE_UNKNOWN if connection to remote array is down. */
	public SecurityType getRemoteVolSecurityType() {
		return this.remoteVolSecurityType;
	}
	/** @param x The security type of the volume on the remote array. Note this may be SECURITY_TYPE_UNKNOWN if connection to remote array is down. */
	public void setRemoteVolSecurityType(SecurityType x) {
		this.remoteVolSecurityType = x;
	}
}
