package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the state of the remote volume. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(108)
public enum RemoteVolumeState implements Serializable {
		/** The volume on the remote array is accessible. */
		optimal(0),
		/** Cannot access LUN on remote array. */
		noLun(1),
		/** Cannot access remote array. */
		noArray(2),
		/** Cannot connect to fabric. */
		noFabric(3),
		/** In the process of connecting to a remote array. */
		initializing(4),
		/** The WWN change failed. */
		wwnChangeFailed(5),
		__UNDEFINED(464378545);

		public final int value;

		private RemoteVolumeState(int v) {
			this.value = v;
		}
}
