package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** define the repair policy for physical components. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(799)
public class RepairPolicy implements Serializable {
	public RepairPolicy() {
	}

	/** This field contains the removal data for the component. This primary piece of data is a removal method. Additional "ready-to-remove" attributes may be defined, depending on the removal method. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the removal data for the component. This primary piece of data is a removal method. Additional \"ready-to-remove\" attributes may be defined, depending on the removal method." , required = true)
	@XmlElement(required = true)
	private ComponentRemovalData removalData;

	/** @return This field contains the removal data for the component. This primary piece of data is a removal method. Additional "ready-to-remove" attributes may be defined, depending on the removal method. */
	public ComponentRemovalData getRemovalData() {
		return this.removalData;
	}
	/** @param x This field contains the removal data for the component. This primary piece of data is a removal method. Additional "ready-to-remove" attributes may be defined, depending on the removal method. */
	public void setRemovalData(ComponentRemovalData x) {
		this.removalData = x;
	}

	/** This field defines the "replacement method" for the component. */
	@io.swagger.annotations.ApiModelProperty(value ="This field defines the \"replacement method\" for the component." , required = true)
	@XmlElement(required = true)
	private ComponentReplacementMethod replacementMethod = ComponentReplacementMethod.__UNDEFINED;

	/** @return This field defines the "replacement method" for the component. */
	public ComponentReplacementMethod getReplacementMethod() {
		return this.replacementMethod;
	}
	/** @param x This field defines the "replacement method" for the component. */
	public void setReplacementMethod(ComponentReplacementMethod x) {
		this.replacementMethod = x;
	}
}
