package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report on the utilization of the repository volumes. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(900)
public class RepositoryUtilization implements Serializable {
	public RepositoryUtilization() {
	}

	/** This field contains the number of bytes used in the repository. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the number of bytes used in the repository." , required = true)
	@XmlElement(required = true)
	private long repositoryUsage;

	/** @return This field contains the number of bytes used in the repository. */
	public long getRepositoryUsage() {
		return this.repositoryUsage;
	}
	/** @param x This field contains the number of bytes used in the repository. */
	public void setRepositoryUsage(long x) {
		this.repositoryUsage = x;
	}

	/** The snapshot volume to which this utilization refers. */
	@io.swagger.annotations.ApiModelProperty(value ="The snapshot volume to which this utilization refers." , required = true)
	@XmlElement(required = true)
	private String snapRef;

	/** @return The snapshot volume to which this utilization refers. */
	public String getSnapRef() {
		return this.snapRef;
	}
	/** @param x The snapshot volume to which this utilization refers. */
	public void setSnapRef(String x) {
		this.snapRef = x;
	}
}
