package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is returned when attempting to reserve a Customer Support Bundle lock by calling reserveSupportData. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(567)
public class ReserveSupportDataReturned implements Serializable {
	public ReserveSupportDataReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is present only if the value of returnCode is equal to RETCODE_OK. It contains the lock key to be used when later releasing the reservation. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of returnCode is equal to RETCODE_OK. It contains the lock key to be used when later releasing the reservation." , required = false)
	@XmlElement(required = false)
	private int supportDataLockKey;

	/** @return This field is present only if the value of returnCode is equal to RETCODE_OK. It contains the lock key to be used when later releasing the reservation. */
	public int getSupportDataLockKey() {
		return this.supportDataLockKey;
	}
	/** @param x This field is present only if the value of returnCode is equal to RETCODE_OK. It contains the lock key to be used when later releasing the reservation. */
	public void setSupportDataLockKey(int x) {
		this.supportDataLockKey = x;
	}

	/** This field is present only if the value of returnCode is equal to RETCODE_CSB_RESERVE_FAILED. It is an integer indicating the suggested number of seconds to wait before retrying the reserve. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of returnCode is equal to RETCODE_CSB_RESERVE_FAILED. It is an integer indicating the suggested number of seconds to wait before retrying the reserve." , required = false)
	@XmlElement(required = false)
	private int supportDataLockTimeRemaining;

	/** @return This field is present only if the value of returnCode is equal to RETCODE_CSB_RESERVE_FAILED. It is an integer indicating the suggested number of seconds to wait before retrying the reserve. */
	public int getSupportDataLockTimeRemaining() {
		return this.supportDataLockTimeRemaining;
	}
	/** @param x This field is present only if the value of returnCode is equal to RETCODE_CSB_RESERVE_FAILED. It is an integer indicating the suggested number of seconds to wait before retrying the reserve. */
	public void setSupportDataLockTimeRemaining(int x) {
		this.supportDataLockTimeRemaining = x;
	}
}
