package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration specifies the different options for the resetSAConfiguration procedure call. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(82)
public enum ResetConfigType implements Serializable {
		/** This option removes the entire configuration of the storage array, including the storage array world-wide unique identifier. This operation causes any SYMbol client connections to be dropped, making it necessary for clients to delete their connections, re-discover the array and reinstate the connections. */
		all(1),
		/** This option removes all aspects of the storage array configuration, except for those related to identification and security. Enters on board backup freeze. */
		storageArray(2),
		/** This option only removes the volume and volume group configuration, while leaving the rest of the configuration intact. Enters on board backup freeze. */
		volumeGroups(3),
		__UNDEFINED(464378545);

		public final int value;

		private ResetConfigType(int v) {
			this.value = v;
		}
}
