package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used for SYMbol procedures for state capture. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(424)
public class ReturnCodeWithOpaqueData implements Serializable {
	public ReturnCodeWithOpaqueData() {
	}

	/** The return code indication for the requested procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code indication for the requested procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code indication for the requested procedure. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code indication for the requested procedure. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The first 2MB of the data generated by the function is returned to the user. */
	@io.swagger.annotations.ApiModelProperty(value ="The first 2MB of the data generated by the function is returned to the user." , required = true)
	@XmlElement(required = true)
	private String data;

	/** @return The first 2MB of the data generated by the function is returned to the user. */
	public String getData() {
		return this.data;
	}
	/** @param x The first 2MB of the data generated by the function is returned to the user. */
	public void setData(String x) {
		this.data = x;
	}
}
