package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as a generic result type for SYMbol procedures that need to return both a success/failure indication and a SYMbol reference value. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(360)
public class ReturnCodeWithRef implements Serializable {
	public ReturnCodeWithRef() {
	}

	/** The return code indication for the requested procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code indication for the requested procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return The return code indication for the requested procedure. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x The return code indication for the requested procedure. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The SYMbol reference value associated with the operation. This is typically the reference value of a new entity that was created by the procedure, so the actual type of the reference will be one of the types that is derived directly from SYMbolRef. */
	@io.swagger.annotations.ApiModelProperty(value ="The SYMbol reference value associated with the operation. This is typically the reference value of a new entity that was created by the procedure, so the actual type of the reference will be one of the types that is derived directly from SYMbolRef." , required = true)
	@XmlElement(required = true)
	private String ref;

	/** @return The SYMbol reference value associated with the operation. This is typically the reference value of a new entity that was created by the procedure, so the actual type of the reference will be one of the types that is derived directly from SYMbolRef. */
	public String getRef() {
		return this.ref;
	}
	/** @param x The SYMbol reference value associated with the operation. This is typically the reference value of a new entity that was created by the procedure, so the actual type of the reference will be one of the types that is derived directly from SYMbolRef. */
	public void setRef(String x) {
		this.ref = x;
	}
}
