package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used for specifying the remote login capability of the controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(344)
public class RloginUpdateDescriptor implements Serializable {
	public RloginUpdateDescriptor() {
	}

	/** The intended target of this command. */
	@io.swagger.annotations.ApiModelProperty(value ="The intended target of this command." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The intended target of this command. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The intended target of this command. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** Name of Ethernet port, as reported by bootWare. */
	@io.swagger.annotations.ApiModelProperty(value ="Name of Ethernet port, as reported by bootWare." , required = true)
	@XmlElement(required = true)
	private String interfaceName;

	/** @return Name of Ethernet port, as reported by bootWare. */
	public String getInterfaceName() {
		return this.interfaceName;
	}
	/** @param x Name of Ethernet port, as reported by bootWare. */
	public void setInterfaceName(String x) {
		this.interfaceName = x;
	}

	/** The channel number of this interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number of this interface." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number of this interface. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number of this interface. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** Set if rlogin capability is desired. */
	@io.swagger.annotations.ApiModelProperty(value ="Set if rlogin capability is desired." , required = true)
	@XmlElement(required = true)
	private boolean enableRlogin;

	/** @return Set if rlogin capability is desired. */
	public boolean isEnableRlogin() {
		return this.enableRlogin;
	}
	/** @param x Set if rlogin capability is desired. */
	public void setEnableRlogin(boolean x) {
		this.enableRlogin = x;
	}
}
