package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to specify the priority of the rollback data copy process. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(139)
public enum RollbackPriority implements Serializable {
		/** The highest level of I/O activity. */
		highest(0),
		/** The next to highest level of I/O activity. */
		high(1),
		/** The medium level of I/O activity. */
		medium(2),
		/** The next to lowest level of I/O activity. */
		low(3),
		/** The lowest level of I/O activity. */
		lowest(4),
		__UNDEFINED(464378545);

		public final int value;

		private RollbackPriority(int v) {
			this.value = v;
		}
}
