package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information needed to issue a controller diagnostic test. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(334)
public class RuntimeDiagDescriptor implements Serializable {
	public RuntimeDiagDescriptor() {
	}

	/** The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error. */
	@io.swagger.annotations.ApiModelProperty(value ="The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The test or tests to run. */
	@io.swagger.annotations.ApiModelProperty(value ="The test or tests to run." , required = true)
	@XmlElement(required = true)
	private RuntimeDiagTestID runtimeDiagTestID = RuntimeDiagTestID.__UNDEFINED;

	/** @return The test or tests to run. */
	public RuntimeDiagTestID getRuntimeDiagTestID() {
		return this.runtimeDiagTestID;
	}
	/** @param x The test or tests to run. */
	public void setRuntimeDiagTestID(RuntimeDiagTestID x) {
		this.runtimeDiagTestID = x;
	}

	/** The channel to use for the loopback data test. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel to use for the loopback data test." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel to use for the loopback data test. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel to use for the loopback data test. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** TRUE, if pattern should be used on loopback data test. */
	@io.swagger.annotations.ApiModelProperty(value ="TRUE, if pattern should be used on loopback data test." , required = true)
	@XmlElement(required = true)
	private boolean usePattern;

	/** @return TRUE, if pattern should be used on loopback data test. */
	public boolean isUsePattern() {
		return this.usePattern;
	}
	/** @param x TRUE, if pattern should be used on loopback data test. */
	public void setUsePattern(boolean x) {
		this.usePattern = x;
	}

	/** The loopback data test pattern. */
	@io.swagger.annotations.ApiModelProperty(value ="The loopback data test pattern." , required = true)
	@XmlElement(required = true)
	private String pattern;

	/** @return The loopback data test pattern. */
	public String getPattern() {
		return this.pattern;
	}
	/** @param x The loopback data test pattern. */
	public void setPattern(String x) {
		this.pattern = x;
	}
}
