package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains test results for a particular test on a particular channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(425)
public class RuntimeDiagTestResults implements Serializable {
	public RuntimeDiagTestResults() {
	}

	/** Identifies the test the results are for. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the test the results are for." , required = true)
	@XmlElement(required = true)
	private RuntimeDiagTestID testID = RuntimeDiagTestID.__UNDEFINED;

	/** @return Identifies the test the results are for. */
	public RuntimeDiagTestID getTestID() {
		return this.testID;
	}
	/** @param x Identifies the test the results are for. */
	public void setTestID(RuntimeDiagTestID x) {
		this.testID = x;
	}

	/** Identifies the channel the test was run on. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the channel the test was run on." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return Identifies the channel the test was run on. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x Identifies the channel the test was run on. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** Identifies the status of the test. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the status of the test." , required = true)
	@XmlElement(required = true)
	private RuntimeDiagTestStatus testStatus = RuntimeDiagTestStatus.__UNDEFINED;

	/** @return Identifies the status of the test. */
	public RuntimeDiagTestStatus getTestStatus() {
		return this.testStatus;
	}
	/** @param x Identifies the status of the test. */
	public void setTestStatus(RuntimeDiagTestStatus x) {
		this.testStatus = x;
	}

	/** Identifies the level of the test run. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the level of the test run." , required = true)
	@XmlElement(required = true)
	private RuntimeDiagTestLevel testLevel = RuntimeDiagTestLevel.__UNDEFINED;

	/** @return Identifies the level of the test run. */
	public RuntimeDiagTestLevel getTestLevel() {
		return this.testLevel;
	}
	/** @param x Identifies the level of the test run. */
	public void setTestLevel(RuntimeDiagTestLevel x) {
		this.testLevel = x;
	}
}
