package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes a controller-resident I/O port used to access the storage array via the I/O path. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(879)
public class SAPort implements Serializable {
	public SAPort() {
	}

	/** This object uniquely identifies an SAPort. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies an SAPort." , required = true)
	@XmlElement(required = true)
	private String saPortRef;

	/** @return This object uniquely identifies an SAPort. */
	public String getSaPortRef() {
		return this.saPortRef;
	}
	/** @param x This object uniquely identifies an SAPort. */
	public void setSaPortRef(String x) {
		this.saPortRef = x;
	}

	/** This object uniquely identifies an SAPortGroup. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies an SAPortGroup." , required = true)
	@XmlElement(required = true)
	private String saPortGroupRef;

	/** @return This object uniquely identifies an SAPortGroup. */
	public String getSaPortGroupRef() {
		return this.saPortGroupRef;
	}
	/** @param x This object uniquely identifies an SAPortGroup. */
	public void setSaPortGroupRef(String x) {
		this.saPortGroupRef = x;
	}

	/** The reference value of the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value of the controller." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The reference value of the controller. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The reference value of the controller. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The host-side I/O port identifier of the port on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The host-side I/O port identifier of the port on the controller." , required = true)
	@XmlElement(required = true)
	private int portId;

	/** @return The host-side I/O port identifier of the port on the controller. */
	public int getPortId() {
		return this.portId;
	}
	/** @param x The host-side I/O port identifier of the port on the controller. */
	public void setPortId(int x) {
		this.portId = x;
	}
}
