package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides argument values for the getSAPort procedure, which is used to inquire about the SAPort object associated with a particular controller and host-side I/O port combination. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(607)
public class SAPortGetDescriptor implements Serializable {
	public SAPortGetDescriptor() {
	}

	/** The reference value of the controller whose port identifier is needed. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value of the controller whose port identifier is needed." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return The reference value of the controller whose port identifier is needed. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x The reference value of the controller whose port identifier is needed. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The host-side I/O port identifier of the port on the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The host-side I/O port identifier of the port on the controller." , required = true)
	@XmlElement(required = true)
	private int portId;

	/** @return The host-side I/O port identifier of the port on the controller. */
	public int getPortId() {
		return this.portId;
	}
	/** @param x The host-side I/O port identifier of the port on the controller. */
	public void setPortId(int x) {
		this.portId = x;
	}
}
