package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a Serial ATA interface on a controller board. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(975)
public class SATAInterface implements Serializable,devmgr.api.model.Identifiable {
	public SATAInterface() {
	}

	/** The channel number of this channel */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number of this channel" , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number of this channel */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number of this channel */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The current interface speed of the SATA interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The current interface speed of the SATA interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed currentInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The current interface speed of the SATA interface. */
	public InterfaceSpeed getCurrentInterfaceSpeed() {
		return this.currentInterfaceSpeed;
	}
	/** @param x The current interface speed of the SATA interface. */
	public void setCurrentInterfaceSpeed(InterfaceSpeed x) {
		this.currentInterfaceSpeed = x;
	}

	/** The maximum interface speed of the SATA interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum interface speed of the SATA interface." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed maximumInterfaceSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The maximum interface speed of the SATA interface. */
	public InterfaceSpeed getMaximumInterfaceSpeed() {
		return this.maximumInterfaceSpeed;
	}
	/** @param x The maximum interface speed of the SATA interface. */
	public void setMaximumInterfaceSpeed(InterfaceSpeed x) {
		this.maximumInterfaceSpeed = x;
	}

	/** An indicator of how the device speed is controlled. */
	@io.swagger.annotations.ApiModelProperty(value ="An indicator of how the device speed is controlled." , required = true)
	@XmlElement(required = true)
	private SpeedControl speedControl = SpeedControl.__UNDEFINED;

	/** @return An indicator of how the device speed is controlled. */
	public SpeedControl getSpeedControl() {
		return this.speedControl;
	}
	/** @param x An indicator of how the device speed is controlled. */
	public void setSpeedControl(SpeedControl x) {
		this.speedControl = x;
	}

	/** A string indicating the chip type. */
	@io.swagger.annotations.ApiModelProperty(value ="A string indicating the chip type." , required = true)
	@XmlElement(required = true)
	private String part;

	/** @return A string indicating the chip type. */
	public String getPart() {
		return this.part;
	}
	/** @param x A string indicating the chip type. */
	public void setPart(String x) {
		this.part = x;
	}

	/** The revision level of the SATA part. */
	@io.swagger.annotations.ApiModelProperty(value ="The revision level of the SATA part." , required = true)
	@XmlElement(required = true)
	private int revision;

	/** @return The revision level of the SATA part. */
	public int getRevision() {
		return this.revision;
	}
	/** @param x The revision level of the SATA part. */
	public void setRevision(int x) {
		this.revision = x;
	}

	/** The unique identifier for a given instance of this structure. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for a given instance of this structure." , required = true)
	@XmlElement(required = true)
	private String interfaceRef;

	/** @return The unique identifier for a given instance of this structure. */
	public String getInterfaceRef() {
		return this.interfaceRef;
	}
	/** @param x The unique identifier for a given instance of this structure. */
	public void setInterfaceRef(String x) {
		this.interfaceRef = x;
	}

	/** The physical location of the SATA interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st SATA interface relative to the parent," "2nd SATA interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the SATA interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying \"1st SATA interface relative to the parent,\" \"2nd SATA interface relative to the parent,\" etc. This \"interface number\" is independent of the interface's channel association." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the SATA interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st SATA interface relative to the parent," "2nd SATA interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the SATA interface. The parent reference in Location identifies the physical component (e.g., controller or host card) where the interface circuitry is located, and the position field is a firmware-assigned 1-relative number signifying "1st SATA interface relative to the parent," "2nd SATA interface relative to the parent," etc. This "interface number" is independent of the interface's channel association. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** This field indicates whether or not the I/O interface is PI capable. */
	@io.swagger.annotations.ApiModelProperty(value ="This field indicates whether or not the I/O interface is PI capable." , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	/** @return This field indicates whether or not the I/O interface is PI capable. */
	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	/** @param x This field indicates whether or not the I/O interface is PI capable. */
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}
	@Override
	public String getId(){
		return interfaceRef;
	}
}
