package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a drive's I/O address. It is used for SCSI drive types only. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(436)
public class SCSIDriveAddress implements Serializable {
	public SCSIDriveAddress() {
	}

	/** The controller drive-side SCSI channel on which the drive resides. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller drive-side SCSI channel on which the drive resides." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The controller drive-side SCSI channel on which the drive resides. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The controller drive-side SCSI channel on which the drive resides. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The drive's SCSI ID value. */
	@io.swagger.annotations.ApiModelProperty(value ="The drive's SCSI ID value." , required = true)
	@XmlElement(required = true)
	private int id;

	/** @return The drive's SCSI ID value. */
	public int getId() {
		return this.id;
	}
	/** @param x The drive's SCSI ID value. */
	public void setId(int x) {
		this.id = x;
	}
}
