package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the different SCSI driver types that may be reported as part of the I/O interface information associated with a controller. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(217)
public enum SCSIDriverType implements Serializable {
		/** Single-ended SCSI driver type. */
		se(1),
		/** High-voltage differential SCSI driver type. */
		hvd(2),
		/** Low-voltage differential SCSI driver type. */
		lvd(3),
		__UNDEFINED(464378545);

		public final int value;

		private SCSIDriverType(int v) {
			this.value = v;
		}
}
