package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to determine the parent type of a SFP and present data specific to that type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(821)
public class SFPParentTypeData implements Serializable {
	public SFPParentTypeData() {
	}

	/** This enumeration object is used to describe the parent type of a SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to describe the parent type of a SFP." , required = true)
	@XmlElement(required = true)
	private SFPParentType sfpParentType = SFPParentType.__UNDEFINED;

	/** @return This enumeration object is used to describe the parent type of a SFP. */
	public SFPParentType getSfpParentType() {
		return this.sfpParentType;
	}
	/** @param x This enumeration object is used to describe the parent type of a SFP. */
	public void setSfpParentType(SFPParentType x) {
		this.sfpParentType = x;
	}

	/** This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_CONTROLLER. It contains the parent type of a SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_CONTROLLER. It contains the parent type of a SFP." , required = false)
	@XmlElement(required = false)
	private ControllerSFP controllerSFP;

	/** @return This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_CONTROLLER. It contains the parent type of a SFP. */
	public ControllerSFP getControllerSFP() {
		return this.controllerSFP;
	}
	/** @param x This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_CONTROLLER. It contains the parent type of a SFP. */
	public void setControllerSFP(ControllerSFP x) {
		this.controllerSFP = x;
	}

	/** No information is returned */
	@io.swagger.annotations.ApiModelProperty(value ="No information is returned" , required = false)
	@XmlElement(required = false)
	private String parentEsm;

	/** @return No information is returned */
	public String getParentEsm() {
		return this.parentEsm;
	}
	/** @param x No information is returned */
	public void setParentEsm(String x) {
		this.parentEsm = x;
	}

	/** This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_MINIHUB. It contains the parent type of a SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_MINIHUB. It contains the parent type of a SFP." , required = false)
	@XmlElement(required = false)
	private String parentMinihub;

	/** @return This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_MINIHUB. It contains the parent type of a SFP. */
	public String getParentMinihub() {
		return this.parentMinihub;
	}
	/** @param x This field is present only if the sfpParentType is equal to SFP_PARENT_TYPE_MINIHUB. It contains the parent type of a SFP. */
	public void setParentMinihub(String x) {
		this.parentMinihub = x;
	}
}
