package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the status of the SFP component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(178)
public enum SFPStatus implements Serializable {
		/** The SFP is working correctly. */
		optimal(1),
		/** The SFP is not working or not present. */
		failed(2),
		/** The SFP has been removed or is missing. */
		removed(3),
		/** The status of the SFP is unknown. */
		unknown(4),
		__UNDEFINED(464378545);

		public final int value;

		private SFPStatus(int v) {
			this.value = v;
		}
}
