package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the connector type of SFP component as per SFF-8436 Specification for QSFP+ 10 Gbs 4X PLUGGABLE TRANSCEIVER Rev 4.3 July 7, 2012, Table "Connector Values". */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(9)
public enum SFP_CONNECT_TYPE implements Serializable {
		/** SFP connector type unknown. */
		unknown(0),
		/** SFP connector type SC. */
		sc(1),
		/** The SFP connect type is FCS1CC */
		fcs1cc(2),
		/** The SFP connect type is FCS2CC */
		fcs2cc(3),
		/** The SFP connect type is BNC or TNC. */
		bncortnc(4),
		/** The SFP connect type is FC COAX. */
		fcCoax(5),
		/** The SFT connect type is F JACK. */
		fJack(6),
		/** The SFP connect type is LC */
		lc(7),
		/** The SFP connect type is MT RJ. */
		mtRj(8),
		/** The SFP connect type is MU. */
		mu(9),
		/** The SFP connect type is SG. */
		sg(10),
		/** The SFP connect type is OPT PIGTAIL. */
		optPigtail(11),
		/** The SFP connect type is HSSDCII */
		hssdcii(12),
		/** The SFP connect type is COP PIGTAIL. */
		copPigtail(13),
		/** The SFP connect type is RJ45. */
		rj45(14),
		/** The current SFP type does not have a separable connector. */
		noSeparableConnector(15),
		__UNDEFINED(464378545);

		public final int value;

		private SFP_CONNECT_TYPE(int v) {
			this.value = v;
		}
}
