package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the Fibre Channel Link Length. See SFF-8436 Specification for QSFP+ 10 Gbs 4X PLUGGABLE TRANCEIVER Rev 4.3 July 7, 2012 Table "Table 33 - Specification compliance (Address 131-138) (Page 00), "Fibre Channel Link Length/Transmitter Technology". */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(204)
public enum SFP_LINKL_TYPE implements Serializable {
		/** Link Length unknown. */
		typeUnknown(0),
		/** Link Length Very Long. */
		typeVlong(1),
		/** Link Length Short. */
		typeShort(2),
		/** Link Length Intermediate. */
		typeIntermediate(3),
		/** Link Length Long. */
		typeLong(4),
		/** Link length medium. */
		typeMedium(5),
		/** For the current SFP Type, the concept of a Link Length is not applicable. MSW will not show a link length. */
		typeNa(6),
		__UNDEFINED(464378545);

		public final int value;

		private SFP_LINKL_TYPE(int v) {
			this.value = v;
		}
}
