package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the transmission media of SFP component. This is a bit field as more than one can be true simultaneously. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(207)
public enum SFP_TRANSMISSION_MEDIA implements Serializable {
		/** Unknown. */
		unknown(0),
		/** Twin Axial Pair. */
		twinAxialPair(1),
		/** Shielded Twisted Pair. */
		tmShieldedTwistedPair(2),
		/** TM Miniature Coax. */
		tmMiniatureCoax(4),
		/** TM Video Coax. */
		tmVideoCoax(8),
		/** TM Multi-mode 62.5m(M6). */
		tmMultiModeM6(16),
		/** TM Multi-mode 50m(M5). */
		tmMultiModeM5(32),
		/** Single Mode. */
		tmSingleMode(64),
		/** For the current SFP type the concept of a transmission media type is not applicable. MSW will not show a transmission media type. */
		na(128),
		__UNDEFINED(464378545);

		public final int value;

		private SFP_TRANSMISSION_MEDIA(int v) {
			this.value = v;
		}
}
