package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the Fibre Channel Transmitter Technology. See SFF-8436 Specification for QSFP+ 10 Gbs 4X PLUGGABLE TRANSCEIVER Rev 4.3 July 7, 2012 Table "Table 33 - Specification compliance (Address 131-138) (Page 00), "Fibre Channel Link Length/Transmitter Technology". */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(146)
public enum SFP_TRANSMITTER_TYPE implements Serializable {
		/** Unknown transmitter type. */
		unknown(0),
		/** Long wave laser. */
		lwlLc(1),
		/** Electrical Inter-Enclosure. */
		eiee(2),
		/** Electrical Intra-Enclosure. */
		eiae(3),
		/** ShortWave Laser without OFC. */
		swlwoofc(4),
		/** ShortWave Laser with OFC. */
		swlwofc(5),
		/** LongWave Laser. */
		lwlLl(6),
		/** Not applicable for non-Fibre Channel SFPs. */
		na(7),
		__UNDEFINED(464378545);

		public final int value;

		private SFP_TRANSMITTER_TYPE(int v) {
			this.value = v;
		}
}
