package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe a configured SNMP community. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(616)
public class SNMPCommunity implements Serializable {
	public SNMPCommunity() {
	}

	/** A reference to the SNMP community. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the SNMP community." , required = true)
	@XmlElement(required = true)
	private String communityRef;

	/** @return A reference to the SNMP community. */
	public String getCommunityRef() {
		return this.communityRef;
	}
	/** @param x A reference to the SNMP community. */
	public void setCommunityRef(String x) {
		this.communityRef = x;
	}

	/** Community name */
	@io.swagger.annotations.ApiModelProperty(value ="Community name" , required = true)
	@XmlElement(required = true)
	private String communityName;

	/** @return Community name */
	public String getCommunityName() {
		return this.communityName;
	}
	/** @param x Community name */
	public void setCommunityName(String x) {
		this.communityName = x;
	}

	/** Community permissions */
	@io.swagger.annotations.ApiModelProperty(value ="Community permissions" , required = true)
	@XmlElement(required = true)
	private SNMPCommunityPermissions communityPermissions = SNMPCommunityPermissions.__UNDEFINED;

	/** @return Community permissions */
	public SNMPCommunityPermissions getCommunityPermissions() {
		return this.communityPermissions;
	}
	/** @param x Community permissions */
	public void setCommunityPermissions(SNMPCommunityPermissions x) {
		this.communityPermissions = x;
	}
}
