package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the SNMP community permissions. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(93)
public enum SNMPCommunityPermissions implements Serializable {
		/** The community permissions are unknown. */
		unknown(0),
		/** The community permissions are read only. */
		readOnly(1),
		/** The community permissions are read/write. Note that although the notion of a read-write permission exists, the controller does not support SNMP SET operations so effectively everything is read-only. */
		readWrite(2),
		__UNDEFINED(464378545);

		public final int value;

		private SNMPCommunityPermissions(int v) {
			this.value = v;
		}
}
