package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union represents the value for one specific SNMP system variable. Multiple instances of this union can be passed into the updateSNMPSystemVariable procedure via the SNMPSystemVariablesUpdateDescriptor. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(534)
public class SNMPSystemVariableValue implements Serializable {
	public SNMPSystemVariableValue() {
	}

	/** This enumeration represents possible SNMP system variables that can be set via SYMbol. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration represents possible SNMP system variables that can be set via SYMbol." , required = true)
	@XmlElement(required = true)
	private SNMPSystemVariableID variable = SNMPSystemVariableID.__UNDEFINED;

	/** @return This enumeration represents possible SNMP system variables that can be set via SYMbol. */
	public SNMPSystemVariableID getVariable() {
		return this.variable;
	}
	/** @param x This enumeration represents possible SNMP system variables that can be set via SYMbol. */
	public void setVariable(SNMPSystemVariableID x) {
		this.variable = x;
	}

	/** This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME." , required = false)
	@XmlElement(required = false)
	private String newSysName;

	/** @return This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME. */
	public String getNewSysName() {
		return this.newSysName;
	}
	/** @param x This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME. */
	public void setNewSysName(String x) {
		this.newSysName = x;
	}

	/** This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT." , required = false)
	@XmlElement(required = false)
	private String newSysContact;

	/** @return This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT. */
	public String getNewSysContact() {
		return this.newSysContact;
	}
	/** @param x This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT. */
	public void setNewSysContact(String x) {
		this.newSysContact = x;
	}

	/** This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION." , required = false)
	@XmlElement(required = false)
	private String newSysLocation;

	/** @return This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION. */
	public String getNewSysLocation() {
		return this.newSysLocation;
	}
	/** @param x This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION. */
	public void setNewSysLocation(String x) {
		this.newSysLocation = x;
	}
}
