package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Internal Message Description sent from the WebService Proxy. Indicates that external access to the SYMbol server has been enabled/disabled */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(392)
public class SYMbolAccessChangeDesc implements Serializable {
	public SYMbolAccessChangeDesc() {
	}

	/** If false, external access to the SYMbol server has been disabled, if true the server is still accessible */
	@io.swagger.annotations.ApiModelProperty(value ="If false, external access to the SYMbol server has been disabled, if true the server is still accessible" , required = true)
	@XmlElement(required = true)
	private boolean isEnabled;

	/** @return If false, external access to the SYMbol server has been disabled, if true the server is still accessible */
	public boolean isIsEnabled() {
		return this.isEnabled;
	}
	/** @param x If false, external access to the SYMbol server has been disabled, if true the server is still accessible */
	public void setIsEnabled(boolean x) {
		this.isEnabled = x;
	}
}
