package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes the authentication information that must accompany SYMbol requests to change the state of an array when the authentication flavor corresponds to AUTH_SYMBOL_HMAC256. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(973)
public class SYMbolAuthenticationHMAC256 implements Serializable {
	public SYMbolAuthenticationHMAC256() {
	}

	/** Client system's IP address. */
	@io.swagger.annotations.ApiModelProperty(value ="Client system's IP address." , required = true)
	@XmlElement(required = true)
	private IpVxAddress clientIp;

	/** @return Client system's IP address. */
	public IpVxAddress getClientIp() {
		return this.clientIp;
	}
	/** @param x Client system's IP address. */
	public void setClientIp(IpVxAddress x) {
		this.clientIp = x;
	}

	/** Storage array unique identifier. */
	@io.swagger.annotations.ApiModelProperty(value ="Storage array unique identifier." , required = true)
	@XmlElement(required = true)
	private SAIdentifier arrayId;

	/** @return Storage array unique identifier. */
	public SAIdentifier getArrayId() {
		return this.arrayId;
	}
	/** @param x Storage array unique identifier. */
	public void setArrayId(SAIdentifier x) {
		this.arrayId = x;
	}

	/** Current configuration generation number */
	@io.swagger.annotations.ApiModelProperty(value ="Current configuration generation number" , required = true)
	@XmlElement(required = true)
	private long configGeneration;

	/** @return Current configuration generation number */
	public long getConfigGeneration() {
		return this.configGeneration;
	}
	/** @param x Current configuration generation number */
	public void setConfigGeneration(long x) {
		this.configGeneration = x;
	}

	/** Message digest value */
	@io.swagger.annotations.ApiModelProperty(value ="Message digest value" , required = true)
	@XmlElement(required = true)
	private String digest;

	/** @return Message digest value */
	public String getDigest() {
		return this.digest;
	}
	/** @param x Message digest value */
	public void setDigest(String x) {
		this.digest = x;
	}
}
