package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used in cases where a SYMbol procedure must operate on a both a SYMbolRef and a user-assigned label value. It is typically used for SYMbol procedures that rename objects. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(355)
public class SYMbolRefWithUAL implements Serializable {
	public SYMbolRefWithUAL() {
	}

	/** The SYMbol reference value of the object on which the operation is to be performed. */
	@io.swagger.annotations.ApiModelProperty(value ="The SYMbol reference value of the object on which the operation is to be performed." , required = true)
	@XmlElement(required = true)
	private String ref;

	/** @return The SYMbol reference value of the object on which the operation is to be performed. */
	public String getRef() {
		return this.ref;
	}
	/** @param x The SYMbol reference value of the object on which the operation is to be performed. */
	public void setRef(String x) {
		this.ref = x;
	}

	/** The user-assigned label (typically a modified one) for the object in question. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned label (typically a modified one) for the object in question." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The user-assigned label (typically a modified one) for the object in question. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The user-assigned label (typically a modified one) for the object in question. */
	public void setLabel(String x) {
		this.label = x;
	}
}
