package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a device attached to a SAS port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1156)
public class SasAttachedDevice implements Serializable {
	public SasAttachedDevice() {
	}

	/** The number of the channel where the SAS-attached device is located. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the channel where the SAS-attached device is located." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The number of the channel where the SAS-attached device is located. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The number of the channel where the SAS-attached device is located. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** An indication of which "side" the channel is on - host or drive. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of which \"side\" the channel is on - host or drive." , required = true)
	@XmlElement(required = true)
	private ChannelType channelType = ChannelType.__UNDEFINED;

	/** @return An indication of which "side" the channel is on - host or drive. */
	public ChannelType getChannelType() {
		return this.channelType;
	}
	/** @param x An indication of which "side" the channel is on - host or drive. */
	public void setChannelType(ChannelType x) {
		this.channelType = x;
	}

	/** This field contains information that explicitly identifies the SAS-attached device. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains information that explicitly identifies the SAS-attached device." , required = true)
	@XmlElement(required = true)
	private SasAttachedDeviceTypeData sasAttachedDeviceData;

	/** @return This field contains information that explicitly identifies the SAS-attached device. */
	public SasAttachedDeviceTypeData getSasAttachedDeviceData() {
		return this.sasAttachedDeviceData;
	}
	/** @param x This field contains information that explicitly identifies the SAS-attached device. */
	public void setSasAttachedDeviceData(SasAttachedDeviceTypeData x) {
		this.sasAttachedDeviceData = x;
	}
}
