package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains information about a device attached to a SAS port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1050)
public class SasAttachedDeviceTypeData implements Serializable {
	public SasAttachedDeviceTypeData() {
	}

	/** This enumeration specifies the different kinds of devices that may be attached to a SAS port. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration specifies the different kinds of devices that may be attached to a SAS port." , required = true)
	@XmlElement(required = true)
	private SasAttachedDeviceType type = SasAttachedDeviceType.__UNDEFINED;

	/** @return This enumeration specifies the different kinds of devices that may be attached to a SAS port. */
	public SasAttachedDeviceType getType() {
		return this.type;
	}
	/** @param x This enumeration specifies the different kinds of devices that may be attached to a SAS port. */
	public void setType(SasAttachedDeviceType x) {
		this.type = x;
	}

	/** A reference to the alternate controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_ALTERNATE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the alternate controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_ALTERNATE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String alternateController;

	/** @return A reference to the alternate controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_ALTERNATE_CONTROLLER. */
	public String getAlternateController() {
		return this.alternateController;
	}
	/** @param x A reference to the alternate controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_ALTERNATE_CONTROLLER. */
	public void setAlternateController(String x) {
		this.alternateController = x;
	}

	/** A reference to a drive that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_DRIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to a drive that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_DRIVE." , required = false)
	@XmlElement(required = false)
	private String drive;

	/** @return A reference to a drive that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_DRIVE. */
	public String getDrive() {
		return this.drive;
	}
	/** @param x A reference to a drive that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_DRIVE. */
	public void setDrive(String x) {
		this.drive = x;
	}

	/** A reference to the SAS expander that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_EXPANDER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the SAS expander that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_EXPANDER." , required = false)
	@XmlElement(required = false)
	private String expander;

	/** @return A reference to the SAS expander that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_EXPANDER. */
	public String getExpander() {
		return this.expander;
	}
	/** @param x A reference to the SAS expander that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_EXPANDER. */
	public void setExpander(String x) {
		this.expander = x;
	}

	/** The SAS address of the port in the host computer that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_HOST. */
	@io.swagger.annotations.ApiModelProperty(value ="The SAS address of the port in the host computer that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_HOST." , required = false)
	@XmlElement(required = false)
	private String remoteHostPortAddress;

	/** @return The SAS address of the port in the host computer that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_HOST. */
	public String getRemoteHostPortAddress() {
		return this.remoteHostPortAddress;
	}
	/** @param x The SAS address of the port in the host computer that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_HOST. */
	public void setRemoteHostPortAddress(String x) {
		this.remoteHostPortAddress = x;
	}

	/** A reference to the local controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_LOCAL_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the local controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_LOCAL_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String localController;

	/** @return A reference to the local controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_LOCAL_CONTROLLER. */
	public String getLocalController() {
		return this.localController;
	}
	/** @param x A reference to the local controller that is the attached device. This field is only present if type equals SAS_ATTACHED_DEV_LOCAL_CONTROLLER. */
	public void setLocalController(String x) {
		this.localController = x;
	}

	/** The tray-slot location of a device of unknown type. This field is only present if type equals SAS_ATTACHED_DEV_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray-slot location of a device of unknown type. This field is only present if type equals SAS_ATTACHED_DEV_UNKNOWN." , required = false)
	@XmlElement(required = false)
	private Location physicalLocation;

	/** @return The tray-slot location of a device of unknown type. This field is only present if type equals SAS_ATTACHED_DEV_UNKNOWN. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The tray-slot location of a device of unknown type. This field is only present if type equals SAS_ATTACHED_DEV_UNKNOWN. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}
}
