package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains port-specific addressing information for a drive which uses the serial-attached SCSI I/O protocol. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(522)
public class SasDrivePortAddress implements Serializable {
	public SasDrivePortAddress() {
	}

	/** The number of the channel where the drive port is located. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the channel where the drive port is located." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The number of the channel where the drive port is located. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The number of the channel where the drive port is located. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The SAS address of the drive port. */
	@io.swagger.annotations.ApiModelProperty(value ="The SAS address of the drive port." , required = true)
	@XmlElement(required = true)
	private String portIdentifier;

	/** @return The SAS address of the drive port. */
	public String getPortIdentifier() {
		return this.portIdentifier;
	}
	/** @param x The SAS address of the drive port. */
	public void setPortIdentifier(String x) {
		this.portIdentifier = x;
	}
}
