package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a SAS expander. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1181)
public class SasExpander implements Serializable,devmgr.api.model.Identifiable {
	public SasExpander() {
	}

	/** The reference value that uniquely identifies the SAS expander. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that uniquely identifies the SAS expander." , required = true)
	@XmlElement(required = true)
	private String expanderRef;

	/** @return The reference value that uniquely identifies the SAS expander. */
	public String getExpanderRef() {
		return this.expanderRef;
	}
	/** @param x The reference value that uniquely identifies the SAS expander. */
	public void setExpanderRef(String x) {
		this.expanderRef = x;
	}

	/** The reference value that uniquely identifies the parent (controller or ESM) of the SAS expander. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that uniquely identifies the parent (controller or ESM) of the SAS expander." , required = true)
	@XmlElement(required = true)
	private SasExpanderParent parent;

	/** @return The reference value that uniquely identifies the parent (controller or ESM) of the SAS expander. */
	public SasExpanderParent getParent() {
		return this.parent;
	}
	/** @param x The reference value that uniquely identifies the parent (controller or ESM) of the SAS expander. */
	public void setParent(SasExpanderParent x) {
		this.parent = x;
	}

	/** The drive channel location of the expander */
	@io.swagger.annotations.ApiModelProperty(value ="The drive channel location of the expander" , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The drive channel location of the expander */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The drive channel location of the expander */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** The SAS address that is the expander device name */
	@io.swagger.annotations.ApiModelProperty(value ="The SAS address that is the expander device name" , required = true)
	@XmlElement(required = true)
	private String deviceName;

	/** @return The SAS address that is the expander device name */
	public String getDeviceName() {
		return this.deviceName;
	}
	/** @param x The SAS address that is the expander device name */
	public void setDeviceName(String x) {
		this.deviceName = x;
	}

	/** The Inquiry vendor identification string for the SAS expander. */
	@io.swagger.annotations.ApiModelProperty(value ="The Inquiry vendor identification string for the SAS expander." , required = true)
	@XmlElement(required = true)
	private String vendorId;

	/** @return The Inquiry vendor identification string for the SAS expander. */
	public String getVendorId() {
		return this.vendorId;
	}
	/** @param x The Inquiry vendor identification string for the SAS expander. */
	public void setVendorId(String x) {
		this.vendorId = x;
	}

	/** The Inquiry product identification string for the SAS expander. */
	@io.swagger.annotations.ApiModelProperty(value ="The Inquiry product identification string for the SAS expander." , required = true)
	@XmlElement(required = true)
	private String productId;

	/** @return The Inquiry product identification string for the SAS expander. */
	public String getProductId() {
		return this.productId;
	}
	/** @param x The Inquiry product identification string for the SAS expander. */
	public void setProductId(String x) {
		this.productId = x;
	}

	/** The version of the firmware on the SAS expander. */
	@io.swagger.annotations.ApiModelProperty(value ="The version of the firmware on the SAS expander." , required = true)
	@XmlElement(required = true)
	private String fwVersion;

	/** @return The version of the firmware on the SAS expander. */
	public String getFwVersion() {
		return this.fwVersion;
	}
	/** @param x The version of the firmware on the SAS expander. */
	public void setFwVersion(String x) {
		this.fwVersion = x;
	}

	/** List of ports that are part of this expander. */
	@io.swagger.annotations.ApiModelProperty(value ="List of ports that are part of this expander." , required = true)
	@XmlElement(required = true)
	private SasPort[] expanderPorts;

	/** @return List of ports that are part of this expander. */
	public SasPort[] getExpanderPorts() {
		return this.expanderPorts;
	}
	/** @param x List of ports that are part of this expander. */
	public void setExpanderPorts(SasPort[] x) {
		this.expanderPorts = x;
	}

	/** The domain number identifies which SAS domain this element is a part of. Domain numbers are arbitrarily assigned by the firmware and are consistent on a per controller basis -- but not across controllers. So, the contents of domains will be consistent across controllers but the number identifying a particular domain may not be. */
	@io.swagger.annotations.ApiModelProperty(value ="The domain number identifies which SAS domain this element is a part of. Domain numbers are arbitrarily assigned by the firmware and are consistent on a per controller basis -- but not across controllers. So, the contents of domains will be consistent across controllers but the number identifying a particular domain may not be." , required = true)
	@XmlElement(required = true)
	private int domainNumber;

	/** @return The domain number identifies which SAS domain this element is a part of. Domain numbers are arbitrarily assigned by the firmware and are consistent on a per controller basis -- but not across controllers. So, the contents of domains will be consistent across controllers but the number identifying a particular domain may not be. */
	public int getDomainNumber() {
		return this.domainNumber;
	}
	/** @param x The domain number identifies which SAS domain this element is a part of. Domain numbers are arbitrarily assigned by the firmware and are consistent on a per controller basis -- but not across controllers. So, the contents of domains will be consistent across controllers but the number identifying a particular domain may not be. */
	public void setDomainNumber(int x) {
		this.domainNumber = x;
	}
	@Override
	public String getId(){
		return expanderRef;
	}
}
