package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is an enumeration defining the different types of SAS miswires. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(122)
public enum SasMiswireType implements Serializable {
		/** No miswire condition exists. */
		none(0),
		/** The miswire resulted in an invalid SAS topology. */
		topology(1),
		/** The miswire is a result of cabling a controller host port to an expansion drive tray. */
		ctlrHostPort(2),
		/** The miswire is a result of cabling a port on a host computer to a drive expansion port on the controller tray. */
		ctlrDrivePortToHost(3),
		/** The miswire is a result of the cabling together of the two ESMs in a drive tray. */
		esm(4),
		/** The miswire is a result of cabling a port on an end device to a drive expansion port on the controller tray. */
		ctlrDrivePortToEndDevice(5),
		__UNDEFINED(464378545);

		public final int value;

		private SasMiswireType(int v) {
			this.value = v;
		}
}
