package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a PHY that is part of a SAS port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(296)
public class SasPhy implements Serializable {
	public SasPhy() {
	}

	/** A number in the range 0-127 that is the PHY identifier. */
	@io.swagger.annotations.ApiModelProperty(value ="A number in the range 0-127 that is the PHY identifier." , required = true)
	@XmlElement(required = true)
	private int phyIdentifier;

	/** @return A number in the range 0-127 that is the PHY identifier. */
	public int getPhyIdentifier() {
		return this.phyIdentifier;
	}
	/** @param x A number in the range 0-127 that is the PHY identifier. */
	public void setPhyIdentifier(int x) {
		this.phyIdentifier = x;
	}

	/** True if the PHY is capable of normal operation. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the PHY is capable of normal operation." , required = true)
	@XmlElement(required = true)
	private boolean isOperational;

	/** @return True if the PHY is capable of normal operation. */
	public boolean isIsOperational() {
		return this.isOperational;
	}
	/** @param x True if the PHY is capable of normal operation. */
	public void setIsOperational(boolean x) {
		this.isOperational = x;
	}
}
