package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used to convey information about the different types of SAS ports. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(630)
public class SasPortTypeData implements Serializable {
	public SasPortTypeData() {
	}

	/** This enumeration specifies the different types of SAS ports. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration specifies the different types of SAS ports." , required = true)
	@XmlElement(required = true)
	private SasPortType portType = SasPortType.__UNDEFINED;

	/** @return This enumeration specifies the different types of SAS ports. */
	public SasPortType getPortType() {
		return this.portType;
	}
	/** @param x This enumeration specifies the different types of SAS ports. */
	public void setPortType(SasPortType x) {
		this.portType = x;
	}

	/** This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE." , required = false)
	@XmlElement(required = false)
	private String portIdentifier;

	/** @return This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE. */
	public String getPortIdentifier() {
		return this.portIdentifier;
	}
	/** @param x This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE. */
	public void setPortIdentifier(String x) {
		this.portIdentifier = x;
	}

	/** This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER." , required = false)
	@XmlElement(required = false)
	private SasRoutingType routingType = SasRoutingType.__UNDEFINED;

	/** @return This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER. */
	public SasRoutingType getRoutingType() {
		return this.routingType;
	}
	/** @param x This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER. */
	public void setRoutingType(SasRoutingType x) {
		this.routingType = x;
	}
}
