package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This is a composite structure containing all schedule-related information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1051)
public class Schedule implements Serializable {
	public Schedule() {
	}

	/** Daily, weekly, or monthly calendar information. */
	@io.swagger.annotations.ApiModelProperty(value ="Daily, weekly, or monthly calendar information." , required = true)
	@XmlElement(required = true)
	private ScheduleCalendar calendar;

	/** @return Daily, weekly, or monthly calendar information. */
	public ScheduleCalendar getCalendar() {
		return this.calendar;
	}
	/** @param x Daily, weekly, or monthly calendar information. */
	public void setCalendar(ScheduleCalendar x) {
		this.calendar = x;
	}

	/** The schedule will not run until this date/time, measured as seconds since midnight, January 1st, 1970 local time. */
	@io.swagger.annotations.ApiModelProperty(value ="The schedule will not run until this date/time, measured as seconds since midnight, January 1st, 1970 local time." , required = true)
	@XmlElement(required = true)
	private long startDate;

	/** @return The schedule will not run until this date/time, measured as seconds since midnight, January 1st, 1970 local time. */
	public long getStartDate() {
		return this.startDate;
	}
	/** @param x The schedule will not run until this date/time, measured as seconds since midnight, January 1st, 1970 local time. */
	public void setStartDate(long x) {
		this.startDate = x;
	}

	/** The number of days, weeks, or months to run. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of days, weeks, or months to run." , required = true)
	@XmlElement(required = true)
	private Recurrence recurrence;

	/** @return The number of days, weeks, or months to run. */
	public Recurrence getRecurrence() {
		return this.recurrence;
	}
	/** @param x The number of days, weeks, or months to run. */
	public void setRecurrence(Recurrence x) {
		this.recurrence = x;
	}

	/** Specification of the time zone. */
	@io.swagger.annotations.ApiModelProperty(value ="Specification of the time zone." , required = true)
	@XmlElement(required = true)
	private TimeZoneDescription timezone;

	/** @return Specification of the time zone. */
	public TimeZoneDescription getTimezone() {
		return this.timezone;
	}
	/** @param x Specification of the time zone. */
	public void setTimezone(TimeZoneDescription x) {
		this.timezone = x;
	}
}
