package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information for SCHEDULE_METHOD_MONTHLY_DATE schedules. The schedule runs on selected days in the month. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(793)
public class ScheduleMonthlyByDate implements Serializable {
	public ScheduleMonthlyByDate() {
	}

	/** This is a bit mask. Values from the DayOfMonth enumeration should be added (or OR'ed) together to set this value. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a bit mask. Values from the DayOfMonth enumeration should be added (or OR'ed) together to set this value." , required = true)
	@XmlElement(required = true)
	private DayOfMonth[] daysOfMonth;

	/** @return This is a bit mask. Values from the DayOfMonth enumeration should be added (or OR'ed) together to set this value. */
	public DayOfMonth[] getDaysOfMonth() {
		return this.daysOfMonth;
	}
	/** @param x This is a bit mask. Values from the DayOfMonth enumeration should be added (or OR'ed) together to set this value. */
	public void setDaysOfMonth(DayOfMonth[] x) {
		this.daysOfMonth = x;
	}

	/** This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value." , required = true)
	@XmlElement(required = true)
	private MonthOfYear[] monthsOfYear;

	/** @return This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	public MonthOfYear[] getMonthsOfYear() {
		return this.monthsOfYear;
	}
	/** @param x This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	public void setMonthsOfYear(MonthOfYear[] x) {
		this.monthsOfYear = x;
	}

	/** Conveys time information, including time of day, recurrence and occurrence frequency. */
	@io.swagger.annotations.ApiModelProperty(value ="Conveys time information, including time of day, recurrence and occurrence frequency." , required = true)
	@XmlElement(required = true)
	private DailySchedule dailySchedule;

	/** @return Conveys time information, including time of day, recurrence and occurrence frequency. */
	public DailySchedule getDailySchedule() {
		return this.dailySchedule;
	}
	/** @param x Conveys time information, including time of day, recurrence and occurrence frequency. */
	public void setDailySchedule(DailySchedule x) {
		this.dailySchedule = x;
	}
}
