package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information for SCHEDULE_METHOD_MONTHLY_DAY schedules. The schedule runs on a selected day of the week during the month. Examples: Second Saturday would be dayOfWeek = DAY_OF_WEEK_SATURDAY, weekNumber = 2. Last Sunday would be dayOfWeek = DAY_OF_WEEK_SUNDAY, weekNumber = 5. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(751)
public class ScheduleMonthlyByDay implements Serializable {
	public ScheduleMonthlyByDay() {
	}

	/** The day of the week. This is NOT a bit mask. */
	@io.swagger.annotations.ApiModelProperty(value ="The day of the week. This is NOT a bit mask." , required = true)
	@XmlElement(required = true)
	private DayOfWeek dayOfWeek = DayOfWeek.__UNDEFINED;

	/** @return The day of the week. This is NOT a bit mask. */
	public DayOfWeek getDayOfWeek() {
		return this.dayOfWeek;
	}
	/** @param x The day of the week. This is NOT a bit mask. */
	public void setDayOfWeek(DayOfWeek x) {
		this.dayOfWeek = x;
	}

	/** Conveys time information, including time of day, recurrence and occurrence frequency. */
	@io.swagger.annotations.ApiModelProperty(value ="Conveys time information, including time of day, recurrence and occurrence frequency." , required = true)
	@XmlElement(required = true)
	private DailySchedule dailySchedule;

	/** @return Conveys time information, including time of day, recurrence and occurrence frequency. */
	public DailySchedule getDailySchedule() {
		return this.dailySchedule;
	}
	/** @param x Conveys time information, including time of day, recurrence and occurrence frequency. */
	public void setDailySchedule(DailySchedule x) {
		this.dailySchedule = x;
	}

	/** The week number during the month. For example, 1 = first, 2 = second, etc., and 5 = last. */
	@io.swagger.annotations.ApiModelProperty(value ="The week number during the month. For example, 1 = first, 2 = second, etc., and 5 = last." , required = true)
	@XmlElement(required = true)
	private int weekNumber;

	/** @return The week number during the month. For example, 1 = first, 2 = second, etc., and 5 = last. */
	public int getWeekNumber() {
		return this.weekNumber;
	}
	/** @param x The week number during the month. For example, 1 = first, 2 = second, etc., and 5 = last. */
	public void setWeekNumber(int x) {
		this.weekNumber = x;
	}

	/** This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value." , required = true)
	@XmlElement(required = true)
	private MonthOfYear[] monthsOfYear;

	/** @return This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	public MonthOfYear[] getMonthsOfYear() {
		return this.monthsOfYear;
	}
	/** @param x This is a bit mask. Values from the MonthOfYear enumeration should be added (or OR'ed) together to set this value. */
	public void setMonthsOfYear(MonthOfYear[] x) {
		this.monthsOfYear = x;
	}
}
