package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information for SCHEDULE_METHOD_WEEKLY schedules. The schedule runs on selected days in the week. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(626)
public class ScheduleWeekly implements Serializable {
	public ScheduleWeekly() {
	}

	/** This is a bit mask. Values from the DayOfWeek enumeration should be added (or OR'ed) together to set this value. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a bit mask. Values from the DayOfWeek enumeration should be added (or OR'ed) together to set this value." , required = true)
	@XmlElement(required = true)
	private DayOfWeek[] daysOfWeek;

	/** @return This is a bit mask. Values from the DayOfWeek enumeration should be added (or OR'ed) together to set this value. */
	public DayOfWeek[] getDaysOfWeek() {
		return this.daysOfWeek;
	}
	/** @param x This is a bit mask. Values from the DayOfWeek enumeration should be added (or OR'ed) together to set this value. */
	public void setDaysOfWeek(DayOfWeek[] x) {
		this.daysOfWeek = x;
	}

	/** Conveys time information, including time of day, recurrence and occurrence frequency. */
	@io.swagger.annotations.ApiModelProperty(value ="Conveys time information, including time of day, recurrence and occurrence frequency." , required = true)
	@XmlElement(required = true)
	private DailySchedule dailySchedule;

	/** @return Conveys time information, including time of day, recurrence and occurrence frequency. */
	public DailySchedule getDailySchedule() {
		return this.dailySchedule;
	}
	/** @param x Conveys time information, including time of day, recurrence and occurrence frequency. */
	public void setDailySchedule(DailySchedule x) {
		this.dailySchedule = x;
	}
}
