package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object contains a data structure with the settings for the base properties for an SCSI target or initiator. The elements in the structure/union are currently only populated if the target/initiator is of iSCSI type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1015)
public class ScsiInitiatorTargetBaseProperties implements Serializable {
	public ScsiInitiatorTargetBaseProperties() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType ioInterfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getIoInterfaceType() {
		return this.ioInterfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setIoInterfaceType(IOInterfaceType x) {
		this.ioInterfaceType = x;
	}

	/** This structure contains the base properties of an iSCSI target or initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="This structure contains the base properties of an iSCSI target or initiator." , required = false)
	@XmlElement(required = false)
	private IscsiInitiatorTargetBaseParameters iSCSIInitiatorTargetBaseParameters;

	/** @return This structure contains the base properties of an iSCSI target or initiator. */
	public IscsiInitiatorTargetBaseParameters getISCSIInitiatorTargetBaseParameters() {
		return this.iSCSIInitiatorTargetBaseParameters;
	}
	/** @param x This structure contains the base properties of an iSCSI target or initiator. */
	public void setISCSIInitiatorTargetBaseParameters(IscsiInitiatorTargetBaseParameters x) {
		this.iSCSIInitiatorTargetBaseParameters = x;
	}
}
