package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Describes a change in the Security Audit Log status */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(159)
public enum SecurityAuditLogEvent implements Serializable {
		/** The Security Audit Log has been manually cleared */
		cleared(0),
		/** The Security Audit Full Policy has been changed */
		fullPolicyChg(1),
		/** The Security Audit Log size has reached its warning threshold */
		warnThresh(2),
		/** The Security Audit Log is now full and the full policy is set to 'Manually Clear' */
		full(3),
		__UNDEFINED(464378545);

		public final int value;

		private SecurityAuditLogEvent(int v) {
			this.value = v;
		}
}
