package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains data specific to given security audit log event type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(654)
public class SecurityAuditLogEventData implements Serializable {
	public SecurityAuditLogEventData() {
	}

	/** Describes a change in the Security Audit Log status */
	@io.swagger.annotations.ApiModelProperty(value ="Describes a change in the Security Audit Log status" , required = true)
	@XmlElement(required = true)
	private SecurityAuditLogEvent auditLogEvent = SecurityAuditLogEvent.__UNDEFINED;

	/** @return Describes a change in the Security Audit Log status */
	public SecurityAuditLogEvent getAuditLogEvent() {
		return this.auditLogEvent;
	}
	/** @param x Describes a change in the Security Audit Log status */
	public void setAuditLogEvent(SecurityAuditLogEvent x) {
		this.auditLogEvent = x;
	}

	/** Fields describing a full policy change event */
	@io.swagger.annotations.ApiModelProperty(value ="Fields describing a full policy change event" , required = false)
	@XmlElement(required = false)
	private SecurityAuditLogFullPolicyChangeDesc fullPolicyChange;

	/** @return Fields describing a full policy change event */
	public SecurityAuditLogFullPolicyChangeDesc getFullPolicyChange() {
		return this.fullPolicyChange;
	}
	/** @param x Fields describing a full policy change event */
	public void setFullPolicyChange(SecurityAuditLogFullPolicyChangeDesc x) {
		this.fullPolicyChange = x;
	}
}
