package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Internal Message Description sent from the WebService Proxy. Indicates an event related to the Security Audit Log */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(762)
public class SecurityAuditLogEventDesc implements Serializable {
	public SecurityAuditLogEventDesc() {
	}

	/** Event data specific to the audit log event type. */
	@io.swagger.annotations.ApiModelProperty(value ="Event data specific to the audit log event type." , required = true)
	@XmlElement(required = true)
	private SecurityAuditLogEventData eventData;

	/** @return Event data specific to the audit log event type. */
	public SecurityAuditLogEventData getEventData() {
		return this.eventData;
	}
	/** @param x Event data specific to the audit log event type. */
	public void setEventData(SecurityAuditLogEventData x) {
		this.eventData = x;
	}

	/** The current Security Audit Log Full Policy */
	@io.swagger.annotations.ApiModelProperty(value ="The current Security Audit Log Full Policy" , required = true)
	@XmlElement(required = true)
	private SecurityAuditLogFullPolicy currentAuditLogFullPolicy = SecurityAuditLogFullPolicy.__UNDEFINED;

	/** @return The current Security Audit Log Full Policy */
	public SecurityAuditLogFullPolicy getCurrentAuditLogFullPolicy() {
		return this.currentAuditLogFullPolicy;
	}
	/** @param x The current Security Audit Log Full Policy */
	public void setCurrentAuditLogFullPolicy(SecurityAuditLogFullPolicy x) {
		this.currentAuditLogFullPolicy = x;
	}
}
