package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The Security Level describes the type of secure drives. This is used to distinguish between FDE and FIPS drives and to denote when there is a mix of drive types. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(83)
public enum SecurityLevel implements Serializable {
		/** The security level of the associated drive set is unknown. */
		unknown(0),
		/** There is no specific security level for the associated drive set. */
		none(1),
		/** There are a mix of security levels in the associated drive set. */
		mixed(2),
		/** The drives in the associated set are 100% FDE capable. */
		fde(3),
		/** The drives in the associated set are 100% FIPS capable. */
		fips(4),
		__UNDEFINED(464378545);

		public final int value;

		private SecurityLevel(int v) {
			this.value = v;
		}
}
