package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to describe the security status of the drive group and the volumes in the drive group */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(173)
public enum SecurityType implements Serializable {
		/** The security type is unknown. */
		unknown(0),
		/** The drive group is a non-secure drive group and not secure capable. */
		none(1),
		/** The drive group is a security capable drive group */
		capable(2),
		/** The drive group is a security enabled drive group. */
		enabled(3),
		__UNDEFINED(464378545);

		public final int value;

		private SecurityType(int v) {
			this.value = v;
		}
}
