package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Contains global, array-wide data about the smart battery configuration. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(327)
public class SmartBatteryData implements Serializable {
	public SmartBatteryData() {
	}

	/** The time of the last completed learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time of the last completed learn cycle, expressed in seconds since midnight GMT, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long lastBatteryLearnCycle;

	/** @return The time of the last completed learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	public long getLastBatteryLearnCycle() {
		return this.lastBatteryLearnCycle;
	}
	/** @param x The time of the last completed learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	public void setLastBatteryLearnCycle(long x) {
		this.lastBatteryLearnCycle = x;
	}

	/** The time of the next scheduled learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time of the next scheduled learn cycle, expressed in seconds since midnight GMT, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long nextBatteryLearnCycle;

	/** @return The time of the next scheduled learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	public long getNextBatteryLearnCycle() {
		return this.nextBatteryLearnCycle;
	}
	/** @param x The time of the next scheduled learn cycle, expressed in seconds since midnight GMT, January 1, 1970. */
	public void setNextBatteryLearnCycle(long x) {
		this.nextBatteryLearnCycle = x;
	}

	/** The time between automatic learn cycles, expressed in weeks. */
	@io.swagger.annotations.ApiModelProperty(value ="The time between automatic learn cycles, expressed in weeks." , required = true)
	@XmlElement(required = true)
	private int batteryLearnCycleInterval;

	/** @return The time between automatic learn cycles, expressed in weeks. */
	public int getBatteryLearnCycleInterval() {
		return this.batteryLearnCycleInterval;
	}
	/** @param x The time between automatic learn cycles, expressed in weeks. */
	public void setBatteryLearnCycleInterval(int x) {
		this.batteryLearnCycleInterval = x;
	}
}
