package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information required for snapshot conversion. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(594)
public class SnapshotConversionLabel implements Serializable {
	public SnapshotConversionLabel() {
	}

	/** Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the "newPITGroupLabel" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process. */
	@io.swagger.annotations.ApiModelProperty(value ="Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the \"newPITGroupLabel\" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process." , required = true)
	@XmlElement(required = true)
	private String snapRepositoryRef;

	/** @return Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the "newPITGroupLabel" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process. */
	public String getSnapRepositoryRef() {
		return this.snapRepositoryRef;
	}
	/** @param x Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the "newPITGroupLabel" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process. */
	public void setSnapRepositoryRef(String x) {
		this.snapRepositoryRef = x;
	}

	/** New label for repository volume being converted from a snapshot repository to a PiT group repository. */
	@io.swagger.annotations.ApiModelProperty(value ="New label for repository volume being converted from a snapshot repository to a PiT group repository." , required = true)
	@XmlElement(required = true)
	private String newRepositoryLabel;

	/** @return New label for repository volume being converted from a snapshot repository to a PiT group repository. */
	public String getNewRepositoryLabel() {
		return this.newRepositoryLabel;
	}
	/** @param x New label for repository volume being converted from a snapshot repository to a PiT group repository. */
	public void setNewRepositoryLabel(String x) {
		this.newRepositoryLabel = x;
	}

	/** Label for new PiT group being created. */
	@io.swagger.annotations.ApiModelProperty(value ="Label for new PiT group being created." , required = true)
	@XmlElement(required = true)
	private String newPITGroupLabel;

	/** @return Label for new PiT group being created. */
	public String getNewPITGroupLabel() {
		return this.newPITGroupLabel;
	}
	/** @param x Label for new PiT group being created. */
	public void setNewPITGroupLabel(String x) {
		this.newPITGroupLabel = x;
	}
}
