package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about how a new snapshot volume is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1158)
public class SnapshotCreationDescriptor implements Serializable {
	public SnapshotCreationDescriptor() {
	}

	/** The base volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The base volume." , required = true)
	@XmlElement(required = true)
	private String baseVolume;

	/** @return The base volume. */
	public String getBaseVolume() {
		return this.baseVolume;
	}
	/** @param x The base volume. */
	public void setBaseVolume(String x) {
		this.baseVolume = x;
	}

	/** The user assigned snapshot label. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned snapshot label." , required = true)
	@XmlElement(required = true)
	private String snapshotLabel;

	/** @return The user assigned snapshot label. */
	public String getSnapshotLabel() {
		return this.snapshotLabel;
	}
	/** @param x The user assigned snapshot label. */
	public void setSnapshotLabel(String x) {
		this.snapshotLabel = x;
	}

	/** The user assigned label for the repository volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned label for the repository volume." , required = true)
	@XmlElement(required = true)
	private String repositoryLabel;

	/** @return The user assigned label for the repository volume. */
	public String getRepositoryLabel() {
		return this.repositoryLabel;
	}
	/** @param x The user assigned label for the repository volume. */
	public void setRepositoryLabel(String x) {
		this.repositoryLabel = x;
	}

	/** The capacity size of the repository to create in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The capacity size of the repository to create in bytes." , required = true)
	@XmlElement(required = true)
	private long repositoryCapacity;

	/** @return The capacity size of the repository to create in bytes. */
	public long getRepositoryCapacity() {
		return this.repositoryCapacity;
	}
	/** @param x The capacity size of the repository to create in bytes. */
	public void setRepositoryCapacity(long x) {
		this.repositoryCapacity = x;
	}

	/** The repository utilization warning threshold. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold." , required = true)
	@XmlElement(required = true)
	private int warnThreshold;

	/** @return The repository utilization warning threshold. */
	public int getWarnThreshold() {
		return this.warnThreshold;
	}
	/** @param x The repository utilization warning threshold. */
	public void setWarnThreshold(int x) {
		this.warnThreshold = x;
	}

	/** The start position of the extent in the base volume (bytes). Not used in this release of software. */
	@io.swagger.annotations.ApiModelProperty(value ="The start position of the extent in the base volume (bytes). Not used in this release of software." , required = true)
	@XmlElement(required = true)
	private long extentStart;

	/** @return The start position of the extent in the base volume (bytes). Not used in this release of software. */
	public long getExtentStart() {
		return this.extentStart;
	}
	/** @param x The start position of the extent in the base volume (bytes). Not used in this release of software. */
	public void setExtentStart(long x) {
		this.extentStart = x;
	}

	/** The size of the extent in bytes. Not used in this release of software. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the extent in bytes. Not used in this release of software." , required = true)
	@XmlElement(required = true)
	private long extentSize;

	/** @return The size of the extent in bytes. Not used in this release of software. */
	public long getExtentSize() {
		return this.extentSize;
	}
	/** @param x The size of the extent in bytes. Not used in this release of software. */
	public void setExtentSize(long x) {
		this.extentSize = x;
	}

	/** The policy regarding what will happen when the repository is full. */
	@io.swagger.annotations.ApiModelProperty(value ="The policy regarding what will happen when the repository is full." , required = true)
	@XmlElement(required = true)
	private RepositoryFullPolicy repFullPolicy = RepositoryFullPolicy.__UNDEFINED;

	/** @return The policy regarding what will happen when the repository is full. */
	public RepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x The policy regarding what will happen when the repository is full. */
	public void setRepFullPolicy(RepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The volume candidate for the repository. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume candidate for the repository." , required = true)
	@XmlElement(required = true)
	private VolumeCandidate candidate;

	/** @return The volume candidate for the repository. */
	public VolumeCandidate getCandidate() {
		return this.candidate;
	}
	/** @param x The volume candidate for the repository. */
	public void setCandidate(VolumeCandidate x) {
		this.candidate = x;
	}

	/** True tells the controller NOT to create a mapping. False causes the controller to create a default mapping for the new snapshot. (Note: A True value for noMapping when the SPM feature is disabled will cause a RETCODE_PARTITIONS_DISABLED from createSnapshot. This is because a host cannot access the snapshot if partitions are disabled and a default mapping was not created when the snapshot was created. */
	@io.swagger.annotations.ApiModelProperty(value ="True tells the controller NOT to create a mapping. False causes the controller to create a default mapping for the new snapshot. (Note: A True value for noMapping when the SPM feature is disabled will cause a RETCODE_PARTITIONS_DISABLED from createSnapshot. This is because a host cannot access the snapshot if partitions are disabled and a default mapping was not created when the snapshot was created." , required = true)
	@XmlElement(required = true)
	private boolean noMapping;

	/** @return True tells the controller NOT to create a mapping. False causes the controller to create a default mapping for the new snapshot. (Note: A True value for noMapping when the SPM feature is disabled will cause a RETCODE_PARTITIONS_DISABLED from createSnapshot. This is because a host cannot access the snapshot if partitions are disabled and a default mapping was not created when the snapshot was created. */
	public boolean isNoMapping() {
		return this.noMapping;
	}
	/** @param x True tells the controller NOT to create a mapping. False causes the controller to create a default mapping for the new snapshot. (Note: A True value for noMapping when the SPM feature is disabled will cause a RETCODE_PARTITIONS_DISABLED from createSnapshot. This is because a host cannot access the snapshot if partitions are disabled and a default mapping was not created when the snapshot was created. */
	public void setNoMapping(boolean x) {
		this.noMapping = x;
	}

	/** The label to assign to the new volume group for the repository, if any. This field is only used when the repository candidate selection type is CANDIDATE_SEL_MANUAL or CANDIDATE_SEL_COUNT. */
	@io.swagger.annotations.ApiModelProperty(value ="The label to assign to the new volume group for the repository, if any. This field is only used when the repository candidate selection type is CANDIDATE_SEL_MANUAL or CANDIDATE_SEL_COUNT." , required = true)
	@XmlElement(required = true)
	private String volumeGroupLabel;

	/** @return The label to assign to the new volume group for the repository, if any. This field is only used when the repository candidate selection type is CANDIDATE_SEL_MANUAL or CANDIDATE_SEL_COUNT. */
	public String getVolumeGroupLabel() {
		return this.volumeGroupLabel;
	}
	/** @param x The label to assign to the new volume group for the repository, if any. This field is only used when the repository candidate selection type is CANDIDATE_SEL_MANUAL or CANDIDATE_SEL_COUNT. */
	public void setVolumeGroupLabel(String x) {
		this.volumeGroupLabel = x;
	}

	/** If true, the snapshot will be created in a stopped state, otherwise it will be started on creation. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, the snapshot will be created in a stopped state, otherwise it will be started on creation." , required = true)
	@XmlElement(required = true)
	private boolean createInStoppedState;

	/** @return If true, the snapshot will be created in a stopped state, otherwise it will be started on creation. */
	public boolean isCreateInStoppedState() {
		return this.createInStoppedState;
	}
	/** @param x If true, the snapshot will be created in a stopped state, otherwise it will be started on creation. */
	public void setCreateInStoppedState(boolean x) {
		this.createInStoppedState = x;
	}

	/** The snapshot schedule. The targetObject in the structure is empty. */
	@io.swagger.annotations.ApiModelProperty(value ="The snapshot schedule. The targetObject in the structure is empty." , required = true)
	@XmlElement(required = true)
	private OptionalScheduleCreationDescriptor snapshotSchedule;

	/** @return The snapshot schedule. The targetObject in the structure is empty. */
	public OptionalScheduleCreationDescriptor getSnapshotSchedule() {
		return this.snapshotSchedule;
	}
	/** @param x The snapshot schedule. The targetObject in the structure is empty. */
	public void setSnapshotSchedule(OptionalScheduleCreationDescriptor x) {
		this.snapshotSchedule = x;
	}
}
