package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to update various snapshot parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(960)
public class SnapshotParamsUpdateDescriptor implements Serializable {
	public SnapshotParamsUpdateDescriptor() {
	}

	/** The snapshot volume to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The snapshot volume to be updated." , required = true)
	@XmlElement(required = true)
	private String snapRef;

	/** @return The snapshot volume to be updated. */
	public String getSnapRef() {
		return this.snapRef;
	}
	/** @param x The snapshot volume to be updated. */
	public void setSnapRef(String x) {
		this.snapRef = x;
	}

	/** The repository utilization warning threshold. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold." , required = true)
	@XmlElement(required = true)
	private int warnThreshold;

	/** @return The repository utilization warning threshold. */
	public int getWarnThreshold() {
		return this.warnThreshold;
	}
	/** @param x The repository utilization warning threshold. */
	public void setWarnThreshold(int x) {
		this.warnThreshold = x;
	}

	/** The start position of the extent in the base volume (bytes). Not used in this release of software. */
	@io.swagger.annotations.ApiModelProperty(value ="The start position of the extent in the base volume (bytes). Not used in this release of software." , required = true)
	@XmlElement(required = true)
	private long extentStart;

	/** @return The start position of the extent in the base volume (bytes). Not used in this release of software. */
	public long getExtentStart() {
		return this.extentStart;
	}
	/** @param x The start position of the extent in the base volume (bytes). Not used in this release of software. */
	public void setExtentStart(long x) {
		this.extentStart = x;
	}

	/** The size of the extent in bytes. Not used in this release of software. */
	@io.swagger.annotations.ApiModelProperty(value ="The size of the extent in bytes. Not used in this release of software." , required = true)
	@XmlElement(required = true)
	private long extentSize;

	/** @return The size of the extent in bytes. Not used in this release of software. */
	public long getExtentSize() {
		return this.extentSize;
	}
	/** @param x The size of the extent in bytes. Not used in this release of software. */
	public void setExtentSize(long x) {
		this.extentSize = x;
	}

	/** The policy concerning what will happen when the repository is full. */
	@io.swagger.annotations.ApiModelProperty(value ="The policy concerning what will happen when the repository is full." , required = true)
	@XmlElement(required = true)
	private RepositoryFullPolicy repFullPolicy = RepositoryFullPolicy.__UNDEFINED;

	/** @return The policy concerning what will happen when the repository is full. */
	public RepositoryFullPolicy getRepFullPolicy() {
		return this.repFullPolicy;
	}
	/** @param x The policy concerning what will happen when the repository is full. */
	public void setRepFullPolicy(RepositoryFullPolicy x) {
		this.repFullPolicy = x;
	}

	/** The importance of the rollback operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The importance of the rollback operation." , required = true)
	@XmlElement(required = true)
	private int rollbackPriority;

	/** @return The importance of the rollback operation. */
	public int getRollbackPriority() {
		return this.rollbackPriority;
	}
	/** @param x The importance of the rollback operation. */
	public void setRollbackPriority(int x) {
		this.rollbackPriority = x;
	}
}
