package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to determine the current status of a rollback operation. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(137)
public enum SnapshotRollbackStatus implements Serializable {
		/** No rollback. */
		none(0),
		/** Actively copying data. */
		inProgress(1),
		/** The rollback is waiting on resources to start background copy. */
		pending(2),
		/** Active data copy paused due to error. */
		paused(3),
		__UNDEFINED(464378545);

		public final int value;

		private SnapshotRollbackStatus(int v) {
			this.value = v;
		}
}
