package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** An enumeration used to determine the status of a snapshot. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(198)
public enum SnapshotStatus implements Serializable {
		/** The snapshot is working correctly */
		active(1),
		/** The snapshot is not in working condition */
		failed(2),
		/** The snapshot has been disabled by user request */
		disabled(3),
		/** The snapshot will reject all IOs because of repository condition */
		offline(4),
		__UNDEFINED(464378545);

		public final int value;

		private SnapshotStatus(int v) {
			this.value = v;
		}
}
