package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to indicate which type of statistics to return on a procedure call to get SOC error statistics. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(76)
public enum SocCommand implements Serializable {
		/** Report SOC error statistics, on a per-port basis, for all SOC ports local to the controller receiving the request, that are connected to controllers, drives, and SFPs in the controller or controller/drive tray. SOC error statistics for SOC ports local to the alternate controller must be obtained from the alternate controller. */
		controllerTray(1),
		/** Report SOC error statistics, on a per-port basis, for all SOC ports connected to ESMs, drives, and SFPs in all drive expansion trays that are accessible to the controller receiving the request. Error statistics for controllers, drives, or SFPs residing in controller trays or controller/drive trays are not reported. It is sufficient to just issue this command to one controller or the other. */
		expansionTrays(2),
		__UNDEFINED(464378545);

		public final int value;

		private SocCommand(int v) {
			this.value = v;
		}
}
