package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is the argument to the procedure for getting SOC error statistics. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(538)
public class SocCommandDescriptor implements Serializable {
	public SocCommandDescriptor() {
	}

	/** This enumeration object is used to indicate which type of statistics to return on a procedure call to get SOC error statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to indicate which type of statistics to return on a procedure call to get SOC error statistics." , required = true)
	@XmlElement(required = true)
	private SocCommand command = SocCommand.__UNDEFINED;

	/** @return This enumeration object is used to indicate which type of statistics to return on a procedure call to get SOC error statistics. */
	public SocCommand getCommand() {
		return this.command;
	}
	/** @param x This enumeration object is used to indicate which type of statistics to return on a procedure call to get SOC error statistics. */
	public void setCommand(SocCommand x) {
		this.command = x;
	}

	/** This field identifies the controller that will return the SOC error statistics. It is only valid if the command field is equal to SOC_GET_CONTROLLER_TRAY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the controller that will return the SOC error statistics. It is only valid if the command field is equal to SOC_GET_CONTROLLER_TRAY." , required = false)
	@XmlElement(required = false)
	private String localController;

	/** @return This field identifies the controller that will return the SOC error statistics. It is only valid if the command field is equal to SOC_GET_CONTROLLER_TRAY. */
	public String getLocalController() {
		return this.localController;
	}
	/** @param x This field identifies the controller that will return the SOC error statistics. It is only valid if the command field is equal to SOC_GET_CONTROLLER_TRAY. */
	public void setLocalController(String x) {
		this.localController = x;
	}
}
