package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to identify a Fibre Channel device attached to a SOC port. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1126)
public class SocConnectedDevice implements Serializable {
	public SocConnectedDevice() {
	}

	/** The number of the channel where the SOC-connected device is located. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the channel where the SOC-connected device is located." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The number of the channel where the SOC-connected device is located. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The number of the channel where the SOC-connected device is located. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** This field contains, or is a reference to, data describing the SOC-connected device. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains, or is a reference to, data describing the SOC-connected device." , required = true)
	@XmlElement(required = true)
	private SocConnectedDeviceTypeData socConnectedDeviceData;

	/** @return This field contains, or is a reference to, data describing the SOC-connected device. */
	public SocConnectedDeviceTypeData getSocConnectedDeviceData() {
		return this.socConnectedDeviceData;
	}
	/** @param x This field contains, or is a reference to, data describing the SOC-connected device. */
	public void setSocConnectedDeviceData(SocConnectedDeviceTypeData x) {
		this.socConnectedDeviceData = x;
	}
}
