package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to identify the type of device attached to a SOC port. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(129)
public enum SocConnectedDeviceType implements Serializable {
		/** Controller attached directly to a local SOC port. */
		controllerLocal(0),
		/** Alternate controller attached to a remote SOC port. */
		controllerAlternate(1),
		/** Drive device type */
		drive(2),
		/** ESM device type */
		esm(3),
		/** SFP device type */
		sfp(4),
		/** Unknown device type */
		unknownDevice(5),
		/** Drawer device type */
		drawer(6),
		__UNDEFINED(464378545);

		public final int value;

		private SocConnectedDeviceType(int v) {
			this.value = v;
		}
}
