package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type defines type-dependent SOC-connected device information. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(985)
public class SocConnectedDeviceTypeData implements Serializable {
	public SocConnectedDeviceTypeData() {
	}

	/** This enumeration object is used to identify the type of device attached to a SOC port. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration object is used to identify the type of device attached to a SOC port." , required = true)
	@XmlElement(required = true)
	private SocConnectedDeviceType type = SocConnectedDeviceType.__UNDEFINED;

	/** @return This enumeration object is used to identify the type of device attached to a SOC port. */
	public SocConnectedDeviceType getType() {
		return this.type;
	}
	/** @param x This enumeration object is used to identify the type of device attached to a SOC port. */
	public void setType(SocConnectedDeviceType x) {
		this.type = x;
	}

	/** This field identifies the alternate controller. It is present only if type is equal to SOC_PORT_CONTROLLER_ALTERNATE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the alternate controller. It is present only if type is equal to SOC_PORT_CONTROLLER_ALTERNATE." , required = false)
	@XmlElement(required = false)
	private String alternateController;

	/** @return This field identifies the alternate controller. It is present only if type is equal to SOC_PORT_CONTROLLER_ALTERNATE. */
	public String getAlternateController() {
		return this.alternateController;
	}
	/** @param x This field identifies the alternate controller. It is present only if type is equal to SOC_PORT_CONTROLLER_ALTERNATE. */
	public void setAlternateController(String x) {
		this.alternateController = x;
	}

	/** This field identifies the local controller. It is present only if type is equal to SOC_PORT_CONTROLLER_LOCAL. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the local controller. It is present only if type is equal to SOC_PORT_CONTROLLER_LOCAL." , required = false)
	@XmlElement(required = false)
	private String localController;

	/** @return This field identifies the local controller. It is present only if type is equal to SOC_PORT_CONTROLLER_LOCAL. */
	public String getLocalController() {
		return this.localController;
	}
	/** @param x This field identifies the local controller. It is present only if type is equal to SOC_PORT_CONTROLLER_LOCAL. */
	public void setLocalController(String x) {
		this.localController = x;
	}

	/** This field identifies a drive. It is present only if type is equal to SOC_PORT_DRIVE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies a drive. It is present only if type is equal to SOC_PORT_DRIVE." , required = false)
	@XmlElement(required = false)
	private String drive;

	/** @return This field identifies a drive. It is present only if type is equal to SOC_PORT_DRIVE. */
	public String getDrive() {
		return this.drive;
	}
	/** @param x This field identifies a drive. It is present only if type is equal to SOC_PORT_DRIVE. */
	public void setDrive(String x) {
		this.drive = x;
	}

	/** This field identifies an ESM. It is only present if type is equal to SOC_PORT_ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies an ESM. It is only present if type is equal to SOC_PORT_ESM." , required = false)
	@XmlElement(required = false)
	private String esm;

	/** @return This field identifies an ESM. It is only present if type is equal to SOC_PORT_ESM. */
	public String getEsm() {
		return this.esm;
	}
	/** @param x This field identifies an ESM. It is only present if type is equal to SOC_PORT_ESM. */
	public void setEsm(String x) {
		this.esm = x;
	}

	/** This field identifies an SFP. It is only present if type is equal to SOC_PORT_SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies an SFP. It is only present if type is equal to SOC_PORT_SFP." , required = false)
	@XmlElement(required = false)
	private String sfp;

	/** @return This field identifies an SFP. It is only present if type is equal to SOC_PORT_SFP. */
	public String getSfp() {
		return this.sfp;
	}
	/** @param x This field identifies an SFP. It is only present if type is equal to SOC_PORT_SFP. */
	public void setSfp(String x) {
		this.sfp = x;
	}

	/** This field identifies the location of an unknown device. It is only present if the type is set to SOC_PORT_UNKNOWN_DEVICE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the location of an unknown device. It is only present if the type is set to SOC_PORT_UNKNOWN_DEVICE." , required = false)
	@XmlElement(required = false)
	private Location physicalLocation;

	/** @return This field identifies the location of an unknown device. It is only present if the type is set to SOC_PORT_UNKNOWN_DEVICE. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x This field identifies the location of an unknown device. It is only present if the type is set to SOC_PORT_UNKNOWN_DEVICE. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** This field identifies the location of the drawer. It is only present if the type is set to SOC_PORT_DRAWER. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the location of the drawer. It is only present if the type is set to SOC_PORT_DRAWER." , required = false)
	@XmlElement(required = false)
	private String drawer;

	/** @return This field identifies the location of the drawer. It is only present if the type is set to SOC_PORT_DRAWER. */
	public String getDrawer() {
		return this.drawer;
	}
	/** @param x This field identifies the location of the drawer. It is only present if the type is set to SOC_PORT_DRAWER. */
	public void setDrawer(String x) {
		this.drawer = x;
	}
}
