package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type specifies a reference to a SOC device's parent, based on the parent type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(572)
public class SocParent implements Serializable {
	public SocParent() {
	}

	/** This enumeration is used to indicate the device type for the parent of a SOC device. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration is used to indicate the device type for the parent of a SOC device." , required = true)
	@XmlElement(required = true)
	private SocParentType socParentType = SocParentType.__UNDEFINED;

	/** @return This enumeration is used to indicate the device type for the parent of a SOC device. */
	public SocParentType getSocParentType() {
		return this.socParentType;
	}
	/** @param x This enumeration is used to indicate the device type for the parent of a SOC device. */
	public void setSocParentType(SocParentType x) {
		this.socParentType = x;
	}

	/** A reference to the SOC device's parent controller. This field is only present if socParentType is equal to SOC_PARENT_TYPE_CONTROLLER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the SOC device's parent controller. This field is only present if socParentType is equal to SOC_PARENT_TYPE_CONTROLLER." , required = false)
	@XmlElement(required = false)
	private String parentController;

	/** @return A reference to the SOC device's parent controller. This field is only present if socParentType is equal to SOC_PARENT_TYPE_CONTROLLER. */
	public String getParentController() {
		return this.parentController;
	}
	/** @param x A reference to the SOC device's parent controller. This field is only present if socParentType is equal to SOC_PARENT_TYPE_CONTROLLER. */
	public void setParentController(String x) {
		this.parentController = x;
	}

	/** A reference to the SOC device's parent ESM. This field is only present if socParentType is equal to SOC_PARENT_TYPE_ESM. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the SOC device's parent ESM. This field is only present if socParentType is equal to SOC_PARENT_TYPE_ESM." , required = false)
	@XmlElement(required = false)
	private String parentEsm;

	/** @return A reference to the SOC device's parent ESM. This field is only present if socParentType is equal to SOC_PARENT_TYPE_ESM. */
	public String getParentEsm() {
		return this.parentEsm;
	}
	/** @param x A reference to the SOC device's parent ESM. This field is only present if socParentType is equal to SOC_PARENT_TYPE_ESM. */
	public void setParentEsm(String x) {
		this.parentEsm = x;
	}

	/** A reference to the SOC device's parent drawer. This field is only present if socParentType is equal to SOC_PARENT_TYPE_DRAWER. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the SOC device's parent drawer. This field is only present if socParentType is equal to SOC_PARENT_TYPE_DRAWER." , required = false)
	@XmlElement(required = false)
	private String parentDrawer;

	/** @return A reference to the SOC device's parent drawer. This field is only present if socParentType is equal to SOC_PARENT_TYPE_DRAWER. */
	public String getParentDrawer() {
		return this.parentDrawer;
	}
	/** @param x A reference to the SOC device's parent drawer. This field is only present if socParentType is equal to SOC_PARENT_TYPE_DRAWER. */
	public void setParentDrawer(String x) {
		this.parentDrawer = x;
	}
}
