package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to indicate the state of a given SOC port. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(216)
public enum SocPortState implements Serializable {
		/** The port state is "Unknown." */
		unknown(0),
		/** The port state is "Inserted." */
		inserted(1),
		/** The port state is "Manually Inserted." */
		insertedManual(2),
		/** The port state is "Loopback." */
		loopback(3),
		/** The port state is "Diag_Xmit." */
		diagXmit(4),
		/** The port state is "Bypassed." */
		bypassed(5),
		/** The port state is "Byp_NoFRU." */
		bypNoFru(6),
		/** The port state is "Byp_TXFault." */
		bypTxFault(7),
		/** The port state is "Byp_LIPF8." */
		bypLipF8(8),
		/** The port state is "Byp_DataTimeout." */
		bypDataTimeout(9),
		/** The port state is "Byp_RxLOS." */
		bypRxLos(10),
		/** The port state is "Byp_SyncLoss." */
		bypSyncLoss(11),
		/** The port state is "Byp_LIPIsol." */
		bypLipIsol(12),
		/** The port state is "Byp_PTBI." */
		bypPtbi(13),
		/** The port state is "Byp_Manual." */
		bypManual(14),
		/** The port state is "Byp_Redundant." */
		bypRedundant(15),
		/** The port state is "Byp_Snoop." */
		bypSnoop(16),
		/** The port state is "Byp_CRCThresh." */
		bypCrcThresh(17),
		/** The port state is "Byp_InvalidOSThresh." */
		bypInvalidOsThresh(18),
		__UNDEFINED(464378545);

		public final int value;

		private SocPortState(int v) {
			this.value = v;
		}
}
