package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used in responding to the request to get SOC error statistics. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1201)
public class SocStatisticsReturned implements Serializable {
	public SocStatisticsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field contains the SOC statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the SOC statistics. It is only valid if the returnCode field is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private SocStatistics socStatistics;

	/** @return This field contains the SOC statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	public SocStatistics getSocStatistics() {
		return this.socStatistics;
	}
	/** @param x This field contains the SOC statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	public void setSocStatistics(SocStatistics x) {
		this.socStatistics = x;
	}
}
