package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** An enumeration used to indicate how the device speed is controlled, Closely resembles values in mhm.h. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(242)
public enum SpeedControl implements Serializable {
		/** Method cannot be determined */
		unknown(1),
		/** Device has fixed speed */
		fixed(2),
		/** Device speed controlled by a switch */
		switched(3),
		/** Device speed is auto negotiated */
		auto(4),
		__UNDEFINED(464378545);

		public final int value;

		private SpeedControl(int v) {
			this.value = v;
		}
}
