package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain detailed information describing possible staged controller firmware. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(859)
public class StagedFirmware implements Serializable {
	public StagedFirmware() {
	}

	/** False, staged FW areas on the controllers are not valid and cannot be activated. True, the staged FW areas on the controllers are valid and can be activated. */
	@io.swagger.annotations.ApiModelProperty(value ="False, staged FW areas on the controllers are not valid and cannot be activated. True, the staged FW areas on the controllers are valid and can be activated." , required = true)
	@XmlElement(required = true)
	private boolean stagedFwValid;

	/** @return False, staged FW areas on the controllers are not valid and cannot be activated. True, the staged FW areas on the controllers are valid and can be activated. */
	public boolean isStagedFwValid() {
		return this.stagedFwValid;
	}
	/** @param x False, staged FW areas on the controllers are not valid and cannot be activated. True, the staged FW areas on the controllers are valid and can be activated. */
	public void setStagedFwValid(boolean x) {
		this.stagedFwValid = x;
	}

	/** The firmware package version identifier. */
	@io.swagger.annotations.ApiModelProperty(value ="The firmware package version identifier." , required = true)
	@XmlElement(required = true)
	private String fwVersion;

	/** @return The firmware package version identifier. */
	public String getFwVersion() {
		return this.fwVersion;
	}
	/** @param x The firmware package version identifier. */
	public void setFwVersion(String x) {
		this.fwVersion = x;
	}

	/** The application code version number. */
	@io.swagger.annotations.ApiModelProperty(value ="The application code version number." , required = true)
	@XmlElement(required = true)
	private String appVersion;

	/** @return The application code version number. */
	public String getAppVersion() {
		return this.appVersion;
	}
	/** @param x The application code version number. */
	public void setAppVersion(String x) {
		this.appVersion = x;
	}

	/** The boot code version number. */
	@io.swagger.annotations.ApiModelProperty(value ="The boot code version number." , required = true)
	@XmlElement(required = true)
	private String bootVersion;

	/** @return The boot code version number. */
	public String getBootVersion() {
		return this.bootVersion;
	}
	/** @param x The boot code version number. */
	public void setBootVersion(String x) {
		this.bootVersion = x;
	}

	/** The NVSRAM version number. */
	@io.swagger.annotations.ApiModelProperty(value ="The NVSRAM version number." , required = true)
	@XmlElement(required = true)
	private String nvsramVersion;

	/** @return The NVSRAM version number. */
	public String getNvsramVersion() {
		return this.nvsramVersion;
	}
	/** @param x The NVSRAM version number. */
	public void setNvsramVersion(String x) {
		this.nvsramVersion = x;
	}

	/** Timestamp when the staged FW was downloaded */
	@io.swagger.annotations.ApiModelProperty(value ="Timestamp when the staged FW was downloaded" , required = true)
	@XmlElement(required = true)
	private long timeStamp;

	/** @return Timestamp when the staged FW was downloaded */
	public long getTimeStamp() {
		return this.timeStamp;
	}
	/** @param x Timestamp when the staged FW was downloaded */
	public void setTimeStamp(long x) {
		this.timeStamp = x;
	}

	/** The field is deprecated. The nvsramVersion field should be used instead. */
	@io.swagger.annotations.ApiModelProperty(value ="The field is deprecated. The nvsramVersion field should be used instead." , required = true)
	@XmlElement(required = true)
	private String nvsramVersionString;

	/** @return The field is deprecated. The nvsramVersion field should be used instead. */
	public String getNvsramVersionString() {
		return this.nvsramVersionString;
	}
	/** @param x The field is deprecated. The nvsramVersion field should be used instead. */
	public void setNvsramVersionString(String x) {
		this.nvsramVersionString = x;
	}

	/** Version descriptors for staged code modules */
	@io.swagger.annotations.ApiModelProperty(value ="Version descriptors for staged code modules" , required = true)
	@XmlElement(required = true)
	private VersionDescriptor[] codeVersions;

	/** @return Version descriptors for staged code modules */
	public VersionDescriptor[] getCodeVersions() {
		return this.codeVersions;
	}
	/** @param x Version descriptors for staged code modules */
	public void setCodeVersions(VersionDescriptor[] x) {
		this.codeVersions = x;
	}
}
