package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union type is used for returning information from the array statistics activation procedures, activateDiscreteTimeSeries and activateHistogram. It contains a return code and, if the return code value is RETCODE_OK, a StatStreamId that can be used in other calls to refer to the active statistics set */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(515)
public class StatStreamIdReturned implements Serializable {
	public StatStreamIdReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** An unique identifier for the stream set that was activated. This field is only valid if returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="An unique identifier for the stream set that was activated. This field is only valid if returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private int streamId;

	/** @return An unique identifier for the stream set that was activated. This field is only valid if returnCode is equal to RETCODE_OK. */
	public int getStreamId() {
		return this.streamId;
	}
	/** @param x An unique identifier for the stream set that was activated. This field is only valid if returnCode is equal to RETCODE_OK. */
	public void setStreamId(int x) {
		this.streamId = x;
	}
}
