package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the setStorageArrayProperties procedure call. It contains new values set by the client for storage array changeable properties. All fields in this structure are variable-length, with upper bound of one. A field of length zero means don't change the associated storage array property; a field of length one means change the property to the supplied value. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(869)
public class StorageArrayChangeableProperties implements Serializable {
	public StorageArrayChangeableProperties() {
	}

	/** The new value to set for the storage array default host type index. */
	@io.swagger.annotations.ApiModelProperty(value ="The new value to set for the storage array default host type index." , required = true)
	@XmlElement(required = true)
	private int[] defaultHostTypeIndex;

	/** @return The new value to set for the storage array default host type index. */
	public int[] getDefaultHostTypeIndex() {
		return this.defaultHostTypeIndex;
	}
	/** @param x The new value to set for the storage array default host type index. */
	public void setDefaultHostTypeIndex(int[] x) {
		this.defaultHostTypeIndex = x;
	}

	/** The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time. */
	@io.swagger.annotations.ApiModelProperty(value ="The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time." , required = true)
	@XmlElement(required = true)
	private long[] nextBatteryLearnCycle;

	/** @return The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time. */
	public long[] getNextBatteryLearnCycle() {
		return this.nextBatteryLearnCycle;
	}
	/** @param x The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time. */
	public void setNextBatteryLearnCycle(long[] x) {
		this.nextBatteryLearnCycle = x;
	}

	/** The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not. */
	@io.swagger.annotations.ApiModelProperty(value ="The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not." , required = true)
	@XmlElement(required = true)
	private boolean[] syslogEnabled;

	/** @return The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not. */
	public boolean[] getSyslogEnabled() {
		return this.syslogEnabled;
	}
	/** @param x The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not. */
	public void setSyslogEnabled(boolean[] x) {
		this.syslogEnabled = x;
	}

	/** The new value to set for the IP address of the syslog server. */
	@io.swagger.annotations.ApiModelProperty(value ="The new value to set for the IP address of the syslog server." , required = true)
	@XmlElement(required = true)
	private IpVxAddress[] syslogServerIpAddress;

	/** @return The new value to set for the IP address of the syslog server. */
	public IpVxAddress[] getSyslogServerIpAddress() {
		return this.syslogServerIpAddress;
	}
	/** @param x The new value to set for the IP address of the syslog server. */
	public void setSyslogServerIpAddress(IpVxAddress[] x) {
		this.syslogServerIpAddress = x;
	}

	/** The new value to set for the UDP port number of the syslog server.. */
	@io.swagger.annotations.ApiModelProperty(value ="The new value to set for the UDP port number of the syslog server.." , required = true)
	@XmlElement(required = true)
	private int[] syslogServerPortNumber;

	/** @return The new value to set for the UDP port number of the syslog server.. */
	public int[] getSyslogServerPortNumber() {
		return this.syslogServerPortNumber;
	}
	/** @param x The new value to set for the UDP port number of the syslog server.. */
	public void setSyslogServerPortNumber(int[] x) {
		this.syslogServerPortNumber = x;
	}
}
