package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration data type identifies the different types of support CRUS that can be present. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(271)
public enum SupportCruType implements Serializable {
		/** The support CRU is unknown. */
		unknown(0),
		/** The support CRU is a power-fan CRU, meaning it can contain both power supplies and fans. */
		powerFan(1),
		/** The support CRU is a battery CRU, meaning it is just for holding batteries. */
		battery(2),
		/** The support CRU is a fan-only CRU. */
		fan(3),
		/** The support CRU is a power supply-only CRU. */
		powerSupply(4),
		__UNDEFINED(464378545);

		public final int value;

		private SupportCruType(int v) {
			this.value = v;
		}
}
