package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Specifies HTTP UTM tunnel request or reply data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(543)
public class SymbolTunnelRequest implements Serializable {
	public SymbolTunnelRequest() {
	}

	/** The list of key / value pairs use for HTTP request / reply properties. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of key / value pairs use for HTTP request / reply properties." , required = true)
	@XmlElement(required = true)
	private TunnelKeyValue[] keyValueList;

	/** @return The list of key / value pairs use for HTTP request / reply properties. */
	public TunnelKeyValue[] getKeyValueList() {
		return this.keyValueList;
	}
	/** @param x The list of key / value pairs use for HTTP request / reply properties. */
	public void setKeyValueList(TunnelKeyValue[] x) {
		this.keyValueList = x;
	}

	/** The opaque body data associated with a request or reply. */
	@io.swagger.annotations.ApiModelProperty(value ="The opaque body data associated with a request or reply." , required = true)
	@XmlElement(required = true)
	private String bodyData;

	/** @return The opaque body data associated with a request or reply. */
	public String getBodyData() {
		return this.bodyData;
	}
	/** @param x The opaque body data associated with a request or reply. */
	public void setBodyData(String x) {
		this.bodyData = x;
	}
}
