package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around a SystemAttributeDefaults structure. It is used by the getSystemAttributeDefaults procedures to return both a return code and the default attribute settings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(779)
public class SystemAttributeDefaultsReturned implements Serializable {
	public SystemAttributeDefaultsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The Disk Pool default attributes. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The Disk Pool default attributes. This field is present only if the value of returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private SystemAttributeDefaults defaults;

	/** @return The Disk Pool default attributes. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public SystemAttributeDefaults getDefaults() {
		return this.defaults;
	}
	/** @param x The Disk Pool default attributes. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public void setDefaults(SystemAttributeDefaults x) {
		this.defaults = x;
	}
}
