package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The structure is designed to model the critical aspects of a SCSI target. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(968)
public class Target implements Serializable {
	public Target() {
	}

	/** The reference that uniquely identifies an instance of this object. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference that uniquely identifies an instance of this object." , required = true)
	@XmlElement(required = true)
	private String targetRef;

	/** @return The reference that uniquely identifies an instance of this object. */
	public String getTargetRef() {
		return this.targetRef;
	}
	/** @param x The reference that uniquely identifies an instance of this object. */
	public void setTargetRef(String x) {
		this.targetRef = x;
	}

	/** The unique node name associated with the target. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique node name associated with the target." , required = true)
	@XmlElement(required = true)
	private ScsiNodeName nodeName;

	/** @return The unique node name associated with the target. */
	public ScsiNodeName getNodeName() {
		return this.nodeName;
	}
	/** @param x The unique node name associated with the target. */
	public void setNodeName(ScsiNodeName x) {
		this.nodeName = x;
	}

	/** An additional name that can be assigned to a target, which is usually "friendlier" than the node name. */
	@io.swagger.annotations.ApiModelProperty(value ="An additional name that can be assigned to a target, which is usually \"friendlier\" than the node name." , required = true)
	@XmlElement(required = true)
	private ScsiAlias alias;

	/** @return An additional name that can be assigned to a target, which is usually "friendlier" than the node name. */
	public ScsiAlias getAlias() {
		return this.alias;
	}
	/** @param x An additional name that can be assigned to a target, which is usually "friendlier" than the node name. */
	public void setAlias(ScsiAlias x) {
		this.alias = x;
	}

	/** The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED. */
	@io.swagger.annotations.ApiModelProperty(value ="The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED." , required = true)
	@XmlElement(required = true)
	private AuthenticationBundle configuredAuthMethods;

	/** @return The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED. */
	public AuthenticationBundle getConfiguredAuthMethods() {
		return this.configuredAuthMethods;
	}
	/** @param x The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED. */
	public void setConfiguredAuthMethods(AuthenticationBundle x) {
		this.configuredAuthMethods = x;
	}

	/** The set of configured (i.e., either in-use or listening for connections) portals associated with this target. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of configured (i.e., either in-use or listening for connections) portals associated with this target." , required = true)
	@XmlElement(required = true)
	private TargetPortal[] portals;

	/** @return The set of configured (i.e., either in-use or listening for connections) portals associated with this target. */
	public TargetPortal[] getPortals() {
		return this.portals;
	}
	/** @param x The set of configured (i.e., either in-use or listening for connections) portals associated with this target. */
	public void setPortals(TargetPortal[] x) {
		this.portals = x;
	}
}
