package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the setTargetProperties procedure. It indicates what properties the caller wants to set and the values for those properties. To support setting a subset of these properties, all of the fields are variable-length arrays of maximum size one; If the caller does not want to set a property, the corresponding length indicator should be zero; otherwise the length indicator is one, and the single element is the new value of the property. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(899)
public class TargetChangeableProperties implements Serializable {
	public TargetChangeableProperties() {
	}

	/** The alias name of the target. */
	@io.swagger.annotations.ApiModelProperty(value ="The alias name of the target." , required = true)
	@XmlElement(required = true)
	private ScsiAlias[] alias;

	/** @return The alias name of the target. */
	public ScsiAlias[] getAlias() {
		return this.alias;
	}
	/** @param x The alias name of the target. */
	public void setAlias(ScsiAlias[] x) {
		this.alias = x;
	}

	/** The set of the authentication methods for the target. This field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of the authentication methods for the target. This field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero." , required = true)
	@XmlElement(required = true)
	private AuthenticationBundle[] configuredAuthMethods;

	/** @return The set of the authentication methods for the target. This field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	public AuthenticationBundle[] getConfiguredAuthMethods() {
		return this.configuredAuthMethods;
	}
	/** @param x The set of the authentication methods for the target. This field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	public void setConfiguredAuthMethods(AuthenticationBundle[] x) {
		this.configuredAuthMethods = x;
	}
}
