package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The structure contains information about a target portal. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(815)
public class TargetPortal implements Serializable {
	public TargetPortal() {
	}

	/** A value identifying the portal group to which this portal belongs. */
	@io.swagger.annotations.ApiModelProperty(value ="A value identifying the portal group to which this portal belongs." , required = true)
	@XmlElement(required = true)
	private short groupTag;

	/** @return A value identifying the portal group to which this portal belongs. */
	public short getGroupTag() {
		return this.groupTag;
	}
	/** @param x A value identifying the portal group to which this portal belongs. */
	public void setGroupTag(short x) {
		this.groupTag = x;
	}

	/** The IP address of the portal. */
	@io.swagger.annotations.ApiModelProperty(value ="The IP address of the portal." , required = true)
	@XmlElement(required = true)
	private IpVxAddress ipAddress;

	/** @return The IP address of the portal. */
	public IpVxAddress getIpAddress() {
		return this.ipAddress;
	}
	/** @param x The IP address of the portal. */
	public void setIpAddress(IpVxAddress x) {
		this.ipAddress = x;
	}

	/** The number of the TCP port on which the target listens for incoming connections. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of the TCP port on which the target listens for incoming connections." , required = true)
	@XmlElement(required = true)
	private int tcpListenPort;

	/** @return The number of the TCP port on which the target listens for incoming connections. */
	public int getTcpListenPort() {
		return this.tcpListenPort;
	}
	/** @param x The number of the TCP port on which the target listens for incoming connections. */
	public void setTcpListenPort(int x) {
		this.tcpListenPort = x;
	}
}
