package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains current data about a single thermal sensor. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(849)
public class ThermalSensorData implements Serializable {
	public ThermalSensorData() {
	}

	/** A reference to a thermal sensor object. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to a thermal sensor object." , required = true)
	@XmlElement(required = true)
	private String thermalSensorRef;

	/** @return A reference to a thermal sensor object. */
	public String getThermalSensorRef() {
		return this.thermalSensorRef;
	}
	/** @param x A reference to a thermal sensor object. */
	public void setThermalSensorRef(String x) {
		this.thermalSensorRef = x;
	}

	/** This value is the current temperature in degrees Celsius, if it is known, otherwise it will be set to a value in the ThermalSensorValue enumeration. Some sensors only report the temperature during an alarm condition. In that case, this field will normally be set to THERMAL_SENSOR_DATA_NOMINAL and will only contain the actual temperature when the alarm is active. */
	@io.swagger.annotations.ApiModelProperty(value ="This value is the current temperature in degrees Celsius, if it is known, otherwise it will be set to a value in the ThermalSensorValue enumeration. Some sensors only report the temperature during an alarm condition. In that case, this field will normally be set to THERMAL_SENSOR_DATA_NOMINAL and will only contain the actual temperature when the alarm is active." , required = true)
	@XmlElement(required = true)
	private int currentTemp;

	/** @return This value is the current temperature in degrees Celsius, if it is known, otherwise it will be set to a value in the ThermalSensorValue enumeration. Some sensors only report the temperature during an alarm condition. In that case, this field will normally be set to THERMAL_SENSOR_DATA_NOMINAL and will only contain the actual temperature when the alarm is active. */
	public int getCurrentTemp() {
		return this.currentTemp;
	}
	/** @param x This value is the current temperature in degrees Celsius, if it is known, otherwise it will be set to a value in the ThermalSensorValue enumeration. Some sensors only report the temperature during an alarm condition. In that case, this field will normally be set to THERMAL_SENSOR_DATA_NOMINAL and will only contain the actual temperature when the alarm is active. */
	public void setCurrentTemp(int x) {
		this.currentTemp = x;
	}
}
