package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains details about the capacity provisioning of a thin volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(383)
public class ThinVolumeCapacityProvisioningDetails implements Serializable {
	public ThinVolumeCapacityProvisioningDetails() {
	}

	/** The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum capacity to which the Expandable Repository Volume can grow (in bytes)." , required = true)
	@XmlElement(required = true)
	private long capacityQuota;

	/** @return The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	public long getCapacityQuota() {
		return this.capacityQuota;
	}
	/** @param x The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	public void setCapacityQuota(long x) {
		this.capacityQuota = x;
	}

	/** The alert threshold percent value for the Expandable Repository Volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The alert threshold percent value for the Expandable Repository Volume." , required = true)
	@XmlElement(required = true)
	private int growthAlertThreshold;

	/** @return The alert threshold percent value for the Expandable Repository Volume. */
	public int getGrowthAlertThreshold() {
		return this.growthAlertThreshold;
	}
	/** @param x The alert threshold percent value for the Expandable Repository Volume. */
	public void setGrowthAlertThreshold(int x) {
		this.growthAlertThreshold = x;
	}

	/** The expansion policy for the Expandable Repository Volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The expansion policy for the Expandable Repository Volume." , required = true)
	@XmlElement(required = true)
	private ThinVolumeRepositoryExpansionPolicy repositoryExpansionPolicy = ThinVolumeRepositoryExpansionPolicy.__UNDEFINED;

	/** @return The expansion policy for the Expandable Repository Volume. */
	public ThinVolumeRepositoryExpansionPolicy getRepositoryExpansionPolicy() {
		return this.repositoryExpansionPolicy;
	}
	/** @param x The expansion policy for the Expandable Repository Volume. */
	public void setRepositoryExpansionPolicy(ThinVolumeRepositoryExpansionPolicy x) {
		this.repositoryExpansionPolicy = x;
	}
}
