package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes the thin volume to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1176)
public class ThinVolumeCreationDescriptor implements Serializable {
	public ThinVolumeCreationDescriptor() {
	}

	/** The repository creation type. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository creation type." , required = true)
	@XmlElement(required = true)
	private ConcatVolumeCreationDescriptor repositoryCreationDescriptor;

	/** @return The repository creation type. */
	public ConcatVolumeCreationDescriptor getRepositoryCreationDescriptor() {
		return this.repositoryCreationDescriptor;
	}
	/** @param x The repository creation type. */
	public void setRepositoryCreationDescriptor(ConcatVolumeCreationDescriptor x) {
		this.repositoryCreationDescriptor = x;
	}

	/** The user assigned volume name. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned volume name." , required = true)
	@XmlElement(required = true)
	private String volumeLabel;

	/** @return The user assigned volume name. */
	public String getVolumeLabel() {
		return this.volumeLabel;
	}
	/** @param x The user assigned volume name. */
	public void setVolumeLabel(String x) {
		this.volumeLabel = x;
	}

	/** The controller that will manage the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller that will manage the volume." , required = true)
	@XmlElement(required = true)
	private String manager;

	/** @return The controller that will manage the volume. */
	public String getManager() {
		return this.manager;
	}
	/** @param x The controller that will manage the volume. */
	public void setManager(String x) {
		this.manager = x;
	}

	/** The thin volume capacity (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The thin volume capacity (in bytes)." , required = true)
	@XmlElement(required = true)
	private long virtualCapacity;

	/** @return The thin volume capacity (in bytes). */
	public long getVirtualCapacity() {
		return this.virtualCapacity;
	}
	/** @param x The thin volume capacity (in bytes). */
	public void setVirtualCapacity(long x) {
		this.virtualCapacity = x;
	}

	/** The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum capacity to which the Expandable Repository Volume can grow (in bytes)." , required = true)
	@XmlElement(required = true)
	private long provisionedCapacityQuota;

	/** @return The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	public long getProvisionedCapacityQuota() {
		return this.provisionedCapacityQuota;
	}
	/** @param x The maximum capacity to which the Expandable Repository Volume can grow (in bytes). */
	public void setProvisionedCapacityQuota(long x) {
		this.provisionedCapacityQuota = x;
	}

	/** If true (non-zero), automatic cache read-ahead is enabled. If false (zero), automatic cache read-ahead is disabled. */
	@io.swagger.annotations.ApiModelProperty(value ="If true (non-zero), automatic cache read-ahead is enabled. If false (zero), automatic cache read-ahead is disabled." , required = true)
	@XmlElement(required = true)
	private int readAhead;

	/** @return If true (non-zero), automatic cache read-ahead is enabled. If false (zero), automatic cache read-ahead is disabled. */
	public int getReadAhead() {
		return this.readAhead;
	}
	/** @param x If true (non-zero), automatic cache read-ahead is enabled. If false (zero), automatic cache read-ahead is disabled. */
	public void setReadAhead(int x) {
		this.readAhead = x;
	}

	/** If true, default mapping will not be created. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, default mapping will not be created." , required = true)
	@XmlElement(required = true)
	private boolean noMapping;

	/** @return If true, default mapping will not be created. */
	public boolean isNoMapping() {
		return this.noMapping;
	}
	/** @param x If true, default mapping will not be created. */
	public void setNoMapping(boolean x) {
		this.noMapping = x;
	}

	/** The expansion policy for the Expandable Repository Volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The expansion policy for the Expandable Repository Volume." , required = true)
	@XmlElement(required = true)
	private ThinVolumeRepositoryExpansionPolicy repositoryExpansionPolicy = ThinVolumeRepositoryExpansionPolicy.__UNDEFINED;

	/** @return The expansion policy for the Expandable Repository Volume. */
	public ThinVolumeRepositoryExpansionPolicy getRepositoryExpansionPolicy() {
		return this.repositoryExpansionPolicy;
	}
	/** @param x The expansion policy for the Expandable Repository Volume. */
	public void setRepositoryExpansionPolicy(ThinVolumeRepositoryExpansionPolicy x) {
		this.repositoryExpansionPolicy = x;
	}

	/** The alert threshold percent value for the Expandable Repository Volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The alert threshold percent value for the Expandable Repository Volume." , required = true)
	@XmlElement(required = true)
	private int growthAlertThreshold;

	/** @return The alert threshold percent value for the Expandable Repository Volume. */
	public int getGrowthAlertThreshold() {
		return this.growthAlertThreshold;
	}
	/** @param x The alert threshold percent value for the Expandable Repository Volume. */
	public void setGrowthAlertThreshold(int x) {
		this.growthAlertThreshold = x;
	}

	/** Specifies which protection type should be used for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="Specifies which protection type should be used for the volume." , required = true)
	@XmlElement(required = true)
	private ProtectionType protectionType = ProtectionType.__UNDEFINED;

	/** @return Specifies which protection type should be used for the volume. */
	public ProtectionType getProtectionType() {
		return this.protectionType;
	}
	/** @param x Specifies which protection type should be used for the volume. */
	public void setProtectionType(ProtectionType x) {
		this.protectionType = x;
	}
}
