package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains static default values for Thin Volumes. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(332)
public class ThinVolumeDefaultAttributes implements Serializable {
	public ThinVolumeDefaultAttributes() {
	}

	/** The minimum provisioned capacity in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum provisioned capacity in bytes." , required = true)
	@XmlElement(required = true)
	private long minProvisionedCapacity;

	/** @return The minimum provisioned capacity in bytes. */
	public long getMinProvisionedCapacity() {
		return this.minProvisionedCapacity;
	}
	/** @param x The minimum provisioned capacity in bytes. */
	public void setMinProvisionedCapacity(long x) {
		this.minProvisionedCapacity = x;
	}

	/** The maximum provisioned capacity in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum provisioned capacity in bytes." , required = true)
	@XmlElement(required = true)
	private long maxProvisionedCapacity;

	/** @return The maximum provisioned capacity in bytes. */
	public long getMaxProvisionedCapacity() {
		return this.maxProvisionedCapacity;
	}
	/** @param x The maximum provisioned capacity in bytes. */
	public void setMaxProvisionedCapacity(long x) {
		this.maxProvisionedCapacity = x;
	}

	/** The minimum virtual capacity in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum virtual capacity in bytes." , required = true)
	@XmlElement(required = true)
	private long minVirtualCapacity;

	/** @return The minimum virtual capacity in bytes. */
	public long getMinVirtualCapacity() {
		return this.minVirtualCapacity;
	}
	/** @param x The minimum virtual capacity in bytes. */
	public void setMinVirtualCapacity(long x) {
		this.minVirtualCapacity = x;
	}

	/** The maximum virtual capacity in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum virtual capacity in bytes." , required = true)
	@XmlElement(required = true)
	private long maxVirtualCapacity;

	/** @return The maximum virtual capacity in bytes. */
	public long getMaxVirtualCapacity() {
		return this.maxVirtualCapacity;
	}
	/** @param x The maximum virtual capacity in bytes. */
	public void setMaxVirtualCapacity(long x) {
		this.maxVirtualCapacity = x;
	}

	/** The minimum alert threshold as a percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The minimum alert threshold as a percentage." , required = true)
	@XmlElement(required = true)
	private int minAlertThreshold;

	/** @return The minimum alert threshold as a percentage. */
	public int getMinAlertThreshold() {
		return this.minAlertThreshold;
	}
	/** @param x The minimum alert threshold as a percentage. */
	public void setMinAlertThreshold(int x) {
		this.minAlertThreshold = x;
	}

	/** The default alert threshold as a percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The default alert threshold as a percentage." , required = true)
	@XmlElement(required = true)
	private int defaultAlertThreshold;

	/** @return The default alert threshold as a percentage. */
	public int getDefaultAlertThreshold() {
		return this.defaultAlertThreshold;
	}
	/** @param x The default alert threshold as a percentage. */
	public void setDefaultAlertThreshold(int x) {
		this.defaultAlertThreshold = x;
	}
}
