package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration defines the actions to take on a thin volume re-initialize request. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(255)
public enum ThinVolumeReinitializeAction implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** Reinitialize the thin volume. */
		only(1),
		/** Reinitialize the thin volume and resize the repository. */
		andResize(2),
		/** Reinitialize the thin volume and use a different repository. */
		newRepository(3),
		__UNDEFINED(464378545);

		public final int value;

		private ThinVolumeReinitializeAction(int v) {
			this.value = v;
		}
}
