package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains data describing a thin volume expansion event. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1043)
public class ThinVolumeRepositoryExpansionHistoryData implements Serializable {
	public ThinVolumeRepositoryExpansionHistoryData() {
	}

	/** A reference to the thin volume. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the thin volume." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return A reference to the thin volume. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x A reference to the thin volume. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The type of expansion. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of expansion." , required = true)
	@XmlElement(required = true)
	private ThinVolumeRepositoryExpansionType type = ThinVolumeRepositoryExpansionType.__UNDEFINED;

	/** @return The type of expansion. */
	public ThinVolumeRepositoryExpansionType getType() {
		return this.type;
	}
	/** @param x The type of expansion. */
	public void setType(ThinVolumeRepositoryExpansionType x) {
		this.type = x;
	}

	/** The start timestamp of expansion operation, in seconds since January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The start timestamp of expansion operation, in seconds since January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long startTime;

	/** @return The start timestamp of expansion operation, in seconds since January 1, 1970. */
	public long getStartTime() {
		return this.startTime;
	}
	/** @param x The start timestamp of expansion operation, in seconds since January 1, 1970. */
	public void setStartTime(long x) {
		this.startTime = x;
	}

	/** The repository capacity before expansion (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The repository capacity before expansion (in bytes)." , required = true)
	@XmlElement(required = true)
	private long preExpansionCapacityInBytes;

	/** @return The repository capacity before expansion (in bytes). */
	public long getPreExpansionCapacityInBytes() {
		return this.preExpansionCapacityInBytes;
	}
	/** @param x The repository capacity before expansion (in bytes). */
	public void setPreExpansionCapacityInBytes(long x) {
		this.preExpansionCapacityInBytes = x;
	}

	/** The repository capacity after expansion (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The repository capacity after expansion (in bytes)." , required = true)
	@XmlElement(required = true)
	private long postExpansionCapacityInBytes;

	/** @return The repository capacity after expansion (in bytes). */
	public long getPostExpansionCapacityInBytes() {
		return this.postExpansionCapacityInBytes;
	}
	/** @param x The repository capacity after expansion (in bytes). */
	public void setPostExpansionCapacityInBytes(long x) {
		this.postExpansionCapacityInBytes = x;
	}
}
