package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration describes a thin volume's Expandable Repository Volume expansion event type. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(78)
public enum ThinVolumeRepositoryExpansionType implements Serializable {
		/** This should never happen. */
		expansionTypeUnknown(0),
		/** The repository was expanded manually. */
		expansionTypeManual(1),
		/** The repository was expanded automatically. */
		expansionTypeAutomatic(2),
		/** Thin Volume automatic contraction */
		contractionTypeAutomatic(3),
		__UNDEFINED(464378545);

		public final int value;

		private ThinVolumeRepositoryExpansionType(int v) {
			this.value = v;
		}
}
