package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convert from GMT to local time using DST rules. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(803)
public class TimeZoneDescription implements Serializable {
	public TimeZoneDescription() {
	}

	/** The time zone identifier (ASCII). */
	@io.swagger.annotations.ApiModelProperty(value ="The time zone identifier (ASCII)." , required = true)
	@XmlElement(required = true)
	private String tzLabel;

	/** @return The time zone identifier (ASCII). */
	public String getTzLabel() {
		return this.tzLabel;
	}
	/** @param x The time zone identifier (ASCII). */
	public void setTzLabel(String x) {
		this.tzLabel = x;
	}

	/** The time zone offset measured in seconds +/- from GMT. */
	@io.swagger.annotations.ApiModelProperty(value ="The time zone offset measured in seconds +/- from GMT." , required = true)
	@XmlElement(required = true)
	private int tzOffset;

	/** @return The time zone offset measured in seconds +/- from GMT. */
	public int getTzOffset() {
		return this.tzOffset;
	}
	/** @param x The time zone offset measured in seconds +/- from GMT. */
	public void setTzOffset(int x) {
		this.tzOffset = x;
	}

	/** The DST start date and time. */
	@io.swagger.annotations.ApiModelProperty(value ="The DST start date and time." , required = true)
	@XmlElement(required = true)
	private DaylightSavingsTime dstStart;

	/** @return The DST start date and time. */
	public DaylightSavingsTime getDstStart() {
		return this.dstStart;
	}
	/** @param x The DST start date and time. */
	public void setDstStart(DaylightSavingsTime x) {
		this.dstStart = x;
	}

	/** The DST end date and time. */
	@io.swagger.annotations.ApiModelProperty(value ="The DST end date and time." , required = true)
	@XmlElement(required = true)
	private DaylightSavingsTime dstEnd;

	/** @return The DST end date and time. */
	public DaylightSavingsTime getDstEnd() {
		return this.dstEnd;
	}
	/** @param x The DST end date and time. */
	public void setDstEnd(DaylightSavingsTime x) {
		this.dstEnd = x;
	}

	/** The number of seconds to adjust the clock during DST */
	@io.swagger.annotations.ApiModelProperty(value ="The number of seconds to adjust the clock during DST" , required = true)
	@XmlElement(required = true)
	private int dstAdjust;

	/** @return The number of seconds to adjust the clock during DST */
	public int getDstAdjust() {
		return this.dstAdjust;
	}
	/** @param x The number of seconds to adjust the clock during DST */
	public void setDstAdjust(int x) {
		this.dstAdjust = x;
	}
}
