package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The field driveTechnologies, which supports mixing drive types within a tray, was previously associated with the Shea Enclosure API changes. It is now understood that drive mixing within a tray is independent of Shea and, in fact, is introduced in Amethyst. This will have an impact on how the ifdefs in SYMbolAPI.px are set up. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(910)
public class Tray implements Serializable,devmgr.api.model.Identifiable {
	public Tray() {
	}

	/** An indication of the type of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of the type of the tray." , required = true)
	@XmlElement(required = true)
	private TrayType type = TrayType.__UNDEFINED;

	/** @return An indication of the type of the tray. */
	public TrayType getType() {
		return this.type;
	}
	/** @param x An indication of the type of the tray. */
	public void setType(TrayType x) {
		this.type = x;
	}

	/** An indication of the physical orientation (horizontal or vertical) of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of the physical orientation (horizontal or vertical) of the tray." , required = true)
	@XmlElement(required = true)
	private TrayOrientation orientation = TrayOrientation.__UNDEFINED;

	/** @return An indication of the physical orientation (horizontal or vertical) of the tray. */
	public TrayOrientation getOrientation() {
		return this.orientation;
	}
	/** @param x An indication of the physical orientation (horizontal or vertical) of the tray. */
	public void setOrientation(TrayOrientation x) {
		this.orientation = x;
	}

	/** The number of slots available for holding RAID controller boards (i.e., set to zero for a drive-only tray). */
	@io.swagger.annotations.ApiModelProperty(value ="The number of slots available for holding RAID controller boards (i.e., set to zero for a drive-only tray)." , required = true)
	@XmlElement(required = true)
	private int numControllerSlots;

	/** @return The number of slots available for holding RAID controller boards (i.e., set to zero for a drive-only tray). */
	public int getNumControllerSlots() {
		return this.numControllerSlots;
	}
	/** @param x The number of slots available for holding RAID controller boards (i.e., set to zero for a drive-only tray). */
	public void setNumControllerSlots(int x) {
		this.numControllerSlots = x;
	}

	/** The total number of slots available for holding disk drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of slots available for holding disk drives." , required = true)
	@XmlElement(required = true)
	private int numDriveSlots;

	/** @return The total number of slots available for holding disk drives. */
	public int getNumDriveSlots() {
		return this.numDriveSlots;
	}
	/** @param x The total number of slots available for holding disk drives. */
	public void setNumDriveSlots(int x) {
		this.numDriveSlots = x;
	}

	/** The tray identifier value, which is typically set using physical switches on the tray itself. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray identifier value, which is typically set using physical switches on the tray itself." , required = true)
	@XmlElement(required = true)
	private int trayId;

	/** @return The tray identifier value, which is typically set using physical switches on the tray itself. */
	public int getTrayId() {
		return this.trayId;
	}
	/** @param x The tray identifier value, which is typically set using physical switches on the tray itself. */
	public void setTrayId(int x) {
		this.trayId = x;
	}

	/** The identifier value for this tray. Other objects may use this reference value to refer to the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The identifier value for this tray. Other objects may use this reference value to refer to the tray." , required = true)
	@XmlElement(required = true)
	private String trayRef;

	/** @return The identifier value for this tray. Other objects may use this reference value to refer to the tray. */
	public String getTrayRef() {
		return this.trayRef;
	}
	/** @param x The identifier value for this tray. Other objects may use this reference value to refer to the tray. */
	public void setTrayRef(String x) {
		this.trayRef = x;
	}

	/** True, if the tray does not have redundant access. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if the tray does not have redundant access." , required = true)
	@XmlElement(required = true)
	private boolean nonRedundantAccess;

	/** @return True, if the tray does not have redundant access. */
	public boolean isNonRedundantAccess() {
		return this.nonRedundantAccess;
	}
	/** @param x True, if the tray does not have redundant access. */
	public void setNonRedundantAccess(boolean x) {
		this.nonRedundantAccess = x;
	}

	/** The part number of the tray from VPD data. */
	@io.swagger.annotations.ApiModelProperty(value ="The part number of the tray from VPD data." , required = true)
	@XmlElement(required = true)
	private String partNumber;

	/** @return The part number of the tray from VPD data. */
	public String getPartNumber() {
		return this.partNumber;
	}
	/** @param x The part number of the tray from VPD data. */
	public void setPartNumber(String x) {
		this.partNumber = x;
	}

	/** The serial number of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The serial number of the tray." , required = true)
	@XmlElement(required = true)
	private String serialNumber;

	/** @return The serial number of the tray. */
	public String getSerialNumber() {
		return this.serialNumber;
	}
	/** @param x The serial number of the tray. */
	public void setSerialNumber(String x) {
		this.serialNumber = x;
	}

	/** The name of the manufacturer of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the manufacturer of the tray." , required = true)
	@XmlElement(required = true)
	private String vendorName;

	/** @return The name of the manufacturer of the tray. */
	public String getVendorName() {
		return this.vendorName;
	}
	/** @param x The name of the manufacturer of the tray. */
	public void setVendorName(String x) {
		this.vendorName = x;
	}

	/** The date the tray was manufactured. */
	@io.swagger.annotations.ApiModelProperty(value ="The date the tray was manufactured." , required = true)
	@XmlElement(required = true)
	private long manufacturerDate;

	/** @return The date the tray was manufactured. */
	public long getManufacturerDate() {
		return this.manufacturerDate;
	}
	/** @param x The date the tray was manufactured. */
	public void setManufacturerDate(long x) {
		this.manufacturerDate = x;
	}

	/** The field replaceable unit type of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The field replaceable unit type of the tray." , required = true)
	@XmlElement(required = true)
	private String fruType;

	/** @return The field replaceable unit type of the tray. */
	public String getFruType() {
		return this.fruType;
	}
	/** @param x The field replaceable unit type of the tray. */
	public void setFruType(String x) {
		this.fruType = x;
	}

	/** True if the IDs on the ESMs do not match. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the IDs on the ESMs do not match." , required = true)
	@XmlElement(required = true)
	private boolean trayIDMismatch;

	/** @return True if the IDs on the ESMs do not match. */
	public boolean isTrayIDMismatch() {
		return this.trayIDMismatch;
	}
	/** @param x True if the IDs on the ESMs do not match. */
	public void setTrayIDMismatch(boolean x) {
		this.trayIDMismatch = x;
	}

	/** True if this tray ID conflicts with that of another tray. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray ID conflicts with that of another tray." , required = true)
	@XmlElement(required = true)
	private boolean trayIDConflict;

	/** @return True if this tray ID conflicts with that of another tray. */
	public boolean isTrayIDConflict() {
		return this.trayIDConflict;
	}
	/** @param x True if this tray ID conflicts with that of another tray. */
	public void setTrayIDConflict(boolean x) {
		this.trayIDConflict = x;
	}

	/** True if the ESM firmware versions do not match. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the ESM firmware versions do not match." , required = true)
	@XmlElement(required = true)
	private boolean esmVersionMismatch;

	/** @return True if the ESM firmware versions do not match. */
	public boolean isEsmVersionMismatch() {
		return this.esmVersionMismatch;
	}
	/** @param x True if the ESM firmware versions do not match. */
	public void setEsmVersionMismatch(boolean x) {
		this.esmVersionMismatch = x;
	}

	/** True if this tray has an ESM join miswire. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray has an ESM join miswire." , required = true)
	@XmlElement(required = true)
	private boolean esmMiswire;

	/** @return True if this tray has an ESM join miswire. */
	public boolean isEsmMiswire() {
		return this.esmMiswire;
	}
	/** @param x True if this tray has an ESM join miswire. */
	public void setEsmMiswire(boolean x) {
		this.esmMiswire = x;
	}

	/** True if this tray has a drive-side minihub speed mismatch. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray has a drive-side minihub speed mismatch." , required = true)
	@XmlElement(required = true)
	private boolean drvMHSpeedMismatch;

	/** @return True if this tray has a drive-side minihub speed mismatch. */
	public boolean isDrvMHSpeedMismatch() {
		return this.drvMHSpeedMismatch;
	}
	/** @param x True if this tray has a drive-side minihub speed mismatch. */
	public void setDrvMHSpeedMismatch(boolean x) {
		this.drvMHSpeedMismatch = x;
	}

	/** True if this tray is an unrecognized/unsupported hardware type. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray is an unrecognized/unsupported hardware type." , required = true)
	@XmlElement(required = true)
	private boolean unsupportedTray;

	/** @return True if this tray is an unrecognized/unsupported hardware type. */
	public boolean isUnsupportedTray() {
		return this.unsupportedTray;
	}
	/** @param x True if this tray is an unrecognized/unsupported hardware type. */
	public void setUnsupportedTray(boolean x) {
		this.unsupportedTray = x;
	}

	/** The channel to the tray that is still operational (if nonRedundantAccess is True). */
	@io.swagger.annotations.ApiModelProperty(value ="The channel to the tray that is still operational (if nonRedundantAccess is True)." , required = true)
	@XmlElement(required = true)
	private int workingChannel;

	/** @return The channel to the tray that is still operational (if nonRedundantAccess is True). */
	public int getWorkingChannel() {
		return this.workingChannel;
	}
	/** @param x The channel to the tray that is still operational (if nonRedundantAccess is True). */
	public void setWorkingChannel(int x) {
		this.workingChannel = x;
	}

	/** The maximum speed of the drive channels, */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum speed of the drive channels," , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed maxSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The maximum speed of the drive channels, */
	public InterfaceSpeed getMaxSpeed() {
		return this.maxSpeed;
	}
	/** @param x The maximum speed of the drive channels, */
	public void setMaxSpeed(InterfaceSpeed x) {
		this.maxSpeed = x;
	}

	/** The interface technology. This field is deprecated. Equivalent information is available in the driveTechnologies and frontEndInterfaceTechnology fields. */
	@io.swagger.annotations.ApiModelProperty(value ="The interface technology. This field is deprecated. Equivalent information is available in the driveTechnologies and frontEndInterfaceTechnology fields." , required = true)
	@XmlElement(required = true)
	private TrayTechnologyType trayTechnologyType = TrayTechnologyType.__UNDEFINED;

	/** @return The interface technology. This field is deprecated. Equivalent information is available in the driveTechnologies and frontEndInterfaceTechnology fields. */
	public TrayTechnologyType getTrayTechnologyType() {
		return this.trayTechnologyType;
	}
	/** @param x The interface technology. This field is deprecated. Equivalent information is available in the driveTechnologies and frontEndInterfaceTechnology fields. */
	public void setTrayTechnologyType(TrayTechnologyType x) {
		this.trayTechnologyType = x;
	}

	/** True if SBOD ESM trays are not properly clustered. */
	@io.swagger.annotations.ApiModelProperty(value ="True if SBOD ESM trays are not properly clustered." , required = true)
	@XmlElement(required = true)
	private boolean esmGroupError;

	/** @return True if SBOD ESM trays are not properly clustered. */
	public boolean isEsmGroupError() {
		return this.esmGroupError;
	}
	/** @param x True if SBOD ESM trays are not properly clustered. */
	public void setEsmGroupError(boolean x) {
		this.esmGroupError = x;
	}

	/** True if this tray is an uncertified hardware type. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray is an uncertified hardware type." , required = true)
	@XmlElement(required = true)
	private boolean uncertifiedTray;

	/** @return True if this tray is an uncertified hardware type. */
	public boolean isUncertifiedTray() {
		return this.uncertifiedTray;
	}
	/** @param x True if this tray is an uncertified hardware type. */
	public void setUncertifiedTray(boolean x) {
		this.uncertifiedTray = x;
	}

	/** True if this tray supports a locate operation. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this tray supports a locate operation." , required = true)
	@XmlElement(required = true)
	private boolean locateTray;

	/** @return True if this tray supports a locate operation. */
	public boolean isLocateTray() {
		return this.locateTray;
	}
	/** @param x True if this tray supports a locate operation. */
	public void setLocateTray(boolean x) {
		this.locateTray = x;
	}

	/** True if the ESM hardware components in the tray are mismatched. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the ESM hardware components in the tray are mismatched." , required = true)
	@XmlElement(required = true)
	private boolean esmHardwareMismatch;

	/** @return True if the ESM hardware components in the tray are mismatched. */
	public boolean isEsmHardwareMismatch() {
		return this.esmHardwareMismatch;
	}
	/** @param x True if the ESM hardware components in the tray are mismatched. */
	public void setEsmHardwareMismatch(boolean x) {
		this.esmHardwareMismatch = x;
	}

	/** True if the tray ID can be set using the updateTray procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the tray ID can be set using the updateTray procedure." , required = true)
	@XmlElement(required = true)
	private boolean hasConfigurableTrayId;

	/** @return True if the tray ID can be set using the updateTray procedure. */
	public boolean isHasConfigurableTrayId() {
		return this.hasConfigurableTrayId;
	}
	/** @param x True if the tray ID can be set using the updateTray procedure. */
	public void setHasConfigurableTrayId(boolean x) {
		this.hasConfigurableTrayId = x;
	}

	/** The front-end I/O interface technology of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The front-end I/O interface technology of the tray." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType frontEndInterfaceTechnology = IOInterfaceType.__UNDEFINED;

	/** @return The front-end I/O interface technology of the tray. */
	public IOInterfaceType getFrontEndInterfaceTechnology() {
		return this.frontEndInterfaceTechnology;
	}
	/** @param x The front-end I/O interface technology of the tray. */
	public void setFrontEndInterfaceTechnology(IOInterfaceType x) {
		this.frontEndInterfaceTechnology = x;
	}

	/** A list of drive technologies that are present in the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="A list of drive technologies that are present in the tray." , required = true)
	@XmlElement(required = true)
	private PhysicalDriveType[] driveTechnologies;

	/** @return A list of drive technologies that are present in the tray. */
	public PhysicalDriveType[] getDriveTechnologies() {
		return this.driveTechnologies;
	}
	/** @param x A list of drive technologies that are present in the tray. */
	public void setDriveTechnologies(PhysicalDriveType[] x) {
		this.driveTechnologies = x;
	}

	/** The number of drive compartments in the tray. Some drive trays are subdivided into "compartments," each having the same number of drive slots. Looking at the front of such an enclosure, multiple compartments are arranged side by side along one dimension, while drives within a compartment are arranged side by side along the other dimension, allowing for greater overall drive density within the constraints of a given enclosure form factor. (Even when arranged as a series of compartments, drive slot numbering is still relative to the entire tray.) */
	@io.swagger.annotations.ApiModelProperty(value ="The number of drive compartments in the tray. Some drive trays are subdivided into \"compartments,\" each having the same number of drive slots. Looking at the front of such an enclosure, multiple compartments are arranged side by side along one dimension, while drives within a compartment are arranged side by side along the other dimension, allowing for greater overall drive density within the constraints of a given enclosure form factor. (Even when arranged as a series of compartments, drive slot numbering is still relative to the entire tray.)" , required = true)
	@XmlElement(required = true)
	private int numDriveCompartments;

	/** @return The number of drive compartments in the tray. Some drive trays are subdivided into "compartments," each having the same number of drive slots. Looking at the front of such an enclosure, multiple compartments are arranged side by side along one dimension, while drives within a compartment are arranged side by side along the other dimension, allowing for greater overall drive density within the constraints of a given enclosure form factor. (Even when arranged as a series of compartments, drive slot numbering is still relative to the entire tray.) */
	public int getNumDriveCompartments() {
		return this.numDriveCompartments;
	}
	/** @param x The number of drive compartments in the tray. Some drive trays are subdivided into "compartments," each having the same number of drive slots. Looking at the front of such an enclosure, multiple compartments are arranged side by side along one dimension, while drives within a compartment are arranged side by side along the other dimension, allowing for greater overall drive density within the constraints of a given enclosure form factor. (Even when arranged as a series of compartments, drive slot numbering is still relative to the entire tray.) */
	public void setNumDriveCompartments(int x) {
		this.numDriveCompartments = x;
	}

	/** The number of drive slots within an individual drive compartment. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of drive slots within an individual drive compartment." , required = true)
	@XmlElement(required = true)
	private int numDriveSlotsPerCompartment;

	/** @return The number of drive slots within an individual drive compartment. */
	public int getNumDriveSlotsPerCompartment() {
		return this.numDriveSlotsPerCompartment;
	}
	/** @param x The number of drive slots within an individual drive compartment. */
	public void setNumDriveSlotsPerCompartment(int x) {
		this.numDriveSlotsPerCompartment = x;
	}

	/** The tray attribute data (see setTrayAttributes procedure). */
	@io.swagger.annotations.ApiModelProperty(value ="The tray attribute data (see setTrayAttributes procedure)." , required = true)
	@XmlElement(required = true)
	private TrayAttribute[] trayAttributes;

	/** @return The tray attribute data (see setTrayAttributes procedure). */
	public TrayAttribute[] getTrayAttributes() {
		return this.trayAttributes;
	}
	/** @param x The tray attribute data (see setTrayAttributes procedure). */
	public void setTrayAttributes(TrayAttribute[] x) {
		this.trayAttributes = x;
	}

	/** True, if the tray has invalid configuration settings. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if the tray has invalid configuration settings." , required = true)
	@XmlElement(required = true)
	private boolean isMisconfigured;

	/** @return True, if the tray has invalid configuration settings. */
	public boolean isIsMisconfigured() {
		return this.isMisconfigured;
	}
	/** @param x True, if the tray has invalid configuration settings. */
	public void setIsMisconfigured(boolean x) {
		this.isMisconfigured = x;
	}

	/** True, if the two ESMs in the tray are reporting different version information for their factory default settings. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if the two ESMs in the tray are reporting different version information for their factory default settings." , required = true)
	@XmlElement(required = true)
	private boolean esmFactoryDefaultsMismatch;

	/** @return True, if the two ESMs in the tray are reporting different version information for their factory default settings. */
	public boolean isEsmFactoryDefaultsMismatch() {
		return this.esmFactoryDefaultsMismatch;
	}
	/** @param x True, if the two ESMs in the tray are reporting different version information for their factory default settings. */
	public void setEsmFactoryDefaultsMismatch(boolean x) {
		this.esmFactoryDefaultsMismatch = x;
	}

	/** The physical location of the tray. The parent reference in Location identifies the storage array itself, and the position field is the tray position number as identified in setSATrayPositions procedure call, or the constant TRAY_POSITION_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the tray. The parent reference in Location identifies the storage array itself, and the position field is the tray position number as identified in setSATrayPositions procedure call, or the constant TRAY_POSITION_UNKNOWN." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the tray. The parent reference in Location identifies the storage array itself, and the position field is the tray position number as identified in setSATrayPositions procedure call, or the constant TRAY_POSITION_UNKNOWN. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the tray. The parent reference in Location identifies the storage array itself, and the position field is the tray position number as identified in setSATrayPositions procedure call, or the constant TRAY_POSITION_UNKNOWN. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** The total number of drawers available in the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of drawers available in the tray." , required = true)
	@XmlElement(required = true)
	private int numDrawers;

	/** @return The total number of drawers available in the tray. */
	public int getNumDrawers() {
		return this.numDrawers;
	}
	/** @param x The total number of drawers available in the tray. */
	public void setNumDrawers(int x) {
		this.numDrawers = x;
	}

	/** If the tray contains drawers, this field specifies the layout within the drawer. Otherwise, this field specifies the layout for the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="If the tray contains drawers, this field specifies the layout within the drawer. Otherwise, this field specifies the layout for the tray." , required = true)
	@XmlElement(required = true)
	private DriveLayout driveLayout;

	/** @return If the tray contains drawers, this field specifies the layout within the drawer. Otherwise, this field specifies the layout for the tray. */
	public DriveLayout getDriveLayout() {
		return this.driveLayout;
	}
	/** @param x If the tray contains drawers, this field specifies the layout within the drawer. Otherwise, this field specifies the layout for the tray. */
	public void setDriveLayout(DriveLayout x) {
		this.driveLayout = x;
	}

	/** This field contains information about the version of the tray's factory default settings. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains information about the version of the tray's factory default settings." , required = true)
	@XmlElement(required = true)
	private FactoryDefaultsVersionData factoryDefaultsData;

	/** @return This field contains information about the version of the tray's factory default settings. */
	public FactoryDefaultsVersionData getFactoryDefaultsData() {
		return this.factoryDefaultsData;
	}
	/** @param x This field contains information about the version of the tray's factory default settings. */
	public void setFactoryDefaultsData(FactoryDefaultsVersionData x) {
		this.factoryDefaultsData = x;
	}

	/** Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray." , required = true)
	@XmlElement(required = true)
	private boolean locateInProgress;

	/** @return Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	public boolean isLocateInProgress() {
		return this.locateInProgress;
	}
	/** @param x Indicates that a locate operation for the device is currently active. The device will show a visual indication to aid an operator in locating the tray. */
	public void setLocateInProgress(boolean x) {
		this.locateInProgress = x;
	}

	/** The device contains 7-segment indicators used to display the Tray Identity. */
	@io.swagger.annotations.ApiModelProperty(value ="The device contains 7-segment indicators used to display the Tray Identity." , required = true)
	@XmlElement(required = true)
	private boolean hasTrayIdentityIndicator;

	/** @return The device contains 7-segment indicators used to display the Tray Identity. */
	public boolean isHasTrayIdentityIndicator() {
		return this.hasTrayIdentityIndicator;
	}
	/** @param x The device contains 7-segment indicators used to display the Tray Identity. */
	public void setHasTrayIdentityIndicator(boolean x) {
		this.hasTrayIdentityIndicator = x;
	}
	@Override
	public String getId(){
		return trayRef;
	}
}
