package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a loss of redundancy to a drive tray. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(749)
public class TrayLostRedundancyFailure implements Serializable {
	public TrayLostRedundancyFailure() {
	}

	/** This object uniquely identifies the particular tray within the storage array that has lost redundancy. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the particular tray within the storage array that has lost redundancy." , required = true)
	@XmlElement(required = true)
	private String trayLostRedundancy;

	/** @return This object uniquely identifies the particular tray within the storage array that has lost redundancy. */
	public String getTrayLostRedundancy() {
		return this.trayLostRedundancy;
	}
	/** @param x This object uniquely identifies the particular tray within the storage array that has lost redundancy. */
	public void setTrayLostRedundancy(String x) {
		this.trayLostRedundancy = x;
	}

	/** The channel to the tray that is still operational. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel to the tray that is still operational." , required = true)
	@XmlElement(required = true)
	private int workingChannel;

	/** @return The channel to the tray that is still operational. */
	public int getWorkingChannel() {
		return this.workingChannel;
	}
	/** @param x The channel to the tray that is still operational. */
	public void setWorkingChannel(int x) {
		this.workingChannel = x;
	}

	/** This object uniquely identifies the failed ESM within the storage array. */
	@io.swagger.annotations.ApiModelProperty(value ="This object uniquely identifies the failed ESM within the storage array." , required = true)
	@XmlElement(required = true)
	private String failedEsm;

	/** @return This object uniquely identifies the failed ESM within the storage array. */
	public String getFailedEsm() {
		return this.failedEsm;
	}
	/** @param x This object uniquely identifies the failed ESM within the storage array. */
	public void setFailedEsm(String x) {
		this.failedEsm = x;
	}
}
