package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify the position of a tray relative to other trays. The storage array controllers maintain a list of these objects, where the relative location of trays are determined by their order in the list. Within the list, the beginning-to-ending location of a tray corresponds to a top-to-bottom physical position (or left-to-right, depending on the tray orientations). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(507)
public class TrayPosition implements Serializable {
	public TrayPosition() {
	}

	/** The tray ID of the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray." , required = true)
	@XmlElement(required = true)
	private int trayId;

	/** @return The tray ID of the tray. */
	public int getTrayId() {
		return this.trayId;
	}
	/** @param x The tray ID of the tray. */
	public void setTrayId(int x) {
		this.trayId = x;
	}

	/** An identifier of the enclosure (i.e. rack) in which the tray resides. This is not supported in the current release of the firmware. */
	@io.swagger.annotations.ApiModelProperty(value ="An identifier of the enclosure (i.e. rack) in which the tray resides. This is not supported in the current release of the firmware." , required = true)
	@XmlElement(required = true)
	private int rackId;

	/** @return An identifier of the enclosure (i.e. rack) in which the tray resides. This is not supported in the current release of the firmware. */
	public int getRackId() {
		return this.rackId;
	}
	/** @param x An identifier of the enclosure (i.e. rack) in which the tray resides. This is not supported in the current release of the firmware. */
	public void setRackId(int x) {
		this.rackId = x;
	}
}
