package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains Energy Star Data associated with a single tray. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(294)
public class TrayPower implements Serializable {
	public TrayPower() {
	}

	/** The tray ID. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID." , required = true)
	@XmlElement(required = true)
	private int trayID;

	/** @return The tray ID. */
	public int getTrayID() {
		return this.trayID;
	}
	/** @param x The tray ID. */
	public void setTrayID(int x) {
		this.trayID = x;
	}

	/** The number of power supplies in the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of power supplies in the tray." , required = true)
	@XmlElement(required = true)
	private int numberOfPowerSupplies;

	/** @return The number of power supplies in the tray. */
	public int getNumberOfPowerSupplies() {
		return this.numberOfPowerSupplies;
	}
	/** @param x The number of power supplies in the tray. */
	public void setNumberOfPowerSupplies(int x) {
		this.numberOfPowerSupplies = x;
	}

	/** List of power measurements for each power supply measured in watts. */
	@io.swagger.annotations.ApiModelProperty(value ="List of power measurements for each power supply measured in watts." , required = true)
	@XmlElement(required = true)
	private int[] inputPower;

	/** @return List of power measurements for each power supply measured in watts. */
	public int[] getInputPower() {
		return this.inputPower;
	}
	/** @param x List of power measurements for each power supply measured in watts. */
	public void setInputPower(int[] x) {
		this.inputPower = x;
	}
}
