package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify the location of the component that is being identified in a MEL entry. It provides a more concise representation of the location than the standard object, since it just provides a tray ID and slot number directly as field elements. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(377)
public class TraySlot implements Serializable {
	public TraySlot() {
	}

	/** The tray ID of the tray in which the component resides. Note that a Tray ID of -1 means "the controller tray." */
	@io.swagger.annotations.ApiModelProperty(value ="The tray ID of the tray in which the component resides. Note that a Tray ID of -1 means \"the controller tray.\"" , required = true)
	@XmlElement(required = true)
	private int tray;

	/** @return The tray ID of the tray in which the component resides. Note that a Tray ID of -1 means "the controller tray." */
	public int getTray() {
		return this.tray;
	}
	/** @param x The tray ID of the tray in which the component resides. Note that a Tray ID of -1 means "the controller tray." */
	public void setTray(int x) {
		this.tray = x;
	}

	/** The slot number, or ordinal identifier, of the component within its tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The slot number, or ordinal identifier, of the component within its tray." , required = true)
	@XmlElement(required = true)
	private int slot;

	/** @return The slot number, or ordinal identifier, of the component within its tray. */
	public int getSlot() {
		return this.slot;
	}
	/** @param x The slot number, or ordinal identifier, of the component within its tray. */
	public void setSlot(int x) {
		this.slot = x;
	}
}
