package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Represents a key / value pair used to transmit metadata for the HTTP UTM tunneling protocol. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(304)
public class TunnelKeyValue implements Serializable {
	public TunnelKeyValue() {
	}

	/** The opaque key value for this pair. */
	@io.swagger.annotations.ApiModelProperty(value ="The opaque key value for this pair." , required = true)
	@XmlElement(required = true)
	private String key;

	/** @return The opaque key value for this pair. */
	public String getKey() {
		return this.key;
	}
	/** @param x The opaque key value for this pair. */
	public void setKey(String x) {
		this.key = x;
	}

	/** The opaque value for this pair. */
	@io.swagger.annotations.ApiModelProperty(value ="The opaque value for this pair." , required = true)
	@XmlElement(required = true)
	private String value;

	/** @return The opaque value for this pair. */
	public String getValue() {
		return this.value;
	}
	/** @param x The opaque value for this pair. */
	public void setValue(String x) {
		this.value = x;
	}
}
