package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Provides default values for the HTTP UTM tunneling API. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(306)
public class TunnelingDefaultAttributes implements Serializable {
	public TunnelingDefaultAttributes() {
	}

	/** This is the maximum consistently allocatable buffer that the UTM RPC mechanism can perform. It will be used for an opaque size buffer used in the SymbolTunnelRequest structure. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the maximum consistently allocatable buffer that the UTM RPC mechanism can perform. It will be used for an opaque size buffer used in the SymbolTunnelRequest structure." , required = true)
	@XmlElement(required = true)
	private int maxAPIBufferBytes;

	/** @return This is the maximum consistently allocatable buffer that the UTM RPC mechanism can perform. It will be used for an opaque size buffer used in the SymbolTunnelRequest structure. */
	public int getMaxAPIBufferBytes() {
		return this.maxAPIBufferBytes;
	}
	/** @param x This is the maximum consistently allocatable buffer that the UTM RPC mechanism can perform. It will be used for an opaque size buffer used in the SymbolTunnelRequest structure. */
	public void setMaxAPIBufferBytes(int x) {
		this.maxAPIBufferBytes = x;
	}
}
