package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** A typed SYMbol reference. Contains generic SYMbol reference with enumeration value indicating type of object the reference refers to. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(525)
public class TypedSYMbolReference implements Serializable {
	public TypedSYMbolReference() {
	}

	/** An enumeration value indicating the type of component that the reference refers to. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration value indicating the type of component that the reference refers to." , required = true)
	@XmlElement(required = true)
	private ComponentType componentType = ComponentType.__UNDEFINED;

	/** @return An enumeration value indicating the type of component that the reference refers to. */
	public ComponentType getComponentType() {
		return this.componentType;
	}
	/** @param x An enumeration value indicating the type of component that the reference refers to. */
	public void setComponentType(ComponentType x) {
		this.componentType = x;
	}

	/** A SYMbol reference that refers to an instance of an object of the type identified by componentType. If the component type is "storage array," this field is a null reference. This is because an object graph describes a single instance of a storage array, so there is no need to uniquely identify instances. */
	@io.swagger.annotations.ApiModelProperty(value ="A SYMbol reference that refers to an instance of an object of the type identified by componentType. If the component type is \"storage array,\" this field is a null reference. This is because an object graph describes a single instance of a storage array, so there is no need to uniquely identify instances." , required = true)
	@XmlElement(required = true)
	private String symbolRef;

	/** @return A SYMbol reference that refers to an instance of an object of the type identified by componentType. If the component type is "storage array," this field is a null reference. This is because an object graph describes a single instance of a storage array, so there is no need to uniquely identify instances. */
	public String getSymbolRef() {
		return this.symbolRef;
	}
	/** @param x A SYMbol reference that refers to an instance of an object of the type identified by componentType. If the component type is "storage array," this field is a null reference. This is because an object graph describes a single instance of a storage array, so there is no need to uniquely identify instances. */
	public void setSymbolRef(String x) {
		this.symbolRef = x;
	}
}
