package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union object is a wrapper around an array of ScsiNodeName. It is used by the getUnconfiguredInitiators procedure that to return both a return code and a list of names of initiators that have not been configured into the storage array topology. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(687)
public class UnconfiguredInitiatorsReturned implements Serializable {
	public UnconfiguredInitiatorsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The array of names of unconfigured initiators. */
	@io.swagger.annotations.ApiModelProperty(value ="The array of names of unconfigured initiators." , required = false)
	@XmlElement(required = false)
	private ScsiNodeName[] unconfiguredInitiators;

	/** @return The array of names of unconfigured initiators. */
	public ScsiNodeName[] getUnconfiguredInitiators() {
		return this.unconfiguredInitiators;
	}
	/** @param x The array of names of unconfigured initiators. */
	public void setUnconfiguredInitiators(ScsiNodeName[] x) {
		this.unconfiguredInitiators = x;
	}
}
