package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey unreadable sectors. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(583)
public class UnreadableSectorTableEntry implements Serializable {
	public UnreadableSectorTableEntry() {
	}

	/** The reference for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for the volume." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference for the volume. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference for the volume. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The volume LBA. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume LBA." , required = true)
	@XmlElement(required = true)
	private long volumeLBA;

	/** @return The volume LBA. */
	public long getVolumeLBA() {
		return this.volumeLBA;
	}
	/** @param x The volume LBA. */
	public void setVolumeLBA(long x) {
		this.volumeLBA = x;
	}

	/** The tray number. */
	@io.swagger.annotations.ApiModelProperty(value ="The tray number." , required = true)
	@XmlElement(required = true)
	private int trayNo;

	/** @return The tray number. */
	public int getTrayNo() {
		return this.trayNo;
	}
	/** @param x The tray number. */
	public void setTrayNo(int x) {
		this.trayNo = x;
	}

	/** The slot number. */
	@io.swagger.annotations.ApiModelProperty(value ="The slot number." , required = true)
	@XmlElement(required = true)
	private int slotNo;

	/** @return The slot number. */
	public int getSlotNo() {
		return this.slotNo;
	}
	/** @param x The slot number. */
	public void setSlotNo(int x) {
		this.slotNo = x;
	}

	/** 8 bytes - unsigned long long */
	@io.swagger.annotations.ApiModelProperty(value ="8 bytes - unsigned long long" , required = true)
	@XmlElement(required = true)
	private long driveLBA;

	/** @return 8 bytes - unsigned long long */
	public long getDriveLBA() {
		return this.driveLBA;
	}
	/** @param x 8 bytes - unsigned long long */
	public void setDriveLBA(long x) {
		this.driveLBA = x;
	}

	/** 8 bytes */
	@io.swagger.annotations.ApiModelProperty(value ="8 bytes" , required = true)
	@XmlElement(required = true)
	private long timeStamp;

	/** @return 8 bytes */
	public long getTimeStamp() {
		return this.timeStamp;
	}
	/** @param x 8 bytes */
	public void setTimeStamp(long x) {
		this.timeStamp = x;
	}

	/** 4 bytes - enumeration */
	@io.swagger.annotations.ApiModelProperty(value ="4 bytes - enumeration" , required = true)
	@XmlElement(required = true)
	private UsmRecordType recordType = UsmRecordType.__UNDEFINED;

	/** @return 4 bytes - enumeration */
	public UsmRecordType getRecordType() {
		return this.recordType;
	}
	/** @param x 4 bytes - enumeration */
	public void setRecordType(UsmRecordType x) {
		this.recordType = x;
	}
}
