package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a "long-running" operation on a volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(439)
public class VolumeActionProgress implements Serializable {
	public VolumeActionProgress() {
	}

	/** The completion percentage of a "long-running" operation on a volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The completion percentage of a \"long-running\" operation on a volume." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return The completion percentage of a "long-running" operation on a volume. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x The completion percentage of a "long-running" operation on a volume. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}

	/** The estimated elapsed time to completion in minutes. Note that this field is always set to -1 for basic RAID volumes. */
	@io.swagger.annotations.ApiModelProperty(value ="The estimated elapsed time to completion in minutes. Note that this field is always set to -1 for basic RAID volumes." , required = true)
	@XmlElement(required = true)
	private int timeToCompletion;

	/** @return The estimated elapsed time to completion in minutes. Note that this field is always set to -1 for basic RAID volumes. */
	public int getTimeToCompletion() {
		return this.timeToCompletion;
	}
	/** @param x The estimated elapsed time to completion in minutes. Note that this field is always set to -1 for basic RAID volumes. */
	public void setTimeToCompletion(int x) {
		this.timeToCompletion = x;
	}
}
