package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when updating a particular volume's cache parameters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(830)
public class VolumeCacheParamsUpdateDescriptor implements Serializable {
	public VolumeCacheParamsUpdateDescriptor() {
	}

	/** The reference value that identifies the volume whose cache parameters are to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume whose cache parameters are to be updated." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference value that identifies the volume whose cache parameters are to be updated. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference value that identifies the volume whose cache parameters are to be updated. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** A true/false indication of whether caching without batteries should be allowed for this volume. Note that setting this attribute to true may result in data loss if the array's cache hold-up battery fails, and then a disorderly power-down of the array occurs. This feature should be used only with extreme caution. */
	@io.swagger.annotations.ApiModelProperty(value ="A true/false indication of whether caching without batteries should be allowed for this volume. Note that setting this attribute to true may result in data loss if the array's cache hold-up battery fails, and then a disorderly power-down of the array occurs. This feature should be used only with extreme caution." , required = true)
	@XmlElement(required = true)
	private boolean cwob;

	/** @return A true/false indication of whether caching without batteries should be allowed for this volume. Note that setting this attribute to true may result in data loss if the array's cache hold-up battery fails, and then a disorderly power-down of the array occurs. This feature should be used only with extreme caution. */
	public boolean isCwob() {
		return this.cwob;
	}
	/** @param x A true/false indication of whether caching without batteries should be allowed for this volume. Note that setting this attribute to true may result in data loss if the array's cache hold-up battery fails, and then a disorderly power-down of the array occurs. This feature should be used only with extreme caution. */
	public void setCwob(boolean x) {
		this.cwob = x;
	}

	/** A true/false indication of whether cache mirroring should be enabled for this volume. If enabled, all cache data will be mirrored across controllers to provide increased resilience to potential controller failures. */
	@io.swagger.annotations.ApiModelProperty(value ="A true/false indication of whether cache mirroring should be enabled for this volume. If enabled, all cache data will be mirrored across controllers to provide increased resilience to potential controller failures." , required = true)
	@XmlElement(required = true)
	private boolean mirrorEnable;

	/** @return A true/false indication of whether cache mirroring should be enabled for this volume. If enabled, all cache data will be mirrored across controllers to provide increased resilience to potential controller failures. */
	public boolean isMirrorEnable() {
		return this.mirrorEnable;
	}
	/** @param x A true/false indication of whether cache mirroring should be enabled for this volume. If enabled, all cache data will be mirrored across controllers to provide increased resilience to potential controller failures. */
	public void setMirrorEnable(boolean x) {
		this.mirrorEnable = x;
	}

	/** A true/false indication of whether read caching should be enabled for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="A true/false indication of whether read caching should be enabled for the volume." , required = true)
	@XmlElement(required = true)
	private boolean readCacheEnable;

	/** @return A true/false indication of whether read caching should be enabled for the volume. */
	public boolean isReadCacheEnable() {
		return this.readCacheEnable;
	}
	/** @param x A true/false indication of whether read caching should be enabled for the volume. */
	public void setReadCacheEnable(boolean x) {
		this.readCacheEnable = x;
	}

	/** A true/false indication of whether write-back caching should be enabled for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="A true/false indication of whether write-back caching should be enabled for the volume." , required = true)
	@XmlElement(required = true)
	private boolean writeCacheEnable;

	/** @return A true/false indication of whether write-back caching should be enabled for the volume. */
	public boolean isWriteCacheEnable() {
		return this.writeCacheEnable;
	}
	/** @param x A true/false indication of whether write-back caching should be enabled for the volume. */
	public void setWriteCacheEnable(boolean x) {
		this.writeCacheEnable = x;
	}

	/** The cache flush modifier value, which is used to specify the maximum amount of time that dirty data for this volume may be retained in the controller's write cache prior to being flushed to disk. */
	@io.swagger.annotations.ApiModelProperty(value ="The cache flush modifier value, which is used to specify the maximum amount of time that dirty data for this volume may be retained in the controller's write cache prior to being flushed to disk." , required = true)
	@XmlElement(required = true)
	private CacheFlushModifier cacheFlushModifier = CacheFlushModifier.__UNDEFINED;

	/** @return The cache flush modifier value, which is used to specify the maximum amount of time that dirty data for this volume may be retained in the controller's write cache prior to being flushed to disk. */
	public CacheFlushModifier getCacheFlushModifier() {
		return this.cacheFlushModifier;
	}
	/** @param x The cache flush modifier value, which is used to specify the maximum amount of time that dirty data for this volume may be retained in the controller's write cache prior to being flushed to disk. */
	public void setCacheFlushModifier(CacheFlushModifier x) {
		this.cacheFlushModifier = x;
	}

	/** A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled." , required = true)
	@XmlElement(required = true)
	private int readAheadMultiplier;

	/** @return A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public int getReadAheadMultiplier() {
		return this.readAheadMultiplier;
	}
	/** @param x A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public void setReadAheadMultiplier(int x) {
		this.readAheadMultiplier = x;
	}
}
