package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about how a new volume-copy is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(945)
public class VolumeCopyCreationDescriptor implements Serializable {
	public VolumeCopyCreationDescriptor() {
	}

	/** The source volume reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The source volume reference." , required = true)
	@XmlElement(required = true)
	private String sourceVolume;

	/** @return The source volume reference. */
	public String getSourceVolume() {
		return this.sourceVolume;
	}
	/** @param x The source volume reference. */
	public void setSourceVolume(String x) {
		this.sourceVolume = x;
	}

	/** The target volume reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The target volume reference." , required = true)
	@XmlElement(required = true)
	private String targetVolume;

	/** @return The target volume reference. */
	public String getTargetVolume() {
		return this.targetVolume;
	}
	/** @param x The target volume reference. */
	public void setTargetVolume(String x) {
		this.targetVolume = x;
	}

	/** Apply write protection to target volume when copy is idle (true/false). */
	@io.swagger.annotations.ApiModelProperty(value ="Apply write protection to target volume when copy is idle (true/false)." , required = true)
	@XmlElement(required = true)
	private boolean idleTargetWriteProt;

	/** @return Apply write protection to target volume when copy is idle (true/false). */
	public boolean isIdleTargetWriteProt() {
		return this.idleTargetWriteProt;
	}
	/** @param x Apply write protection to target volume when copy is idle (true/false). */
	public void setIdleTargetWriteProt(boolean x) {
		this.idleTargetWriteProt = x;
	}

	/** Importance of copy operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Importance of copy operation." , required = true)
	@XmlElement(required = true)
	private VolumeCopyPriority copyPriority = VolumeCopyPriority.__UNDEFINED;

	/** @return Importance of copy operation. */
	public VolumeCopyPriority getCopyPriority() {
		return this.copyPriority;
	}
	/** @param x Importance of copy operation. */
	public void setCopyPriority(VolumeCopyPriority x) {
		this.copyPriority = x;
	}

	/** When true, this indicates that the source snapshot should be disabled when the physical copy operation is complete. This field is only set to true when the volume copy is a clone. */
	@io.swagger.annotations.ApiModelProperty(value ="When true, this indicates that the source snapshot should be disabled when the physical copy operation is complete. This field is only set to true when the volume copy is a clone." , required = true)
	@XmlElement(required = true)
	private boolean disableSnapshot;

	/** @return When true, this indicates that the source snapshot should be disabled when the physical copy operation is complete. This field is only set to true when the volume copy is a clone. */
	public boolean isDisableSnapshot() {
		return this.disableSnapshot;
	}
	/** @param x When true, this indicates that the source snapshot should be disabled when the physical copy operation is complete. This field is only set to true when the volume copy is a clone. */
	public void setDisableSnapshot(boolean x) {
		this.disableSnapshot = x;
	}

	/** For clones based on PiT Groups, this will identify the PiT Group. */
	@io.swagger.annotations.ApiModelProperty(value ="For clones based on PiT Groups, this will identify the PiT Group." , required = true)
	@XmlElement(required = true)
	private String pgRef;

	/** @return For clones based on PiT Groups, this will identify the PiT Group. */
	public String getPgRef() {
		return this.pgRef;
	}
	/** @param x For clones based on PiT Groups, this will identify the PiT Group. */
	public void setPgRef(String x) {
		this.pgRef = x;
	}
}
