package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the priority of the volume copy operation. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(77)
public enum VolumeCopyPriority implements Serializable {
		/** Lowest level of I/O activity to the target. */
		priority0(0),
		/** Next to lowest level of I/O activity to the target. */
		priority1(1),
		/** Default value. */
		priority2(2),
		/** Next to highest level of I/O activity to the target. */
		priority3(3),
		/** Highest level of I/O activity to the target. */
		priority4(4),
		__UNDEFINED(464378545);

		public final int value;

		private VolumeCopyPriority(int v) {
			this.value = v;
		}
}
