package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is a counter group containing volume-related statistical counters. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(328)
public class VolumeCounterGroup implements Serializable {
	public VolumeCounterGroup() {
	}

	/** A reference to the controller that accumulated the counters for this group. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller that accumulated the counters for this group." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return A reference to the controller that accumulated the counters for this group. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x A reference to the controller that accumulated the counters for this group. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}

	/** The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long baseTime;

	/** @return The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public long getBaseTime() {
		return this.baseTime;
	}
	/** @param x The time that the counters were last reset. Time is the number of seconds since midnight, January 1, 1970. */
	public void setBaseTime(long x) {
		this.baseTime = x;
	}

	/** The number of read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitOps;

	/** @return The number of read operations that hit cache. */
	public long getReadHitOps() {
		return this.readHitOps;
	}
	/** @param x The number of read operations that hit cache. */
	public void setReadHitOps(long x) {
		this.readHitOps = x;
	}

	/** The number of bytes read that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes read that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitBytes;

	/** @return The number of bytes read that hit cache. */
	public long getReadHitBytes() {
		return this.readHitBytes;
	}
	/** @param x The number of bytes read that hit cache. */
	public void setReadHitBytes(long x) {
		this.readHitBytes = x;
	}

	/** The total time in microseconds spent in read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeTotal;

	/** @return The total time in microseconds spent in read operations that hit cache. */
	public long getReadHitTimeTotal() {
		return this.readHitTimeTotal;
	}
	/** @param x The total time in microseconds spent in read operations that hit cache. */
	public void setReadHitTimeTotal(long x) {
		this.readHitTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one read operation that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one read operation that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeMax;

	/** @return The maximum time in microseconds spent in any one read operation that hit cache. */
	public long getReadHitTimeMax() {
		return this.readHitTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one read operation that hit cache. */
	public void setReadHitTimeMax(long x) {
		this.readHitTimeMax = x;
	}

	/** The number of read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read operations." , required = true)
	@XmlElement(required = true)
	private long readOps;

	/** @return The number of read operations. */
	public long getReadOps() {
		return this.readOps;
	}
	/** @param x The number of read operations. */
	public void setReadOps(long x) {
		this.readOps = x;
	}

	/** The number of bytes read. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes read." , required = true)
	@XmlElement(required = true)
	private long readBytes;

	/** @return The number of bytes read. */
	public long getReadBytes() {
		return this.readBytes;
	}
	/** @param x The number of bytes read. */
	public void setReadBytes(long x) {
		this.readBytes = x;
	}

	/** The total time in microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotal;

	/** @return The total time in microseconds spent in read operations. */
	public long getReadTimeTotal() {
		return this.readTimeTotal;
	}
	/** @param x The total time in microseconds spent in read operations. */
	public void setReadTimeTotal(long x) {
		this.readTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one read operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one read operation." , required = true)
	@XmlElement(required = true)
	private long readTimeMax;

	/** @return The maximum time in microseconds spent in any one read operation. */
	public long getReadTimeMax() {
		return this.readTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one read operation. */
	public void setReadTimeMax(long x) {
		this.readTimeMax = x;
	}

	/** The number of write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitOps;

	/** @return The number of write operations that hit cache. */
	public long getWriteHitOps() {
		return this.writeHitOps;
	}
	/** @param x The number of write operations that hit cache. */
	public void setWriteHitOps(long x) {
		this.writeHitOps = x;
	}

	/** The number of bytes written that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes written that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitBytes;

	/** @return The number of bytes written that hit cache. */
	public long getWriteHitBytes() {
		return this.writeHitBytes;
	}
	/** @param x The number of bytes written that hit cache. */
	public void setWriteHitBytes(long x) {
		this.writeHitBytes = x;
	}

	/** The total time in microseconds spent in write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeTotal;

	/** @return The total time in microseconds spent in write operations that hit cache. */
	public long getWriteHitTimeTotal() {
		return this.writeHitTimeTotal;
	}
	/** @param x The total time in microseconds spent in write operations that hit cache. */
	public void setWriteHitTimeTotal(long x) {
		this.writeHitTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one write operation that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one write operation that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeMax;

	/** @return The maximum time in microseconds spent in any one write operation that hit cache. */
	public long getWriteHitTimeMax() {
		return this.writeHitTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one write operation that hit cache. */
	public void setWriteHitTimeMax(long x) {
		this.writeHitTimeMax = x;
	}

	/** The number of write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of write operations." , required = true)
	@XmlElement(required = true)
	private long writeOps;

	/** @return The number of write operations. */
	public long getWriteOps() {
		return this.writeOps;
	}
	/** @param x The number of write operations. */
	public void setWriteOps(long x) {
		this.writeOps = x;
	}

	/** The number of bytes written. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes written." , required = true)
	@XmlElement(required = true)
	private long writeBytes;

	/** @return The number of bytes written. */
	public long getWriteBytes() {
		return this.writeBytes;
	}
	/** @param x The number of bytes written. */
	public void setWriteBytes(long x) {
		this.writeBytes = x;
	}

	/** The total time in microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotal;

	/** @return The total time in microseconds spent in write operations. */
	public long getWriteTimeTotal() {
		return this.writeTimeTotal;
	}
	/** @param x The total time in microseconds spent in write operations. */
	public void setWriteTimeTotal(long x) {
		this.writeTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one write operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one write operation." , required = true)
	@XmlElement(required = true)
	private long writeTimeMax;

	/** @return The maximum time in microseconds spent in any one write operation. */
	public long getWriteTimeMax() {
		return this.writeTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one write operation. */
	public void setWriteTimeMax(long x) {
		this.writeTimeMax = x;
	}

	/** The number of non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherOps;

	/** @return The number of non-read-write operations. */
	public long getOtherOps() {
		return this.otherOps;
	}
	/** @param x The number of non-read-write operations. */
	public void setOtherOps(long x) {
		this.otherOps = x;
	}

	/** The total time in microseconds spent in non-read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent in non-read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotal;

	/** @return The total time in microseconds spent in non-read-write operations. */
	public long getOtherTimeTotal() {
		return this.otherTimeTotal;
	}
	/** @param x The total time in microseconds spent in non-read-write operations. */
	public void setOtherTimeTotal(long x) {
		this.otherTimeTotal = x;
	}

	/** The maximum time in microseconds spent in any one non-read-write operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum time in microseconds spent in any one non-read-write operation." , required = true)
	@XmlElement(required = true)
	private long otherTimeMax;

	/** @return The maximum time in microseconds spent in any one non-read-write operation. */
	public long getOtherTimeMax() {
		return this.otherTimeMax;
	}
	/** @param x The maximum time in microseconds spent in any one non-read-write operation. */
	public void setOtherTimeMax(long x) {
		this.otherTimeMax = x;
	}

	/** The total time in microseconds spent idle since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="The total time in microseconds spent idle since baseTime." , required = true)
	@XmlElement(required = true)
	private long idleTime;

	/** @return The total time in microseconds spent idle since baseTime. */
	public long getIdleTime() {
		return this.idleTime;
	}
	/** @param x The total time in microseconds spent idle since baseTime. */
	public void setIdleTime(long x) {
		this.idleTime = x;
	}

	/** The number of read requests that have failed due to redundancy group inconsistencies. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests that have failed due to redundancy group inconsistencies." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkUnrecoveredReads;

	/** @return The number of read requests that have failed due to redundancy group inconsistencies. */
	public long getErrRedundancyChkUnrecoveredReads() {
		return this.errRedundancyChkUnrecoveredReads;
	}
	/** @param x The number of read requests that have failed due to redundancy group inconsistencies. */
	public void setErrRedundancyChkUnrecoveredReads(long x) {
		this.errRedundancyChkUnrecoveredReads = x;
	}

	/** The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkRecoveredReads;

	/** @return The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	public long getErrRedundancyChkRecoveredReads() {
		return this.errRedundancyChkRecoveredReads;
	}
	/** @param x The number of read requests that have experienced a redundancy group inconsistency that was subsequently recovered by retrying the consistency check. */
	public void setErrRedundancyChkRecoveredReads(long x) {
		this.errRedundancyChkRecoveredReads = x;
	}

	/** The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion." , required = true)
	@XmlElement(required = true)
	private long errRedundancyChkIndeterminateReads;

	/** @return The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	public long getErrRedundancyChkIndeterminateReads() {
		return this.errRedundancyChkIndeterminateReads;
	}
	/** @param x The number of read requests for which the consistency of the redundancy data could not be determined, but for which the read was carried out to completion. */
	public void setErrRedundancyChkIndeterminateReads(long x) {
		this.errRedundancyChkIndeterminateReads = x;
	}

	/** The sum of the squares of microseconds spent in read operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in read operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long readHitTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in read operations that hit cache. */
	public long getReadHitTimeTotalSq() {
		return this.readHitTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in read operations that hit cache. */
	public void setReadHitTimeTotalSq(long x) {
		this.readHitTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in read operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in read operations." , required = true)
	@XmlElement(required = true)
	private long readTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in read operations. */
	public long getReadTimeTotalSq() {
		return this.readTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in read operations. */
	public void setReadTimeTotalSq(long x) {
		this.readTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in write operations that hit cache. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in write operations that hit cache." , required = true)
	@XmlElement(required = true)
	private long writeHitTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in write operations that hit cache. */
	public long getWriteHitTimeTotalSq() {
		return this.writeHitTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in write operations that hit cache. */
	public void setWriteHitTimeTotalSq(long x) {
		this.writeHitTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in write operations." , required = true)
	@XmlElement(required = true)
	private long writeTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in write operations. */
	public long getWriteTimeTotalSq() {
		return this.writeTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in write operations. */
	public void setWriteTimeTotalSq(long x) {
		this.writeTimeTotalSq = x;
	}

	/** The sum of the squares of microseconds spent in non read-write operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of microseconds spent in non read-write operations." , required = true)
	@XmlElement(required = true)
	private long otherTimeTotalSq;

	/** @return The sum of the squares of microseconds spent in non read-write operations. */
	public long getOtherTimeTotalSq() {
		return this.otherTimeTotalSq;
	}
	/** @param x The sum of the squares of microseconds spent in non read-write operations. */
	public void setOtherTimeTotalSq(long x) {
		this.otherTimeTotalSq = x;
	}

	/** The number of flash cache read hit operations. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of flash cache read hit operations." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitOps;

	/** @return The number of flash cache read hit operations. */
	public long getFlashCacheReadHitOps() {
		return this.flashCacheReadHitOps;
	}
	/** @param x The number of flash cache read hit operations. */
	public void setFlashCacheReadHitOps(long x) {
		this.flashCacheReadHitOps = x;
	}

	/** The number of flash cache read hit bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of flash cache read hit bytes." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitBytes;

	/** @return The number of flash cache read hit bytes. */
	public long getFlashCacheReadHitBytes() {
		return this.flashCacheReadHitBytes;
	}
	/** @param x The number of flash cache read hit bytes. */
	public void setFlashCacheReadHitBytes(long x) {
		this.flashCacheReadHitBytes = x;
	}

	/** The sum of all response times for all reads that have cache hits, in microseconds */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of all response times for all reads that have cache hits, in microseconds" , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeTotal;

	/** @return The sum of all response times for all reads that have cache hits, in microseconds */
	public long getFlashCacheReadHitTimeTotal() {
		return this.flashCacheReadHitTimeTotal;
	}
	/** @param x The sum of all response times for all reads that have cache hits, in microseconds */
	public void setFlashCacheReadHitTimeTotal(long x) {
		this.flashCacheReadHitTimeTotal = x;
	}

	/** Maximum I/O time in microseconds for any one read I/O that has a cache hit */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum I/O time in microseconds for any one read I/O that has a cache hit" , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeMax;

	/** @return Maximum I/O time in microseconds for any one read I/O that has a cache hit */
	public long getFlashCacheReadHitTimeMax() {
		return this.flashCacheReadHitTimeMax;
	}
	/** @param x Maximum I/O time in microseconds for any one read I/O that has a cache hit */
	public void setFlashCacheReadHitTimeMax(long x) {
		this.flashCacheReadHitTimeMax = x;
	}

	/** The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	@io.swagger.annotations.ApiModelProperty(value ="The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation)." , required = true)
	@XmlElement(required = true)
	private long flashCacheReadHitTimeTotalSq;

	/** @return The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	public long getFlashCacheReadHitTimeTotalSq() {
		return this.flashCacheReadHitTimeTotalSq;
	}
	/** @param x The sum of the squares of the response times for all reads that have cache hits, in microseconds (used for standard deviation). */
	public void setFlashCacheReadHitTimeTotalSq(long x) {
		this.flashCacheReadHitTimeTotalSq = x;
	}

	/** The number of pre-fetched bytes that are ultimately read by the host. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of pre-fetched bytes that are ultimately read by the host." , required = true)
	@XmlElement(required = true)
	private long prefetchHitBytes;

	/** @return The number of pre-fetched bytes that are ultimately read by the host. */
	public long getPrefetchHitBytes() {
		return this.prefetchHitBytes;
	}
	/** @param x The number of pre-fetched bytes that are ultimately read by the host. */
	public void setPrefetchHitBytes(long x) {
		this.prefetchHitBytes = x;
	}

	/** The number of pre-fetched bytes that are evicted from cache without being read by the host. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of pre-fetched bytes that are evicted from cache without being read by the host." , required = true)
	@XmlElement(required = true)
	private long prefetchMissBytes;

	/** @return The number of pre-fetched bytes that are evicted from cache without being read by the host. */
	public long getPrefetchMissBytes() {
		return this.prefetchMissBytes;
	}
	/** @param x The number of pre-fetched bytes that are evicted from cache without being read by the host. */
	public void setPrefetchMissBytes(long x) {
		this.prefetchMissBytes = x;
	}

	/** Start time for this collection as measured by the number of seconds since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="Start time for this collection as measured by the number of seconds since baseTime." , required = true)
	@XmlElement(required = true)
	private long startTime;

	/** @return Start time for this collection as measured by the number of seconds since baseTime. */
	public long getStartTime() {
		return this.startTime;
	}
	/** @param x Start time for this collection as measured by the number of seconds since baseTime. */
	public void setStartTime(long x) {
		this.startTime = x;
	}

	/** End time for this collection as measured by the number of seconds since baseTime. */
	@io.swagger.annotations.ApiModelProperty(value ="End time for this collection as measured by the number of seconds since baseTime." , required = true)
	@XmlElement(required = true)
	private long observedTime;

	/** @return End time for this collection as measured by the number of seconds since baseTime. */
	public long getObservedTime() {
		return this.observedTime;
	}
	/** @param x End time for this collection as measured by the number of seconds since baseTime. */
	public void setObservedTime(long x) {
		this.observedTime = x;
	}

	/** Total drive queue depth. */
	@io.swagger.annotations.ApiModelProperty(value ="Total drive queue depth." , required = true)
	@XmlElement(required = true)
	private long queueDepthTotal;

	/** @return Total drive queue depth. */
	public long getQueueDepthTotal() {
		return this.queueDepthTotal;
	}
	/** @param x Total drive queue depth. */
	public void setQueueDepthTotal(long x) {
		this.queueDepthTotal = x;
	}

	/** Maximum queue depth. */
	@io.swagger.annotations.ApiModelProperty(value ="Maximum queue depth." , required = true)
	@XmlElement(required = true)
	private long queueDepthMax;

	/** @return Maximum queue depth. */
	public long getQueueDepthMax() {
		return this.queueDepthMax;
	}
	/** @param x Maximum queue depth. */
	public void setQueueDepthMax(long x) {
		this.queueDepthMax = x;
	}

	/** Total number of IOs that are categorized as random. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of IOs that are categorized as random." , required = true)
	@XmlElement(required = true)
	private long randomIosTotal;

	/** @return Total number of IOs that are categorized as random. */
	public long getRandomIosTotal() {
		return this.randomIosTotal;
	}
	/** @param x Total number of IOs that are categorized as random. */
	public void setRandomIosTotal(long x) {
		this.randomIosTotal = x;
	}

	/** Total number of Bytes that are categorized as random. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of Bytes that are categorized as random." , required = true)
	@XmlElement(required = true)
	private long randomBytesTotal;

	/** @return Total number of Bytes that are categorized as random. */
	public long getRandomBytesTotal() {
		return this.randomBytesTotal;
	}
	/** @param x Total number of Bytes that are categorized as random. */
	public void setRandomBytesTotal(long x) {
		this.randomBytesTotal = x;
	}

	/** The number of write operations that are delayed, waiting for cache flush. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of write operations that are delayed, waiting for cache flush." , required = true)
	@XmlElement(required = true)
	private long cacheWriteWaitHitOps;

	/** @return The number of write operations that are delayed, waiting for cache flush. */
	public long getCacheWriteWaitHitOps() {
		return this.cacheWriteWaitHitOps;
	}
	/** @param x The number of write operations that are delayed, waiting for cache flush. */
	public void setCacheWriteWaitHitOps(long x) {
		this.cacheWriteWaitHitOps = x;
	}

	/** Bytes written that are categorized as Full stripe writes. */
	@io.swagger.annotations.ApiModelProperty(value ="Bytes written that are categorized as Full stripe writes." , required = true)
	@XmlElement(required = true)
	private long fullStripeWritesBytes;

	/** @return Bytes written that are categorized as Full stripe writes. */
	public long getFullStripeWritesBytes() {
		return this.fullStripeWritesBytes;
	}
	/** @param x Bytes written that are categorized as Full stripe writes. */
	public void setFullStripeWritesBytes(long x) {
		this.fullStripeWritesBytes = x;
	}

	/** Total number of IOs shipped to this volume. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of IOs shipped to this volume." , required = true)
	@XmlElement(required = true)
	private long totalIosShipped;

	/** @return Total number of IOs shipped to this volume. */
	public long getTotalIosShipped() {
		return this.totalIosShipped;
	}
	/** @param x Total number of IOs shipped to this volume. */
	public void setTotalIosShipped(long x) {
		this.totalIosShipped = x;
	}

	/** Total number of cache blocks evicted by this volume. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of cache blocks evicted by this volume." , required = true)
	@XmlElement(required = true)
	private long totalBlksEvicted;

	/** @return Total number of cache blocks evicted by this volume. */
	public long getTotalBlksEvicted() {
		return this.totalBlksEvicted;
	}
	/** @param x Total number of cache blocks evicted by this volume. */
	public void setTotalBlksEvicted(long x) {
		this.totalBlksEvicted = x;
	}

	/** Number of cache blocks in use by this volume. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of cache blocks in use by this volume." , required = true)
	@XmlElement(required = true)
	private long cacheBlksInUse;

	/** @return Number of cache blocks in use by this volume. */
	public long getCacheBlksInUse() {
		return this.cacheBlksInUse;
	}
	/** @param x Number of cache blocks in use by this volume. */
	public void setCacheBlksInUse(long x) {
		this.cacheBlksInUse = x;
	}

	/** The number of bytes in write operations that were delayed waiting for cache flush. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes in write operations that were delayed waiting for cache flush." , required = true)
	@XmlElement(required = true)
	private long cacheWriteWaitHitBytes;

	/** @return The number of bytes in write operations that were delayed waiting for cache flush. */
	public long getCacheWriteWaitHitBytes() {
		return this.cacheWriteWaitHitBytes;
	}
	/** @param x The number of bytes in write operations that were delayed waiting for cache flush. */
	public void setCacheWriteWaitHitBytes(long x) {
		this.cacheWriteWaitHitBytes = x;
	}
}
