package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information used for a Dynamic Volume Expansion (DVE) or a DCE/DVE combination. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(777)
public class VolumeExpansionDescriptor implements Serializable {
	public VolumeExpansionDescriptor() {
	}

	/** The volume that is being expanded. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume that is being expanded." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The volume that is being expanded. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The volume that is being expanded. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The drives to be used for the DCE/DVE operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The drives to be used for the DCE/DVE operation." , required = true)
	@XmlElement(required = true)
	private String[] driveRef;

	/** @return The drives to be used for the DCE/DVE operation. */
	public String[] getDriveRef() {
		return this.driveRef;
	}
	/** @param x The drives to be used for the DCE/DVE operation. */
	public void setDriveRef(String[] x) {
		this.driveRef = x;
	}

	/** The total new capacity requested for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The total new capacity requested for the volume." , required = true)
	@XmlElement(required = true)
	private long newCapacity;

	/** @return The total new capacity requested for the volume. */
	public long getNewCapacity() {
		return this.newCapacity;
	}
	/** @param x The total new capacity requested for the volume. */
	public void setNewCapacity(long x) {
		this.newCapacity = x;
	}
}
