package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument to the enableFlashCacheVolume procedure. It identifies the high level flash cache volume and user volume to be used when creating a flash cache proxy. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1116)
public class VolumeFlashCacheDescriptor implements Serializable {
	public VolumeFlashCacheDescriptor() {
	}

	/** The user volume to link to the flash cache proxy. */
	@io.swagger.annotations.ApiModelProperty(value ="The user volume to link to the flash cache proxy." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The user volume to link to the flash cache proxy. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The user volume to link to the flash cache proxy. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The high level flash cache volume to be linked to the flash cache proxy. */
	@io.swagger.annotations.ApiModelProperty(value ="The high level flash cache volume to be linked to the flash cache proxy." , required = true)
	@XmlElement(required = true)
	private String flashCacheRef;

	/** @return The high level flash cache volume to be linked to the flash cache proxy. */
	public String getFlashCacheRef() {
		return this.flashCacheRef;
	}
	/** @param x The high level flash cache volume to be linked to the flash cache proxy. */
	public void setFlashCacheRef(String x) {
		this.flashCacheRef = x;
	}
}
