package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when updating a volume group's ownership. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(917)
public class VolumeGroupOwnershipUpdateDescriptor implements Serializable {
	public VolumeGroupOwnershipUpdateDescriptor() {
	}

	/** The reference value that identifies the volume group whose ownership is to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume group whose ownership is to be updated." , required = true)
	@XmlElement(required = true)
	private String volumeGroupRef;

	/** @return The reference value that identifies the volume group whose ownership is to be updated. */
	public String getVolumeGroupRef() {
		return this.volumeGroupRef;
	}
	/** @param x The reference value that identifies the volume group whose ownership is to be updated. */
	public void setVolumeGroupRef(String x) {
		this.volumeGroupRef = x;
	}

	/** The controller reference value of the controller that is to be instituted as the new manager, or owner, of the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller reference value of the controller that is to be instituted as the new manager, or owner, of the volume group." , required = true)
	@XmlElement(required = true)
	private String manager;

	/** @return The controller reference value of the controller that is to be instituted as the new manager, or owner, of the volume group. */
	public String getManager() {
		return this.manager;
	}
	/** @param x The controller reference value of the controller that is to be instituted as the new manager, or owner, of the volume group. */
	public void setManager(String x) {
		this.manager = x;
	}
}
