package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure conveys information about a single volume group that would be created from a given AutoConfigTemplate. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(430)
public class VolumeGroupSummary implements Serializable {
	public VolumeGroupSummary() {
	}

	/** The total usable capacity of the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The total usable capacity of the volume group." , required = true)
	@XmlElement(required = true)
	private long volumeGroupCapacity;

	/** @return The total usable capacity of the volume group. */
	public long getVolumeGroupCapacity() {
		return this.volumeGroupCapacity;
	}
	/** @param x The total usable capacity of the volume group. */
	public void setVolumeGroupCapacity(long x) {
		this.volumeGroupCapacity = x;
	}

	/** The number of volumes in the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of volumes in the volume group." , required = true)
	@XmlElement(required = true)
	private int volumeCount;

	/** @return The number of volumes in the volume group. */
	public int getVolumeCount() {
		return this.volumeCount;
	}
	/** @param x The number of volumes in the volume group. */
	public void setVolumeCount(int x) {
		this.volumeCount = x;
	}

	/** The total usable capacity of volume(s). */
	@io.swagger.annotations.ApiModelProperty(value ="The total usable capacity of volume(s)." , required = true)
	@XmlElement(required = true)
	private long volumeCapacity;

	/** @return The total usable capacity of volume(s). */
	public long getVolumeCapacity() {
		return this.volumeCapacity;
	}
	/** @param x The total usable capacity of volume(s). */
	public void setVolumeCapacity(long x) {
		this.volumeCapacity = x;
	}

	/** True, if volume group has tray loss protection. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if volume group has tray loss protection." , required = true)
	@XmlElement(required = true)
	private boolean trayLossProtection;

	/** @return True, if volume group has tray loss protection. */
	public boolean isTrayLossProtection() {
		return this.trayLossProtection;
	}
	/** @param x True, if volume group has tray loss protection. */
	public void setTrayLossProtection(boolean x) {
		this.trayLossProtection = x;
	}

	/** True, if all drives have matching spindle speed. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if all drives have matching spindle speed." , required = true)
	@XmlElement(required = true)
	private boolean spindleSpeedMatch;

	/** @return True, if all drives have matching spindle speed. */
	public boolean isSpindleSpeedMatch() {
		return this.spindleSpeedMatch;
	}
	/** @param x True, if all drives have matching spindle speed. */
	public void setSpindleSpeedMatch(boolean x) {
		this.spindleSpeedMatch = x;
	}

	/** True, if all drives have matching spindle speed. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if all drives have matching spindle speed." , required = true)
	@XmlElement(required = true)
	private int spindleSpeed;

	/** @return True, if all drives have matching spindle speed. */
	public int getSpindleSpeed() {
		return this.spindleSpeed;
	}
	/** @param x True, if all drives have matching spindle speed. */
	public void setSpindleSpeed(int x) {
		this.spindleSpeed = x;
	}

	/** This field is used to specify the volume group security type. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used to specify the volume group security type." , required = true)
	@XmlElement(required = true)
	private SecurityType volumeGroupSecurityType = SecurityType.__UNDEFINED;

	/** @return This field is used to specify the volume group security type. */
	public SecurityType getVolumeGroupSecurityType() {
		return this.volumeGroupSecurityType;
	}
	/** @param x This field is used to specify the volume group security type. */
	public void setVolumeGroupSecurityType(SecurityType x) {
		this.volumeGroupSecurityType = x;
	}

	/** This field is set to true when the volume group has drawer loss protection; otherwise it is set to false */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to true when the volume group has drawer loss protection; otherwise it is set to false" , required = true)
	@XmlElement(required = true)
	private boolean drawerLossProtection;

	/** @return This field is set to true when the volume group has drawer loss protection; otherwise it is set to false */
	public boolean isDrawerLossProtection() {
		return this.drawerLossProtection;
	}
	/** @param x This field is set to true when the volume group has drawer loss protection; otherwise it is set to false */
	public void setDrawerLossProtection(boolean x) {
		this.drawerLossProtection = x;
	}

	/** This field is set to the desired drive media type of the drive. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to the desired drive media type of the drive." , required = true)
	@XmlElement(required = true)
	private DriveMediaType driveMediaType = DriveMediaType.__UNDEFINED;

	/** @return This field is set to the desired drive media type of the drive. */
	public DriveMediaType getDriveMediaType() {
		return this.driveMediaType;
	}
	/** @param x This field is set to the desired drive media type of the drive. */
	public void setDriveMediaType(DriveMediaType x) {
		this.driveMediaType = x;
	}

	/** True when all drives in the volume group are PI capable. */
	@io.swagger.annotations.ApiModelProperty(value ="True when all drives in the volume group are PI capable." , required = true)
	@XmlElement(required = true)
	private boolean protectionInformationCapable;

	/** @return True when all drives in the volume group are PI capable. */
	public boolean isProtectionInformationCapable() {
		return this.protectionInformationCapable;
	}
	/** @param x True when all drives in the volume group are PI capable. */
	public void setProtectionInformationCapable(boolean x) {
		this.protectionInformationCapable = x;
	}

	/** Identifies the drive block format of the volume candidate. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the drive block format of the volume candidate." , required = true)
	@XmlElement(required = true)
	private DriveBlockFormat driveBlockFormat = DriveBlockFormat.__UNDEFINED;

	/** @return Identifies the drive block format of the volume candidate. */
	public DriveBlockFormat getDriveBlockFormat() {
		return this.driveBlockFormat;
	}
	/** @param x Identifies the drive block format of the volume candidate. */
	public void setDriveBlockFormat(DriveBlockFormat x) {
		this.driveBlockFormat = x;
	}

	/** Refines the information in the securityType field to describe the set of drives. */
	@io.swagger.annotations.ApiModelProperty(value ="Refines the information in the securityType field to describe the set of drives." , required = true)
	@XmlElement(required = true)
	private SecurityLevel volumeGroupSecurityLevel = SecurityLevel.__UNDEFINED;

	/** @return Refines the information in the securityType field to describe the set of drives. */
	public SecurityLevel getVolumeGroupSecurityLevel() {
		return this.volumeGroupSecurityLevel;
	}
	/** @param x Refines the information in the securityType field to describe the set of drives. */
	public void setVolumeGroupSecurityLevel(SecurityLevel x) {
		this.volumeGroupSecurityLevel = x;
	}
}
