package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when updating a volume's user-assigned label. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(669)
public class VolumeLabelUpdateDescriptor implements Serializable {
	public VolumeLabelUpdateDescriptor() {
	}

	/** The reference value that identifies the volume whose user-assigned label is to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume whose user-assigned label is to be updated." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference value that identifies the volume whose user-assigned label is to be updated. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference value that identifies the volume whose user-assigned label is to be updated. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The new label for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The new label for the volume." , required = true)
	@XmlElement(required = true)
	private String label;

	/** @return The new label for the volume. */
	public String getLabel() {
		return this.label;
	}
	/** @param x The new label for the volume. */
	public void setLabel(String x) {
		this.label = x;
	}
}
