package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the input to the failBackVolumeOwnership procedure used to request a fail back of volume ownership from current to preferred owner. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(351)
public class VolumeOwnershipFailBackRequestDescriptor implements Serializable {
	public VolumeOwnershipFailBackRequestDescriptor() {
	}

	/** If true, controller will perform fail back operation of current ownership to preferred owner regardless of current host connectivity. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, controller will perform fail back operation of current ownership to preferred owner regardless of current host connectivity." , required = true)
	@XmlElement(required = true)
	private boolean ignoreConnectivity;

	/** @return If true, controller will perform fail back operation of current ownership to preferred owner regardless of current host connectivity. */
	public boolean isIgnoreConnectivity() {
		return this.ignoreConnectivity;
	}
	/** @param x If true, controller will perform fail back operation of current ownership to preferred owner regardless of current host connectivity. */
	public void setIgnoreConnectivity(boolean x) {
		this.ignoreConnectivity = x;
	}

	/** If true, the fail back operation will apply to volumes whose preferred owner is either controller, otherwise the fail-back operation will apply only to those volumes with a preferred owner on the controller receiving the request. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, the fail back operation will apply to volumes whose preferred owner is either controller, otherwise the fail-back operation will apply only to those volumes with a preferred owner on the controller receiving the request." , required = true)
	@XmlElement(required = true)
	private boolean bothControllers;

	/** @return If true, the fail back operation will apply to volumes whose preferred owner is either controller, otherwise the fail-back operation will apply only to those volumes with a preferred owner on the controller receiving the request. */
	public boolean isBothControllers() {
		return this.bothControllers;
	}
	/** @param x If true, the fail back operation will apply to volumes whose preferred owner is either controller, otherwise the fail-back operation will apply only to those volumes with a preferred owner on the controller receiving the request. */
	public void setBothControllers(boolean x) {
		this.bothControllers = x;
	}
}
