package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used for the setVolumeProperties procedure. It contains the volume whose properties are to be changed and the new property settings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(831)
public class VolumePropertiesUpdateDescriptor implements Serializable {
	public VolumePropertiesUpdateDescriptor() {
	}

	/** The reference value that identifies the volume being changed. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume being changed." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference value that identifies the volume being changed. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference value that identifies the volume being changed. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The new property settings for the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The new property settings for the volume." , required = true)
	@XmlElement(required = true)
	private VolumeChangeableProperties settings;

	/** @return The new property settings for the volume. */
	public VolumeChangeableProperties getSettings() {
		return this.settings;
	}
	/** @param x The new property settings for the volume. */
	public void setSettings(VolumeChangeableProperties x) {
		this.settings = x;
	}
}
