package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when performing a volume group RAID level migration operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(876)
public class VolumeRAIDMigrationDescriptor implements Serializable {
	public VolumeRAIDMigrationDescriptor() {
	}

	/** The reference value that identifies the volume group whose RAID level is to be changed. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume group whose RAID level is to be changed." , required = true)
	@XmlElement(required = true)
	private String volumeGroupRef;

	/** @return The reference value that identifies the volume group whose RAID level is to be changed. */
	public String getVolumeGroupRef() {
		return this.volumeGroupRef;
	}
	/** @param x The reference value that identifies the volume group whose RAID level is to be changed. */
	public void setVolumeGroupRef(String x) {
		this.volumeGroupRef = x;
	}

	/** The new RAID level to be assigned to the volumes in the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="The new RAID level to be assigned to the volumes in the volume group." , required = true)
	@XmlElement(required = true)
	private RAIDLevel newRaidLevel = RAIDLevel.__UNDEFINED;

	/** @return The new RAID level to be assigned to the volumes in the volume group. */
	public RAIDLevel getNewRaidLevel() {
		return this.newRaidLevel;
	}
	/** @param x The new RAID level to be assigned to the volumes in the volume group. */
	public void setNewRaidLevel(RAIDLevel x) {
		this.newRaidLevel = x;
	}
}
