package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Five priority levels are defined: */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(112)
public enum VolumeScanPriority implements Serializable {
		/** Specifies the highest priority. At this setting the volume scan commands are executed at the same priority as normal host I/O. */
		priority0(0),
		/** The volume scan priority is 1. */
		priority1(1),
		/** The volume scan priority is 2. */
		priority2(2),
		/** The volume scan priority is 3. */
		priority3(3),
		/** This is the lowest priority. */
		priority4(4),
		__UNDEFINED(464378545);

		public final int value;

		private VolumeScanPriority(int v) {
			this.value = v;
		}
}
