package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when performing a volume segment resize operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(847)
public class VolumeSegmentSizingDescriptor implements Serializable {
	public VolumeSegmentSizingDescriptor() {
	}

	/** The reference value that identifies the volume whose segment size is to be changed. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume whose segment size is to be changed." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference value that identifies the volume whose segment size is to be changed. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference value that identifies the volume whose segment size is to be changed. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The new segment size, expressed in bytes, to be used for the volume. This must be one of the supported segment sizes, as specified in the FeatureParameters object returned by the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="The new segment size, expressed in bytes, to be used for the volume. This must be one of the supported segment sizes, as specified in the FeatureParameters object returned by the controller." , required = true)
	@XmlElement(required = true)
	private int newSegmentSize;

	/** @return The new segment size, expressed in bytes, to be used for the volume. This must be one of the supported segment sizes, as specified in the FeatureParameters object returned by the controller. */
	public int getNewSegmentSize() {
		return this.newSegmentSize;
	}
	/** @param x The new segment size, expressed in bytes, to be used for the volume. This must be one of the supported segment sizes, as specified in the FeatureParameters object returned by the controller. */
	public void setNewSegmentSize(int x) {
		this.newSegmentSize = x;
	}
}
