package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe a recommended combination of segment size and cache read ahead multiplier for a given volume usage type. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(416)
public class VolumeUsageHint implements Serializable {
	public VolumeUsageHint() {
	}

	/** How the volume will be used (e.g. multimedia, transactional, file system). */
	@io.swagger.annotations.ApiModelProperty(value ="How the volume will be used (e.g. multimedia, transactional, file system)." , required = true)
	@XmlElement(required = true)
	private VolumeUsage usageHint = VolumeUsage.__UNDEFINED;

	/** @return How the volume will be used (e.g. multimedia, transactional, file system). */
	public VolumeUsage getUsageHint() {
		return this.usageHint;
	}
	/** @param x How the volume will be used (e.g. multimedia, transactional, file system). */
	public void setUsageHint(VolumeUsage x) {
		this.usageHint = x;
	}

	/** The volume segment size. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume segment size." , required = true)
	@XmlElement(required = true)
	private int segmentSize;

	/** @return The volume segment size. */
	public int getSegmentSize() {
		return this.segmentSize;
	}
	/** @param x The volume segment size. */
	public void setSegmentSize(int x) {
		this.segmentSize = x;
	}

	/** A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled." , required = true)
	@XmlElement(required = true)
	private int readAhead;

	/** @return A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public int getReadAhead() {
		return this.readAhead;
	}
	/** @param x A true (non-zero) / false (zero) indicator of whether or not automatic cache read-ahead is enabled. */
	public void setReadAhead(int x) {
		this.readAhead = x;
	}
}
