package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the Workload and Volume to be mapped. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(772)
public class WorkloadVolumeCreateMappingDescriptor implements Serializable {
	public WorkloadVolumeCreateMappingDescriptor() {
	}

	/** The unique identifier for the workload to be mapped to the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for the workload to be mapped to the volume." , required = true)
	@XmlElement(required = true)
	private String workloadRef;

	/** @return The unique identifier for the workload to be mapped to the volume. */
	public String getWorkloadRef() {
		return this.workloadRef;
	}
	/** @param x The unique identifier for the workload to be mapped to the volume. */
	public void setWorkloadRef(String x) {
		this.workloadRef = x;
	}

	/** The unique identifier for the volume that is to be mapped to the workload. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for the volume that is to be mapped to the workload." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The unique identifier for the volume that is to be mapped to the workload. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The unique identifier for the volume that is to be mapped to the workload. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}
}
