/*
 * Copyright (c)  2016 Netapp.  All rights reserved
 */

package devmgr.api.workers;

import devmgr.api.rpc.SymbolClient;
import devmgr.api.rpc.NIOClientCallback;
import devmgr.api.symbol.ObjectBundle;
import devmgr.api.symbol.ProductCapability;

import java.util.Set;
import java.util.concurrent.ExecutorService;

/**
 * Created by masonb on 3/24/2016.
 */
public interface AbstractObjectGraphFetcher {
    ObjectBundle doObjectGraphFetch(ExecutorService pool, SymbolClient client, NIOClientCallback<ObjectBundle> callback) throws Exception;

    /**
     * Provide the set of array ProductCapabilities to the fetcher.
     *
     * @param capabilities a set of ProductCapabilities
     */
    void setProductCapabilities(Set<ProductCapability> capabilities);
    void setSystemId(String id);
}
